/* DiscoveredCamera.c generated by valac 0.40.19, the Vala compiler
 * generated from DiscoveredCamera.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <gphoto2/gphoto2-camera.h>
#include <gphoto.h>
#include <stdlib.h>
#include <string.h>
#include <gphoto2/gphoto2-port-info-list.h>
#include <gphoto2/gphoto2-abilities-list.h>
#include <gphoto2/gphoto2-result.h>
#include <gphoto2/gphoto2-port-result.h>
#include <gio/gio.h>
#include <gudev/gudev.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DISCOVERED_CAMERA (discovered_camera_get_type ())
#define DISCOVERED_CAMERA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DISCOVERED_CAMERA, DiscoveredCamera))
#define DISCOVERED_CAMERA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DISCOVERED_CAMERA, DiscoveredCameraClass))
#define IS_DISCOVERED_CAMERA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DISCOVERED_CAMERA))
#define IS_DISCOVERED_CAMERA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DISCOVERED_CAMERA))
#define DISCOVERED_CAMERA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DISCOVERED_CAMERA, DiscoveredCameraClass))

typedef struct _DiscoveredCamera DiscoveredCamera;
typedef struct _DiscoveredCameraClass DiscoveredCameraClass;
typedef struct _DiscoveredCameraPrivate DiscoveredCameraPrivate;
#define _gp_camera_unref0(var) ((var == NULL) ? NULL : (var = (gp_camera_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _discovered_camera_unref0(var) ((var == NULL) ? NULL : (var = (discovered_camera_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _ParamSpecDiscoveredCamera ParamSpecDiscoveredCamera;

struct _DiscoveredCamera {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DiscoveredCameraPrivate * priv;
	Camera* gcamera;
	gchar* uri;
	gchar* display_name;
	gchar* icon;
};

struct _DiscoveredCameraClass {
	GTypeClass parent_class;
	void (*finalize) (DiscoveredCamera *self);
};

struct _DiscoveredCameraPrivate {
	gchar* port;
	gchar* camera_name;
	gchar** mount_uris;
	gint mount_uris_length1;
	gint _mount_uris_size_;
};

typedef enum  {
	GPHOTO_ERROR_LIBRARY
} GPhotoError;
#define GPHOTO_ERROR gphoto_error_quark ()
struct _ParamSpecDiscoveredCamera {
	GParamSpec parent_instance;
};


static gpointer discovered_camera_parent_class = NULL;

gpointer discovered_camera_ref (gpointer instance);
void discovered_camera_unref (gpointer instance);
GParamSpec* param_spec_discovered_camera (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_discovered_camera (GValue* value,
                                  gpointer v_object);
void value_take_discovered_camera (GValue* value,
                                   gpointer v_object);
gpointer value_get_discovered_camera (const GValue* value);
GType discovered_camera_get_type (void) G_GNUC_CONST;
#define DISCOVERED_CAMERA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DISCOVERED_CAMERA, DiscoveredCameraPrivate))
GQuark gphoto_error_quark (void);
DiscoveredCamera* discovered_camera_new (const gchar* name,
                                         const gchar* port,
                                         GPPortInfo port_info,
                                         CameraAbilities camera_abilities,
                                         GError** error);
DiscoveredCamera* discovered_camera_construct (GType object_type,
                                               const gchar* name,
                                               const gchar* port,
                                               GPPortInfo port_info,
                                               CameraAbilities camera_abilities,
                                               GError** error);
static void _vala_array_add68 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add69 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static gchar* discovered_camera_get_port_path (DiscoveredCamera* self,
                                        const gchar* port);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _vala_array_add70 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add71 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
GMount* discovered_camera_get_mount (DiscoveredCamera* self);
static void discovered_camera_finalize (DiscoveredCamera * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static void
_vala_array_add68 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if ((*length) == (*size)) {
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 148 "DiscoveredCamera.c"
	}
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	(*array)[(*length)++] = value;
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	(*array)[*length] = NULL;
#line 154 "DiscoveredCamera.c"
}


static void
_vala_array_add69 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if ((*length) == (*size)) {
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 170 "DiscoveredCamera.c"
	}
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	(*array)[(*length)++] = value;
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	(*array)[*length] = NULL;
#line 176 "DiscoveredCamera.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return self ? g_object_ref (self) : NULL;
#line 185 "DiscoveredCamera.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 194 "DiscoveredCamera.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 203 "DiscoveredCamera.c"
}


static void
_vala_array_add70 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if ((*length) == (*size)) {
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 219 "DiscoveredCamera.c"
	}
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	(*array)[(*length)++] = value;
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	(*array)[*length] = NULL;
#line 225 "DiscoveredCamera.c"
}


static void
_vala_array_add71 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if ((*length) == (*size)) {
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 241 "DiscoveredCamera.c"
	}
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	(*array)[(*length)++] = value;
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	(*array)[*length] = NULL;
#line 247 "DiscoveredCamera.c"
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = maxlen;
#line 1394 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 271 "DiscoveredCamera.c"
	} else {
		gchar* _tmp2_;
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 280 "DiscoveredCamera.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1403 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 301 "DiscoveredCamera.c"
	} else {
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 305 "DiscoveredCamera.c"
	}
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 311 "DiscoveredCamera.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 321 "DiscoveredCamera.c"
	}
#line 1412 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 325 "DiscoveredCamera.c"
		glong _tmp3_;
#line 1413 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1413 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1414 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 333 "DiscoveredCamera.c"
	} else {
		glong _tmp4_;
#line 1416 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1416 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 340 "DiscoveredCamera.c"
	}
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 344 "DiscoveredCamera.c"
		glong _tmp5_;
#line 1419 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1419 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 350 "DiscoveredCamera.c"
	}
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp7_;
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 362 "DiscoveredCamera.c"
}


DiscoveredCamera*
discovered_camera_construct (GType object_type,
                             const gchar* name,
                             const gchar* port,
                             GPPortInfo port_info,
                             CameraAbilities camera_abilities,
                             GError** error)
{
	DiscoveredCamera* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar* _tmp8_;
	int res = 0;
	Camera* _tmp9_ = NULL;
	int _tmp10_;
	int _tmp11_;
	Camera* _tmp16_;
	int _tmp17_;
	Camera* _tmp22_;
	int _tmp23_;
	gchar* path = NULL;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp91_;
	GError* _inner_error0_ = NULL;
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (port != NULL, NULL);
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self = (DiscoveredCamera*) g_type_create_instance (object_type);
#line 18 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp0_ = g_strdup (port);
#line 18 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_g_free0 (self->priv->port);
#line 18 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->priv->port = _tmp0_;
#line 19 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp1_ = g_strdup (name);
#line 19 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_g_free0 (self->priv->camera_name);
#line 19 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->priv->camera_name = _tmp1_;
#line 20 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp2_ = g_strdup_printf ("gphoto2://[%s]", port);
#line 20 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_g_free0 (self->uri);
#line 20 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->uri = _tmp2_;
#line 22 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp3_ = g_new0 (gchar*, 0 + 1);
#line 22 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->priv->mount_uris = (_vala_array_free (self->priv->mount_uris, self->priv->mount_uris_length1, (GDestroyNotify) g_free), NULL);
#line 22 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->priv->mount_uris = _tmp3_;
#line 22 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->priv->mount_uris_length1 = 0;
#line 22 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->priv->_mount_uris_size_ = self->priv->mount_uris_length1;
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp4_ = self->priv->mount_uris;
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp4__length1 = self->priv->mount_uris_length1;
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp5_ = self->uri;
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_vala_array_add68 (&self->priv->mount_uris, &self->priv->mount_uris_length1, &self->priv->_mount_uris_size_, _tmp6_);
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp7_ = self->priv->mount_uris;
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp7__length1 = self->priv->mount_uris_length1;
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp8_ = g_strdup_printf ("mtp://[%s]", port);
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_vala_array_add69 (&self->priv->mount_uris, &self->priv->mount_uris_length1, &self->priv->_mount_uris_size_, _tmp8_);
#line 26 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp10_ = gp_camera_new (&_tmp9_);
#line 26 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_gp_camera_unref0 (self->gcamera);
#line 26 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->gcamera = _tmp9_;
#line 26 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	res = _tmp10_;
#line 28 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp11_ = res;
#line 28 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (_tmp11_ != GP_OK) {
#line 463 "DiscoveredCamera.c"
		int _tmp12_;
		int _tmp13_;
		const gchar* _tmp14_;
		GError* _tmp15_;
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp12_ = res;
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp13_ = res;
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp14_ = gp_port_result_as_string (_tmp13_);
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp15_ = g_error_new (GPHOTO_ERROR, GPHOTO_ERROR_LIBRARY, "[%d] Unable to create camera object for %s: %s", (gint) _tmp12_, name, _tmp14_);
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_inner_error0_ = _tmp15_;
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			g_propagate_error (error, _inner_error0_);
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_discovered_camera_unref0 (self);
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			return NULL;
#line 486 "DiscoveredCamera.c"
		} else {
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			g_clear_error (&_inner_error0_);
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			return NULL;
#line 494 "DiscoveredCamera.c"
		}
	}
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp16_ = self->gcamera;
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	res = gp_camera_set_abilities (_tmp16_, camera_abilities);
#line 34 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp17_ = res;
#line 34 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (_tmp17_ != GP_OK) {
#line 505 "DiscoveredCamera.c"
		int _tmp18_;
		int _tmp19_;
		const gchar* _tmp20_;
		GError* _tmp21_;
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp18_ = res;
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp19_ = res;
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp20_ = gp_port_result_as_string (_tmp19_);
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp21_ = g_error_new (GPHOTO_ERROR, GPHOTO_ERROR_LIBRARY, "[%d] Unable to set camera abilities for %s: %s", (gint) _tmp18_, name, _tmp20_);
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_inner_error0_ = _tmp21_;
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			g_propagate_error (error, _inner_error0_);
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_discovered_camera_unref0 (self);
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			return NULL;
#line 528 "DiscoveredCamera.c"
		} else {
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			g_clear_error (&_inner_error0_);
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			return NULL;
#line 536 "DiscoveredCamera.c"
		}
	}
#line 39 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp22_ = self->gcamera;
#line 39 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	res = gp_camera_set_port_info (_tmp22_, port_info);
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp23_ = res;
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (_tmp23_ != GP_OK) {
#line 547 "DiscoveredCamera.c"
		int _tmp24_;
		int _tmp25_;
		const gchar* _tmp26_;
		GError* _tmp27_;
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp24_ = res;
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp25_ = res;
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp26_ = gp_port_result_as_string (_tmp25_);
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp27_ = g_error_new (GPHOTO_ERROR, GPHOTO_ERROR_LIBRARY, "[%d] Unable to set port infor for %s: %s", (gint) _tmp24_, name, _tmp26_);
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_inner_error0_ = _tmp27_;
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			g_propagate_error (error, _inner_error0_);
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_discovered_camera_unref0 (self);
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			return NULL;
#line 570 "DiscoveredCamera.c"
		} else {
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			g_clear_error (&_inner_error0_);
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			return NULL;
#line 578 "DiscoveredCamera.c"
		}
	}
#line 45 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp28_ = discovered_camera_get_port_path (self, port);
#line 45 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	path = _tmp28_;
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp29_ = path;
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (_tmp29_ != NULL) {
#line 589 "DiscoveredCamera.c"
		GVolumeMonitor* monitor = NULL;
		GVolumeMonitor* _tmp30_;
		GVolumeMonitor* _tmp31_;
		GList* _tmp32_;
		GUdevClient* client = NULL;
		GUdevClient* _tmp45_;
		GUdevDevice* device = NULL;
		GUdevClient* _tmp46_;
		const gchar* _tmp47_;
		GUdevDevice* _tmp48_;
		gchar* serial = NULL;
		GUdevDevice* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		gchar** _tmp52_;
		gint _tmp52__length1;
		const gchar* _tmp53_;
		gchar* _tmp54_;
		gchar** _tmp55_;
		gint _tmp55__length1;
		const gchar* _tmp56_;
		gchar* _tmp57_;
		const gchar* _tmp58_;
		const gchar* _tmp62_;
#line 47 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp30_ = g_volume_monitor_get ();
#line 47 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		monitor = _tmp30_;
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp31_ = monitor;
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp32_ = g_volume_monitor_get_volumes (_tmp31_);
#line 622 "DiscoveredCamera.c"
		{
			GList* volume_collection = NULL;
			GList* volume_it = NULL;
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			volume_collection = _tmp32_;
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			for (volume_it = volume_collection; volume_it != NULL; volume_it = volume_it->next) {
#line 630 "DiscoveredCamera.c"
				GVolume* _tmp33_;
				GVolume* volume = NULL;
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp33_ = _g_object_ref0 ((GVolume*) volume_it->data);
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				volume = _tmp33_;
#line 637 "DiscoveredCamera.c"
				{
					GVolume* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
					const gchar* _tmp37_;
					gboolean _tmp38_;
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_tmp34_ = volume;
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_tmp35_ = g_volume_get_identifier (_tmp34_, G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE);
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_tmp36_ = _tmp35_;
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_tmp37_ = path;
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_tmp38_ = g_strcmp0 (_tmp36_, _tmp37_) == 0;
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_g_free0 (_tmp36_);
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					if (_tmp38_) {
#line 658 "DiscoveredCamera.c"
						GVolume* _tmp39_;
						gchar* _tmp40_;
						GVolume* _tmp41_;
						GIcon* _tmp42_;
						GIcon* _tmp43_;
						gchar* _tmp44_;
#line 50 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_tmp39_ = volume;
#line 50 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_tmp40_ = g_volume_get_name (_tmp39_);
#line 50 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_g_free0 (self->display_name);
#line 50 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						self->display_name = _tmp40_;
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_tmp41_ = volume;
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_tmp42_ = g_volume_get_symbolic_icon (_tmp41_);
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_tmp43_ = _tmp42_;
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_tmp44_ = g_icon_to_string (_tmp43_);
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_g_free0 (self->icon);
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						self->icon = _tmp44_;
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_g_object_unref0 (_tmp43_);
#line 687 "DiscoveredCamera.c"
					}
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_g_object_unref0 (volume);
#line 691 "DiscoveredCamera.c"
				}
			}
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			(volume_collection == NULL) ? NULL : (volume_collection = (_g_list_free__g_object_unref0_ (volume_collection), NULL));
#line 696 "DiscoveredCamera.c"
		}
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp45_ = g_udev_client_new (NULL);
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		client = _tmp45_;
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp46_ = client;
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp47_ = path;
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp48_ = g_udev_client_query_by_device_file (_tmp46_, _tmp47_);
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		device = _tmp48_;
#line 61 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp49_ = device;
#line 61 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp50_ = g_udev_device_get_property (_tmp49_, "ID_SERIAL");
#line 61 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp51_ = g_strdup (_tmp50_);
#line 61 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		serial = _tmp51_;
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp52_ = self->priv->mount_uris;
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp52__length1 = self->priv->mount_uris_length1;
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp53_ = serial;
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp54_ = g_strdup_printf ("gphoto2://%s", _tmp53_);
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_vala_array_add70 (&self->priv->mount_uris, &self->priv->mount_uris_length1, &self->priv->_mount_uris_size_, _tmp54_);
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp55_ = self->priv->mount_uris;
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp55__length1 = self->priv->mount_uris_length1;
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp56_ = serial;
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp57_ = g_strdup_printf ("mtp://%s", _tmp56_);
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_vala_array_add71 (&self->priv->mount_uris, &self->priv->mount_uris_length1, &self->priv->_mount_uris_size_, _tmp57_);
#line 66 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp58_ = self->display_name;
#line 66 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		if (_tmp58_ == NULL) {
#line 742 "DiscoveredCamera.c"
			GUdevDevice* _tmp59_;
			const gchar* _tmp60_;
			gchar* _tmp61_;
#line 67 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp59_ = device;
#line 67 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp60_ = g_udev_device_get_sysfs_attr (_tmp59_, "product");
#line 67 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp61_ = g_strdup (_tmp60_);
#line 67 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_g_free0 (self->display_name);
#line 67 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			self->display_name = _tmp61_;
#line 756 "DiscoveredCamera.c"
		}
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp62_ = self->display_name;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		if (_tmp62_ == NULL) {
#line 762 "DiscoveredCamera.c"
			GUdevDevice* _tmp63_;
			const gchar* _tmp64_;
			gchar* _tmp65_;
#line 71 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp63_ = device;
#line 71 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp64_ = g_udev_device_get_property (_tmp63_, "ID_MODEL");
#line 71 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp65_ = g_strdup (_tmp64_);
#line 71 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_g_free0 (self->display_name);
#line 71 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			self->display_name = _tmp65_;
#line 776 "DiscoveredCamera.c"
		}
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_g_free0 (serial);
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_g_object_unref0 (device);
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_g_object_unref0 (client);
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_g_object_unref0 (monitor);
#line 786 "DiscoveredCamera.c"
	}
#line 76 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (g_str_has_prefix (port, "disk:")) {
#line 790 "DiscoveredCamera.c"
		{
			GMount* mount = NULL;
			gchar* _tmp66_;
			gchar* _tmp67_;
			GFile* _tmp68_;
			GFile* _tmp69_;
			GMount* _tmp70_;
			GMount* _tmp71_;
			GVolume* volume = NULL;
			GMount* _tmp72_;
			GVolume* _tmp73_;
			GVolume* _tmp74_;
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp66_ = string_substring (port, (glong) 5, (glong) -1);
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp67_ = _tmp66_;
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp68_ = g_file_new_for_path (_tmp67_);
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp69_ = _tmp68_;
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp70_ = g_file_find_enclosing_mount (_tmp69_, NULL, &_inner_error0_);
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp71_ = _tmp70_;
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_g_object_unref0 (_tmp69_);
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_g_free0 (_tmp67_);
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			mount = _tmp71_;
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 823 "DiscoveredCamera.c"
				goto __catch78_g_error;
			}
#line 79 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp72_ = mount;
#line 79 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp73_ = g_mount_get_volume (_tmp72_);
#line 79 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			volume = _tmp73_;
#line 80 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp74_ = volume;
#line 80 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			if (_tmp74_ != NULL) {
#line 836 "DiscoveredCamera.c"
				GVolume* _tmp75_;
				gchar* _tmp76_;
				gchar* _tmp77_;
				gchar* _tmp78_;
				GVolume* _tmp79_;
				GIcon* _tmp80_;
				GIcon* _tmp81_;
				gchar* _tmp82_;
#line 82 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp75_ = volume;
#line 82 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp76_ = g_volume_get_name (_tmp75_);
#line 82 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp77_ = _tmp76_;
#line 82 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp78_ = g_strdup_printf (_ ("%s (%s)"), name, _tmp77_);
#line 82 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_free0 (self->display_name);
#line 82 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				self->display_name = _tmp78_;
#line 82 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_free0 (_tmp77_);
#line 83 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp79_ = volume;
#line 83 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp80_ = g_volume_get_symbolic_icon (_tmp79_);
#line 83 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp81_ = _tmp80_;
#line 83 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp82_ = g_icon_to_string (_tmp81_);
#line 83 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_free0 (self->icon);
#line 83 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				self->icon = _tmp82_;
#line 83 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_object_unref0 (_tmp81_);
#line 873 "DiscoveredCamera.c"
			} else {
				GMount* _tmp83_;
				gchar* _tmp84_;
				gchar* _tmp85_;
				gchar* _tmp86_;
				GMount* _tmp87_;
				GIcon* _tmp88_;
				GIcon* _tmp89_;
				gchar* _tmp90_;
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp83_ = mount;
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp84_ = g_mount_get_name (_tmp83_);
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp85_ = _tmp84_;
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp86_ = g_strdup_printf (_ ("%s (%s)"), name, _tmp85_);
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_free0 (self->display_name);
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				self->display_name = _tmp86_;
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_free0 (_tmp85_);
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp87_ = mount;
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp88_ = g_mount_get_symbolic_icon (_tmp87_);
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp89_ = _tmp88_;
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp90_ = g_icon_to_string (_tmp89_);
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_free0 (self->icon);
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				self->icon = _tmp90_;
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_object_unref0 (_tmp89_);
#line 911 "DiscoveredCamera.c"
			}
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_g_object_unref0 (volume);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_g_object_unref0 (mount);
#line 917 "DiscoveredCamera.c"
		}
		goto __finally78;
		__catch78_g_error:
		{
			GError* e = NULL;
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			e = _inner_error0_;
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_inner_error0_ = NULL;
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_g_error_free0 (e);
#line 929 "DiscoveredCamera.c"
		}
		__finally78:
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			if (_inner_error0_->domain == GPHOTO_ERROR) {
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				g_propagate_error (error, _inner_error0_);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_free0 (path);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_discovered_camera_unref0 (self);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				return NULL;
#line 944 "DiscoveredCamera.c"
			} else {
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_free0 (path);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				g_clear_error (&_inner_error0_);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				return NULL;
#line 954 "DiscoveredCamera.c"
			}
		}
	}
#line 93 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp91_ = self->display_name;
#line 93 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (_tmp91_ == NULL) {
#line 962 "DiscoveredCamera.c"
		const gchar* _tmp92_;
		gchar* _tmp93_;
#line 94 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp92_ = self->priv->camera_name;
#line 94 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp93_ = g_strdup (_tmp92_);
#line 94 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_g_free0 (self->display_name);
#line 94 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		self->display_name = _tmp93_;
#line 973 "DiscoveredCamera.c"
	}
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_g_free0 (path);
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return self;
#line 979 "DiscoveredCamera.c"
}


DiscoveredCamera*
discovered_camera_new (const gchar* name,
                       const gchar* port,
                       GPPortInfo port_info,
                       CameraAbilities camera_abilities,
                       GError** error)
{
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return discovered_camera_construct (TYPE_DISCOVERED_CAMERA, name, port, port_info, camera_abilities, error);
#line 992 "DiscoveredCamera.c"
}


GMount*
discovered_camera_get_mount (DiscoveredCamera* self)
{
	GMount* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GError* _inner_error0_ = NULL;
#line 98 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (IS_DISCOVERED_CAMERA (self), NULL);
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp0_ = self->priv->mount_uris;
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_tmp0__length1 = self->priv->mount_uris_length1;
#line 1009 "DiscoveredCamera.c"
	{
		gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		uri_collection = _tmp0_;
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		uri_collection_length1 = _tmp0__length1;
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 1021 "DiscoveredCamera.c"
			gchar* _tmp1_;
			gchar* uri = NULL;
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			_tmp1_ = g_strdup (uri_collection[uri_it]);
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			uri = _tmp1_;
#line 1028 "DiscoveredCamera.c"
			{
				GFile* f = NULL;
				const gchar* _tmp2_;
				GFile* _tmp3_;
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp2_ = uri;
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_tmp3_ = g_file_new_for_uri (_tmp2_);
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				f = _tmp3_;
#line 1039 "DiscoveredCamera.c"
				{
					GMount* mount = NULL;
					GFile* _tmp4_;
					GMount* _tmp5_;
					GMount* _tmp6_;
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_tmp4_ = f;
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_tmp5_ = g_file_find_enclosing_mount (_tmp4_, NULL, &_inner_error0_);
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					mount = _tmp5_;
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1053 "DiscoveredCamera.c"
						goto __catch79_g_error;
					}
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_tmp6_ = mount;
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					if (_tmp6_ != NULL) {
#line 104 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						result = mount;
#line 104 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_g_object_unref0 (f);
#line 104 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						_g_free0 (uri);
#line 104 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
						return result;
#line 1068 "DiscoveredCamera.c"
					}
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_g_object_unref0 (mount);
#line 1072 "DiscoveredCamera.c"
				}
				goto __finally79;
				__catch79_g_error:
				{
					GError* _error_ = NULL;
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_error_ = _inner_error0_;
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_inner_error0_ = NULL;
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_g_error_free0 (_error_);
#line 1084 "DiscoveredCamera.c"
				}
				__finally79:
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_g_object_unref0 (f);
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					_g_free0 (uri);
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					g_clear_error (&_inner_error0_);
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
					return NULL;
#line 1099 "DiscoveredCamera.c"
				}
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_object_unref0 (f);
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
				_g_free0 (uri);
#line 1105 "DiscoveredCamera.c"
			}
		}
	}
#line 108 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	result = NULL;
#line 108 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return result;
#line 1113 "DiscoveredCamera.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1479 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1479 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1479 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1136 "DiscoveredCamera.c"
	} else {
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1140 "DiscoveredCamera.c"
	}
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1146 "DiscoveredCamera.c"
	} else {
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1150 "DiscoveredCamera.c"
	}
#line 1480 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1154 "DiscoveredCamera.c"
		gchar* _tmp2_;
#line 1481 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1481 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp2_;
#line 1481 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 1162 "DiscoveredCamera.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		regex = _tmp6_;
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1190 "DiscoveredCamera.c"
				goto __catch80_g_regex_error;
			}
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1484 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 1199 "DiscoveredCamera.c"
		}
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp8_ = regex;
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1213 "DiscoveredCamera.c"
				goto __catch80_g_regex_error;
			}
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 1222 "DiscoveredCamera.c"
		}
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp10_;
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1485 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 1236 "DiscoveredCamera.c"
	}
	goto __finally80;
	__catch80_g_regex_error:
	{
		GError* e = NULL;
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		e = _inner_error0_;
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1487 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 1250 "DiscoveredCamera.c"
	}
	__finally80:
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1483 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return NULL;
#line 1261 "DiscoveredCamera.c"
	}
}


static gchar*
discovered_camera_get_port_path (DiscoveredCamera* self,
                                 const gchar* port)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 111 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (IS_DISCOVERED_CAMERA (self), NULL);
#line 111 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (port != NULL, NULL);
#line 113 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (g_str_has_prefix (port, "usb:")) {
#line 1278 "DiscoveredCamera.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp1_ = string_substring (port, (glong) 4, (glong) -1);
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp2_ = _tmp1_;
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp3_ = string_replace (_tmp2_, ",", "/");
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp4_ = _tmp3_;
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp5_ = g_strdup_printf ("/dev/bus/usb/%s", _tmp4_);
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_g_free0 (_tmp0_);
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp0_ = _tmp5_;
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_g_free0 (_tmp4_);
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_g_free0 (_tmp2_);
#line 1302 "DiscoveredCamera.c"
	} else {
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_g_free0 (_tmp0_);
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		_tmp0_ = NULL;
#line 1308 "DiscoveredCamera.c"
	}
#line 113 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	result = _tmp0_;
#line 113 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return result;
#line 1314 "DiscoveredCamera.c"
}


static void
value_discovered_camera_init (GValue* value)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	value->data[0].v_pointer = NULL;
#line 1323 "DiscoveredCamera.c"
}


static void
value_discovered_camera_free_value (GValue* value)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (value->data[0].v_pointer) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		discovered_camera_unref (value->data[0].v_pointer);
#line 1334 "DiscoveredCamera.c"
	}
}


static void
value_discovered_camera_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (src_value->data[0].v_pointer) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		dest_value->data[0].v_pointer = discovered_camera_ref (src_value->data[0].v_pointer);
#line 1347 "DiscoveredCamera.c"
	} else {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1351 "DiscoveredCamera.c"
	}
}


static gpointer
value_discovered_camera_peek_pointer (const GValue* value)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return value->data[0].v_pointer;
#line 1361 "DiscoveredCamera.c"
}


static gchar*
value_discovered_camera_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (collect_values[0].v_pointer) {
#line 1373 "DiscoveredCamera.c"
		DiscoveredCamera * object;
		object = collect_values[0].v_pointer;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		if (object->parent_instance.g_class == NULL) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1380 "DiscoveredCamera.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1384 "DiscoveredCamera.c"
		}
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = discovered_camera_ref (object);
#line 1388 "DiscoveredCamera.c"
	} else {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = NULL;
#line 1392 "DiscoveredCamera.c"
	}
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return NULL;
#line 1396 "DiscoveredCamera.c"
}


static gchar*
value_discovered_camera_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	DiscoveredCamera ** object_p;
	object_p = collect_values[0].v_pointer;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (!object_p) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1412 "DiscoveredCamera.c"
	}
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (!value->data[0].v_pointer) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*object_p = NULL;
#line 1418 "DiscoveredCamera.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*object_p = value->data[0].v_pointer;
#line 1422 "DiscoveredCamera.c"
	} else {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		*object_p = discovered_camera_ref (value->data[0].v_pointer);
#line 1426 "DiscoveredCamera.c"
	}
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return NULL;
#line 1430 "DiscoveredCamera.c"
}


GParamSpec*
param_spec_discovered_camera (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	ParamSpecDiscoveredCamera* spec;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DISCOVERED_CAMERA), NULL);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return G_PARAM_SPEC (spec);
#line 1450 "DiscoveredCamera.c"
}


gpointer
value_get_discovered_camera (const GValue* value)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DISCOVERED_CAMERA), NULL);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return value->data[0].v_pointer;
#line 1461 "DiscoveredCamera.c"
}


void
value_set_discovered_camera (GValue* value,
                             gpointer v_object)
{
	DiscoveredCamera * old;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DISCOVERED_CAMERA));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	old = value->data[0].v_pointer;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (v_object) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DISCOVERED_CAMERA));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = v_object;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		discovered_camera_ref (value->data[0].v_pointer);
#line 1484 "DiscoveredCamera.c"
	} else {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = NULL;
#line 1488 "DiscoveredCamera.c"
	}
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (old) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		discovered_camera_unref (old);
#line 1494 "DiscoveredCamera.c"
	}
}


void
value_take_discovered_camera (GValue* value,
                              gpointer v_object)
{
	DiscoveredCamera * old;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DISCOVERED_CAMERA));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	old = value->data[0].v_pointer;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (v_object) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DISCOVERED_CAMERA));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = v_object;
#line 1516 "DiscoveredCamera.c"
	} else {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		value->data[0].v_pointer = NULL;
#line 1520 "DiscoveredCamera.c"
	}
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (old) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		discovered_camera_unref (old);
#line 1526 "DiscoveredCamera.c"
	}
}


static void
discovered_camera_class_init (DiscoveredCameraClass * klass)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	discovered_camera_parent_class = g_type_class_peek_parent (klass);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	((DiscoveredCameraClass *) klass)->finalize = discovered_camera_finalize;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_type_class_add_private (klass, sizeof (DiscoveredCameraPrivate));
#line 1540 "DiscoveredCamera.c"
}


static void
discovered_camera_instance_init (DiscoveredCamera * self)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->priv = DISCOVERED_CAMERA_GET_PRIVATE (self);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->ref_count = 1;
#line 1551 "DiscoveredCamera.c"
}


static void
discovered_camera_finalize (DiscoveredCamera * obj)
{
	DiscoveredCamera * self;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DISCOVERED_CAMERA, DiscoveredCamera);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_signal_handlers_destroy (self);
#line 8 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_gp_camera_unref0 (self->gcamera);
#line 9 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_g_free0 (self->uri);
#line 10 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_g_free0 (self->display_name);
#line 11 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_g_free0 (self->icon);
#line 13 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_g_free0 (self->priv->port);
#line 14 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	_g_free0 (self->priv->camera_name);
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	self->priv->mount_uris = (_vala_array_free (self->priv->mount_uris, self->priv->mount_uris_length1, (GDestroyNotify) g_free), NULL);
#line 1577 "DiscoveredCamera.c"
}


GType
discovered_camera_get_type (void)
{
	static volatile gsize discovered_camera_type_id__volatile = 0;
	if (g_once_init_enter (&discovered_camera_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_discovered_camera_init, value_discovered_camera_free_value, value_discovered_camera_copy_value, value_discovered_camera_peek_pointer, "p", value_discovered_camera_collect_value, "p", value_discovered_camera_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DiscoveredCameraClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) discovered_camera_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiscoveredCamera), 0, (GInstanceInitFunc) discovered_camera_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType discovered_camera_type_id;
		discovered_camera_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DiscoveredCamera", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&discovered_camera_type_id__volatile, discovered_camera_type_id);
	}
	return discovered_camera_type_id__volatile;
}


gpointer
discovered_camera_ref (gpointer instance)
{
	DiscoveredCamera * self;
	self = instance;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	g_atomic_int_inc (&self->ref_count);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	return instance;
#line 1606 "DiscoveredCamera.c"
}


void
discovered_camera_unref (gpointer instance)
{
	DiscoveredCamera * self;
	self = instance;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		DISCOVERED_CAMERA_GET_CLASS (self)->finalize (self);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/camera/DiscoveredCamera.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1621 "DiscoveredCamera.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



