/* Db.c generated by valac 0.40.19, the Vala compiler
 * generated from Db.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	DB_VERIFY_RESULT_OK,
	DB_VERIFY_RESULT_FUTURE_VERSION,
	DB_VERIFY_RESULT_UPGRADE_ERROR,
	DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE
} DbVerifyResult;


#define DB_TYPE_VERIFY_RESULT (db_verify_result_get_type ())

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
#define _application_unref0(var) ((var == NULL) ? NULL : (var = (application_unref (var), NULL)))

#define TYPE_FACE_TABLE (face_table_get_type ())
#define FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_TABLE, FaceTable))
#define FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_TABLE, FaceTableClass))
#define IS_FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_TABLE))
#define IS_FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_TABLE))
#define FACE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_TABLE, FaceTableClass))

typedef struct _FaceTable FaceTable;
typedef struct _FaceTableClass FaceTableClass;

#define TYPE_FACE_LOCATION_TABLE (face_location_table_get_type ())
#define FACE_LOCATION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_LOCATION_TABLE, FaceLocationTable))
#define FACE_LOCATION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_LOCATION_TABLE, FaceLocationTableClass))
#define IS_FACE_LOCATION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_LOCATION_TABLE))
#define IS_FACE_LOCATION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_LOCATION_TABLE))
#define FACE_LOCATION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_LOCATION_TABLE, FaceLocationTableClass))

typedef struct _FaceLocationTable FaceLocationTable;
typedef struct _FaceLocationTableClass FaceLocationTableClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);


extern gchar* db_filename;
gchar* db_filename = NULL;

#define DB_IN_MEMORY_NAME ":memory:"
void db_preconfigure (GFile* db_file);
void db_init (GError** error);
void database_table_init (const gchar* filename);
void db_terminate (void);
void database_table_terminate (void);
GType db_verify_result_get_type (void) G_GNUC_CONST;
DbVerifyResult db_verify_database (gchar* * app_version,
                                   gint* schema_version);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType version_table_get_type (void) G_GNUC_CONST;
VersionTable* version_table_get_instance (void);
gint version_table_get_version (VersionTable* self,
                                gchar* * app_version);
#define DATABASE_TABLE_SCHEMA_VERSION 22
#define RESOURCES_APP_VERSION _VERSION
void version_table_set_version (VersionTable* self,
                                gint version,
                                const gchar* app_version,
                                const gchar* user_data);
DbVerifyResult db_upgrade_database (gint input_version);
gboolean database_table_has_column (const gchar* table_name,
                                    const gchar* column_name);
gboolean database_table_add_column (const gchar* table_name,
                                    const gchar* column_name,
                                    const gchar* column_constraints);
gboolean database_table_has_table (const gchar* table_name);
gboolean database_table_ensure_column (const gchar* table_name,
                                       const gchar* column_name,
                                       const gchar* column_constraints,
                                       const gchar* upgrade_msg);
void tag_table_upgrade_for_htags (void);
void gsettings_configuration_engine_run_gsettings_migrator (void);
gpointer application_ref (gpointer instance);
void application_unref (gpointer instance);
GParamSpec* param_spec_application (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_application (GValue* value,
                            gpointer v_object);
void value_take_application (GValue* value,
                             gpointer v_object);
gpointer value_get_application (const GValue* value);
GType application_get_type (void) G_GNUC_CONST;
Application* application_get_instance (void);
void application_set_raw_thumbs_fix_required (Application* self,
                                              gboolean should_fixup);
GType face_table_get_type (void) G_GNUC_CONST;
FaceTable* face_table_get_instance (void);
GType face_location_table_get_type (void) G_GNUC_CONST;
FaceLocationTable* face_location_table_get_instance (void);
void version_table_update_version (VersionTable* self,
                                   gint version,
                                   const gchar* app_version);


void
db_preconfigure (GFile* db_file)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_;
#line 14 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	g_return_if_fail ((db_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (db_file, g_file_get_type ()));
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (db_file != NULL) {
#line 168 "Db.c"
		gchar* _tmp1_;
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp1_ = g_file_get_path (db_file);
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp0_ = _tmp1_;
#line 176 "Db.c"
	} else {
		gchar* _tmp2_;
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp2_ = g_strdup (DB_IN_MEMORY_NAME);
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp0_ = _tmp2_;
#line 185 "Db.c"
	}
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_g_free0 (db_filename);
#line 15 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	db_filename = _tmp3_;
#line 14 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_g_free0 (_tmp0_);
#line 195 "Db.c"
}


void
db_init (GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 19 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp0_ = db_filename;
#line 19 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_vala_assert (_tmp0_ != NULL, "filename != null");
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp1_ = db_filename;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	database_table_init (_tmp1_);
#line 212 "Db.c"
}


void
db_terminate (void)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	database_table_terminate ();
#line 221 "Db.c"
}


GType
db_verify_result_get_type (void)
{
	static volatile gsize db_verify_result_type_id__volatile = 0;
	if (g_once_init_enter (&db_verify_result_type_id__volatile)) {
		static const GEnumValue values[] = {{DB_VERIFY_RESULT_OK, "DB_VERIFY_RESULT_OK", "ok"}, {DB_VERIFY_RESULT_FUTURE_VERSION, "DB_VERIFY_RESULT_FUTURE_VERSION", "future-version"}, {DB_VERIFY_RESULT_UPGRADE_ERROR, "DB_VERIFY_RESULT_UPGRADE_ERROR", "upgrade-error"}, {DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE, "DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE", "no-upgrade-available"}, {0, NULL, NULL}};
		GType db_verify_result_type_id;
		db_verify_result_type_id = g_enum_register_static ("DbVerifyResult", values);
		g_once_init_leave (&db_verify_result_type_id__volatile, db_verify_result_type_id);
	}
	return db_verify_result_type_id__volatile;
}


DbVerifyResult
db_verify_database (gchar* * app_version,
                    gint* schema_version)
{
	gchar* _vala_app_version = NULL;
	gint _vala_schema_version = 0;
	DbVerifyResult result = 0;
	VersionTable* version_table = NULL;
	VersionTable* _tmp0_;
	VersionTable* _tmp1_;
	gchar* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp7_;
#line 36 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp0_ = version_table_get_instance ();
#line 36 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version_table = _tmp0_;
#line 37 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp1_ = version_table;
#line 37 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp3_ = version_table_get_version (_tmp1_, &_tmp2_);
#line 37 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_g_free0 (_vala_app_version);
#line 37 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_vala_app_version = _tmp2_;
#line 37 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_vala_schema_version = _tmp3_;
#line 39 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp4_ = _vala_schema_version;
#line 39 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (_tmp4_ >= 0) {
#line 271 "Db.c"
		gint _tmp5_;
		const gchar* _tmp6_;
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp5_ = _vala_schema_version;
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp6_ = _vala_app_version;
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_debug ("Db.vala:40: Database schema version %d created by app version %s", _tmp5_, _tmp6_);
#line 280 "Db.c"
	}
#line 42 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp7_ = _vala_schema_version;
#line 42 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (_tmp7_ == -1) {
#line 286 "Db.c"
		VersionTable* _tmp8_;
		gchar* _tmp9_;
#line 44 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_debug ("Db.vala:44: Creating database schema version %d for app version %s", DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION);
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp8_ = version_table;
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		version_table_set_version (_tmp8_, DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION, NULL);
#line 47 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp9_ = g_strdup (RESOURCES_APP_VERSION);
#line 47 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 47 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_vala_app_version = _tmp9_;
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_vala_schema_version = DATABASE_TABLE_SCHEMA_VERSION;
#line 303 "Db.c"
	} else {
		gint _tmp10_;
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp10_ = _vala_schema_version;
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (_tmp10_ > DATABASE_TABLE_SCHEMA_VERSION) {
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_FUTURE_VERSION;
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			_database_table_unref0 (version_table);
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			if (app_version) {
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
				*app_version = _vala_app_version;
#line 318 "Db.c"
			} else {
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
				_g_free0 (_vala_app_version);
#line 322 "Db.c"
			}
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			if (schema_version) {
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
				*schema_version = _vala_schema_version;
#line 328 "Db.c"
			}
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 332 "Db.c"
		} else {
			gint _tmp11_;
#line 52 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			_tmp11_ = _vala_schema_version;
#line 52 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			if (_tmp11_ < DATABASE_TABLE_SCHEMA_VERSION) {
#line 339 "Db.c"
				DbVerifyResult _result_ = 0;
				gint _tmp12_;
				DbVerifyResult _tmp13_;
#line 54 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
				_tmp12_ = _vala_schema_version;
#line 54 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
				_result_ = db_upgrade_database (_tmp12_);
#line 55 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
				_tmp13_ = _result_;
#line 55 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
				if (_tmp13_ != DB_VERIFY_RESULT_OK) {
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
					result = _result_;
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
					_database_table_unref0 (version_table);
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
					if (app_version) {
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
						*app_version = _vala_app_version;
#line 359 "Db.c"
					} else {
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
						_g_free0 (_vala_app_version);
#line 363 "Db.c"
					}
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
					if (schema_version) {
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
						*schema_version = _vala_schema_version;
#line 369 "Db.c"
					}
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
					return result;
#line 373 "Db.c"
				}
			}
		}
	}
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_database_table_unref0 (version_table);
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (app_version) {
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		*app_version = _vala_app_version;
#line 386 "Db.c"
	} else {
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 390 "Db.c"
	}
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (schema_version) {
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		*schema_version = _vala_schema_version;
#line 396 "Db.c"
	}
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	return result;
#line 400 "Db.c"
}


DbVerifyResult
db_upgrade_database (gint input_version)
{
	DbVerifyResult result = 0;
	gint version = 0;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	FaceTable* _tmp7_;
	FaceTable* _tmp8_;
	FaceLocationTable* _tmp9_;
	FaceLocationTable* _tmp10_;
	gint _tmp11_;
	VersionTable* _tmp12_;
	VersionTable* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_vala_assert (input_version < DATABASE_TABLE_SCHEMA_VERSION, "input_version < DatabaseTable.SCHEMA_VERSION");
#line 65 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = input_version;
#line 68 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp0_ = version;
#line 68 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (_tmp0_ == 1) {
#line 69 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		result = DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE;
#line 69 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		return result;
#line 435 "Db.c"
	}
#line 71 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp1_ = version;
#line 71 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	g_message ("Db.vala:71: Upgrading database from schema version %d to %d", _tmp1_, DATABASE_TABLE_SCHEMA_VERSION);
#line 83 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "flags")) {
#line 84 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:84: upgrade_database: adding flags column to PhotoTable");
#line 85 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "flags", "INTEGER DEFAULT 0")) {
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 451 "Db.c"
		}
	}
#line 89 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 3;
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "file_format")) {
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:101: upgrade_database: adding file_format column to PhotoTable");
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "file_format", "INTEGER DEFAULT 0")) {
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 466 "Db.c"
		}
	}
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 4;
#line 113 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "title")) {
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:114: upgrade_database: adding title column to PhotoTable");
#line 115 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "title", "TEXT")) {
#line 116 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 116 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 481 "Db.c"
		}
	}
#line 119 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 5;
#line 126 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "backlinks")) {
#line 127 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:127: upgrade_database: adding backlinks column to PhotoTable");
#line 128 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "backlinks", "TEXT")) {
#line 129 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 129 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 496 "Db.c"
		}
	}
#line 132 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 6;
#line 146 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "time_reimported")) {
#line 147 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:147: upgrade_database: adding time_reimported column to PhotoT" \
"able");
#line 148 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "time_reimported", "INTEGER")) {
#line 149 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 149 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 511 "Db.c"
		}
	}
#line 152 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "editable_id")) {
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:153: upgrade_database: adding editable_id column to PhotoTable");
#line 154 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "editable_id", "INTEGER DEFAULT -1")) {
#line 155 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 155 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 524 "Db.c"
		}
	}
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 7;
#line 170 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "rating")) {
#line 171 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:171: upgrade_database: adding rating column to PhotoTable");
#line 172 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "rating", "INTEGER DEFAULT 0")) {
#line 173 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 173 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 539 "Db.c"
		}
	}
#line 182 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "metadata_dirty")) {
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:183: upgrade_database: adding metadata_dirty column to PhotoTa" \
"ble");
#line 184 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "metadata_dirty", "INTEGER DEFAULT 1")) {
#line 185 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 185 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 552 "Db.c"
		}
	}
#line 188 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 9;
#line 195 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (database_table_has_table ("VideoTable")) {
#line 195 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp2_ = !database_table_has_column ("VideoTable", "flags");
#line 561 "Db.c"
	} else {
#line 195 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp2_ = FALSE;
#line 565 "Db.c"
	}
#line 195 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (_tmp2_) {
#line 196 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:196: upgrade_database: adding flags column to VideoTable");
#line 197 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("VideoTable", "flags", "INTEGER DEFAULT 0")) {
#line 198 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 198 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 577 "Db.c"
		}
	}
#line 201 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 10;
#line 208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("EventTable", "primary_source_id")) {
#line 209 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:209: upgrade_database: adding primary_source_id column to Even" \
"tTable");
#line 210 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("EventTable", "primary_source_id", "TEXT")) {
#line 211 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 211 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 592 "Db.c"
		}
	}
#line 214 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 11;
#line 221 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_ensure_column ("TombstoneTable", "reason", "INTEGER DEFAULT 0", "upgrade_database: adding reason column to TombstoneTable")) {
#line 223 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 223 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		return result;
#line 603 "Db.c"
	}
#line 226 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 12;
#line 233 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "developer")) {
#line 234 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:234: upgrade_database: adding developer column to PhotoTable");
#line 235 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "developer", "TEXT")) {
#line 236 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 236 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 617 "Db.c"
		}
	}
#line 239 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "develop_shotwell_id")) {
#line 240 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:240: upgrade_database: adding develop_shotwell_id column to Ph" \
"otoTable");
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "develop_shotwell_id", "INTEGER DEFAULT -1")) {
#line 242 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 242 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 630 "Db.c"
		}
	}
#line 245 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "develop_camera_id")) {
#line 246 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:246: upgrade_database: adding develop_camera_id column to Phot" \
"oTable");
#line 247 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "develop_camera_id", "INTEGER DEFAULT -1")) {
#line 248 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 248 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 643 "Db.c"
		}
	}
#line 251 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "develop_embedded_id")) {
#line 252 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:252: upgrade_database: adding develop_embedded_id column to Ph" \
"otoTable");
#line 253 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "develop_embedded_id", "INTEGER DEFAULT -1")) {
#line 254 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 254 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 656 "Db.c"
		}
	}
#line 257 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 13;
#line 264 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (input_version < 14) {
#line 265 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		tag_table_upgrade_for_htags ();
#line 665 "Db.c"
	}
#line 267 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 14;
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 15;
#line 289 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (input_version < 16) {
#line 292 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		gsettings_configuration_engine_run_gsettings_migrator ();
#line 675 "Db.c"
	}
#line 295 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 16;
#line 302 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("PhotoTable", "comment")) {
#line 303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:303: upgrade_database: adding comment column to PhotoTable");
#line 304 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("PhotoTable", "comment", "TEXT")) {
#line 305 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 305 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 689 "Db.c"
		}
	}
#line 307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (database_table_has_table ("VideoTable") & (!database_table_has_column ("VideoTable", "comment"))) {
#line 308 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:308: upgrade_database: adding comment column to VideoTable");
#line 309 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("VideoTable", "comment", "TEXT")) {
#line 310 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 310 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 702 "Db.c"
		}
	}
#line 313 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 17;
#line 320 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("EventTable", "comment")) {
#line 321 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:321: upgrade_database: adding comment column to EventTable");
#line 322 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("EventTable", "comment", "TEXT")) {
#line 323 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 323 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 717 "Db.c"
		}
	}
#line 326 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 18;
#line 337 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (input_version < 19) {
#line 724 "Db.c"
		Application* _tmp3_;
		Application* _tmp4_;
#line 338 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp3_ = application_get_instance ();
#line 338 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp4_ = _tmp3_;
#line 338 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		application_set_raw_thumbs_fix_required (_tmp4_, TRUE);
#line 338 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_application_unref0 (_tmp4_);
#line 735 "Db.c"
	}
#line 341 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 19;
#line 351 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 20;
#line 358 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_ensure_column ("PhotoTable", "has_gps", "INTEGER DEFAULT -1", "upgrade_database: adding gps_lat column to PhotoTable")) {
#line 358 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp6_ = TRUE;
#line 745 "Db.c"
	} else {
#line 360 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp6_ = !database_table_ensure_column ("PhotoTable", "gps_lat", "REAL", "upgrade_database: adding gps_lat column to PhotoTable");
#line 749 "Db.c"
	}
#line 358 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (_tmp6_) {
#line 358 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp5_ = TRUE;
#line 755 "Db.c"
	} else {
#line 362 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		_tmp5_ = !database_table_ensure_column ("PhotoTable", "gps_lon", "REAL", "upgrade_database: adding gps_lon column to PhotoTable");
#line 759 "Db.c"
	}
#line 358 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (_tmp5_) {
#line 364 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 364 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		return result;
#line 767 "Db.c"
	}
#line 367 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 21;
#line 375 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp7_ = face_table_get_instance ();
#line 375 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp8_ = _tmp7_;
#line 375 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_database_table_unref0 (_tmp8_);
#line 376 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp9_ = face_location_table_get_instance ();
#line 376 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp10_ = _tmp9_;
#line 376 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_database_table_unref0 (_tmp10_);
#line 377 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("FaceLocationTable", "vec")) {
#line 378 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:378: upgrade_database: adding vec column to FaceLocationTable");
#line 379 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("FaceLocationTable", "vec", "TEXT")) {
#line 380 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 380 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 793 "Db.c"
		}
	}
#line 382 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("FaceLocationTable", "guess")) {
#line 383 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:383: upgrade_database: adding guess column to FaceLocationTabl" \
"e");
#line 384 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("FaceLocationTable", "guess", "INTEGER DEFAULT 0")) {
#line 385 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 385 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 806 "Db.c"
		}
	}
#line 387 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	if (!database_table_has_column ("FaceTable", "ref")) {
#line 388 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		g_message ("Db.vala:388: upgrade_database: adding ref column to FaceTable");
#line 389 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
		if (!database_table_add_column ("FaceTable", "ref", "INTEGER DEFAULT -1")) {
#line 390 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 390 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
			return result;
#line 819 "Db.c"
		}
	}
#line 393 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version = 22;
#line 399 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp11_ = version;
#line 399 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_vala_assert (_tmp11_ == DATABASE_TABLE_SCHEMA_VERSION, "version == DatabaseTable.SCHEMA_VERSION");
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp12_ = version_table_get_instance ();
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp13_ = _tmp12_;
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp14_ = version;
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	version_table_update_version (_tmp13_, _tmp14_, RESOURCES_APP_VERSION);
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_database_table_unref0 (_tmp13_);
#line 402 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	_tmp15_ = version;
#line 402 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	g_message ("Db.vala:402: Database upgrade to schema version %d successful", _tmp15_);
#line 404 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 404 "/builddir/build/BUILD/shotwell-0.31.1/src/db/Db.vala"
	return result;
#line 846 "Db.c"
}



