/* FaceTable.c generated by valac 0.40.19, the Vala compiler
 * generated from FaceTable.vala, do not modify */

/* Copyright 2018 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sqlite3.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_FACE_ID (face_id_get_type ())
typedef struct _FaceID FaceID;

#define TYPE_FACE_ROW (face_row_get_type ())
#define FACE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_ROW, FaceRow))
#define FACE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_ROW, FaceRowClass))
#define IS_FACE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_ROW))
#define IS_FACE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_ROW))
#define FACE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_ROW, FaceRowClass))

typedef struct _FaceRow FaceRow;
typedef struct _FaceRowClass FaceRowClass;
typedef struct _FaceRowPrivate FaceRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecFaceRow ParamSpecFaceRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_FACE_TABLE (face_table_get_type ())
#define FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_TABLE, FaceTable))
#define FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_TABLE, FaceTableClass))
#define IS_FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_TABLE))
#define IS_FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_TABLE))
#define FACE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_TABLE, FaceTableClass))

typedef struct _FaceTable FaceTable;
typedef struct _FaceTableClass FaceTableClass;
typedef struct _FaceTablePrivate FaceTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _face_row_unref0(var) ((var == NULL) ? NULL : (var = (face_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FaceID {
	gint64 id;
};

struct _PhotoID {
	gint64 id;
};

struct _FaceRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	FaceRowPrivate * priv;
	FaceID face_id;
	gchar* name;
	time_t time_created;
	PhotoID ref;
	gchar* vec;
};

struct _FaceRowClass {
	GTypeClass parent_class;
	void (*finalize) (FaceRow *self);
};

struct _ParamSpecFaceRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _FaceTable {
	DatabaseTable parent_instance;
	FaceTablePrivate * priv;
};

struct _FaceTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer face_row_parent_class = NULL;
static gpointer face_table_parent_class = NULL;
static FaceTable* face_table_instance;
static FaceTable* face_table_instance = NULL;
extern sqlite3* database_table_db;

GType face_id_get_type (void) G_GNUC_CONST;
FaceID* face_id_dup (const FaceID* self);
void face_id_free (FaceID* self);
#define FACE_ID_INVALID ((gint64) -1)
void face_id_init (FaceID *self,
                   gint64 id);
gboolean face_id_is_invalid (FaceID *self);
gboolean face_id_is_valid (FaceID *self);
gpointer face_row_ref (gpointer instance);
void face_row_unref (gpointer instance);
GParamSpec* param_spec_face_row (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags);
void value_set_face_row (GValue* value,
                         gpointer v_object);
void value_take_face_row (GValue* value,
                          gpointer v_object);
gpointer value_get_face_row (const GValue* value);
GType face_row_get_type (void) G_GNUC_CONST;
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
FaceRow* face_row_new (void);
FaceRow* face_row_construct (GType object_type);
static void face_row_finalize (FaceRow * obj);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType face_table_get_type (void) G_GNUC_CONST;
static FaceTable* face_table_new (void);
static FaceTable* face_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
void database_table_fatal (const gchar* op,
                           gint res);
FaceTable* face_table_get_instance (void);
GQuark database_error_quark (void);
FaceRow* face_table_add (FaceTable* self,
                         const gchar* name,
                         GError** error);
gulong now_sec (void);
void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
void face_table_create_from_row (FaceTable* self,
                                 FaceRow* row,
                                 FaceID* result,
                                 GError** error);
void face_table_remove (FaceTable* self,
                        FaceID* face_id,
                        GError** error);
void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
gchar* face_table_get_name (FaceTable* self,
                            FaceID* face_id,
                            GError** error);
gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt* * stmt);
FaceRow* face_table_get_row (FaceTable* self,
                             FaceID* face_id,
                             GError** error);
GeeList* face_table_get_all_rows (FaceTable* self,
                                  GError** error);
void face_table_rename (FaceTable* self,
                        FaceID* face_id,
                        const gchar* new_name,
                        GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
void face_table_set_reference (FaceTable* self,
                               FaceID* face_id,
                               PhotoID* photo_id,
                               GError** error);
GeeList* face_table_get_ref_rows (FaceTable* self,
                                  GError** error);
void photo_id_init (PhotoID *self,
                    gint64 id);
static void face_table_finalize (DatabaseTable * obj);


void
face_id_init (FaceID *self,
              gint64 id)
{
#line 12 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	memset (self, 0, sizeof (FaceID));
#line 13 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	(*self).id = id;
#line 243 "FaceTable.c"
}


gboolean
face_id_is_invalid (FaceID *self)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = (*self).id;
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	result = _tmp0_ == FACE_ID_INVALID;
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return result;
#line 258 "FaceTable.c"
}


gboolean
face_id_is_valid (FaceID *self)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = (*self).id;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	result = _tmp0_ != FACE_ID_INVALID;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return result;
#line 273 "FaceTable.c"
}


FaceID*
face_id_dup (const FaceID* self)
{
	FaceID* dup;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	dup = g_new0 (FaceID, 1);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	memcpy (dup, self, sizeof (FaceID));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return dup;
#line 287 "FaceTable.c"
}


void
face_id_free (FaceID* self)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_free (self);
#line 296 "FaceTable.c"
}


GType
face_id_get_type (void)
{
	static volatile gsize face_id_type_id__volatile = 0;
	if (g_once_init_enter (&face_id_type_id__volatile)) {
		GType face_id_type_id;
		face_id_type_id = g_boxed_type_register_static ("FaceID", (GBoxedCopyFunc) face_id_dup, (GBoxedFreeFunc) face_id_free);
		g_once_init_leave (&face_id_type_id__volatile, face_id_type_id);
	}
	return face_id_type_id__volatile;
}


FaceRow*
face_row_construct (GType object_type)
{
	FaceRow* self = NULL;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	self = (FaceRow*) g_type_create_instance (object_type);
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return self;
#line 321 "FaceTable.c"
}


FaceRow*
face_row_new (void)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return face_row_construct (TYPE_FACE_ROW);
#line 330 "FaceTable.c"
}


static void
value_face_row_init (GValue* value)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	value->data[0].v_pointer = NULL;
#line 339 "FaceTable.c"
}


static void
value_face_row_free_value (GValue* value)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (value->data[0].v_pointer) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		face_row_unref (value->data[0].v_pointer);
#line 350 "FaceTable.c"
	}
}


static void
value_face_row_copy_value (const GValue* src_value,
                           GValue* dest_value)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		dest_value->data[0].v_pointer = face_row_ref (src_value->data[0].v_pointer);
#line 363 "FaceTable.c"
	} else {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 367 "FaceTable.c"
	}
}


static gpointer
value_face_row_peek_pointer (const GValue* value)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return value->data[0].v_pointer;
#line 377 "FaceTable.c"
}


static gchar*
value_face_row_collect_value (GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (collect_values[0].v_pointer) {
#line 389 "FaceTable.c"
		FaceRow * object;
		object = collect_values[0].v_pointer;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 396 "FaceTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 400 "FaceTable.c"
		}
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		value->data[0].v_pointer = face_row_ref (object);
#line 404 "FaceTable.c"
	} else {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 408 "FaceTable.c"
	}
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return NULL;
#line 412 "FaceTable.c"
}


static gchar*
value_face_row_lcopy_value (const GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
	FaceRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (!object_p) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 428 "FaceTable.c"
	}
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (!value->data[0].v_pointer) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		*object_p = NULL;
#line 434 "FaceTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		*object_p = value->data[0].v_pointer;
#line 438 "FaceTable.c"
	} else {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		*object_p = face_row_ref (value->data[0].v_pointer);
#line 442 "FaceTable.c"
	}
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return NULL;
#line 446 "FaceTable.c"
}


GParamSpec*
param_spec_face_row (const gchar* name,
                     const gchar* nick,
                     const gchar* blurb,
                     GType object_type,
                     GParamFlags flags)
{
	ParamSpecFaceRow* spec;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_FACE_ROW), NULL);
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return G_PARAM_SPEC (spec);
#line 466 "FaceTable.c"
}


gpointer
value_get_face_row (const GValue* value)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW), NULL);
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return value->data[0].v_pointer;
#line 477 "FaceTable.c"
}


void
value_set_face_row (GValue* value,
                    gpointer v_object)
{
	FaceRow * old;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW));
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	old = value->data[0].v_pointer;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (v_object) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FACE_ROW));
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		value->data[0].v_pointer = v_object;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		face_row_ref (value->data[0].v_pointer);
#line 500 "FaceTable.c"
	} else {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 504 "FaceTable.c"
	}
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (old) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		face_row_unref (old);
#line 510 "FaceTable.c"
	}
}


void
value_take_face_row (GValue* value,
                     gpointer v_object)
{
	FaceRow * old;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FACE_ROW));
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	old = value->data[0].v_pointer;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (v_object) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FACE_ROW));
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		value->data[0].v_pointer = v_object;
#line 532 "FaceTable.c"
	} else {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		value->data[0].v_pointer = NULL;
#line 536 "FaceTable.c"
	}
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (old) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		face_row_unref (old);
#line 542 "FaceTable.c"
	}
}


static void
face_row_class_init (FaceRowClass * klass)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	face_row_parent_class = g_type_class_peek_parent (klass);
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	((FaceRowClass *) klass)->finalize = face_row_finalize;
#line 554 "FaceTable.c"
}


static void
face_row_instance_init (FaceRow * self)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	self->ref_count = 1;
#line 563 "FaceTable.c"
}


static void
face_row_finalize (FaceRow * obj)
{
	FaceRow * self;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FACE_ROW, FaceRow);
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_signal_handlers_destroy (self);
#line 27 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_g_free0 (self->name);
#line 30 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_g_free0 (self->vec);
#line 579 "FaceTable.c"
}


GType
face_row_get_type (void)
{
	static volatile gsize face_row_type_id__volatile = 0;
	if (g_once_init_enter (&face_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_face_row_init, value_face_row_free_value, value_face_row_copy_value, value_face_row_peek_pointer, "p", value_face_row_collect_value, "p", value_face_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (FaceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) face_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FaceRow), 0, (GInstanceInitFunc) face_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType face_row_type_id;
		face_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FaceRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&face_row_type_id__volatile, face_row_type_id);
	}
	return face_row_type_id__volatile;
}


gpointer
face_row_ref (gpointer instance)
{
	FaceRow * self;
	self = instance;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return instance;
#line 608 "FaceTable.c"
}


void
face_row_unref (gpointer instance)
{
	FaceRow * self;
	self = instance;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		FACE_ROW_GET_CLASS (self)->finalize (self);
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 623 "FaceTable.c"
	}
}


static FaceTable*
face_table_construct (GType object_type)
{
	FaceTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
#line 36 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	self = (FaceTable*) database_table_construct (object_type);
#line 37 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "FaceTable");
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "FaceTable " "(" "id INTEGER NOT NULL PRIMARY KEY, " "name TEXT NOT NULL, " "time_created TIMESTAMP, " "ref INTEGER DEFAULT -1" ")", -1, &_tmp1_, NULL);
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = _tmp2_;
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 50 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp4_ = stmt;
#line 50 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_step (_tmp4_);
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp5_ = res;
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (_tmp5_ != SQLITE_DONE) {
#line 666 "FaceTable.c"
		gint _tmp6_;
#line 52 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_tmp6_ = res;
#line 52 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		database_table_fatal ("create FaceTable", _tmp6_);
#line 672 "FaceTable.c"
	}
#line 36 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 36 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return self;
#line 678 "FaceTable.c"
}


static FaceTable*
face_table_new (void)
{
#line 36 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return face_table_construct (TYPE_FACE_TABLE);
#line 687 "FaceTable.c"
}


static gpointer
_database_table_ref0 (gpointer self)
{
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 696 "FaceTable.c"
}


FaceTable*
face_table_get_instance (void)
{
	FaceTable* result = NULL;
	FaceTable* _tmp0_;
	FaceTable* _tmp2_;
	FaceTable* _tmp3_;
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = face_table_instance;
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (_tmp0_ == NULL) {
#line 711 "FaceTable.c"
		FaceTable* _tmp1_;
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_tmp1_ = face_table_new ();
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_database_table_unref0 (face_table_instance);
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		face_table_instance = _tmp1_;
#line 719 "FaceTable.c"
	}
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp2_ = face_table_instance;
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	result = _tmp3_;
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return result;
#line 729 "FaceTable.c"
}


FaceRow*
face_table_add (FaceTable* self,
                const gchar* name,
                GError** error)
{
	FaceRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	time_t time_created = 0;
	sqlite3_stmt* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	time_t _tmp9_;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_;
	gint _tmp12_;
	FaceRow* row = NULL;
	FaceRow* _tmp14_;
	FaceRow* _tmp15_;
	sqlite3* _tmp16_;
	FaceRow* _tmp17_;
	gchar* _tmp18_;
	FaceRow* _tmp19_;
	time_t _tmp20_;
	GError* _inner_error0_ = NULL;
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO FaceTable (name, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = _tmp2_;
#line 66 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 66 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 68 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	time_created = (time_t) now_sec ();
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp4_ = stmt;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp5_ = g_strdup (name);
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp6_ = g_free;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_bind_text (_tmp4_, 1, _tmp5_, -1, _tmp6_);
#line 71 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp7_ = res;
#line 71 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 72 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp8_ = stmt;
#line 72 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp9_ = time_created;
#line 72 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp8_, 2, (gint64) _tmp9_);
#line 73 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp10_ = res;
#line 73 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp10_ == SQLITE_OK, "res == Sqlite.OK");
#line 75 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp11_ = stmt;
#line 75 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_step (_tmp11_);
#line 76 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp12_ = res;
#line 76 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (_tmp12_ != SQLITE_DONE) {
#line 814 "FaceTable.c"
		gint _tmp13_;
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_tmp13_ = res;
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		database_table_throw_error ("FaceTable.add", _tmp13_, &_inner_error0_);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				return NULL;
#line 830 "FaceTable.c"
			} else {
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				g_clear_error (&_inner_error0_);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				return NULL;
#line 840 "FaceTable.c"
			}
		}
	}
#line 79 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp14_ = face_row_new ();
#line 79 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	row = _tmp14_;
#line 80 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp15_ = row;
#line 80 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp16_ = database_table_db;
#line 80 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	face_id_init (&_tmp15_->face_id, sqlite3_last_insert_rowid (_tmp16_));
#line 81 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp17_ = row;
#line 81 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp18_ = g_strdup (name);
#line 81 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_g_free0 (_tmp17_->name);
#line 81 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp17_->name = _tmp18_;
#line 82 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp19_ = row;
#line 82 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp20_ = time_created;
#line 82 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp19_->time_created = _tmp20_;
#line 84 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	result = row;
#line 84 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 84 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return result;
#line 874 "FaceTable.c"
}


void
face_table_create_from_row (FaceTable* self,
                            FaceRow* row,
                            FaceID* result,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GDestroyNotify _tmp7_;
	gint _tmp8_;
	sqlite3_stmt* _tmp9_;
	time_t _tmp10_;
	gint _tmp11_;
	sqlite3_stmt* _tmp12_;
	gint _tmp13_;
	sqlite3* _tmp15_;
	FaceID _tmp16_ = {0};
	GError* _inner_error0_ = NULL;
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_ROW (row));
#line 89 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 89 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO FaceTable (name, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
#line 89 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 89 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 89 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = _tmp2_;
#line 91 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 91 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 93 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp4_ = stmt;
#line 93 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp5_ = row->name;
#line 93 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 93 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp7_ = g_free;
#line 93 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_bind_text (_tmp4_, 1, _tmp6_, -1, _tmp7_);
#line 94 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp8_ = res;
#line 94 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp8_ == SQLITE_OK, "res == Sqlite.OK");
#line 95 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp9_ = stmt;
#line 95 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp10_ = row->time_created;
#line 95 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp9_, 2, (gint64) _tmp10_);
#line 96 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp11_ = res;
#line 96 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp11_ == SQLITE_OK, "res == Sqlite.OK");
#line 98 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp12_ = stmt;
#line 98 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_step (_tmp12_);
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp13_ = res;
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (_tmp13_ != SQLITE_DONE) {
#line 953 "FaceTable.c"
		gint _tmp14_;
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_tmp14_ = res;
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		database_table_throw_error ("FaceTable.create_from_row", _tmp14_, &_inner_error0_);
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				return;
#line 969 "FaceTable.c"
			} else {
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				g_clear_error (&_inner_error0_);
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				return;
#line 979 "FaceTable.c"
			}
		}
	}
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp15_ = database_table_db;
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	face_id_init (&_tmp16_, sqlite3_last_insert_rowid (_tmp15_));
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	*result = _tmp16_;
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return;
#line 993 "FaceTable.c"
}


void
face_table_remove (FaceTable* self,
                   FaceID* face_id,
                   GError** error)
{
	FaceID _tmp0_;
	gint64 _tmp1_;
	GError* _inner_error0_ = NULL;
#line 105 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 105 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (face_id != NULL);
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp1_ = _tmp0_.id;
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, &_inner_error0_);
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			return;
#line 1023 "FaceTable.c"
		} else {
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			g_clear_error (&_inner_error0_);
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			return;
#line 1031 "FaceTable.c"
		}
	}
}


gchar*
face_table_get_name (FaceTable* self,
                     FaceID* face_id,
                     GError** error)
{
	gchar* result = NULL;
	sqlite3_stmt* stmt = NULL;
	FaceID _tmp0_;
	gint64 _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gboolean _tmp3_;
	sqlite3_stmt* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
#line 109 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 109 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_val_if_fail (face_id != NULL, NULL);
#line 111 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 111 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp1_ = _tmp0_.id;
#line 111 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp3_ = database_table_select_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "name", &_tmp2_);
#line 111 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 111 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	stmt = _tmp2_;
#line 111 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (!_tmp3_) {
#line 112 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		result = NULL;
#line 112 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_sqlite3_finalize0 (stmt);
#line 112 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		return result;
#line 1073 "FaceTable.c"
	}
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp4_ = stmt;
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (_tmp4_, 0);
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	result = _tmp6_;
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 114 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return result;
#line 1087 "FaceTable.c"
}


FaceRow*
face_table_get_row (FaceTable* self,
                    FaceID* face_id,
                    GError** error)
{
	FaceRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	FaceID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	gint _tmp9_;
	FaceRow* row = NULL;
	FaceRow* _tmp12_;
	FaceRow* _tmp13_;
	FaceID _tmp14_;
	FaceRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	FaceRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 117 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 117 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_val_if_fail (face_id != NULL, NULL);
#line 119 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 119 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT name, time_created FROM FaceTable WHERE id=?", -1, &_tmp1_, NULL);
#line 119 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 119 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 119 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = _tmp2_;
#line 121 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 121 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp4_ = stmt;
#line 123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp5_ = *face_id;
#line 123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp6_ = _tmp5_.id;
#line 123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 124 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp7_ = res;
#line 124 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 126 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp8_ = stmt;
#line 126 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_step (_tmp8_);
#line 127 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp9_ = res;
#line 127 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (_tmp9_ == SQLITE_DONE) {
#line 128 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		result = NULL;
#line 128 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_sqlite3_finalize0 (stmt);
#line 128 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		return result;
#line 1164 "FaceTable.c"
	} else {
		gint _tmp10_;
#line 129 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_tmp10_ = res;
#line 129 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		if (_tmp10_ != SQLITE_ROW) {
#line 1171 "FaceTable.c"
			gint _tmp11_;
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp11_ = res;
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			database_table_throw_error ("FaceTable.get_row", _tmp11_, &_inner_error0_);
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					_sqlite3_finalize0 (stmt);
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					return NULL;
#line 1187 "FaceTable.c"
				} else {
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					_sqlite3_finalize0 (stmt);
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					g_clear_error (&_inner_error0_);
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					return NULL;
#line 1197 "FaceTable.c"
				}
			}
		}
	}
#line 132 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp12_ = face_row_new ();
#line 132 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	row = _tmp12_;
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp13_ = row;
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp14_ = *face_id;
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp13_->face_id = _tmp14_;
#line 134 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp15_ = row;
#line 134 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp16_ = stmt;
#line 134 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp17_ = (const gchar*) sqlite3_column_text (_tmp16_, 0);
#line 134 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 134 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_g_free0 (_tmp15_->name);
#line 134 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp15_->name = _tmp18_;
#line 135 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp19_ = row;
#line 135 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp20_ = stmt;
#line 135 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp19_->time_created = (time_t) sqlite3_column_int64 (_tmp20_, 1);
#line 137 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	result = row;
#line 137 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 137 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return result;
#line 1236 "FaceTable.c"
}


GeeList*
face_table_get_all_rows (FaceTable* self,
                         GError** error)
{
	GeeList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	GeeList* rows = NULL;
	GeeArrayList* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 140 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 142 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 142 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, name, time_created FROM FaceTable", -1, &_tmp1_, NULL);
#line 142 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 142 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 142 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = _tmp2_;
#line 144 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 144 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 146 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp4_ = gee_array_list_new (TYPE_FACE_ROW, (GBoxedCopyFunc) face_row_ref, (GDestroyNotify) face_row_unref, NULL, NULL, NULL);
#line 146 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	rows = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_LIST, GeeList);
#line 1274 "FaceTable.c"
	{
		gboolean _tmp5_ = FALSE;
#line 148 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_tmp5_ = TRUE;
#line 148 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		while (TRUE) {
#line 1281 "FaceTable.c"
			sqlite3_stmt* _tmp6_;
			gint _tmp7_;
			FaceRow* row = NULL;
			FaceRow* _tmp10_;
			FaceRow* _tmp11_;
			sqlite3_stmt* _tmp12_;
			FaceRow* _tmp13_;
			sqlite3_stmt* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			FaceRow* _tmp17_;
			sqlite3_stmt* _tmp18_;
			GeeList* _tmp19_;
			FaceRow* _tmp20_;
#line 148 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			if (!_tmp5_) {
#line 1298 "FaceTable.c"
			}
#line 148 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp5_ = FALSE;
#line 149 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp6_ = stmt;
#line 149 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			res = sqlite3_step (_tmp6_);
#line 150 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp7_ = res;
#line 150 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			if (_tmp7_ == SQLITE_DONE) {
#line 151 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				break;
#line 1312 "FaceTable.c"
			} else {
				gint _tmp8_;
#line 152 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				_tmp8_ = res;
#line 152 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				if (_tmp8_ != SQLITE_ROW) {
#line 1319 "FaceTable.c"
					gint _tmp9_;
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					_tmp9_ = res;
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					database_table_throw_error ("FaceTable.get_all_rows", _tmp9_, &_inner_error0_);
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							return NULL;
#line 1337 "FaceTable.c"
						} else {
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							g_clear_error (&_inner_error0_);
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							return NULL;
#line 1349 "FaceTable.c"
						}
					}
				}
			}
#line 156 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp10_ = face_row_new ();
#line 156 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			row = _tmp10_;
#line 157 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp11_ = row;
#line 157 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp12_ = stmt;
#line 157 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			face_id_init (&_tmp11_->face_id, sqlite3_column_int64 (_tmp12_, 0));
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp13_ = row;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp14_ = stmt;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp15_ = (const gchar*) sqlite3_column_text (_tmp14_, 1);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp16_ = g_strdup (_tmp15_);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_g_free0 (_tmp13_->name);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp13_->name = _tmp16_;
#line 159 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp17_ = row;
#line 159 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp18_ = stmt;
#line 159 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp17_->time_created = (time_t) sqlite3_column_int64 (_tmp18_, 2);
#line 161 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp19_ = rows;
#line 161 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp20_ = row;
#line 161 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection), _tmp20_);
#line 148 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_face_row_unref0 (row);
#line 1390 "FaceTable.c"
		}
	}
#line 164 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	result = rows;
#line 164 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 164 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return result;
#line 1399 "FaceTable.c"
}


void
face_table_rename (FaceTable* self,
                   FaceID* face_id,
                   const gchar* new_name,
                   GError** error)
{
	FaceID _tmp0_;
	gint64 _tmp1_;
	GError* _inner_error0_ = NULL;
#line 167 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 167 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (face_id != NULL);
#line 167 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (new_name != NULL);
#line 168 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = *face_id;
#line 168 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp1_ = _tmp0_.id;
#line 168 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "name", new_name, &_inner_error0_);
#line 168 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 168 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 168 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 168 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			return;
#line 1432 "FaceTable.c"
		} else {
#line 168 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 168 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			g_clear_error (&_inner_error0_);
#line 168 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			return;
#line 1440 "FaceTable.c"
		}
	}
}


void
face_table_set_reference (FaceTable* self,
                          FaceID* face_id,
                          PhotoID* photo_id,
                          GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	PhotoID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	FaceID _tmp9_;
	gint64 _tmp10_;
	gint _tmp11_;
	sqlite3_stmt* _tmp12_;
	gint _tmp13_;
	GError* _inner_error0_ = NULL;
#line 171 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (IS_FACE_TABLE (self));
#line 171 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (face_id != NULL);
#line 171 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 174 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 174 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE FaceTable SET ref=? WHERE id=?", -1, &_tmp1_, NULL);
#line 174 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 174 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 174 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = _tmp2_;
#line 175 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 175 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 176 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp4_ = stmt;
#line 176 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp5_ = *photo_id;
#line 176 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp6_ = _tmp5_.id;
#line 176 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 177 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp7_ = res;
#line 177 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 178 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp8_ = stmt;
#line 178 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp9_ = *face_id;
#line 178 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp10_ = _tmp9_.id;
#line 178 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_bind_int64 (_tmp8_, 2, _tmp10_);
#line 179 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp11_ = res;
#line 179 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp11_ == SQLITE_OK, "res == Sqlite.OK");
#line 181 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp12_ = stmt;
#line 181 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = sqlite3_step (_tmp12_);
#line 182 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp13_ = res;
#line 182 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	if (_tmp13_ != SQLITE_DONE) {
#line 1521 "FaceTable.c"
		gint _tmp14_;
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_tmp14_ = res;
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		database_table_throw_error ("FaceTable.set_reference", _tmp14_, &_inner_error0_);
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				return;
#line 1537 "FaceTable.c"
			} else {
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				_sqlite3_finalize0 (stmt);
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				g_clear_error (&_inner_error0_);
#line 183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				return;
#line 1547 "FaceTable.c"
			}
		}
	}
#line 171 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1553 "FaceTable.c"
}


GeeList*
face_table_get_ref_rows (FaceTable* self,
                         GError** error)
{
	GeeList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	GeeList* rows = NULL;
	GeeArrayList* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 186 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
#line 188 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp0_ = database_table_db;
#line 188 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, name, time_created, ref FROM FaceTable WHERE ref != -1", -1, &_tmp1_, NULL);
#line 188 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 188 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	stmt = _tmp1_;
#line 188 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	res = _tmp2_;
#line 190 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp3_ = res;
#line 190 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 192 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_tmp4_ = gee_array_list_new (TYPE_FACE_ROW, (GBoxedCopyFunc) face_row_ref, (GDestroyNotify) face_row_unref, NULL, NULL, NULL);
#line 192 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	rows = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_LIST, GeeList);
#line 1591 "FaceTable.c"
	{
		gboolean _tmp5_ = FALSE;
#line 194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		_tmp5_ = TRUE;
#line 194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
		while (TRUE) {
#line 1598 "FaceTable.c"
			sqlite3_stmt* _tmp6_;
			gint _tmp7_;
			FaceRow* row = NULL;
			FaceRow* _tmp10_;
			FaceRow* _tmp11_;
			sqlite3_stmt* _tmp12_;
			FaceRow* _tmp13_;
			sqlite3_stmt* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			FaceRow* _tmp17_;
			sqlite3_stmt* _tmp18_;
			FaceRow* _tmp19_;
			sqlite3_stmt* _tmp20_;
			GeeList* _tmp21_;
			FaceRow* _tmp22_;
#line 194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			if (!_tmp5_) {
#line 1617 "FaceTable.c"
			}
#line 194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp5_ = FALSE;
#line 195 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp6_ = stmt;
#line 195 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			res = sqlite3_step (_tmp6_);
#line 196 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp7_ = res;
#line 196 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			if (_tmp7_ == SQLITE_DONE) {
#line 197 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				break;
#line 1631 "FaceTable.c"
			} else {
				gint _tmp8_;
#line 198 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				_tmp8_ = res;
#line 198 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
				if (_tmp8_ != SQLITE_ROW) {
#line 1638 "FaceTable.c"
					gint _tmp9_;
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					_tmp9_ = res;
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					database_table_throw_error ("FaceTable.get_all_rows", _tmp9_, &_inner_error0_);
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							return NULL;
#line 1656 "FaceTable.c"
						} else {
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							_g_object_unref0 (rows);
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							_sqlite3_finalize0 (stmt);
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							g_clear_error (&_inner_error0_);
#line 199 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
							return NULL;
#line 1668 "FaceTable.c"
						}
					}
				}
			}
#line 202 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp10_ = face_row_new ();
#line 202 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			row = _tmp10_;
#line 203 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp11_ = row;
#line 203 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp12_ = stmt;
#line 203 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			face_id_init (&_tmp11_->face_id, sqlite3_column_int64 (_tmp12_, 0));
#line 204 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp13_ = row;
#line 204 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp14_ = stmt;
#line 204 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp15_ = (const gchar*) sqlite3_column_text (_tmp14_, 1);
#line 204 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp16_ = g_strdup (_tmp15_);
#line 204 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_g_free0 (_tmp13_->name);
#line 204 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp13_->name = _tmp16_;
#line 205 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp17_ = row;
#line 205 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp18_ = stmt;
#line 205 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp17_->time_created = (time_t) sqlite3_column_int64 (_tmp18_, 2);
#line 206 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp19_ = row;
#line 206 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp20_ = stmt;
#line 206 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			photo_id_init (&_tmp19_->ref, sqlite3_column_int64 (_tmp20_, 3));
#line 208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp21_ = rows;
#line 208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_tmp22_ = row;
#line 208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection), _tmp22_);
#line 194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
			_face_row_unref0 (row);
#line 1715 "FaceTable.c"
		}
	}
#line 211 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	result = rows;
#line 211 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	_sqlite3_finalize0 (stmt);
#line 211 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	return result;
#line 1724 "FaceTable.c"
}


static void
face_table_class_init (FaceTableClass * klass)
{
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	face_table_parent_class = g_type_class_peek_parent (klass);
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	((DatabaseTableClass *) klass)->finalize = face_table_finalize;
#line 1735 "FaceTable.c"
}


static void
face_table_instance_init (FaceTable * self)
{
}


static void
face_table_finalize (DatabaseTable * obj)
{
	FaceTable * self;
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FACE_TABLE, FaceTable);
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/db/FaceTable.vala"
	DATABASE_TABLE_CLASS (face_table_parent_class)->finalize (obj);
#line 1753 "FaceTable.c"
}


GType
face_table_get_type (void)
{
	static volatile gsize face_table_type_id__volatile = 0;
	if (g_once_init_enter (&face_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FaceTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) face_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FaceTable), 0, (GInstanceInitFunc) face_table_instance_init, NULL };
		GType face_table_type_id;
		face_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "FaceTable", &g_define_type_info, 0);
		g_once_init_leave (&face_table_type_id__volatile, face_table_type_id);
	}
	return face_table_type_id__volatile;
}



