/* BackgroundProgressBar.c generated by valac 0.40.19, the Vala compiler
 * generated from BackgroundProgressBar.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define TYPE_BACKGROUND_PROGRESS_BAR (background_progress_bar_get_type ())
#define BACKGROUND_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_PROGRESS_BAR, BackgroundProgressBar))
#define BACKGROUND_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_PROGRESS_BAR, BackgroundProgressBarClass))
#define IS_BACKGROUND_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_PROGRESS_BAR))
#define IS_BACKGROUND_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_PROGRESS_BAR))
#define BACKGROUND_PROGRESS_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_PROGRESS_BAR, BackgroundProgressBarClass))

typedef struct _BackgroundProgressBar BackgroundProgressBar;
typedef struct _BackgroundProgressBarClass BackgroundProgressBarClass;
typedef struct _BackgroundProgressBarPrivate BackgroundProgressBarPrivate;
typedef enum  {
	BACKGROUND_PROGRESS_BAR_PRIORITY_NONE = 0,
	BACKGROUND_PROGRESS_BAR_PRIORITY_STARTUP_SCAN = 35,
	BACKGROUND_PROGRESS_BAR_PRIORITY_REALTIME_UPDATE = 40,
	BACKGROUND_PROGRESS_BAR_PRIORITY_REALTIME_IMPORT = 50,
	BACKGROUND_PROGRESS_BAR_PRIORITY_METADATA_WRITER = 30
} BackgroundProgressBarPriority;


#define BACKGROUND_PROGRESS_BAR_TYPE_PRIORITY (background_progress_bar_priority_get_type ())
enum  {
	BACKGROUND_PROGRESS_BAR_0_PROPERTY,
	BACKGROUND_PROGRESS_BAR_SHOULD_BE_VISIBLE_PROPERTY,
	BACKGROUND_PROGRESS_BAR_NUM_PROPERTIES
};
static GParamSpec* background_progress_bar_properties[BACKGROUND_PROGRESS_BAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _BackgroundProgressBar {
	GtkProgressBar parent_instance;
	BackgroundProgressBarPrivate * priv;
};

struct _BackgroundProgressBarClass {
	GtkProgressBarClass parent_class;
};

struct _BackgroundProgressBarPrivate {
	gboolean _should_be_visible;
	BackgroundProgressBarPriority current_priority;
	guint pulse_id;
};


static gpointer background_progress_bar_parent_class = NULL;

GType background_progress_bar_get_type (void) G_GNUC_CONST;
GType background_progress_bar_priority_get_type (void) G_GNUC_CONST;
#define BACKGROUND_PROGRESS_BAR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BACKGROUND_PROGRESS_BAR, BackgroundProgressBarPrivate))
#define BACKGROUND_PROGRESS_BAR_PULSE_MSEC 250
BackgroundProgressBar* background_progress_bar_new (void);
BackgroundProgressBar* background_progress_bar_construct (GType object_type);
void background_progress_bar_start (BackgroundProgressBar* self,
                                    const gchar* label,
                                    BackgroundProgressBarPriority priority);
void background_progress_bar_stop (BackgroundProgressBar* self,
                                   BackgroundProgressBarPriority priority,
                                   gboolean clear);
static void background_progress_bar_set_should_be_visible (BackgroundProgressBar* self,
                                                    gboolean value);
static gboolean background_progress_bar_on_pulse_timeout (BackgroundProgressBar* self);
static gboolean _background_progress_bar_on_pulse_timeout_gsource_func (gpointer self);
void background_progress_bar_clear (BackgroundProgressBar* self,
                                    BackgroundProgressBarPriority priority);
gboolean background_progress_bar_update (BackgroundProgressBar* self,
                                         const gchar* label,
                                         BackgroundProgressBarPriority priority,
                                         gdouble count,
                                         gdouble total);
gboolean background_progress_bar_get_should_be_visible (BackgroundProgressBar* self);
static void background_progress_bar_finalize (GObject * obj);
static void _vala_background_progress_bar_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_background_progress_bar_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);


GType
background_progress_bar_priority_get_type (void)
{
	static volatile gsize background_progress_bar_priority_type_id__volatile = 0;
	if (g_once_init_enter (&background_progress_bar_priority_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKGROUND_PROGRESS_BAR_PRIORITY_NONE, "BACKGROUND_PROGRESS_BAR_PRIORITY_NONE", "none"}, {BACKGROUND_PROGRESS_BAR_PRIORITY_STARTUP_SCAN, "BACKGROUND_PROGRESS_BAR_PRIORITY_STARTUP_SCAN", "startup-scan"}, {BACKGROUND_PROGRESS_BAR_PRIORITY_REALTIME_UPDATE, "BACKGROUND_PROGRESS_BAR_PRIORITY_REALTIME_UPDATE", "realtime-update"}, {BACKGROUND_PROGRESS_BAR_PRIORITY_REALTIME_IMPORT, "BACKGROUND_PROGRESS_BAR_PRIORITY_REALTIME_IMPORT", "realtime-import"}, {BACKGROUND_PROGRESS_BAR_PRIORITY_METADATA_WRITER, "BACKGROUND_PROGRESS_BAR_PRIORITY_METADATA_WRITER", "metadata-writer"}, {0, NULL, NULL}};
		GType background_progress_bar_priority_type_id;
		background_progress_bar_priority_type_id = g_enum_register_static ("BackgroundProgressBarPriority", values);
		g_once_init_leave (&background_progress_bar_priority_type_id__volatile, background_progress_bar_priority_type_id);
	}
	return background_progress_bar_priority_type_id__volatile;
}


BackgroundProgressBar*
background_progress_bar_construct (GType object_type)
{
	BackgroundProgressBar * self = NULL;
#line 26 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	self = (BackgroundProgressBar*) g_object_new (object_type, "show-text", TRUE, NULL);
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	return self;
#line 125 "BackgroundProgressBar.c"
}


BackgroundProgressBar*
background_progress_bar_new (void)
{
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	return background_progress_bar_construct (TYPE_BACKGROUND_PROGRESS_BAR);
#line 134 "BackgroundProgressBar.c"
}


static gboolean
_background_progress_bar_on_pulse_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = background_progress_bar_on_pulse_timeout ((BackgroundProgressBar*) self);
#line 42 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	return result;
#line 145 "BackgroundProgressBar.c"
}


void
background_progress_bar_start (BackgroundProgressBar* self,
                               const gchar* label,
                               BackgroundProgressBarPriority priority)
{
	BackgroundProgressBarPriority _tmp0_;
#line 32 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_return_if_fail (IS_BACKGROUND_PROGRESS_BAR (self));
#line 32 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_return_if_fail (label != NULL);
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_tmp0_ = self->priv->current_priority;
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	if (priority < _tmp0_) {
#line 34 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		return;
#line 165 "BackgroundProgressBar.c"
	}
#line 36 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	background_progress_bar_stop (self, priority, FALSE);
#line 38 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	self->priv->current_priority = priority;
#line 39 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	gtk_progress_bar_set_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_progress_bar_get_type (), GtkProgressBar), label);
#line 40 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	gtk_progress_bar_pulse (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_progress_bar_get_type (), GtkProgressBar));
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	background_progress_bar_set_should_be_visible (self, TRUE);
#line 42 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	self->priv->pulse_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) BACKGROUND_PROGRESS_BAR_PULSE_MSEC, _background_progress_bar_on_pulse_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 179 "BackgroundProgressBar.c"
}


void
background_progress_bar_stop (BackgroundProgressBar* self,
                              BackgroundProgressBarPriority priority,
                              gboolean clear)
{
	BackgroundProgressBarPriority _tmp0_;
	guint _tmp1_;
#line 45 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_return_if_fail (IS_BACKGROUND_PROGRESS_BAR (self));
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_tmp0_ = self->priv->current_priority;
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	if (priority < _tmp0_) {
#line 47 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		return;
#line 198 "BackgroundProgressBar.c"
	}
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_tmp1_ = self->priv->pulse_id;
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	if (_tmp1_ != ((guint) 0)) {
#line 204 "BackgroundProgressBar.c"
		guint _tmp2_;
#line 50 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		_tmp2_ = self->priv->pulse_id;
#line 50 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		g_source_remove (_tmp2_);
#line 51 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		self->priv->pulse_id = (guint) 0;
#line 212 "BackgroundProgressBar.c"
	}
#line 54 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	if (clear) {
#line 55 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		background_progress_bar_clear (self, priority);
#line 218 "BackgroundProgressBar.c"
	}
}


gboolean
background_progress_bar_update (BackgroundProgressBar* self,
                                const gchar* label,
                                BackgroundProgressBarPriority priority,
                                gdouble count,
                                gdouble total)
{
	gboolean result = FALSE;
	BackgroundProgressBarPriority _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gdouble fraction = 0.0;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 58 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_return_val_if_fail (IS_BACKGROUND_PROGRESS_BAR (self), FALSE);
#line 58 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_return_val_if_fail (label != NULL, FALSE);
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_tmp0_ = self->priv->current_priority;
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	if (priority < _tmp0_) {
#line 60 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		result = FALSE;
#line 60 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		return result;
#line 251 "BackgroundProgressBar.c"
	}
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	background_progress_bar_stop (self, priority, FALSE);
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	if (count <= 0.0) {
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		_tmp2_ = TRUE;
#line 259 "BackgroundProgressBar.c"
	} else {
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		_tmp2_ = total <= 0.0;
#line 263 "BackgroundProgressBar.c"
	}
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	if (_tmp2_) {
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		_tmp1_ = TRUE;
#line 269 "BackgroundProgressBar.c"
	} else {
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		_tmp1_ = count >= total;
#line 273 "BackgroundProgressBar.c"
	}
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	if (_tmp1_) {
#line 65 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		background_progress_bar_clear (self, priority);
#line 67 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		result = FALSE;
#line 67 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		return result;
#line 283 "BackgroundProgressBar.c"
	}
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	self->priv->current_priority = priority;
#line 72 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	fraction = count / total;
#line 73 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_tmp3_ = fraction;
#line 73 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	gtk_progress_bar_set_fraction (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_progress_bar_get_type (), GtkProgressBar), _tmp3_);
#line 74 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_tmp4_ = fraction;
#line 74 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_tmp5_ = g_strdup_printf (_ ("%s (%d%%)"), label, (gint) (_tmp4_ * 100.0));
#line 74 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_tmp6_ = _tmp5_;
#line 74 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	gtk_progress_bar_set_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_progress_bar_get_type (), GtkProgressBar), _tmp6_);
#line 74 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_g_free0 (_tmp6_);
#line 75 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	background_progress_bar_set_should_be_visible (self, TRUE);
#line 83 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	result = TRUE;
#line 83 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	return result;
#line 309 "BackgroundProgressBar.c"
}


void
background_progress_bar_clear (BackgroundProgressBar* self,
                               BackgroundProgressBarPriority priority)
{
	BackgroundProgressBarPriority _tmp0_;
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_return_if_fail (IS_BACKGROUND_PROGRESS_BAR (self));
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_tmp0_ = self->priv->current_priority;
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	if (priority < _tmp0_) {
#line 88 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		return;
#line 326 "BackgroundProgressBar.c"
	}
#line 90 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	background_progress_bar_stop (self, priority, FALSE);
#line 92 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	self->priv->current_priority = 0;
#line 94 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	gtk_progress_bar_set_fraction (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_progress_bar_get_type (), GtkProgressBar), 0.0);
#line 95 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	gtk_progress_bar_set_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_progress_bar_get_type (), GtkProgressBar), "");
#line 96 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	background_progress_bar_set_should_be_visible (self, FALSE);
#line 338 "BackgroundProgressBar.c"
}


static gboolean
background_progress_bar_on_pulse_timeout (BackgroundProgressBar* self)
{
	gboolean result = FALSE;
#line 104 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_return_val_if_fail (IS_BACKGROUND_PROGRESS_BAR (self), FALSE);
#line 105 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	gtk_progress_bar_pulse (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_progress_bar_get_type (), GtkProgressBar));
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	result = TRUE;
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	return result;
#line 354 "BackgroundProgressBar.c"
}


gboolean
background_progress_bar_get_should_be_visible (BackgroundProgressBar* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 16 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_return_val_if_fail (IS_BACKGROUND_PROGRESS_BAR (self), FALSE);
#line 16 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	_tmp0_ = self->priv->_should_be_visible;
#line 16 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	result = _tmp0_;
#line 16 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	return result;
#line 371 "BackgroundProgressBar.c"
}


static void
background_progress_bar_set_should_be_visible (BackgroundProgressBar* self,
                                               gboolean value)
{
#line 16 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_return_if_fail (IS_BACKGROUND_PROGRESS_BAR (self));
#line 16 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	if (background_progress_bar_get_should_be_visible (self) != value) {
#line 16 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		self->priv->_should_be_visible = value;
#line 16 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		g_object_notify_by_pspec ((GObject *) self, background_progress_bar_properties[BACKGROUND_PROGRESS_BAR_SHOULD_BE_VISIBLE_PROPERTY]);
#line 387 "BackgroundProgressBar.c"
	}
}


static void
background_progress_bar_class_init (BackgroundProgressBarClass * klass)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	background_progress_bar_parent_class = g_type_class_peek_parent (klass);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_type_class_add_private (klass, sizeof (BackgroundProgressBarPrivate));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_background_progress_bar_get_property;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_background_progress_bar_set_property;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	G_OBJECT_CLASS (klass)->finalize = background_progress_bar_finalize;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BACKGROUND_PROGRESS_BAR_SHOULD_BE_VISIBLE_PROPERTY, background_progress_bar_properties[BACKGROUND_PROGRESS_BAR_SHOULD_BE_VISIBLE_PROPERTY] = g_param_spec_boolean ("should-be-visible", "should-be-visible", "should-be-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 407 "BackgroundProgressBar.c"
}


static void
background_progress_bar_instance_init (BackgroundProgressBar * self)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	self->priv = BACKGROUND_PROGRESS_BAR_GET_PRIVATE (self);
#line 16 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	self->priv->_should_be_visible = FALSE;
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	self->priv->current_priority = BACKGROUND_PROGRESS_BAR_PRIORITY_NONE;
#line 30 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	self->priv->pulse_id = (guint) 0;
#line 422 "BackgroundProgressBar.c"
}


static void
background_progress_bar_finalize (GObject * obj)
{
	BackgroundProgressBar * self;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKGROUND_PROGRESS_BAR, BackgroundProgressBar);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	G_OBJECT_CLASS (background_progress_bar_parent_class)->finalize (obj);
#line 434 "BackgroundProgressBar.c"
}


GType
background_progress_bar_get_type (void)
{
	static volatile gsize background_progress_bar_type_id__volatile = 0;
	if (g_once_init_enter (&background_progress_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BackgroundProgressBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_progress_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackgroundProgressBar), 0, (GInstanceInitFunc) background_progress_bar_instance_init, NULL };
		GType background_progress_bar_type_id;
		background_progress_bar_type_id = g_type_register_static (gtk_progress_bar_get_type (), "BackgroundProgressBar", &g_define_type_info, 0);
		g_once_init_leave (&background_progress_bar_type_id__volatile, background_progress_bar_type_id);
	}
	return background_progress_bar_type_id__volatile;
}


static void
_vala_background_progress_bar_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	BackgroundProgressBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BACKGROUND_PROGRESS_BAR, BackgroundProgressBar);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	switch (property_id) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		case BACKGROUND_PROGRESS_BAR_SHOULD_BE_VISIBLE_PROPERTY:
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		g_value_set_boolean (value, background_progress_bar_get_should_be_visible (self));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		break;
#line 468 "BackgroundProgressBar.c"
		default:
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		break;
#line 474 "BackgroundProgressBar.c"
	}
}


static void
_vala_background_progress_bar_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	BackgroundProgressBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BACKGROUND_PROGRESS_BAR, BackgroundProgressBar);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
	switch (property_id) {
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		case BACKGROUND_PROGRESS_BAR_SHOULD_BE_VISIBLE_PROPERTY:
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		background_progress_bar_set_should_be_visible (self, g_value_get_boolean (value));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		break;
#line 495 "BackgroundProgressBar.c"
		default:
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/library/BackgroundProgressBar.vala"
		break;
#line 501 "BackgroundProgressBar.c"
	}
}



