/* Photo.c generated by valac 0.40.19, the Vala compiler
 * generated from Photo.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <time.h>
#include <float.h>
#include <math.h>
#include "shotwell-graphics-processor.h"
#include <glib/gstdio.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;


#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;
typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;


#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;
enum  {
	PHOTO_TRANSFORMATION_STATE_0_PROPERTY,
	PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES
};
static GParamSpec* photo_transformation_state_properties[PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES];
enum  {
	PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL,
	PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS
};
static guint photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS] = {0};
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;


#define TYPE_RATING (rating_get_type ())

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;


#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;
typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;


#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_POSITIONABLE (positionable_get_type ())
#define POSITIONABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POSITIONABLE, Positionable))
#define IS_POSITIONABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POSITIONABLE))
#define POSITIONABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_POSITIONABLE, PositionableIface))

typedef struct _Positionable Positionable;
typedef struct _PositionableIface PositionableIface;

#define TYPE_GPS_COORDS (gps_coords_get_type ())
typedef struct _GpsCoords GpsCoords;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;
typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;


#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;
typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;


#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
enum  {
	PHOTO_0_PROPERTY,
	PHOTO_NUM_PROPERTIES
};
static GParamSpec* photo_properties[PHOTO_NUM_PROPERTIES];

#define PHOTO_TYPE_CACHED_PIXBUF (photo_cached_pixbuf_get_type ())
#define PHOTO_CACHED_PIXBUF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbuf))
#define PHOTO_CACHED_PIXBUF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbufClass))
#define PHOTO_IS_CACHED_PIXBUF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_CACHED_PIXBUF))
#define PHOTO_IS_CACHED_PIXBUF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_CACHED_PIXBUF))
#define PHOTO_CACHED_PIXBUF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbufClass))

typedef struct _PhotoCachedPixbuf PhotoCachedPixbuf;
typedef struct _PhotoCachedPixbufClass PhotoCachedPixbufClass;
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;


#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;


#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;
typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;


#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;


#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef enum  {
	PHOTO_FILE_READER_ROLE_DEFAULT,
	PHOTO_FILE_READER_ROLE_THUMBNAIL
} PhotoFileReaderRole;


#define PHOTO_FILE_READER_TYPE_ROLE (photo_file_reader_role_get_type ())

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE (photo_reimport_raw_development_state_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))

typedef struct _PhotoReimportRawDevelopmentState PhotoReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateClass PhotoReimportRawDevelopmentStateClass;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStatePrivate PhotoReimportRawDevelopmentStatePrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;
typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;


#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;
typedef struct _PhotoCachedPixbufPrivate PhotoCachedPixbufPrivate;
#define _photo_cached_pixbuf_unref0(var) ((var == NULL) ? NULL : (var = (photo_cached_pixbuf_unref (var), NULL)))

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
typedef void (*OneShotCallback) (gpointer user_data);
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_0_PROPERTY,
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES
};
static GParamSpec* photo_photo_transformation_state_impl_properties[PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES];
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoParamSpecCachedPixbuf PhotoParamSpecCachedPixbuf;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
enum  {
	PHOTO_EDITABLE_REPLACED_SIGNAL,
	PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL,
	PHOTO_BASELINE_REPLACED_SIGNAL,
	PHOTO_MASTER_REIMPORTED_SIGNAL,
	PHOTO_EDITABLE_REIMPORTED_SIGNAL,
	PHOTO_BASELINE_REIMPORTED_SIGNAL,
	PHOTO_SOURCE_REIMPORTED_SIGNAL,
	PHOTO_NUM_SIGNALS
};
static guint photo_signals[PHOTO_NUM_SIGNALS] = {0};
typedef struct _DataCollectionPrivate DataCollectionPrivate;
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, gpointer user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;
typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;


#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, gpointer user_data);
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, gpointer user_data);

#define TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (library_photo_source_holding_tank_get_type ())
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))

typedef struct _LibraryPhotoSourceHoldingTank LibraryPhotoSourceHoldingTank;
typedef struct _LibraryPhotoSourceHoldingTankClass LibraryPhotoSourceHoldingTankClass;

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS
};
static guint library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS] = {0};

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;
enum  {
	LIBRARY_PHOTO_0_PROPERTY,
	LIBRARY_PHOTO_NUM_PROPERTIES
};
static GParamSpec* library_photo_properties[LIBRARY_PHOTO_NUM_PROPERTIES];
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;


#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;
typedef struct _MediaSourceHoldingTankPrivate MediaSourceHoldingTankPrivate;
typedef struct _LibraryPhotoSourceHoldingTankPrivate LibraryPhotoSourceHoldingTankPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ImportID {
	gint64 id;
};

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _EventID {
	gint64 id;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

struct _GpsCoords {
	gint has_gps;
	gdouble latitude;
	gdouble longitude;
};

struct _PositionableIface {
	GTypeInterface parent_iface;
	void (*get_gps_coords) (Positionable* self, GpsCoords* result);
	void (*set_gps_coords) (Positionable* self, GpsCoords* gps_coords);
};

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
	PhotoRow* row;
	gboolean can_rotate_now;
	BackingPhotoRow* backing_photo_row;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_raw_development_modified) (Photo* self);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*raw_development_modified) (Photo* self);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

struct _PhotoPrivate {
	time_t cached_exposure_time;
	GRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GeeHashMap* developments;
	GRecMutex __lock_developments;
};

struct _PhotoID {
	gint64 id;
};

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	GpsCoords gps_coords;
	gchar* comment;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStatePrivate * priv;
};

struct _PhotoReimportRawDevelopmentStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentState *self);
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

struct _PhotoCachedPixbuf {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoCachedPixbufPrivate * priv;
	Photo* photo;
	GdkPixbuf* pixbuf;
	GTimer* last_touched;
};

struct _PhotoCachedPixbufClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoCachedPixbuf *self);
};

struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecCachedPixbuf {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, gpointer comparator_target, ComparatorPredicate predicate, gpointer predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, gpointer monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _MediaSourceHoldingTank {
	DatabaseSourceHoldingTank parent_instance;
	MediaSourceHoldingTankPrivate * priv;
};

struct _MediaSourceHoldingTankClass {
	DatabaseSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTank {
	MediaSourceHoldingTank parent_instance;
	LibraryPhotoSourceHoldingTankPrivate * priv;
};

struct _LibraryPhotoSourceHoldingTankClass {
	MediaSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};


static gpointer photo_import_params_parent_class = NULL;
static gpointer photo_transformation_state_parent_class = NULL;
static gpointer photo_parent_class = NULL;
static GeeLinkedList* photo_source_pixbuf_cache;
static GRecMutex __lock_photo_photo_source_pixbuf_cache = {0};
static GeeLinkedList* photo_source_pixbuf_cache = NULL;
static guint photo_discard_source_id;
static guint photo_discard_source_id = (guint) 0;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_cached_pixbuf_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface * photo_dateable_parent_iface = NULL;
static PositionableIface * photo_positionable_parent_iface = NULL;
static gpointer library_photo_source_collection_parent_class = NULL;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern TagSourceCollection* tag_global;
static FlaggableIface * library_photo_flaggable_parent_iface = NULL;
static MonitorableIface * library_photo_monitorable_parent_iface = NULL;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_photo_import_params (GValue* value,
                                    gpointer v_object);
void value_take_photo_import_params (GValue* value,
                                     gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_thumbnails (GValue* value,
                           gpointer v_object);
void value_take_thumbnails (GValue* value,
                            gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_photo_row (GValue* value,
                          gpointer v_object);
void value_take_photo_row (GValue* value,
                           gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST;
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
PhotoImportParams* photo_import_params_new (GFile* file,
                                            GFile* final_associated_file,
                                            ImportID* import_id,
                                            PhotoFileSnifferOptions sniffer_options,
                                            const gchar* exif_md5,
                                            const gchar* thumbnail_md5,
                                            const gchar* full_md5,
                                            Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type,
                                                  GFile* file,
                                                  GFile* final_associated_file,
                                                  ImportID* import_id,
                                                  PhotoFileSnifferOptions sniffer_options,
                                                  const gchar* exif_md5,
                                                  const gchar* thumbnail_md5,
                                                  const gchar* full_md5,
                                                  Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file,
                                                               ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type,
                                                                     GFile* file,
                                                                     ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams * obj);
GType photo_transformation_state_get_type (void) G_GNUC_CONST;
#define PHOTO_TRANSFORMATION_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStatePrivate))
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject * obj);
GType rating_get_type (void) G_GNUC_CONST;
gboolean rating_can_increase (Rating self);
gboolean rating_can_decrease (Rating self);
gboolean rating_is_valid (Rating self);
Rating rating_increase (Rating self);
Rating rating_decrease (Rating self);
gint rating_serialize (Rating self);
Rating rating_unserialize (gint value);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_snapshot (GValue* value,
                                gpointer v_object);
void value_take_source_snapshot (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_backing_file_state (GValue* value,
                                   gpointer v_object);
void value_take_backing_file_state (GValue* value,
                                    gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType photo_exception_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_media_metadata (GValue* value,
                               gpointer v_object);
void value_take_media_metadata (GValue* value,
                                gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType gps_coords_get_type (void) G_GNUC_CONST;
GpsCoords* gps_coords_dup (const GpsCoords* self);
void gps_coords_free (GpsCoords* self);
GType positionable_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType rotation_get_type (void) G_GNUC_CONST;
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_backing_photo_row (GValue* value,
                                  gpointer v_object);
void value_take_backing_photo_row (GValue* value,
                                   gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST;
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags) G_GNUC_UNUSED;
static void photo_value_set_backing_readers (GValue* value,
                                      gpointer v_object) G_GNUC_UNUSED;
static void photo_value_take_backing_readers (GValue* value,
                                       gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value,
                                   gpointer v_object);
void value_take_one_shot_scheduler (GValue* value,
                                    gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST;
GType raw_developer_get_type (void) G_GNUC_CONST;
#define PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO, PhotoPrivate))
gboolean photo_exception_prohibits (PhotoException self,
                                    PhotoException exception);
gboolean photo_exception_allows (PhotoException self,
                                 PhotoException exception);
static gpointer photo_cached_pixbuf_ref (gpointer instance);
static void photo_cached_pixbuf_unref (gpointer instance);
static GParamSpec* photo_param_spec_cached_pixbuf (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags) G_GNUC_UNUSED;
static void photo_value_set_cached_pixbuf (GValue* value,
                                    gpointer v_object) G_GNUC_UNUSED;
static void photo_value_take_cached_pixbuf (GValue* value,
                                     gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_value_get_cached_pixbuf (const GValue* value) G_GNUC_UNUSED;
static GType photo_cached_pixbuf_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
#define PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC 10
#define PHOTO_SOURCE_PIXBUF_MIN_LRU_COUNT 1
#define PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT 3
#define PHOTO_MIN_EMBEDDED_SIZE 1024
Photo* photo_construct (GType object_type,
                        PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) -1)
PhotoSource* photo_source_construct (GType object_type,
                                     gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType orientation_get_type (void) G_GNUC_CONST;
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
gchar* media_source_prep_comment (const gchar* comment);
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_photo_file_adapter (GValue* value,
                                   gpointer v_object);
void value_take_photo_file_adapter (GValue* value,
                                    gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_reader_get_type (void) G_GNUC_CONST;
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self,
                                                  const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack,
                                   gunichar ch,
                                   gint start_index);
gchar* string_sliced_at (const gchar* str,
                         gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
static BackingPhotoRow* photo_get_backing_row (Photo* self,
                                        BackingPhotoID* id);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType photo_table_get_type (void) G_GNUC_CONST;
PhotoTable* photo_table_get_instance (void);
GQuark database_error_quark (void);
void photo_table_detach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  GError** error);
void photo_remove_all_transformations (Photo* self,
                                       gboolean notify);
RawDeveloper* raw_developer_as_array (int* result_length1);
void photo_init_photo (void);
void photo_terminate_photo (void);
void photo_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file);
static void photo_real_notify_editable_replaced (Photo* self,
                                          GFile* old_file,
                                          GFile* new_file);
void photo_notify_raw_development_modified (Photo* self);
static void photo_real_notify_raw_development_modified (Photo* self);
void photo_notify_baseline_replaced (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_notify_master_reimported (Photo* self,
                                          PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self,
                                            PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self,
                                          PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self,
                                            PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base,
                                             GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self,
                            gboolean delete_editable,
                            gboolean remove_transformations,
                            gboolean notify);
PhotoFileFormat photo_get_master_file_format (Photo* self);
static gboolean photo_delete_raw_development (Photo* self,
                                       RawDeveloper d);
gchar* data_object_to_string (DataObject* self);
gboolean data_source_internal_delete_backing (DataSource* self,
                                              GError** error);
GType backing_photo_table_get_type (void) G_GNUC_CONST;
BackingPhotoTable* backing_photo_table_get_instance (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GError** error);
void backing_photo_table_remove (BackingPhotoTable* self,
                                 BackingPhotoID* backing_id,
                                 GError** error);
gboolean photo_is_raw_developer_complete (Photo* self,
                                          RawDeveloper d);
gboolean photo_is_raw_developer_available (Photo* self,
                                           RawDeveloper d);
PhotoMetadata* photo_get_master_metadata (Photo* self,
                                          GError** error);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_photo_preview (GValue* value,
                              gpointer v_object);
void value_take_photo_preview (GValue* value,
                               gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self,
                                          guint number);
void photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                         Dimensions* result);
void photo_add_backing_photo_for_development (Photo* self,
                                              RawDeveloper d,
                                              BackingPhotoRow* bpr,
                                              gboolean notify,
                                              GError** error);
void photo_import_developed_backing_photo (PhotoRow* row,
                                           RawDeveloper d,
                                           BackingPhotoRow* bpr,
                                           GError** error);
void data_object_notify_altered (DataObject* self,
                                 Alteration* alteration);
Alteration* alteration_new (const gchar* subject,
                            const gchar* detail);
Alteration* alteration_construct (GType object_type,
                                  const gchar* subject,
                                  const gchar* detail);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value,
                                        gpointer v_object);
void value_take_photo_file_interrogator (GValue* value,
                                         gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST;
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file,
                                                    PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type,
                                                          GFile* file,
                                                          PhotoFileSnifferOptions options);
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self,
                                          GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
void value_set_detected_photo_information (GValue* value,
                                           gpointer v_object);
void value_take_detected_photo_information (GValue* value,
                                            gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST;
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
gboolean photo_file_interrogator_get_is_photo_corrupted (PhotoFileInterrogator* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void backing_photo_table_add (BackingPhotoTable* self,
                              BackingPhotoRow* state,
                              GError** error);
void photo_table_update_raw_development (PhotoTable* self,
                                         PhotoRow* row,
                                         RawDeveloper rd,
                                         BackingPhotoID* backing_photo_id,
                                         GError** error);
static void photo_develop_photo (Photo* self,
                          RawDeveloper d,
                          gboolean notify);
BackingPhotoRow* raw_developer_create_backing_row_for_development (RawDeveloper self,
                                                                   const gchar* raw_filepath,
                                                                   const gchar* camera_development_filename,
                                                                   GError** error);
GdkPixbuf* photo_get_master_pixbuf (Photo* self,
                                    Scaling* scaling,
                                    gboolean rotate,
                                    GError** error);
void scaling_for_original (Scaling* result);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self,
                                                  const gchar* filepath,
                                                  GError** error);
GType jpeg_quality_get_type (void) G_GNUC_CONST;
void photo_file_writer_write (PhotoFileWriter* self,
                              GdkPixbuf* pixbuf,
                              JpegQuality quality,
                              GError** error);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self,
                                                                   const gchar* filepath,
                                                                   GError** error);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self,
                                                PhotoMetadata* metadata,
                                                GError** error);
GBytes* photo_preview_flatten (PhotoPreview* self,
                               GError** error);
gboolean jpeg_is_jpeg_bytes (GBytes* bytes,
                             GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self,
                                     GError** error);
void photo_set_default_raw_developer (Photo* self,
                                      RawDeveloper d);
void photo_set_raw_developer (Photo* self,
                              RawDeveloper d,
                              gboolean notify);
void photo_revert_to_master (Photo* self,
                             gboolean notify);
GdkPixbuf* photo_get_prefetched_copy (Photo* self,
                                      GError** error);
gboolean photo_set_orientation (Photo* self,
                                Orientation orientation);
void photo_discard_prefetched (Photo* self);
RawDeveloper photo_get_raw_developer (Photo* self);
gchar* raw_developer_to_string (RawDeveloper self);
void photo_table_remove_development (PhotoTable* self,
                                     PhotoRow* row,
                                     RawDeveloper rd,
                                     GError** error);
void photo_redevelop_raw (Photo* self,
                          RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base,
                                                       int* result_length1);
BackingFileState* backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row,
                                                         const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_row (GType object_type,
                                                               BackingPhotoRow* photo_row,
                                                               const gchar* md5);
static void _vala_array_add84 (BackingFileState** * array,
                        int* length,
                        int* size,
                        BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add85 (BackingFileState** * array,
                        int* length,
                        int* size,
                        BackingFileState* value);
gboolean photo_is_developed (Photo* self);
GeeCollection* photo_get_raw_development_photo_rows (Photo* self);
static void _vala_array_add86 (BackingFileState** * array,
                        int* length,
                        int* size,
                        BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self,
                                           BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
const gchar* backing_fetch_mode_to_string (BackingFetchMode self);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
BackingPhotoRow* photo_get_master_photo_row (Photo* self);
BackingPhotoRow* photo_get_editable_photo_row (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self,
                                                      RawDeveloper d);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self,
                                                        ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self,
                                                 ExportFormatParameters* params);
GFile* media_source_get_master_file (MediaSource* self);
gchar* photo_get_export_basename (Photo* self,
                                  PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_metadata_date_time (GValue* value,
                                   gpointer v_object);
void value_take_metadata_date_time (GValue* value,
                                    gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* media_metadata_get_title (MediaMetadata* self);
void photo_metadata_get_gps_coords (PhotoMetadata* self,
                                    GpsCoords* result);
gchar* media_metadata_get_comment (MediaMetadata* self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self,
                                     GCompareDataFunc compare_func,
                                     gpointer compare_func_target,
                                     GDestroyNotify compare_func_target_destroy_notify);
Rating photo_metadata_get_rating (PhotoMetadata* self);
#define PHOTO_ID_INVALID ((gint64) -1)
void photo_id_init (PhotoID *self,
                    gint64 id);
#define EVENT_ID_INVALID ((gint64) -1)
void event_id_init (EventID *self,
                    gint64 id);
GType photo_file_reader_role_get_type (void) G_GNUC_CONST;
void photo_file_reader_set_role (PhotoFileReader* self,
                                 PhotoFileReaderRole role);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails,
                                         PhotoFileReader* reader,
                                         Orientation orientation,
                                         Dimensions* original_dim,
                                         GError** error);
ImportResult import_result_convert_error (GError* err,
                                          ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
BackingPhotoRow* photo_query_backing_photo_row (Photo* self,
                                                GFile* file,
                                                PhotoFileSnifferOptions options,
                                                DetectedPhotoInformation* * detected,
                                                GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value,
                                            gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value,
                                             gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_master (Photo* self,
                                            PhotoReimportMasterState* * reimport_state,
                                            GError** error);
static void _vala_array_add87 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add88 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add89 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add90 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static gboolean _gps_coords_equal (const GpsCoords * s1,
                            const GpsCoords * s2);
static void _vala_array_add91 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add92 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add93 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row,
                                                                    PhotoMetadata* metadata,
                                                                    gchar** alterations,
                                                                    int alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type,
                                                                          PhotoRow* row,
                                                                          PhotoMetadata* metadata,
                                                                          gchar** alterations,
                                                                          int alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata);
static void photo_real_apply_user_metadata_for_reimport (Photo* self,
                                                  PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self,
                                   PhotoReimportMasterState* state,
                                   GError** error);
void photo_table_reimport (PhotoTable* self,
                           PhotoRow* row,
                           GError** error);
void backing_photo_row_copy_from (BackingPhotoRow* self,
                                  BackingPhotoRow* from);
static void _vala_array_add94 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add95 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
Alteration* alteration_new_from_array (gchar** array,
                                       int array_length1);
Alteration* alteration_construct_from_array (GType object_type,
                                             gchar** array,
                                             int array_length1);
static gboolean photo_verify_file_for_reimport (Photo* self,
                                         GFile* file,
                                         BackingPhotoRow* * backing,
                                         DetectedPhotoInformation* * detected,
                                         GError** error);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value,
                                              gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value,
                                               gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_editable (Photo* self,
                                              PhotoReimportEditableState* * state,
                                              GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                                                        PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type,
                                                                              BackingPhotoRow* backing_state,
                                                                              PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_finish_reimport_editable (Photo* self,
                                     PhotoReimportEditableState* state,
                                     GError** error);
void photo_get_editable_id (Photo* self,
                            BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self,
                                 BackingPhotoRow* row,
                                 GError** error);
void media_source_set_title (MediaSource* self,
                             const gchar* title);
void positionable_set_gps_coords (Positionable* self,
                                  GpsCoords* gps_coords);
gboolean media_source_set_comment (MediaSource* self,
                                   const gchar* comment);
void media_source_set_rating (MediaSource* self,
                              Rating rating);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type,
                                            const gchar* list);
gpointer photo_reimport_raw_development_state_ref (gpointer instance);
void photo_reimport_raw_development_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                             const gchar* nick,
                                                             const gchar* blurb,
                                                             GType object_type,
                                                             GParamFlags flags);
void photo_value_set_reimport_raw_development_state (GValue* value,
                                                     gpointer v_object);
void photo_value_take_reimport_raw_development_state (GValue* value,
                                                      gpointer v_object);
gpointer photo_value_get_reimport_raw_development_state (const GValue* value);
GType photo_reimport_raw_development_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_raw_development (Photo* self,
                                                     PhotoReimportRawDevelopmentState* * state,
                                                     GError** error);
GeeCollection* photo_get_raw_developer_files (Photo* self);
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                                    BackingPhotoRow* backing,
                                                    PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
void photo_finish_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState* state,
                                            GError** error);
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                                  const gchar* nick,
                                                                                  const gchar* blurb,
                                                                                  GType object_type,
                                                                                  GParamFlags flags) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                          gpointer v_object) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                           gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) G_GNUC_UNUSED;
GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST;
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self,
                         PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
void photo_set_master_timestamp (Photo* self,
                                 GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self,
                                   PhotoID* photo_id,
                                   time_t timestamp,
                                   GError** error);
void app_window_database_error (GError* err);
void photo_update_editable_modification_time (Photo* self,
                                              GFileInfo* info,
                                              GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                           BackingPhotoID* id,
                                           time_t timestamp,
                                           GError** error);
void photo_update_many_editable_timestamps (GeeMap* map,
                                            GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self,
                                    Scaling* scaling,
                                    GError** error);
void scaling_for_best_fit (gint pixels,
                           gboolean scale_up,
                           Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename,
                                   gchar** extensions,
                                   int extensions_length1);
void disassemble_filename (const gchar* basename,
                           gchar* * name,
                           gchar* * ext);
gboolean photo_is_duplicate (GFile* file,
                             const gchar* thumbnail_md5,
                             const gchar* full_md5,
                             PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self,
                                    GFile* file,
                                    const gchar* thumbnail_md5,
                                    const gchar* md5,
                                    PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file,
                                  const gchar* thumbnail_md5,
                                  const gchar* full_md5,
                                  PhotoFileFormat file_format,
                                  int* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self,
                                        GFile* file,
                                        const gchar* thumbnail_md5,
                                        const gchar* md5,
                                        PhotoFileFormat file_format,
                                        int* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST;
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self,
                            GFile* file);
void photo_table_set_filepath (PhotoTable* self,
                               PhotoID* photo_id,
                               const gchar* filepath,
                               GError** error);
void media_source_notify_master_replaced (MediaSource* self,
                                          GFile* old_file,
                                          GFile* new_file);
static void _vala_array_add96 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add97 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add98 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add99 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void photo_set_editable_file (Photo* self,
                              GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       const gchar* filepath,
                                       GError** error);
static void _vala_array_add100 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add101 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add102 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
void photo_set_many_editable_file (GeeMap* map,
                                   GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base,
                              EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base,
                               ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self,
                                 Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self,
                                 Alteration* other);
guint64 photo_replace_flags (Photo* self,
                             guint64 flags,
                             Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self,
                                    PhotoID* photo_id,
                                    guint64 flags);
gboolean photo_is_flag_set (Photo* self,
                            guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags,
                                            guint64 selector);
guint64 photo_add_flags (Photo* self,
                         guint64 mask,
                         Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags,
                                         guint64 selector);
guint64 photo_remove_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags,
                                            guint64 selector);
guint64 photo_add_remove_flags (Photo* self,
                                guint64 add,
                                guint64 remove,
                                Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add,
                                  guint64 add_mask,
                                  Alteration* additional_add_alteration,
                                  GeeCollection* remove,
                                  guint64 remove_mask,
                                  Alteration* additional_remove_alteration,
                                  GError** error);
guint64 photo_toggle_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self,
                                      gboolean dirty,
                                      GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self,
                                     PhotoID* photo_id,
                                     gboolean dirty,
                                     GError** error);
static Rating photo_real_get_rating (MediaSource* base);
static void photo_real_set_rating (MediaSource* base,
                            Rating rating);
gboolean photo_table_set_rating (PhotoTable* self,
                                 PhotoID* photo_id,
                                 Rating rating);
static void photo_real_increase_rating (MediaSource* base);
static void photo_real_decrease_rating (MediaSource* base);
static void photo_real_commit_backlinks (DataSource* base,
                                  SourceCollection* sources,
                                  const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* backlinks,
                                   GError** error);
static gboolean photo_real_set_event_id (MediaSource* base,
                                  EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self,
                                PhotoID* photo_id,
                                EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base,
                            DataSource* source);
gboolean data_source_equals (DataSource* self,
                             DataSource* source);
static void photo_file_exif_updated (Photo* self);
GFile* media_source_get_file (MediaSource* self);
gboolean photo_table_master_exif_updated (PhotoTable* self,
                                          PhotoID* photoID,
                                          gint64 filesize,
                                          glong timestamp,
                                          const gchar* md5,
                                          const gchar* exif_md5,
                                          const gchar* thumbnail_md5,
                                          PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static gchar* photo_real_get_comment (MediaSource* base);
static void photo_real_set_title (MediaSource* base,
                           const gchar* title);
gboolean photo_table_set_title (PhotoTable* self,
                                PhotoID* photo_id,
                                const gchar* new_title);
static void photo_real_get_gps_coords (Positionable* base,
                                GpsCoords* result);
static void photo_real_set_gps_coords (Positionable* base,
                                GpsCoords* gps_coords);
void photo_table_set_gps_coords (PhotoTable* self,
                                 PhotoID* photo_id,
                                 GpsCoords* new_gps_coords,
                                 GError** error);
static gboolean photo_real_set_comment (MediaSource* base,
                                 const gchar* comment);
gboolean photo_table_set_comment (PhotoTable* self,
                                  PhotoID* photo_id,
                                  const gchar* new_comment);
void photo_set_import_id (Photo* self,
                          ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self,
                                PhotoID* photo_id,
                                ImportID* import_id,
                                GError** error);
void photo_set_title_persistent (Photo* self,
                                 const gchar* title,
                                 GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self,
                                                GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self,
                               const gchar* title,
                               PhotoMetadataSetOption option);
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self,
                                                                   GError** error);
void library_monitor_blacklist_file (GFile* file,
                                     const gchar* reason);
void library_monitor_unblacklist_file (GFile* file);
void photo_set_comment_persistent (Photo* self,
                                   const gchar* comment,
                                   GError** error);
void photo_metadata_set_comment (PhotoMetadata* self,
                                 const gchar* comment,
                                 PhotoMetadataSetOption option);
static void photo_real_set_exposure_time (Dateable* base,
                                   time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self,
                                        PhotoID* photo_id,
                                        time_t time);
void photo_set_exposure_time_persistent (Photo* self,
                                         time_t time,
                                         GError** error);
void dateable_set_exposure_time (Dateable* self,
                                 time_t target_time);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                            MetadataDateTime* date_time,
                                            PhotoMetadataSetOption option);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type,
                                                time_t timestamp);
static void photo_real_get_dimensions (MediaSource* base,
                                PhotoException disallowed_steps,
                                Dimensions* result);
void photo_get_raw_dimensions (Photo* self,
                               Dimensions* result);
Orientation photo_get_orientation (Photo* self);
gboolean photo_get_straighten (Photo* self,
                               gdouble* theta);
void compute_arb_rotated_size (gdouble src_width,
                               gdouble src_height,
                               gdouble angle,
                               gdouble* dest_width,
                               gdouble* dest_height);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self,
                         Box* crop,
                         PhotoException exceptions);
void box_get_dimensions (Box *self,
                         Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
static KeyValueMap* photo_get_transformation (Photo* self,
                                       const gchar* name);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self,
                                   const gchar* name);
PixelTransformation* photo_get_color_adjustment (Photo* self,
                                                 PixelTransformationType type);
void photo_set_color_adjustments (Photo* self,
                                  PixelTransformationBundle* new_adjustments);
static gboolean photo_remove_transformation (Photo* self,
                                      const gchar* name);
static gboolean photo_set_transformation (Photo* self,
                                   KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_editable_metadata (Photo* self,
                                            GError** error);
gboolean photo_persist_master_metadata (Photo* self,
                                        PhotoMetadata* metadata,
                                        PhotoReimportMasterState* * state,
                                        GError** error);
void photo_finish_update_master_metadata (Photo* self,
                                          PhotoReimportMasterState* state,
                                          GError** error);
gboolean photo_persist_editable_metadata (Photo* self,
                                          PhotoMetadata* metadata,
                                          PhotoReimportEditableState* * state,
                                          GError** error);
void photo_finish_update_editable_metadata (Photo* self,
                                            PhotoReimportEditableState* state,
                                            GError** error);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
gboolean photo_has_alterations (Photo* self);
gchar* media_source_get_comment (MediaSource* self);
gchar* media_source_get_title (MediaSource* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo,
                                                                              Orientation orientation,
                                                                              GeeHashMap* transformations,
                                                                              PixelTransformer* transformer,
                                                                              PixelTransformationBundle* adjustments);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type,
                                                                                    Photo* photo,
                                                                                    Orientation orientation,
                                                                                    GeeHashMap* transformations,
                                                                                    PixelTransformer* transformer,
                                                                                    PixelTransformationBundle* adjustments);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gboolean photo_load_transformation_state (Photo* self,
                                          PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self,
                                               PhotoID* photo_id,
                                               Orientation orientation,
                                               GeeHashMap* transformations);
gboolean photo_table_remove_all_transformations (PhotoTable* self,
                                                 PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
gboolean photo_check_can_rotate (Photo* self);
void photo_rotate (Photo* self,
                   Rotation rotation);
static void photo_real_rotate (Photo* self,
                        Rotation rotation);
Orientation orientation_perform (Orientation self,
                                 Rotation rotation);
gboolean photo_table_set_transformation (PhotoTable* self,
                                         PhotoID* photo_id,
                                         KeyValueMap* map);
gboolean photo_table_remove_transformation (PhotoTable* self,
                                            PhotoID* photo_id,
                                            const gchar* object);
gboolean photo_has_crop (Photo* self);
gboolean photo_get_raw_crop (Photo* self,
                             Box* crop);
void box_init (Box *self,
               gint left,
               gint top,
               gint right,
               gint bottom);
static void photo_set_raw_crop (Photo* self,
                         Box* crop);
static gboolean photo_get_raw_straighten (Photo* self,
                                   gdouble* angle);
static void photo_set_raw_straighten (Photo* self,
                               gdouble theta);
GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST;
EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self,
                                                            int* result_length1);
gboolean photo_has_redeye_transformations (Photo* self);
void photo_add_redeye_instance (Photo* self,
                                EditingToolsRedeyeInstance* redeye);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self,
                                            Scaling* scaling,
                                            PhotoException exceptions,
                                            Dimensions* scaled_image,
                                            Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                                   Scaling* scaling,
                                                   PhotoException exceptions,
                                                   Dimensions* scaled_image,
                                                   Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self,
                             Dimensions* space,
                             Box* box,
                             Box* result);
void orientation_rotate_dimensions (Orientation self,
                                    Dimensions* dim,
                                    Dimensions* result);
void box_get_scaled (Box *self,
                     Dimensions* scaled,
                     Box* result);
void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self,
                                    Dimensions* original,
                                    Dimensions* scaled,
                                    Dimensions* result);
void orientation_derotate_dimensions (Orientation self,
                                      Dimensions* dim,
                                      Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self,
                                  Scaling* scaling,
                                  PhotoException exceptions,
                                  BackingFetchMode fetch_mode,
                                  GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self,
                                            GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self,
                                          Dimensions* full,
                                          Dimensions* scaled,
                                          GError** error);
gboolean dimensions_approx_equals (Dimensions *self,
                                   Dimensions* dim,
                                   gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self,
                                           Scaling* scaling,
                                           gboolean rotate,
                                           BackingFetchMode fetch_mode,
                                           GError** error);
GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self,
                                        Scaling* scaling,
                                        gboolean rotate,
                                        GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self,
                                      GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base,
                                  Scaling* scaling,
                                  GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          BackingFetchMode fetch_mode,
                                          GError** error);
static GdkPixbuf* photo_run_source_pixbuf_cache (Photo* locate,
                                          gboolean keep,
                                          GError** error);
static PhotoCachedPixbuf* photo_cached_pixbuf_new (Photo* photo,
                                            GdkPixbuf* pixbuf);
static PhotoCachedPixbuf* photo_cached_pixbuf_construct (GType object_type,
                                                  Photo* photo,
                                                  GdkPixbuf* pixbuf);
static gboolean photo_trim_source_pixbuf_cache (void);
static gboolean _photo_trim_source_pixbuf_cache_gsource_func (gpointer self);
gboolean photo_get_develop_raw_photos_to_files (void);
void media_source_get_dimensions (MediaSource* self,
                                  PhotoException disallowed_steps,
                                  Dimensions* result);
gboolean dimensions_equals (Dimensions *self,
                            Dimensions* dim);
static GdkPixbuf* photo_do_redeye (Photo* self,
                            GdkPixbuf* pixbuf,
                            EditingToolsRedeyeInstance* inst);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf,
                       gdouble angle);
gboolean photo_has_user_generated_metadata (Photo* self);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata);
static void photo_real_set_user_metadata_for_export (Photo* self,
                                              PhotoMetadata* metadata);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value,
                                             gpointer v_object);
void value_take_photo_file_format_properties (GValue* value,
                                              gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self,
                                                            GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self,
                                         GFile* file,
                                         gboolean export_metadata,
                                         GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
time_t media_source_get_exposure_time (MediaSource* self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                          Dimensions* dim,
                                          PhotoMetadataSetOption option);
void photo_metadata_set_orientation (PhotoMetadata* self,
                                     Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self,
                                  const gchar* software,
                                  const gchar* version);
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_clear (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self,
                                   Scaling* scaling,
                                   PhotoFileFormat export_format);
void photo_export (Photo* self,
                   GFile* dest_file,
                   Scaling* scaling,
                   JpegQuality quality,
                   PhotoFileFormat export_format,
                   gboolean direct_copy_unmodified,
                   gboolean export_metadata,
                   GError** error);
const gchar* photo_file_format_to_string (PhotoFileFormat self);
void photo_metadata_remove_tag (PhotoMetadata* self,
                                const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self,
                                         PhotoFileFormat* file_format,
                                         GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self,
                                                               const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GError** error);
static gboolean photo_launch_editor (GFile* file,
                              PhotoFileFormat file_format,
                              GError** error);
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
gchar* configuration_facade_get_external_raw_app (ConfigurationFacade* self);
gchar* configuration_facade_get_external_photo_app (ConfigurationFacade* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_with_raw_external_editor (Photo* self,
                                          GError** error);
void photo_open_with_external_editor (Photo* self,
                                      GError** error);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self,
                            PhotoFileFormat file_format,
                            GFile* file,
                            GError** error);
static void photo_start_monitoring_editable (Photo* self,
                                      GFile* file,
                                      GError** error);
static void photo_on_editable_file_changed (Photo* self,
                                     GFile* file,
                                     GFile* other_file,
                                     GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                             GFile* file,
                                                             GFile* other_file,
                                                             GFileMonitorEvent event_type,
                                                             gpointer self);
static void photo_update_editable (Photo* self,
                            gboolean only_attributes,
                            PhotoFileReader* new_reader,
                            GError** error);
static void photo_update_editable_attributes (Photo* self,
                                       GError** error);
void photo_reimport_editable (Photo* self,
                              GError** error);
void photo_table_attach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  BackingPhotoID* editable_id,
                                  GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            time_t timestamp,
                                            gint64 filesize,
                                            GError** error);
static void _vala_array_add103 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add104 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add105 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add106 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add107 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
static void _vala_array_add108 (gchar** * array,
                         int* length,
                         int* size,
                         gchar* value);
void backing_photo_id_init (BackingPhotoID *self,
                            gint64 id);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name,
                                          OneShotCallback callback,
                                          gpointer callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type,
                                                const gchar* name,
                                                OneShotCallback callback,
                                                gpointer callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self,
                                       guint msec,
                                       gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_original_dimensions (Photo* self,
                                    Dimensions* result);
void photo_get_master_dimensions (Photo* self,
                                  Dimensions* result);
void photo_set_crop (Photo* self,
                     Box* crop);
void orientation_derotate_box (Orientation self,
                               Dimensions* space,
                               Box* box,
                               Box* result);
void photo_set_straighten (Photo* self,
                           gdouble theta);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self,
                                   GdkPixbuf* pixbuf,
                                   gint x,
                                   gint y);
void photo_unscaled_to_raw_point (Photo* self,
                                  GdkPoint* unscaled_point,
                                  GdkPoint* result);
void orientation_derotate_point (Orientation self,
                                 Dimensions* space,
                                 GdkPoint* point,
                                 GdkPoint* result);
void photo_unscaled_to_raw_rect (Photo* self,
                                 GdkRectangle* unscaled_rect,
                                 GdkRectangle* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
gboolean photo_enhance (Photo* self);
void photo_set_develop_raw_photos_to_files (gboolean value);
static void photo_real_editable_replaced (Photo* self,
                                   GFile* old_file,
                                   GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self,
                                   PhotoMetadata* metadata);
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplPrivate))
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                                gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject * obj);
static void photo_backing_readers_finalize (PhotoBackingReaders * obj);
static void photo_cached_pixbuf_finalize (PhotoCachedPixbuf * obj);
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState * obj);
static gchar** _vala_array_dup27 (gchar** self,
                           int length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj);
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj);
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj);
PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                                                                                  PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                                                                        BackingPhotoRow* backing,
                                                                                                                        PhotoMetadata* metadata);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj);
static void photo_finalize (GObject * obj);
static void _vala_photo_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_backlink (GValue* value,
                                gpointer v_object);
void value_take_source_backlink (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
void value_set_workers (GValue* value,
                        gpointer v_object);
void value_take_workers (GValue* value,
                         gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionPrivate))
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
gboolean file_equal (GFile* a,
                     GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
gint int64_compare (gint64* a,
                    gint64* b);
static gint _int64_compare_gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (gint64* a,
                      gint64* b);
static gboolean _int64_equal_gee_equal_data_func (gconstpointer a,
                                           gconstpointer b,
                                           gpointer self);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source,
                                                     gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type,
                                                          const gchar* name,
                                                          GetSourceDatabaseKey source_key_func,
                                                          gpointer source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                                   GeeCollection* added,
                                                                   GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                         GeeCollection* added,
                                                                                                         GeeCollection* removed,
                                                                                                         gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                                  GeeCollection* added,
                                                                  GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                        GeeCollection* added,
                                                                                                        GeeCollection* removed,
                                                                                                        gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                                                      SourceHoldingTankCheckToKeep check_to_keep,
                                                                      gpointer check_to_keep_target,
                                                                      GetSourceDatabaseKey get_key,
                                                                      gpointer get_key_target);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type,
                                                                            LibraryPhotoSourceCollection* sources,
                                                                            SourceHoldingTankCheckToKeep check_to_keep,
                                                                            gpointer check_to_keep_target,
                                                                            GetSourceDatabaseKey get_key,
                                                                            gpointer get_key_target);
GType library_photo_source_holding_tank_get_type (void) G_GNUC_CONST;
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                                         Workers* workers,
                                                                         GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers,
                                 GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type,
                                       Workers* workers,
                                       GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                                    DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                                  GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                                   GeeIterable* added,
                                                                   GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                           Photo* photo,
                                                           GFile* old_file,
                                                           GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                    GFile* old_file,
                                                                                    GFile* new_file,
                                                                                    gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                                  Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                  gpointer self);
void data_collection_notify_contents_altered (DataCollection* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
static void library_photo_source_collection_real_items_altered (DataCollection* base,
                                                         GeeMap* items);
gboolean alteration_has_detail (Alteration* self,
                                const gchar* subject,
                                const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                      GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST;
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value,
                                       gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value,
                                        gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
HierarchicalTagIndex* hierarchical_tag_index_get_global_index (void);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gboolean hierarchical_tag_index_is_tag_in_index (HierarchicalTagIndex* self,
                                                 const gchar* tag);
gchar* tag_prep_tag_name (const gchar* name);
gchar* hierarchical_tag_index_get_path_for_name (HierarchicalTagIndex* self,
                                                 const gchar* name);
Tag* tag_for_path (const gchar* name);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self,
                      GeeCollection* sources);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self,
                                                         GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                                       gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                                     PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                                      const gchar* source_id);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self,
                                                          gint64 numeric_id);
gint64 parse_int64 (const gchar* str,
                    gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                                          EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self,
                                                EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self,
                                                     gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                                      GFile* file);
LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                                             GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                      LibraryPhoto* photo,
                                                      GFileInfo* info,
                                                      GeeCollection* matches_master,
                                                      GeeCollection* matches_editable,
                                                      GeeCollection* matches_development);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                              GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                                GFileInfo* info,
                                                                GeeCollection* matches_master,
                                                                GeeCollection* matches_editable,
                                                                GeeCollection* matched_development);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                      const gchar* basename,
                                                                      gint64 filesize,
                                                                      PhotoID* result);
gint utf8_ci_compare (void* a,
                      void* b);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                          const gchar* basename,
                                                                          gint64 filesize);
gboolean photo_id_is_valid (PhotoID *self);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self,
                                                             GFile* file);
LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                                       GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self,
                                                     const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                                 GFile* file,
                                                                 LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self,
                                                           GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                            SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self,
                                         SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self,
                                           SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                           SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self,
                                          SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self,
                                        SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type,
                                                                                 MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                          GValue * return_value,
                                                          guint n_param_values,
                                                          const GValue * param_values,
                                                          gpointer invocation_hint,
                                                          gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection * obj);
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO, LibraryPhotoPrivate))
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type,
                                       PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
static void library_photo_import_gps_metadata (LibraryPhoto* self);
static void _library_photo_import_gps_metadata_one_shot_callback (gpointer self);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self,
                                          gint priority);
void data_source_rehydrate_backlinks (DataSource* self,
                                      SourceCollection* unlinked_from,
                                      const gchar* dehydrated);
static void library_photo_upgrade_rating_flags (LibraryPhoto* self,
                                         guint64 flags);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type,
                                                          PhotoImportParams* import_params);
void library_photo_init (ProgressMonitor monitor,
                         gpointer monitor_target);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self,
                                         GeeCollection* objects,
                                         ProgressMonitor monitor,
                                         gpointer monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self,
                                                GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self,
                                                  GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params,
                                          LibraryPhoto* * photo);
void photo_table_add (PhotoTable* self,
                      PhotoRow* photo_row,
                      PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self,
                         PhotoID* photo_id,
                         GError** error);
static void library_photo_real_notify_master_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source,
                                         gboolean force,
                                         GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base,
                                        Alteration* alteration);
gboolean alteration_has_subject (Alteration* self,
                                 const gchar* subject);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base,
                                                  Scaling* scaling,
                                                  GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                           gint scale,
                                           GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
static void library_photo_real_rotate (Photo* base,
                                Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source,
                             Rotation rotation,
                             GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base,
                                             gint scale,
                                             GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source,
                                  gint scale,
                                  GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                            BackingPhotoRow* backing,
                                            BackingPhotoID* result,
                                            GError** error);
GFile* library_files_duplicate (GFile* src,
                                GFileProgressCallback progress_callback,
                                gpointer progress_callback_target,
                                gboolean blacklist,
                                GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self,
                                          gint64 current,
                                          gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                                   gint64 total_num_bytes,
                                                                   gpointer self);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self,
                                       GError** error);
void photo_table_duplicate (PhotoTable* self,
                            PhotoID* photo_id,
                            const gchar* new_filename,
                            BackingPhotoID* editable_id,
                            BackingPhotoID* develop_shotwell,
                            BackingPhotoID* develop_camera_id,
                            BackingPhotoID* develop_embedded_id,
                            PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self,
                               PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source,
                                ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self,
                              DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST;
GType event_get_type (void) G_GNUC_CONST;
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self,
                   MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self,
                                                 MediaSource* source);
void tag_attach (Tag* self,
                 MediaSource* source);
void spin_event_loop (void);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base,
                                                     GError** error);
gboolean media_source_delete_original_file (MediaSource* self);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
gboolean library_photo_has_nontrash_duplicate (GFile* file,
                                               const gchar* thumbnail_md5,
                                               const gchar* full_md5,
                                               PhotoFileFormat file_format);
void library_photo_get_nontrash_duplicate (GFile* file,
                                           const gchar* thumbnail_md5,
                                           const gchar* full_md5,
                                           PhotoFileFormat file_format,
                                           PhotoID* result);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
Rating media_source_get_rating (MediaSource* self);
void positionable_get_gps_coords (Positionable* self,
                                  GpsCoords* result);
gboolean gps_coords_equals (GpsCoords *self,
                            GpsCoords* gps);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base,
                                                      PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self,
                                  GeeCollection* keywords,
                                  PhotoMetadataSetOption option);
void photo_metadata_set_rating (PhotoMetadata* self,
                                Rating rating);
void photo_metadata_set_gps_coords (PhotoMetadata* self,
                                    GpsCoords* gps_coords);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                          PhotoMetadata* metadata);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
gboolean tag_source_collection_exists (TagSourceCollection* self,
                                       const gchar* name,
                                       gboolean treat_htags_as_root);
static void library_photo_finalize (GObject * obj);
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankPrivate))
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources,
                                                       SourceHoldingTankCheckToKeep check_to_keep,
                                                       gpointer check_to_keep_target,
                                                       GetSourceDatabaseKey get_key,
                                                       gpointer get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type,
                                                             MediaSourceCollection* sources,
                                                             SourceHoldingTankCheckToKeep check_to_keep,
                                                             gpointer check_to_keep_target,
                                                             GetSourceDatabaseKey get_key,
                                                             gpointer get_key_target);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                     GeeCollection* added,
                                                                     GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                             Photo* _photo,
                                                             GFile* old_file,
                                                             GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                      GFile* old_file,
                                                                                      GFile* new_file,
                                                                                      gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                                    Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                    gpointer self);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self,
                                                  GeeCollection* added,
                                                  GeeCollection* removed);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

GType
backing_fetch_mode_get_type (void)
{
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 3858 "Photo.c"
}


static gpointer
_thumbnails_ref0 (gpointer self)
{
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 3867 "Photo.c"
}


PhotoImportParams*
photo_import_params_construct (GType object_type,
                               GFile* file,
                               GFile* final_associated_file,
                               ImportID* import_id,
                               PhotoFileSnifferOptions sniffer_options,
                               const gchar* exif_md5,
                               const gchar* thumbnail_md5,
                               const gchar* full_md5,
                               Thumbnails* thumbnails)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	Thumbnails* _tmp6_;
#line 38 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((final_associated_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (final_associated_file, g_file_get_type ()), NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((thumbnails == NULL) || IS_THUMBNAILS (thumbnails), NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 41 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->file = _tmp0_;
#line 42 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (final_associated_file);
#line 42 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 42 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->final_associated_file = _tmp1_;
#line 43 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = *import_id;
#line 43 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->import_id = _tmp2_;
#line 44 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->sniffer_options = sniffer_options;
#line 45 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = g_strdup (exif_md5);
#line 45 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 45 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->exif_md5 = _tmp3_;
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = g_strdup (thumbnail_md5);
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 46 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->thumbnail_md5 = _tmp4_;
#line 47 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = g_strdup (full_md5);
#line 47 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 47 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->full_md5 = _tmp5_;
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = _thumbnails_ref0 (thumbnails);
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->thumbnails = _tmp6_;
#line 38 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 3944 "Photo.c"
}


PhotoImportParams*
photo_import_params_new (GFile* file,
                         GFile* final_associated_file,
                         ImportID* import_id,
                         PhotoFileSnifferOptions sniffer_options,
                         const gchar* exif_md5,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         Thumbnails* thumbnails)
{
#line 38 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 3960 "Photo.c"
}


PhotoImportParams*
photo_import_params_construct_create_placeholder (GType object_type,
                                                  GFile* file,
                                                  ImportID* import_id)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	ImportID _tmp1_;
#line 52 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 52 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 52 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 53 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 53 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 53 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->file = _tmp0_;
#line 54 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = *import_id;
#line 54 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->import_id = _tmp1_;
#line 55 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 56 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->exif_md5 = NULL;
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 58 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 58 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->full_md5 = NULL;
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 59 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->thumbnails = NULL;
#line 52 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 4008 "Photo.c"
}


PhotoImportParams*
photo_import_params_new_create_placeholder (GFile* file,
                                            ImportID* import_id)
{
#line 52 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 4018 "Photo.c"
}


static void
value_photo_import_params_init (GValue* value)
{
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 4027 "Photo.c"
}


static void
value_photo_import_params_free_value (GValue* value)
{
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 4038 "Photo.c"
	}
}


static void
value_photo_import_params_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 4051 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4055 "Photo.c"
	}
}


static gpointer
value_photo_import_params_peek_pointer (const GValue* value)
{
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 4065 "Photo.c"
}


static gchar*
value_photo_import_params_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 4077 "Photo.c"
		PhotoImportParams * object;
		object = collect_values[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4084 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4088 "Photo.c"
		}
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 4092 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4096 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 4100 "Photo.c"
}


static gchar*
value_photo_import_params_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoImportParams ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!object_p) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4116 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = NULL;
#line 4122 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 4126 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 4130 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 4134 "Photo.c"
}


GParamSpec*
param_spec_photo_import_params (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecPhotoImportParams* spec;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 4154 "Photo.c"
}


gpointer
value_get_photo_import_params (const GValue* value)
{
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 4165 "Photo.c"
}


void
value_set_photo_import_params (GValue* value,
                               gpointer v_object)
{
	PhotoImportParams * old;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 4188 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4192 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_import_params_unref (old);
#line 4198 "Photo.c"
	}
}


void
value_take_photo_import_params (GValue* value,
                                gpointer v_object)
{
	PhotoImportParams * old;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 4220 "Photo.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4224 "Photo.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_import_params_unref (old);
#line 4230 "Photo.c"
	}
}


static void
photo_import_params_class_init (PhotoImportParamsClass * klass)
{
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoImportParamsClass *) klass)->finalize = photo_import_params_finalize;
#line 4242 "Photo.c"
}


static void
photo_import_params_instance_init (PhotoImportParams * self)
{
	PhotoRow* _tmp0_;
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->final_associated_file = NULL;
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->row = _tmp0_;
#line 36 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->keywords = NULL;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->ref_count = 1;
#line 4260 "Photo.c"
}


static void
photo_import_params_finalize (PhotoImportParams * obj)
{
	PhotoImportParams * self;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams);
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 23 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 24 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 27 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 28 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 32 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 35 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 36 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 4288 "Photo.c"
}


GType
photo_import_params_get_type (void)
{
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_import_params_type_id;
		photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}


gpointer
photo_import_params_ref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return instance;
#line 4317 "Photo.c"
}


void
photo_import_params_unref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4332 "Photo.c"
	}
}


gboolean
photo_transformation_state_is_broken (PhotoTransformationState* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 72 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (self), FALSE);
#line 73 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->is_broke;
#line 73 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 73 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 4350 "Photo.c"
}


PhotoTransformationState*
photo_transformation_state_construct (GType object_type)
{
	PhotoTransformationState * self = NULL;
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 4362 "Photo.c"
}


static void
photo_transformation_state_real_broken (PhotoTransformationState* self)
{
#line 69 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 4371 "Photo.c"
}


static void
photo_transformation_state_class_init (PhotoTransformationStateClass * klass)
{
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoTransformationStatePrivate));
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoTransformationStateClass *) klass)->broken = photo_transformation_state_real_broken;
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4388 "Photo.c"
}


static void
photo_transformation_state_instance_init (PhotoTransformationState * self)
{
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv = PHOTO_TRANSFORMATION_STATE_GET_PRIVATE (self);
#line 64 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 4399 "Photo.c"
}


static void
photo_transformation_state_finalize (GObject * obj)
{
	PhotoTransformationState * self;
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 63 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 4411 "Photo.c"
}


GType
photo_transformation_state_get_type (void)
{
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}


gboolean
rating_can_increase (Rating self)
{
	gboolean result = FALSE;
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = self < RATING_FIVE;
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 4437 "Photo.c"
}


gboolean
rating_can_decrease (Rating self)
{
	gboolean result = FALSE;
#line 91 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = self > RATING_REJECTED;
#line 91 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 4449 "Photo.c"
}


gboolean
rating_is_valid (Rating self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 95 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (self >= RATING_REJECTED) {
#line 95 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self <= RATING_FIVE;
#line 4462 "Photo.c"
	} else {
#line 95 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 4466 "Photo.c"
	}
#line 95 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 95 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 4472 "Photo.c"
}


Rating
rating_increase (Rating self)
{
	Rating result = 0;
	Rating _tmp0_ = 0;
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (rating_can_increase (self)) {
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self + 1;
#line 4485 "Photo.c"
	} else {
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self;
#line 4489 "Photo.c"
	}
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 4495 "Photo.c"
}


Rating
rating_decrease (Rating self)
{
	Rating result = 0;
	Rating _tmp0_ = 0;
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (rating_can_decrease (self)) {
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self - 1;
#line 4508 "Photo.c"
	} else {
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self;
#line 4512 "Photo.c"
	}
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 4518 "Photo.c"
}


gint
rating_serialize (Rating self)
{
	gint result = 0;
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	switch (self) {
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RATING_REJECTED:
#line 4530 "Photo.c"
		{
#line 109 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = -1;
#line 109 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4536 "Photo.c"
		}
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RATING_UNRATED:
#line 4540 "Photo.c"
		{
#line 111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = 0;
#line 111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4546 "Photo.c"
		}
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RATING_ONE:
#line 4550 "Photo.c"
		{
#line 113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = 1;
#line 113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4556 "Photo.c"
		}
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RATING_TWO:
#line 4560 "Photo.c"
		{
#line 115 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = 2;
#line 115 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4566 "Photo.c"
		}
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RATING_THREE:
#line 4570 "Photo.c"
		{
#line 117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = 3;
#line 117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4576 "Photo.c"
		}
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RATING_FOUR:
#line 4580 "Photo.c"
		{
#line 119 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = 4;
#line 119 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4586 "Photo.c"
		}
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RATING_FIVE:
#line 4590 "Photo.c"
		{
#line 121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = 5;
#line 121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4596 "Photo.c"
		}
		default:
		{
#line 123 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = 0;
#line 123 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4604 "Photo.c"
		}
	}
}


Rating
rating_unserialize (gint value)
{
	Rating result = 0;
#line 128 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (value > ((gint) RATING_FIVE)) {
#line 129 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = RATING_FIVE;
#line 129 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 4620 "Photo.c"
	} else {
#line 130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (value < ((gint) RATING_REJECTED)) {
#line 131 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = RATING_REJECTED;
#line 131 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4628 "Photo.c"
		}
	}
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	switch (value) {
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case -1:
#line 4635 "Photo.c"
		{
#line 135 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = RATING_REJECTED;
#line 135 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4641 "Photo.c"
		}
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case 0:
#line 4645 "Photo.c"
		{
#line 137 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = RATING_UNRATED;
#line 137 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4651 "Photo.c"
		}
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case 1:
#line 4655 "Photo.c"
		{
#line 139 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = RATING_ONE;
#line 139 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4661 "Photo.c"
		}
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case 2:
#line 4665 "Photo.c"
		{
#line 141 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = RATING_TWO;
#line 141 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4671 "Photo.c"
		}
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case 3:
#line 4675 "Photo.c"
		{
#line 143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = RATING_THREE;
#line 143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4681 "Photo.c"
		}
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case 4:
#line 4685 "Photo.c"
		{
#line 145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = RATING_FOUR;
#line 145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4691 "Photo.c"
		}
#line 133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case 5:
#line 4695 "Photo.c"
		{
#line 147 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = RATING_FIVE;
#line 147 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4701 "Photo.c"
		}
		default:
		{
#line 149 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = RATING_UNRATED;
#line 149 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 4709 "Photo.c"
		}
	}
}


GType
rating_get_type (void)
{
	static volatile gsize rating_type_id__volatile = 0;
	if (g_once_init_enter (&rating_type_id__volatile)) {
		static const GEnumValue values[] = {{RATING_REJECTED, "RATING_REJECTED", "rejected"}, {RATING_UNRATED, "RATING_UNRATED", "unrated"}, {RATING_ONE, "RATING_ONE", "one"}, {RATING_TWO, "RATING_TWO", "two"}, {RATING_THREE, "RATING_THREE", "three"}, {RATING_FOUR, "RATING_FOUR", "four"}, {RATING_FIVE, "RATING_FIVE", "five"}, {0, NULL, NULL}};
		GType rating_type_id;
		rating_type_id = g_enum_register_static ("Rating", values);
		g_once_init_leave (&rating_type_id__volatile, rating_type_id);
	}
	return rating_type_id__volatile;
}


gboolean
photo_exception_prohibits (PhotoException self,
                           PhotoException exception)
{
	gboolean result = FALSE;
#line 225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = (self & exception) != 0;
#line 225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 4738 "Photo.c"
}


gboolean
photo_exception_allows (PhotoException self,
                        PhotoException exception)
{
	gboolean result = FALSE;
#line 229 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = (self & exception) == 0;
#line 229 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 4751 "Photo.c"
}


GType
photo_exception_get_type (void)
{
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
		GType photo_exception_type_id;
		photo_exception_type_id = g_enum_register_static ("PhotoException", values);
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}


static gpointer
_photo_row_ref0 (gpointer self)
{
#line 397 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 4774 "Photo.c"
}


static gpointer
_backing_photo_row_ref0 (gpointer self)
{
#line 418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 4783 "Photo.c"
}


Photo*
photo_construct (GType object_type,
                 PhotoRow* row)
{
	Photo * self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoRow* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	PhotoRow* _tmp5_;
	PhotoRow* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	PhotoBackingReaders* _tmp9_;
	BackingPhotoRow* _tmp10_;
	PhotoFileFormat _tmp11_;
	BackingPhotoRow* _tmp12_;
	const gchar* _tmp13_;
	PhotoFileReader* _tmp14_;
	gchar* basename = NULL;
	BackingPhotoRow* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp21_;
	BackingPhotoID _tmp25_;
	gint64 _tmp26_;
	BackingPhotoRow* _tmp41_;
	PhotoFileFormat _tmp42_;
	gboolean _tmp57_ = FALSE;
	BackingPhotoRow* _tmp58_;
	PhotoFileFormat _tmp59_;
	PhotoBackingReaders* _tmp71_;
	PhotoFileReader* _tmp72_;
	PhotoRow* _tmp88_;
	time_t _tmp89_;
	GError* _inner_error0_ = NULL;
#line 396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 397 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 397 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 397 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->row = _tmp0_;
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = self->row;
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = self->row;
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_->title;
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = media_source_prep_title (_tmp3_);
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp1_->title);
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_->title = _tmp4_;
#line 401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = self->row;
#line 401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = self->row;
#line 401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = _tmp6_->comment;
#line 401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = media_source_prep_comment (_tmp7_);
#line 401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp5_->comment);
#line 401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_->comment = _tmp8_;
#line 405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = self->priv->readers;
#line 405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = row->master;
#line 405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = _tmp10_->file_format;
#line 405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = row->master;
#line 405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = _tmp12_->filepath;
#line 405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = photo_file_format_create_reader (_tmp11_, _tmp13_);
#line 405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp9_->master);
#line 405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_->master = _tmp14_;
#line 408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = row->master;
#line 408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = _tmp15_->filepath;
#line 408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = string_sliced_at_last_char (_tmp16_, (gunichar) G_DIR_SEPARATOR, 0);
#line 408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	basename = _tmp17_;
#line 409 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = basename;
#line 409 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 4887 "Photo.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = basename;
#line 410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = string_sliced_at (_tmp19_, 1);
#line 410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		self->priv->file_title = _tmp20_;
#line 4898 "Photo.c"
	}
#line 412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = self->priv->file_title;
#line 412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (is_string_empty (_tmp21_)) {
#line 4904 "Photo.c"
		BackingPhotoRow* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
#line 413 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = row->master;
#line 413 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = _tmp22_->filepath;
#line 413 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 413 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 413 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		self->priv->file_title = _tmp24_;
#line 4918 "Photo.c"
	}
#line 415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp25_ = row->editable_id;
#line 415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = _tmp25_.id;
#line 415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp26_ != BACKING_PHOTO_ID_INVALID) {
#line 4926 "Photo.c"
		BackingPhotoRow* e = NULL;
		BackingPhotoID _tmp27_;
		BackingPhotoRow* _tmp28_;
		BackingPhotoRow* _tmp29_;
#line 416 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp27_ = row->editable_id;
#line 416 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp28_ = photo_get_backing_row (self, &_tmp27_);
#line 416 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		e = _tmp28_;
#line 417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp29_ = e;
#line 417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp29_ != NULL) {
#line 4941 "Photo.c"
			BackingPhotoRow* _tmp30_;
			BackingPhotoRow* _tmp31_;
			PhotoBackingReaders* _tmp32_;
			BackingPhotoRow* _tmp33_;
			PhotoFileFormat _tmp34_;
			BackingPhotoRow* _tmp35_;
			const gchar* _tmp36_;
			PhotoFileReader* _tmp37_;
#line 418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp30_ = e;
#line 418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp31_ = _backing_photo_row_ref0 (_tmp30_);
#line 418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			self->priv->editable = _tmp31_;
#line 419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp32_ = self->priv->readers;
#line 419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp33_ = self->priv->editable;
#line 419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp34_ = _tmp33_->file_format;
#line 419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp35_ = self->priv->editable;
#line 419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36_ = _tmp35_->filepath;
#line 419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp37_ = photo_file_format_create_reader (_tmp34_, _tmp36_);
#line 419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp32_->editable);
#line 419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp32_->editable = _tmp37_;
#line 4974 "Photo.c"
		} else {
			{
				PhotoTable* _tmp38_;
				PhotoTable* _tmp39_;
				PhotoRow* _tmp40_;
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp38_ = photo_table_get_instance ();
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp39_ = _tmp38_;
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp40_ = self->row;
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_table_detach_editable (_tmp39_, _tmp40_, &_inner_error0_);
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp39_);
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 4994 "Photo.c"
						goto __catch279_database_error;
					}
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (basename);
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return NULL;
#line 5007 "Photo.c"
				}
			}
			goto __finally279;
			__catch279_database_error:
			{
				GError* err = NULL;
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				err = _inner_error0_;
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_inner_error0_ = NULL;
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (err);
#line 5020 "Photo.c"
			}
			__finally279:
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (basename);
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return NULL;
#line 5035 "Photo.c"
			}
#line 429 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_remove_all_transformations (self, FALSE);
#line 5039 "Photo.c"
		}
#line 415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 5043 "Photo.c"
	}
#line 433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp41_ = row->master;
#line 433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp42_ = _tmp41_->file_format;
#line 433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp42_ == PHOTO_FILE_FORMAT_RAW) {
#line 5051 "Photo.c"
		GeeHashMap* _tmp43_;
		gint _tmp44_ = 0;
		RawDeveloper* _tmp45_;
#line 435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp43_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, (GDestroyNotify) backing_photo_row_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		self->priv->developments = _tmp43_;
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp45_ = raw_developer_as_array (&_tmp44_);
#line 5063 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			d_collection = _tmp45_;
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			d_collection_length1 = _tmp44_;
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 5075 "Photo.c"
				RawDeveloper d = 0;
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				d = d_collection[d_it];
#line 5079 "Photo.c"
				{
					BackingPhotoID id = {0};
					BackingPhotoID* _tmp46_;
					gint _tmp46__length1;
					RawDeveloper _tmp47_;
					BackingPhotoID _tmp48_;
					BackingPhotoID _tmp49_;
					gint64 _tmp50_;
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp46_ = row->development_ids;
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp46__length1 = row->development_ids_length1;
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp47_ = d;
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp48_ = _tmp46_[_tmp47_];
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					id = _tmp48_;
#line 438 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp49_ = id;
#line 438 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp50_ = _tmp49_.id;
#line 438 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_tmp50_ != BACKING_PHOTO_ID_INVALID) {
#line 5104 "Photo.c"
						BackingPhotoRow* bpr = NULL;
						BackingPhotoID _tmp51_;
						BackingPhotoRow* _tmp52_;
						BackingPhotoRow* _tmp53_;
#line 439 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp51_ = id;
#line 439 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp52_ = photo_get_backing_row (self, &_tmp51_);
#line 439 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						bpr = _tmp52_;
#line 440 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp53_ = bpr;
#line 440 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp53_ != NULL) {
#line 5119 "Photo.c"
							GeeHashMap* _tmp54_;
							RawDeveloper _tmp55_;
							BackingPhotoRow* _tmp56_;
#line 441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp54_ = self->priv->developments;
#line 441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp55_ = d;
#line 441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp56_ = bpr;
#line 441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp55_), _tmp56_);
#line 5131 "Photo.c"
						}
#line 438 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 5135 "Photo.c"
					}
				}
			}
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 5141 "Photo.c"
		}
	}
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp58_ = row->master;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp59_ = _tmp58_->file_format;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp59_ == PHOTO_FILE_FORMAT_RAW) {
#line 5150 "Photo.c"
		GeeHashMap* _tmp60_;
		RawDeveloper _tmp61_;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp60_ = self->priv->developments;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp61_ = row->developer;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp57_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp61_));
#line 5159 "Photo.c"
	} else {
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp57_ = FALSE;
#line 5163 "Photo.c"
	}
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp57_) {
#line 5167 "Photo.c"
		BackingPhotoRow* r = NULL;
		GeeHashMap* _tmp62_;
		RawDeveloper _tmp63_;
		gpointer _tmp64_;
		PhotoBackingReaders* _tmp65_;
		BackingPhotoRow* _tmp66_;
		PhotoFileFormat _tmp67_;
		BackingPhotoRow* _tmp68_;
		const gchar* _tmp69_;
		PhotoFileReader* _tmp70_;
#line 448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp62_ = self->priv->developments;
#line 448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp63_ = row->developer;
#line 448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp64_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp63_));
#line 448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		r = (BackingPhotoRow*) _tmp64_;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp65_ = self->priv->readers;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp66_ = r;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp67_ = _tmp66_->file_format;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp68_ = r;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp69_ = _tmp68_->filepath;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp70_ = photo_file_format_create_reader (_tmp67_, _tmp69_);
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp65_->developer);
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp65_->developer = _tmp70_;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 5204 "Photo.c"
	}
#line 453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp71_ = self->priv->readers;
#line 453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp72_ = _tmp71_->editable;
#line 453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp72_ != NULL) {
#line 5212 "Photo.c"
		BackingPhotoRow* _tmp73_;
		BackingPhotoRow* _tmp74_;
#line 454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp73_ = self->priv->editable;
#line 454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp74_ = _backing_photo_row_ref0 (_tmp73_);
#line 454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		self->backing_photo_row = _tmp74_;
#line 5223 "Photo.c"
	} else {
		BackingPhotoRow* _tmp75_;
		PhotoFileFormat _tmp76_;
#line 455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp75_ = row->master;
#line 455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp76_ = _tmp75_->file_format;
#line 455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp76_ != PHOTO_FILE_FORMAT_RAW) {
#line 5233 "Photo.c"
			PhotoRow* _tmp77_;
			BackingPhotoRow* _tmp78_;
			BackingPhotoRow* _tmp79_;
#line 456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp77_ = self->row;
#line 456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp78_ = _tmp77_->master;
#line 456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp79_ = _backing_photo_row_ref0 (_tmp78_);
#line 456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			self->backing_photo_row = _tmp79_;
#line 5247 "Photo.c"
		} else {
			GeeHashMap* _tmp80_;
			RawDeveloper _tmp81_;
#line 460 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp80_ = self->priv->developments;
#line 460 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp81_ = row->developer;
#line 460 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp81_))) {
#line 5257 "Photo.c"
				GeeHashMap* _tmp82_;
				RawDeveloper _tmp83_;
				gpointer _tmp84_;
#line 461 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp82_ = self->priv->developments;
#line 461 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp83_ = row->developer;
#line 461 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp84_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp82_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp83_));
#line 461 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 461 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp84_;
#line 5271 "Photo.c"
			} else {
				PhotoRow* _tmp85_;
				BackingPhotoRow* _tmp86_;
				BackingPhotoRow* _tmp87_;
#line 464 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp85_ = self->row;
#line 464 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp86_ = _tmp85_->master;
#line 464 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp87_ = _backing_photo_row_ref0 (_tmp86_);
#line 464 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 464 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->backing_photo_row = _tmp87_;
#line 5286 "Photo.c"
			}
		}
	}
#line 468 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp88_ = self->row;
#line 468 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp89_ = _tmp88_->exposure_time;
#line 468 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->cached_exposure_time = _tmp89_;
#line 396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (basename);
#line 396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 5300 "Photo.c"
}


void
photo_init_photo (void)
{
	GeeLinkedList* _tmp0_;
#line 472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = gee_linked_list_new (PHOTO_TYPE_CACHED_PIXBUF, (GBoxedCopyFunc) photo_cached_pixbuf_ref, (GDestroyNotify) photo_cached_pixbuf_unref, NULL, NULL, NULL);
#line 472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo_source_pixbuf_cache);
#line 472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_source_pixbuf_cache = _tmp0_;
#line 5314 "Photo.c"
}


void
photo_terminate_photo (void)
{
	guint _tmp0_;
#line 476 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo_source_pixbuf_cache);
#line 476 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_source_pixbuf_cache = NULL;
#line 478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_discard_source_id;
#line 478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 5330 "Photo.c"
		guint _tmp1_;
#line 479 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = photo_discard_source_id;
#line 479 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_source_remove (_tmp1_);
#line 480 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_discard_source_id = (guint) 0;
#line 5338 "Photo.c"
	}
}


static void
photo_real_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file)
{
#line 484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL], 0, old_file, new_file);
#line 5354 "Photo.c"
}


void
photo_notify_editable_replaced (Photo* self,
                                GFile* old_file,
                                GFile* new_file)
{
#line 484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_replaced (self, old_file, new_file);
#line 5367 "Photo.c"
}


static void
photo_real_notify_raw_development_modified (Photo* self)
{
#line 489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL], 0);
#line 5376 "Photo.c"
}


void
photo_notify_raw_development_modified (Photo* self)
{
#line 488 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 488 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_raw_development_modified (self);
#line 5387 "Photo.c"
}


static void
photo_real_notify_baseline_replaced (Photo* self)
{
#line 493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL], 0);
#line 5396 "Photo.c"
}


void
photo_notify_baseline_replaced (Photo* self)
{
#line 492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_replaced (self);
#line 5407 "Photo.c"
}


static void
photo_real_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL], 0, metadata);
#line 5419 "Photo.c"
}


void
photo_notify_master_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_master_reimported (self, metadata);
#line 5431 "Photo.c"
}


static void
photo_real_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 500 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 501 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL], 0, metadata);
#line 5443 "Photo.c"
}


void
photo_notify_editable_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
#line 500 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 500 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_reimported (self, metadata);
#line 5455 "Photo.c"
}


static void
photo_real_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL], 0, metadata);
#line 5467 "Photo.c"
}


void
photo_notify_source_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_source_reimported (self, metadata);
#line 5479 "Photo.c"
}


static void
photo_real_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 509 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL], 0, metadata);
#line 5491 "Photo.c"
}


void
photo_notify_baseline_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
#line 508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_reimported (self, metadata);
#line 5503 "Photo.c"
}


static gboolean
photo_real_internal_delete_backing (DataSource* base,
                                    GError** error)
{
	Photo * self;
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GFile* file = NULL;
	GFile* _tmp11_;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 512 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ret = TRUE;
#line 514 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = NULL;
#line 5525 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5532 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 5542 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				file = _tmp5_;
#line 5556 "Photo.c"
			}
		}
		__finally280:
		{
			PhotoBackingReaders* _tmp6_;
#line 515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5566 "Photo.c"
		}
#line 515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5570 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp7_;
#line 5578 "Photo.c"
		}
	}
#line 520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 5585 "Photo.c"
		gint _tmp8_ = 0;
		RawDeveloper* _tmp9_;
#line 523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = raw_developer_as_array (&_tmp8_);
#line 5590 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			d_collection = _tmp9_;
#line 523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			d_collection_length1 = _tmp8_;
#line 523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 5602 "Photo.c"
				RawDeveloper d = 0;
#line 523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				d = d_collection[d_it];
#line 5606 "Photo.c"
				{
					RawDeveloper _tmp10_;
#line 524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = d;
#line 524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					photo_delete_raw_development (self, _tmp10_);
#line 5613 "Photo.c"
				}
			}
#line 523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 5618 "Photo.c"
		}
	}
#line 528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = file;
#line 528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 5625 "Photo.c"
		{
			gboolean _tmp12_ = FALSE;
			GFile* _tmp13_;
#line 530 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = file;
#line 530 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = g_file_trash (_tmp13_, NULL, &_inner_error0_);
#line 530 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5635 "Photo.c"
				goto __catch281_g_error;
			}
#line 530 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			ret = _tmp12_;
#line 5640 "Photo.c"
		}
		goto __finally281;
		__catch281_g_error:
		{
			GError* err = NULL;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			err = _inner_error0_;
#line 529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_inner_error0_ = NULL;
#line 532 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			ret = FALSE;
#line 533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = file;
#line 533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = g_file_get_path (_tmp14_);
#line 533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp16_ = _tmp15_;
#line 533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp17_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp18_ = _tmp17_;
#line 533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp19_ = err;
#line 533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp20_ = _tmp19_->message;
#line 533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_message ("Photo.vala:533: Unable to move editable %s for %s to trash: %s", _tmp16_, _tmp18_, _tmp20_);
#line 533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_tmp18_);
#line 533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_tmp16_);
#line 529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_error_free0 (err);
#line 5681 "Photo.c"
		}
		__finally281:
#line 529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5686 "Photo.c"
			gboolean _tmp21_ = FALSE;
#line 529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp21_;
#line 5694 "Photo.c"
		}
	}
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), TYPE_DATA_SOURCE, DataSource), &_inner_error0_);
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5701 "Photo.c"
		gboolean _tmp24_ = FALSE;
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp24_;
#line 5709 "Photo.c"
	}
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp23_) {
#line 5713 "Photo.c"
		gboolean _tmp25_;
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp25_ = ret;
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = _tmp25_;
#line 5719 "Photo.c"
	} else {
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = FALSE;
#line 5723 "Photo.c"
	}
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp22_;
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 5731 "Photo.c"
}


static BackingPhotoRow*
photo_get_backing_row (Photo* self,
                       BackingPhotoID* id)
{
	BackingPhotoRow* result = NULL;
	BackingPhotoID _tmp0_;
	gint64 _tmp1_;
	BackingPhotoRow* backing_row = NULL;
	BackingPhotoRow* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 544 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 544 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 545 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = *id;
#line 545 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 545 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == BACKING_PHOTO_ID_INVALID) {
#line 546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = NULL;
#line 546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 5759 "Photo.c"
	}
#line 548 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	backing_row = NULL;
#line 5763 "Photo.c"
	{
		BackingPhotoRow* _tmp2_ = NULL;
		BackingPhotoTable* _tmp3_;
		BackingPhotoTable* _tmp4_;
		BackingPhotoID _tmp5_;
		BackingPhotoRow* _tmp6_;
		BackingPhotoRow* _tmp7_;
		BackingPhotoRow* _tmp8_;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = backing_photo_table_get_instance ();
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = *id;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = backing_photo_table_fetch (_tmp4_, &_tmp5_, &_inner_error0_);
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_database_table_unref0 (_tmp4_);
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp7_;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5790 "Photo.c"
				goto __catch282_database_error;
			}
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 5801 "Photo.c"
		}
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = _tmp2_;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = NULL;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		backing_row = _tmp8_;
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp2_);
#line 5813 "Photo.c"
	}
	goto __finally282;
	__catch282_database_error:
	{
		GError* err = NULL;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = err;
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:552: Unable to fetch backing state for %s: %s", _tmp10_, _tmp12_);
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 5841 "Photo.c"
	}
	__finally282:
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 5854 "Photo.c"
	}
#line 555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = backing_row;
#line 555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 5860 "Photo.c"
		{
			BackingPhotoTable* _tmp14_;
			BackingPhotoTable* _tmp15_;
			BackingPhotoID _tmp16_;
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp16_ = *id;
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			backing_photo_table_remove (_tmp15_, &_tmp16_, &_inner_error0_);
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5879 "Photo.c"
					goto __catch283_database_error;
				}
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return NULL;
#line 5890 "Photo.c"
			}
		}
		goto __finally283;
		__catch283_database_error:
		{
			GError* err = NULL;
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			err = _inner_error0_;
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_inner_error0_ = NULL;
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_error_free0 (err);
#line 5903 "Photo.c"
		}
		__finally283:
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 5916 "Photo.c"
		}
#line 561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = NULL;
#line 561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 5924 "Photo.c"
	}
#line 564 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = backing_row;
#line 564 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 5930 "Photo.c"
}


gboolean
photo_is_raw_developer_complete (Photo* self,
                                 RawDeveloper d)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 569 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 5942 "Photo.c"
	{
		GeeHashMap* _tmp0_;
		gboolean _tmp9_ = FALSE;
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 5950 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashMap* _tmp2_;
#line 571 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 571 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 5958 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
				BackingPhotoRow* _tmp5_;
				const gchar* _tmp6_;
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = (BackingPhotoRow*) _tmp4_;
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = _tmp5_->filepath;
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = g_file_test (_tmp6_, G_FILE_TEST_EXISTS);
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp5_);
#line 5975 "Photo.c"
			} else {
#line 571 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 5979 "Photo.c"
			}
#line 571 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp1_;
#line 5983 "Photo.c"
			{
				GeeHashMap* _tmp7_;
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = self->priv->developments;
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5990 "Photo.c"
			}
#line 571 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 5994 "Photo.c"
		}
		__finally284:
		{
			GeeHashMap* _tmp8_;
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = self->priv->developments;
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6003 "Photo.c"
		}
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp9_;
#line 6011 "Photo.c"
	}
}


gboolean
photo_is_raw_developer_available (Photo* self,
                                  RawDeveloper d)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 577 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 6024 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6031 "Photo.c"
		{
			GeeHashMap* _tmp1_;
#line 579 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 579 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 580 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = TRUE;
#line 6040 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6047 "Photo.c"
				}
#line 580 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 6051 "Photo.c"
			}
		}
		__finally285:
		{
			GeeHashMap* _tmp3_;
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6061 "Photo.c"
		}
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6065 "Photo.c"
			gboolean _tmp4_ = FALSE;
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp4_;
#line 6073 "Photo.c"
		}
	}
#line 583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	switch (d) {
#line 583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6080 "Photo.c"
		{
#line 585 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = TRUE;
#line 585 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 6086 "Photo.c"
		}
#line 583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 6090 "Photo.c"
		{
#line 588 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = FALSE;
#line 588 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 6096 "Photo.c"
		}
#line 583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 6100 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp5_;
				guint num_previews = 0U;
				PhotoMetadata* _tmp6_;
				guint _tmp7_;
#line 592 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = photo_get_master_metadata (self, &_inner_error0_);
#line 592 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				meta = _tmp5_;
#line 592 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6114 "Photo.c"
					goto __catch286_g_error;
				}
#line 593 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = meta;
#line 593 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				num_previews = photo_metadata_get_preview_count (_tmp6_);
#line 595 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = num_previews;
#line 595 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp7_ > ((guint) 0)) {
#line 6125 "Photo.c"
					PhotoPreview* prev = NULL;
					PhotoMetadata* _tmp8_;
					guint _tmp9_;
					PhotoPreview* _tmp10_;
					PhotoPreview* _tmp11_;
					Dimensions dims = {0};
					PhotoPreview* _tmp12_;
					Dimensions _tmp13_ = {0};
					gint _tmp14_ = 0;
					Dimensions _tmp15_;
					gint _tmp16_;
					Dimensions _tmp17_;
					gint _tmp18_;
					gint preview_major_axis = 0;
					gint _tmp23_;
#line 596 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_ = meta;
#line 596 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp9_ = num_previews;
#line 596 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = photo_metadata_get_preview (_tmp8_, _tmp9_ - 1);
#line 596 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					prev = _tmp10_;
#line 599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_ = prev;
#line 599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_tmp11_ == NULL) {
#line 600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						result = FALSE;
#line 600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						return result;
#line 6161 "Photo.c"
					}
#line 602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = prev;
#line 602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					photo_preview_get_pixel_dimensions (_tmp12_, &_tmp13_);
#line 602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					dims = _tmp13_;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp15_ = dims;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp16_ = _tmp15_.width;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp17_ = dims;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp18_ = _tmp17_.height;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_tmp16_ > _tmp18_) {
#line 6179 "Photo.c"
						Dimensions _tmp19_;
						gint _tmp20_;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp19_ = dims;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp20_ = _tmp19_.width;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp14_ = _tmp20_;
#line 6188 "Photo.c"
					} else {
						Dimensions _tmp21_;
						gint _tmp22_;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp21_ = dims;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp22_ = _tmp21_.height;
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp14_ = _tmp22_;
#line 6198 "Photo.c"
					}
#line 605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					preview_major_axis = _tmp14_;
#line 606 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp23_ = preview_major_axis;
#line 606 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_tmp23_ < PHOTO_MIN_EMBEDDED_SIZE) {
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						result = FALSE;
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						return result;
#line 6214 "Photo.c"
					}
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					result = TRUE;
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return result;
#line 6224 "Photo.c"
				}
#line 614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = FALSE;
#line 614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 6232 "Photo.c"
			}
			goto __finally286;
			__catch286_g_error:
			{
				GError* e = NULL;
				GError* _tmp24_;
				const gchar* _tmp25_;
#line 591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				e = _inner_error0_;
#line 591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_inner_error0_ = NULL;
#line 616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = e;
#line 616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = _tmp24_->message;
#line 616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_debug ("Photo.vala:616: Error accessing embedded preview. Message: %s", _tmp25_);
#line 591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (e);
#line 6252 "Photo.c"
			}
			__finally286:
#line 591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6257 "Photo.c"
				gboolean _tmp26_ = FALSE;
#line 591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return _tmp26_;
#line 6265 "Photo.c"
			}
#line 618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = FALSE;
#line 618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 6271 "Photo.c"
		}
		default:
		{
#line 621 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_assert_not_reached ();
#line 6277 "Photo.c"
		}
	}
}


void
photo_add_backing_photo_for_development (Photo* self,
                                         RawDeveloper d,
                                         BackingPhotoRow* bpr,
                                         gboolean notify,
                                         GError** error)
{
	PhotoRow* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 629 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 629 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, d, bpr, &_inner_error0_);
#line 629 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 629 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 629 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 6306 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6314 "Photo.c"
		{
			GeeHashMap* _tmp2_;
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), bpr);
#line 6321 "Photo.c"
		}
		__finally287:
		{
			GeeHashMap* _tmp3_;
#line 630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6330 "Photo.c"
		}
#line 630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 6338 "Photo.c"
		}
	}
#line 634 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (notify) {
#line 6343 "Photo.c"
		Alteration* _tmp4_;
		Alteration* _tmp5_;
#line 635 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = alteration_new ("image", "developer");
#line 635 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 635 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp5_);
#line 635 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp5_);
#line 6354 "Photo.c"
	}
}


void
photo_import_developed_backing_photo (PhotoRow* row,
                                      RawDeveloper d,
                                      BackingPhotoRow* bpr,
                                      GError** error)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp4_;
	GTimeVal _tmp5_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp6_;
	PhotoFileInterrogator* _tmp7_;
	PhotoFileInterrogator* _tmp8_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp9_;
	DetectedPhotoInformation* _tmp10_;
	gboolean _tmp11_ = FALSE;
	DetectedPhotoInformation* _tmp12_;
	DetectedPhotoInformation* _tmp14_;
	Dimensions _tmp15_;
	GFileInfo* _tmp16_;
	GTimeVal _tmp17_;
	glong _tmp18_;
	Orientation _tmp19_ = 0;
	DetectedPhotoInformation* _tmp20_;
	PhotoMetadata* _tmp21_;
	BackingPhotoTable* _tmp24_;
	BackingPhotoTable* _tmp25_;
	PhotoTable* _tmp26_;
	PhotoTable* _tmp27_;
	BackingPhotoID _tmp28_;
	GError* _inner_error0_ = NULL;
#line 638 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 638 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (bpr));
#line 640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = bpr->filepath;
#line 640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = _tmp1_;
#line 641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = file;
#line 641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = g_file_query_info (_tmp2_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	info = _tmp3_;
#line 641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 6421 "Photo.c"
	}
#line 643 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = info;
#line 643 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp4_, &_tmp5_);
#line 643 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	timestamp = _tmp5_;
#line 645 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = file;
#line 645 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = photo_file_interrogator_new (_tmp6_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 645 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	interrogator = _tmp7_;
#line 647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = interrogator;
#line 647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp8_, &_inner_error0_);
#line 647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 6451 "Photo.c"
	}
#line 649 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = interrogator;
#line 649 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = photo_file_interrogator_get_detected_photo_information (_tmp9_);
#line 649 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	detected = _tmp10_;
#line 650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = detected;
#line 650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = TRUE;
#line 6465 "Photo.c"
	} else {
		PhotoFileInterrogator* _tmp13_;
#line 650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = interrogator;
#line 650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = photo_file_interrogator_get_is_photo_corrupted (_tmp13_);
#line 6472 "Photo.c"
	}
#line 650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp11_) {
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 6486 "Photo.c"
	}
#line 656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = detected;
#line 656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = _tmp14_->image_dim;
#line 656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	bpr->dim = _tmp15_;
#line 657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = info;
#line 657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	bpr->filesize = g_file_info_get_size (_tmp16_);
#line 658 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = timestamp;
#line 658 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = _tmp17_.tv_sec;
#line 658 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	bpr->timestamp = (time_t) _tmp18_;
#line 659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = detected;
#line 659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = _tmp20_->metadata;
#line 659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp21_ != NULL) {
#line 6510 "Photo.c"
		DetectedPhotoInformation* _tmp22_;
		PhotoMetadata* _tmp23_;
#line 659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = detected;
#line 659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = _tmp22_->metadata;
#line 659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = photo_metadata_get_orientation (_tmp23_);
#line 6519 "Photo.c"
	} else {
#line 660 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = ORIENTATION_TOP_LEFT;
#line 6523 "Photo.c"
	}
#line 659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	bpr->original_orientation = _tmp19_;
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_ = backing_photo_table_get_instance ();
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	backing_photo_table_add (_tmp25_, bpr, &_inner_error0_);
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_database_table_unref0 (_tmp25_);
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 6549 "Photo.c"
	}
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = photo_table_get_instance ();
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27_ = _tmp26_;
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp28_ = bpr->id;
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_table_update_raw_development (_tmp27_, row, d, &_tmp28_, &_inner_error0_);
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_database_table_unref0 (_tmp27_);
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 6575 "Photo.c"
	}
#line 638 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 638 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 638 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 638 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 6585 "Photo.c"
}


static void
photo_develop_photo (Photo* self,
                     RawDeveloper d,
                     gboolean notify)
{
	gboolean wrote_img_to_disk = FALSE;
	BackingPhotoRow* bps = NULL;
	GError* _inner_error0_ = NULL;
#line 669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 670 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	wrote_img_to_disk = FALSE;
#line 671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	bps = NULL;
#line 673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	switch (d) {
#line 673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6607 "Photo.c"
		{
			{
				BackingPhotoRow* _tmp0_ = NULL;
				PhotoRow* _tmp1_;
				BackingPhotoRow* _tmp2_;
				const gchar* _tmp3_;
				BackingPhotoRow* _tmp4_;
				BackingPhotoRow* _tmp5_;
				GdkPixbuf* pix = NULL;
				GdkPixbuf* _tmp12_;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp17_;
				const gchar* _tmp18_;
				PhotoFileWriter* _tmp19_;
				PhotoFileWriter* _tmp20_;
				GdkPixbuf* _tmp21_;
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp22_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp23_;
				const gchar* _tmp24_;
				PhotoFileMetadataWriter* _tmp25_;
				PhotoFileMetadataWriter* _tmp26_;
				PhotoMetadata* _tmp27_;
#line 677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = self->row;
#line 677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = _tmp1_->master;
#line 677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = _tmp2_->filepath;
#line 677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = raw_developer_create_backing_row_for_development (d, _tmp3_, NULL, &_inner_error0_);
#line 677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp0_ = _tmp4_;
#line 677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6644 "Photo.c"
					goto __catch288_g_error;
				}
#line 677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp0_;
#line 677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp0_ = NULL;
#line 677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				bps = _tmp5_;
#line 678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				pix = NULL;
#line 6657 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 6664 "Photo.c"
					{
						GdkPixbuf* _tmp7_ = NULL;
						Scaling _tmp8_ = {0};
						GdkPixbuf* _tmp9_;
						GdkPixbuf* _tmp10_;
#line 684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						scaling_for_original (&_tmp8_);
#line 684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp9_ = photo_get_master_pixbuf (self, &_tmp8_, FALSE, &_inner_error0_);
#line 684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp7_ = _tmp9_;
#line 684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6678 "Photo.c"
							goto __finally289;
						}
#line 684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp10_ = _tmp7_;
#line 684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp7_ = NULL;
#line 684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (pix);
#line 684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						pix = _tmp10_;
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (_tmp7_);
#line 6691 "Photo.c"
					}
					__finally289:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp11_;
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp11_ = self->priv->readers;
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6701 "Photo.c"
					}
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (pix);
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_backing_photo_row_unref0 (_tmp0_);
#line 6709 "Photo.c"
						goto __catch288_g_error;
					}
				}
#line 687 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = pix;
#line 687 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp12_ == NULL) {
#line 688 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_debug ("Photo.vala:688: Could not get preview pixbuf");
#line 689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6723 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						gboolean _tmp13_;
#line 713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp13_ = wrote_img_to_disk;
#line 713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp13_) {
#line 6731 "Photo.c"
							{
								BackingPhotoRow* _tmp14_;
#line 716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp14_ = bps;
#line 716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp14_, notify, &_inner_error0_);
#line 716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6740 "Photo.c"
									goto __catch290_g_error;
								}
#line 718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6745 "Photo.c"
							}
							goto __finally290;
							__catch290_g_error:
							{
								GError* e = NULL;
								GError* _tmp15_;
								const gchar* _tmp16_;
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								e = _inner_error0_;
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_inner_error0_ = NULL;
#line 720 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp15_ = e;
#line 720 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp16_ = _tmp15_->message;
#line 720 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								g_debug ("Photo.vala:720: Error adding backing photo as development. Message: %s", _tmp16_);
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_g_error_free0 (e);
#line 6765 "Photo.c"
							}
							__finally290:
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6770 "Photo.c"
								goto __catch288_g_error;
							}
						}
					}
#line 689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 6779 "Photo.c"
				}
#line 693 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = bps;
#line 693 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = _tmp17_->filepath;
#line 693 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp19_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp18_, &_inner_error0_);
#line 693 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				writer = _tmp19_;
#line 693 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 693 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 693 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6795 "Photo.c"
					goto __catch288_g_error;
				}
#line 694 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp20_ = writer;
#line 694 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = pix;
#line 694 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_file_writer_write (_tmp20_, _tmp21_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 694 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 694 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 694 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 694 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6812 "Photo.c"
					goto __catch288_g_error;
				}
#line 702 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = photo_get_master_metadata (self, &_inner_error0_);
#line 707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				meta = _tmp22_;
#line 707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6829 "Photo.c"
					goto __catch288_g_error;
				}
#line 708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = bps;
#line 708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = _tmp23_->filepath;
#line 708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp24_, &_inner_error0_);
#line 708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				mwriter = _tmp25_;
#line 708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6850 "Photo.c"
					goto __catch288_g_error;
				}
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp26_ = mwriter;
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp27_ = meta;
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp26_, _tmp27_, &_inner_error0_);
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (pix);
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6871 "Photo.c"
					goto __catch288_g_error;
				}
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (pix);
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp0_);
#line 6884 "Photo.c"
			}
			goto __finally288;
			__catch288_g_error:
			{
				GError* err = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				err = _inner_error0_;
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_inner_error0_ = NULL;
#line 711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = err;
#line 711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_debug ("Photo.vala:711: Error developing photo: %s", _tmp29_);
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (err);
#line 6904 "Photo.c"
			}
			__finally288:
			{
				GError* _inner_error1_ = NULL;
				gboolean _tmp30_;
#line 713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp30_ = wrote_img_to_disk;
#line 713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp30_) {
#line 6914 "Photo.c"
					{
						BackingPhotoRow* _tmp31_;
#line 716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp31_ = bps;
#line 716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp31_, notify, &_inner_error1_);
#line 716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 6923 "Photo.c"
							goto __catch291_g_error;
						}
#line 718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 6928 "Photo.c"
					}
					goto __finally291;
					__catch291_g_error:
					{
						GError* e = NULL;
						GError* _tmp32_;
						const gchar* _tmp33_;
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						e = _inner_error1_;
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_inner_error1_ = NULL;
#line 720 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp32_ = e;
#line 720 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp33_ = _tmp32_->message;
#line 720 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_debug ("Photo.vala:720: Error adding backing photo as development. Message: %s", _tmp33_);
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_error_free0 (e);
#line 6948 "Photo.c"
					}
					__finally291:
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						return;
#line 6961 "Photo.c"
					}
				}
			}
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 6975 "Photo.c"
			}
#line 726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 6979 "Photo.c"
		}
#line 673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 6983 "Photo.c"
		{
#line 730 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 6987 "Photo.c"
		}
#line 673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 6991 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp34_;
				guint c = 0U;
				PhotoMetadata* _tmp35_;
				guint _tmp36_;
				PhotoPreview* prev = NULL;
				PhotoMetadata* _tmp41_;
				guint _tmp42_;
				PhotoPreview* _tmp43_;
				PhotoPreview* _tmp44_;
				GBytes* pix = NULL;
				PhotoPreview* _tmp49_;
				GBytes* _tmp50_;
				GBytes* _tmp51_;
				BackingPhotoRow* _tmp56_ = NULL;
				PhotoRow* _tmp57_;
				BackingPhotoRow* _tmp58_;
				const gchar* _tmp59_;
				BackingPhotoRow* _tmp60_;
				BackingPhotoRow* _tmp61_;
				gboolean _tmp62_ = FALSE;
				GBytes* _tmp63_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp83_;
				const gchar* _tmp84_;
				PhotoFileMetadataWriter* _tmp85_;
				PhotoFileMetadataWriter* _tmp86_;
				PhotoMetadata* _tmp87_;
#line 735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp34_ = photo_get_master_metadata (self, &_inner_error0_);
#line 735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				meta = _tmp34_;
#line 735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7028 "Photo.c"
					goto __catch292_g_error;
				}
#line 736 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp35_ = meta;
#line 736 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				c = photo_metadata_get_preview_count (_tmp35_);
#line 737 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp36_ = c;
#line 737 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp36_ <= ((guint) 0)) {
#line 738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7041 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						gboolean _tmp37_;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp37_ = wrote_img_to_disk;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp37_) {
#line 7049 "Photo.c"
							{
								BackingPhotoRow* _tmp38_;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp38_ = bps;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp38_, notify, &_inner_error0_);
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7058 "Photo.c"
									goto __catch293_g_error;
								}
#line 788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7063 "Photo.c"
							}
							goto __finally293;
							__catch293_g_error:
							{
								GError* e = NULL;
								GError* _tmp39_;
								const gchar* _tmp40_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								e = _inner_error0_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_inner_error0_ = NULL;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp39_ = e;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp40_ = _tmp39_->message;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp40_);
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_g_error_free0 (e);
#line 7083 "Photo.c"
							}
							__finally293:
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7088 "Photo.c"
								goto __catch292_g_error;
							}
						}
					}
#line 738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 7097 "Photo.c"
				}
#line 739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp41_ = meta;
#line 739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp42_ = c;
#line 739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp43_ = photo_metadata_get_preview (_tmp41_, _tmp42_ - 1);
#line 739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				prev = _tmp43_;
#line 740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp44_ = prev;
#line 740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp44_ == NULL) {
#line 741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_debug ("Photo.vala:741: Could not get preview from metadata");
#line 742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7117 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						gboolean _tmp45_;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp45_ = wrote_img_to_disk;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp45_) {
#line 7125 "Photo.c"
							{
								BackingPhotoRow* _tmp46_;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp46_ = bps;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp46_, notify, &_inner_error0_);
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7134 "Photo.c"
									goto __catch294_g_error;
								}
#line 788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7139 "Photo.c"
							}
							goto __finally294;
							__catch294_g_error:
							{
								GError* e = NULL;
								GError* _tmp47_;
								const gchar* _tmp48_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								e = _inner_error0_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_inner_error0_ = NULL;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp47_ = e;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp48_ = _tmp47_->message;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp48_);
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_g_error_free0 (e);
#line 7159 "Photo.c"
							}
							__finally294:
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7164 "Photo.c"
								goto __catch292_g_error;
							}
						}
					}
#line 742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 7173 "Photo.c"
				}
#line 745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp49_ = prev;
#line 745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp50_ = photo_preview_flatten (_tmp49_, &_inner_error0_);
#line 745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				pix = _tmp50_;
#line 745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7187 "Photo.c"
					goto __catch292_g_error;
				}
#line 746 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp51_ = pix;
#line 746 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp51_ == NULL) {
#line 747 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_debug ("Photo.vala:747: Could not get preview pixbuf");
#line 748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7202 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						gboolean _tmp52_;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp52_ = wrote_img_to_disk;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp52_) {
#line 7210 "Photo.c"
							{
								BackingPhotoRow* _tmp53_;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp53_ = bps;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp53_, notify, &_inner_error0_);
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7219 "Photo.c"
									goto __catch295_g_error;
								}
#line 788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 7224 "Photo.c"
							}
							goto __finally295;
							__catch295_g_error:
							{
								GError* e = NULL;
								GError* _tmp54_;
								const gchar* _tmp55_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								e = _inner_error0_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_inner_error0_ = NULL;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp54_ = e;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp55_ = _tmp54_->message;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp55_);
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_g_error_free0 (e);
#line 7244 "Photo.c"
							}
							__finally295:
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7249 "Photo.c"
								goto __catch292_g_error;
							}
						}
					}
#line 748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 7258 "Photo.c"
				}
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp57_ = self->row;
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp58_ = _tmp57_->master;
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp59_ = _tmp58_->filepath;
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp60_ = raw_developer_create_backing_row_for_development (d, _tmp59_, NULL, &_inner_error0_);
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp56_ = _tmp60_;
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7278 "Photo.c"
					goto __catch292_g_error;
				}
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp61_ = _tmp56_;
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp56_ = NULL;
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				bps = _tmp61_;
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp63_ = pix;
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp62_ = jpeg_is_jpeg_bytes (_tmp63_, &_inner_error0_);
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp56_);
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7303 "Photo.c"
					goto __catch292_g_error;
				}
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp62_) {
#line 7308 "Photo.c"
					GFile* outfile = NULL;
					BackingPhotoRow* _tmp64_;
					const gchar* _tmp65_;
					GFile* _tmp66_;
					GFile* _tmp67_;
					GBytes* _tmp68_;
					gsize _tmp69_ = 0;
					guint8* _tmp70_;
#line 757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp64_ = bps;
#line 757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp65_ = _tmp64_->filepath;
#line 757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp66_ = g_file_new_for_path (_tmp65_);
#line 757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					outfile = _tmp66_;
#line 758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp67_ = outfile;
#line 758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp68_ = pix;
#line 758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp70_ = g_bytes_get_data (_tmp68_, &_tmp69_);
#line 758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_file_replace_contents (_tmp67_, _tmp70_, (gsize) _tmp69_, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
#line 758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (outfile);
#line 758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_backing_photo_row_unref0 (_tmp56_);
#line 758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7345 "Photo.c"
						goto __catch292_g_error;
					}
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (outfile);
#line 7350 "Photo.c"
				} else {
					GdkPixbuf* pixbuf = NULL;
					PhotoPreview* _tmp71_;
					GdkPixbuf* _tmp72_;
					GdkPixbuf* _tmp73_;
					PhotoFileWriter* writer = NULL;
					BackingPhotoRow* _tmp78_;
					const gchar* _tmp79_;
					PhotoFileWriter* _tmp80_;
					PhotoFileWriter* _tmp81_;
					GdkPixbuf* _tmp82_;
#line 761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp71_ = prev;
#line 761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp72_ = photo_preview_get_pixbuf (_tmp71_, &_inner_error0_);
#line 761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					pixbuf = _tmp72_;
#line 761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_backing_photo_row_unref0 (_tmp56_);
#line 761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7378 "Photo.c"
						goto __catch292_g_error;
					}
#line 762 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp73_ = pixbuf;
#line 762 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_tmp73_ == NULL) {
#line 763 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_debug ("Photo.vala:763: Could not get preview pixbuf");
#line 764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_backing_photo_row_unref0 (_tmp56_);
#line 764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7397 "Photo.c"
						{
							GError* _inner_error0_ = NULL;
							gboolean _tmp74_;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp74_ = wrote_img_to_disk;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (_tmp74_) {
#line 7405 "Photo.c"
								{
									BackingPhotoRow* _tmp75_;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_tmp75_ = bps;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									photo_add_backing_photo_for_development (self, d, _tmp75_, notify, &_inner_error0_);
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7414 "Photo.c"
										goto __catch296_g_error;
									}
#line 788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									photo_notify_raw_development_modified (self);
#line 7419 "Photo.c"
								}
								goto __finally296;
								__catch296_g_error:
								{
									GError* e = NULL;
									GError* _tmp76_;
									const gchar* _tmp77_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									e = _inner_error0_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_inner_error0_ = NULL;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_tmp76_ = e;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_tmp77_ = _tmp76_->message;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp77_);
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_g_error_free0 (e);
#line 7439 "Photo.c"
								}
								__finally296:
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7444 "Photo.c"
									goto __catch292_g_error;
								}
							}
						}
#line 764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						return;
#line 7453 "Photo.c"
					}
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp78_ = bps;
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp79_ = _tmp78_->filepath;
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp80_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp79_, &_inner_error0_);
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					writer = _tmp80_;
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_backing_photo_row_unref0 (_tmp56_);
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7475 "Photo.c"
						goto __catch292_g_error;
					}
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp81_ = writer;
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp82_ = pixbuf;
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					photo_file_writer_write (_tmp81_, _tmp82_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_file_adapter_unref0 (writer);
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (pixbuf);
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_backing_photo_row_unref0 (_tmp56_);
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_bytes_unref0 (pix);
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 7498 "Photo.c"
						goto __catch292_g_error;
					}
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 7505 "Photo.c"
				}
#line 774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp83_ = bps;
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp84_ = _tmp83_->filepath;
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp85_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp84_, &_inner_error0_);
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				mwriter = _tmp85_;
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp56_);
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7527 "Photo.c"
					goto __catch292_g_error;
				}
#line 778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp86_ = mwriter;
#line 778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp87_ = meta;
#line 778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp86_, _tmp87_, &_inner_error0_);
#line 778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp56_);
#line 778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_bytes_unref0 (pix);
#line 778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 7548 "Photo.c"
					goto __catch292_g_error;
				}
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp56_);
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_bytes_unref0 (pix);
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 7561 "Photo.c"
			}
			goto __finally292;
			__catch292_g_error:
			{
				GError* e = NULL;
				GError* _tmp88_;
				const gchar* _tmp89_;
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				e = _inner_error0_;
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_inner_error0_ = NULL;
#line 780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp88_ = e;
#line 780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp89_ = _tmp88_->message;
#line 780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_debug ("Photo.vala:780: Error accessing embedded preview. Message: %s", _tmp89_);
#line 781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (e);
#line 7581 "Photo.c"
				{
					GError* _inner_error0_ = NULL;
					gboolean _tmp90_;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp90_ = wrote_img_to_disk;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_tmp90_) {
#line 7589 "Photo.c"
						{
							BackingPhotoRow* _tmp91_;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp91_ = bps;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							photo_add_backing_photo_for_development (self, d, _tmp91_, notify, &_inner_error0_);
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7598 "Photo.c"
								goto __catch297_g_error;
							}
#line 788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							photo_notify_raw_development_modified (self);
#line 7603 "Photo.c"
						}
						goto __finally297;
						__catch297_g_error:
						{
							GError* e = NULL;
							GError* _tmp92_;
							const gchar* _tmp93_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							e = _inner_error0_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_inner_error0_ = NULL;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp92_ = e;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp93_ = _tmp92_->message;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp93_);
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_error_free0 (e);
#line 7623 "Photo.c"
						}
						__finally297:
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_backing_photo_row_unref0 (bps);
#line 7630 "Photo.c"
						}
					}
				}
#line 781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 7638 "Photo.c"
			}
			__finally292:
			{
				GError* _inner_error1_ = NULL;
				gboolean _tmp94_;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp94_ = wrote_img_to_disk;
#line 783 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp94_) {
#line 7648 "Photo.c"
					{
						BackingPhotoRow* _tmp95_;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp95_ = bps;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp95_, notify, &_inner_error1_);
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 7657 "Photo.c"
							goto __catch298_g_error;
						}
#line 788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 7662 "Photo.c"
					}
					goto __finally298;
					__catch298_g_error:
					{
						GError* e = NULL;
						GError* _tmp96_;
						const gchar* _tmp97_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						e = _inner_error1_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_inner_error1_ = NULL;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp96_ = e;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp97_ = _tmp96_->message;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_debug ("Photo.vala:790: Error adding backing photo as development. Message: %s", _tmp97_);
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_error_free0 (e);
#line 7682 "Photo.c"
					}
					__finally298:
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						return;
#line 7695 "Photo.c"
					}
				}
			}
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 7709 "Photo.c"
			}
#line 795 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 7713 "Photo.c"
		}
		default:
		{
#line 798 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_assert_not_reached ();
#line 7719 "Photo.c"
		}
	}
#line 669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (bps);
#line 7724 "Photo.c"
}


void
photo_set_default_raw_developer (Photo* self,
                                 RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 803 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 7735 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 7742 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 805 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 805 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_->developer = d;
#line 7749 "Photo.c"
		}
		__finally299:
		{
			PhotoRow* _tmp2_;
#line 804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 7758 "Photo.c"
		}
#line 804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 7768 "Photo.c"
		}
	}
}


void
photo_set_raw_developer (Photo* self,
                         RawDeveloper d,
                         gboolean notify)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 7788 "Photo.c"
	}
#line 817 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_is_raw_developer_available (self, RAW_DEVELOPER_CAMERA)) {
#line 817 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = d == RAW_DEVELOPER_EMBEDDED;
#line 7794 "Photo.c"
	} else {
#line 817 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 7798 "Photo.c"
	}
#line 817 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp0_) {
#line 818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		d = RAW_DEVELOPER_CAMERA;
#line 7804 "Photo.c"
	}
#line 822 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_is_raw_developer_available (self, RAW_DEVELOPER_EMBEDDED)) {
#line 822 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = d != RAW_DEVELOPER_CAMERA;
#line 7810 "Photo.c"
	} else {
#line 822 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 7814 "Photo.c"
	}
#line 822 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_) {
#line 823 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		d = RAW_DEVELOPER_SHOTWELL;
#line 7820 "Photo.c"
	}
	{
		GeeHashMap* _tmp2_;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = self->priv->developments;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 7828 "Photo.c"
		{
			RawDeveloper stale_raw_developer = 0;
			PhotoRow* _tmp3_;
			RawDeveloper _tmp4_;
			GeeHashMap* _tmp5_;
			PhotoRow* _tmp7_;
			GeeHashMap* _tmp8_;
			gpointer _tmp9_;
			PhotoBackingReaders* _tmp10_;
			BackingPhotoRow* _tmp11_;
			PhotoFileFormat _tmp12_;
			BackingPhotoRow* _tmp13_;
			const gchar* _tmp14_;
			PhotoFileReader* _tmp15_;
			BackingPhotoRow* _tmp19_;
			Orientation _tmp20_;
			gboolean _tmp28_ = FALSE;
			RawDeveloper _tmp29_;
#line 826 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 826 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->developer;
#line 826 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			stale_raw_developer = _tmp4_;
#line 829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!photo_is_raw_developer_complete (self, d)) {
#line 830 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_develop_photo (self, d, notify);
#line 7857 "Photo.c"
			}
#line 832 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 832 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 7863 "Photo.c"
				{
					GeeHashMap* _tmp6_;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp6_ = self->priv->developments;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7870 "Photo.c"
				}
#line 833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 7874 "Photo.c"
			}
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_->developer = d;
#line 840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = self->priv->developments;
#line 840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp9_;
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = self->priv->readers;
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = self->backing_photo_row;
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = _tmp11_->file_format;
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = self->backing_photo_row;
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = _tmp13_->filepath;
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = photo_file_format_create_reader (_tmp12_, _tmp14_);
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_->developer);
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_->developer = _tmp15_;
#line 7906 "Photo.c"
			{
				GdkPixbuf* _tmp16_;
				GdkPixbuf* _tmp17_;
#line 844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = photo_get_prefetched_copy (self, &_inner_error0_);
#line 844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = _tmp16_;
#line 844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp17_);
#line 844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7918 "Photo.c"
					goto __catch301_g_error;
				}
			}
			goto __finally301;
			__catch301_g_error:
			{
				GError* e = NULL;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				e = _inner_error0_;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_inner_error0_ = NULL;
#line 847 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (e);
#line 7932 "Photo.c"
				{
					GeeHashMap* _tmp18_;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp18_ = self->priv->developments;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7939 "Photo.c"
				}
#line 847 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 7943 "Photo.c"
			}
			__finally301:
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 7954 "Photo.c"
			}
#line 850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp19_ = self->backing_photo_row;
#line 850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp20_ = _tmp19_->original_orientation;
#line 850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_set_orientation (self, _tmp20_);
#line 7962 "Photo.c"
			{
				PhotoTable* _tmp21_;
				PhotoTable* _tmp22_;
				PhotoRow* _tmp23_;
				BackingPhotoRow* _tmp24_;
				BackingPhotoID _tmp25_;
#line 853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = photo_table_get_instance ();
#line 853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = _tmp21_;
#line 853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = self->row;
#line 853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = self->backing_photo_row;
#line 853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = _tmp24_->id;
#line 853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_table_update_raw_development (_tmp22_, _tmp23_, d, &_tmp25_, &_inner_error0_);
#line 853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp22_);
#line 853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7985 "Photo.c"
					goto __catch302_g_error;
				}
			}
			goto __finally302;
			__catch302_g_error:
			{
				GError* e = NULL;
				GError* _tmp26_;
				const gchar* _tmp27_;
#line 852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				e = _inner_error0_;
#line 852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_inner_error0_ = NULL;
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp26_ = e;
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp27_ = _tmp26_->message;
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_warning ("Photo.vala:855: Error updating database: %s", _tmp27_);
#line 852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (e);
#line 8007 "Photo.c"
			}
			__finally302:
#line 852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 8018 "Photo.c"
			}
#line 862 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp29_ = stale_raw_developer;
#line 862 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp29_ != RAW_DEVELOPER_CAMERA) {
#line 8024 "Photo.c"
				RawDeveloper _tmp30_;
				PhotoRow* _tmp31_;
				RawDeveloper _tmp32_;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp30_ = stale_raw_developer;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp31_ = self->row;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp32_ = _tmp31_->developer;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = _tmp30_ != _tmp32_;
#line 8036 "Photo.c"
			} else {
#line 862 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = FALSE;
#line 8040 "Photo.c"
			}
#line 862 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp28_) {
#line 8044 "Photo.c"
				RawDeveloper _tmp33_;
#line 866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp33_ = stale_raw_developer;
#line 866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_delete_raw_development (self, _tmp33_);
#line 8050 "Photo.c"
			}
		}
		__finally300:
		{
			GeeHashMap* _tmp34_;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp34_ = self->priv->developments;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8060 "Photo.c"
		}
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 8070 "Photo.c"
		}
	}
#line 873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (notify) {
#line 8075 "Photo.c"
		Alteration* _tmp35_;
		Alteration* _tmp36_;
#line 874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = alteration_new ("image", "developer");
#line 874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp36_);
#line 874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp36_);
#line 8086 "Photo.c"
	}
#line 875 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_discard_prefetched (self);
#line 8090 "Photo.c"
}


RawDeveloper
photo_get_raw_developer (Photo* self)
{
	RawDeveloper result = 0;
	PhotoRow* _tmp0_;
	RawDeveloper _tmp1_;
#line 878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_->developer;
#line 879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp1_;
#line 879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 8110 "Photo.c"
}


static gboolean
photo_delete_raw_development (Photo* self,
                              RawDeveloper d)
{
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
#line 884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ret = FALSE;
#line 8125 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 8132 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			BackingPhotoRow* bpr = NULL;
			GeeHashMap* _tmp7_;
			gpointer _tmp8_;
			BackingPhotoRow* _tmp9_;
			const gchar* _tmp10_;
			GeeHashMap* _tmp31_;
#line 888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d))) {
#line 889 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = FALSE;
#line 8151 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8158 "Photo.c"
				}
#line 889 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 8162 "Photo.c"
			}
#line 893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = raw_developer_to_string (d);
#line 893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_debug ("Photo.vala:893: Delete raw development: %s %s", _tmp4_, _tmp6_);
#line 893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_tmp6_);
#line 893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_tmp4_);
#line 894 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 894 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 894 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp8_;
#line 895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = bpr;
#line 895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = _tmp9_->filepath;
#line 895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp10_ != NULL) {
#line 8190 "Photo.c"
				GFile* f = NULL;
				BackingPhotoRow* _tmp11_;
				const gchar* _tmp12_;
				GFile* _tmp13_;
#line 896 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = bpr;
#line 896 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = _tmp11_->filepath;
#line 896 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = g_file_new_for_path (_tmp12_);
#line 896 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				f = _tmp13_;
#line 8203 "Photo.c"
				{
#line 898 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (d == RAW_DEVELOPER_CAMERA) {
#line 8207 "Photo.c"
						GFile* _tmp14_;
#line 899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp14_ = f;
#line 899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_file_trash (_tmp14_, NULL, &_inner_error0_);
#line 899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8215 "Photo.c"
							goto __catch304_g_error;
						}
					} else {
						GFile* _tmp15_;
#line 901 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp15_ = f;
#line 901 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_file_delete (_tmp15_, NULL, &_inner_error0_);
#line 901 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8226 "Photo.c"
							goto __catch304_g_error;
						}
					}
				}
				goto __finally304;
				__catch304_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp16_;
					const gchar* _tmp17_;
					GError* _tmp18_;
					const gchar* _tmp19_;
#line 897 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					e = _inner_error0_;
#line 897 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_inner_error0_ = NULL;
#line 903 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp16_ = bpr;
#line 903 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp17_ = _tmp16_->filepath;
#line 903 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp18_ = e;
#line 903 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp19_ = _tmp18_->message;
#line 903 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_warning ("Photo.vala:903: Unable to delete RAW development: %s error: %s", _tmp17_, _tmp19_);
#line 897 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_error_free0 (e);
#line 8255 "Photo.c"
				}
				__finally304:
#line 897 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8260 "Photo.c"
					gboolean _tmp20_ = FALSE;
#line 897 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (f);
#line 897 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 897 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 897 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 897 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return _tmp20_;
#line 8272 "Photo.c"
				}
#line 895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 8276 "Photo.c"
			}
			{
				PhotoTable* _tmp21_;
				PhotoTable* _tmp22_;
				PhotoRow* _tmp23_;
				BackingPhotoTable* _tmp24_;
				BackingPhotoTable* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoID _tmp27_;
#line 909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = photo_table_get_instance ();
#line 909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = _tmp21_;
#line 909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = self->row;
#line 909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_table_remove_development (_tmp22_, _tmp23_, d, &_inner_error0_);
#line 909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp22_);
#line 909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8298 "Photo.c"
					goto __catch305_g_error;
				}
#line 910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = backing_photo_table_get_instance ();
#line 910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = _tmp24_;
#line 910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp26_ = bpr;
#line 910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp27_ = _tmp26_->id;
#line 910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				backing_photo_table_remove (_tmp25_, &_tmp27_, &_inner_error0_);
#line 910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp25_);
#line 910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8315 "Photo.c"
					goto __catch305_g_error;
				}
			}
			goto __finally305;
			__catch305_g_error:
			{
				GError* e = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				e = _inner_error0_;
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_inner_error0_ = NULL;
#line 912 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = e;
#line 912 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 912 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_warning ("Photo.vala:912: Database error while deleting RAW development: %s", _tmp29_);
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (e);
#line 8337 "Photo.c"
			}
			__finally305:
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8342 "Photo.c"
				gboolean _tmp30_ = FALSE;
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return _tmp30_;
#line 8352 "Photo.c"
			}
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp31_ = self->priv->developments;
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			ret = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d), NULL);
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 8360 "Photo.c"
		}
		__finally303:
		{
			GeeHashMap* _tmp32_;
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp32_ = self->priv->developments;
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8369 "Photo.c"
		}
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8373 "Photo.c"
			gboolean _tmp33_ = FALSE;
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp33_;
#line 8381 "Photo.c"
		}
	}
#line 918 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 919 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = ret;
#line 919 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 8390 "Photo.c"
}


void
photo_redevelop_raw (Photo* self,
                     RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 923 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 8401 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 8408 "Photo.c"
		{
			RawDeveloper dev = 0;
			RawDeveloper _tmp1_;
			RawDeveloper _tmp2_;
#line 925 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_delete_raw_development (self, d);
#line 926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			dev = d;
#line 927 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = dev;
#line 927 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp1_ == RAW_DEVELOPER_CAMERA) {
#line 928 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 8423 "Photo.c"
			}
#line 930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = dev;
#line 930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_set_raw_developer (self, _tmp2_, TRUE);
#line 8429 "Photo.c"
		}
		__finally306:
		{
			GeeHashMap* _tmp3_;
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 8438 "Photo.c"
		}
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 8448 "Photo.c"
		}
	}
}


static void
_vala_array_add84 (BackingFileState** * array,
                   int* length,
                   int* size,
                   BackingFileState* value)
{
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8466 "Photo.c"
	}
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 8472 "Photo.c"
}


static void
_vala_array_add85 (BackingFileState** * array,
                   int* length,
                   int* size,
                   BackingFileState* value)
{
#line 939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8488 "Photo.c"
	}
#line 939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 8494 "Photo.c"
}


static void
_vala_array_add86 (BackingFileState** * array,
                   int* length,
                   int* size,
                   BackingFileState* value)
{
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 8510 "Photo.c"
	}
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 8516 "Photo.c"
}


static BackingFileState**
photo_real_get_backing_files_state (MediaSource* base,
                                    int* result_length1)
{
	Photo * self;
	BackingFileState** result = NULL;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp24_;
	gint _tmp24__length1;
	GError* _inner_error0_ = NULL;
#line 934 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 935 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 935 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	backing = _tmp0_;
#line 935 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	backing_length1 = 0;
#line 935 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_size_ = backing_length1;
#line 8543 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = self->row;
#line 936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8550 "Photo.c"
		{
			BackingFileState** _tmp2_;
			gint _tmp2__length1;
			PhotoRow* _tmp3_;
			BackingPhotoRow* _tmp4_;
			PhotoRow* _tmp5_;
			const gchar* _tmp6_;
			BackingFileState* _tmp7_;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = backing;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2__length1 = backing_length1;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->master;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _tmp5_->md5;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = backing_file_state_new_from_photo_row (_tmp4_, _tmp6_);
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add84 (&backing, &backing_length1, &_backing_size_, _tmp7_);
#line 938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (photo_has_editable (self)) {
#line 8577 "Photo.c"
				BackingFileState** _tmp8_;
				gint _tmp8__length1;
				BackingPhotoRow* _tmp9_;
				BackingFileState* _tmp10_;
#line 939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = backing;
#line 939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8__length1 = backing_length1;
#line 939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = self->priv->editable;
#line 939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = backing_file_state_new_from_photo_row (_tmp9_, NULL);
#line 939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_vala_array_add85 (&backing, &backing_length1, &_backing_size_, _tmp10_);
#line 8592 "Photo.c"
			}
#line 941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (photo_is_developed (self)) {
#line 8596 "Photo.c"
				GeeCollection* dev_rows = NULL;
				GeeCollection* _tmp11_;
				GeeCollection* _tmp12_;
#line 942 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = photo_get_raw_development_photo_rows (self);
#line 942 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				dev_rows = _tmp11_;
#line 943 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = dev_rows;
#line 943 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp12_ != NULL) {
#line 8608 "Photo.c"
					{
						GeeIterator* _r_it = NULL;
						GeeCollection* _tmp13_;
						GeeIterator* _tmp14_;
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp13_ = dev_rows;
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp14_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ITERABLE, GeeIterable));
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_r_it = _tmp14_;
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						while (TRUE) {
#line 8621 "Photo.c"
							GeeIterator* _tmp15_;
							BackingPhotoRow* r = NULL;
							GeeIterator* _tmp16_;
							gpointer _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							BackingFileState** _tmp20_;
							gint _tmp20__length1;
							BackingPhotoRow* _tmp21_;
							BackingFileState* _tmp22_;
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp15_ = _r_it;
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (!gee_iterator_next (_tmp15_)) {
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								break;
#line 8638 "Photo.c"
							}
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp16_ = _r_it;
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp17_ = gee_iterator_get (_tmp16_);
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							r = (BackingPhotoRow*) _tmp17_;
#line 945 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp18_ = r;
#line 945 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp19_ = _tmp18_->filepath;
#line 945 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							g_debug ("Photo.vala:945: adding: %s", _tmp19_);
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp20_ = backing;
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp20__length1 = backing_length1;
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp21_ = r;
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp22_ = backing_file_state_new_from_photo_row (_tmp21_, NULL);
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_vala_array_add86 (&backing, &backing_length1, &_backing_size_, _tmp22_);
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 8664 "Photo.c"
						}
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 8668 "Photo.c"
					}
				}
#line 941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 8673 "Photo.c"
			}
		}
		__finally307:
		{
			PhotoRow* _tmp23_;
#line 936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp23_ = self->row;
#line 936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8683 "Photo.c"
		}
#line 936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 8695 "Photo.c"
		}
	}
#line 952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_ = backing;
#line 952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24__length1 = backing_length1;
#line 952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (result_length1) {
#line 952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*result_length1 = _tmp24__length1;
#line 8706 "Photo.c"
	}
#line 952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp24_;
#line 952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 8712 "Photo.c"
}


static PhotoFileReader*
photo_get_backing_reader (Photo* self,
                          BackingFetchMode mode)
{
	PhotoFileReader* result = NULL;
#line 955 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	switch (mode) {
#line 956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 8727 "Photo.c"
		{
			PhotoFileReader* _tmp0_;
#line 958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp0_ = photo_get_master_reader (self);
#line 958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp0_;
#line 958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 8736 "Photo.c"
		}
#line 956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 8740 "Photo.c"
		{
			PhotoFileReader* _tmp1_;
#line 961 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = photo_get_baseline_reader (self);
#line 961 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp1_;
#line 961 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 8749 "Photo.c"
		}
#line 956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 8753 "Photo.c"
		{
			PhotoFileReader* _tmp2_;
#line 964 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = photo_get_source_reader (self);
#line 964 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_;
#line 964 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 8762 "Photo.c"
		}
#line 956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 8766 "Photo.c"
		{
#line 967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 8770 "Photo.c"
				PhotoFileReader* _tmp3_;
#line 968 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = photo_get_raw_developer_reader (self);
#line 968 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = _tmp3_;
#line 968 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 8778 "Photo.c"
			} else {
				PhotoFileReader* _tmp4_;
#line 970 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = photo_get_master_reader (self);
#line 970 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = _tmp4_;
#line 970 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 8787 "Photo.c"
			}
		}
		default:
		{
			GEnumValue* _tmp5_;
#line 973 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), mode);
#line 973 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_error ("Photo.vala:973: Unknown backing fetch mode %s", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 8797 "Photo.c"
		}
	}
}


static gpointer
_photo_file_adapter_ref0 (gpointer self)
{
#line 979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 8808 "Photo.c"
}


static PhotoFileReader*
photo_get_master_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8819 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8826 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp3_;
#line 8839 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8846 "Photo.c"
			}
#line 979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 8850 "Photo.c"
		}
		__finally308:
		{
			PhotoBackingReaders* _tmp5_;
#line 978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8859 "Photo.c"
		}
#line 978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 8867 "Photo.c"
	}
}


PhotoFileReader*
photo_get_editable_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8879 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8886 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp3_;
#line 8899 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8906 "Photo.c"
			}
#line 985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 8910 "Photo.c"
		}
		__finally309:
		{
			PhotoBackingReaders* _tmp5_;
#line 984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8919 "Photo.c"
		}
#line 984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 8927 "Photo.c"
	}
}


static PhotoFileReader*
photo_get_baseline_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 8939 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8946 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 992 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 992 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 992 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8961 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 993 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 993 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 993 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 993 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = _tmp5_;
#line 8973 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8980 "Photo.c"
				}
#line 993 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 8984 "Photo.c"
			}
#line 995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 8992 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = _tmp11_;
#line 9004 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9011 "Photo.c"
				}
#line 996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 9015 "Photo.c"
			}
#line 998 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 998 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 998 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 998 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp15_;
#line 9025 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9032 "Photo.c"
			}
#line 998 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9036 "Photo.c"
		}
		__finally310:
		{
			PhotoBackingReaders* _tmp17_;
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9045 "Photo.c"
		}
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 9053 "Photo.c"
	}
}


static PhotoFileReader*
photo_get_source_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1003 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9065 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9072 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 1005 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1005 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1005 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9087 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 1006 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1006 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 1006 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 1006 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = _tmp5_;
#line 9099 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9106 "Photo.c"
				}
#line 1006 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 9110 "Photo.c"
			}
#line 1008 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 1008 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 1008 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 9118 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 1009 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 1009 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 1009 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 1009 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = _tmp11_;
#line 9130 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9137 "Photo.c"
				}
#line 1009 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 9141 "Photo.c"
			}
#line 1011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 1011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 1011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp15_;
#line 9151 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9158 "Photo.c"
			}
#line 1011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9162 "Photo.c"
		}
		__finally311:
		{
			PhotoBackingReaders* _tmp17_;
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9171 "Photo.c"
		}
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 9179 "Photo.c"
	}
}


static PhotoFileReader*
photo_get_raw_developer_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9191 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 1017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9198 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 1018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 1018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 1018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp3_;
#line 9211 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 1017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 1017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9218 "Photo.c"
			}
#line 1018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9222 "Photo.c"
		}
		__finally312:
		{
			PhotoBackingReaders* _tmp5_;
#line 1017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 1017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9231 "Photo.c"
		}
#line 1017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 9239 "Photo.c"
	}
}


gboolean
photo_is_developed (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1022 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9251 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9259 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1024 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1024 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 1024 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9269 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9276 "Photo.c"
			}
#line 1024 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9280 "Photo.c"
		}
		__finally313:
		{
			PhotoBackingReaders* _tmp4_;
#line 1023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9289 "Photo.c"
		}
#line 1023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 9297 "Photo.c"
	}
}


gboolean
photo_has_editable (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9309 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9317 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9327 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9334 "Photo.c"
			}
#line 1030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9338 "Photo.c"
		}
		__finally314:
		{
			PhotoBackingReaders* _tmp4_;
#line 1029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9347 "Photo.c"
		}
#line 1029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 9355 "Photo.c"
	}
}


gboolean
photo_does_master_exist (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9367 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9375 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1036 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1036 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1036 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = photo_file_adapter_file_exists (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 9385 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9392 "Photo.c"
			}
#line 1036 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9396 "Photo.c"
		}
		__finally315:
		{
			PhotoBackingReaders* _tmp4_;
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9405 "Photo.c"
		}
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 9413 "Photo.c"
	}
}


gboolean
photo_does_editable_exist (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1041 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9425 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9433 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 1043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 1043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 1043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 9444 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 1043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 1043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 1043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = photo_file_adapter_file_exists (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 9453 "Photo.c"
			} else {
#line 1043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 9457 "Photo.c"
			}
#line 1043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp1_;
#line 9461 "Photo.c"
			{
				PhotoBackingReaders* _tmp6_;
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9468 "Photo.c"
			}
#line 1043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9472 "Photo.c"
		}
		__finally316:
		{
			PhotoBackingReaders* _tmp7_;
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9481 "Photo.c"
		}
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp8_;
#line 9489 "Photo.c"
	}
}


gboolean
photo_is_master_baseline (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1047 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9501 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9509 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_ == NULL;
#line 9519 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9526 "Photo.c"
			}
#line 1049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9530 "Photo.c"
		}
		__finally317:
		{
			PhotoBackingReaders* _tmp4_;
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9539 "Photo.c"
		}
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 9547 "Photo.c"
	}
}


gboolean
photo_is_master_source (Photo* self)
{
	gboolean result = FALSE;
#line 1053 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1054 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = !photo_has_editable (self);
#line 1054 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 9562 "Photo.c"
}


gboolean
photo_is_editable_baseline (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 1057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 9573 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 9581 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1059 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1059 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 1059 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 9591 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9598 "Photo.c"
			}
#line 1059 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9602 "Photo.c"
		}
		__finally318:
		{
			PhotoBackingReaders* _tmp4_;
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9611 "Photo.c"
		}
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 9619 "Photo.c"
	}
}


gboolean
photo_is_editable_source (Photo* self)
{
	gboolean result = FALSE;
#line 1063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_has_editable (self);
#line 1064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 9634 "Photo.c"
}


BackingPhotoRow*
photo_get_master_photo_row (Photo* self)
{
	BackingPhotoRow* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9645 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9652 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 1069 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1069 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1069 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 1069 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp3_;
#line 9665 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 1068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9672 "Photo.c"
			}
#line 1069 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9676 "Photo.c"
		}
		__finally319:
		{
			PhotoRow* _tmp5_;
#line 1068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 1068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9685 "Photo.c"
		}
#line 1068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 9693 "Photo.c"
	}
}


BackingPhotoRow*
photo_get_editable_photo_row (Photo* self)
{
	BackingPhotoRow* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1073 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9705 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9712 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 1076 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1076 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp1_->editable_id)) {
#line 9719 "Photo.c"
				BackingPhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
#line 1077 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = self->priv->editable;
#line 1077 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 1077 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = _tmp3_;
#line 9728 "Photo.c"
				{
					PhotoRow* _tmp4_;
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp4_ = self->row;
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9735 "Photo.c"
				}
#line 1077 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 9739 "Photo.c"
			} else {
#line 1079 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = NULL;
#line 9743 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp5_ = self->row;
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9750 "Photo.c"
				}
#line 1079 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 9754 "Photo.c"
			}
		}
		__finally320:
		{
			PhotoRow* _tmp6_;
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9764 "Photo.c"
		}
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 9772 "Photo.c"
	}
}


GeeCollection*
photo_get_raw_development_photo_rows (Photo* self)
{
	GeeCollection* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9784 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1084 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1084 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9791 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9799 "Photo.c"
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 9813 "Photo.c"
			} else {
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 9819 "Photo.c"
			}
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp1_;
#line 9823 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 1084 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 1084 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9830 "Photo.c"
			}
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9834 "Photo.c"
		}
		__finally321:
		{
			PhotoRow* _tmp7_;
#line 1084 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 1084 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9843 "Photo.c"
		}
#line 1084 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1084 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1084 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 9851 "Photo.c"
	}
}


BackingPhotoRow*
photo_get_raw_development_photo_row (Photo* self,
                                     RawDeveloper d)
{
	BackingPhotoRow* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 9864 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9871 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9879 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
#line 1091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) d));
#line 1091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp4_;
#line 9890 "Photo.c"
			} else {
#line 1091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 9896 "Photo.c"
			}
#line 1091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp1_;
#line 9900 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = self->row;
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9907 "Photo.c"
			}
#line 1091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 9911 "Photo.c"
		}
		__finally322:
		{
			PhotoRow* _tmp6_;
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9920 "Photo.c"
		}
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 9928 "Photo.c"
	}
}


static PhotoFileFormat*
_photo_file_format_dup (PhotoFileFormat* self)
{
	PhotoFileFormat* dup;
#line 1101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 1101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 1101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return dup;
#line 9943 "Photo.c"
}


static gpointer
__photo_file_format_dup0 (gpointer self)
{
#line 1101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 9952 "Photo.c"
}


PhotoFileFormat*
photo_get_editable_file_format (Photo* self)
{
	PhotoFileFormat* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_;
	PhotoFileFormat* _tmp4_;
#line 1095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1096 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1096 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	reader = _tmp0_;
#line 1097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = reader;
#line 1097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1098 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = NULL;
#line 1098 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 1098 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 9982 "Photo.c"
	}
#line 1101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = reader;
#line 1101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 1101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp4_;
#line 1101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 9996 "Photo.c"
}


PhotoFileFormat
photo_get_export_format_for_parameters (Photo* self,
                                        ExportFormatParameters* params)
{
	PhotoFileFormat result = 0;
	PhotoFileFormat _result_ = 0;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
#line 1104 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1104 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1105 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_result_ = photo_file_format_get_system_default_format ();
#line 1107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = *params;
#line 1107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 1107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	switch (_tmp1_) {
#line 1107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 10022 "Photo.c"
		{
#line 1109 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_result_ = photo_get_master_file_format (self);
#line 1110 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 10028 "Photo.c"
		}
#line 1107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 10032 "Photo.c"
		{
#line 1113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_result_ = photo_get_best_export_file_format (self);
#line 1114 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 10038 "Photo.c"
		}
#line 1107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 10042 "Photo.c"
		{
			ExportFormatParameters _tmp2_;
			PhotoFileFormat _tmp3_;
#line 1117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = *params;
#line 1117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _tmp2_.specified_format;
#line 1117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_result_ = _tmp3_;
#line 1118 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 10054 "Photo.c"
		}
		default:
		{
#line 1121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_error ("Photo.vala:1121: get_export_format_for_parameters: unsupported export " \
"format mode");
#line 10060 "Photo.c"
		}
	}
#line 1124 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _result_;
#line 1124 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 10067 "Photo.c"
}


gchar*
photo_get_export_basename_for_parameters (Photo* self,
                                          ExportFormatParameters* params)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
	const gchar* _tmp8_;
#line 1127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 1128 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_result_ = NULL;
#line 1130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = *params;
#line 1130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 1130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	switch (_tmp1_) {
#line 1130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 10094 "Photo.c"
		{
			GFile* _tmp2_;
			GFile* _tmp3_;
			gchar* _tmp4_;
#line 1132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 1132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 1132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = g_file_get_basename (_tmp3_);
#line 1132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_result_);
#line 1132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_result_ = _tmp4_;
#line 1132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp3_);
#line 1133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 10113 "Photo.c"
		}
#line 1130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 1130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 10119 "Photo.c"
		{
			ExportFormatParameters _tmp5_;
			PhotoFileFormat _tmp6_;
			gchar* _tmp7_;
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = *params;
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = photo_get_export_format_for_parameters (self, &_tmp5_);
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = photo_get_export_basename (self, &_tmp6_);
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp7_;
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_result_);
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 10136 "Photo.c"
		}
		default:
		{
#line 1140 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_error ("Photo.vala:1140: get_export_basename_for_parameters: unsupported expor" \
"t format mode");
#line 10142 "Photo.c"
		}
	}
#line 1143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = _result_;
#line 1143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (_tmp8_ != NULL, "result != null");
#line 1144 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _result_;
#line 1144 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 10153 "Photo.c"
}


ImportResult
photo_prepare_for_import (PhotoImportParams* params)
{
	ImportResult result = 0;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp11_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp15_;
	GTimeVal _tmp16_ = {0};
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp19_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp23_;
	PhotoFileSnifferOptions _tmp24_;
	PhotoFileInterrogator* _tmp25_;
	PhotoFileInterrogator* _tmp32_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp33_;
	DetectedPhotoInformation* _tmp34_;
	gboolean _tmp35_ = FALSE;
	DetectedPhotoInformation* _tmp36_;
	PhotoFileSnifferOptions _tmp39_;
	Orientation orientation = 0;
	time_t exposure_time = 0;
	gchar* title = NULL;
	gchar* _tmp49_;
	GpsCoords gps_coords = {0};
	gchar* comment = NULL;
	gchar* _tmp50_;
	Rating rating = 0;
	DetectedPhotoInformation* _tmp51_;
	PhotoMetadata* _tmp52_;
	gboolean _tmp74_ = FALSE;
	gboolean _tmp75_ = FALSE;
	DetectedPhotoInformation* _tmp76_;
	GdkColorspace _tmp77_;
	PhotoRow* _tmp85_;
	PhotoRow* _tmp86_;
	BackingPhotoRow* _tmp87_;
	GFile* _tmp88_;
	gchar* _tmp89_;
	PhotoRow* _tmp90_;
	BackingPhotoRow* _tmp91_;
	DetectedPhotoInformation* _tmp92_;
	Dimensions _tmp93_;
	PhotoRow* _tmp94_;
	BackingPhotoRow* _tmp95_;
	GFileInfo* _tmp96_;
	PhotoRow* _tmp97_;
	BackingPhotoRow* _tmp98_;
	GTimeVal _tmp99_;
	glong _tmp100_;
	PhotoRow* _tmp101_;
	time_t _tmp102_;
	PhotoRow* _tmp103_;
	Orientation _tmp104_;
	PhotoRow* _tmp105_;
	BackingPhotoRow* _tmp106_;
	Orientation _tmp107_;
	PhotoRow* _tmp108_;
	ImportID _tmp109_;
	PhotoRow* _tmp110_;
	PhotoRow* _tmp111_;
	PhotoRow* _tmp112_;
	DetectedPhotoInformation* _tmp113_;
	const gchar* _tmp114_;
	gchar* _tmp115_;
	PhotoRow* _tmp116_;
	DetectedPhotoInformation* _tmp117_;
	const gchar* _tmp118_;
	gchar* _tmp119_;
	PhotoRow* _tmp120_;
	DetectedPhotoInformation* _tmp121_;
	const gchar* _tmp122_;
	gchar* _tmp123_;
	PhotoRow* _tmp124_;
	PhotoRow* _tmp125_;
	PhotoRow* _tmp126_;
	BackingPhotoRow* _tmp127_;
	DetectedPhotoInformation* _tmp128_;
	PhotoFileFormat _tmp129_;
	PhotoRow* _tmp130_;
	const gchar* _tmp131_;
	gchar* _tmp132_;
	PhotoRow* _tmp133_;
	GpsCoords _tmp134_;
	PhotoRow* _tmp135_;
	const gchar* _tmp136_;
	gchar* _tmp137_;
	PhotoRow* _tmp138_;
	Rating _tmp139_;
	Thumbnails* _tmp140_;
	GError* _inner_error0_ = NULL;
#line 1159 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 1163 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = params->file;
#line 1163 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1163 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = _tmp1_;
#line 1165 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	info = NULL;
#line 10266 "Photo.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = file;
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10280 "Photo.c"
			goto __catch323_g_error;
		}
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp2_;
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = NULL;
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		info = _tmp5_;
#line 1166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 10293 "Photo.c"
	}
	goto __finally323;
	__catch323_g_error:
	{
		GError* err = NULL;
#line 1166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 1166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 1170 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1170 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1170 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1170 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1170 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 10313 "Photo.c"
	}
	__finally323:
#line 1166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return 0;
#line 10328 "Photo.c"
	}
#line 1173 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = info;
#line 1173 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 1174 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1174 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1174 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1174 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 10342 "Photo.c"
	}
#line 1176 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = file;
#line 1176 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_is_file_image (_tmp7_)) {
#line 10348 "Photo.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = file;
#line 1177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 1177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_message ("Photo.vala:1177: Not importing %s: Not an image file", _tmp10_);
#line 1177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1179 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1179 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1179 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1179 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 10370 "Photo.c"
	}
#line 1182 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = file;
#line 1182 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_file_format_is_file_supported (_tmp11_)) {
#line 10376 "Photo.c"
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1183 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = file;
#line 1183 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 1183 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1183 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_message ("Photo.vala:1183: Not importing %s: Unsupported extension", _tmp14_);
#line 1183 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp14_);
#line 1185 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1185 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1185 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1185 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 10398 "Photo.c"
	}
#line 1188 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = info;
#line 1188 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp15_, &_tmp16_);
#line 1188 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	timestamp = _tmp16_;
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = params->exif_md5;
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 10410 "Photo.c"
		const gchar* _tmp20_;
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = params->thumbnail_md5;
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = _tmp20_ != NULL;
#line 10416 "Photo.c"
	} else {
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = FALSE;
#line 10420 "Photo.c"
	}
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp18_) {
#line 10424 "Photo.c"
		const gchar* _tmp21_;
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp21_ = params->full_md5;
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = _tmp21_ != NULL;
#line 10430 "Photo.c"
	} else {
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = FALSE;
#line 10434 "Photo.c"
	}
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp17_) {
#line 10438 "Photo.c"
		PhotoFileSnifferOptions _tmp22_;
#line 1192 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = params->sniffer_options;
#line 1192 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		params->sniffer_options = _tmp22_ | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 10444 "Photo.c"
	}
#line 1195 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = file;
#line 1195 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_ = params->sniffer_options;
#line 1195 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp25_ = photo_file_interrogator_new (_tmp23_, _tmp24_);
#line 1195 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	interrogator = _tmp25_;
#line 10454 "Photo.c"
	{
		PhotoFileInterrogator* _tmp26_;
#line 1197 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp26_ = interrogator;
#line 1197 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp26_, &_inner_error0_);
#line 1197 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10463 "Photo.c"
			goto __catch324_g_error;
		}
	}
	goto __finally324;
	__catch324_g_error:
	{
		GError* err = NULL;
		GFile* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 1199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp27_ = file;
#line 1199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp28_ = g_file_get_path (_tmp27_);
#line 1199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 1199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp30_ = err;
#line 1199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp31_ = _tmp30_->message;
#line 1199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:1199: Unable to interrogate photo file %s: %s", _tmp29_, _tmp31_);
#line 1199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp29_);
#line 1201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 10506 "Photo.c"
	}
	__finally324:
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return 0;
#line 10523 "Photo.c"
	}
#line 1204 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp32_ = interrogator;
#line 1204 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_file_interrogator_get_is_photo_corrupted (_tmp32_)) {
#line 1205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 10539 "Photo.c"
	}
#line 1208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = interrogator;
#line 1208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp34_ = photo_file_interrogator_get_detected_photo_information (_tmp33_);
#line 1208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	detected = _tmp34_;
#line 1209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp36_ = detected;
#line 1209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp36_ == NULL) {
#line 1209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = TRUE;
#line 10553 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp37_;
		PhotoFileFormat _tmp38_;
#line 1209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp37_ = detected;
#line 1209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp38_ = _tmp37_->file_format;
#line 1209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = _tmp38_ == PHOTO_FILE_FORMAT_UNKNOWN;
#line 10563 "Photo.c"
	}
#line 1209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp35_) {
#line 1210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 10579 "Photo.c"
	}
#line 1213 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp39_ = params->sniffer_options;
#line 1213 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((_tmp39_ & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 10585 "Photo.c"
		DetectedPhotoInformation* _tmp40_;
		const gchar* _tmp41_;
		gchar* _tmp42_;
		DetectedPhotoInformation* _tmp43_;
		const gchar* _tmp44_;
		gchar* _tmp45_;
		DetectedPhotoInformation* _tmp46_;
		const gchar* _tmp47_;
		gchar* _tmp48_;
#line 1214 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp40_ = detected;
#line 1214 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp41_ = params->exif_md5;
#line 1214 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp42_ = g_strdup (_tmp41_);
#line 1214 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp40_->exif_md5);
#line 1214 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp40_->exif_md5 = _tmp42_;
#line 1215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp43_ = detected;
#line 1215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp44_ = params->thumbnail_md5;
#line 1215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp45_ = g_strdup (_tmp44_);
#line 1215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp43_->thumbnail_md5);
#line 1215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp43_->thumbnail_md5 = _tmp45_;
#line 1216 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp46_ = detected;
#line 1216 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp47_ = params->full_md5;
#line 1216 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp48_ = g_strdup (_tmp47_);
#line 1216 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp46_->md5);
#line 1216 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp46_->md5 = _tmp48_;
#line 10625 "Photo.c"
	}
#line 1219 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1220 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	exposure_time = (time_t) 0;
#line 1221 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp49_ = g_strdup ("");
#line 1221 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	title = _tmp49_;
#line 1222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	memset (&gps_coords, 0, sizeof (GpsCoords));
#line 1223 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp50_ = g_strdup ("");
#line 1223 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	comment = _tmp50_;
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	rating = RATING_UNRATED;
#line 1231 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp51_ = detected;
#line 1231 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp52_ = _tmp51_->metadata;
#line 1231 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 10649 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp53_;
		PhotoMetadata* _tmp54_;
		MetadataDateTime* _tmp55_;
		MetadataDateTime* _tmp56_;
		DetectedPhotoInformation* _tmp58_;
		PhotoMetadata* _tmp59_;
		DetectedPhotoInformation* _tmp60_;
		PhotoMetadata* _tmp61_;
		gchar* _tmp62_;
		DetectedPhotoInformation* _tmp63_;
		PhotoMetadata* _tmp64_;
		GpsCoords _tmp65_ = {0};
		DetectedPhotoInformation* _tmp66_;
		PhotoMetadata* _tmp67_;
		gchar* _tmp68_;
		DetectedPhotoInformation* _tmp69_;
		PhotoMetadata* _tmp70_;
		GeeSet* _tmp71_;
		DetectedPhotoInformation* _tmp72_;
		PhotoMetadata* _tmp73_;
#line 1232 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp53_ = detected;
#line 1232 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp54_ = _tmp53_->metadata;
#line 1232 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp55_ = photo_metadata_get_exposure_date_time (_tmp54_);
#line 1232 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		date_time = _tmp55_;
#line 1233 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp56_ = date_time;
#line 1233 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp56_ != NULL) {
#line 10683 "Photo.c"
			MetadataDateTime* _tmp57_;
#line 1234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp57_ = date_time;
#line 1234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			exposure_time = metadata_date_time_get_timestamp (_tmp57_);
#line 10689 "Photo.c"
		}
#line 1236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp58_ = detected;
#line 1236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp59_ = _tmp58_->metadata;
#line 1236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		orientation = photo_metadata_get_orientation (_tmp59_);
#line 1237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp60_ = detected;
#line 1237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp61_ = _tmp60_->metadata;
#line 1237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp62_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (title);
#line 1237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		title = _tmp62_;
#line 1238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp63_ = detected;
#line 1238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp64_ = _tmp63_->metadata;
#line 1238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_get_gps_coords (_tmp64_, &_tmp65_);
#line 1238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gps_coords = _tmp65_;
#line 1239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp66_ = detected;
#line 1239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp67_ = _tmp66_->metadata;
#line 1239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp68_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (comment);
#line 1239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		comment = _tmp68_;
#line 1240 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp69_ = detected;
#line 1240 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp70_ = _tmp69_->metadata;
#line 1240 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp71_ = photo_metadata_get_keywords (_tmp70_, NULL, NULL, NULL);
#line 1240 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (params->keywords);
#line 1240 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		params->keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp72_ = detected;
#line 1241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp73_ = _tmp72_->metadata;
#line 1241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		rating = photo_metadata_get_rating (_tmp73_);
#line 1231 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10743 "Photo.c"
	}
#line 1245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp76_ = detected;
#line 1245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp77_ = _tmp76_->colorspace;
#line 1245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp77_ != GDK_COLORSPACE_RGB) {
#line 1245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp75_ = TRUE;
#line 10753 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp78_;
		gint _tmp79_;
#line 1246 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp78_ = detected;
#line 1246 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp79_ = _tmp78_->channels;
#line 1246 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp75_ = _tmp79_ < 3;
#line 10763 "Photo.c"
	}
#line 1245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp75_) {
#line 1245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp74_ = TRUE;
#line 10769 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp80_;
		gint _tmp81_;
#line 1247 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp80_ = detected;
#line 1247 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp81_ = _tmp80_->bits_per_channel;
#line 1247 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp74_ = _tmp81_ != 8;
#line 10779 "Photo.c"
	}
#line 1245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp74_) {
#line 10783 "Photo.c"
		GFile* _tmp82_;
		gchar* _tmp83_;
		gchar* _tmp84_;
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp82_ = file;
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp83_ = g_file_get_path (_tmp82_);
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp84_ = _tmp83_;
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_message ("Photo.vala:1248: Not importing %s: Unsupported color format", _tmp84_);
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp84_);
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (comment);
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (title);
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 10813 "Photo.c"
	}
#line 1256 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp85_ = params->row;
#line 1256 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_id_init (&_tmp85_->photo_id, PHOTO_ID_INVALID);
#line 1257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp86_ = params->row;
#line 1257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp87_ = _tmp86_->master;
#line 1257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp88_ = file;
#line 1257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp89_ = g_file_get_path (_tmp88_);
#line 1257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp87_->filepath);
#line 1257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp87_->filepath = _tmp89_;
#line 1258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp90_ = params->row;
#line 1258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp91_ = _tmp90_->master;
#line 1258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp92_ = detected;
#line 1258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp93_ = _tmp92_->image_dim;
#line 1258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp91_->dim = _tmp93_;
#line 1259 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp94_ = params->row;
#line 1259 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp95_ = _tmp94_->master;
#line 1259 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp96_ = info;
#line 1259 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp95_->filesize = g_file_info_get_size (_tmp96_);
#line 1260 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp97_ = params->row;
#line 1260 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp98_ = _tmp97_->master;
#line 1260 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp99_ = timestamp;
#line 1260 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp100_ = _tmp99_.tv_sec;
#line 1260 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp98_->timestamp = (time_t) _tmp100_;
#line 1261 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp101_ = params->row;
#line 1261 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp102_ = exposure_time;
#line 1261 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp101_->exposure_time = _tmp102_;
#line 1262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp103_ = params->row;
#line 1262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp104_ = orientation;
#line 1262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp103_->orientation = _tmp104_;
#line 1263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp105_ = params->row;
#line 1263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp106_ = _tmp105_->master;
#line 1263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp107_ = orientation;
#line 1263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp106_->original_orientation = _tmp107_;
#line 1264 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp108_ = params->row;
#line 1264 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp109_ = params->import_id;
#line 1264 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp108_->import_id = _tmp109_;
#line 1265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp110_ = params->row;
#line 1265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	event_id_init (&_tmp110_->event_id, EVENT_ID_INVALID);
#line 1266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp111_ = params->row;
#line 1266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp111_->transformations);
#line 1266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp111_->transformations = NULL;
#line 1267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp112_ = params->row;
#line 1267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp113_ = detected;
#line 1267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp114_ = _tmp113_->md5;
#line 1267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp115_ = g_strdup (_tmp114_);
#line 1267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp112_->md5);
#line 1267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp112_->md5 = _tmp115_;
#line 1268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp116_ = params->row;
#line 1268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp117_ = detected;
#line 1268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp118_ = _tmp117_->thumbnail_md5;
#line 1268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp119_ = g_strdup (_tmp118_);
#line 1268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp116_->thumbnail_md5);
#line 1268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp116_->thumbnail_md5 = _tmp119_;
#line 1269 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp120_ = params->row;
#line 1269 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp121_ = detected;
#line 1269 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp122_ = _tmp121_->exif_md5;
#line 1269 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp123_ = g_strdup (_tmp122_);
#line 1269 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp120_->exif_md5);
#line 1269 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp120_->exif_md5 = _tmp123_;
#line 1270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp124_ = params->row;
#line 1270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp124_->time_created = (time_t) 0;
#line 1271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp125_ = params->row;
#line 1271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp125_->flags = (guint64) 0;
#line 1272 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp126_ = params->row;
#line 1272 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp127_ = _tmp126_->master;
#line 1272 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp128_ = detected;
#line 1272 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp129_ = _tmp128_->file_format;
#line 1272 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp127_->file_format = _tmp129_;
#line 1273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp130_ = params->row;
#line 1273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp131_ = title;
#line 1273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp132_ = g_strdup (_tmp131_);
#line 1273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp130_->title);
#line 1273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp130_->title = _tmp132_;
#line 1274 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp133_ = params->row;
#line 1274 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp134_ = gps_coords;
#line 1274 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp133_->gps_coords = _tmp134_;
#line 1275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp135_ = params->row;
#line 1275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp136_ = comment;
#line 1275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp137_ = g_strdup (_tmp136_);
#line 1275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp135_->comment);
#line 1275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp135_->comment = _tmp137_;
#line 1276 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp138_ = params->row;
#line 1276 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp139_ = rating;
#line 1276 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp138_->rating = _tmp139_;
#line 1278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp140_ = params->thumbnails;
#line 1278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp140_ != NULL) {
#line 10985 "Photo.c"
		PhotoFileReader* reader = NULL;
		PhotoRow* _tmp141_;
		BackingPhotoRow* _tmp142_;
		PhotoFileFormat _tmp143_;
		PhotoRow* _tmp144_;
		BackingPhotoRow* _tmp145_;
		const gchar* _tmp146_;
		PhotoFileReader* _tmp147_;
		PhotoFileReader* _tmp148_;
#line 1279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp141_ = params->row;
#line 1279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp142_ = _tmp141_->master;
#line 1279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp143_ = _tmp142_->file_format;
#line 1279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp144_ = params->row;
#line 1279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp145_ = _tmp144_->master;
#line 1279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp146_ = _tmp145_->filepath;
#line 1279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp147_ = photo_file_format_create_reader (_tmp143_, _tmp146_);
#line 1279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		reader = _tmp147_;
#line 1281 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp148_ = reader;
#line 1281 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_file_reader_set_role (_tmp148_, PHOTO_FILE_READER_ROLE_THUMBNAIL);
#line 11015 "Photo.c"
		{
			Thumbnails* _tmp149_;
			PhotoFileReader* _tmp150_;
			PhotoRow* _tmp151_;
			Orientation _tmp152_;
			PhotoRow* _tmp153_;
			BackingPhotoRow* _tmp154_;
			Dimensions _tmp155_;
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp149_ = params->thumbnails;
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp150_ = reader;
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp151_ = params->row;
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp152_ = _tmp151_->orientation;
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp153_ = params->row;
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp154_ = _tmp153_->master;
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp155_ = _tmp154_->dim;
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp149_, _tmp150_, _tmp152_, &_tmp155_, &_inner_error0_);
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11042 "Photo.c"
				goto __catch325_g_error;
			}
		}
		goto __finally325;
		__catch325_g_error:
		{
			GError* err = NULL;
			GError* _tmp156_;
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			err = _inner_error0_;
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_inner_error0_ = NULL;
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp156_ = err;
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = import_result_convert_error (_tmp156_, IMPORT_RESULT_FILE_ERROR);
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_error_free0 (err);
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (comment);
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (title);
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 1286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 11077 "Photo.c"
		}
		__finally325:
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (comment);
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (title);
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return 0;
#line 11102 "Photo.c"
		}
#line 1278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 11106 "Photo.c"
	}
#line 1293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (comment);
#line 1293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (title);
#line 1293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 1293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 1293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 11124 "Photo.c"
}


void
photo_create_pre_import (PhotoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoRow* _tmp3_;
	BackingPhotoRow* _tmp4_;
	gchar* _tmp5_;
	PhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	PhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	PhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	PhotoRow* _tmp12_;
	PhotoRow* _tmp13_;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	PhotoRow* _tmp16_;
	ImportID _tmp17_;
	PhotoRow* _tmp18_;
	PhotoRow* _tmp19_;
	PhotoRow* _tmp20_;
	PhotoRow* _tmp21_;
	PhotoRow* _tmp22_;
	PhotoRow* _tmp23_;
	PhotoRow* _tmp24_;
	PhotoRow* _tmp25_;
	BackingPhotoRow* _tmp26_;
	PhotoRow* _tmp27_;
	PhotoRow* _tmp28_;
	PhotoRow* _tmp29_;
	PhotoRow* _tmp30_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp31_;
	PhotoFileSnifferOptions _tmp32_;
	PhotoFileInterrogator* _tmp33_;
	GError* _inner_error0_ = NULL;
#line 1296 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_IMPORT_PARAMS (params));
#line 1297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = params->file;
#line 1297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = _tmp1_;
#line 1298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = params->row;
#line 1298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_id_init (&_tmp2_->photo_id, PHOTO_ID_INVALID);
#line 1299 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = params->row;
#line 1299 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = _tmp3_->master;
#line 1299 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = g_file_get_path (file);
#line 1299 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp4_->filepath);
#line 1299 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_->filepath = _tmp5_;
#line 1300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = params->row;
#line 1300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dimensions_init (&_tmp7_->dim, 0, 0);
#line 1301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = params->row;
#line 1301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = _tmp8_->master;
#line 1301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_->filesize = (gint64) 0;
#line 1302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = params->row;
#line 1302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_->timestamp = (time_t) 0;
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = params->row;
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_->exposure_time = (time_t) 0;
#line 1304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = params->row;
#line 1304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_->orientation = ORIENTATION_TOP_LEFT;
#line 1305 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = params->row;
#line 1305 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 1305 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1306 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = params->row;
#line 1306 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = params->import_id;
#line 1306 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_->import_id = _tmp17_;
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = params->row;
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	event_id_init (&_tmp18_->event_id, EVENT_ID_INVALID);
#line 1308 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = params->row;
#line 1308 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp19_->transformations);
#line 1308 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_->transformations = NULL;
#line 1309 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = params->row;
#line 1309 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp20_->md5);
#line 1309 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_->md5 = NULL;
#line 1310 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = params->row;
#line 1310 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp21_->thumbnail_md5);
#line 1310 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_->thumbnail_md5 = NULL;
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp22_ = params->row;
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp22_->exif_md5);
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp22_->exif_md5 = NULL;
#line 1312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = params->row;
#line 1312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_->time_created = (time_t) 0;
#line 1313 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_ = params->row;
#line 1313 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_->flags = (guint64) 0;
#line 1314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp25_ = params->row;
#line 1314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = _tmp25_->master;
#line 1314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27_ = params->row;
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp27_->title);
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27_->title = NULL;
#line 1316 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp28_ = params->row;
#line 1316 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	memset (&_tmp28_->gps_coords, 0, sizeof (GpsCoords));
#line 1317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = params->row;
#line 1317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp29_->comment);
#line 1317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_->comment = NULL;
#line 1318 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_ = params->row;
#line 1318 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_->rating = RATING_UNRATED;
#line 1320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = params->file;
#line 1320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp32_ = params->sniffer_options;
#line 1320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = photo_file_interrogator_new (_tmp31_, _tmp32_);
#line 1320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	interrogator = _tmp33_;
#line 11298 "Photo.c"
	{
		DetectedPhotoInformation* detected = NULL;
		DetectedPhotoInformation* _tmp34_;
		gboolean _tmp35_ = FALSE;
		gboolean _tmp36_ = FALSE;
		DetectedPhotoInformation* _tmp37_;
#line 1322 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 1322 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11309 "Photo.c"
			goto __catch326_g_error;
		}
#line 1323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		detected = _tmp34_;
#line 1324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp37_ = detected;
#line 1324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp37_ != NULL) {
#line 1324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36_ = !photo_file_interrogator_get_is_photo_corrupted (interrogator);
#line 11322 "Photo.c"
		} else {
#line 1324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36_ = FALSE;
#line 11326 "Photo.c"
		}
#line 1324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp36_) {
#line 11330 "Photo.c"
			DetectedPhotoInformation* _tmp38_;
			PhotoFileFormat _tmp39_;
#line 1324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp38_ = detected;
#line 1324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp39_ = _tmp38_->file_format;
#line 1324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp35_ = _tmp39_ != PHOTO_FILE_FORMAT_UNKNOWN;
#line 11339 "Photo.c"
		} else {
#line 1324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp35_ = FALSE;
#line 11343 "Photo.c"
		}
#line 1324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp35_) {
#line 11347 "Photo.c"
			PhotoRow* _tmp40_;
			BackingPhotoRow* _tmp41_;
			DetectedPhotoInformation* _tmp42_;
			PhotoFileFormat _tmp43_;
#line 1325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp40_ = params->row;
#line 1325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp41_ = _tmp40_->master;
#line 1325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp42_ = detected;
#line 1325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp43_ = _tmp42_->file_format;
#line 1325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp41_->file_format = _tmp43_;
#line 11362 "Photo.c"
		}
#line 1321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 11366 "Photo.c"
	}
	goto __finally326;
	__catch326_g_error:
	{
		GError* err = NULL;
		gchar* _tmp44_;
		gchar* _tmp45_;
		GError* _tmp46_;
		const gchar* _tmp47_;
#line 1321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 1321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 1327 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp44_ = g_file_get_path (file);
#line 1327 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp45_ = _tmp44_;
#line 1327 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp46_ = err;
#line 1327 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp47_ = _tmp46_->message;
#line 1327 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_debug ("Photo.vala:1327: Unable to interrogate photo file %s: %s", _tmp45_, _tmp47_);
#line 1327 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp45_);
#line 1321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 11394 "Photo.c"
	}
	__finally326:
#line 1321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 11409 "Photo.c"
	}
#line 1296 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1296 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 11415 "Photo.c"
}


BackingPhotoRow*
photo_query_backing_photo_row (Photo* self,
                               GFile* file,
                               PhotoFileSnifferOptions options,
                               DetectedPhotoInformation* * detected,
                               GError** error)
{
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* result = NULL;
	BackingPhotoRow* backing = NULL;
	BackingPhotoRow* _tmp0_;
	GFileInfo* info = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	DetectedPhotoInformation* _tmp11_;
	gboolean _tmp12_ = FALSE;
	DetectedPhotoInformation* _tmp13_;
	GTimeVal modification_time = {0};
	GFileInfo* _tmp17_;
	GTimeVal _tmp18_ = {0};
	BackingPhotoRow* _tmp19_;
	gchar* _tmp20_;
	BackingPhotoRow* _tmp21_;
	GTimeVal _tmp22_;
	glong _tmp23_;
	BackingPhotoRow* _tmp24_;
	GFileInfo* _tmp25_;
	BackingPhotoRow* _tmp26_;
	DetectedPhotoInformation* _tmp27_;
	PhotoFileFormat _tmp28_;
	BackingPhotoRow* _tmp29_;
	DetectedPhotoInformation* _tmp30_;
	Dimensions _tmp31_;
	Orientation _tmp32_ = 0;
	DetectedPhotoInformation* _tmp33_;
	PhotoMetadata* _tmp34_;
	BackingPhotoRow* _tmp37_;
	GError* _inner_error0_ = NULL;
#line 1331 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1331 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1333 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1333 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_detected = NULL;
#line 1335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	backing = _tmp0_;
#line 1337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	info = NULL;
#line 11473 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 1339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 1339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11484 "Photo.c"
			goto __catch327_g_error;
		}
#line 1339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 1339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 1339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		info = _tmp3_;
#line 1338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 11497 "Photo.c"
	}
	goto __finally327;
	__catch327_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 1338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 1338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 1342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = g_file_get_path (file);
#line 1342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = err;
#line 1342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 1342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("Photo.vala:1342: Unable to read file information for %s: %s", _tmp5_, _tmp7_);
#line 1342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 1344 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = NULL;
#line 1344 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1344 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1344 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1344 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (detected) {
#line 1344 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*detected = _vala_detected;
#line 11535 "Photo.c"
		} else {
#line 1344 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11539 "Photo.c"
		}
#line 1344 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 11543 "Photo.c"
	}
	__finally327:
#line 1338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 11556 "Photo.c"
	}
#line 1348 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (file, options);
#line 1348 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	interrogator = _tmp8_;
#line 1349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = interrogator;
#line 1349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error0_);
#line 1349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 11578 "Photo.c"
	}
#line 1350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = interrogator;
#line 1350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 1350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_detected = _tmp11_;
#line 1351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = _vala_detected;
#line 1351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 1351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = TRUE;
#line 11594 "Photo.c"
	} else {
		PhotoFileInterrogator* _tmp14_;
#line 1351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = interrogator;
#line 1351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = photo_file_interrogator_get_is_photo_corrupted (_tmp14_);
#line 11601 "Photo.c"
	}
#line 1351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp12_) {
#line 11605 "Photo.c"
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 1352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 1352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 1352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("Photo.vala:1352: Photo update: %s no longer a recognized image", _tmp16_);
#line 1352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp16_);
#line 1354 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = NULL;
#line 1354 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1354 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1354 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1354 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (detected) {
#line 1354 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*detected = _vala_detected;
#line 11628 "Photo.c"
		} else {
#line 1354 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11632 "Photo.c"
		}
#line 1354 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 11636 "Photo.c"
	}
#line 1357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = info;
#line 1357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp17_, &_tmp18_);
#line 1357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	modification_time = _tmp18_;
#line 1359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = backing;
#line 1359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = g_file_get_path (file);
#line 1359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp19_->filepath);
#line 1359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_->filepath = _tmp20_;
#line 1360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = backing;
#line 1360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp22_ = modification_time;
#line 1360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = _tmp22_.tv_sec;
#line 1360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_->timestamp = (time_t) _tmp23_;
#line 1361 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_ = backing;
#line 1361 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp25_ = info;
#line 1361 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_->filesize = g_file_info_get_size (_tmp25_);
#line 1362 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = backing;
#line 1362 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27_ = _vala_detected;
#line 1362 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp28_ = _tmp27_->file_format;
#line 1362 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_->file_format = _tmp28_;
#line 1363 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = backing;
#line 1363 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_ = _vala_detected;
#line 1363 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = _tmp30_->image_dim;
#line 1363 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_->dim = _tmp31_;
#line 1364 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = _vala_detected;
#line 1364 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp34_ = _tmp33_->metadata;
#line 1364 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp34_ != NULL) {
#line 11688 "Photo.c"
		DetectedPhotoInformation* _tmp35_;
		PhotoMetadata* _tmp36_;
#line 1365 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = _vala_detected;
#line 1365 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp36_ = _tmp35_->metadata;
#line 1365 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = photo_metadata_get_orientation (_tmp36_);
#line 11697 "Photo.c"
	} else {
#line 1365 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = ORIENTATION_TOP_LEFT;
#line 11701 "Photo.c"
	}
#line 1364 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp37_ = backing;
#line 1364 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp37_->original_orientation = _tmp32_;
#line 1367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = backing;
#line 1367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 1367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (detected) {
#line 1367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*detected = _vala_detected;
#line 11717 "Photo.c"
	} else {
#line 1367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 11721 "Photo.c"
	}
#line 1367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 11725 "Photo.c"
}


static void
_vala_array_add87 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11741 "Photo.c"
	}
#line 1463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11747 "Photo.c"
}


static void
_vala_array_add88 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11763 "Photo.c"
	}
#line 1466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11769 "Photo.c"
}


static void
_vala_array_add89 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11785 "Photo.c"
	}
#line 1475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11791 "Photo.c"
}


static void
_vala_array_add90 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11807 "Photo.c"
	}
#line 1478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11813 "Photo.c"
}


static gboolean
_gps_coords_equal (const GpsCoords * s1,
                   const GpsCoords * s2)
{
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (s1 == s2) {
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return TRUE;
#line 11825 "Photo.c"
	}
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (s1 == NULL) {
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return FALSE;
#line 11831 "Photo.c"
	}
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (s2 == NULL) {
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return FALSE;
#line 11837 "Photo.c"
	}
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (s1->has_gps != s2->has_gps) {
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return FALSE;
#line 11843 "Photo.c"
	}
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (s1->latitude != s2->latitude) {
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return FALSE;
#line 11849 "Photo.c"
	}
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (s1->longitude != s2->longitude) {
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return FALSE;
#line 11855 "Photo.c"
	}
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return TRUE;
#line 11859 "Photo.c"
}


static void
_vala_array_add91 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11875 "Photo.c"
	}
#line 1482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11881 "Photo.c"
}


static void
_vala_array_add92 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11897 "Photo.c"
	}
#line 1486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11903 "Photo.c"
}


static void
_vala_array_add93 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11919 "Photo.c"
	}
#line 1489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11925 "Photo.c"
}


static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 1499 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 11934 "Photo.c"
}


gboolean
photo_prepare_for_reimport_master (Photo* self,
                                   PhotoReimportMasterState* * reimport_state,
                                   GError** error)
{
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp4_;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_;
	BackingPhotoRow* _tmp8_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	DetectedPhotoInformation* _tmp14_;
	GdkColorspace _tmp15_;
	PhotoRow* updated_row = NULL;
	PhotoRow* _tmp23_;
	gchar** list = NULL;
	gchar** _tmp29_;
	gint list_length1;
	gint _list_size_;
	PhotoRow* _tmp30_;
	const gchar* _tmp31_;
	DetectedPhotoInformation* _tmp32_;
	const gchar* _tmp33_;
	PhotoRow* _tmp36_;
	BackingPhotoRow* _tmp37_;
	Orientation _tmp38_;
	BackingPhotoRow* _tmp39_;
	Orientation _tmp40_;
	GpsCoords gps_coords = {0};
	DetectedPhotoInformation* _tmp47_;
	PhotoMetadata* _tmp48_;
	PhotoRow* _tmp91_;
	BackingPhotoRow* _tmp92_;
	BackingPhotoRow* _tmp93_;
	PhotoRow* _tmp94_;
	DetectedPhotoInformation* _tmp95_;
	const gchar* _tmp96_;
	gchar* _tmp97_;
	PhotoRow* _tmp98_;
	DetectedPhotoInformation* _tmp99_;
	const gchar* _tmp100_;
	gchar* _tmp101_;
	PhotoRow* _tmp102_;
	DetectedPhotoInformation* _tmp103_;
	const gchar* _tmp104_;
	gchar* _tmp105_;
	PhotoMetadata* metadata = NULL;
	DetectedPhotoInformation* _tmp106_;
	PhotoMetadata* _tmp107_;
	PhotoRow* _tmp130_;
	PhotoMetadata* _tmp131_;
	gchar** _tmp132_;
	gint _tmp132__length1;
	PhotoReimportMasterStateImpl* _tmp133_;
	GError* _inner_error0_ = NULL;
#line 1431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1432 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1432 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = _tmp3_;
#line 1437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = file;
#line 1437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error0_);
#line 1437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	detected = _tmp5_;
#line 1437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	backing = _tmp6_;
#line 1437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12032 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp7_;
#line 12042 "Photo.c"
	}
#line 1439 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = backing;
#line 1439 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 12048 "Photo.c"
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1440 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = file;
#line 1440 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 1440 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 1440 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:1440: Unable to retrieve photo state from %s for reimport", _tmp11_);
#line 1440 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp11_);
#line 1441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 1441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (reimport_state) {
#line 1441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 12074 "Photo.c"
		} else {
#line 1441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 12078 "Photo.c"
		}
#line 1441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 12082 "Photo.c"
	}
#line 1445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = detected;
#line 1445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = _tmp14_->colorspace;
#line 1445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp15_ != GDK_COLORSPACE_RGB) {
#line 1445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = TRUE;
#line 12092 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp16_;
		gint _tmp17_;
#line 1446 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = detected;
#line 1446 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = _tmp16_->channels;
#line 1446 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = _tmp17_ < 3;
#line 12102 "Photo.c"
	}
#line 1445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp13_) {
#line 1445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = TRUE;
#line 12108 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp18_;
		gint _tmp19_;
#line 1447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = detected;
#line 1447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = _tmp18_->bits_per_channel;
#line 1447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = _tmp19_ != 8;
#line 12118 "Photo.c"
	}
#line 1445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp12_) {
#line 12122 "Photo.c"
		GFile* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 1448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = file;
#line 1448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp21_ = g_file_get_path (_tmp20_);
#line 1448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 1448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:1448: Not re-importing %s: Unsupported color format", _tmp22_);
#line 1448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp22_);
#line 1450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 1450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (reimport_state) {
#line 1450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 12148 "Photo.c"
		} else {
#line 1450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 12152 "Photo.c"
		}
#line 1450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 12156 "Photo.c"
	}
#line 1454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = photo_row_new ();
#line 1454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	updated_row = _tmp23_;
#line 12162 "Photo.c"
	{
		PhotoRow* _tmp24_;
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp24_ = self->row;
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12169 "Photo.c"
		{
			PhotoRow* _tmp25_;
			PhotoRow* _tmp26_;
#line 1456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp25_ = self->row;
#line 1456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp26_ = _photo_row_ref0 (_tmp25_);
#line 1456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			updated_row = _tmp26_;
#line 12181 "Photo.c"
		}
		__finally328:
		{
			PhotoRow* _tmp27_;
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp27_ = self->row;
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12190 "Photo.c"
		}
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12194 "Photo.c"
			gboolean _tmp28_ = FALSE;
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 1455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp28_;
#line 12208 "Photo.c"
		}
	}
#line 1460 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = g_new0 (gchar*, 0 + 1);
#line 1460 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	list = _tmp29_;
#line 1460 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	list_length1 = 0;
#line 1460 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_list_size_ = list_length1;
#line 1462 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_ = updated_row;
#line 1462 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = _tmp30_->md5;
#line 1462 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp32_ = detected;
#line 1462 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = _tmp32_->md5;
#line 1462 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_strcmp0 (_tmp31_, _tmp33_) != 0) {
#line 12229 "Photo.c"
		gchar** _tmp34_;
		gint _tmp34__length1;
		gchar* _tmp35_;
#line 1463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34_ = list;
#line 1463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34__length1 = list_length1;
#line 1463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = g_strdup ("metadata:md5");
#line 1463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_array_add87 (&list, &list_length1, &_list_size_, _tmp35_);
#line 12241 "Photo.c"
	}
#line 1465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp36_ = updated_row;
#line 1465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp37_ = _tmp36_->master;
#line 1465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp38_ = _tmp37_->original_orientation;
#line 1465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp39_ = backing;
#line 1465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp40_ = _tmp39_->original_orientation;
#line 1465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp38_ != _tmp40_) {
#line 12255 "Photo.c"
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar* _tmp42_;
		PhotoRow* _tmp43_;
		BackingPhotoRow* _tmp44_;
		BackingPhotoRow* _tmp45_;
		Orientation _tmp46_;
#line 1466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp41_ = list;
#line 1466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp41__length1 = list_length1;
#line 1466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp42_ = g_strdup ("image:orientation");
#line 1466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_array_add88 (&list, &list_length1, &_list_size_, _tmp42_);
#line 1467 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp43_ = updated_row;
#line 1467 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp44_ = _tmp43_->master;
#line 1467 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp45_ = backing;
#line 1467 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp46_ = _tmp45_->original_orientation;
#line 1467 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp44_->original_orientation = _tmp46_;
#line 12281 "Photo.c"
	}
#line 1470 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	memset (&gps_coords, 0, sizeof (GpsCoords));
#line 1472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp47_ = detected;
#line 1472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp48_ = _tmp47_->metadata;
#line 1472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 12291 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp49_;
		PhotoMetadata* _tmp50_;
		MetadataDateTime* _tmp51_;
		gboolean _tmp52_ = FALSE;
		MetadataDateTime* _tmp53_;
		PhotoRow* _tmp59_;
		const gchar* _tmp60_;
		DetectedPhotoInformation* _tmp61_;
		PhotoMetadata* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gboolean _tmp65_;
		DetectedPhotoInformation* _tmp68_;
		PhotoMetadata* _tmp69_;
		GpsCoords _tmp70_ = {0};
		PhotoRow* _tmp71_;
		GpsCoords _tmp72_;
		GpsCoords _tmp73_;
		PhotoRow* _tmp76_;
		const gchar* _tmp77_;
		DetectedPhotoInformation* _tmp78_;
		PhotoMetadata* _tmp79_;
		gchar* _tmp80_;
		gchar* _tmp81_;
		gboolean _tmp82_;
		PhotoRow* _tmp85_;
		Rating _tmp86_;
		DetectedPhotoInformation* _tmp87_;
		PhotoMetadata* _tmp88_;
#line 1473 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp49_ = detected;
#line 1473 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp50_ = _tmp49_->metadata;
#line 1473 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp51_ = photo_metadata_get_exposure_date_time (_tmp50_);
#line 1473 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		date_time = _tmp51_;
#line 1474 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp53_ = date_time;
#line 1474 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp53_ != NULL) {
#line 12334 "Photo.c"
			PhotoRow* _tmp54_;
			time_t _tmp55_;
			MetadataDateTime* _tmp56_;
#line 1474 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp54_ = updated_row;
#line 1474 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp55_ = _tmp54_->exposure_time;
#line 1474 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp56_ = date_time;
#line 1474 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp52_ = _tmp55_ != metadata_date_time_get_timestamp (_tmp56_);
#line 12346 "Photo.c"
		} else {
#line 1474 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp52_ = FALSE;
#line 12350 "Photo.c"
		}
#line 1474 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp52_) {
#line 12354 "Photo.c"
			gchar** _tmp57_;
			gint _tmp57__length1;
			gchar* _tmp58_;
#line 1475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp57_ = list;
#line 1475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp57__length1 = list_length1;
#line 1475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp58_ = g_strdup ("metadata:exposure-time");
#line 1475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add89 (&list, &list_length1, &_list_size_, _tmp58_);
#line 12366 "Photo.c"
		}
#line 1477 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp59_ = updated_row;
#line 1477 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp60_ = _tmp59_->title;
#line 1477 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp61_ = detected;
#line 1477 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp62_ = _tmp61_->metadata;
#line 1477 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp63_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1477 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp64_ = _tmp63_;
#line 1477 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp65_ = g_strcmp0 (_tmp60_, _tmp64_) != 0;
#line 1477 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp64_);
#line 1477 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp65_) {
#line 12386 "Photo.c"
			gchar** _tmp66_;
			gint _tmp66__length1;
			gchar* _tmp67_;
#line 1478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp66_ = list;
#line 1478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp66__length1 = list_length1;
#line 1478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp67_ = g_strdup ("metadata:name");
#line 1478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add90 (&list, &list_length1, &_list_size_, _tmp67_);
#line 12398 "Photo.c"
		}
#line 1480 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp68_ = detected;
#line 1480 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp69_ = _tmp68_->metadata;
#line 1480 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_get_gps_coords (_tmp69_, &_tmp70_);
#line 1480 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gps_coords = _tmp70_;
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp71_ = updated_row;
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp72_ = _tmp71_->gps_coords;
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp73_ = gps_coords;
#line 1481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_gps_coords_equal (&_tmp72_, &_tmp73_) != TRUE) {
#line 12416 "Photo.c"
			gchar** _tmp74_;
			gint _tmp74__length1;
			gchar* _tmp75_;
#line 1482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp74_ = list;
#line 1482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp74__length1 = list_length1;
#line 1482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp75_ = g_strdup ("metadata:gps");
#line 1482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add91 (&list, &list_length1, &_list_size_, _tmp75_);
#line 12428 "Photo.c"
		}
#line 1485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp76_ = updated_row;
#line 1485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp77_ = _tmp76_->comment;
#line 1485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp78_ = detected;
#line 1485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp79_ = _tmp78_->metadata;
#line 1485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp80_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp81_ = _tmp80_;
#line 1485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp82_ = g_strcmp0 (_tmp77_, _tmp81_) != 0;
#line 1485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp81_);
#line 1485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp82_) {
#line 12448 "Photo.c"
			gchar** _tmp83_;
			gint _tmp83__length1;
			gchar* _tmp84_;
#line 1486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp83_ = list;
#line 1486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp83__length1 = list_length1;
#line 1486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp84_ = g_strdup ("metadata:comment");
#line 1486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add92 (&list, &list_length1, &_list_size_, _tmp84_);
#line 12460 "Photo.c"
		}
#line 1488 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp85_ = updated_row;
#line 1488 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp86_ = _tmp85_->rating;
#line 1488 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp87_ = detected;
#line 1488 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp88_ = _tmp87_->metadata;
#line 1488 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp86_ != photo_metadata_get_rating (_tmp88_)) {
#line 12472 "Photo.c"
			gchar** _tmp89_;
			gint _tmp89__length1;
			gchar* _tmp90_;
#line 1489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp89_ = list;
#line 1489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp89__length1 = list_length1;
#line 1489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp90_ = g_strdup ("metadata:rating");
#line 1489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add93 (&list, &list_length1, &_list_size_, _tmp90_);
#line 12484 "Photo.c"
		}
#line 1472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 12488 "Photo.c"
	}
#line 1492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp91_ = updated_row;
#line 1492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp92_ = backing;
#line 1492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp93_ = _backing_photo_row_ref0 (_tmp92_);
#line 1492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp91_->master);
#line 1492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp91_->master = _tmp93_;
#line 1493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp94_ = updated_row;
#line 1493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp95_ = detected;
#line 1493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp96_ = _tmp95_->md5;
#line 1493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp97_ = g_strdup (_tmp96_);
#line 1493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp94_->md5);
#line 1493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp94_->md5 = _tmp97_;
#line 1494 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp98_ = updated_row;
#line 1494 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp99_ = detected;
#line 1494 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp100_ = _tmp99_->exif_md5;
#line 1494 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp101_ = g_strdup (_tmp100_);
#line 1494 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp98_->exif_md5);
#line 1494 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp98_->exif_md5 = _tmp101_;
#line 1495 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp102_ = updated_row;
#line 1495 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp103_ = detected;
#line 1495 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp104_ = _tmp103_->thumbnail_md5;
#line 1495 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp105_ = g_strdup (_tmp104_);
#line 1495 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp102_->thumbnail_md5);
#line 1495 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp102_->thumbnail_md5 = _tmp105_;
#line 1497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	metadata = NULL;
#line 1498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp106_ = detected;
#line 1498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp107_ = _tmp106_->metadata;
#line 1498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp107_ != NULL) {
#line 12544 "Photo.c"
		DetectedPhotoInformation* _tmp108_;
		PhotoMetadata* _tmp109_;
		PhotoMetadata* _tmp110_;
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp111_;
		PhotoMetadata* _tmp112_;
		MetadataDateTime* _tmp113_;
		MetadataDateTime* _tmp114_;
		PhotoRow* _tmp117_;
		GpsCoords _tmp118_;
		PhotoRow* _tmp119_;
		DetectedPhotoInformation* _tmp120_;
		PhotoMetadata* _tmp121_;
		gchar* _tmp122_;
		PhotoRow* _tmp123_;
		DetectedPhotoInformation* _tmp124_;
		PhotoMetadata* _tmp125_;
		gchar* _tmp126_;
		PhotoRow* _tmp127_;
		DetectedPhotoInformation* _tmp128_;
		PhotoMetadata* _tmp129_;
#line 1499 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp108_ = detected;
#line 1499 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp109_ = _tmp108_->metadata;
#line 1499 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp110_ = _media_metadata_ref0 (_tmp109_);
#line 1499 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1499 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		metadata = _tmp110_;
#line 1501 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp111_ = detected;
#line 1501 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp112_ = _tmp111_->metadata;
#line 1501 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp113_ = photo_metadata_get_exposure_date_time (_tmp112_);
#line 1501 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		date_time = _tmp113_;
#line 1502 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp114_ = date_time;
#line 1502 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp114_ != NULL) {
#line 12588 "Photo.c"
			PhotoRow* _tmp115_;
			MetadataDateTime* _tmp116_;
#line 1503 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp115_ = updated_row;
#line 1503 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp116_ = date_time;
#line 1503 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp115_->exposure_time = metadata_date_time_get_timestamp (_tmp116_);
#line 12597 "Photo.c"
		}
#line 1505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp117_ = updated_row;
#line 1505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp118_ = gps_coords;
#line 1505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp117_->gps_coords = _tmp118_;
#line 1506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp119_ = updated_row;
#line 1506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp120_ = detected;
#line 1506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp121_ = _tmp120_->metadata;
#line 1506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp122_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp121_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp119_->title);
#line 1506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp119_->title = _tmp122_;
#line 1507 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp123_ = updated_row;
#line 1507 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp124_ = detected;
#line 1507 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp125_ = _tmp124_->metadata;
#line 1507 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp126_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp125_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1507 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp123_->comment);
#line 1507 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp123_->comment = _tmp126_;
#line 1508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp127_ = updated_row;
#line 1508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp128_ = detected;
#line 1508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp129_ = _tmp128_->metadata;
#line 1508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp127_->rating = photo_metadata_get_rating (_tmp129_);
#line 1498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 12639 "Photo.c"
	}
#line 1511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp130_ = updated_row;
#line 1511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp131_ = metadata;
#line 1511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp132_ = list;
#line 1511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp132__length1 = list_length1;
#line 1511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp133_ = photo_reimport_master_state_impl_new (_tmp130_, _tmp131_, _tmp132_, _tmp132__length1);
#line 1511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_reimport_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp133_, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (reimport_state) {
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 12673 "Photo.c"
	} else {
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 12677 "Photo.c"
	}
#line 1513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 12681 "Photo.c"
}


static void
photo_real_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata)
{
#line 1516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 12693 "Photo.c"
}


void
photo_apply_user_metadata_for_reimport (Photo* self,
                                        PhotoMetadata* metadata)
{
#line 1516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->apply_user_metadata_for_reimport (self, metadata);
#line 12705 "Photo.c"
}


static gpointer
_photo_reimport_master_state_ref0 (gpointer self)
{
#line 1520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 12714 "Photo.c"
}


static void
_vala_array_add94 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12730 "Photo.c"
	}
#line 1538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 12736 "Photo.c"
}


static void
_vala_array_add95 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 12752 "Photo.c"
	}
#line 1540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 12758 "Photo.c"
}


void
photo_finish_reimport_master (Photo* self,
                              PhotoReimportMasterState* state,
                              GError** error)
{
	PhotoReimportMasterStateImpl* reimport_state = NULL;
	PhotoReimportMasterStateImpl* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	PhotoRow* _tmp3_;
	PhotoMetadata* _tmp19_;
	gboolean _tmp21_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	PhotoMetadata* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 1519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 1520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _photo_reimport_master_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl));
#line 1520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	reimport_state = _tmp0_;
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = reimport_state->row;
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_table_reimport (_tmp2_, _tmp3_, &_inner_error0_);
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 12806 "Photo.c"
		} else {
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 12816 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp4_;
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = self->row;
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12825 "Photo.c"
		{
			BackingPhotoRow* original_master = NULL;
			PhotoRow* _tmp5_;
			BackingPhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			BackingPhotoRow* _tmp11_;
			BackingPhotoRow* _tmp12_;
			PhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			PhotoRow* _tmp15_;
			BackingPhotoRow* _tmp16_;
			gboolean _tmp17_;
#line 1526 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 1526 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _tmp5_->master;
#line 1526 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = _backing_photo_row_ref0 (_tmp6_);
#line 1526 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			original_master = _tmp7_;
#line 1527 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = reimport_state->row;
#line 1527 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = _photo_row_ref0 (_tmp8_);
#line 1527 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1527 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			self->row = _tmp9_;
#line 1528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = self->row;
#line 1528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = original_master;
#line 1528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = _backing_photo_row_ref0 (_tmp11_);
#line 1528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (_tmp10_->master);
#line 1528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_->master = _tmp12_;
#line 1529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = self->row;
#line 1529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = reimport_state->row;
#line 1529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp16_ = _tmp15_->master;
#line 1529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			backing_photo_row_copy_from (_tmp14_, _tmp16_);
#line 1530 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp17_ = reimport_state->metadata_only;
#line 1530 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!_tmp17_) {
#line 1531 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_remove_all_transformations (self, FALSE);
#line 12883 "Photo.c"
			}
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 12887 "Photo.c"
		}
		__finally329:
		{
			PhotoRow* _tmp18_;
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp18_ = self->row;
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12896 "Photo.c"
		}
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 12908 "Photo.c"
			} else {
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 12918 "Photo.c"
			}
		}
	}
#line 1534 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = reimport_state->metadata;
#line 1534 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 12926 "Photo.c"
		PhotoMetadata* _tmp20_;
#line 1535 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = reimport_state->metadata;
#line 1535 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp20_);
#line 12932 "Photo.c"
	}
#line 1537 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = reimport_state->metadata_only;
#line 1537 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp21_) {
#line 12938 "Photo.c"
		gchar** _tmp22_;
		gint _tmp22__length1;
		gchar* _tmp23_;
#line 1538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = reimport_state->alterations;
#line 1538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22__length1 = reimport_state->alterations_length1;
#line 1538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = g_strdup ("image:master");
#line 1538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_array_add94 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp23_);
#line 1539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (photo_is_master_baseline (self)) {
#line 12952 "Photo.c"
			gchar** _tmp24_;
			gint _tmp24__length1;
			gchar* _tmp25_;
#line 1540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp24_ = reimport_state->alterations;
#line 1540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp24__length1 = reimport_state->alterations_length1;
#line 1540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp25_ = g_strdup ("image:baseline");
#line 1540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add95 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp25_);
#line 12964 "Photo.c"
		}
	}
#line 1543 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = reimport_state->alterations;
#line 1543 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26__length1 = reimport_state->alterations_length1;
#line 1543 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp26__length1 > 0) {
#line 12973 "Photo.c"
		gchar** _tmp27_;
		gint _tmp27__length1;
		Alteration* _tmp28_;
		Alteration* _tmp29_;
#line 1544 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp27_ = reimport_state->alterations;
#line 1544 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp27__length1 = reimport_state->alterations_length1;
#line 1544 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp28_ = alteration_new_from_array (_tmp27_, _tmp27__length1);
#line 1544 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 1544 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp29_);
#line 1544 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp29_);
#line 12990 "Photo.c"
	}
#line 1546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_ = reimport_state->metadata;
#line 1546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_notify_master_reimported (self, _tmp30_);
#line 1548 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 12998 "Photo.c"
		PhotoMetadata* _tmp31_;
#line 1549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp31_ = reimport_state->metadata;
#line 1549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp31_);
#line 13004 "Photo.c"
	}
#line 1551 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_is_master_source (self)) {
#line 13008 "Photo.c"
		PhotoMetadata* _tmp32_;
#line 1552 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = reimport_state->metadata;
#line 1552 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp32_);
#line 13014 "Photo.c"
	}
#line 1519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 13018 "Photo.c"
}


static gboolean
photo_verify_file_for_reimport (Photo* self,
                                GFile* file,
                                BackingPhotoRow* * backing,
                                DetectedPhotoInformation* * detected,
                                GError** error)
{
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	gboolean result = FALSE;
	BackingPhotoRow* _tmp0_ = NULL;
	DetectedPhotoInformation* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_;
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	DetectedPhotoInformation* _tmp8_;
	GdkColorspace _tmp9_;
	GError* _inner_error0_ = NULL;
#line 1556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_query_backing_photo_row (self, file, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp1_, &_inner_error0_);
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_detected = _tmp1_;
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13056 "Photo.c"
		gboolean _tmp3_ = FALSE;
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp3_;
#line 13062 "Photo.c"
	}
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_backing = _tmp4_;
#line 1560 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = _vala_backing;
#line 1560 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 1561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 1561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (backing) {
#line 1561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*backing = _vala_backing;
#line 13084 "Photo.c"
		} else {
#line 1561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 13088 "Photo.c"
		}
#line 1561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (detected) {
#line 1561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*detected = _vala_detected;
#line 13094 "Photo.c"
		} else {
#line 1561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 13098 "Photo.c"
		}
#line 1561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 13102 "Photo.c"
	}
#line 1565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = _vala_detected;
#line 1565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = _tmp8_->colorspace;
#line 1565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp9_ != GDK_COLORSPACE_RGB) {
#line 1565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = TRUE;
#line 13112 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp10_;
		gint _tmp11_;
#line 1566 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = _vala_detected;
#line 1566 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = _tmp10_->channels;
#line 1566 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = _tmp11_ < 3;
#line 13122 "Photo.c"
	}
#line 1565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp7_) {
#line 1565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = TRUE;
#line 13128 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp12_;
		gint _tmp13_;
#line 1567 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = _vala_detected;
#line 1567 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = _tmp12_->bits_per_channel;
#line 1567 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = _tmp13_ != 8;
#line 13138 "Photo.c"
	}
#line 1565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp6_) {
#line 13142 "Photo.c"
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1568 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = g_file_get_path (file);
#line 1568 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 1568 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:1568: Not re-importing %s: Unsupported color format", _tmp15_);
#line 1568 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp15_);
#line 1570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 1570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (backing) {
#line 1570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*backing = _vala_backing;
#line 13161 "Photo.c"
		} else {
#line 1570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 13165 "Photo.c"
		}
#line 1570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (detected) {
#line 1570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*detected = _vala_detected;
#line 13171 "Photo.c"
		} else {
#line 1570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 13175 "Photo.c"
		}
#line 1570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 13179 "Photo.c"
	}
#line 1573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 1573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp0_);
#line 1573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (backing) {
#line 1573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*backing = _vala_backing;
#line 13189 "Photo.c"
	} else {
#line 1573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 13193 "Photo.c"
	}
#line 1573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (detected) {
#line 1573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*detected = _vala_detected;
#line 13199 "Photo.c"
	} else {
#line 1573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 13203 "Photo.c"
	}
#line 1573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 13207 "Photo.c"
}


gboolean
photo_prepare_for_reimport_editable (Photo* self,
                                     PhotoReimportEditableState* * state,
                                     GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	BackingPhotoRow* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	gboolean _tmp6_;
	BackingPhotoRow* _tmp8_;
	DetectedPhotoInformation* _tmp9_;
	PhotoMetadata* _tmp10_;
	PhotoReimportEditableStateImpl* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 1577 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_state = NULL;
#line 1580 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1580 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = _tmp0_;
#line 1581 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = file;
#line 1581 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 1582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 1582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 13255 "Photo.c"
		} else {
#line 1582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 13259 "Photo.c"
		}
#line 1582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 13263 "Photo.c"
	}
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = file;
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = photo_verify_file_for_reimport (self, _tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	backing = _tmp4_;
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	detected = _tmp5_;
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp6_;
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13281 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp7_;
#line 13293 "Photo.c"
	}
#line 1586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp2_) {
#line 1587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 1587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 1587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 13309 "Photo.c"
		} else {
#line 1587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 13313 "Photo.c"
		}
#line 1587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 13317 "Photo.c"
	}
#line 1589 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = backing;
#line 1589 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = detected;
#line 1589 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = _tmp9_->metadata;
#line 1589 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = photo_reimport_editable_state_impl_new (_tmp8_, _tmp10_);
#line 1589 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1589 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 1591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 1591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (state) {
#line 1591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*state = _vala_state;
#line 13343 "Photo.c"
	} else {
#line 1591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 13347 "Photo.c"
	}
#line 1591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 13351 "Photo.c"
}


static gpointer
_photo_reimport_editable_state_ref0 (gpointer self)
{
#line 1600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 13360 "Photo.c"
}


void
photo_finish_reimport_editable (Photo* self,
                                PhotoReimportEditableState* state,
                                GError** error)
{
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp0_ = {0};
	PhotoReimportEditableStateImpl* reimport_state = NULL;
	PhotoReimportEditableStateImpl* _tmp1_;
	PhotoReimportEditableStateImpl* _tmp2_;
	gboolean _tmp3_;
	PhotoReimportEditableStateImpl* _tmp19_;
	PhotoMetadata* _tmp20_;
	gchar* list = NULL;
	gchar* _tmp36_;
	PhotoReimportEditableStateImpl* _tmp37_;
	gboolean _tmp38_;
	const gchar* _tmp41_;
	Alteration* _tmp42_;
	Alteration* _tmp43_;
	PhotoReimportEditableStateImpl* _tmp44_;
	PhotoMetadata* _tmp45_;
	GError* _inner_error0_ = NULL;
#line 1595 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1595 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 1596 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1596 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	editable_id = _tmp0_;
#line 1597 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 1598 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 13399 "Photo.c"
	}
#line 1600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _photo_reimport_editable_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl));
#line 1600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	reimport_state = _tmp1_;
#line 1602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = reimport_state;
#line 1602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_->metadata_only;
#line 1602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp3_) {
#line 13411 "Photo.c"
		BackingPhotoTable* _tmp4_;
		BackingPhotoTable* _tmp5_;
		PhotoReimportEditableStateImpl* _tmp6_;
		BackingPhotoRow* _tmp7_;
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = backing_photo_table_get_instance ();
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = reimport_state;
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = _tmp6_->backing_state;
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		backing_photo_table_update (_tmp5_, _tmp7_, &_inner_error0_);
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_database_table_unref0 (_tmp5_);
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 13438 "Photo.c"
			} else {
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 13448 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp8_;
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = self->row;
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 13457 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp9_;
				BackingPhotoRow* _tmp10_;
				BackingPhotoRow* _tmp11_;
				PhotoReimportEditableStateImpl* _tmp12_;
				BackingPhotoRow* _tmp13_;
				Orientation _tmp14_;
#line 1606 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = reimport_state;
#line 1606 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _tmp9_->backing_state;
#line 1606 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _backing_photo_row_ref0 (_tmp10_);
#line 1606 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1606 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->editable = _tmp11_;
#line 1607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = reimport_state;
#line 1607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = _tmp12_->backing_state;
#line 1607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = _tmp13_->original_orientation;
#line 1607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_set_orientation (self, _tmp14_);
#line 1608 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_remove_all_transformations (self, FALSE);
#line 13485 "Photo.c"
			}
			__finally330:
			{
				PhotoRow* _tmp15_;
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = self->row;
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13494 "Photo.c"
			}
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 13506 "Photo.c"
				} else {
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 13516 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp16_;
		BackingPhotoRow* _tmp17_;
		Orientation _tmp18_;
#line 1611 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = reimport_state;
#line 1611 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = _tmp16_->backing_state;
#line 1611 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = _tmp17_->original_orientation;
#line 1611 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_set_orientation (self, _tmp18_);
#line 13532 "Photo.c"
	}
#line 1614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = reimport_state;
#line 1614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = _tmp19_->metadata;
#line 1614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 13540 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp21_;
		PhotoMetadata* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		PhotoReimportEditableStateImpl* _tmp25_;
		PhotoMetadata* _tmp26_;
		GpsCoords _tmp27_ = {0};
		PhotoReimportEditableStateImpl* _tmp28_;
		PhotoMetadata* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		PhotoReimportEditableStateImpl* _tmp32_;
		PhotoMetadata* _tmp33_;
		PhotoReimportEditableStateImpl* _tmp34_;
		PhotoMetadata* _tmp35_;
#line 1615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp21_ = reimport_state;
#line 1615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = _tmp21_->metadata;
#line 1615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp24_ = _tmp23_;
#line 1615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp24_);
#line 1615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp24_);
#line 1616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp25_ = reimport_state;
#line 1616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp26_ = _tmp25_->metadata;
#line 1616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_get_gps_coords (_tmp26_, &_tmp27_);
#line 1616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		positionable_set_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp27_);
#line 1617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp28_ = reimport_state;
#line 1617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp29_ = _tmp28_->metadata;
#line 1617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp30_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 1617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp31_ = _tmp30_;
#line 1617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp31_);
#line 1617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp31_);
#line 1618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = reimport_state;
#line 1618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp33_ = _tmp32_->metadata;
#line 1618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), photo_metadata_get_rating (_tmp33_));
#line 1619 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34_ = reimport_state;
#line 1619 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = _tmp34_->metadata;
#line 1619 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp35_);
#line 13600 "Photo.c"
	}
#line 1622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp36_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	list = _tmp36_;
#line 1623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp37_ = reimport_state;
#line 1623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp38_ = _tmp37_->metadata_only;
#line 1623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp38_) {
#line 13612 "Photo.c"
		const gchar* _tmp39_;
		gchar* _tmp40_;
#line 1624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp39_ = list;
#line 1624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp40_ = g_strconcat (_tmp39_, "image:editable,image:baseline", NULL);
#line 1624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (list);
#line 1624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		list = _tmp40_;
#line 13623 "Photo.c"
	}
#line 1626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp41_ = list;
#line 1626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp42_ = alteration_new_from_list (_tmp41_);
#line 1626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 1626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp43_);
#line 1626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_alteration_unref0 (_tmp43_);
#line 1628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp44_ = reimport_state;
#line 1628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp45_ = _tmp44_->metadata;
#line 1628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp45_);
#line 1630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_is_editable_baseline (self)) {
#line 13643 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp46_;
		PhotoMetadata* _tmp47_;
#line 1631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp46_ = reimport_state;
#line 1631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp47_ = _tmp46_->metadata;
#line 1631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp47_);
#line 13652 "Photo.c"
	}
#line 1633 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_is_editable_source (self)) {
#line 13656 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp48_;
		PhotoMetadata* _tmp49_;
#line 1634 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp48_ = reimport_state;
#line 1634 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp49_ = _tmp48_->metadata;
#line 1634 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp49_);
#line 13665 "Photo.c"
	}
#line 1595 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (list);
#line 1595 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 13671 "Photo.c"
}


static gpointer
_photo_reimport_raw_development_state_ref0 (gpointer self)
{
#line 1656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 13680 "Photo.c"
}


gboolean
photo_prepare_for_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState* * state,
                                            GError** error)
{
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	gboolean result = FALSE;
	GeeCollection* files = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* _tmp18_;
	PhotoReimportRawDevelopmentState* _tmp19_;
	PhotoReimportRawDevelopmentStateImpl* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 1638 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_state = NULL;
#line 1641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	files = _tmp0_;
#line 1642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = files;
#line 1642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1643 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 1643 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (files);
#line 1643 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 1643 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 13722 "Photo.c"
		} else {
#line 1643 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 13726 "Photo.c"
		}
#line 1643 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 13730 "Photo.c"
	}
#line 1645 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1645 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	reimport_state = _tmp2_;
#line 13736 "Photo.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = files;
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_file_it = _tmp4_;
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 13749 "Photo.c"
			GeeIterator* _tmp5_;
			GFile* file = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			gboolean _tmp8_ = FALSE;
			GFile* _tmp9_;
			BackingPhotoRow* _tmp10_ = NULL;
			DetectedPhotoInformation* _tmp11_ = NULL;
			gboolean _tmp12_;
			PhotoReimportRawDevelopmentStateImpl* _tmp14_;
			BackingPhotoRow* _tmp15_;
			DetectedPhotoInformation* _tmp16_;
			PhotoMetadata* _tmp17_;
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = _file_it;
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 13771 "Photo.c"
			}
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _file_it;
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			file = (GFile*) _tmp7_;
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = file;
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = photo_verify_file_for_reimport (self, _tmp9_, &_tmp10_, &_tmp11_, &_inner_error0_);
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			backing = _tmp10_;
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			detected = _tmp11_;
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = _tmp12_;
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13795 "Photo.c"
				gboolean _tmp13_ = FALSE;
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (files);
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return _tmp13_;
#line 13813 "Photo.c"
			}
#line 1650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!_tmp8_) {
#line 1651 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1651 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1651 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 1651 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				continue;
#line 13825 "Photo.c"
			}
#line 1653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = reimport_state;
#line 1653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = backing;
#line 1653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp16_ = detected;
#line 1653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp17_ = _tmp16_->metadata;
#line 1653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp14_, _tmp15_, _tmp17_);
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 13843 "Photo.c"
		}
#line 1647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 13847 "Photo.c"
	}
#line 1656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState));
#line 1656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_state = _tmp19_;
#line 1657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = reimport_state;
#line 1657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_reimport_raw_development_state_impl_get_size (_tmp20_) > 0;
#line 1657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (files);
#line 1657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (state) {
#line 1657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*state = _vala_state;
#line 13869 "Photo.c"
	} else {
#line 1657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 13873 "Photo.c"
	}
#line 1657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 13877 "Photo.c"
}


void
photo_finish_reimport_raw_development (Photo* self,
                                       PhotoReimportRawDevelopmentState* state,
                                       GError** error)
{
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp0_;
	gchar* list = NULL;
	gchar* _tmp29_;
	PhotoReimportRawDevelopmentStateImpl* _tmp30_;
	gboolean _tmp31_;
	const gchar* _tmp34_;
	Alteration* _tmp35_;
	Alteration* _tmp36_;
	GError* _inner_error0_ = NULL;
#line 1661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE (state));
#line 1662 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 13904 "Photo.c"
	}
#line 1665 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl));
#line 1665 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	reimport_state = _tmp0_;
#line 13910 "Photo.c"
	{
		GeeIterator* _dev_it = NULL;
		PhotoReimportRawDevelopmentStateImpl* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = reimport_state;
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp1_->list;
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_dev_it = _tmp3_;
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 13926 "Photo.c"
			GeeIterator* _tmp4_;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			PhotoReimportRawDevelopmentStateImpl* _tmp7_;
			gboolean _tmp8_;
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _dev_it;
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 13939 "Photo.c"
			}
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = _dev_it;
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp6_;
#line 1668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = reimport_state;
#line 1668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = _tmp7_->metadata_only;
#line 1668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!_tmp8_) {
#line 13953 "Photo.c"
				BackingPhotoTable* _tmp9_;
				BackingPhotoTable* _tmp10_;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp11_;
				BackingPhotoRow* _tmp12_;
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = backing_photo_table_get_instance ();
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = dev;
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = _tmp11_->backing;
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				backing_photo_table_update (_tmp10_, _tmp12_, &_inner_error0_);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp10_);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_propagate_error (error, _inner_error0_);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						return;
#line 13984 "Photo.c"
					} else {
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_clear_error (&_inner_error0_);
#line 1669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						return;
#line 13998 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp13_;
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp13_ = self->row;
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_row);
#line 14007 "Photo.c"
					{
						gint _tmp14_ = 0;
						RawDeveloper* _tmp15_;
#line 1673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp15_ = raw_developer_as_array (&_tmp14_);
#line 14013 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							d_collection = _tmp15_;
#line 1673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							d_collection_length1 = _tmp14_;
#line 1673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 14025 "Photo.c"
								RawDeveloper d = 0;
#line 1673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								d = d_collection[d_it];
#line 14029 "Photo.c"
								{
									BackingPhotoID id = {0};
									PhotoRow* _tmp16_;
									BackingPhotoID* _tmp17_;
									gint _tmp17__length1;
									RawDeveloper _tmp18_;
									BackingPhotoID _tmp19_;
									BackingPhotoID _tmp20_;
									gint64 _tmp21_;
#line 1674 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_tmp16_ = self->row;
#line 1674 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_tmp17_ = _tmp16_->development_ids;
#line 1674 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_tmp17__length1 = _tmp16_->development_ids_length1;
#line 1674 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_tmp18_ = d;
#line 1674 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_tmp19_ = _tmp17_[_tmp18_];
#line 1674 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									id = _tmp19_;
#line 1675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_tmp20_ = id;
#line 1675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									_tmp21_ = _tmp20_.id;
#line 1675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
									if (_tmp21_ != BACKING_PHOTO_ID_INVALID) {
#line 14057 "Photo.c"
										BackingPhotoRow* bpr = NULL;
										BackingPhotoID _tmp22_;
										BackingPhotoRow* _tmp23_;
										BackingPhotoRow* _tmp24_;
#line 1676 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
										_tmp22_ = id;
#line 1676 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
										_tmp23_ = photo_get_backing_row (self, &_tmp22_);
#line 1676 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
										bpr = _tmp23_;
#line 1677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
										_tmp24_ = bpr;
#line 1677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
										if (_tmp24_ != NULL) {
#line 14072 "Photo.c"
											GeeHashMap* _tmp25_;
											RawDeveloper _tmp26_;
											BackingPhotoRow* _tmp27_;
#line 1678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
											_tmp25_ = self->priv->developments;
#line 1678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
											_tmp26_ = d;
#line 1678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
											_tmp27_ = bpr;
#line 1678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
											gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), (gpointer) ((gintptr) _tmp26_), _tmp27_);
#line 14084 "Photo.c"
										}
#line 1675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 14088 "Photo.c"
									}
								}
							}
#line 1673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 14094 "Photo.c"
						}
					}
					__finally331:
					{
						PhotoRow* _tmp28_;
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp28_ = self->row;
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14104 "Photo.c"
					}
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							g_propagate_error (error, _inner_error0_);
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							return;
#line 14120 "Photo.c"
						} else {
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							g_clear_error (&_inner_error0_);
#line 1671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							return;
#line 14134 "Photo.c"
						}
					}
				}
			}
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 14141 "Photo.c"
		}
#line 1667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 14145 "Photo.c"
	}
#line 1685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	list = _tmp29_;
#line 1686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_ = reimport_state;
#line 1686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = _tmp30_->metadata_only;
#line 1686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp31_) {
#line 14157 "Photo.c"
		const gchar* _tmp32_;
		gchar* _tmp33_;
#line 1687 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = list;
#line 1687 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp33_ = g_strconcat (_tmp32_, "image:editable,image:baseline", NULL);
#line 1687 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (list);
#line 1687 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		list = _tmp33_;
#line 14168 "Photo.c"
	}
#line 1689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp34_ = list;
#line 1689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp35_ = alteration_new_from_list (_tmp34_);
#line 1689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 1689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp36_);
#line 1689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_alteration_unref0 (_tmp36_);
#line 1691 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (list);
#line 1661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 14186 "Photo.c"
}


static gchar*
photo_real_get_typename (DataSource* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1694 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 1695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 14204 "Photo.c"
}


static gint64
photo_real_get_instance_id (DataSource* base)
{
	Photo * self;
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_;
#line 1698 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp1_;
#line 1699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 14225 "Photo.c"
}


static gchar*
photo_real_get_source_id (DataSource* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1702 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1706 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = data_source_get_typename (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource));
#line 1706 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1706 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, data_source_get_instance_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource)));
#line 1706 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1706 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1706 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 1706 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 14254 "Photo.c"
}


void
photo_set_master_timestamp (Photo* self,
                            GFileInfo* info)
{
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 1710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 1711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	modification = _tmp0_;
#line 14273 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 14281 "Photo.c"
			{
				PhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
				time_t _tmp4_;
				GTimeVal _tmp5_;
				glong _tmp6_;
				PhotoTable* _tmp8_;
				PhotoTable* _tmp9_;
				PhotoRow* _tmp10_;
				PhotoID _tmp11_;
				GTimeVal _tmp12_;
				glong _tmp13_;
				PhotoRow* _tmp14_;
				BackingPhotoRow* _tmp15_;
				GTimeVal _tmp16_;
				glong _tmp17_;
#line 1715 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = self->row;
#line 1715 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = _tmp2_->master;
#line 1715 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_->timestamp;
#line 1715 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = modification;
#line 1715 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = _tmp5_.tv_sec;
#line 1715 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp4_ == ((time_t) _tmp6_)) {
#line 14310 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						PhotoRow* _tmp7_;
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp7_ = self->row;
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14318 "Photo.c"
					}
#line 1716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 14322 "Photo.c"
				}
#line 1718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = self->row;
#line 1718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _tmp10_->photo_id;
#line 1718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = modification;
#line 1718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = _tmp12_.tv_sec;
#line 1718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_table_update_timestamp (_tmp9_, &_tmp11_, (time_t) _tmp13_, &_inner_error0_);
#line 1718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14342 "Photo.c"
					goto __finally333;
				}
#line 1719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = self->row;
#line 1719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = _tmp14_->master;
#line 1719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = modification;
#line 1719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = _tmp16_.tv_sec;
#line 1719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_->timestamp = (time_t) _tmp17_;
#line 14355 "Photo.c"
			}
			__finally333:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp18_;
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = self->row;
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14365 "Photo.c"
			}
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 14371 "Photo.c"
					goto __catch332_database_error;
				}
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 14380 "Photo.c"
			}
		}
	}
	goto __finally332;
	__catch332_database_error:
	{
		GError* err = NULL;
		GError* _tmp19_;
#line 1713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 1713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 1722 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = err;
#line 1722 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		app_window_database_error (_tmp19_);
#line 1724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 14401 "Photo.c"
	}
	__finally332:
#line 1713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 14412 "Photo.c"
	}
#line 1727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 14416 "Photo.c"
		Alteration* _tmp20_;
		Alteration* _tmp21_;
#line 1728 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1728 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1728 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp21_);
#line 1728 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp21_);
#line 14427 "Photo.c"
	} else {
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 1730 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = alteration_new ("metadata", "master-timestamp");
#line 1730 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1730 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp23_);
#line 1730 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 14439 "Photo.c"
	}
}


void
photo_update_editable_modification_time (Photo* self,
                                         GFileInfo* info,
                                         GError** error)
{
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	gboolean altered = FALSE;
	gboolean _tmp18_;
	GError* _inner_error0_ = NULL;
#line 1734 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1734 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 1735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	modification = _tmp0_;
#line 1737 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	altered = FALSE;
#line 14464 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = self->row;
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14471 "Photo.c"
		{
			gboolean _tmp2_ = FALSE;
			PhotoRow* _tmp3_;
#line 1739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 1739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp3_->editable_id)) {
#line 14479 "Photo.c"
				BackingPhotoRow* _tmp4_;
				time_t _tmp5_;
				GTimeVal _tmp6_;
				glong _tmp7_;
#line 1739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->priv->editable;
#line 1739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp4_->timestamp;
#line 1739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = modification;
#line 1739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp6_.tv_sec;
#line 1739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = _tmp5_ != ((time_t) _tmp7_);
#line 14494 "Photo.c"
			} else {
#line 1739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = FALSE;
#line 14498 "Photo.c"
			}
#line 1739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_) {
#line 14502 "Photo.c"
				BackingPhotoTable* _tmp8_;
				BackingPhotoTable* _tmp9_;
				PhotoRow* _tmp10_;
				BackingPhotoID _tmp11_;
				GTimeVal _tmp12_;
				glong _tmp13_;
				BackingPhotoRow* _tmp14_;
				GTimeVal _tmp15_;
				glong _tmp16_;
#line 1740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = backing_photo_table_get_instance ();
#line 1740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = self->row;
#line 1740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _tmp10_->editable_id;
#line 1740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = modification;
#line 1740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = _tmp12_.tv_sec;
#line 1740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp9_, &_tmp11_, (time_t) _tmp13_, &_inner_error0_);
#line 1740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1740 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14530 "Photo.c"
					goto __finally334;
				}
#line 1742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = self->priv->editable;
#line 1742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = modification;
#line 1742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = _tmp15_.tv_sec;
#line 1742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_->timestamp = (time_t) _tmp16_;
#line 1743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				altered = TRUE;
#line 14543 "Photo.c"
			}
		}
		__finally334:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp17_;
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp17_ = self->row;
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14554 "Photo.c"
		}
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 14564 "Photo.c"
			} else {
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 14572 "Photo.c"
			}
		}
	}
#line 1747 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = altered;
#line 1747 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp18_) {
#line 14580 "Photo.c"
		Alteration* _tmp19_;
		Alteration* _tmp20_;
#line 1748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 1748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp20_);
#line 1748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp20_);
#line 14591 "Photo.c"
	}
}


void
photo_update_many_editable_timestamps (GeeMap* map,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 1752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 1754 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 14605 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = gee_map_get_keys (map);
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_it = _tmp4_;
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 14629 "Photo.c"
			GeeIterator* _tmp5_;
			Photo* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Photo* _tmp8_;
			Photo* _tmp9_;
			gpointer _tmp10_;
			GFileInfo* _tmp11_;
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = _photo_it;
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 14644 "Photo.c"
			}
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo = (Photo*) _tmp7_;
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = photo;
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = photo;
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = gee_map_get (map, _tmp9_);
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = (GFileInfo*) _tmp10_;
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_update_editable_modification_time (_tmp8_, _tmp11_, &_inner_error0_);
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 14676 "Photo.c"
				} else {
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 14688 "Photo.c"
				}
			}
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 14693 "Photo.c"
		}
#line 1755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 14697 "Photo.c"
	}
#line 1757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 14709 "Photo.c"
		} else {
#line 1757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 14717 "Photo.c"
		}
	}
}


static PhotoFileFormat
photo_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	Photo * self;
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
#line 1760 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_file_format_can_write_image (photo_get_file_format (self))) {
#line 1761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = photo_get_file_format (self);
#line 14735 "Photo.c"
	} else {
#line 1762 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = photo_file_format_get_system_default_format ();
#line 14739 "Photo.c"
	}
#line 1761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 1761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 14745 "Photo.c"
}


static GdkPixbuf*
photo_real_create_thumbnail (ThumbnailSource* base,
                             gint scale,
                             GError** error)
{
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 1765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	scaling_for_best_fit (scale, TRUE, &_tmp1_);
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_source_get_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), &_tmp1_, &_inner_error0_);
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 14775 "Photo.c"
	}
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 1766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 14787 "Photo.c"
}


gboolean
photo_is_file_image (GFile* file)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1769 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1773 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_file_format_is_file_supported (file)) {
#line 1774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 14802 "Photo.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 1774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = g_file_get_basename (file);
#line 1774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = photo_is_extension_found (_tmp2_, PHOTO_IMAGE_EXTENSIONS, G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp2_);
#line 14814 "Photo.c"
	}
#line 1773 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 1773 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 14820 "Photo.c"
}


static gboolean
photo_is_extension_found (const gchar* basename,
                          gchar** extensions,
                          int extensions_length1)
{
	gboolean result = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 1777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	disassemble_filename (basename, &_tmp0_, &_tmp1_);
#line 1779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (name);
#line 1779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	name = _tmp0_;
#line 1779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (ext);
#line 1779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ext = _tmp1_;
#line 1780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = ext;
#line 1780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 1781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 1781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (ext);
#line 1781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (name);
#line 1781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 14861 "Photo.c"
	}
#line 1784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = ext;
#line 1784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
#line 1784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (ext);
#line 1784 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ext = _tmp4_;
#line 14871 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1787 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		extension_collection = extensions;
#line 1787 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		extension_collection_length1 = extensions_length1;
#line 1787 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		for (extension_it = 0; extension_it < extension_collection_length1; extension_it = extension_it + 1) {
#line 14883 "Photo.c"
			gchar* _tmp5_;
			gchar* extension = NULL;
#line 1787 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = g_strdup (extension_collection[extension_it]);
#line 1787 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			extension = _tmp5_;
#line 14890 "Photo.c"
			{
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = ext;
#line 1788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = extension;
#line 1788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 1789 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					result = TRUE;
#line 1789 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (extension);
#line 1789 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (ext);
#line 1789 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (name);
#line 1789 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return result;
#line 14910 "Photo.c"
				}
#line 1787 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (extension);
#line 14914 "Photo.c"
			}
		}
	}
#line 1792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = FALSE;
#line 1792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (ext);
#line 1792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (name);
#line 1792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 14926 "Photo.c"
}


gboolean
photo_is_duplicate (GFile* file,
                    const gchar* thumbnail_md5,
                    const gchar* full_md5,
                    PhotoFileFormat file_format)
{
	gboolean result = FALSE;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gboolean _tmp2_;
#line 1798 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_table_has_duplicate (_tmp1_, file, thumbnail_md5, full_md5, file_format);
#line 1801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp2_;
#line 1801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 14954 "Photo.c"
}


PhotoID*
photo_get_duplicate_ids (GFile* file,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         PhotoFileFormat file_format,
                         int* result_length1)
{
	PhotoID* result = NULL;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gint _tmp2_ = 0;
	PhotoID* _tmp3_;
	PhotoID* _tmp4_;
	gint _tmp4__length1;
	PhotoID* _tmp5_;
	gint _tmp5__length1;
#line 1807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo_table_get_duplicate_ids (_tmp1_, file, thumbnail_md5, full_md5, file_format, &_tmp2_);
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4__length1 = _tmp2_;
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (result_length1) {
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*result_length1 = _tmp5__length1;
#line 14996 "Photo.c"
	}
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp5_;
#line 1810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 15002 "Photo.c"
}


gint64
photo_get_photo_key (DataSource* source)
{
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_;
#line 1817 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0LL);
#line 1818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_PHOTO, Photo), &_tmp0_);
#line 1818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp1_;
#line 1818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 15022 "Photo.c"
}


static GFile*
photo_real_get_file (MediaSource* base)
{
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1836 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 1837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 15051 "Photo.c"
}


static void
_vala_array_add96 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1880 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1880 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1880 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15067 "Photo.c"
	}
#line 1880 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1880 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 15073 "Photo.c"
}


static void
_vala_array_add97 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15089 "Photo.c"
	}
#line 1885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 15095 "Photo.c"
}


static void
_vala_array_add98 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15111 "Photo.c"
	}
#line 1888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 15117 "Photo.c"
}


static void
_vala_array_add99 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15133 "Photo.c"
	}
#line 1891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 15139 "Photo.c"
}


void
photo_set_master_file (Photo* self,
                       GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	gboolean name_changed = FALSE;
	GFile* old_file = NULL;
	gboolean _tmp33_;
	GError* _inner_error0_ = NULL;
#line 1842 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1842 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 1843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	filepath = _tmp0_;
#line 1845 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	altered = FALSE;
#line 1846 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	is_baseline = FALSE;
#line 1847 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	is_source = FALSE;
#line 1848 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	name_changed = FALSE;
#line 1849 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old_file = NULL;
#line 15174 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 15182 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 15190 "Photo.c"
					{
						PhotoBackingReaders* _tmp3_;
						PhotoFileReader* _tmp4_;
						GFile* _tmp5_;
						GFile* _tmp6_;
#line 1853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp3_ = self->priv->readers;
#line 1853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp4_ = _tmp3_->master;
#line 1853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						old_file = _tmp5_;
#line 1854 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp6_ = old_file;
#line 1854 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (!g_file_equal (file, _tmp6_)) {
#line 15210 "Photo.c"
							PhotoTable* _tmp7_;
							PhotoTable* _tmp8_;
							PhotoID _tmp9_ = {0};
							const gchar* _tmp10_;
							PhotoRow* _tmp11_;
							BackingPhotoRow* _tmp12_;
							const gchar* _tmp13_;
							gchar* _tmp14_;
							gchar* _tmp15_;
							PhotoBackingReaders* _tmp16_;
							PhotoRow* _tmp17_;
							BackingPhotoRow* _tmp18_;
							PhotoFileFormat _tmp19_;
							const gchar* _tmp20_;
							PhotoFileReader* _tmp21_;
							gboolean _tmp22_ = FALSE;
							PhotoRow* _tmp23_;
							const gchar* _tmp24_;
#line 1855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp7_ = photo_table_get_instance ();
#line 1855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp8_ = _tmp7_;
#line 1855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							photo_get_photo_id (self, &_tmp9_);
#line 1855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp10_ = filepath;
#line 1855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							photo_table_set_filepath (_tmp8_, &_tmp9_, _tmp10_, &_inner_error0_);
#line 1855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_database_table_unref0 (_tmp8_);
#line 1855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15243 "Photo.c"
								goto __finally337;
							}
#line 1857 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp11_ = self->row;
#line 1857 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp12_ = _tmp11_->master;
#line 1857 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp13_ = filepath;
#line 1857 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp14_ = g_strdup (_tmp13_);
#line 1857 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_free0 (_tmp12_->filepath);
#line 1857 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp12_->filepath = _tmp14_;
#line 1858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp15_ = g_file_get_basename (file);
#line 1858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							self->priv->file_title = _tmp15_;
#line 1859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp16_ = self->priv->readers;
#line 1859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp17_ = self->row;
#line 1859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp18_ = _tmp17_->master;
#line 1859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp19_ = _tmp18_->file_format;
#line 1859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp20_ = filepath;
#line 1859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp21_ = photo_file_format_create_reader (_tmp19_, _tmp20_);
#line 1859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp16_->master);
#line 1859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp16_->master = _tmp21_;
#line 1861 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							altered = TRUE;
#line 1862 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							is_baseline = photo_is_master_baseline (self);
#line 1863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							is_source = photo_is_master_source (self);
#line 1864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp23_ = self->row;
#line 1864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp24_ = _tmp23_->title;
#line 1864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (is_string_empty (_tmp24_)) {
#line 15292 "Photo.c"
								GFile* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								gchar* _tmp29_;
#line 1865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp25_ = old_file;
#line 1865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp26_ = g_file_get_basename (_tmp25_);
#line 1865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp27_ = _tmp26_;
#line 1865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp28_ = g_file_get_basename (file);
#line 1865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp29_ = _tmp28_;
#line 1865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp22_ = g_strcmp0 (_tmp27_, _tmp29_) != 0;
#line 1865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_g_free0 (_tmp29_);
#line 1865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_g_free0 (_tmp27_);
#line 15314 "Photo.c"
							} else {
#line 1864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp22_ = FALSE;
#line 15318 "Photo.c"
							}
#line 1864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							name_changed = _tmp22_;
#line 15322 "Photo.c"
						}
					}
					__finally337:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp30_;
#line 1852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp30_ = self->priv->readers;
#line 1852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 15333 "Photo.c"
					}
#line 1852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15337 "Photo.c"
						goto __finally336;
					}
				}
			}
			__finally336:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp31_;
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp31_ = self->row;
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15350 "Photo.c"
			}
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 15356 "Photo.c"
					goto __catch335_database_error;
				}
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (filepath);
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 15369 "Photo.c"
			}
		}
	}
	goto __finally335;
	__catch335_database_error:
	{
		GError* err = NULL;
		GError* _tmp32_;
#line 1850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 1850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 1870 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = err;
#line 1870 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		app_window_database_error (_tmp32_);
#line 1850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 15388 "Photo.c"
	}
	__finally335:
#line 1850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (filepath);
#line 1850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 15403 "Photo.c"
	}
#line 1873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = altered;
#line 1873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp33_) {
#line 15409 "Photo.c"
		GFile* _tmp34_;
		gboolean _tmp35_;
		gchar** alteration_list = NULL;
		gchar** _tmp36_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp37_;
		gint _tmp37__length1;
		gchar* _tmp38_;
		gboolean _tmp39_;
		gboolean _tmp42_;
		gboolean _tmp45_;
		gchar** _tmp48_;
		gint _tmp48__length1;
		Alteration* _tmp49_;
		Alteration* _tmp50_;
#line 1874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34_ = old_file;
#line 1874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		media_source_notify_master_replaced (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp34_, file);
#line 1876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = is_baseline;
#line 1876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp35_) {
#line 1877 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 15436 "Photo.c"
		}
#line 1879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp36_ = g_new0 (gchar*, 0 + 1);
#line 1879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		alteration_list = _tmp36_;
#line 1879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1880 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp37_ = alteration_list;
#line 1880 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp37__length1 = alteration_list_length1;
#line 1880 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp38_ = g_strdup ("backing:master");
#line 1880 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_array_add96 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp38_);
#line 1884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp39_ = name_changed;
#line 1884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp39_) {
#line 15458 "Photo.c"
			gchar** _tmp40_;
			gint _tmp40__length1;
			gchar* _tmp41_;
#line 1885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp40_ = alteration_list;
#line 1885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp40__length1 = alteration_list_length1;
#line 1885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp41_ = g_strdup ("metadata:name");
#line 1885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add97 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp41_);
#line 15470 "Photo.c"
		}
#line 1887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp42_ = is_source;
#line 1887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp42_) {
#line 15476 "Photo.c"
			gchar** _tmp43_;
			gint _tmp43__length1;
			gchar* _tmp44_;
#line 1888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp43_ = alteration_list;
#line 1888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp43__length1 = alteration_list_length1;
#line 1888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp44_ = g_strdup ("backing:source");
#line 1888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add98 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp44_);
#line 15488 "Photo.c"
		}
#line 1890 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp45_ = is_baseline;
#line 1890 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp45_) {
#line 15494 "Photo.c"
			gchar** _tmp46_;
			gint _tmp46__length1;
			gchar* _tmp47_;
#line 1891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp46_ = alteration_list;
#line 1891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp46__length1 = alteration_list_length1;
#line 1891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp47_ = g_strdup ("backing:baseline");
#line 1891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add99 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp47_);
#line 15506 "Photo.c"
		}
#line 1893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp48_ = alteration_list;
#line 1893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp48__length1 = alteration_list_length1;
#line 1893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp49_ = alteration_new_from_array (_tmp48_, _tmp48__length1);
#line 1893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp50_ = _tmp49_;
#line 1893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp50_);
#line 1893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp50_);
#line 1873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 15522 "Photo.c"
	}
#line 1842 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1842 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (filepath);
#line 15528 "Photo.c"
}


static void
_vala_array_add100 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1933 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1933 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1933 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15544 "Photo.c"
	}
#line 1933 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1933 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 15550 "Photo.c"
}


static void
_vala_array_add101 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15566 "Photo.c"
	}
#line 1936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 15572 "Photo.c"
}


static void
_vala_array_add102 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 1939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 15588 "Photo.c"
	}
#line 1939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 15594 "Photo.c"
}


void
photo_set_editable_file (Photo* self,
                         GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	GFile* old_file = NULL;
	gboolean _tmp29_;
	GError* _inner_error0_ = NULL;
#line 1899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 1900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	filepath = _tmp0_;
#line 1902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	altered = FALSE;
#line 1903 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	is_baseline = FALSE;
#line 1904 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	is_source = FALSE;
#line 1905 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old_file = NULL;
#line 15626 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 15634 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 15642 "Photo.c"
					{
						GFile* _tmp3_ = NULL;
						PhotoBackingReaders* _tmp4_;
						PhotoFileReader* _tmp5_;
						GFile* _tmp9_;
						gboolean _tmp10_ = FALSE;
						GFile* _tmp11_;
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp5_ = _tmp4_->editable;
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp5_ != NULL) {
#line 15656 "Photo.c"
							PhotoBackingReaders* _tmp6_;
							PhotoFileReader* _tmp7_;
							GFile* _tmp8_;
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp6_ = self->priv->readers;
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp7_ = _tmp6_->editable;
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp8_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp3_ = _tmp8_;
#line 15670 "Photo.c"
						} else {
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp3_ = NULL;
#line 15676 "Photo.c"
						}
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp9_ = _g_object_ref0 (_tmp3_);
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						old_file = _tmp9_;
#line 1910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp11_ = old_file;
#line 1910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp11_ != NULL) {
#line 15688 "Photo.c"
							GFile* _tmp12_;
#line 1910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp12_ = old_file;
#line 1910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp10_ = !g_file_equal (_tmp12_, file);
#line 15694 "Photo.c"
						} else {
#line 1910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp10_ = FALSE;
#line 15698 "Photo.c"
						}
#line 1910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp10_) {
#line 15702 "Photo.c"
							BackingPhotoTable* _tmp13_;
							BackingPhotoTable* _tmp14_;
							PhotoRow* _tmp15_;
							BackingPhotoID _tmp16_;
							const gchar* _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							gchar* _tmp20_;
							PhotoBackingReaders* _tmp21_;
							BackingPhotoRow* _tmp22_;
							PhotoFileFormat _tmp23_;
							const gchar* _tmp24_;
							PhotoFileReader* _tmp25_;
#line 1911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp13_ = backing_photo_table_get_instance ();
#line 1911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp14_ = _tmp13_;
#line 1911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp15_ = self->row;
#line 1911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp16_ = _tmp15_->editable_id;
#line 1911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp17_ = filepath;
#line 1911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							backing_photo_table_set_filepath (_tmp14_, &_tmp16_, _tmp17_, &_inner_error0_);
#line 1911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_database_table_unref0 (_tmp14_);
#line 1911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_g_object_unref0 (_tmp3_);
#line 15734 "Photo.c"
								goto __finally340;
							}
#line 1913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp18_ = self->priv->editable;
#line 1913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp19_ = filepath;
#line 1913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp20_ = g_strdup (_tmp19_);
#line 1913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_free0 (_tmp18_->filepath);
#line 1913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp18_->filepath = _tmp20_;
#line 1914 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp21_ = self->priv->readers;
#line 1914 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp22_ = self->priv->editable;
#line 1914 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp23_ = _tmp22_->file_format;
#line 1914 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp24_ = filepath;
#line 1914 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp25_ = photo_file_format_create_reader (_tmp23_, _tmp24_);
#line 1914 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp21_->editable);
#line 1914 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp21_->editable = _tmp25_;
#line 1916 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							altered = TRUE;
#line 1917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							is_baseline = photo_is_editable_baseline (self);
#line 1918 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							is_source = photo_is_editable_source (self);
#line 15767 "Photo.c"
						}
#line 1908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (_tmp3_);
#line 15771 "Photo.c"
					}
					__finally340:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp26_;
#line 1908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp26_ = self->priv->readers;
#line 1908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 15781 "Photo.c"
					}
#line 1908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15785 "Photo.c"
						goto __finally339;
					}
				}
			}
			__finally339:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp27_;
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp27_ = self->row;
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15798 "Photo.c"
			}
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 15804 "Photo.c"
					goto __catch338_database_error;
				}
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (filepath);
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 15817 "Photo.c"
			}
		}
	}
	goto __finally338;
	__catch338_database_error:
	{
		GError* err = NULL;
		GError* _tmp28_;
#line 1906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 1906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 1923 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp28_ = err;
#line 1923 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		app_window_database_error (_tmp28_);
#line 1906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 15836 "Photo.c"
	}
	__finally338:
#line 1906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (filepath);
#line 1906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 15851 "Photo.c"
	}
#line 1926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = altered;
#line 1926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp29_) {
#line 15857 "Photo.c"
		GFile* _tmp30_;
		gboolean _tmp31_;
		gchar** alteration_list = NULL;
		gchar** _tmp32_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		gchar* _tmp34_;
		gboolean _tmp35_;
		gboolean _tmp38_;
		gchar** _tmp41_;
		gint _tmp41__length1;
		Alteration* _tmp42_;
		Alteration* _tmp43_;
#line 1927 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp30_ = old_file;
#line 1927 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp30_, file);
#line 1929 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp31_ = is_baseline;
#line 1929 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp31_) {
#line 1930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 15883 "Photo.c"
		}
#line 1932 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = g_new0 (gchar*, 0 + 1);
#line 1932 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		alteration_list = _tmp32_;
#line 1932 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1932 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1933 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp33_ = alteration_list;
#line 1933 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp33__length1 = alteration_list_length1;
#line 1933 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34_ = g_strdup ("backing:editable");
#line 1933 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_array_add100 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp34_);
#line 1935 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = is_baseline;
#line 1935 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp35_) {
#line 15905 "Photo.c"
			gchar** _tmp36_;
			gint _tmp36__length1;
			gchar* _tmp37_;
#line 1936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36_ = alteration_list;
#line 1936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36__length1 = alteration_list_length1;
#line 1936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp37_ = g_strdup ("backing:baseline");
#line 1936 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add101 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp37_);
#line 15917 "Photo.c"
		}
#line 1938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp38_ = is_source;
#line 1938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp38_) {
#line 15923 "Photo.c"
			gchar** _tmp39_;
			gint _tmp39__length1;
			gchar* _tmp40_;
#line 1939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp39_ = alteration_list;
#line 1939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp39__length1 = alteration_list_length1;
#line 1939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp40_ = g_strdup ("backing:source");
#line 1939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add102 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp40_);
#line 15935 "Photo.c"
		}
#line 1941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp41_ = alteration_list;
#line 1941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp41__length1 = alteration_list_length1;
#line 1941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp42_ = alteration_new_from_array (_tmp41_, _tmp41__length1);
#line 1941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp43_ = _tmp42_;
#line 1941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp43_);
#line 1941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp43_);
#line 1926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 15951 "Photo.c"
	}
#line 1899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (filepath);
#line 15957 "Photo.c"
}


void
photo_set_many_editable_file (GeeMap* map,
                              GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 1947 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 1949 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 1949 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map_iter = _tmp0_;
#line 1950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	while (TRUE) {
#line 15978 "Photo.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Photo* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFile* _tmp7_;
#line 1950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = map_iter;
#line 1950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 1950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 15992 "Photo.c"
		}
#line 1951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = map_iter;
#line 1951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 1951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = (Photo*) _tmp3_;
#line 1951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = map_iter;
#line 1951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 1951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = (GFile*) _tmp6_;
#line 1951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_set_editable_file (_tmp4_, _tmp7_);
#line 1951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 1951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 16012 "Photo.c"
	}
#line 1953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 16026 "Photo.c"
		} else {
#line 1953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 16036 "Photo.c"
		}
	}
#line 1946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 16041 "Photo.c"
}


GFile*
photo_get_actual_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 1959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 16069 "Photo.c"
}


static GFile*
photo_real_get_master_file (MediaSource* base)
{
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1962 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 1963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 1963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 16098 "Photo.c"
}


GFile*
photo_get_editable_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
#line 1966 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	reader = _tmp0_;
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = reader;
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 16120 "Photo.c"
		PhotoFileReader* _tmp3_;
		GFile* _tmp4_;
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = reader;
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 16131 "Photo.c"
	} else {
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 16137 "Photo.c"
	}
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp1_;
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 16145 "Photo.c"
}


GeeCollection*
photo_get_raw_developer_files (Photo* self)
{
	GeeCollection* result = NULL;
	GeeArrayList* ret = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1972 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1973 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1974 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = NULL;
#line 1974 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 16164 "Photo.c"
	}
#line 1976 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1976 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ret = _tmp0_;
#line 16170 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = self->row;
#line 1977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16177 "Photo.c"
		{
			{
				GeeIterator* _row_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = self->priv->developments;
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp5_);
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_row_it = _tmp7_;
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				while (TRUE) {
#line 16205 "Photo.c"
					GeeIterator* _tmp8_;
					BackingPhotoRow* row = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					GeeArrayList* _tmp11_;
					BackingPhotoRow* _tmp12_;
					const gchar* _tmp13_;
					GFile* _tmp14_;
					GFile* _tmp15_;
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_ = _row_it;
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (!gee_iterator_next (_tmp8_)) {
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						break;
#line 16221 "Photo.c"
					}
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp9_ = _row_it;
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = gee_iterator_get (_tmp9_);
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					row = (BackingPhotoRow*) _tmp10_;
#line 1979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_ = ret;
#line 1979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = row;
#line 1979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp13_ = _tmp12_->filepath;
#line 1979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp14_ = g_file_new_for_path (_tmp13_);
#line 1979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 1979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp15_);
#line 1979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp15_);
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 16245 "Photo.c"
				}
#line 1978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 16249 "Photo.c"
			}
		}
		__finally341:
		{
			PhotoRow* _tmp16_;
#line 1977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp16_ = self->row;
#line 1977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16259 "Photo.c"
		}
#line 1977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (ret);
#line 1977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 16271 "Photo.c"
		}
	}
#line 1982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (ret, GEE_TYPE_COLLECTION, GeeCollection);
#line 1982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 16278 "Photo.c"
}


GFile*
photo_get_source_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 1986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 1986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 16306 "Photo.c"
}


PhotoFileFormat
photo_get_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	GError* _inner_error0_ = NULL;
#line 1989 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 16317 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 1990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16324 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			PhotoFileFormat _tmp2_;
#line 1991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->file_format;
#line 1991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_;
#line 16334 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 1990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16341 "Photo.c"
			}
#line 1991 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 16345 "Photo.c"
		}
		__finally342:
		{
			PhotoRow* _tmp4_;
#line 1990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 1990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16354 "Photo.c"
		}
#line 1990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return 0;
#line 16362 "Photo.c"
	}
}


PhotoFileFormat
photo_get_best_export_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	PhotoFileFormat file_format = 0;
	PhotoFileFormat _tmp0_;
#line 1995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file_format = photo_get_file_format (self);
#line 1997 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = file_format;
#line 1997 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_file_format_can_write (_tmp0_)) {
#line 1998 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		file_format = photo_file_format_get_system_default_format ();
#line 16383 "Photo.c"
	}
#line 2000 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = file_format;
#line 2000 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 16389 "Photo.c"
}


PhotoFileFormat
photo_get_master_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	GError* _inner_error0_ = NULL;
#line 2003 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 16400 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16407 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 2005 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 2005 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2005 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 16417 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16424 "Photo.c"
			}
#line 2005 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 16428 "Photo.c"
		}
		__finally343:
		{
			PhotoRow* _tmp4_;
#line 2004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16437 "Photo.c"
		}
#line 2004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return 0;
#line 16445 "Photo.c"
	}
}


static time_t
photo_real_get_timestamp (MediaSource* base)
{
	Photo * self;
	time_t result = 0;
	GError* _inner_error0_ = NULL;
#line 2009 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16458 "Photo.c"
	{
		PhotoRow* _tmp0_;
		time_t _tmp5_ = 0;
#line 2010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16466 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			time_t _tmp2_;
#line 2011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->timestamp;
#line 2011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_;
#line 16476 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16483 "Photo.c"
			}
#line 2011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 16487 "Photo.c"
		}
		__finally344:
		{
			PhotoRow* _tmp4_;
#line 2010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16496 "Photo.c"
		}
#line 2010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 16504 "Photo.c"
	}
}


void
photo_get_photo_id (Photo* self,
                    PhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 2015 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 16516 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16523 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoID _tmp2_;
#line 2017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 2017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*result = _tmp2_;
#line 16533 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16540 "Photo.c"
			}
#line 2017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 16544 "Photo.c"
		}
		__finally345:
		{
			PhotoRow* _tmp4_;
#line 2016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16553 "Photo.c"
		}
#line 2016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 16561 "Photo.c"
	}
}


static inline void
photo_real_get_event_id (MediaSource* base,
                         EventID* result)
{
	Photo * self;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
#line 2022 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 2023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 2023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	*result = _tmp1_;
#line 2023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 16583 "Photo.c"
}


inline gint64
photo_get_raw_event_id (Photo* self)
{
	gint64 result = 0LL;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
	gint64 _tmp2_;
#line 2027 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0LL);
#line 2028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->row;
#line 2028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 2028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 2028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp2_;
#line 2028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 16606 "Photo.c"
}


static void
photo_real_get_import_id (MediaSource* base,
                          ImportID* result)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2031 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16618 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16625 "Photo.c"
		{
			PhotoRow* _tmp1_;
			ImportID _tmp2_;
#line 2033 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2033 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 2033 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*result = _tmp2_;
#line 16635 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16642 "Photo.c"
			}
#line 2033 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 16646 "Photo.c"
		}
		__finally346:
		{
			PhotoRow* _tmp4_;
#line 2032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16655 "Photo.c"
		}
#line 2032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 16663 "Photo.c"
	}
}


void
photo_get_editable_id (Photo* self,
                       BackingPhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 2037 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 16675 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16682 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoID _tmp2_;
#line 2039 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2039 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 2039 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*result = _tmp2_;
#line 16692 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16699 "Photo.c"
			}
#line 2039 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 16703 "Photo.c"
		}
		__finally347:
		{
			PhotoRow* _tmp4_;
#line 2038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16712 "Photo.c"
		}
#line 2038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 16720 "Photo.c"
	}
}


static gchar*
photo_real_get_master_md5 (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 16733 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16740 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 2045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp3_;
#line 16753 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16760 "Photo.c"
			}
#line 2045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 16764 "Photo.c"
		}
		__finally348:
		{
			PhotoRow* _tmp5_;
#line 2044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16773 "Photo.c"
		}
#line 2044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 16781 "Photo.c"
	}
}


guint64
photo_get_flags (Photo* self)
{
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 16793 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16801 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
#line 2053 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2053 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2053 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_;
#line 16811 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16818 "Photo.c"
			}
#line 2053 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 16822 "Photo.c"
		}
		__finally349:
		{
			PhotoRow* _tmp4_;
#line 2052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16831 "Photo.c"
		}
#line 2052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 16839 "Photo.c"
	}
}


static void
photo_notify_flags_altered (Photo* self,
                            Alteration* additional_alteration)
{
	Alteration* alteration = NULL;
	Alteration* _tmp0_;
	Alteration* _tmp3_;
#line 2057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration));
#line 2058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 2058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	alteration = _tmp0_;
#line 2059 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (additional_alteration != NULL) {
#line 16861 "Photo.c"
		Alteration* _tmp1_;
		Alteration* _tmp2_;
#line 2060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = alteration;
#line 2060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = alteration_compress (_tmp1_, additional_alteration);
#line 2060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (alteration);
#line 2060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		alteration = _tmp2_;
#line 16872 "Photo.c"
	}
#line 2062 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = alteration;
#line 2062 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp3_);
#line 2057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_alteration_unref0 (alteration);
#line 16880 "Photo.c"
}


guint64
photo_replace_flags (Photo* self,
                     guint64 flags,
                     Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
#line 2065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 16897 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16904 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
			gboolean _tmp4_;
#line 2068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 2068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			committed = photo_table_replace_flags (_tmp2_, &_tmp3_, flags);
#line 2068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2069 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = committed;
#line 2069 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp4_) {
#line 16924 "Photo.c"
				PhotoRow* _tmp5_;
#line 2070 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = self->row;
#line 2070 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_->flags = flags;
#line 16930 "Photo.c"
			}
		}
		__finally350:
		{
			PhotoRow* _tmp6_;
#line 2067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 2067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16940 "Photo.c"
		}
#line 2067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16944 "Photo.c"
			guint64 _tmp7_ = 0ULL;
#line 2067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp7_;
#line 16952 "Photo.c"
		}
	}
#line 2073 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = committed;
#line 2073 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_) {
#line 2074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16961 "Photo.c"
	}
#line 2076 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = flags;
#line 2076 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 16967 "Photo.c"
}


gboolean
photo_is_flag_set (Photo* self,
                   guint64 mask)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2079 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 16979 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 2080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16987 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
#line 2081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = media_source_internal_is_flag_set (_tmp2_, mask);
#line 16997 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17004 "Photo.c"
			}
#line 2081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 17008 "Photo.c"
		}
		__finally351:
		{
			PhotoRow* _tmp4_;
#line 2080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17017 "Photo.c"
		}
#line 2080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 17025 "Photo.c"
	}
}


guint64
photo_add_flags (Photo* self,
                 guint64 mask,
                 Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError* _inner_error0_ = NULL;
#line 2085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2086 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	flags = (guint64) 0;
#line 2088 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	committed = FALSE;
#line 17048 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17055 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 2090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			flags = media_source_internal_add_flags (_tmp2_, mask);
#line 2091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 2091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = flags;
#line 2091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 17076 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 2092 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 2092 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 2092 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 2092 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = flags;
#line 2092 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 2092 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 2093 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = committed;
#line 2093 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp10_) {
#line 17098 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 2094 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_ = self->row;
#line 2094 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = flags;
#line 2094 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 17107 "Photo.c"
				}
			}
		}
		__finally352:
		{
			PhotoRow* _tmp13_;
#line 2089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = self->row;
#line 2089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17118 "Photo.c"
		}
#line 2089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17122 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 2089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp14_;
#line 17130 "Photo.c"
		}
	}
#line 2098 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = committed;
#line 2098 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp15_) {
#line 2099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17139 "Photo.c"
	}
#line 2101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = flags;
#line 2101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 17145 "Photo.c"
}


guint64
photo_remove_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError* _inner_error0_ = NULL;
#line 2104 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2104 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2105 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	flags = (guint64) 0;
#line 2107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	committed = FALSE;
#line 17167 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2108 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2108 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17174 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 2109 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2109 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2109 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			flags = media_source_internal_remove_flags (_tmp2_, mask);
#line 2110 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2110 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 2110 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = flags;
#line 2110 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 17195 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 2111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 2111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 2111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 2111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = flags;
#line 2111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 2111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 2112 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = committed;
#line 2112 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp10_) {
#line 17217 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 2113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_ = self->row;
#line 2113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = flags;
#line 2113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 17226 "Photo.c"
				}
			}
		}
		__finally353:
		{
			PhotoRow* _tmp13_;
#line 2108 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = self->row;
#line 2108 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17237 "Photo.c"
		}
#line 2108 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17241 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 2108 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2108 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2108 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp14_;
#line 17249 "Photo.c"
		}
	}
#line 2117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = committed;
#line 2117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp15_) {
#line 2118 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17258 "Photo.c"
	}
#line 2120 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = flags;
#line 2120 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 17264 "Photo.c"
}


guint64
photo_add_remove_flags (Photo* self,
                        guint64 add,
                        guint64 remove,
                        Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError* _inner_error0_ = NULL;
#line 2123 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2123 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2124 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	flags = (guint64) 0;
#line 2126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	committed = FALSE;
#line 17287 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17294 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 2128 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2128 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2128 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			flags = (_tmp2_ | add) & (~remove);
#line 2129 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2129 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 2129 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = flags;
#line 2129 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 17315 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 2130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 2130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 2130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 2130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = flags;
#line 2130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 2130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 2131 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = committed;
#line 2131 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp10_) {
#line 17337 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 2132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_ = self->row;
#line 2132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = flags;
#line 2132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 17346 "Photo.c"
				}
			}
		}
		__finally354:
		{
			PhotoRow* _tmp13_;
#line 2127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = self->row;
#line 2127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17357 "Photo.c"
		}
#line 2127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17361 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 2127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp14_;
#line 17369 "Photo.c"
		}
	}
#line 2136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = committed;
#line 2136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp15_) {
#line 2137 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17378 "Photo.c"
	}
#line 2139 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = flags;
#line 2139 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 17384 "Photo.c"
}


void
photo_add_remove_many_flags (GeeCollection* add,
                             guint64 add_mask,
                             Alteration* additional_add_alteration,
                             GeeCollection* remove,
                             guint64 remove_mask,
                             Alteration* additional_remove_alteration,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2142 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((add == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (add, GEE_TYPE_COLLECTION));
#line 2142 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((additional_add_alteration == NULL) || IS_ALTERATION (additional_add_alteration));
#line 2142 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((remove == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (remove, GEE_TYPE_COLLECTION));
#line 2142 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((additional_remove_alteration == NULL) || IS_ALTERATION (additional_remove_alteration));
#line 2145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 2147 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (add != NULL) {
#line 17410 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp0_;
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (add, GEE_TYPE_ITERABLE, GeeIterable));
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_it = _tmp0_;
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 17420 "Photo.c"
				GeeIterator* _tmp1_;
				Photo* photo = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Photo* _tmp4_;
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = _photo_it;
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 17432 "Photo.c"
				}
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = _photo_it;
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo = (Photo*) _tmp3_;
#line 2149 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = photo;
#line 2149 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_add_flags (_tmp4_, add_mask, additional_add_alteration);
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 17446 "Photo.c"
			}
#line 2148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 17450 "Photo.c"
		}
	}
#line 2152 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (remove != NULL) {
#line 17455 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp5_;
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (remove, GEE_TYPE_ITERABLE, GeeIterable));
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_it = _tmp5_;
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 17465 "Photo.c"
				GeeIterator* _tmp6_;
				Photo* photo = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Photo* _tmp9_;
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = _photo_it;
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 17477 "Photo.c"
				}
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _photo_it;
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo = (Photo*) _tmp8_;
#line 2154 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = photo;
#line 2154 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_remove_flags (_tmp9_, remove_mask, additional_remove_alteration);
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 17491 "Photo.c"
			}
#line 2153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 17495 "Photo.c"
		}
	}
#line 2157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 2157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 17508 "Photo.c"
		} else {
#line 2157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 17516 "Photo.c"
		}
	}
}


guint64
photo_toggle_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp15_;
	GError* _inner_error0_ = NULL;
#line 2160 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 2160 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 2161 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	flags = (guint64) 0;
#line 2163 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	committed = FALSE;
#line 17540 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2164 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2164 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17547 "Photo.c"
		{
			PhotoRow* _tmp1_;
			guint64 _tmp2_;
			PhotoRow* _tmp3_;
			guint64 _tmp4_;
			guint64 _tmp5_;
#line 2165 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2165 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2165 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			flags = _tmp2_ ^ mask;
#line 2166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->flags;
#line 2166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = flags;
#line 2166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp4_ != _tmp5_) {
#line 17568 "Photo.c"
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoID _tmp8_ = {0};
				guint64 _tmp9_;
				gboolean _tmp10_;
#line 2167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 2167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 2167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp8_);
#line 2167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = flags;
#line 2167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				committed = photo_table_replace_flags (_tmp7_, &_tmp8_, _tmp9_);
#line 2167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 2168 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = committed;
#line 2168 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp10_) {
#line 17590 "Photo.c"
					PhotoRow* _tmp11_;
					guint64 _tmp12_;
#line 2169 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_ = self->row;
#line 2169 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = flags;
#line 2169 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_->flags = _tmp12_;
#line 17599 "Photo.c"
				}
			}
		}
		__finally355:
		{
			PhotoRow* _tmp13_;
#line 2164 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = self->row;
#line 2164 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17610 "Photo.c"
		}
#line 2164 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17614 "Photo.c"
			guint64 _tmp14_ = 0ULL;
#line 2164 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2164 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2164 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp14_;
#line 17622 "Photo.c"
		}
	}
#line 2173 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = committed;
#line 2173 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp15_) {
#line 2174 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 17631 "Photo.c"
	}
#line 2176 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = flags;
#line 2176 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 17637 "Photo.c"
}


gboolean
photo_is_master_metadata_dirty (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2179 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 17648 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 2180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17656 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 2181 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2181 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2181 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_;
#line 17666 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17673 "Photo.c"
			}
#line 2181 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 17677 "Photo.c"
		}
		__finally356:
		{
			PhotoRow* _tmp4_;
#line 2180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17686 "Photo.c"
		}
#line 2180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 17694 "Photo.c"
	}
}


void
photo_set_master_metadata_dirty (Photo* self,
                                 gboolean dirty,
                                 GError** error)
{
	gboolean committed = FALSE;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
#line 2185 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	committed = FALSE;
#line 17711 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17718 "Photo.c"
		{
			PhotoRow* _tmp1_;
			gboolean _tmp2_;
#line 2188 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2188 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2188 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != dirty) {
#line 17728 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
				PhotoRow* _tmp6_;
#line 2189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp4_, &_tmp5_, dirty, &_inner_error0_);
#line 2189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17745 "Photo.c"
					goto __finally357;
				}
#line 2190 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 2190 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_->metadata_dirty = dirty;
#line 2191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				committed = TRUE;
#line 17754 "Photo.c"
			}
		}
		__finally357:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp7_;
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17765 "Photo.c"
		}
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 17775 "Photo.c"
			} else {
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 17783 "Photo.c"
			}
		}
	}
#line 2195 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = committed;
#line 2195 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_) {
#line 17791 "Photo.c"
		Alteration* _tmp9_;
		Alteration* _tmp10_;
#line 2196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = alteration_new ("metadata", "master-dirty");
#line 2196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp10_);
#line 2196 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp10_);
#line 17802 "Photo.c"
	}
}


static Rating
photo_real_get_rating (MediaSource* base)
{
	Photo * self;
	Rating result = 0;
	GError* _inner_error0_ = NULL;
#line 2199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17815 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17822 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
#line 2201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_;
#line 17832 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17839 "Photo.c"
			}
#line 2201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 17843 "Photo.c"
		}
		__finally358:
		{
			PhotoRow* _tmp4_;
#line 2200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17852 "Photo.c"
		}
#line 2200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return 0;
#line 17860 "Photo.c"
	}
}


static void
photo_real_set_rating (MediaSource* base,
                       Rating rating)
{
	Photo * self;
	gboolean committed = FALSE;
	gboolean _tmp10_;
	GError* _inner_error0_ = NULL;
#line 2205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2206 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	committed = FALSE;
#line 17877 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17884 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			Rating _tmp3_;
#line 2209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 2209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _tmp2_->rating;
#line 2209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (rating != _tmp3_) {
#line 2209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = rating_is_valid (rating);
#line 17897 "Photo.c"
			} else {
#line 2209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 17901 "Photo.c"
			}
#line 2209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp1_) {
#line 17905 "Photo.c"
				PhotoTable* _tmp4_;
				PhotoTable* _tmp5_;
				PhotoID _tmp6_ = {0};
				gboolean _tmp7_;
#line 2210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp6_);
#line 2210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				committed = photo_table_set_rating (_tmp5_, &_tmp6_, rating);
#line 2210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2211 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = committed;
#line 2211 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp7_) {
#line 17924 "Photo.c"
					PhotoRow* _tmp8_;
#line 2212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_ = self->row;
#line 2212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_->rating = rating;
#line 17930 "Photo.c"
				}
			}
		}
		__finally359:
		{
			PhotoRow* _tmp9_;
#line 2208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17941 "Photo.c"
		}
#line 2208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 17951 "Photo.c"
		}
	}
#line 2216 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = committed;
#line 2216 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp10_) {
#line 17958 "Photo.c"
		Alteration* _tmp11_;
		Alteration* _tmp12_;
#line 2217 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = alteration_new ("metadata", "rating");
#line 2217 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 2217 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp12_);
#line 2217 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp12_);
#line 17969 "Photo.c"
	}
}


static void
photo_real_increase_rating (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2220 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 17981 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2221 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2221 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17988 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
#line 2222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_increase (_tmp2_));
#line 17998 "Photo.c"
		}
		__finally360:
		{
			PhotoRow* _tmp3_;
#line 2221 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2221 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18007 "Photo.c"
		}
#line 2221 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2221 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2221 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2221 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 18017 "Photo.c"
		}
	}
}


static void
photo_real_decrease_rating (MediaSource* base)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18030 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2227 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2227 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18037 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Rating _tmp2_;
#line 2228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->rating;
#line 2228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_decrease (_tmp2_));
#line 18047 "Photo.c"
		}
		__finally361:
		{
			PhotoRow* _tmp3_;
#line 2227 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2227 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18056 "Photo.c"
		}
#line 2227 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2227 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2227 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2227 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 18066 "Photo.c"
		}
	}
}


static void
photo_real_commit_backlinks (DataSource* base,
                             SourceCollection* sources,
                             const gchar* backlinks)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2232 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2232 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 18083 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 2237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, backlinks, &_inner_error0_);
#line 2237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 18102 "Photo.c"
				goto __catch362_database_error;
			}
#line 2237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 18111 "Photo.c"
		}
		{
			PhotoRow* _tmp3_;
#line 2238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 18119 "Photo.c"
			{
				PhotoRow* _tmp4_;
				gchar* _tmp5_;
#line 2239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = g_strdup (backlinks);
#line 2239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp4_->backlinks);
#line 2239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_->backlinks = _tmp5_;
#line 18131 "Photo.c"
			}
			__finally363:
			{
				PhotoRow* _tmp6_;
#line 2238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 2238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18140 "Photo.c"
			}
#line 2238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 18146 "Photo.c"
					goto __catch362_database_error;
				}
#line 2238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 18155 "Photo.c"
			}
		}
	}
	goto __finally362;
	__catch362_database_error:
	{
		GError* err = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 2236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 2236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 2242 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2242 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2242 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = err;
#line 2242 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = _tmp9_->message;
#line 2242 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:2242: Unable to update link state for %s: %s", _tmp8_, _tmp10_);
#line 2242 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp8_);
#line 2236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 18185 "Photo.c"
	}
	__finally362:
#line 2236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 18196 "Photo.c"
	}
}


static gboolean
photo_real_set_event_id (MediaSource* base,
                         EventID* event_id)
{
	Photo * self;
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 18212 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp12_ = FALSE;
#line 2251 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2251 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18220 "Photo.c"
		{
			gboolean committed = FALSE;
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 2252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = *event_id;
#line 2252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			committed = _tmp6_;
#line 2254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = committed;
#line 2254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp7_) {
#line 18250 "Photo.c"
				PhotoRow* _tmp8_;
				EventID _tmp9_;
#line 2255 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2255 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = *event_id;
#line 2255 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_->event_id = _tmp9_;
#line 18259 "Photo.c"
			}
#line 2257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = committed;
#line 18263 "Photo.c"
			{
				PhotoRow* _tmp10_;
#line 2251 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = self->row;
#line 2251 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18270 "Photo.c"
			}
#line 2257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 18274 "Photo.c"
		}
		__finally364:
		{
			PhotoRow* _tmp11_;
#line 2251 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = self->row;
#line 2251 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18283 "Photo.c"
		}
#line 2251 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2251 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2251 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp12_;
#line 18291 "Photo.c"
	}
}


static gchar*
photo_real_to_string (DataObject* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	PhotoID _tmp9_ = {0};
	gint64 _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	PhotoFileReader* _tmp13_;
	PhotoFileReader* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
#line 2261 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_is_master_baseline (self)) {
#line 18316 "Photo.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = photo_get_actual_file (self);
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = g_strconcat (" (", _tmp4_, NULL);
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = g_strconcat (_tmp6_, ")", NULL);
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = _tmp7_;
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 18348 "Photo.c"
	} else {
		gchar* _tmp8_;
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = g_strdup ("");
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 18357 "Photo.c"
	}
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_photo_id (self, &_tmp9_);
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = _tmp9_.id;
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp10_);
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = photo_get_master_reader (self);
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = g_strdup_printf ("[%s] %s%s", _tmp12_, _tmp16_, _tmp0_);
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp16_);
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp14_);
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp12_);
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp18_;
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 18391 "Photo.c"
}


static gboolean
photo_real_equals (DataSource* base,
                   DataSource* source)
{
	Photo * self;
	gboolean result = FALSE;
	Photo* photo = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
#line 2266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 2268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_PHOTO (source) ? ((Photo*) source) : NULL);
#line 2268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = _tmp0_;
#line 2269 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo;
#line 2269 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 18416 "Photo.c"
		PhotoID photo_id = {0};
		PhotoID _tmp2_ = {0};
		PhotoID other_photo_id = {0};
		Photo* _tmp3_;
		PhotoID _tmp4_ = {0};
		gboolean _tmp5_ = FALSE;
		Photo* _tmp6_;
#line 2270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_id = _tmp2_;
#line 2271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = photo;
#line 2271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_get_photo_id (_tmp3_, &_tmp4_);
#line 2271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		other_photo_id = _tmp4_;
#line 2273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = photo;
#line 2273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (self != _tmp6_) {
#line 18438 "Photo.c"
			PhotoID _tmp7_;
			gint64 _tmp8_;
#line 2273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = photo_id;
#line 2273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = _tmp7_.id;
#line 2273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = _tmp8_ != PHOTO_ID_INVALID;
#line 18447 "Photo.c"
		} else {
#line 2273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = FALSE;
#line 18451 "Photo.c"
		}
#line 2273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp5_) {
#line 18455 "Photo.c"
			PhotoID _tmp9_;
			gint64 _tmp10_;
			PhotoID _tmp11_;
			gint64 _tmp12_;
#line 2274 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = photo_id;
#line 2274 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = _tmp9_.id;
#line 2274 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = other_photo_id;
#line 2274 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = _tmp11_.id;
#line 2274 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_assert (_tmp10_ != _tmp12_, "photo_id.id != other_photo_id.id");
#line 18470 "Photo.c"
		}
	}
#line 2278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = DATA_SOURCE_CLASS (photo_parent_class)->equals (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), TYPE_DATA_SOURCE, DataSource), source);
#line 2278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 2278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 18479 "Photo.c"
}


static void
photo_file_exif_updated (Photo* self)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFileInfo* info = NULL;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp7_;
	GTimeVal _tmp8_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	DetectedPhotoInformation* _tmp14_;
	gboolean _tmp15_ = FALSE;
	DetectedPhotoInformation* _tmp16_;
	gboolean success = FALSE;
	gboolean _tmp34_;
	GError* _inner_error0_ = NULL;
#line 2282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = _tmp0_;
#line 2285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	info = NULL;
#line 18509 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 2287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 2287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 2287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18520 "Photo.c"
			goto __catch365_g_error;
		}
#line 2287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 2287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 2287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		info = _tmp3_;
#line 2286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 18533 "Photo.c"
	}
	goto __finally365;
	__catch365_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 2286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 2286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 2290 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2290 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2290 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = err->message;
#line 2290 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_error ("Photo.vala:2290: Unable to read file information for %s: %s", _tmp5_, _tmp6_);
#line 2290 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 18558 "Photo.c"
	}
	__finally365:
#line 2286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 2286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 18573 "Photo.c"
	}
#line 2293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = info;
#line 2293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp7_, &_tmp8_);
#line 2293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	timestamp = _tmp8_;
#line 2296 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2296 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	interrogator = _tmp9_;
#line 18585 "Photo.c"
	{
#line 2298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 2298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18591 "Photo.c"
			goto __catch366_g_error;
		}
	}
	goto __finally366;
	__catch366_g_error:
	{
		GError* err = NULL;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 2297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 2297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 2300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = g_file_get_path (file);
#line 2300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 2300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = err;
#line 2300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = _tmp12_->message;
#line 2300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:2300: Unable to interrogate photo file %s: %s", _tmp11_, _tmp13_);
#line 2300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp11_);
#line 2297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 18621 "Photo.c"
	}
	__finally366:
#line 2297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 2297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 18638 "Photo.c"
	}
#line 2303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	detected = _tmp14_;
#line 2304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = detected;
#line 2304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 2304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = TRUE;
#line 18650 "Photo.c"
	} else {
#line 2304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = photo_file_interrogator_get_is_photo_corrupted (interrogator);
#line 18654 "Photo.c"
	}
#line 2304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp15_) {
#line 18658 "Photo.c"
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 2305 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2305 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 2305 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("Photo.vala:2305: file_exif_updated: %s no longer an image", _tmp18_);
#line 2305 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp18_);
#line 2307 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2307 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2307 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 2307 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 2307 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 18679 "Photo.c"
	}
	{
		PhotoRow* _tmp19_;
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = self->row;
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18687 "Photo.c"
		{
			PhotoTable* _tmp20_;
			PhotoTable* _tmp21_;
			PhotoID _tmp22_ = {0};
			GFileInfo* _tmp23_;
			GTimeVal _tmp24_;
			glong _tmp25_;
			DetectedPhotoInformation* _tmp26_;
			const gchar* _tmp27_;
			DetectedPhotoInformation* _tmp28_;
			const gchar* _tmp29_;
			DetectedPhotoInformation* _tmp30_;
			const gchar* _tmp31_;
			PhotoRow* _tmp32_;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp20_ = photo_table_get_instance ();
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp21_ = _tmp20_;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_get_photo_id (self, &_tmp22_);
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp23_ = info;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp24_ = timestamp;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp25_ = _tmp24_.tv_sec;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp26_ = detected;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp27_ = _tmp26_->md5;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp28_ = detected;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp29_ = _tmp28_->exif_md5;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp30_ = detected;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp31_ = _tmp30_->thumbnail_md5;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp32_ = self->row;
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			success = photo_table_master_exif_updated (_tmp21_, &_tmp22_, g_file_info_get_size (_tmp23_), _tmp25_, _tmp27_, _tmp29_, _tmp31_, _tmp32_);
#line 2312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp21_);
#line 18732 "Photo.c"
		}
		__finally367:
		{
			PhotoRow* _tmp33_;
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp33_ = self->row;
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18741 "Photo.c"
		}
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 18759 "Photo.c"
		}
	}
#line 2316 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp34_ = success;
#line 2316 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp34_) {
#line 18766 "Photo.c"
		Alteration* _tmp35_;
		Alteration* _tmp36_;
#line 2317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 2317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp36_);
#line 2317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp36_);
#line 18777 "Photo.c"
	}
#line 2282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 2282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 18787 "Photo.c"
}


static guint64
photo_real_get_filesize (MediaSource* base)
{
	Photo * self;
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2322 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18799 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18807 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			gint64 _tmp2_;
#line 2324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 18817 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18824 "Photo.c"
			}
#line 2324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 18828 "Photo.c"
		}
		__finally368:
		{
			PhotoRow* _tmp4_;
#line 2323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18837 "Photo.c"
		}
#line 2323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 18845 "Photo.c"
	}
}


static guint64
photo_real_get_master_filesize (MediaSource* base)
{
	Photo * self;
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2328 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18858 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp6_ = 0ULL;
#line 2329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18866 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			gint64 _tmp3_;
#line 2330 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2330 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2330 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _tmp2_->filesize;
#line 2330 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = (guint64) _tmp3_;
#line 18879 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18886 "Photo.c"
			}
#line 2330 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 18890 "Photo.c"
		}
		__finally369:
		{
			PhotoRow* _tmp5_;
#line 2329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18899 "Photo.c"
		}
#line 2329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp6_;
#line 18907 "Photo.c"
	}
}


guint64
photo_get_editable_filesize (Photo* self)
{
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 18919 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18927 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			gint64 _tmp2_;
#line 2336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 18937 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18944 "Photo.c"
			}
#line 2336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 18948 "Photo.c"
		}
		__finally370:
		{
			PhotoRow* _tmp4_;
#line 2335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18957 "Photo.c"
		}
#line 2335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 18965 "Photo.c"
	}
}


static time_t
photo_real_get_exposure_time (Dateable* base)
{
	Photo * self;
	time_t result = 0;
	time_t _tmp0_;
#line 2340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2341 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->cached_exposure_time;
#line 2341 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 2341 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 18984 "Photo.c"
}


static gchar*
photo_real_get_basename (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2344 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 18996 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19003 "Photo.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 2346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_;
#line 19013 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19020 "Photo.c"
			}
#line 2346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 19024 "Photo.c"
		}
		__finally371:
		{
			PhotoRow* _tmp4_;
#line 2345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19033 "Photo.c"
		}
#line 2345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 19041 "Photo.c"
	}
}


static gchar*
photo_real_get_title (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 19054 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19061 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp3_;
#line 19074 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19081 "Photo.c"
			}
#line 2352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 19085 "Photo.c"
		}
		__finally372:
		{
			PhotoRow* _tmp5_;
#line 2351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19094 "Photo.c"
		}
#line 2351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 19102 "Photo.c"
	}
}


static gchar*
photo_real_get_comment (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2356 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 19115 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19122 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2358 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2358 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->comment;
#line 2358 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2358 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp3_;
#line 19135 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19142 "Photo.c"
			}
#line 2358 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 19146 "Photo.c"
		}
		__finally373:
		{
			PhotoRow* _tmp5_;
#line 2357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19155 "Photo.c"
		}
#line 2357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 19163 "Photo.c"
	}
}


static void
photo_real_set_title (MediaSource* base,
                      const gchar* title)
{
	Photo * self;
	gchar* new_title = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	gboolean _tmp16_;
	GError* _inner_error0_ = NULL;
#line 2362 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2363 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_prep_title (title);
#line 2363 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	new_title = _tmp0_;
#line 2365 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	committed = FALSE;
#line 19186 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = self->row;
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19193 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
			gboolean _tmp11_;
#line 2367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = new_title;
#line 2367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->title;
#line 2367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 19212 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp5_ = self->row;
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19219 "Photo.c"
				}
#line 2368 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (new_title);
#line 2368 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 19225 "Photo.c"
			}
#line 2370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = self->row;
#line 2370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = new_title;
#line 2370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			committed = photo_table_set_title (_tmp7_, &_tmp9_, _tmp10_);
#line 2370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = committed;
#line 2371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp11_) {
#line 19245 "Photo.c"
				PhotoRow* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 2372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = self->row;
#line 2372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = new_title;
#line 2372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 2372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp12_->title);
#line 2372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_->title = _tmp14_;
#line 19259 "Photo.c"
			}
		}
		__finally374:
		{
			PhotoRow* _tmp15_;
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = self->row;
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19269 "Photo.c"
		}
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (new_title);
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2366 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 19281 "Photo.c"
		}
	}
#line 2375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = committed;
#line 2375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp16_) {
#line 19288 "Photo.c"
		Alteration* _tmp17_;
		Alteration* _tmp18_;
#line 2376 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = alteration_new ("metadata", "name");
#line 2376 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 2376 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp18_);
#line 2376 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp18_);
#line 19299 "Photo.c"
	}
#line 2362 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (new_title);
#line 19303 "Photo.c"
}


static void
photo_real_get_gps_coords (Positionable* base,
                           GpsCoords* result)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2379 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 19315 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19322 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GpsCoords _tmp2_;
#line 2381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->gps_coords;
#line 2381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*result = _tmp2_;
#line 19332 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19339 "Photo.c"
			}
#line 2381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 19343 "Photo.c"
		}
		__finally375:
		{
			PhotoRow* _tmp4_;
#line 2380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19352 "Photo.c"
		}
#line 2380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 19360 "Photo.c"
	}
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 2392 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 19370 "Photo.c"
}


static void
photo_real_set_gps_coords (Positionable* base,
                           GpsCoords* gps_coords)
{
	Photo * self;
	GError* dberr = NULL;
	GError* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2385 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2385 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (gps_coords != NULL);
#line 2386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dberr = NULL;
#line 19388 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19395 "Photo.c"
		{
			{
				PhotoTable* _tmp1_;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				GpsCoords _tmp5_;
				PhotoRow* _tmp7_;
				GpsCoords _tmp8_;
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = *gps_coords;
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_table_set_gps_coords (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 19423 "Photo.c"
						goto __catch377_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp6_ = self->row;
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19432 "Photo.c"
					}
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_error_free0 (dberr);
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 2389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 19442 "Photo.c"
				}
#line 2390 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = self->row;
#line 2390 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = *gps_coords;
#line 2390 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_->gps_coords = _tmp8_;
#line 19450 "Photo.c"
			}
			goto __finally377;
			__catch377_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2388 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				err = _inner_error0_;
#line 2388 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_inner_error0_ = NULL;
#line 2392 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = err;
#line 2392 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2392 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2392 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				dberr = _tmp10_;
#line 2388 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (err);
#line 19472 "Photo.c"
			}
			__finally377:
#line 2388 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2388 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2388 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2388 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2388 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 19485 "Photo.c"
			}
		}
		__finally376:
		{
			PhotoRow* _tmp11_;
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = self->row;
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19495 "Photo.c"
		}
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_error_free0 (dberr);
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 19507 "Photo.c"
		}
	}
#line 2395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = dberr;
#line 2395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 19514 "Photo.c"
		Alteration* _tmp13_;
		Alteration* _tmp14_;
#line 2396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = alteration_new ("metadata", "gps");
#line 2396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp14_);
#line 2396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp14_);
#line 19525 "Photo.c"
	} else {
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 2398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = dberr;
#line 2398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = _tmp17_->message;
#line 2398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:2398: Unable to write gps coordinates for %s: %s", _tmp16_, _tmp18_);
#line 2398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp16_);
#line 19543 "Photo.c"
	}
#line 2385 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_error_free0 (dberr);
#line 19547 "Photo.c"
}


static gboolean
photo_real_set_comment (MediaSource* base,
                        const gchar* comment)
{
	Photo * self;
	gboolean result = FALSE;
	gchar* new_comment = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	gboolean _tmp17_;
	GError* _inner_error0_ = NULL;
#line 2402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_prep_comment (comment);
#line 2403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	new_comment = _tmp0_;
#line 2405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	committed = FALSE;
#line 19570 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = self->row;
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19577 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
			gboolean _tmp11_;
#line 2407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = new_comment;
#line 2407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->comment;
#line 2407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 2408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = TRUE;
#line 19598 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp5_ = self->row;
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19605 "Photo.c"
				}
#line 2408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (new_comment);
#line 2408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 19611 "Photo.c"
			}
#line 2410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = self->row;
#line 2410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = new_comment;
#line 2410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			committed = photo_table_set_comment (_tmp7_, &_tmp9_, _tmp10_);
#line 2410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2411 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = committed;
#line 2411 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp11_) {
#line 19631 "Photo.c"
				PhotoRow* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 2412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = self->row;
#line 2412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = new_comment;
#line 2412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 2412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp12_->comment);
#line 2412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_->comment = _tmp14_;
#line 19645 "Photo.c"
			}
		}
		__finally378:
		{
			PhotoRow* _tmp15_;
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = self->row;
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19655 "Photo.c"
		}
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19659 "Photo.c"
			gboolean _tmp16_ = FALSE;
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (new_comment);
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp16_;
#line 19669 "Photo.c"
		}
	}
#line 2415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = committed;
#line 2415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp17_) {
#line 19676 "Photo.c"
		Alteration* _tmp18_;
		Alteration* _tmp19_;
#line 2416 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = alteration_new ("metadata", "comment");
#line 2416 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2416 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp19_);
#line 2416 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp19_);
#line 19687 "Photo.c"
	}
#line 2418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = committed;
#line 2418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (new_comment);
#line 2418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 19695 "Photo.c"
}


void
photo_set_import_id (Photo* self,
                     ImportID* import_id)
{
	GError* dberr = NULL;
	GError* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dberr = NULL;
#line 19712 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19719 "Photo.c"
		{
			{
				PhotoTable* _tmp1_;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				ImportID _tmp5_;
				PhotoRow* _tmp7_;
				ImportID _tmp8_;
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = *import_id;
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 19747 "Photo.c"
						goto __catch380_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp6_ = self->row;
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19756 "Photo.c"
					}
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_error_free0 (dberr);
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 2425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 19766 "Photo.c"
				}
#line 2426 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = self->row;
#line 2426 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = *import_id;
#line 2426 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 19774 "Photo.c"
			}
			goto __finally380;
			__catch380_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				err = _inner_error0_;
#line 2424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_inner_error0_ = NULL;
#line 2428 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = err;
#line 2428 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2428 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2428 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				dberr = _tmp10_;
#line 2424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (err);
#line 19796 "Photo.c"
			}
			__finally380:
#line 2424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 19809 "Photo.c"
			}
		}
		__finally379:
		{
			PhotoRow* _tmp11_;
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = self->row;
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19819 "Photo.c"
		}
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_error_free0 (dberr);
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 19831 "Photo.c"
		}
	}
#line 2432 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = dberr;
#line 2432 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 19838 "Photo.c"
		Alteration* _tmp13_;
		Alteration* _tmp14_;
#line 2433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = alteration_new ("metadata", "import-id");
#line 2433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp14_);
#line 2433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp14_);
#line 19849 "Photo.c"
	} else {
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 2435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 2435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = dberr;
#line 2435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = _tmp17_->message;
#line 2435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:2435: Unable to write import ID for %s: %s", _tmp16_, _tmp18_);
#line 2435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp16_);
#line 19867 "Photo.c"
	}
#line 2421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_error_free0 (dberr);
#line 19871 "Photo.c"
}


void
photo_set_title_persistent (Photo* self,
                            const gchar* title,
                            GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2438 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2439 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2439 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	source = _tmp0_;
#line 2442 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = source;
#line 2442 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 19904 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = source;
#line 2443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:2443: No photo file writer available for %s", _tmp4_);
#line 2443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), title);
#line 2447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2447 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 19924 "Photo.c"
	}
#line 2450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = source;
#line 2450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	metadata = _tmp6_;
#line 2450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 19940 "Photo.c"
	}
#line 2451 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = metadata;
#line 2451 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_metadata_set_title (_tmp7_, title, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = source;
#line 2453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	writer = _tmp9_;
#line 2453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 19962 "Photo.c"
	}
#line 2454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = source;
#line 2454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_title");
#line 2454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 19974 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = writer;
#line 2456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = metadata;
#line 2456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19986 "Photo.c"
			goto __finally381;
		}
	}
	__finally381:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = source;
#line 2458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 20006 "Photo.c"
	}
#line 2455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2455 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 20020 "Photo.c"
	}
#line 2461 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), title);
#line 2463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2438 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2438 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2438 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 20032 "Photo.c"
}


void
photo_set_comment_persistent (Photo* self,
                              const gchar* comment,
                              GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2467 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2467 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	source = _tmp0_;
#line 2470 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = source;
#line 2470 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 20065 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2471 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = source;
#line 2471 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2471 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2471 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:2471: No photo file writer available for %s", _tmp4_);
#line 2471 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2473 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), comment);
#line 2475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 20085 "Photo.c"
	}
#line 2478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = source;
#line 2478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	metadata = _tmp6_;
#line 2478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2478 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 20101 "Photo.c"
	}
#line 2479 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = metadata;
#line 2479 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_metadata_set_comment (_tmp7_, comment, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = source;
#line 2481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	writer = _tmp9_;
#line 2481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 20123 "Photo.c"
	}
#line 2482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = source;
#line 2482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_comment");
#line 2482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 20135 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = writer;
#line 2484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = metadata;
#line 2484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20147 "Photo.c"
			goto __finally382;
		}
	}
	__finally382:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = source;
#line 2486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 20167 "Photo.c"
	}
#line 2483 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2483 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2483 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2483 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2483 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2483 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 20181 "Photo.c"
	}
#line 2489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), comment);
#line 2491 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 20193 "Photo.c"
}


static void
photo_real_set_exposure_time (Dateable* base,
                              time_t time)
{
	Photo * self;
	gboolean committed = FALSE;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
#line 2494 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 20207 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20214 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			gboolean _tmp5_;
#line 2497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			committed = photo_table_set_exposure_time (_tmp2_, &_tmp4_, time);
#line 2497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = committed;
#line 2498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp5_) {
#line 20237 "Photo.c"
				PhotoRow* _tmp6_;
#line 2499 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 2499 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_->exposure_time = time;
#line 2500 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->cached_exposure_time = time;
#line 20245 "Photo.c"
			}
		}
		__finally383:
		{
			PhotoRow* _tmp7_;
#line 2496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 2496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20255 "Photo.c"
		}
#line 2496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 20265 "Photo.c"
		}
	}
#line 2504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = committed;
#line 2504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_) {
#line 20272 "Photo.c"
		Alteration* _tmp9_;
		Alteration* _tmp10_;
#line 2505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = alteration_new ("metadata", "exposure-time");
#line 2505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp10_);
#line 2505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp10_);
#line 20283 "Photo.c"
	}
}


void
photo_set_exposure_time_persistent (Photo* self,
                                    time_t time,
                                    GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	MetadataDateTime* _tmp8_;
	MetadataDateTime* _tmp9_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp10_;
	PhotoFileMetadataWriter* _tmp11_;
	PhotoFileReader* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 2508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2509 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2509 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	source = _tmp0_;
#line 2512 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = source;
#line 2512 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 20319 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = source;
#line 2513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:2513: No photo file writer available for %s", _tmp4_);
#line 2513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dateable_set_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATEABLE, Dateable), time);
#line 2517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 20339 "Photo.c"
	}
#line 2520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = source;
#line 2520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	metadata = _tmp6_;
#line 2520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 20355 "Photo.c"
	}
#line 2521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = metadata;
#line 2521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = metadata_date_time_new (time);
#line 2521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp7_, _tmp9_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_metadata_date_time_unref0 (_tmp9_);
#line 2523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = source;
#line 2523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = photo_file_reader_create_metadata_writer (_tmp10_, &_inner_error0_);
#line 2523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	writer = _tmp11_;
#line 2523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 20383 "Photo.c"
	}
#line 2524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = source;
#line 2524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 2524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp14_, "Photo.set_exposure_time_persistent");
#line 2524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp14_);
#line 20395 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp15_;
		PhotoMetadata* _tmp16_;
#line 2526 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = writer;
#line 2526 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = metadata;
#line 2526 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp15_, _tmp16_, &_inner_error0_);
#line 2526 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20407 "Photo.c"
			goto __finally384;
		}
	}
	__finally384:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
#line 2528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = source;
#line 2528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 2528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp19_);
#line 2528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp19_);
#line 20427 "Photo.c"
	}
#line 2525 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2525 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2525 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2525 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2525 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2525 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 20441 "Photo.c"
	}
#line 2531 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dateable_set_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATEABLE, Dateable), time);
#line 2533 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 20453 "Photo.c"
}


/**
     * @brief Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void
photo_real_get_dimensions (MediaSource* base,
                           PhotoException disallowed_steps,
                           Dimensions* result)
{
	Photo * self;
	Dimensions returned_dims = {0};
	Dimensions _tmp0_ = {0};
#line 2549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 2551 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2551 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	returned_dims = _tmp0_;
#line 2554 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_ORIENTATION)) {
#line 20486 "Photo.c"
		Orientation ori_tmp = 0;
		Orientation _tmp1_;
#line 2555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		ori_tmp = photo_get_orientation (self);
#line 2558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = ori_tmp;
#line 2558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		switch (_tmp1_) {
#line 2558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 20503 "Photo.c"
			{
				gint width_tmp = 0;
				Dimensions _tmp2_;
				gint _tmp3_;
				Dimensions _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 2564 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = returned_dims;
#line 2564 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = _tmp2_.width;
#line 2564 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				width_tmp = _tmp3_;
#line 2566 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = returned_dims;
#line 2566 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp4_.height;
#line 2566 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				returned_dims.width = _tmp5_;
#line 2567 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = width_tmp;
#line 2567 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				returned_dims.height = _tmp6_;
#line 2568 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 20529 "Photo.c"
			}
			default:
			{
#line 2572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 20535 "Photo.c"
			}
		}
	}
#line 2577 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 20541 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle = 0.0;
		gdouble _tmp7_ = 0.0;
		Dimensions _tmp8_;
		gint _tmp9_;
		Dimensions _tmp10_;
		gint _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_;
		gdouble _tmp16_;
#line 2579 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		angle = 0.0;
#line 2581 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_get_straighten (self, &_tmp7_);
#line 2581 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		angle = _tmp7_;
#line 2583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = returned_dims;
#line 2583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = _tmp8_.width;
#line 2583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = returned_dims;
#line 2583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = _tmp10_.height;
#line 2583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = angle;
#line 2583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp9_, (gdouble) _tmp11_, _tmp12_, &_tmp13_, &_tmp14_);
#line 2583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		x_size = _tmp13_;
#line 2583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		y_size = _tmp14_;
#line 2585 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = x_size;
#line 2585 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		returned_dims.width = (gint) _tmp15_;
#line 2586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = y_size;
#line 2586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		returned_dims.height = (gint) _tmp16_;
#line 20585 "Photo.c"
	}
#line 2590 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_CROP)) {
#line 20589 "Photo.c"
		Box crop = {0};
		Box _tmp17_ = {0};
		gboolean _tmp18_;
#line 2592 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = photo_get_crop (self, &_tmp17_, disallowed_steps);
#line 2592 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		crop = _tmp17_;
#line 2592 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp18_) {
#line 20599 "Photo.c"
			Dimensions _tmp19_ = {0};
#line 2593 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp19_);
#line 2593 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			returned_dims = _tmp19_;
#line 20605 "Photo.c"
		}
	}
#line 2596 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	*result = returned_dims;
#line 2596 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 20612 "Photo.c"
}


static void
photo_locked_create_adjustments_from_data (Photo* self)
{
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_;
#line 2600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2601 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2601 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2601 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2603 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map = _tmp1_;
#line 2604 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = map;
#line 2604 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 20641 "Photo.c"
		PixelTransformationBundle* _tmp3_;
#line 2605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 20647 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_;
		KeyValueMap* _tmp5_;
#line 2607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = map;
#line 2607 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 20657 "Photo.c"
	}
#line 2609 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2609 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2609 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2609 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 20669 "Photo.c"
}


PixelTransformationBundle*
photo_get_color_adjustments (Photo* self)
{
	PixelTransformationBundle* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2613 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 20680 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20687 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_;
			PixelTransformationBundle* _tmp2_;
			PixelTransformationBundle* _tmp3_;
#line 2615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 20698 "Photo.c"
			}
#line 2618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp3_;
#line 20706 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20713 "Photo.c"
			}
#line 2618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 20717 "Photo.c"
		}
		__finally385:
		{
			PhotoRow* _tmp5_;
#line 2614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20726 "Photo.c"
		}
#line 2614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 20734 "Photo.c"
	}
}


PixelTransformer*
photo_get_pixel_transformer (Photo* self)
{
	PixelTransformer* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 20746 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20753 "Photo.c"
		{
			PixelTransformer* _tmp1_;
			PixelTransformer* _tmp2_;
			PixelTransformer* _tmp3_;
#line 2624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2625 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 20764 "Photo.c"
			}
#line 2627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp3_;
#line 20772 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20779 "Photo.c"
			}
#line 2627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 20783 "Photo.c"
		}
		__finally386:
		{
			PhotoRow* _tmp5_;
#line 2623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20792 "Photo.c"
		}
#line 2623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 20800 "Photo.c"
	}
}


gboolean
photo_has_color_adjustments (Photo* self)
{
	gboolean result = FALSE;
#line 2631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2632 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_has_transformation (self, "adjustments");
#line 2632 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 20815 "Photo.c"
}


PixelTransformation*
photo_get_color_adjustment (Photo* self,
                            PixelTransformationType type)
{
	PixelTransformation* result = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	PixelTransformation* _tmp2_;
	PixelTransformation* _tmp3_;
#line 2635 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2636 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2636 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2636 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = pixel_transformation_bundle_get_transformation (_tmp1_, type);
#line 2636 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2636 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2636 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 2636 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 20844 "Photo.c"
}


void
photo_set_color_adjustments (Photo* self,
                             PixelTransformationBundle* new_adjustments)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp5_;
	gboolean committed = FALSE;
	gboolean _tmp28_;
	GError* _inner_error0_ = NULL;
#line 2639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_adjustments, TYPE_PIXEL_TRANSFORMATION_BUNDLE));
#line 2642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (pixel_transformation_bundle_is_identity (new_adjustments)) {
#line 20863 "Photo.c"
		gboolean _result_ = FALSE;
		gboolean _tmp2_;
		{
			PhotoRow* _tmp0_;
#line 2644 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp0_ = self->row;
#line 2644 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 20872 "Photo.c"
			{
#line 2645 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_result_ = photo_remove_transformation (self, "adjustments");
#line 2646 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2646 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->transformer = NULL;
#line 20884 "Photo.c"
			}
			__finally387:
			{
				PhotoRow* _tmp1_;
#line 2644 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = self->row;
#line 2644 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20893 "Photo.c"
			}
#line 2644 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2644 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2644 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2644 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 20903 "Photo.c"
			}
		}
#line 2650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _result_;
#line 2650 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp2_) {
#line 20910 "Photo.c"
			Alteration* _tmp3_;
			Alteration* _tmp4_;
#line 2651 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = alteration_new ("image", "color-adjustments");
#line 2651 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 2651 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp4_);
#line 2651 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_alteration_unref0 (_tmp4_);
#line 20921 "Photo.c"
		}
#line 2653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 20925 "Photo.c"
	}
#line 2657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = pixel_transformation_bundle_save (new_adjustments, "adjustments");
#line 2657 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map = _tmp5_;
#line 20931 "Photo.c"
	{
		PhotoRow* _tmp6_;
#line 2660 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = self->row;
#line 2660 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20938 "Photo.c"
		{
			gboolean _tmp7_ = FALSE;
			PixelTransformer* _tmp8_;
			KeyValueMap* _tmp26_;
#line 2661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = self->priv->transformer;
#line 2661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp8_ == NULL) {
#line 2661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = TRUE;
#line 20949 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp9_;
#line 2661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = self->priv->adjustments;
#line 2661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp9_ == NULL;
#line 20956 "Photo.c"
			}
#line 2661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp7_) {
#line 20960 "Photo.c"
				PixelTransformationBundle* _tmp10_;
				PixelTransformer* _tmp11_;
#line 2663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->adjustments = _tmp10_;
#line 2664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = pixel_transformation_bundle_generate_transformer (new_adjustments);
#line 2664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->transformer = _tmp11_;
#line 20975 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp25_;
				{
					GeeIterator* _transformation_it = NULL;
					GeeIterable* _tmp12_;
					GeeIterable* _tmp13_;
					GeeIterator* _tmp14_;
					GeeIterator* _tmp15_;
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = pixel_transformation_bundle_get_transformations (new_adjustments);
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp13_ = _tmp12_;
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp14_ = gee_iterable_iterator (_tmp13_);
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp13_);
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_transformation_it = _tmp15_;
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					while (TRUE) {
#line 20998 "Photo.c"
						GeeIterator* _tmp16_;
						PixelTransformation* transformation = NULL;
						GeeIterator* _tmp17_;
						gpointer _tmp18_;
						PixelTransformer* _tmp19_;
						PixelTransformationBundle* _tmp20_;
						PixelTransformation* _tmp21_;
						PixelTransformation* _tmp22_;
						PixelTransformation* _tmp23_;
						PixelTransformation* _tmp24_;
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp16_ = _transformation_it;
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (!gee_iterator_next (_tmp16_)) {
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							break;
#line 21015 "Photo.c"
						}
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp17_ = _transformation_it;
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp18_ = gee_iterator_get (_tmp17_);
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						transformation = (PixelTransformation*) _tmp18_;
#line 2668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp19_ = self->priv->transformer;
#line 2668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp20_ = self->priv->adjustments;
#line 2668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp21_ = transformation;
#line 2668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp22_ = pixel_transformation_bundle_get_transformation (_tmp20_, pixel_transformation_get_transformation_type (_tmp21_));
#line 2668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp23_ = _tmp22_;
#line 2668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp24_ = transformation;
#line 2668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp19_, _tmp23_, _tmp24_);
#line 2668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_pixel_transformation_unref0 (_tmp23_);
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 21041 "Photo.c"
					}
#line 2667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 21045 "Photo.c"
				}
#line 2673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2673 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->adjustments = _tmp25_;
#line 21053 "Photo.c"
			}
#line 2676 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp26_ = map;
#line 2676 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			committed = photo_set_transformation (self, _tmp26_);
#line 21059 "Photo.c"
		}
		__finally388:
		{
			PhotoRow* _tmp27_;
#line 2660 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp27_ = self->row;
#line 2660 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21068 "Photo.c"
		}
#line 2660 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2660 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2660 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2660 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2660 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 21080 "Photo.c"
		}
	}
#line 2679 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp28_ = committed;
#line 2679 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp28_) {
#line 21087 "Photo.c"
		Alteration* _tmp29_;
		Alteration* _tmp30_;
#line 2680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp29_ = alteration_new ("image", "color-adjustments");
#line 2680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp30_ = _tmp29_;
#line 2680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp30_);
#line 2680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp30_);
#line 21098 "Photo.c"
	}
#line 2639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 21102 "Photo.c"
}


static PhotoMetadata*
photo_real_get_metadata (PhotoSource* base)
{
	Photo * self;
	PhotoMetadata* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 21114 "Photo.c"
	{
		PhotoMetadata* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_;
		PhotoFileReader* _tmp2_;
		PhotoMetadata* _tmp3_;
		PhotoMetadata* _tmp4_;
		PhotoMetadata* _tmp5_;
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = photo_get_source_reader (self);
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21136 "Photo.c"
			goto __catch389_g_error;
		}
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp0_;
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = _tmp5_;
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (_tmp0_);
#line 2686 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 21149 "Photo.c"
	}
	goto __finally389;
	__catch389_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 2685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 2685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 2688 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = err;
#line 2688 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 2688 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:2688: Unable to load metadata: %s", _tmp7_);
#line 2690 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = NULL;
#line 2690 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 2690 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 21173 "Photo.c"
	}
	__finally389:
#line 2685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_clear_error (&_inner_error0_);
#line 2685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 21182 "Photo.c"
}


PhotoMetadata*
photo_get_master_metadata (Photo* self,
                           GError** error)
{
	PhotoMetadata* result = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	PhotoMetadata* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 2694 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_get_master_reader (self);
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _tmp4_;
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 21218 "Photo.c"
	}
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = _tmp0_;
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp5_;
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (_tmp0_);
#line 2695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 21230 "Photo.c"
}


PhotoMetadata*
photo_get_editable_metadata (Photo* self,
                             GError** error)
{
	PhotoMetadata* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 2698 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	reader = _tmp0_;
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = reader;
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 21254 "Photo.c"
		PhotoFileReader* _tmp3_;
		PhotoMetadata* _tmp4_;
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = reader;
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error0_);
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 21275 "Photo.c"
		}
	} else {
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 21282 "Photo.c"
	}
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp1_;
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 21290 "Photo.c"
}


gboolean
photo_persist_master_metadata (Photo* self,
                               PhotoMetadata* metadata,
                               PhotoReimportMasterState* * state,
                               GError** error)
{
	PhotoReimportMasterState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* master_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileMetadataWriter* _tmp2_ = NULL;
	PhotoFileReader* _tmp3_;
	PhotoFileMetadataWriter* _tmp4_;
	gboolean _tmp7_ = FALSE;
	PhotoReimportMasterState* _tmp8_ = NULL;
	gboolean _tmp9_;
	PhotoReimportMasterState* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 2707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_state = NULL;
#line 2711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	master_reader = _tmp0_;
#line 2713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = master_reader;
#line 2713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 2714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 2714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 2714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 21337 "Photo.c"
		} else {
#line 2714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 21341 "Photo.c"
		}
#line 2714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 21345 "Photo.c"
	}
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = master_reader;
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = photo_file_reader_create_metadata_writer (_tmp3_, &_inner_error0_);
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp4_;
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21355 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp5_;
#line 21363 "Photo.c"
	}
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp2_, metadata, &_inner_error0_);
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21369 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp6_;
#line 21379 "Photo.c"
	}
#line 2718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = photo_prepare_for_reimport_master (self, &_tmp8_, &_inner_error0_);
#line 2718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_state = _tmp8_;
#line 2718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = _tmp9_;
#line 2718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21391 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 2718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp10_;
#line 21401 "Photo.c"
	}
#line 2718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp7_) {
#line 2719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 2719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 2719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 21415 "Photo.c"
		} else {
#line 2719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 21419 "Photo.c"
		}
#line 2719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 21423 "Photo.c"
	}
#line 2721 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = _vala_state;
#line 2721 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl)->metadata_only = TRUE;
#line 2723 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 2723 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2723 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2723 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (state) {
#line 2723 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*state = _vala_state;
#line 21439 "Photo.c"
	} else {
#line 2723 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 21443 "Photo.c"
	}
#line 2723 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 21447 "Photo.c"
}


void
photo_finish_update_master_metadata (Photo* self,
                                     PhotoReimportMasterState* state,
                                     GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 2727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_finish_reimport_master (self, state, &_inner_error0_);
#line 2727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 21471 "Photo.c"
		} else {
#line 2727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 21479 "Photo.c"
		}
	}
}


gboolean
photo_persist_editable_metadata (Photo* self,
                                 PhotoMetadata* metadata,
                                 PhotoReimportEditableState* * state,
                                 GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* editable_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileMetadataWriter* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	gboolean _tmp8_ = FALSE;
	PhotoReimportEditableState* _tmp9_ = NULL;
	gboolean _tmp10_;
	PhotoReimportEditableState* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2730 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2730 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 2732 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2732 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_state = NULL;
#line 2734 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2734 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	editable_reader = _tmp0_;
#line 2735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2736 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 2736 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2736 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 2736 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 21529 "Photo.c"
		} else {
#line 2736 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 21533 "Photo.c"
		}
#line 2736 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 21537 "Photo.c"
	}
#line 2738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2738 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 2739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 2739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 2739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 21551 "Photo.c"
		} else {
#line 2739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 21555 "Photo.c"
		}
#line 2739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 21559 "Photo.c"
	}
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = editable_reader;
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = photo_file_reader_create_metadata_writer (_tmp4_, &_inner_error0_);
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp5_;
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21569 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp6_;
#line 21577 "Photo.c"
	}
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp3_, metadata, &_inner_error0_);
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21583 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp7_;
#line 21593 "Photo.c"
	}
#line 2743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = photo_prepare_for_reimport_editable (self, &_tmp9_, &_inner_error0_);
#line 2743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_state = _tmp9_;
#line 2743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = _tmp10_;
#line 2743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21605 "Photo.c"
		gboolean _tmp11_ = FALSE;
#line 2743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp11_;
#line 21615 "Photo.c"
	}
#line 2743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp8_) {
#line 2744 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 2744 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2744 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2744 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 2744 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 21629 "Photo.c"
		} else {
#line 2744 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 21633 "Photo.c"
		}
#line 2744 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 21637 "Photo.c"
	}
#line 2746 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = _vala_state;
#line 2746 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl)->metadata_only = TRUE;
#line 2748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 2748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 2748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (state) {
#line 2748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*state = _vala_state;
#line 21653 "Photo.c"
	} else {
#line 2748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 21657 "Photo.c"
	}
#line 2748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 21661 "Photo.c"
}


void
photo_finish_update_editable_metadata (Photo* self,
                                       PhotoReimportEditableState* state,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2751 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2751 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 2752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_finish_reimport_editable (self, state, &_inner_error0_);
#line 2752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 21685 "Photo.c"
		} else {
#line 2752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 21693 "Photo.c"
		}
	}
}


void
photo_get_raw_dimensions (Photo* self,
                          Dimensions* result)
{
	GError* _inner_error0_ = NULL;
#line 2757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 21706 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21713 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Dimensions _tmp2_;
#line 2759 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2759 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2759 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*result = _tmp2_;
#line 21723 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21730 "Photo.c"
			}
#line 2759 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 21734 "Photo.c"
		}
		__finally390:
		{
			PhotoRow* _tmp4_;
#line 2758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21743 "Photo.c"
		}
#line 2758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2758 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 21751 "Photo.c"
	}
}


gboolean
photo_has_transformations (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2763 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 21763 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp10_ = FALSE;
#line 2764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21771 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			Orientation _tmp3_;
			BackingPhotoRow* _tmp4_;
			Orientation _tmp5_;
#line 2765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 2765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _tmp2_->orientation;
#line 2765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->backing_photo_row;
#line 2765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = _tmp4_->original_orientation;
#line 2765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp3_ != _tmp5_) {
#line 2766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = TRUE;
#line 21790 "Photo.c"
			} else {
				PhotoRow* _tmp6_;
				GeeHashMap* _tmp7_;
#line 2767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 2767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp6_->transformations;
#line 2767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = _tmp7_ != NULL;
#line 21800 "Photo.c"
			}
#line 2765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp1_;
#line 21804 "Photo.c"
			{
				PhotoRow* _tmp8_;
#line 2764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = self->row;
#line 2764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21811 "Photo.c"
			}
#line 2765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 21815 "Photo.c"
		}
		__finally391:
		{
			PhotoRow* _tmp9_;
#line 2764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21824 "Photo.c"
		}
#line 2764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp10_;
#line 21832 "Photo.c"
	}
}


gboolean
photo_only_metadata_changed (Photo* self)
{
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 2771 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2772 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	date_time = NULL;
#line 2774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 2774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	metadata = _tmp0_;
#line 2775 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 2775 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 21858 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
#line 2776 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = metadata;
#line 2776 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2776 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2776 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		date_time = _tmp3_;
#line 21869 "Photo.c"
	}
	{
		PhotoRow* _tmp4_;
		gboolean _tmp20_ = FALSE;
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = self->row;
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21878 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
#line 2779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 2779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 21889 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_;
				Orientation _tmp10_;
				BackingPhotoRow* _tmp11_;
				Orientation _tmp12_;
#line 2780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = self->row;
#line 2780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _tmp9_->orientation;
#line 2780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = self->backing_photo_row;
#line 2780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = _tmp11_->original_orientation;
#line 2780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp10_ != _tmp12_) {
#line 2780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_ = TRUE;
#line 21907 "Photo.c"
				} else {
					gboolean _tmp13_ = FALSE;
					MetadataDateTime* _tmp14_;
#line 2781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp14_ = date_time;
#line 2781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_tmp14_ != NULL) {
#line 21915 "Photo.c"
						PhotoRow* _tmp15_;
						time_t _tmp16_;
						MetadataDateTime* _tmp17_;
#line 2781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp15_ = self->row;
#line 2781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp16_ = _tmp15_->exposure_time;
#line 2781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp17_ = date_time;
#line 2781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp13_ = _tmp16_ != metadata_date_time_get_timestamp (_tmp17_);
#line 21927 "Photo.c"
					} else {
#line 2781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp13_ = FALSE;
#line 21931 "Photo.c"
					}
#line 2781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_ = _tmp13_;
#line 21935 "Photo.c"
				}
#line 2780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 21939 "Photo.c"
			} else {
#line 2779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = FALSE;
#line 21943 "Photo.c"
			}
#line 2779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp5_;
#line 21947 "Photo.c"
			{
				PhotoRow* _tmp18_;
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = self->row;
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21954 "Photo.c"
			}
#line 2779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 21962 "Photo.c"
		}
		__finally392:
		{
			PhotoRow* _tmp19_;
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp19_ = self->row;
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21971 "Photo.c"
		}
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp20_;
#line 21983 "Photo.c"
	}
#line 2771 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2771 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 21989 "Photo.c"
}


gboolean
photo_has_alterations (Photo* self)
{
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	gchar* title = NULL;
	gchar* comment = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	MetadataDateTime* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 2785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	date_time = NULL;
#line 2787 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	title = NULL;
#line 2788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	comment = NULL;
#line 2790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 2790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	metadata = _tmp0_;
#line 2791 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 2791 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 22021 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
		PhotoMetadata* _tmp4_;
		gchar* _tmp5_;
		PhotoMetadata* _tmp6_;
		gchar* _tmp7_;
#line 2792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = metadata;
#line 2792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		date_time = _tmp3_;
#line 2793 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = metadata;
#line 2793 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 2793 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (title);
#line 2793 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		title = _tmp5_;
#line 2794 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = metadata;
#line 2794 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 2794 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (comment);
#line 2794 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		comment = _tmp7_;
#line 22052 "Photo.c"
	}
#line 2798 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = date_time;
#line 2798 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 22058 "Photo.c"
		{
			PhotoRow* _tmp9_;
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 22065 "Photo.c"
			{
				BackingPhotoRow* _tmp10_;
				time_t _tmp11_;
				PhotoRow* _tmp12_;
				time_t _tmp13_;
#line 2802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _tmp10_->timestamp;
#line 2802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = self->row;
#line 2802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = _tmp12_->exposure_time;
#line 2802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp11_ != _tmp13_) {
#line 2804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					result = TRUE;
#line 22083 "Photo.c"
					{
						PhotoRow* _tmp14_;
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp14_ = self->row;
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22090 "Photo.c"
					}
#line 2804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (comment);
#line 2804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (title);
#line 2804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return result;
#line 22102 "Photo.c"
				}
			}
			__finally393:
			{
				PhotoRow* _tmp15_;
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = self->row;
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22112 "Photo.c"
			}
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22116 "Photo.c"
				gboolean _tmp16_ = FALSE;
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (comment);
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (title);
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2800 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return _tmp16_;
#line 22132 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp17_;
		gboolean _tmp41_ = FALSE;
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = self->row;
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22143 "Photo.c"
		{
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			gboolean _tmp21_ = FALSE;
			PhotoRow* _tmp22_;
			GeeHashMap* _tmp23_;
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp22_ = self->row;
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp23_ = _tmp22_->transformations;
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp23_ != NULL) {
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = TRUE;
#line 22159 "Photo.c"
			} else {
				PhotoRow* _tmp24_;
				Orientation _tmp25_;
				BackingPhotoRow* _tmp26_;
				Orientation _tmp27_;
#line 2811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = self->row;
#line 2811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = _tmp24_->orientation;
#line 2811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp26_ = self->backing_photo_row;
#line 2811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp27_ = _tmp26_->original_orientation;
#line 2811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = _tmp25_ != _tmp27_;
#line 22175 "Photo.c"
			}
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp21_) {
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp20_ = TRUE;
#line 22181 "Photo.c"
			} else {
				gboolean _tmp28_ = FALSE;
				MetadataDateTime* _tmp29_;
#line 2812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = date_time;
#line 2812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp29_ != NULL) {
#line 22189 "Photo.c"
					PhotoRow* _tmp30_;
					time_t _tmp31_;
					MetadataDateTime* _tmp32_;
#line 2812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp30_ = self->row;
#line 2812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp31_ = _tmp30_->exposure_time;
#line 2812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp32_ = date_time;
#line 2812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp28_ = _tmp31_ != metadata_date_time_get_timestamp (_tmp32_);
#line 22201 "Photo.c"
				} else {
#line 2812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp28_ = FALSE;
#line 22205 "Photo.c"
				}
#line 2812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp20_ = _tmp28_;
#line 22209 "Photo.c"
			}
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp20_) {
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp19_ = TRUE;
#line 22215 "Photo.c"
			} else {
				gchar* _tmp33_;
				gchar* _tmp34_;
				const gchar* _tmp35_;
#line 2813 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp33_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2813 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp34_ = _tmp33_;
#line 2813 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp35_ = comment;
#line 2813 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp19_ = g_strcmp0 (_tmp34_, _tmp35_) != 0;
#line 2813 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp34_);
#line 22230 "Photo.c"
			}
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp19_) {
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = TRUE;
#line 22236 "Photo.c"
			} else {
				gchar* _tmp36_;
				gchar* _tmp37_;
				const gchar* _tmp38_;
#line 2814 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp36_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 2814 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 2814 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp38_ = title;
#line 2814 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = g_strcmp0 (_tmp37_, _tmp38_) != 0;
#line 2814 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp37_);
#line 22251 "Photo.c"
			}
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp18_;
#line 22255 "Photo.c"
			{
				PhotoRow* _tmp39_;
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp39_ = self->row;
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22262 "Photo.c"
			}
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (comment);
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (title);
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 22274 "Photo.c"
		}
		__finally394:
		{
			PhotoRow* _tmp40_;
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp40_ = self->row;
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22283 "Photo.c"
		}
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (comment);
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (title);
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp41_;
#line 22299 "Photo.c"
	}
#line 2785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (comment);
#line 2785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (title);
#line 2785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 22309 "Photo.c"
}


PhotoTransformationState*
photo_save_transformation_state (Photo* self)
{
	PhotoTransformationState* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 22320 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2820 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2820 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22327 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_;
			PhotoRow* _tmp9_;
			Orientation _tmp10_;
			PhotoRow* _tmp11_;
			GeeHashMap* _tmp12_;
			PhotoPhotoTransformationStateImpl* _tmp13_;
#line 2823 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2823 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22342 "Photo.c"
				PixelTransformer* _tmp3_;
				PixelTransformer* _tmp4_;
#line 2823 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2823 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2823 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2823 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 22353 "Photo.c"
			} else {
#line 2823 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2823 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 22359 "Photo.c"
			}
#line 2824 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2824 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 22365 "Photo.c"
				PixelTransformationBundle* _tmp7_;
				PixelTransformationBundle* _tmp8_;
#line 2824 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2824 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2824 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2824 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 22376 "Photo.c"
			} else {
#line 2824 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2824 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = NULL;
#line 22382 "Photo.c"
			}
#line 2821 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2821 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = _tmp9_->orientation;
#line 2821 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = self->row;
#line 2821 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = _tmp11_->transformations;
#line 2821 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = photo_photo_transformation_state_impl_new (self, _tmp10_, _tmp12_, _tmp1_, _tmp5_);
#line 2821 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 2821 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2821 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 22400 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2820 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = self->row;
#line 2820 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22407 "Photo.c"
			}
#line 2821 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 22411 "Photo.c"
		}
		__finally395:
		{
			PhotoRow* _tmp15_;
#line 2820 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = self->row;
#line 2820 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22420 "Photo.c"
		}
#line 2820 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2820 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2820 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 22428 "Photo.c"
	}
}


static gpointer
_pixel_transformer_ref0 (gpointer self)
{
#line 2845 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 22438 "Photo.c"
}


static gpointer
_pixel_transformation_bundle_ref0 (gpointer self)
{
#line 2846 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 22447 "Photo.c"
}


gboolean
photo_load_transformation_state (Photo* self,
                                 PhotoTransformationState* state)
{
	gboolean result = FALSE;
	PhotoPhotoTransformationStateImpl* state_impl = NULL;
	PhotoPhotoTransformationStateImpl* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	Orientation saved_orientation = 0;
	PhotoPhotoTransformationStateImpl* _tmp2_;
	GeeHashMap* saved_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp3_;
	GeeHashMap* _tmp4_;
	PixelTransformer* saved_transformer = NULL;
	PhotoPhotoTransformationStateImpl* _tmp5_;
	PixelTransformer* _tmp6_;
	PixelTransformationBundle* saved_adjustments = NULL;
	PhotoPhotoTransformationStateImpl* _tmp7_;
	PixelTransformationBundle* _tmp8_;
	gboolean committed = FALSE;
	gboolean _tmp28_;
	GError* _inner_error0_ = NULL;
#line 2828 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2828 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (state), FALSE);
#line 2829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (state) ? ((PhotoPhotoTransformationStateImpl*) state) : NULL);
#line 2829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	state_impl = _tmp0_;
#line 2830 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = state_impl;
#line 2830 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 2831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 22491 "Photo.c"
	}
#line 2833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = state_impl;
#line 2833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	saved_orientation = photo_photo_transformation_state_impl_get_orientation (_tmp2_);
#line 2834 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = state_impl;
#line 2834 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_get_transformations (_tmp3_);
#line 2834 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	saved_transformations = _tmp4_;
#line 2835 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = state_impl;
#line 2835 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_get_transformer (_tmp5_);
#line 2835 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	saved_transformer = _tmp6_;
#line 2836 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = state_impl;
#line 2836 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp7_);
#line 2836 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	saved_adjustments = _tmp8_;
#line 22515 "Photo.c"
	{
		PhotoRow* _tmp9_;
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = self->row;
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22522 "Photo.c"
		{
			PhotoTable* _tmp10_;
			PhotoTable* _tmp11_;
			PhotoRow* _tmp12_;
			PhotoID _tmp13_;
			Orientation _tmp14_;
			GeeHashMap* _tmp15_;
			gboolean _tmp16_;
#line 2840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = photo_table_get_instance ();
#line 2840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = self->row;
#line 2840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = _tmp12_->photo_id;
#line 2840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = saved_orientation;
#line 2840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = saved_transformations;
#line 2840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			committed = photo_table_set_transformation_state (_tmp11_, &_tmp13_, _tmp14_, _tmp15_);
#line 2840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp11_);
#line 2842 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp16_ = committed;
#line 2842 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp16_) {
#line 22551 "Photo.c"
				PhotoRow* _tmp17_;
				Orientation _tmp18_;
				PhotoRow* _tmp19_;
				GeeHashMap* _tmp20_;
				GeeHashMap* _tmp21_;
				PixelTransformer* _tmp22_;
				PixelTransformer* _tmp23_;
				PixelTransformationBundle* _tmp24_;
				PixelTransformationBundle* _tmp25_;
#line 2843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = self->row;
#line 2843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = saved_orientation;
#line 2843 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_->orientation = _tmp18_;
#line 2844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp19_ = self->row;
#line 2844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp20_ = saved_transformations;
#line 2844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = _g_object_ref0 (_tmp20_);
#line 2844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp19_->transformations);
#line 2844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp19_->transformations = _tmp21_;
#line 2845 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = saved_transformer;
#line 2845 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = _pixel_transformer_ref0 (_tmp22_);
#line 2845 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2845 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->transformer = _tmp23_;
#line 2846 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = saved_adjustments;
#line 2846 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = _pixel_transformation_bundle_ref0 (_tmp24_);
#line 2846 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2846 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->adjustments = _tmp25_;
#line 22593 "Photo.c"
			}
		}
		__finally396:
		{
			PhotoRow* _tmp26_;
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp26_ = self->row;
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22603 "Photo.c"
		}
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22607 "Photo.c"
			gboolean _tmp27_ = FALSE;
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2839 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp27_;
#line 22623 "Photo.c"
		}
	}
#line 2850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp28_ = committed;
#line 2850 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp28_) {
#line 22630 "Photo.c"
		Alteration* _tmp29_;
		Alteration* _tmp30_;
#line 2851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp29_ = alteration_new ("image", "transformation-state");
#line 2851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp30_ = _tmp29_;
#line 2851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp30_);
#line 2851 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp30_);
#line 22641 "Photo.c"
	}
#line 2853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = committed;
#line 2853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 22655 "Photo.c"
}


void
photo_remove_all_transformations (Photo* self,
                                  gboolean notify)
{
	gboolean is_altered = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_;
	GError* _inner_error0_ = NULL;
#line 2856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2857 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	is_altered = FALSE;
#line 22671 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22678 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			PhotoRow* _tmp5_;
			PhotoRow* _tmp6_;
			Orientation _tmp7_;
			BackingPhotoRow* _tmp8_;
			Orientation _tmp9_;
#line 2859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->row;
#line 2859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			is_altered = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2860 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2860 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp5_->transformations);
#line 2860 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_->transformations = NULL;
#line 2862 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2862 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			self->priv->transformer = NULL;
#line 2863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 2865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = _tmp6_->orientation;
#line 2865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = self->backing_photo_row;
#line 2865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = _tmp8_->original_orientation;
#line 2865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp7_ != _tmp9_) {
#line 22725 "Photo.c"
				PhotoTable* _tmp10_;
				PhotoTable* _tmp11_;
				PhotoRow* _tmp12_;
				PhotoID _tmp13_;
				BackingPhotoRow* _tmp14_;
				Orientation _tmp15_;
				PhotoRow* _tmp16_;
				BackingPhotoRow* _tmp17_;
				Orientation _tmp18_;
#line 2866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = photo_table_get_instance ();
#line 2866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 2866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = self->row;
#line 2866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = _tmp12_->photo_id;
#line 2866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = self->backing_photo_row;
#line 2866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = _tmp14_->original_orientation;
#line 2866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_table_set_orientation (_tmp11_, &_tmp13_, _tmp15_);
#line 2866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp11_);
#line 2868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = self->row;
#line 2868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = self->backing_photo_row;
#line 2868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = _tmp17_->original_orientation;
#line 2868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_->orientation = _tmp18_;
#line 2869 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				is_altered = TRUE;
#line 22761 "Photo.c"
			}
		}
		__finally397:
		{
			PhotoRow* _tmp19_;
#line 2858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp19_ = self->row;
#line 2858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22771 "Photo.c"
		}
#line 2858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 22781 "Photo.c"
		}
	}
#line 2873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = is_altered;
#line 2873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp21_) {
#line 2873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = notify;
#line 22790 "Photo.c"
	} else {
#line 2873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = FALSE;
#line 22794 "Photo.c"
	}
#line 2873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp20_) {
#line 22798 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 2874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = alteration_new ("image", "revert");
#line 2874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 2874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp23_);
#line 2874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 22809 "Photo.c"
	}
}


Orientation
photo_get_original_orientation (Photo* self)
{
	Orientation result = 0;
	GError* _inner_error0_ = NULL;
#line 2877 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 22821 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22828 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->original_orientation;
#line 2879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_;
#line 22838 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22845 "Photo.c"
			}
#line 2879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 22849 "Photo.c"
		}
		__finally398:
		{
			PhotoRow* _tmp4_;
#line 2878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22858 "Photo.c"
		}
#line 2878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return 0;
#line 22866 "Photo.c"
	}
}


Orientation
photo_get_orientation (Photo* self)
{
	Orientation result = 0;
	GError* _inner_error0_ = NULL;
#line 2883 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 22878 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22885 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp2_;
#line 22895 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22902 "Photo.c"
			}
#line 2885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 22906 "Photo.c"
		}
		__finally399:
		{
			PhotoRow* _tmp4_;
#line 2884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 2884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22915 "Photo.c"
		}
#line 2884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2884 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return 0;
#line 22923 "Photo.c"
	}
}


gboolean
photo_set_orientation (Photo* self,
                       Orientation orientation)
{
	gboolean result = FALSE;
	gboolean committed = FALSE;
	gboolean _tmp11_;
	GError* _inner_error0_ = NULL;
#line 2889 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2890 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	committed = FALSE;
#line 22940 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22947 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2892 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2892 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2892 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != orientation) {
#line 22957 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoRow* _tmp5_;
				PhotoID _tmp6_;
				gboolean _tmp7_;
#line 2893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = self->row;
#line 2893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = _tmp5_->photo_id;
#line 2893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				committed = photo_table_set_orientation (_tmp4_, &_tmp6_, orientation);
#line 2893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2894 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = committed;
#line 2894 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp7_) {
#line 22979 "Photo.c"
					PhotoRow* _tmp8_;
#line 2895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_ = self->row;
#line 2895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_->orientation = orientation;
#line 22985 "Photo.c"
				}
			}
		}
		__finally400:
		{
			PhotoRow* _tmp9_;
#line 2891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22996 "Photo.c"
		}
#line 2891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23000 "Photo.c"
			gboolean _tmp10_ = FALSE;
#line 2891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp10_;
#line 23008 "Photo.c"
		}
	}
#line 2899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = committed;
#line 2899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp11_) {
#line 23015 "Photo.c"
		Alteration* _tmp12_;
		Alteration* _tmp13_;
#line 2900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = alteration_new ("image", "orientation");
#line 2900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 2900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp13_);
#line 2900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp13_);
#line 23026 "Photo.c"
	}
#line 2902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = committed;
#line 2902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 23032 "Photo.c"
}


gboolean
photo_check_can_rotate (Photo* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 2905 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->can_rotate_now;
#line 2906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 2906 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 23049 "Photo.c"
}


static void
photo_real_rotate (Photo* self,
                   Rotation rotation)
{
	GError* _inner_error0_ = NULL;
	{
		PhotoRow* _tmp0_;
#line 2910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23064 "Photo.c"
		{
#line 2911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_set_orientation (self, orientation_perform (photo_get_orientation (self), rotation));
#line 23068 "Photo.c"
		}
		__finally401:
		{
			PhotoRow* _tmp1_;
#line 2910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23077 "Photo.c"
		}
#line 2910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2910 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 23087 "Photo.c"
		}
	}
}


void
photo_rotate (Photo* self,
              Rotation rotation)
{
#line 2909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->rotate (self, rotation);
#line 23101 "Photo.c"
}


static gboolean
photo_has_transformation (Photo* self,
                          const gchar* name)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 23115 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 2916 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2916 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23123 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			GeeHashMap* _tmp3_;
#line 2917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 2917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 23134 "Photo.c"
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 2917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->row;
#line 2917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name);
#line 23143 "Photo.c"
			} else {
#line 2917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 23147 "Photo.c"
			}
#line 2917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp1_;
#line 23151 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2916 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = self->row;
#line 2916 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23158 "Photo.c"
			}
#line 2917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 23162 "Photo.c"
		}
		__finally402:
		{
			PhotoRow* _tmp7_;
#line 2916 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = self->row;
#line 2916 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23171 "Photo.c"
		}
#line 2916 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2916 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2916 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp8_;
#line 23179 "Photo.c"
	}
}


static KeyValueMap*
photo_get_transformation (Photo* self,
                          const gchar* name)
{
	KeyValueMap* result = NULL;
	KeyValueMap* map = NULL;
	GError* _inner_error0_ = NULL;
#line 2924 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2924 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2925 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map = NULL;
#line 23197 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23204 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
#line 2927 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2927 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2927 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 23214 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				gpointer _tmp5_;
				KeyValueMap* _tmp6_;
#line 2928 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2928 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2928 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name);
#line 2928 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2928 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				map = (KeyValueMap*) _tmp5_;
#line 2929 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = map;
#line 2929 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp6_ != NULL) {
#line 23233 "Photo.c"
					KeyValueMap* _tmp7_;
					KeyValueMap* _tmp8_;
#line 2930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp7_ = map;
#line 2930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_ = key_value_map_copy (_tmp7_);
#line 2930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					map = _tmp8_;
#line 23244 "Photo.c"
				}
			}
		}
		__finally403:
		{
			PhotoRow* _tmp9_;
#line 2926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = self->row;
#line 2926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23255 "Photo.c"
		}
#line 2926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 23267 "Photo.c"
		}
	}
#line 2934 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = map;
#line 2934 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 23274 "Photo.c"
}


static gboolean
photo_set_transformation (Photo* self,
                          KeyValueMap* trans)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (trans, TYPE_KEY_VALUE_MAP), FALSE);
#line 23288 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp16_ = FALSE;
#line 2938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23296 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp5_;
			GeeHashMap* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			PhotoTable* _tmp9_;
			PhotoTable* _tmp10_;
			PhotoRow* _tmp11_;
			PhotoID _tmp12_;
			gboolean _tmp13_;
#line 2939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 23315 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2940 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2940 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2940 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2940 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_->transformations = _tmp4_;
#line 23326 "Photo.c"
			}
#line 2942 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = self->row;
#line 2942 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _tmp5_->transformations;
#line 2942 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = key_value_map_get_group (trans);
#line 2942 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2942 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_, trans);
#line 2942 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_tmp8_);
#line 2944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = photo_table_get_instance ();
#line 2944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = self->row;
#line 2944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = _tmp11_->photo_id;
#line 2944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = photo_table_set_transformation (_tmp10_, &_tmp12_, trans);
#line 2944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp10_);
#line 2944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp13_;
#line 23354 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = self->row;
#line 2938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23361 "Photo.c"
			}
#line 2944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 23365 "Photo.c"
		}
		__finally404:
		{
			PhotoRow* _tmp15_;
#line 2938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = self->row;
#line 2938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23374 "Photo.c"
		}
#line 2938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp16_;
#line 23382 "Photo.c"
	}
}


static gboolean
photo_remove_transformation (Photo* self,
                             const gchar* name)
{
	gboolean result = FALSE;
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_;
	GError* _inner_error0_ = NULL;
#line 2948 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2948 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 23401 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 2950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23408 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp10_;
			PhotoTable* _tmp11_;
			PhotoRow* _tmp12_;
			PhotoID _tmp13_;
#line 2951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->row;
#line 2951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 23422 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				PhotoRow* _tmp5_;
				GeeHashMap* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 2952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->row;
#line 2952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				altered_cache = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), name, NULL);
#line 2953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = self->row;
#line 2953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = _tmp5_->transformations;
#line 2953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = gee_abstract_map_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 2953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 2953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp8_ == 0) {
#line 23445 "Photo.c"
					PhotoRow* _tmp9_;
#line 2954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp9_ = self->row;
#line 2954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp9_->transformations);
#line 2954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp9_->transformations = NULL;
#line 23453 "Photo.c"
				}
			} else {
#line 2956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				altered_cache = FALSE;
#line 23458 "Photo.c"
			}
#line 2959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = photo_table_get_instance ();
#line 2959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = self->row;
#line 2959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = _tmp12_->photo_id;
#line 2959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			altered_persistent = photo_table_remove_transformation (_tmp11_, &_tmp13_, name);
#line 2959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp11_);
#line 23472 "Photo.c"
		}
		__finally405:
		{
			PhotoRow* _tmp14_;
#line 2950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = self->row;
#line 2950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23481 "Photo.c"
		}
#line 2950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23485 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 2950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2950 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp15_;
#line 23493 "Photo.c"
		}
	}
#line 2963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = altered_cache;
#line 2963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp17_) {
#line 2963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = TRUE;
#line 23502 "Photo.c"
	} else {
#line 2963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = altered_persistent;
#line 23506 "Photo.c"
	}
#line 2963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp16_;
#line 2963 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 23512 "Photo.c"
}


gboolean
photo_has_crop (Photo* self)
{
	gboolean result = FALSE;
#line 2966 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_has_transformation (self, "crop");
#line 2967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 23526 "Photo.c"
}


gboolean
photo_get_raw_crop (Photo* self,
                    Box* crop)
{
	Box _vala_crop = {0};
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint left = 0;
	KeyValueMap* _tmp2_;
	gint top = 0;
	KeyValueMap* _tmp3_;
	gint right = 0;
	KeyValueMap* _tmp4_;
	gint bottom = 0;
	KeyValueMap* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
#line 2971 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2972 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2974 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2974 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map = _tmp0_;
#line 2975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = map;
#line 2975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2976 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 2976 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2976 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (crop) {
#line 2976 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*crop = _vala_crop;
#line 23575 "Photo.c"
		}
#line 2976 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 23579 "Photo.c"
	}
#line 2978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = map;
#line 2978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	left = key_value_map_get_int (_tmp2_, "left", -1);
#line 2979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = map;
#line 2979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	top = key_value_map_get_int (_tmp3_, "top", -1);
#line 2980 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = map;
#line 2980 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	right = key_value_map_get_int (_tmp4_, "right", -1);
#line 2981 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = map;
#line 2981 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	bottom = key_value_map_get_int (_tmp5_, "bottom", -1);
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = left;
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp9_ == -1) {
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = TRUE;
#line 23603 "Photo.c"
	} else {
		gint _tmp10_;
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = top;
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = _tmp10_ == -1;
#line 23610 "Photo.c"
	}
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_) {
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = TRUE;
#line 23616 "Photo.c"
	} else {
		gint _tmp11_;
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = right;
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = _tmp11_ == -1;
#line 23623 "Photo.c"
	}
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp7_) {
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = TRUE;
#line 23629 "Photo.c"
	} else {
		gint _tmp12_;
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = bottom;
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = _tmp12_ == -1;
#line 23636 "Photo.c"
	}
#line 2983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp6_) {
#line 2984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 2984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (crop) {
#line 2984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*crop = _vala_crop;
#line 23648 "Photo.c"
		}
#line 2984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 23652 "Photo.c"
	}
#line 2986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = left;
#line 2986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = top;
#line 2986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = right;
#line 2986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = bottom;
#line 2986 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	box_init (&_vala_crop, _tmp13_, _tmp14_, _tmp15_, _tmp16_);
#line 2988 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 2988 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2988 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (crop) {
#line 2988 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*crop = _vala_crop;
#line 23672 "Photo.c"
	}
#line 2988 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 23676 "Photo.c"
}


static void
photo_set_raw_crop (Photo* self,
                    Box* crop)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	Box _tmp2_;
	gint _tmp3_;
	KeyValueMap* _tmp4_;
	Box _tmp5_;
	gint _tmp6_;
	KeyValueMap* _tmp7_;
	Box _tmp8_;
	gint _tmp9_;
	KeyValueMap* _tmp10_;
	Box _tmp11_;
	gint _tmp12_;
	KeyValueMap* _tmp13_;
#line 2992 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2992 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 2993 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 2993 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map = _tmp0_;
#line 2994 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = map;
#line 2994 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = *crop;
#line 2994 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_.left;
#line 2994 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp3_);
#line 2995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = map;
#line 2995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = *crop;
#line 2995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = _tmp5_.top;
#line 2995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	key_value_map_set_int (_tmp4_, "top", _tmp6_);
#line 2996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = map;
#line 2996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = *crop;
#line 2996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 2996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	key_value_map_set_int (_tmp7_, "right", _tmp9_);
#line 2997 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = map;
#line 2997 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = *crop;
#line 2997 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = _tmp11_.bottom;
#line 2997 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	key_value_map_set_int (_tmp10_, "bottom", _tmp12_);
#line 2999 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = map;
#line 2999 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_set_transformation (self, _tmp13_)) {
#line 23743 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 3000 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = alteration_new ("image", "crop");
#line 3000 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 3000 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp15_);
#line 3000 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 23754 "Photo.c"
	}
#line 2992 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23758 "Photo.c"
}


static gboolean
photo_get_raw_straighten (Photo* self,
                          gdouble* angle)
{
	gdouble _vala_angle = 0.0;
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 3003 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 3004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map = _tmp0_;
#line 3005 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = map;
#line 3005 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 3006 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_angle = 0.0;
#line 3008 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 3008 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3008 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (angle) {
#line 3008 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*angle = _vala_angle;
#line 23792 "Photo.c"
		}
#line 3008 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 23796 "Photo.c"
	}
#line 3011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = map;
#line 3011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_angle = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 3013 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 3013 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3013 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (angle) {
#line 3013 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*angle = _vala_angle;
#line 23810 "Photo.c"
	}
#line 3013 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 23814 "Photo.c"
}


static void
photo_set_raw_straighten (Photo* self,
                          gdouble theta)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 3016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 3017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map = _tmp0_;
#line 3018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = map;
#line 3018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", theta);
#line 3020 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = map;
#line 3020 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_set_transformation (self, _tmp2_)) {
#line 23840 "Photo.c"
		Alteration* _tmp3_;
		Alteration* _tmp4_;
#line 3021 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = alteration_new ("image", "straighten");
#line 3021 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 3021 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp4_);
#line 3021 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp4_);
#line 23851 "Photo.c"
	}
#line 3016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23855 "Photo.c"
}


static EditingToolsRedeyeInstance*
photo_get_raw_redeye_instances (Photo* self,
                                int* result_length1)
{
	EditingToolsRedeyeInstance* result = NULL;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	gint _tmp5_;
	EditingToolsRedeyeInstance* res = NULL;
	gint _tmp6_;
	EditingToolsRedeyeInstance* _tmp7_;
	gint res_length1;
	gint _res_size_;
	GdkPoint default_point = {0};
	GdkPoint _tmp8_ = {0};
	EditingToolsRedeyeInstance* _tmp45_;
	gint _tmp45__length1;
#line 3026 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3027 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3027 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map = _tmp0_;
#line 3028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = map;
#line 3028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 23889 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_;
		EditingToolsRedeyeInstance* _tmp3_;
		gint _tmp3__length1;
#line 3029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 3029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3__length1 = 0;
#line 3029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (result_length1) {
#line 3029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 23903 "Photo.c"
		}
#line 3029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = _tmp3_;
#line 3029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 23911 "Photo.c"
	}
#line 3031 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = map;
#line 3031 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = num_points;
#line 3032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (_tmp5_ > 0, "num_points > 0");
#line 3034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = num_points;
#line 3034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = g_new0 (EditingToolsRedeyeInstance, _tmp6_);
#line 3034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	res = _tmp7_;
#line 3034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	res_length1 = _tmp6_;
#line 3034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_res_size_ = res_length1;
#line 3036 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_.x = 0;
#line 3036 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	default_point = _tmp8_;
#line 3037 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	default_point.x = -1;
#line 3038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	default_point.y = -1;
#line 23939 "Photo.c"
	{
		gint i = 0;
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		i = 0;
#line 23944 "Photo.c"
		{
			gboolean _tmp9_ = FALSE;
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = TRUE;
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 23951 "Photo.c"
				gint _tmp11_;
				gint _tmp12_;
				gchar* center_key = NULL;
				gint _tmp13_;
				gchar* _tmp14_;
				gchar* radius_key = NULL;
				gint _tmp15_;
				gchar* _tmp16_;
				EditingToolsRedeyeInstance* _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_;
				KeyValueMap* _tmp19_;
				const gchar* _tmp20_;
				GdkPoint _tmp21_;
				GdkPoint _tmp22_ = {0};
				EditingToolsRedeyeInstance* _tmp23_;
				gint _tmp23__length1;
				gint _tmp24_;
				EditingToolsRedeyeInstance _tmp25_;
				GdkPoint _tmp26_;
				gint _tmp27_;
				GdkPoint _tmp28_;
				gint _tmp29_;
				EditingToolsRedeyeInstance* _tmp30_;
				gint _tmp30__length1;
				gint _tmp31_;
				EditingToolsRedeyeInstance _tmp32_;
				GdkPoint _tmp33_;
				gint _tmp34_;
				GdkPoint _tmp35_;
				gint _tmp36_;
				EditingToolsRedeyeInstance* _tmp37_;
				gint _tmp37__length1;
				gint _tmp38_;
				KeyValueMap* _tmp39_;
				const gchar* _tmp40_;
				EditingToolsRedeyeInstance* _tmp41_;
				gint _tmp41__length1;
				gint _tmp42_;
				EditingToolsRedeyeInstance _tmp43_;
				gint _tmp44_;
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!_tmp9_) {
#line 23995 "Photo.c"
					gint _tmp10_;
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = i;
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					i = _tmp10_ + 1;
#line 24001 "Photo.c"
				}
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = FALSE;
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = i;
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = num_points;
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!(_tmp11_ < _tmp12_)) {
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 24013 "Photo.c"
				}
#line 3041 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = i;
#line 3041 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = g_strdup_printf ("center%d", _tmp13_);
#line 3041 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				center_key = _tmp14_;
#line 3042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = i;
#line 3042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = g_strdup_printf ("radius%d", _tmp15_);
#line 3042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				radius_key = _tmp16_;
#line 3044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = res;
#line 3044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17__length1 = res_length1;
#line 3044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = i;
#line 3044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp19_ = map;
#line 3044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp20_ = center_key;
#line 3044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = default_point;
#line 3044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				key_value_map_get_point (_tmp19_, _tmp20_, &_tmp21_, &_tmp22_);
#line 3044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_[_tmp18_].center = _tmp22_;
#line 3045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = res;
#line 3045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23__length1 = res_length1;
#line 3045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = i;
#line 3045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = _tmp23_[_tmp24_];
#line 3045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp26_ = _tmp25_.center;
#line 3045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp27_ = _tmp26_.x;
#line 3045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = default_point;
#line 3045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = _tmp28_.x;
#line 3045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_vala_assert (_tmp27_ != _tmp29_, "res[i].center.x != default_point.x");
#line 3046 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp30_ = res;
#line 3046 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp30__length1 = res_length1;
#line 3046 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp31_ = i;
#line 3046 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp32_ = _tmp30_[_tmp31_];
#line 3046 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp33_ = _tmp32_.center;
#line 3046 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp34_ = _tmp33_.y;
#line 3046 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp35_ = default_point;
#line 3046 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp36_ = _tmp35_.y;
#line 3046 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_vala_assert (_tmp34_ != _tmp36_, "res[i].center.y != default_point.y");
#line 3048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp37_ = res;
#line 3048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp37__length1 = res_length1;
#line 3048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp38_ = i;
#line 3048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp39_ = map;
#line 3048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp40_ = radius_key;
#line 3048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp37_[_tmp38_].radius = key_value_map_get_int (_tmp39_, _tmp40_, -1);
#line 3049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp41_ = res;
#line 3049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp41__length1 = res_length1;
#line 3049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp42_ = i;
#line 3049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp43_ = _tmp41_[_tmp42_];
#line 3049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp44_ = _tmp43_.radius;
#line 3049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_vala_assert (_tmp44_ != -1, "res[i].radius != -1");
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (radius_key);
#line 3040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (center_key);
#line 24107 "Photo.c"
			}
		}
	}
#line 3052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp45_ = res;
#line 3052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp45__length1 = res_length1;
#line 3052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (result_length1) {
#line 3052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*result_length1 = _tmp45__length1;
#line 24119 "Photo.c"
	}
#line 3052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp45_;
#line 3052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 24127 "Photo.c"
}


gboolean
photo_has_redeye_transformations (Photo* self)
{
	gboolean result = FALSE;
#line 3055 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_has_transformation (self, "redeye");
#line 3056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 24141 "Photo.c"
}


void
photo_add_redeye_instance (Photo* self,
                           EditingToolsRedeyeInstance* redeye)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* radius_key = NULL;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* center_key = NULL;
	gint _tmp9_;
	gchar* _tmp10_;
	KeyValueMap* _tmp11_;
	const gchar* _tmp12_;
	EditingToolsRedeyeInstance _tmp13_;
	gint _tmp14_;
	KeyValueMap* _tmp15_;
	const gchar* _tmp16_;
	EditingToolsRedeyeInstance _tmp17_;
	GdkPoint _tmp18_;
	KeyValueMap* _tmp19_;
	gint _tmp20_;
	KeyValueMap* _tmp21_;
#line 3060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 3061 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3061 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map = _tmp0_;
#line 3062 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = map;
#line 3062 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 24185 "Photo.c"
		KeyValueMap* _tmp2_;
		KeyValueMap* _tmp3_;
#line 3063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 3063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		map = _tmp2_;
#line 3064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = map;
#line 3064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 24198 "Photo.c"
	}
#line 3067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = map;
#line 3067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = num_points;
#line 3068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (_tmp5_ >= 0, "num_points >= 0");
#line 3070 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = num_points;
#line 3070 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	num_points = _tmp6_ + 1;
#line 3072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = num_points;
#line 3072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = g_strdup_printf ("radius%d", _tmp7_ - 1);
#line 3072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	radius_key = _tmp8_;
#line 3073 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = num_points;
#line 3073 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = g_strdup_printf ("center%d", _tmp9_ - 1);
#line 3073 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	center_key = _tmp10_;
#line 3075 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = map;
#line 3075 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = radius_key;
#line 3075 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = *redeye;
#line 3075 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = _tmp13_.radius;
#line 3075 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	key_value_map_set_int (_tmp11_, _tmp12_, _tmp14_);
#line 3076 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = map;
#line 3076 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = center_key;
#line 3076 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = *redeye;
#line 3076 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = _tmp17_.center;
#line 3076 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	key_value_map_set_point (_tmp15_, _tmp16_, &_tmp18_);
#line 3078 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = map;
#line 3078 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = num_points;
#line 3078 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	key_value_map_set_int (_tmp19_, "num_points", _tmp20_);
#line 3080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = map;
#line 3080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_set_transformation (self, _tmp21_)) {
#line 24254 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 3081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = alteration_new ("image", "redeye");
#line 3081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 3081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp23_);
#line 3081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 24265 "Photo.c"
	}
#line 3060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (center_key);
#line 3060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (radius_key);
#line 3060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 24273 "Photo.c"
}


static gboolean
photo_calculate_pixbuf_dimensions (Photo* self,
                                   Scaling* scaling,
                                   PhotoException exceptions,
                                   Dimensions* scaled_image,
                                   Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 3095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 24292 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp7_ = FALSE;
#line 3097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 3097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24300 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			gboolean _tmp4_;
#line 3099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = *scaling;
#line 3099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, exceptions, &_tmp2_, &_tmp3_);
#line 3099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_scaled_image = _tmp2_;
#line 3099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp3_;
#line 3099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp4_;
#line 24316 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 3097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = self->row;
#line 3097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24323 "Photo.c"
			}
#line 3099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (scaled_image) {
#line 3099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 24329 "Photo.c"
			}
#line 3099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (scaled_to_viewport) {
#line 3099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24335 "Photo.c"
			}
#line 3099 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 24339 "Photo.c"
		}
		__finally406:
		{
			PhotoRow* _tmp6_;
#line 3097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = self->row;
#line 3097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24348 "Photo.c"
		}
#line 3097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp7_;
#line 24356 "Photo.c"
	}
#line 3095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (scaled_image) {
#line 3095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 24362 "Photo.c"
	}
#line 3095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (scaled_to_viewport) {
#line 3095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24368 "Photo.c"
	}
}


static gboolean
photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          Dimensions* scaled_image,
                                          Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	Dimensions raw = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	gboolean _tmp36_ = FALSE;
	Dimensions _tmp37_;
	gint _tmp38_;
	Dimensions _tmp39_;
	gint _tmp40_;
#line 3105 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3105 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3107 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	raw = _tmp0_;
#line 3109 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 24401 "Photo.c"
		Dimensions _tmp1_;
		Dimensions _tmp2_;
#line 3110 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = raw;
#line 3110 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_scaled_image = _tmp1_;
#line 3111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = raw;
#line 3111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp2_;
#line 3113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 3113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (scaled_image) {
#line 3113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 24418 "Photo.c"
		}
#line 3113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (scaled_to_viewport) {
#line 3113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24424 "Photo.c"
		}
#line 3113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 24428 "Photo.c"
	}
#line 3116 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 3121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 3122 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 3124 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 24438 "Photo.c"
		Box crop = {0};
		Box _tmp3_ = {0};
		gboolean _tmp4_;
#line 3126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 3126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		crop = _tmp3_;
#line 3126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp4_) {
#line 24448 "Photo.c"
			Dimensions rotated_raw = {0};
			Dimensions _tmp5_;
			Box scaled_crop = {0};
			Dimensions _tmp13_ = {0};
			Dimensions _tmp14_ = {0};
			Box _tmp15_ = {0};
			Dimensions _tmp16_ = {0};
			gboolean _tmp17_ = FALSE;
			Dimensions _tmp20_ = {0};
			Dimensions _tmp21_ = {0};
			Dimensions _tmp22_ = {0};
#line 3129 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = raw;
#line 3129 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			rotated_raw = _tmp5_;
#line 3130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24466 "Photo.c"
				Orientation _tmp6_;
				Dimensions _tmp7_;
				Box _tmp8_;
				Box _tmp9_ = {0};
				Orientation _tmp10_;
				Dimensions _tmp11_;
				Dimensions _tmp12_ = {0};
#line 3131 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = orientation;
#line 3131 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = raw;
#line 3131 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = crop;
#line 3131 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				orientation_rotate_box (_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 3131 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				crop = _tmp9_;
#line 3132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = orientation;
#line 3132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = raw;
#line 3132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				orientation_rotate_dimensions (_tmp10_, &_tmp11_, &_tmp12_);
#line 3132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				rotated_raw = _tmp12_;
#line 24492 "Photo.c"
			}
#line 3136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp13_);
#line 3136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp13_, &_tmp14_);
#line 3136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			box_get_scaled (&crop, &_tmp14_, &_tmp15_);
#line 3136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			scaled_crop = _tmp15_;
#line 3139 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp16_);
#line 3139 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp16_;
#line 3142 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (box_get_width (&crop) <= box_get_width (&scaled_crop)) {
#line 3143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = box_get_height (&crop) <= box_get_height (&scaled_crop);
#line 24510 "Photo.c"
			} else {
#line 3142 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = FALSE;
#line 24514 "Photo.c"
			}
#line 3142 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp17_) {
#line 24518 "Photo.c"
				Dimensions _tmp18_;
				Dimensions _tmp19_ = {0};
#line 3144 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = raw;
#line 3144 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_vala_scaled_image = _tmp18_;
#line 3145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				box_get_dimensions (&crop, &_tmp19_);
#line 3145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_vala_scaled_to_viewport = _tmp19_;
#line 3147 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				result = FALSE;
#line 3147 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (scaled_image) {
#line 3147 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 24535 "Photo.c"
				}
#line 3147 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (scaled_to_viewport) {
#line 3147 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24541 "Photo.c"
				}
#line 3147 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return result;
#line 24545 "Photo.c"
			}
#line 3152 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp20_);
#line 3152 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp21_);
#line 3152 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp20_, &_tmp21_, &_tmp22_);
#line 3152 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_scaled_image = _tmp22_;
#line 3156 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24557 "Photo.c"
				Orientation _tmp23_;
				Dimensions _tmp24_;
				Dimensions _tmp25_ = {0};
#line 3157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = orientation;
#line 3157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = _vala_scaled_image;
#line 3157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				orientation_derotate_dimensions (_tmp23_, &_tmp24_, &_tmp25_);
#line 3157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_vala_scaled_image = _tmp25_;
#line 24569 "Photo.c"
			}
		}
	}
#line 3162 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!dimensions_has_area (&_vala_scaled_image)) {
#line 24575 "Photo.c"
		Dimensions rotated_raw = {0};
		Dimensions _tmp26_;
		Dimensions _tmp30_;
		Dimensions _tmp31_ = {0};
		Dimensions _tmp32_;
#line 3164 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp26_ = raw;
#line 3164 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		rotated_raw = _tmp26_;
#line 3165 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24587 "Photo.c"
			Orientation _tmp27_;
			Dimensions _tmp28_;
			Dimensions _tmp29_ = {0};
#line 3166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp27_ = orientation;
#line 3166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp28_ = raw;
#line 3166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			orientation_rotate_dimensions (_tmp27_, &_tmp28_, &_tmp29_);
#line 3166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			rotated_raw = _tmp29_;
#line 24599 "Photo.c"
		}
#line 3168 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp30_ = rotated_raw;
#line 3168 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp30_, &_tmp31_);
#line 3168 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_scaled_image = _tmp31_;
#line 3169 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = _vala_scaled_image;
#line 3169 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp32_;
#line 3172 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24613 "Photo.c"
			Orientation _tmp33_;
			Dimensions _tmp34_;
			Dimensions _tmp35_ = {0};
#line 3173 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp33_ = orientation;
#line 3173 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp34_ = _vala_scaled_image;
#line 3173 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			orientation_derotate_dimensions (_tmp33_, &_tmp34_, &_tmp35_);
#line 3173 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_scaled_image = _tmp35_;
#line 24625 "Photo.c"
		}
	}
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp37_ = _vala_scaled_image;
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp38_ = _tmp37_.width;
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp39_ = raw;
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp40_ = _tmp39_.width;
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp38_ >= _tmp40_) {
#line 24638 "Photo.c"
		Dimensions _tmp41_;
		gint _tmp42_;
		Dimensions _tmp43_;
		gint _tmp44_;
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp41_ = _vala_scaled_image;
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp42_ = _tmp41_.height;
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp43_ = raw;
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp44_ = _tmp43_.height;
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp36_ = _tmp42_ >= _tmp44_;
#line 24653 "Photo.c"
	} else {
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp36_ = FALSE;
#line 24657 "Photo.c"
	}
#line 3177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp36_) {
#line 24661 "Photo.c"
		Dimensions _tmp45_;
#line 3178 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp45_ = raw;
#line 3178 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_scaled_image = _tmp45_;
#line 3180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 3180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (scaled_image) {
#line 3180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 24673 "Photo.c"
		}
#line 3180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (scaled_to_viewport) {
#line 3180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24679 "Photo.c"
		}
#line 3180 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 24683 "Photo.c"
	}
#line 3183 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_image), "scaled_image.has_area()");
#line 3184 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_to_viewport), "scaled_to_viewport.has_area()");
#line 3186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 3186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (scaled_image) {
#line 3186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 24695 "Photo.c"
	}
#line 3186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (scaled_to_viewport) {
#line 3186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 24701 "Photo.c"
	}
#line 3186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 24705 "Photo.c"
}


static GdkPixbuf*
photo_load_raw_pixbuf (Photo* self,
                       Scaling* scaling,
                       PhotoException exceptions,
                       BackingFetchMode fetch_mode,
                       GError** error)
{
	GdkPixbuf* result = NULL;
	PhotoFileReader* loader = NULL;
	PhotoFileReader* _tmp0_;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	gboolean is_scaled = FALSE;
	Scaling _tmp5_;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	gboolean _tmp9_;
	GdkPixbuf* pixbuf = NULL;
	PhotoFileReader* _tmp14_;
	Dimensions _tmp15_ = {0};
	Dimensions _tmp16_;
	GdkPixbuf* _tmp17_;
	GdkPixbuf* _tmp18_;
	Dimensions _tmp19_ = {0};
	GError* _inner_error0_ = NULL;
#line 3192 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3192 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3195 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_backing_reader (self, fetch_mode);
#line 3195 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	loader = _tmp0_;
#line 3198 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 24745 "Photo.c"
		GdkPixbuf* _tmp1_ = NULL;
		PhotoFileReader* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = loader;
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = photo_file_reader_unscaled_read (_tmp2_, &_inner_error0_);
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp3_;
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 24764 "Photo.c"
		}
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp1_;
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = _tmp4_;
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 24778 "Photo.c"
	}
#line 3208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = *scaling;
#line 3208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = photo_calculate_pixbuf_dimensions (self, &_tmp5_, exceptions, &_tmp6_, &_tmp7_);
#line 3208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	scaled_image = _tmp6_;
#line 3208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	scaled_to_viewport = _tmp7_;
#line 3208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	is_scaled = _tmp8_;
#line 3210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = is_scaled;
#line 3210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp9_) {
#line 24794 "Photo.c"
		GdkPixbuf* _tmp10_ = NULL;
		PhotoFileReader* _tmp11_;
		GdkPixbuf* _tmp12_;
		GdkPixbuf* _tmp13_;
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = loader;
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = photo_file_reader_unscaled_read (_tmp11_, &_inner_error0_);
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = _tmp12_;
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 24813 "Photo.c"
		}
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = _tmp10_;
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = NULL;
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = _tmp13_;
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp10_);
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3215 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 24827 "Photo.c"
	}
#line 3218 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = loader;
#line 3218 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp15_);
#line 3218 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = scaled_image;
#line 3218 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = photo_file_reader_scaled_read (_tmp14_, &_tmp15_, &_tmp16_, &_inner_error0_);
#line 3218 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	pixbuf = _tmp17_;
#line 3218 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3218 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3218 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3218 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 24847 "Photo.c"
	}
#line 3226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = pixbuf;
#line 3226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dimensions_for_pixbuf (_tmp18_, &_tmp19_);
#line 3226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (dimensions_approx_equals (&scaled_image, &_tmp19_, PHOTO_SCALING_FUDGE), "scaled_image.approx_equals(Dimensions.for_pixbuf(pixbuf), SCALING_FUDGE)");
#line 3228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = pixbuf;
#line 3228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 3228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 24861 "Photo.c"
}


GdkPixbuf*
photo_get_master_pixbuf (Photo* self,
                         Scaling* scaling,
                         gboolean rotate,
                         GError** error)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3233 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3233 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_MASTER, &_inner_error0_);
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 24893 "Photo.c"
	}
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 24905 "Photo.c"
}


GdkPixbuf*
photo_get_unmodified_pixbuf (Photo* self,
                             Scaling* scaling,
                             gboolean rotate,
                             GError** error)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error0_);
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 24937 "Photo.c"
	}
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 24949 "Photo.c"
}


static GdkPixbuf*
photo_get_untransformed_pixbuf (Photo* self,
                                Scaling* scaling,
                                gboolean rotate,
                                BackingFetchMode fetch_mode,
                                GError** error)
{
	GdkPixbuf* result = NULL;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	Scaling _tmp5_;
	GdkPixbuf* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 3243 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3243 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 24972 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 3258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24979 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
#line 3259 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = *scaling;
#line 3259 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 3259 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			scaled_image = _tmp2_;
#line 3259 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 3261 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			original_orientation = photo_get_original_orientation (self);
#line 24994 "Photo.c"
		}
		__finally407:
		{
			PhotoRow* _tmp4_;
#line 3258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 3258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 25003 "Photo.c"
		}
#line 3258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 25011 "Photo.c"
		}
	}
#line 3265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = *scaling;
#line 3265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = photo_load_raw_pixbuf (self, &_tmp5_, PHOTO_EXCEPTION_NONE, fetch_mode, &_inner_error0_);
#line 3265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	pixbuf = _tmp6_;
#line 3265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 25026 "Photo.c"
	}
#line 3271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (rotate) {
#line 25030 "Photo.c"
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
#line 3272 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = pixbuf;
#line 3272 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = orientation_rotate_pixbuf (original_orientation, _tmp7_);
#line 3272 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3272 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		pixbuf = _tmp8_;
#line 25041 "Photo.c"
	}
#line 3281 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = pixbuf;
#line 3281 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 25047 "Photo.c"
}


static GdkPixbuf*
photo_real_get_pixbuf (PhotoSource* base,
                       Scaling* scaling,
                       GError** error)
{
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3284 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO, Photo);
#line 3284 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 25079 "Photo.c"
	}
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 25091 "Photo.c"
}


/**
     * One-stop shopping for the source pixbuf cache.
     *
     * The source pixbuf cache holds untransformed, unscaled (full-sized) pixbufs of Photo objects.
     * These can be rather large and shouldn't be held in memory for too long, nor should many be
     * allowed to stack up.
     *
     * If locate is non-null, a source pixbuf is returned for the Photo.  If keep is true, the
     * pixbuf is stored in the cache.  (Thus, passing a Photo w/ keep == false will drop the cached
     * pixbuf.)  If Photo is non-null but keep is false, null is returned.
     *
     * Whether locate is null or not, the cache is walked in its entirety, dropping expired pixbufs
     * and dropping excessive pixbufs from the LRU.  Locating a Photo "touches" the pixbuf, i.e.
     * it moves to the head of the LRU.
     */
static gpointer
_photo_cached_pixbuf_ref0 (gpointer self)
{
#line 3320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? photo_cached_pixbuf_ref (self) : NULL;
#line 25115 "Photo.c"
}


static gboolean
_photo_trim_source_pixbuf_cache_gsource_func (gpointer self)
{
	gboolean result;
	result = photo_trim_source_pixbuf_cache ();
#line 3372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 25126 "Photo.c"
}


static GdkPixbuf*
photo_run_source_pixbuf_cache (Photo* locate,
                               gboolean keep,
                               GError** error)
{
	GdkPixbuf* result = NULL;
	GError* _inner_error0_ = NULL;
#line 3303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((locate == NULL) || IS_PHOTO (locate), NULL);
#line 25139 "Photo.c"
	{
		GeeLinkedList* _tmp0_;
#line 3304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = photo_source_pixbuf_cache;
#line 3304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&__lock_photo_photo_source_pixbuf_cache);
#line 25146 "Photo.c"
		{
			PhotoCachedPixbuf* found = NULL;
			gdouble min_elapsed = 0.0;
			gint count = 0;
			GeeIterator* iter = NULL;
			GeeLinkedList* _tmp1_;
			GeeIterator* _tmp2_;
			gboolean _tmp22_ = FALSE;
			gboolean _tmp23_ = FALSE;
			PhotoCachedPixbuf* _tmp24_;
			gboolean _tmp32_ = FALSE;
			PhotoCachedPixbuf* _tmp33_;
			guint _tmp45_;
			GeeLinkedList* _tmp47_;
			gint _tmp48_;
			gint _tmp49_;
			GdkPixbuf* _tmp53_ = NULL;
			PhotoCachedPixbuf* _tmp54_;
			GdkPixbuf* _tmp57_;
#line 3305 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			found = NULL;
#line 3309 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			min_elapsed = DBL_MAX;
#line 3310 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			count = 0;
#line 3311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = photo_source_pixbuf_cache;
#line 3311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			iter = _tmp2_;
#line 3312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 25180 "Photo.c"
				GeeIterator* _tmp3_;
				PhotoCachedPixbuf* cached_pixbuf = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				gdouble elapsed = 0.0;
				PhotoCachedPixbuf* _tmp6_;
				GTimer* _tmp7_;
				gboolean _tmp8_ = FALSE;
#line 3312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = iter;
#line 3312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 3312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 25195 "Photo.c"
				}
#line 3313 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = iter;
#line 3313 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 3313 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				cached_pixbuf = (PhotoCachedPixbuf*) _tmp5_;
#line 3315 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = cached_pixbuf;
#line 3315 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp6_->last_touched;
#line 3315 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				elapsed = trunc (g_timer_elapsed (_tmp7_, NULL)) + 1;
#line 3317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (locate != NULL) {
#line 25211 "Photo.c"
					PhotoCachedPixbuf* _tmp9_;
					Photo* _tmp10_;
#line 3317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp9_ = cached_pixbuf;
#line 3317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = _tmp9_->photo;
#line 3317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_ = data_source_equals (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (locate, TYPE_DATA_SOURCE, DataSource));
#line 25220 "Photo.c"
				} else {
#line 3317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_ = FALSE;
#line 25224 "Photo.c"
				}
#line 3317 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp8_) {
#line 25228 "Photo.c"
					GeeIterator* _tmp11_;
					PhotoCachedPixbuf* _tmp12_;
					PhotoCachedPixbuf* _tmp13_;
					gint _tmp14_;
#line 3319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_ = iter;
#line 3319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_iterator_remove (_tmp11_);
#line 3320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = cached_pixbuf;
#line 3320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp13_ = _photo_cached_pixbuf_ref0 (_tmp12_);
#line 3320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_cached_pixbuf_unref0 (found);
#line 3320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					found = _tmp13_;
#line 3323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp14_ = count;
#line 3323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					count = _tmp14_ + 1;
#line 25249 "Photo.c"
				} else {
					gdouble _tmp15_;
#line 3324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp15_ = elapsed;
#line 3324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_tmp15_ >= ((gdouble) PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC)) {
#line 25256 "Photo.c"
						GeeIterator* _tmp16_;
#line 3325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp16_ = iter;
#line 3325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						gee_iterator_remove (_tmp16_);
#line 25262 "Photo.c"
					} else {
						gint _tmp17_;
#line 3326 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp17_ = count;
#line 3326 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp17_ >= PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT) {
#line 25269 "Photo.c"
							GeeIterator* _tmp18_;
#line 3327 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp18_ = iter;
#line 3327 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							gee_iterator_remove (_tmp18_);
#line 25275 "Photo.c"
						} else {
							gdouble _tmp19_;
							gdouble _tmp20_;
							gint _tmp21_;
#line 3331 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp19_ = elapsed;
#line 3331 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp20_ = min_elapsed;
#line 3331 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							min_elapsed = MIN (_tmp19_, _tmp20_);
#line 3332 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp21_ = count;
#line 3332 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							count = _tmp21_ + 1;
#line 25290 "Photo.c"
						}
					}
				}
#line 3312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_cached_pixbuf_unref0 (cached_pixbuf);
#line 25296 "Photo.c"
			}
#line 3337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp24_ = found;
#line 3337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp24_ == NULL) {
#line 3337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = locate != NULL;
#line 25304 "Photo.c"
			} else {
#line 3337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = FALSE;
#line 25308 "Photo.c"
			}
#line 3337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp23_) {
#line 3337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = keep;
#line 25314 "Photo.c"
			} else {
#line 3337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = FALSE;
#line 25318 "Photo.c"
			}
#line 3337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp22_) {
#line 25322 "Photo.c"
				GdkPixbuf* _tmp25_ = NULL;
				Scaling _tmp26_ = {0};
				GdkPixbuf* _tmp27_;
				PhotoCachedPixbuf* _tmp28_;
#line 3339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				scaling_for_original (&_tmp26_);
#line 3339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp27_ = photo_load_raw_pixbuf (locate, &_tmp26_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = _tmp27_;
#line 3339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (iter);
#line 3339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_cached_pixbuf_unref0 (found);
#line 25339 "Photo.c"
					goto __finally408;
				}
#line 3338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = photo_cached_pixbuf_new (locate, _tmp25_);
#line 3338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_cached_pixbuf_unref0 (found);
#line 3338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				found = _tmp28_;
#line 3337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp25_);
#line 25350 "Photo.c"
			} else {
				PhotoCachedPixbuf* _tmp29_;
#line 3340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = found;
#line 3340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp29_ != NULL) {
#line 25357 "Photo.c"
					PhotoCachedPixbuf* _tmp30_;
					GTimer* _tmp31_;
#line 3342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp30_ = found;
#line 3342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp31_ = _tmp30_->last_touched;
#line 3342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_timer_start (_tmp31_);
#line 25366 "Photo.c"
				}
			}
#line 3346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp33_ = found;
#line 3346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp33_ != NULL) {
#line 3346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp32_ = keep;
#line 25375 "Photo.c"
			} else {
#line 3346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp32_ = FALSE;
#line 25379 "Photo.c"
			}
#line 3346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp32_) {
#line 25383 "Photo.c"
				GeeLinkedList* _tmp34_;
				PhotoCachedPixbuf* _tmp35_;
				PhotoCachedPixbuf* _tmp36_;
				GTimer* _tmp37_;
				gdouble _tmp38_;
#line 3347 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp34_ = photo_source_pixbuf_cache;
#line 3347 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp35_ = found;
#line 3347 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_abstract_list_insert (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0, _tmp35_);
#line 3352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp36_ = found;
#line 3352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp37_ = _tmp36_->last_touched;
#line 3352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp38_ = min_elapsed;
#line 3352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				min_elapsed = MIN (g_timer_elapsed (_tmp37_, NULL), _tmp38_);
#line 3356 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				while (TRUE) {
#line 25405 "Photo.c"
					GeeLinkedList* _tmp39_;
					gint _tmp40_;
					gint _tmp41_;
					GeeLinkedList* _tmp42_;
					gpointer _tmp43_;
					PhotoCachedPixbuf* _tmp44_;
#line 3356 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp39_ = photo_source_pixbuf_cache;
#line 3356 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp40_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3356 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp41_ = _tmp40_;
#line 3356 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (!(_tmp41_ > PHOTO_SOURCE_PIXBUF_MAX_LRU_COUNT)) {
#line 3356 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						break;
#line 25422 "Photo.c"
					}
#line 3357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp42_ = photo_source_pixbuf_cache;
#line 3357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp43_ = gee_deque_poll_tail (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, GEE_TYPE_DEQUE, GeeDeque));
#line 3357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp44_ = (PhotoCachedPixbuf*) _tmp43_;
#line 3357 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_cached_pixbuf_unref0 (_tmp44_);
#line 25432 "Photo.c"
				}
			}
#line 3361 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp45_ = photo_discard_source_id;
#line 3361 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp45_ != ((guint) 0)) {
#line 25439 "Photo.c"
				guint _tmp46_;
#line 3362 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp46_ = photo_discard_source_id;
#line 3362 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_source_remove (_tmp46_);
#line 3363 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_discard_source_id = (guint) 0;
#line 25447 "Photo.c"
			}
#line 3367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp47_ = photo_source_pixbuf_cache;
#line 3367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp48_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 3367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp49_ = _tmp48_;
#line 3367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp49_ > PHOTO_SOURCE_PIXBUF_MIN_LRU_COUNT) {
#line 25457 "Photo.c"
				gdouble _tmp50_;
				guint retry_sec = 0U;
				gdouble _tmp51_;
				guint _tmp52_;
#line 3368 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp50_ = min_elapsed;
#line 3368 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_vala_assert (_tmp50_ >= 0.0, "min_elapsed >= 0.0");
#line 3371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp51_ = min_elapsed;
#line 3371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				retry_sec = PHOTO_SOURCE_PIXBUF_TIME_TO_LIVE_SEC - ((guint) trunc (_tmp51_));
#line 3372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp52_ = retry_sec;
#line 3372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_discard_source_id = g_timeout_add_seconds_full (G_PRIORITY_LOW, _tmp52_, _photo_trim_source_pixbuf_cache_gsource_func, NULL, NULL);
#line 25474 "Photo.c"
			}
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp54_ = found;
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp54_ != NULL) {
#line 25480 "Photo.c"
				PhotoCachedPixbuf* _tmp55_;
				GdkPixbuf* _tmp56_;
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp55_ = found;
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp56_ = _tmp55_->pixbuf;
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp53_ = _tmp56_;
#line 25489 "Photo.c"
			} else {
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp53_ = NULL;
#line 25493 "Photo.c"
			}
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp57_ = _g_object_ref0 (_tmp53_);
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp57_;
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (iter);
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_cached_pixbuf_unref0 (found);
#line 25503 "Photo.c"
			{
				GError* _inner_error0_ = NULL;
				GeeLinkedList* _tmp58_;
#line 3304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp58_ = photo_source_pixbuf_cache;
#line 3304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&__lock_photo_photo_source_pixbuf_cache);
#line 25511 "Photo.c"
			}
#line 3375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 25515 "Photo.c"
		}
		__finally408:
		{
			GError* _inner_error1_ = NULL;
			GeeLinkedList* _tmp59_;
#line 3304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp59_ = photo_source_pixbuf_cache;
#line 3304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&__lock_photo_photo_source_pixbuf_cache);
#line 25525 "Photo.c"
		}
#line 3304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 25531 "Photo.c"
	}
}


static gboolean
photo_trim_source_pixbuf_cache (void)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
	{
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
#line 3381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = photo_run_source_pixbuf_cache (NULL, FALSE, &_inner_error0_);
#line 3381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25552 "Photo.c"
			goto __catch409_g_error;
		}
	}
	goto __finally409;
	__catch409_g_error:
	{
		GError* err = NULL;
#line 3380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 3380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 3380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 25566 "Photo.c"
	}
	__finally409:
#line 3380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25571 "Photo.c"
		gboolean _tmp2_ = FALSE;
#line 3380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp2_;
#line 25579 "Photo.c"
	}
#line 3385 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = FALSE;
#line 3385 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 25585 "Photo.c"
}


/**
     * @brief Get a copy of what's in the cache.
     *
     * @return A copy of the Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf*
photo_get_prefetched_copy (Photo* self,
                           GError** error)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 3393 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_run_source_pixbuf_cache (self, TRUE, &_inner_error0_);
#line 3394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 25615 "Photo.c"
	}
#line 3394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = gdk_pixbuf_copy (_tmp0_);
#line 3394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp2_;
#line 3394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 25625 "Photo.c"
}


/**
     * @brief Discards the cached version of the unmodified image.
     */
void
photo_discard_prefetched (Photo* self)
{
	GError* _inner_error0_ = NULL;
#line 3400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 25638 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
		GdkPixbuf* _tmp1_;
#line 3402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = photo_run_source_pixbuf_cache (self, FALSE, &_inner_error0_);
#line 3402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25650 "Photo.c"
			goto __catch410_g_error;
		}
	}
	goto __finally410;
	__catch410_g_error:
	{
		GError* err = NULL;
#line 3401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 3401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 3401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 25664 "Photo.c"
	}
	__finally410:
#line 3401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 25675 "Photo.c"
	}
}


/**
     * @brief Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf*
photo_get_pixbuf_with_options (Photo* self,
                               Scaling* scaling,
                               PhotoException exceptions,
                               BackingFetchMode fetch_mode,
                               GError** error)
{
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances = NULL;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer = NULL;
	Orientation orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp22_;
	gboolean _tmp64_;
	gboolean _tmp74_ = FALSE;
	gboolean _tmp75_;
	GError* _inner_error0_ = NULL;
#line 3418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp4_) {
#line 3432 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 25735 "Photo.c"
	} else {
#line 3431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = FALSE;
#line 25739 "Photo.c"
	}
#line 3431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_) {
#line 25743 "Photo.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 3433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (fetch_mode == BACKING_FETCH_MODE_BASELINE) {
#line 3433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = TRUE;
#line 25750 "Photo.c"
		} else {
#line 3433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = fetch_mode == BACKING_FETCH_MODE_UNMODIFIED;
#line 25754 "Photo.c"
		}
#line 3433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp6_) {
#line 3433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = TRUE;
#line 25760 "Photo.c"
		} else {
#line 3434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = fetch_mode == BACKING_FETCH_MODE_SOURCE;
#line 25764 "Photo.c"
		}
#line 3433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp5_;
#line 25768 "Photo.c"
	} else {
#line 3431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 25772 "Photo.c"
	}
#line 3431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_) {
#line 3435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = !photo_is_raw_developer_complete (self, photo_get_raw_developer (self));
#line 25778 "Photo.c"
	} else {
#line 3431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 25782 "Photo.c"
	}
#line 3431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp0_) {
#line 3436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_set_raw_developer (self, photo_get_raw_developer (self), TRUE);
#line 25788 "Photo.c"
	}
#line 3441 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3442 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	redeye_instances = NULL;
#line 3443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3446 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	transformer = NULL;
#line 25802 "Photo.c"
	{
		PhotoRow* _tmp7_;
#line 3449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = self->row;
#line 3449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 25809 "Photo.c"
		{
			Dimensions _tmp8_ = {0};
			Dimensions _tmp9_ = {0};
			Dimensions _tmp10_ = {0};
			Dimensions _tmp11_;
			Dimensions _tmp12_ = {0};
			Dimensions _tmp13_;
			gint _tmp14_ = 0;
			EditingToolsRedeyeInstance* _tmp15_;
			Box _tmp16_ = {0};
			gboolean _tmp17_;
			gdouble _tmp18_ = 0.0;
			gboolean _tmp19_;
#line 3450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_ALL, &_tmp8_);
#line 3450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			original = _tmp8_;
#line 3451 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), exceptions, &_tmp9_);
#line 3451 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp9_, &_tmp10_);
#line 3451 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			scaled = _tmp10_;
#line 3452 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = scaled;
#line 3452 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			scaled_to_viewport = _tmp11_;
#line 3454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp12_);
#line 3454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = scaled;
#line 3454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			is_scaled = !dimensions_equals (&_tmp12_, &_tmp13_);
#line 3456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = photo_get_raw_redeye_instances (self, &_tmp14_);
#line 3456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			redeye_instances = _tmp15_;
#line 3456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			redeye_instances_length1 = _tmp14_;
#line 3456 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp17_ = photo_get_raw_crop (self, &_tmp16_);
#line 3458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			crop = _tmp16_;
#line 3458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			is_cropped = _tmp17_;
#line 3460 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp19_ = photo_get_raw_straighten (self, &_tmp18_);
#line 3460 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			straightening_angle = _tmp18_;
#line 3460 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			is_straightened = _tmp19_;
#line 3462 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (photo_has_color_adjustments (self)) {
#line 25867 "Photo.c"
				PixelTransformer* _tmp20_;
#line 3463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp20_ = photo_get_pixel_transformer (self);
#line 3463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3463 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				transformer = _tmp20_;
#line 25875 "Photo.c"
			}
#line 3465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			orientation = photo_get_orientation (self);
#line 25879 "Photo.c"
		}
		__finally411:
		{
			PhotoRow* _tmp21_;
#line 3449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp21_ = self->row;
#line 3449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 25888 "Photo.c"
		}
#line 3449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 25900 "Photo.c"
		}
	}
#line 3472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp22_ = photo_get_prefetched_copy (self, &_inner_error0_);
#line 3472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	pixbuf = _tmp22_;
#line 3472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 25917 "Photo.c"
	}
#line 3479 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_REDEYE)) {
#line 25921 "Photo.c"
		EditingToolsRedeyeInstance* _tmp23_;
		gint _tmp23__length1;
#line 3484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = redeye_instances;
#line 3484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23__length1 = redeye_instances_length1;
#line 25928 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			instance_collection = _tmp23_;
#line 3484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			instance_collection_length1 = _tmp23__length1;
#line 3484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			for (instance_it = 0; instance_it < instance_collection_length1; instance_it = instance_it + 1) {
#line 25940 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				instance = instance_collection[instance_it];
#line 25944 "Photo.c"
				{
					GdkPixbuf* _tmp24_;
					EditingToolsRedeyeInstance _tmp25_;
					GdkPixbuf* _tmp26_;
#line 3485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp24_ = pixbuf;
#line 3485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp25_ = instance;
#line 3485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp26_ = photo_do_redeye (self, _tmp24_, &_tmp25_);
#line 3485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3485 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					pixbuf = _tmp26_;
#line 25959 "Photo.c"
				}
			}
		}
	}
#line 3493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 25966 "Photo.c"
		gboolean _tmp27_;
#line 3497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp27_ = is_straightened;
#line 3497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp27_) {
#line 25972 "Photo.c"
			GdkPixbuf* _tmp28_;
			gdouble _tmp29_;
			GdkPixbuf* _tmp30_;
#line 3498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp28_ = pixbuf;
#line 3498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp29_ = straightening_angle;
#line 3498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp30_ = rotate_arb (_tmp28_, _tmp29_);
#line 3498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			pixbuf = _tmp30_;
#line 25986 "Photo.c"
		}
	}
#line 3507 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 25991 "Photo.c"
		gboolean _tmp31_;
#line 3511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp31_ = is_cropped;
#line 3511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp31_) {
#line 25997 "Photo.c"
			Box _tmp32_;
			gint _tmp33_;
			GdkPixbuf* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			Box _tmp37_;
			gint _tmp38_;
			GdkPixbuf* _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
			Box _tmp42_;
			gint _tmp43_;
			Box _tmp44_;
			gint _tmp45_;
			GdkPixbuf* _tmp46_;
			gint _tmp47_;
			gint _tmp48_;
			Box _tmp49_;
			gint _tmp50_;
			Box _tmp51_;
			gint _tmp52_;
			GdkPixbuf* _tmp53_;
			gint _tmp54_;
			gint _tmp55_;
			GdkPixbuf* _tmp56_;
			Box _tmp57_;
			gint _tmp58_;
			Box _tmp59_;
			gint _tmp60_;
			GdkPixbuf* _tmp61_;
#line 3516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp32_ = crop;
#line 3516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp33_ = _tmp32_.left;
#line 3516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp34_ = pixbuf;
#line 3516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp35_ = gdk_pixbuf_get_width (_tmp34_);
#line 3516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 3516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			crop.left = CLAMP (_tmp33_, 0, _tmp36_ - 2);
#line 3517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp37_ = crop;
#line 3517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp38_ = _tmp37_.top;
#line 3517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp39_ = pixbuf;
#line 3517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp40_ = gdk_pixbuf_get_height (_tmp39_);
#line 3517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp41_ = _tmp40_;
#line 3517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			crop.top = CLAMP (_tmp38_, 0, _tmp41_ - 2);
#line 3519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp42_ = crop;
#line 3519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp43_ = _tmp42_.right;
#line 3519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp44_ = crop;
#line 3519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp45_ = _tmp44_.left;
#line 3519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp46_ = pixbuf;
#line 3519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp47_ = gdk_pixbuf_get_width (_tmp46_);
#line 3519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp48_ = _tmp47_;
#line 3519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			crop.right = CLAMP (_tmp43_, _tmp45_ + 1, _tmp48_ - 1);
#line 3520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp49_ = crop;
#line 3520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp50_ = _tmp49_.bottom;
#line 3520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp51_ = crop;
#line 3520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp52_ = _tmp51_.top;
#line 3520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp53_ = pixbuf;
#line 3520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp54_ = gdk_pixbuf_get_height (_tmp53_);
#line 3520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp55_ = _tmp54_;
#line 3520 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			crop.bottom = CLAMP (_tmp50_, _tmp52_ + 1, _tmp55_ - 1);
#line 3522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp56_ = pixbuf;
#line 3522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp57_ = crop;
#line 3522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp58_ = _tmp57_.left;
#line 3522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp59_ = crop;
#line 3522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp60_ = _tmp59_.top;
#line 3522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp61_ = gdk_pixbuf_new_subpixbuf (_tmp56_, _tmp58_, _tmp60_, box_get_width (&crop), box_get_height (&crop));
#line 3522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			pixbuf = _tmp61_;
#line 26100 "Photo.c"
		}
	}
#line 3532 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 26105 "Photo.c"
		GdkPixbuf* _tmp62_;
		GdkPixbuf* _tmp63_;
#line 3536 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp62_ = pixbuf;
#line 3536 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp63_ = orientation_rotate_pixbuf (orientation, _tmp62_);
#line 3536 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3536 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		pixbuf = _tmp63_;
#line 26116 "Photo.c"
	}
#line 3543 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp64_ = is_scaled;
#line 3543 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp64_) {
#line 26122 "Photo.c"
		GdkPixbuf* _tmp65_;
		Dimensions _tmp66_;
		gint _tmp67_;
		Dimensions _tmp68_;
		gint _tmp69_;
		GdkPixbuf* _tmp70_;
#line 3547 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp65_ = pixbuf;
#line 3547 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp66_ = scaled_to_viewport;
#line 3547 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp67_ = _tmp66_.width;
#line 3547 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp68_ = scaled_to_viewport;
#line 3547 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp69_ = _tmp68_.height;
#line 3547 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp70_ = gdk_pixbuf_scale_simple (_tmp65_, _tmp67_, _tmp69_, GDK_INTERP_BILINEAR);
#line 3547 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3547 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		pixbuf = _tmp70_;
#line 26145 "Photo.c"
	}
#line 3555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ADJUST)) {
#line 26149 "Photo.c"
		PixelTransformer* _tmp71_;
#line 3559 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp71_ = transformer;
#line 3559 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp71_ != NULL) {
#line 26155 "Photo.c"
			PixelTransformer* _tmp72_;
			GdkPixbuf* _tmp73_;
#line 3560 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp72_ = transformer;
#line 3560 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp73_ = pixbuf;
#line 3560 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp72_, _tmp73_, NULL);
#line 26164 "Photo.c"
		}
	}
#line 3569 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp75_ = is_scaled;
#line 3569 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp75_) {
#line 26171 "Photo.c"
		gboolean _tmp76_;
#line 3569 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp76_ = is_straightened;
#line 3569 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp74_ = !_tmp76_;
#line 26177 "Photo.c"
	} else {
#line 3569 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp74_ = FALSE;
#line 26181 "Photo.c"
	}
#line 3569 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp74_) {
#line 26185 "Photo.c"
		GdkPixbuf* _tmp77_;
		Dimensions _tmp78_ = {0};
#line 3570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp77_ = pixbuf;
#line 3570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dimensions_for_pixbuf (_tmp77_, &_tmp78_);
#line 3570 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_assert (dimensions_approx_equals (&scaled_to_viewport, &_tmp78_, PHOTO_SCALING_FUDGE), "scaled_to_viewport.approx_equals(Dimensions.for_pixbuf(pixbuf), SCALING_FUDGE)");
#line 26194 "Photo.c"
	}
#line 3578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = pixbuf;
#line 3578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 26204 "Photo.c"
}


static gboolean
photo_real_has_user_generated_metadata (Photo* self)
{
	gboolean _tmp0_ = FALSE;
#line 3586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return _tmp0_;
#line 26216 "Photo.c"
}


gboolean
photo_has_user_generated_metadata (Photo* self)
{
#line 3586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return PHOTO_GET_CLASS (self)->has_user_generated_metadata (self);
#line 26227 "Photo.c"
}


static void
photo_real_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata)
{
#line 3590 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3590 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 26239 "Photo.c"
}


void
photo_set_user_metadata_for_export (Photo* self,
                                    PhotoMetadata* metadata)
{
#line 3590 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3590 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->set_user_metadata_for_export (self, metadata);
#line 26251 "Photo.c"
}


gchar*
photo_get_export_basename (Photo* self,
                           PhotoFileFormat* file_format)
{
	gchar* result = NULL;
#line 3597 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3598 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (file_format != NULL) {
#line 26264 "Photo.c"
		PhotoFileFormatProperties* _tmp0_;
		PhotoFileFormatProperties* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = photo_file_format_get_properties (*file_format);
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = photo_file_format_properties_convert_file_extension (_tmp1_, _tmp3_);
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = g_file_get_basename (_tmp5_);
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp1_);
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = _tmp7_;
#line 3599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 26299 "Photo.c"
	} else {
#line 3601 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (photo_file_format_can_write (photo_get_file_format (self))) {
#line 26303 "Photo.c"
			PhotoFileFormatProperties* _tmp8_;
			PhotoFileFormatProperties* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = photo_file_format_get_properties (photo_get_file_format (self));
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = photo_file_format_properties_convert_file_extension (_tmp9_, _tmp11_);
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = g_file_get_basename (_tmp13_);
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp13_);
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp9_);
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp15_;
#line 3602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 26338 "Photo.c"
		} else {
			PhotoFileFormatProperties* _tmp16_;
			PhotoFileFormatProperties* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp16_ = photo_file_format_get_properties (photo_file_format_get_system_default_format ());
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp18_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp20_ = photo_file_format_properties_convert_file_extension (_tmp17_, _tmp19_);
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp21_ = _tmp20_;
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp22_ = g_file_get_basename (_tmp21_);
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp21_);
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp17_);
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			result = _tmp23_;
#line 3605 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return result;
#line 26374 "Photo.c"
		}
	}
}


static gboolean
photo_export_fullsized_backing (Photo* self,
                                GFile* file,
                                gboolean export_metadata,
                                GError** error)
{
	gboolean result = FALSE;
	PhotoFileReader* export_reader = NULL;
	gboolean is_master = FALSE;
	PhotoFileReader* _tmp24_;
	PhotoFileFormatProperties* format_properties = NULL;
	PhotoFileReader* _tmp25_;
	PhotoFileFormatProperties* _tmp26_;
	GFile* dest_file = NULL;
	PhotoFileFormatProperties* _tmp27_;
	GFile* _tmp28_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	PhotoFileMetadataWriter* _tmp33_;
	PhotoFileMetadataWriter* _tmp34_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	PhotoFileMetadataWriter* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	PhotoFileReader* _tmp41_;
	GFile* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp56_;
	PhotoMetadata* _tmp57_;
	PhotoMetadata* _tmp59_;
	PhotoFileMetadataWriter* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	PhotoFileMetadataWriter* _tmp82_;
	PhotoMetadata* _tmp83_;
	GError* _inner_error0_ = NULL;
#line 3611 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3611 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 3614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	export_reader = NULL;
#line 3615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	is_master = TRUE;
#line 26435 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 26442 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 3617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 26453 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 3617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 26462 "Photo.c"
			} else {
#line 3617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 26466 "Photo.c"
			}
#line 3617 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp1_) {
#line 26470 "Photo.c"
				PhotoBackingReaders* _tmp6_;
				PhotoFileReader* _tmp7_;
				PhotoFileReader* _tmp8_;
#line 3618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp6_->editable;
#line 3618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = _photo_file_adapter_ref0 (_tmp7_);
#line 3618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				export_reader = _tmp8_;
#line 3619 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				is_master = FALSE;
#line 26486 "Photo.c"
			} else {
				gboolean _tmp9_ = FALSE;
				PhotoBackingReaders* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 3620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = self->priv->readers;
#line 3620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _tmp10_->developer;
#line 3620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 26497 "Photo.c"
					PhotoBackingReaders* _tmp12_;
					PhotoFileReader* _tmp13_;
#line 3620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 3620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp13_ = _tmp12_->developer;
#line 3620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp9_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 26506 "Photo.c"
				} else {
#line 3620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp9_ = FALSE;
#line 26510 "Photo.c"
				}
#line 3620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp9_) {
#line 26514 "Photo.c"
					PhotoBackingReaders* _tmp14_;
					PhotoFileReader* _tmp15_;
					PhotoFileReader* _tmp16_;
#line 3621 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp14_ = self->priv->readers;
#line 3621 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp15_ = _tmp14_->developer;
#line 3621 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp16_ = _photo_file_adapter_ref0 (_tmp15_);
#line 3621 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3621 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					export_reader = _tmp16_;
#line 3622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					is_master = FALSE;
#line 26530 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp17_;
					PhotoFileReader* _tmp18_;
#line 3623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp17_ = self->priv->readers;
#line 3623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp18_ = _tmp17_->master;
#line 3623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (photo_file_format_can_write_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)))) {
#line 26540 "Photo.c"
						PhotoBackingReaders* _tmp19_;
						PhotoFileReader* _tmp20_;
						PhotoFileReader* _tmp21_;
#line 3624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp19_ = self->priv->readers;
#line 3624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp20_ = _tmp19_->master;
#line 3624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp21_ = _photo_file_adapter_ref0 (_tmp20_);
#line 3624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						export_reader = _tmp21_;
#line 26554 "Photo.c"
					}
				}
			}
		}
		__finally412:
		{
			PhotoBackingReaders* _tmp22_;
#line 3616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp22_ = self->priv->readers;
#line 3616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 26566 "Photo.c"
		}
#line 3616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26570 "Photo.c"
			gboolean _tmp23_ = FALSE;
#line 3616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp23_;
#line 26578 "Photo.c"
		}
	}
#line 3628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_ = export_reader;
#line 3628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp24_ == NULL) {
#line 3629 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 3629 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3629 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 26591 "Photo.c"
	}
#line 3631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp25_ = export_reader;
#line 3631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = photo_file_format_get_properties (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 3631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	format_properties = _tmp26_;
#line 3634 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27_ = format_properties;
#line 3634 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp28_ = photo_file_format_properties_convert_file_extension (_tmp27_, file);
#line 3634 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dest_file = _tmp28_;
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = export_reader;
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_ = dest_file;
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = g_file_get_path (_tmp30_);
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = photo_file_format_create_metadata_writer (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)), _tmp32_, &_inner_error0_);
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	writer = _tmp34_;
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26623 "Photo.c"
		gboolean _tmp35_ = FALSE;
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp35_;
#line 26635 "Photo.c"
	}
#line 3640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp36_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp37_ = _tmp36_;
#line 3640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp38_ = writer;
#line 3640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp39_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 3640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_debug ("Photo.vala:3640: Exporting full-sized copy of %s to %s", _tmp37_, _tmp40_);
#line 3640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp40_);
#line 3640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp37_);
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp41_ = export_reader;
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp42_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp44_ = dest_file;
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_file_copy (_tmp43_, _tmp44_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp43_);
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26667 "Photo.c"
		gboolean _tmp45_ = FALSE;
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp45_;
#line 26681 "Photo.c"
	}
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_has_alterations (self)) {
#line 26685 "Photo.c"
		gboolean _tmp51_;
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp51_ = is_master;
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp50_ = _tmp51_;
#line 26691 "Photo.c"
	} else {
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp50_ = FALSE;
#line 26695 "Photo.c"
	}
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp50_) {
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp49_ = !photo_has_user_generated_metadata (self);
#line 26701 "Photo.c"
	} else {
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp49_ = FALSE;
#line 26705 "Photo.c"
	}
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp49_) {
#line 26709 "Photo.c"
		gchar* _tmp52_;
		gchar* _tmp53_;
#line 3648 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp52_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3648 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp53_ = _tmp52_;
#line 3648 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp48_ = _tmp53_ == NULL;
#line 3648 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp53_);
#line 26720 "Photo.c"
	} else {
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp48_ = FALSE;
#line 26724 "Photo.c"
	}
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp48_) {
#line 26728 "Photo.c"
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 3648 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp54_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3648 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp55_ = _tmp54_;
#line 3648 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp47_ = _tmp55_ == NULL;
#line 3648 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp55_);
#line 26739 "Photo.c"
	} else {
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp47_ = FALSE;
#line 26743 "Photo.c"
	}
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp47_) {
#line 3648 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp46_ = export_metadata;
#line 26749 "Photo.c"
	} else {
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp46_ = FALSE;
#line 26753 "Photo.c"
	}
#line 3647 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp46_) {
#line 3649 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = TRUE;
#line 3649 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3649 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3649 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3649 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3649 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 26769 "Photo.c"
	}
#line 3652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp56_ = export_reader;
#line 3652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp57_ = photo_file_reader_read_metadata (_tmp56_, &_inner_error0_);
#line 3652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	metadata = _tmp57_;
#line 3652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26779 "Photo.c"
		gboolean _tmp58_ = FALSE;
#line 3652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp58_;
#line 26793 "Photo.c"
	}
#line 3653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp59_ = metadata;
#line 3653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp59_ == NULL) {
#line 26799 "Photo.c"
		PhotoFileReader* _tmp60_;
		PhotoMetadata* _tmp61_;
#line 3654 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp60_ = export_reader;
#line 3654 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp61_ = photo_file_format_create_metadata (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)));
#line 3654 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3654 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		metadata = _tmp61_;
#line 26810 "Photo.c"
	}
#line 3656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp62_ = writer;
#line 3656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp63_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp64_ = _tmp63_;
#line 3656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_debug ("Photo.vala:3656: Updating metadata of %s", _tmp64_);
#line 3656 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp64_);
#line 3658 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != ((time_t) 0)) {
#line 26824 "Photo.c"
		PhotoMetadata* _tmp65_;
		MetadataDateTime* _tmp66_;
		MetadataDateTime* _tmp67_;
#line 3659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp65_ = metadata;
#line 3659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp66_ = metadata_date_time_new (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)));
#line 3659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp67_ = _tmp66_;
#line 3659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp65_, _tmp67_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_metadata_date_time_unref0 (_tmp67_);
#line 26838 "Photo.c"
	} else {
		PhotoMetadata* _tmp68_;
#line 3661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp68_ = metadata;
#line 3661 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp68_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 26845 "Photo.c"
	}
#line 3663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (export_metadata) {
#line 26849 "Photo.c"
		PhotoMetadata* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		PhotoMetadata* _tmp72_;
		gchar* _tmp73_;
		gchar* _tmp74_;
		PhotoMetadata* _tmp75_;
		Dimensions _tmp76_ = {0};
		PhotoMetadata* _tmp77_;
		PhotoMetadata* _tmp78_;
		PhotoMetadata* _tmp80_;
#line 3665 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp69_ = metadata;
#line 3665 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp70_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3665 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp71_ = _tmp70_;
#line 3665 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_title (_tmp69_, _tmp71_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3665 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp71_);
#line 3666 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp72_ = metadata;
#line 3666 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp73_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3666 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp74_ = _tmp73_;
#line 3666 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_comment (_tmp72_, _tmp74_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3666 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp74_);
#line 3667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp75_ = metadata;
#line 3667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp76_);
#line 3667 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp75_, &_tmp76_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp77_ = metadata;
#line 3668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_orientation (_tmp77_, photo_get_orientation (self));
#line 3669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp78_ = metadata;
#line 3669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_software (_tmp78_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (photo_get_orientation (self) != photo_get_original_orientation (self)) {
#line 26897 "Photo.c"
			PhotoMetadata* _tmp79_;
#line 3672 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp79_ = metadata;
#line 3672 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp79_);
#line 26903 "Photo.c"
		}
#line 3674 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp80_ = metadata;
#line 3674 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp80_);
#line 26909 "Photo.c"
	} else {
		PhotoMetadata* _tmp81_;
#line 3678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp81_ = metadata;
#line 3678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_clear (_tmp81_);
#line 26916 "Photo.c"
	}
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp82_ = writer;
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp83_ = metadata;
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp82_, _tmp83_, &_inner_error0_);
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26926 "Photo.c"
		gboolean _tmp84_ = FALSE;
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp84_;
#line 26942 "Photo.c"
	}
#line 3682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 3682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 26958 "Photo.c"
}


gboolean
photo_is_export_required (Photo* self,
                          Scaling* scaling,
                          PhotoFileFormat export_format)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 3688 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3688 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!scaling_is_unscaled (scaling)) {
#line 3689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = TRUE;
#line 26979 "Photo.c"
	} else {
#line 3689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = photo_has_alterations (self);
#line 26983 "Photo.c"
	}
#line 3689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_) {
#line 3689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = TRUE;
#line 26989 "Photo.c"
	} else {
#line 3689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = photo_has_user_generated_metadata (self);
#line 26993 "Photo.c"
	}
#line 3689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_) {
#line 3689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 26999 "Photo.c"
	} else {
#line 3690 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = export_format != photo_get_file_format (self);
#line 27003 "Photo.c"
	}
#line 3689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 3689 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 27009 "Photo.c"
}


void
photo_export (Photo* self,
              GFile* dest_file,
              Scaling* scaling,
              JpegQuality quality,
              PhotoFileFormat export_format,
              gboolean direct_copy_unmodified,
              gboolean export_metadata,
              GError** error)
{
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp7_;
	PhotoMetadata* _tmp8_;
	PhotoFileWriter* writer = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileWriter* _tmp12_;
	PhotoFileWriter* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	PhotoFileWriter* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GEnumValue* _tmp19_;
	GdkPixbuf* pixbuf = NULL;
	gboolean _tmp20_ = FALSE;
	PhotoFileWriter* _tmp29_;
	GdkPixbuf* _tmp30_;
	PhotoFileWriter* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp50_ = FALSE;
	PhotoFileMetadataWriter* _tmp58_ = NULL;
	gchar* _tmp59_;
	gchar* _tmp60_;
	PhotoFileMetadataWriter* _tmp61_;
	PhotoFileMetadataWriter* _tmp62_;
	PhotoMetadata* _tmp63_;
	GError* _inner_error0_ = NULL;
#line 3696 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3696 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dest_file, g_file_get_type ()));
#line 3696 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3698 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (direct_copy_unmodified) {
#line 27063 "Photo.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 3699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_file_copy (_tmp1_, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 27080 "Photo.c"
		}
#line 3701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 27084 "Photo.c"
	}
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 27088 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (!photo_has_alterations (self)) {
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = TRUE;
#line 27094 "Photo.c"
		} else {
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = photo_only_metadata_changed (self);
#line 27098 "Photo.c"
		}
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp5_;
#line 27102 "Photo.c"
	} else {
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = FALSE;
#line 27106 "Photo.c"
	}
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp4_) {
#line 3709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = export_format == photo_get_file_format (self);
#line 27112 "Photo.c"
	} else {
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = FALSE;
#line 27116 "Photo.c"
	}
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp3_) {
#line 3709 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF;
#line 27122 "Photo.c"
	} else {
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = FALSE;
#line 27126 "Photo.c"
	}
#line 3708 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_) {
#line 27130 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 3710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = photo_export_fullsized_backing (self, dest_file, export_metadata, &_inner_error0_);
#line 3710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 27140 "Photo.c"
		}
#line 3710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp6_) {
#line 3711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 27146 "Photo.c"
		}
	}
#line 3717 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 3717 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	metadata = _tmp7_;
#line 3718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = metadata;
#line 3718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 27157 "Photo.c"
		PhotoMetadata* _tmp9_;
#line 3719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = photo_file_format_create_metadata (export_format);
#line 3719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3719 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		metadata = _tmp9_;
#line 27165 "Photo.c"
	}
#line 3721 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_file_format_can_write (export_format)) {
#line 3722 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		export_format = photo_file_format_get_system_default_format ();
#line 27171 "Photo.c"
	}
#line 3724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = g_file_get_path (dest_file);
#line 3724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = photo_file_format_create_writer (export_format, _tmp11_, &_inner_error0_);
#line 3724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 3724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp11_);
#line 3724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	writer = _tmp13_;
#line 3724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3724 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 27193 "Photo.c"
	}
#line 3726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 3726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 3726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = writer;
#line 3726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 3727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), export_format);
#line 3726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_debug ("Photo.vala:3726: Saving transformed version of %s to %s in file format" \
" %s", _tmp15_, _tmp18_, (_tmp19_ != NULL) ? _tmp19_->value_name : NULL);
#line 3726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp18_);
#line 3726 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp15_);
#line 3733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = TRUE;
#line 27217 "Photo.c"
	} else {
#line 3734 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 27221 "Photo.c"
	}
#line 3733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp20_) {
#line 27225 "Photo.c"
		GdkPixbuf* _tmp21_ = NULL;
		Scaling _tmp22_;
		GdkPixbuf* _tmp23_;
		GdkPixbuf* _tmp24_;
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = *scaling;
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = photo_get_pixbuf_with_options (self, &_tmp22_, PHOTO_EXCEPTION_ORIENTATION, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp21_ = _tmp23_;
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 27248 "Photo.c"
		}
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp24_ = _tmp21_;
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp21_ = NULL;
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3735 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		pixbuf = _tmp24_;
#line 3733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 27260 "Photo.c"
	} else {
		GdkPixbuf* _tmp25_ = NULL;
		Scaling _tmp26_;
		GdkPixbuf* _tmp27_;
		GdkPixbuf* _tmp28_;
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp26_ = *scaling;
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp27_ = photo_get_pixbuf_with_options (self, &_tmp26_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp25_ = _tmp27_;
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 27284 "Photo.c"
		}
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp28_ = _tmp25_;
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp25_ = NULL;
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3739 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		pixbuf = _tmp28_;
#line 3733 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp25_);
#line 27296 "Photo.c"
	}
#line 3743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = writer;
#line 3743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_ = pixbuf;
#line 3743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_file_writer_write (_tmp29_, _tmp30_, quality, &_inner_error0_);
#line 3743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 27316 "Photo.c"
	}
#line 3745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = writer;
#line 3745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp32_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 3745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_debug ("Photo.vala:3745: Setting EXIF for %s", _tmp33_);
#line 3745 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp33_);
#line 3748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (export_metadata) {
#line 27330 "Photo.c"
		PhotoMetadata* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		PhotoMetadata* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		PhotoMetadata* _tmp40_;
		PhotoMetadata* _tmp45_;
		PhotoMetadata* _tmp46_;
		PhotoMetadata* _tmp47_;
#line 3750 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34_ = metadata;
#line 3750 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = media_source_get_title (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3750 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 3750 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_title (_tmp34_, _tmp36_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3750 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp36_);
#line 3751 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp37_ = metadata;
#line 3751 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp38_ = media_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3751 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 3751 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_comment (_tmp37_, _tmp39_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3751 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp39_);
#line 3752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp40_ = metadata;
#line 3752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_software (_tmp40_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 3754 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != ((time_t) 0)) {
#line 27367 "Photo.c"
			PhotoMetadata* _tmp41_;
			MetadataDateTime* _tmp42_;
			MetadataDateTime* _tmp43_;
#line 3755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp41_ = metadata;
#line 3755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp42_ = metadata_date_time_new (media_source_get_exposure_time (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)));
#line 3755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp43_ = _tmp42_;
#line 3755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp41_, _tmp43_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_metadata_date_time_unref0 (_tmp43_);
#line 27381 "Photo.c"
		} else {
			PhotoMetadata* _tmp44_;
#line 3757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp44_ = metadata;
#line 3757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp44_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 27388 "Photo.c"
		}
#line 3759 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp45_ = metadata;
#line 3759 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_remove_tag (_tmp45_, "Exif.Iop.RelatedImageWidth");
#line 3760 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp46_ = metadata;
#line 3760 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_remove_tag (_tmp46_, "Exif.Iop.RelatedImageHeight");
#line 3761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp47_ = metadata;
#line 3761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp47_);
#line 3763 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (photo_has_user_generated_metadata (self)) {
#line 27404 "Photo.c"
			PhotoMetadata* _tmp48_;
#line 3764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp48_ = metadata;
#line 3764 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp48_);
#line 27410 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp49_;
#line 3768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp49_ = metadata;
#line 3768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_clear (_tmp49_);
#line 27418 "Photo.c"
	}
#line 3775 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3775 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp50_ = TRUE;
#line 27424 "Photo.c"
	} else {
#line 3776 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp50_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 27428 "Photo.c"
	}
#line 3775 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp50_) {
#line 27432 "Photo.c"
		PhotoMetadata* _tmp51_;
		Dimensions _tmp52_ = {0};
		PhotoMetadata* _tmp53_;
#line 3777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp51_ = metadata;
#line 3777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_ORIENTATION, &_tmp52_);
#line 3777 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp51_, &_tmp52_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp53_ = metadata;
#line 3778 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_orientation (_tmp53_, photo_get_orientation (self));
#line 27446 "Photo.c"
	} else {
		PhotoMetadata* _tmp54_;
		GdkPixbuf* _tmp55_;
		Dimensions _tmp56_ = {0};
		PhotoMetadata* _tmp57_;
#line 3781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp54_ = metadata;
#line 3781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp55_ = pixbuf;
#line 3781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dimensions_for_pixbuf (_tmp55_, &_tmp56_);
#line 3781 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp54_, &_tmp56_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3782 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp57_ = metadata;
#line 3782 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_orientation (_tmp57_, ORIENTATION_TOP_LEFT);
#line 27464 "Photo.c"
	}
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp59_ = g_file_get_path (dest_file);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp60_ = _tmp59_;
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp61_ = photo_file_format_create_metadata_writer (export_format, _tmp60_, &_inner_error0_);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp62_ = _tmp61_;
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp60_);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp58_ = _tmp62_;
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 27490 "Photo.c"
	}
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp63_ = metadata;
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp58_, _tmp63_, &_inner_error0_);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp58_);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3785 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 27510 "Photo.c"
	}
#line 3696 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp58_);
#line 3696 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3696 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3696 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 27520 "Photo.c"
}


static GFile*
photo_generate_new_editable_file (Photo* self,
                                  PhotoFileFormat* file_format,
                                  GError** error)
{
	PhotoFileFormat _vala_file_format = 0;
	GFile* result = NULL;
	GFile* backing = NULL;
	PhotoFileFormat _tmp3_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gchar* editable_basename = NULL;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean collision = FALSE;
	GFile* _tmp21_ = NULL;
	GFile* _tmp22_;
	GFile* _tmp23_;
	gboolean _tmp24_ = FALSE;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	GError* _inner_error0_ = NULL;
#line 3788 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 27556 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->row;
#line 3790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 27563 "Photo.c"
		{
			GFile* _tmp1_;
#line 3791 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_file_format = photo_get_file_format (self);
#line 3792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			backing = _tmp1_;
#line 27574 "Photo.c"
		}
		__finally413:
		{
			PhotoRow* _tmp2_;
#line 3790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = self->row;
#line 3790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27583 "Photo.c"
		}
#line 3790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3790 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return NULL;
#line 27593 "Photo.c"
		}
	}
#line 3795 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _vala_file_format;
#line 3795 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_file_format_can_write (_tmp3_)) {
#line 3796 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_file_format = photo_file_format_get_system_default_format ();
#line 27602 "Photo.c"
	}
#line 3799 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = g_file_get_basename (backing);
#line 3799 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 3799 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	disassemble_filename (_tmp5_, &_tmp6_, &_tmp7_);
#line 3799 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (name);
#line 3799 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	name = _tmp6_;
#line 3799 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (ext);
#line 3799 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ext = _tmp7_;
#line 3799 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp5_);
#line 3801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = ext;
#line 3801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp9_ == NULL) {
#line 3801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = TRUE;
#line 27626 "Photo.c"
	} else {
		PhotoFileFormat _tmp10_;
		PhotoFileFormatProperties* _tmp11_;
		PhotoFileFormatProperties* _tmp12_;
		const gchar* _tmp13_;
#line 3801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = _vala_file_format;
#line 3801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = photo_file_format_get_properties (_tmp10_);
#line 3801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 3801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = ext;
#line 3801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = !photo_file_format_properties_is_recognized_extension (_tmp12_, _tmp13_);
#line 3801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp12_);
#line 27644 "Photo.c"
	}
#line 3801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_) {
#line 27648 "Photo.c"
		PhotoFileFormat _tmp14_;
		PhotoFileFormatProperties* _tmp15_;
		PhotoFileFormatProperties* _tmp16_;
		gchar* _tmp17_;
#line 3802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = _vala_file_format;
#line 3802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = photo_file_format_get_properties (_tmp14_);
#line 3802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 3802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = photo_file_format_properties_get_default_extension (_tmp16_);
#line 3802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (ext);
#line 3802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		ext = _tmp17_;
#line 3802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp16_);
#line 27667 "Photo.c"
	}
#line 3804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = name;
#line 3804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = ext;
#line 3804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = g_strdup_printf ("%s_%s.%s", _tmp18_, _ ("modified"), _tmp19_);
#line 3804 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	editable_basename = _tmp20_;
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp22_ = g_file_get_parent (backing);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = _tmp22_;
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp25_ = generate_unique_file (_tmp23_, editable_basename, &_tmp24_, &_inner_error0_);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	collision = _tmp24_;
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = _tmp25_;
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp23_);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = _tmp26_;
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (editable_basename);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (ext);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (name);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (backing);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 27705 "Photo.c"
	}
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27_ = _tmp21_;
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = NULL;
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp27_;
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp21_);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (editable_basename);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (ext);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (name);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (backing);
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (file_format) {
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*file_format = _vala_file_format;
#line 27727 "Photo.c"
	}
#line 3807 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 27731 "Photo.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 27740 "Photo.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 27749 "Photo.c"
}


static gboolean
photo_launch_editor (GFile* file,
                     PhotoFileFormat file_format,
                     GError** error)
{
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* commandline = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	GAppInfo* app = NULL;
	GList* files = NULL;
	GFile* _tmp14_;
	GAppInfo* _tmp15_;
	gchar** argv = NULL;
	gchar** _tmp20_;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
	GPid child_pid = 0;
	gboolean _tmp26_ = FALSE;
	gchar** _tmp27_;
	gint _tmp27__length1;
	GPid _tmp28_ = 0;
	gboolean _tmp29_;
	GError* _inner_error0_ = NULL;
#line 3810 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 3811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (file_format == PHOTO_FILE_FORMAT_RAW) {
#line 27789 "Photo.c"
		ConfigFacade* _tmp1_;
		ConfigFacade* _tmp2_;
		gchar* _tmp3_;
#line 3811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = config_facade_get_instance ();
#line 3811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 3811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = configuration_facade_get_external_raw_app (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 3811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 3811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 27805 "Photo.c"
	} else {
		ConfigFacade* _tmp4_;
		ConfigFacade* _tmp5_;
		gchar* _tmp6_;
#line 3812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = config_facade_get_instance ();
#line 3812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = configuration_facade_get_external_photo_app (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 3812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = _tmp6_;
#line 3812 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 27822 "Photo.c"
	}
#line 3811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = g_strdup (_tmp0_);
#line 3811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	commandline = _tmp7_;
#line 3814 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = commandline;
#line 3814 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (is_string_empty (_tmp8_)) {
#line 3815 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 3815 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (commandline);
#line 3815 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3815 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 27840 "Photo.c"
	}
	{
		GAppInfo* _tmp9_ = NULL;
		const gchar* _tmp10_;
		GAppInfo* _tmp11_;
		GAppInfo* _tmp12_;
#line 3819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = commandline;
#line 3819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = g_app_info_create_from_commandline (_tmp10_, "", G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 3819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = _tmp11_;
#line 3819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27855 "Photo.c"
			goto __catch414_g_error;
		}
#line 3819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = _tmp9_;
#line 3819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = NULL;
#line 3819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		app = _tmp12_;
#line 3818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 27868 "Photo.c"
	}
	goto __finally414;
	__catch414_g_error:
	{
		GError* er = NULL;
#line 3818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		er = _inner_error0_;
#line 3818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 3822 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3822 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		app = NULL;
#line 3818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (er);
#line 27884 "Photo.c"
	}
	__finally414:
#line 3818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27889 "Photo.c"
		gboolean _tmp13_ = FALSE;
#line 3818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (commandline);
#line 3818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3818 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp13_;
#line 27901 "Photo.c"
	}
#line 3825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	files = NULL;
#line 3826 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = _g_object_ref0 (file);
#line 3826 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	files = g_list_insert (files, _tmp14_, -1);
#line 3828 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = app;
#line 3828 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp15_ != NULL) {
#line 27913 "Photo.c"
		gboolean _tmp16_ = FALSE;
		GAppInfo* _tmp17_;
		GList* _tmp18_;
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = app;
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = files;
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = g_app_info_launch (_tmp17_, _tmp18_, NULL, &_inner_error0_);
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27925 "Photo.c"
			gboolean _tmp19_ = FALSE;
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (app);
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (commandline);
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_tmp0_);
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp19_;
#line 27939 "Photo.c"
		}
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = _tmp16_;
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (commandline);
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 27953 "Photo.c"
	}
#line 3831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = g_new0 (gchar*, 2 + 1);
#line 3831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	argv = _tmp20_;
#line 3831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	argv_length1 = 2;
#line 3831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3832 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = argv;
#line 3832 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21__length1 = argv_length1;
#line 3832 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp22_ = commandline;
#line 3832 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 3832 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp21_[0]);
#line 3832 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_[0] = _tmp23_;
#line 3833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_ = argv;
#line 3833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24__length1 = argv_length1;
#line 3833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp25_ = g_file_get_path (file);
#line 3833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp24_[1]);
#line 3833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_[1] = _tmp25_;
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27_ = argv;
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27__length1 = argv_length1;
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = g_spawn_async ("/", _tmp27_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp28_, &_inner_error0_);
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	child_pid = _tmp28_;
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = _tmp29_;
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27997 "Photo.c"
		gboolean _tmp30_ = FALSE;
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (commandline);
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp30_;
#line 28013 "Photo.c"
	}
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp26_;
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (app);
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (commandline);
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 3837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 28029 "Photo.c"
}


void
photo_open_with_raw_external_editor (Photo* self,
                                     GError** error)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 3847 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3848 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 3848 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3848 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_launch_editor (_tmp1_, photo_get_master_file_format (self), &_inner_error0_);
#line 3848 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3848 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3848 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3848 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 28056 "Photo.c"
	}
}


void
photo_open_with_external_editor (Photo* self,
                                 GError** error)
{
	GFile* current_editable_file = NULL;
	GFile* create_editable_file = NULL;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GFile* _tmp16_;
	gboolean _tmp22_ = FALSE;
	GFile* _tmp23_;
	GFile* _tmp40_;
	GFileMonitor* _tmp41_;
	GFile* _tmp43_;
	GError* _inner_error0_ = NULL;
#line 3852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3853 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	current_editable_file = NULL;
#line 3854 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	create_editable_file = NULL;
#line 28083 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28090 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			GFile* _tmp6_;
#line 3857 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3857 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3857 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 28101 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 3858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				current_editable_file = _tmp5_;
#line 28115 "Photo.c"
			}
#line 3860 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3860 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 28121 "Photo.c"
				GFile* _tmp7_ = NULL;
				PhotoFileFormat _tmp8_ = 0;
				GFile* _tmp9_;
				GFile* _tmp10_;
#line 3861 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = photo_generate_new_editable_file (self, &_tmp8_, &_inner_error0_);
#line 3861 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				editable_file_format = _tmp8_;
#line 3861 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _tmp9_;
#line 3861 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28134 "Photo.c"
					goto __finally415;
				}
#line 3861 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _tmp7_;
#line 3861 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = NULL;
#line 3861 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3861 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				create_editable_file = _tmp10_;
#line 3860 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 28147 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp11_;
				PhotoFileReader* _tmp12_;
#line 3863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = self->priv->readers;
#line 3863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = _tmp11_->editable;
#line 3863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				editable_file_format = photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 28157 "Photo.c"
			}
		}
		__finally415:
		{
			GError* _inner_error1_ = NULL;
			PhotoBackingReaders* _tmp13_;
#line 3856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 3856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28168 "Photo.c"
		}
#line 3856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 28180 "Photo.c"
		}
	}
#line 3868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = create_editable_file;
#line 3868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 28187 "Photo.c"
		GFile* _tmp17_;
#line 3868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = current_editable_file;
#line 3868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = _tmp17_ != NULL;
#line 28193 "Photo.c"
	} else {
#line 3868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = FALSE;
#line 28197 "Photo.c"
	}
#line 3868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp15_) {
#line 28201 "Photo.c"
		gboolean _tmp18_ = FALSE;
		GFile* _tmp19_;
#line 3869 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = current_editable_file;
#line 3869 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (!g_file_query_exists (_tmp19_, NULL)) {
#line 3869 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp18_ = TRUE;
#line 28210 "Photo.c"
		} else {
#line 3869 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp18_ = photo_has_transformations (self);
#line 28214 "Photo.c"
		}
#line 3869 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = _tmp18_;
#line 28218 "Photo.c"
	} else {
#line 3868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = FALSE;
#line 28222 "Photo.c"
	}
#line 3868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp14_) {
#line 28226 "Photo.c"
		GFile* _tmp20_;
		GFile* _tmp21_;
#line 3870 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3870 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 3870 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3870 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		create_editable_file = _tmp21_;
#line 28237 "Photo.c"
	}
#line 3873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = create_editable_file;
#line 3873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 28243 "Photo.c"
		PhotoFileFormat _tmp24_;
#line 3873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp24_ = editable_file_format;
#line 3873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = photo_file_format_can_write (_tmp24_);
#line 28249 "Photo.c"
	} else {
#line 3873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = FALSE;
#line 28253 "Photo.c"
	}
#line 3873 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp22_) {
#line 28257 "Photo.c"
		PhotoFileFormat _tmp36_;
		GFile* _tmp37_;
		GFile* _tmp38_;
		GFile* _tmp39_;
#line 3874 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 28264 "Photo.c"
		{
			GFile* _tmp25_;
			Scaling _tmp26_ = {0};
			PhotoFileFormat _tmp27_;
#line 3877 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp25_ = create_editable_file;
#line 3877 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			scaling_for_original (&_tmp26_);
#line 3877 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp27_ = editable_file_format;
#line 3877 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_export (self, _tmp25_, &_tmp26_, JPEG_QUALITY_MAXIMUM, _tmp27_, FALSE, TRUE, &_inner_error0_);
#line 3877 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28279 "Photo.c"
				goto __catch416_g_error;
			}
		}
		goto __finally416;
		__catch416_g_error:
		{
			GError* err = NULL;
			GError* _tmp34_;
			GError* _tmp35_;
#line 3876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			err = _inner_error0_;
#line 3876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_inner_error0_ = NULL;
#line 28293 "Photo.c"
			{
				GFile* _tmp28_;
#line 3882 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = create_editable_file;
#line 3882 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_file_delete (_tmp28_, NULL, &_inner_error0_);
#line 3882 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28302 "Photo.c"
					goto __catch417_g_error;
				}
			}
			goto __finally417;
			__catch417_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				GError* _tmp32_;
				const gchar* _tmp33_;
#line 3881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				delete_err = _inner_error0_;
#line 3881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_inner_error0_ = NULL;
#line 3885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = create_editable_file;
#line 3885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp30_ = g_file_get_path (_tmp29_);
#line 3885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 3885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp32_ = delete_err;
#line 3885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp33_ = _tmp32_->message;
#line 3885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_warning ("Photo.vala:3885: Unable to delete editable file %s after export error:" \
" %s", _tmp31_, _tmp33_);
#line 3885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp31_);
#line 3881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (delete_err);
#line 28335 "Photo.c"
			}
			__finally417:
#line 3881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_error_free0 (err);
#line 3881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 3881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 28352 "Photo.c"
			}
#line 3889 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp34_ = err;
#line 3889 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp35_ = _g_error_copy0 (_tmp34_);
#line 3889 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_inner_error0_ = _tmp35_;
#line 3889 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_error_free0 (err);
#line 28362 "Photo.c"
			goto __finally416;
		}
		__finally416:
#line 3876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 28376 "Photo.c"
		}
#line 3893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp36_ = editable_file_format;
#line 3893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp37_ = create_editable_file;
#line 3893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_attach_editable (self, _tmp36_, _tmp37_, &_inner_error0_);
#line 3893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3893 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 28394 "Photo.c"
		}
#line 3895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp38_ = create_editable_file;
#line 3895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp39_ = _g_object_ref0 (_tmp38_);
#line 3895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		current_editable_file = _tmp39_;
#line 28404 "Photo.c"
	}
#line 3898 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp40_ = current_editable_file;
#line 3898 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (_tmp40_ != NULL, "current_editable_file != null");
#line 3901 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp41_ = self->priv->editable_monitor;
#line 3901 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp41_ == NULL) {
#line 28414 "Photo.c"
		GFile* _tmp42_;
#line 3902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp42_ = current_editable_file;
#line 3902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp42_, &_inner_error0_);
#line 3902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 28430 "Photo.c"
		}
	}
#line 3904 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp43_ = current_editable_file;
#line 3904 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_launch_editor (_tmp43_, photo_get_file_format (self), &_inner_error0_);
#line 3904 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3904 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3904 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3904 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3904 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 28447 "Photo.c"
	}
#line 3852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (current_editable_file);
#line 28453 "Photo.c"
}


void
photo_revert_to_master (Photo* self,
                        gboolean notify)
{
#line 3907 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, notify);
#line 28465 "Photo.c"
}


static void
_photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                        GFile* file,
                                                        GFile* other_file,
                                                        GFileMonitorEvent event_type,
                                                        gpointer self)
{
#line 3918 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_on_editable_file_changed ((Photo*) self, file, other_file, event_type);
#line 28478 "Photo.c"
}


static void
photo_start_monitoring_editable (Photo* self,
                                 GFile* file,
                                 GError** error)
{
	GFileMonitor* _tmp0_ = NULL;
	GFileMonitor* _tmp1_;
	GFileMonitor* _tmp2_;
	GFileMonitor* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 3912 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_monitor_blacklist_file (file, "Photo.start_monitoring_editable");
#line 3917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 3917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 28510 "Photo.c"
	}
#line 3917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 3917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 3917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3917 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->editable_monitor = _tmp2_;
#line 3918 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = self->priv->editable_monitor;
#line 3918 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 3911 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 28526 "Photo.c"
}


static void
photo_halt_monitoring_editable (Photo* self)
{
	GFileMonitor* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileMonitor* _tmp4_;
	guint _tmp5_;
	GFileMonitor* _tmp6_;
#line 3921 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3922 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3922 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3923 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 28548 "Photo.c"
	}
#line 3926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = _tmp1_;
#line 3927 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = file;
#line 3927 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 28558 "Photo.c"
		GFile* _tmp3_;
#line 3928 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = file;
#line 3928 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 28564 "Photo.c"
	}
#line 3930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3931 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3931 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3932 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3932 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3921 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 28582 "Photo.c"
}


static void
photo_attach_editable (Photo* self,
                       PhotoFileFormat file_format,
                       GFile* file,
                       GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3935 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3935 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 3940 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_remove_all_transformations (self, FALSE);
#line 3941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 3941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_file_format_create_reader (file_format, _tmp1_);
#line 3941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp3_, &_inner_error0_);
#line 3941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 3941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 3941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 28623 "Photo.c"
	}
}


static void
photo_update_editable_attributes (Photo* self,
                                  GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3945 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error0_);
#line 3945 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3945 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3945 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 28643 "Photo.c"
	}
}


void
photo_reimport_editable (Photo* self,
                         GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3948 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3949 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error0_);
#line 3949 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3949 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3949 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 28663 "Photo.c"
	}
}


static void
_vala_array_add103 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 4056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28680 "Photo.c"
	}
#line 4056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 28686 "Photo.c"
}


static void
_vala_array_add104 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 4057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28702 "Photo.c"
	}
#line 4057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 28708 "Photo.c"
}


static void
_vala_array_add105 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 4060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28724 "Photo.c"
	}
#line 4060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 28730 "Photo.c"
}


static void
_vala_array_add106 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 4064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28746 "Photo.c"
	}
#line 4064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 28752 "Photo.c"
}


static void
_vala_array_add107 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 4065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28768 "Photo.c"
	}
#line 4065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 28774 "Photo.c"
}


static void
_vala_array_add108 (gchar** * array,
                    int* length,
                    int* size,
                    gchar* value)
{
#line 4068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 4068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 28790 "Photo.c"
	}
#line 4068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 28796 "Photo.c"
}


static void
photo_update_editable (Photo* self,
                       gboolean only_attributes,
                       PhotoFileReader* new_reader,
                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	PhotoFileReader* old_reader = NULL;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_ = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp5_;
	PhotoFileReader* _tmp6_;
	gboolean timestamp_changed = FALSE;
	gboolean filesize_changed = FALSE;
	gboolean is_new_editable = FALSE;
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp7_ = {0};
	GFile* file = NULL;
	PhotoFileReader* _tmp8_;
	GFile* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp10_;
	DetectedPhotoInformation* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_;
	gboolean _tmp87_ = FALSE;
	gchar** alteration_list = NULL;
	gchar** _tmp96_;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp97_;
	gboolean _tmp104_ = FALSE;
	gboolean _tmp105_;
	gchar** _tmp112_;
	gint _tmp112__length1;
	GError* _inner_error0_ = NULL;
#line 3954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((new_reader == NULL) || IS_PHOTO_FILE_READER (new_reader));
#line 3956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (only_attributes) {
#line 3956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = new_reader == NULL;
#line 28846 "Photo.c"
	} else {
#line 3956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 28850 "Photo.c"
	}
#line 3956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_) {
#line 3956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 28856 "Photo.c"
	} else {
#line 3956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = !only_attributes;
#line 28860 "Photo.c"
	}
#line 3956 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (_tmp0_, "(only_attributes && new_reader == null) || (!only_attributes)");
#line 3958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_get_editable_reader (self);
#line 3958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old_reader = _tmp2_;
#line 3960 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = new_reader;
#line 3960 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 28872 "Photo.c"
		PhotoFileReader* _tmp4_;
#line 3960 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = old_reader;
#line 3960 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp4_;
#line 28878 "Photo.c"
	}
#line 3960 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = _photo_file_adapter_ref0 (_tmp3_);
#line 3960 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	reader = _tmp5_;
#line 3961 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = reader;
#line 3961 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 3962 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3964 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3964 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3964 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 28896 "Photo.c"
	}
#line 3967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	timestamp_changed = FALSE;
#line 3968 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	filesize_changed = FALSE;
#line 3969 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	is_new_editable = FALSE;
#line 3971 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_editable_id (self, &_tmp7_);
#line 3971 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	editable_id = _tmp7_;
#line 3972 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = reader;
#line 3972 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 3972 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = _tmp9_;
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = file;
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = photo_query_backing_photo_row (self, _tmp10_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp11_, &_inner_error0_);
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	detected = _tmp11_;
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	backing = _tmp12_;
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 28938 "Photo.c"
	}
#line 3979 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 28942 "Photo.c"
		BackingPhotoRow* _tmp13_;
#line 3981 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = backing;
#line 3981 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp13_ != NULL) {
#line 28948 "Photo.c"
			BackingPhotoTable* _tmp14_;
			BackingPhotoTable* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp16_ = backing;
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			backing_photo_table_add (_tmp15_, _tmp16_, &_inner_error0_);
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3982 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 28978 "Photo.c"
			}
			{
				PhotoRow* _tmp17_;
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = self->row;
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28986 "Photo.c"
				{
					PhotoTable* _tmp18_;
					PhotoTable* _tmp19_;
					PhotoRow* _tmp20_;
					BackingPhotoRow* _tmp21_;
					BackingPhotoID _tmp22_;
					BackingPhotoRow* _tmp23_;
					BackingPhotoRow* _tmp24_;
					BackingPhotoRow* _tmp25_;
					BackingPhotoRow* _tmp26_;
					BackingPhotoRow* _tmp27_;
					Orientation _tmp28_;
#line 3984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					timestamp_changed = TRUE;
#line 3985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					filesize_changed = TRUE;
#line 3987 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp18_ = photo_table_get_instance ();
#line 3987 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 3987 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp20_ = self->row;
#line 3987 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp21_ = backing;
#line 3987 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp22_ = _tmp21_->id;
#line 3987 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					photo_table_attach_editable (_tmp19_, _tmp20_, &_tmp22_, &_inner_error0_);
#line 3987 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_database_table_unref0 (_tmp19_);
#line 3987 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29019 "Photo.c"
						goto __finally418;
					}
#line 3988 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp23_ = backing;
#line 3988 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp24_ = _backing_photo_row_ref0 (_tmp23_);
#line 3988 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3988 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					self->priv->editable = _tmp24_;
#line 3989 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp25_ = self->priv->editable;
#line 3989 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp26_ = _backing_photo_row_ref0 (_tmp25_);
#line 3989 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3989 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					self->backing_photo_row = _tmp26_;
#line 3990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp27_ = self->backing_photo_row;
#line 3990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp28_ = _tmp27_->original_orientation;
#line 3990 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					photo_set_orientation (self, _tmp28_);
#line 29044 "Photo.c"
				}
				__finally418:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp29_;
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp29_ = self->row;
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 29054 "Photo.c"
				}
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (file);
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 29072 "Photo.c"
				}
			}
		}
#line 3993 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		is_new_editable = TRUE;
#line 29078 "Photo.c"
	}
#line 3996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (only_attributes) {
#line 29082 "Photo.c"
		GFileInfo* info = NULL;
		GTimeVal timestamp = {0};
		GFileInfo* _tmp38_;
		GTimeVal _tmp39_ = {0};
		BackingPhotoTable* _tmp40_;
		BackingPhotoTable* _tmp41_;
		BackingPhotoID _tmp42_;
		GTimeVal _tmp43_;
		glong _tmp44_;
		GFileInfo* _tmp45_;
#line 3998 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_assert (backing_photo_id_is_valid (&editable_id), "editable_id.is_valid()");
#line 29095 "Photo.c"
		{
			GFileInfo* _tmp30_ = NULL;
			GFile* _tmp31_;
			GFileInfo* _tmp32_;
			GFileInfo* _tmp33_;
#line 4002 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp31_ = file;
#line 4002 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp32_ = g_file_query_filesystem_info (_tmp31_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error0_);
#line 4002 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp30_ = _tmp32_;
#line 4002 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29109 "Photo.c"
				goto __catch419_g_error;
			}
#line 4002 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp33_ = _tmp30_;
#line 4002 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp30_ = NULL;
#line 4002 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 4002 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			info = _tmp33_;
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp30_);
#line 29122 "Photo.c"
		}
		goto __finally419;
		__catch419_g_error:
		{
			GError* err = NULL;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			err = _inner_error0_;
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_inner_error0_ = NULL;
#line 4004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp34_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 4004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36_ = err;
#line 4004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp37_ = _tmp36_->message;
#line 4004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_warning ("Photo.vala:4004: Unable to read editable filesystem info for %s: %s", _tmp35_, _tmp37_);
#line 4004 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_tmp35_);
#line 4005 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4007 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_error_free0 (err);
#line 4007 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 4007 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4007 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4007 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 4007 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4007 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4007 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 29166 "Photo.c"
		}
		__finally419:
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4001 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 29187 "Photo.c"
		}
#line 4010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp38_ = info;
#line 4010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_file_info_get_modification_time (_tmp38_, &_tmp39_);
#line 4010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		timestamp = _tmp39_;
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp40_ = backing_photo_table_get_instance ();
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp41_ = _tmp40_;
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp42_ = editable_id;
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp43_ = timestamp;
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp44_ = _tmp43_.tv_sec;
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp45_ = info;
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		backing_photo_table_update_attributes (_tmp41_, &_tmp42_, (time_t) _tmp44_, g_file_info_get_size (_tmp45_), &_inner_error0_);
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_database_table_unref0 (_tmp41_);
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4012 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 29229 "Photo.c"
		}
		{
			PhotoRow* _tmp46_;
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp46_ = self->row;
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 29237 "Photo.c"
			{
				BackingPhotoRow* _tmp47_;
				time_t _tmp48_;
				GTimeVal _tmp49_;
				glong _tmp50_;
				BackingPhotoRow* _tmp51_;
				gint64 _tmp52_;
				GFileInfo* _tmp53_;
				BackingPhotoRow* _tmp54_;
				GTimeVal _tmp55_;
				glong _tmp56_;
				BackingPhotoRow* _tmp57_;
				GFileInfo* _tmp58_;
#line 4015 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp47_ = self->priv->editable;
#line 4015 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp48_ = _tmp47_->timestamp;
#line 4015 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp49_ = timestamp;
#line 4015 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp50_ = _tmp49_.tv_sec;
#line 4015 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				timestamp_changed = _tmp48_ != ((time_t) _tmp50_);
#line 4016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp51_ = self->priv->editable;
#line 4016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp52_ = _tmp51_->filesize;
#line 4016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp53_ = info;
#line 4016 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				filesize_changed = _tmp52_ != g_file_info_get_size (_tmp53_);
#line 4018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp54_ = self->priv->editable;
#line 4018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp55_ = timestamp;
#line 4018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp56_ = _tmp55_.tv_sec;
#line 4018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp54_->timestamp = (time_t) _tmp56_;
#line 4019 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp57_ = self->priv->editable;
#line 4019 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp58_ = info;
#line 4019 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp57_->filesize = g_file_info_get_size (_tmp58_);
#line 29283 "Photo.c"
			}
			__finally420:
			{
				PhotoRow* _tmp59_;
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp59_ = self->row;
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 29292 "Photo.c"
			}
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (info);
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4014 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 29312 "Photo.c"
			}
		}
#line 3996 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 29317 "Photo.c"
	} else {
		gboolean _tmp60_ = FALSE;
#line 4023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (backing_photo_id_is_valid (&editable_id)) {
#line 29322 "Photo.c"
			gboolean _tmp61_;
#line 4023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp61_ = is_new_editable;
#line 4023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp60_ = !_tmp61_;
#line 29328 "Photo.c"
		} else {
#line 4023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp60_ = FALSE;
#line 29332 "Photo.c"
		}
#line 4023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp60_) {
#line 29336 "Photo.c"
			BackingPhotoRow* _tmp62_;
			BackingPhotoID _tmp63_;
			BackingPhotoTable* _tmp64_;
			BackingPhotoTable* _tmp65_;
			BackingPhotoRow* _tmp66_;
#line 4028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp62_ = backing;
#line 4028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp63_ = editable_id;
#line 4028 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp62_->id = _tmp63_;
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp64_ = backing_photo_table_get_instance ();
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp65_ = _tmp64_;
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp66_ = backing;
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			backing_photo_table_update (_tmp65_, _tmp66_, &_inner_error0_);
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp65_);
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4029 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 29374 "Photo.c"
			}
			{
				PhotoRow* _tmp67_;
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp67_ = self->row;
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 29382 "Photo.c"
				{
					BackingPhotoRow* _tmp68_;
					time_t _tmp69_;
					BackingPhotoRow* _tmp70_;
					time_t _tmp71_;
					BackingPhotoRow* _tmp72_;
					gint64 _tmp73_;
					BackingPhotoRow* _tmp74_;
					gint64 _tmp75_;
					BackingPhotoRow* _tmp76_;
					BackingPhotoRow* _tmp77_;
					BackingPhotoRow* _tmp78_;
					BackingPhotoRow* _tmp79_;
					BackingPhotoRow* _tmp80_;
					Orientation _tmp81_;
#line 4031 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp68_ = self->priv->editable;
#line 4031 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp69_ = _tmp68_->timestamp;
#line 4031 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp70_ = backing;
#line 4031 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp71_ = _tmp70_->timestamp;
#line 4031 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					timestamp_changed = _tmp69_ != _tmp71_;
#line 4032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp72_ = self->priv->editable;
#line 4032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp73_ = _tmp72_->filesize;
#line 4032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp74_ = backing;
#line 4032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp75_ = _tmp74_->filesize;
#line 4032 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					filesize_changed = _tmp73_ != _tmp75_;
#line 4034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp76_ = backing;
#line 4034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp77_ = _backing_photo_row_ref0 (_tmp76_);
#line 4034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 4034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					self->priv->editable = _tmp77_;
#line 4035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp78_ = self->priv->editable;
#line 4035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp79_ = _backing_photo_row_ref0 (_tmp78_);
#line 4035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4035 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					self->backing_photo_row = _tmp79_;
#line 4036 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp80_ = self->backing_photo_row;
#line 4036 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp81_ = _tmp80_->original_orientation;
#line 4036 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					photo_set_orientation (self, _tmp81_);
#line 29440 "Photo.c"
				}
				__finally421:
				{
					PhotoRow* _tmp82_;
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp82_ = self->row;
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 29449 "Photo.c"
				}
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (file);
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 4030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 29467 "Photo.c"
				}
			}
		}
	}
#line 4042 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (new_reader != NULL) {
#line 29474 "Photo.c"
		{
			PhotoBackingReaders* _tmp83_;
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp83_ = self->priv->readers;
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_readers);
#line 29481 "Photo.c"
			{
				PhotoBackingReaders* _tmp84_;
				PhotoFileReader* _tmp85_;
#line 4044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp84_ = self->priv->readers;
#line 4044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp85_ = _photo_file_adapter_ref0 (new_reader);
#line 4044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp84_->editable);
#line 4044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp84_->editable = _tmp85_;
#line 29493 "Photo.c"
			}
			__finally422:
			{
				PhotoBackingReaders* _tmp86_;
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp86_ = self->priv->readers;
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29502 "Photo.c"
			}
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4043 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 29520 "Photo.c"
			}
		}
	}
#line 4048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!only_attributes) {
#line 29526 "Photo.c"
		PhotoFileReader* _tmp88_;
		PhotoFileReader* _tmp89_;
#line 4048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp88_ = reader;
#line 4048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp89_ = old_reader;
#line 4048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp87_ = _tmp88_ != _tmp89_;
#line 29535 "Photo.c"
	} else {
#line 4048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp87_ = FALSE;
#line 29539 "Photo.c"
	}
#line 4048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp87_) {
#line 29543 "Photo.c"
		GFile* _tmp90_ = NULL;
		PhotoFileReader* _tmp91_;
		GFile* _tmp94_ = NULL;
#line 4049 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4050 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp91_ = old_reader;
#line 4050 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp91_ != NULL) {
#line 29553 "Photo.c"
			PhotoFileReader* _tmp92_;
			GFile* _tmp93_;
#line 4050 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp92_ = old_reader;
#line 4050 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp93_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp92_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4050 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp90_);
#line 4050 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp90_ = _tmp93_;
#line 29564 "Photo.c"
		} else {
#line 4050 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp90_);
#line 4050 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp90_ = NULL;
#line 29570 "Photo.c"
		}
#line 4051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (new_reader != NULL) {
#line 29574 "Photo.c"
			GFile* _tmp95_;
#line 4051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp95_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (new_reader, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp94_);
#line 4051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp94_ = _tmp95_;
#line 29582 "Photo.c"
		} else {
#line 4051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp94_);
#line 4051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp94_ = NULL;
#line 29588 "Photo.c"
		}
#line 4050 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp90_, _tmp94_);
#line 4048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp94_);
#line 4048 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp90_);
#line 29596 "Photo.c"
	}
#line 4054 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp96_ = g_new0 (gchar*, 0 + 1);
#line 4054 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	alteration_list = _tmp96_;
#line 4054 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	alteration_list_length1 = 0;
#line 4054 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 4055 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp97_ = timestamp_changed;
#line 4055 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp97_) {
#line 29610 "Photo.c"
		gchar** _tmp98_;
		gint _tmp98__length1;
		gchar* _tmp99_;
		gchar** _tmp100_;
		gint _tmp100__length1;
		gchar* _tmp101_;
#line 4056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp98_ = alteration_list;
#line 4056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp98__length1 = alteration_list_length1;
#line 4056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp99_ = g_strdup ("metadata:editable-timestamp");
#line 4056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_array_add103 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp99_);
#line 4057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp100_ = alteration_list;
#line 4057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp100__length1 = alteration_list_length1;
#line 4057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp101_ = g_strdup ("metadata:baseline-timestamp");
#line 4057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_array_add104 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp101_);
#line 4059 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 29635 "Photo.c"
			gchar** _tmp102_;
			gint _tmp102__length1;
			gchar* _tmp103_;
#line 4060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp102_ = alteration_list;
#line 4060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp102__length1 = alteration_list_length1;
#line 4060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp103_ = g_strdup ("metadata:source-timestamp");
#line 4060 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add105 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp103_);
#line 29647 "Photo.c"
		}
	}
#line 4063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp105_ = filesize_changed;
#line 4063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp105_) {
#line 4063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp104_ = TRUE;
#line 29656 "Photo.c"
	} else {
#line 4063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp104_ = new_reader != NULL;
#line 29660 "Photo.c"
	}
#line 4063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp104_) {
#line 29664 "Photo.c"
		gchar** _tmp106_;
		gint _tmp106__length1;
		gchar* _tmp107_;
		gchar** _tmp108_;
		gint _tmp108__length1;
		gchar* _tmp109_;
#line 4064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp106_ = alteration_list;
#line 4064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp106__length1 = alteration_list_length1;
#line 4064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp107_ = g_strdup ("image:editable");
#line 4064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_array_add106 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp107_);
#line 4065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp108_ = alteration_list;
#line 4065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp108__length1 = alteration_list_length1;
#line 4065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp109_ = g_strdup ("image:baseline");
#line 4065 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_array_add107 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp109_);
#line 4067 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 29689 "Photo.c"
			gchar** _tmp110_;
			gint _tmp110__length1;
			gchar* _tmp111_;
#line 4068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp110_ = alteration_list;
#line 4068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp110__length1 = alteration_list_length1;
#line 4068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp111_ = g_strdup ("image:source");
#line 4068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_array_add108 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp111_);
#line 29701 "Photo.c"
		}
	}
#line 4071 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp112_ = alteration_list;
#line 4071 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp112__length1 = alteration_list_length1;
#line 4071 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp112__length1 > 0) {
#line 29710 "Photo.c"
		gchar** _tmp113_;
		gint _tmp113__length1;
		Alteration* _tmp114_;
		Alteration* _tmp115_;
#line 4072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp113_ = alteration_list;
#line 4072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp113__length1 = alteration_list_length1;
#line 4072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp114_ = alteration_new_from_array (_tmp113_, _tmp113__length1);
#line 4072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp115_ = _tmp114_;
#line 4072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp115_);
#line 4072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp115_);
#line 29727 "Photo.c"
	}
#line 3954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 3954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3954 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 29741 "Photo.c"
}


static void
photo_detach_editable (Photo* self,
                       gboolean delete_editable,
                       gboolean remove_transformations,
                       gboolean notify)
{
	gboolean has_editable = FALSE;
	GFile* editable_file = NULL;
	gboolean _tmp8_;
	gboolean _tmp26_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_;
	GError* _inner_error0_ = NULL;
#line 4075 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4076 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 4078 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	has_editable = FALSE;
#line 4079 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	editable_file = NULL;
#line 29768 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 29775 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 4081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 4081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 4081 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 29785 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
				PhotoBackingReaders* _tmp6_;
#line 4082 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 4082 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 4082 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4082 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 4082 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				editable_file = _tmp5_;
#line 4083 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 4083 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 4083 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_->editable = NULL;
#line 4084 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				has_editable = TRUE;
#line 29808 "Photo.c"
			}
		}
		__finally423:
		{
			PhotoBackingReaders* _tmp7_;
#line 4080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 4080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29818 "Photo.c"
		}
#line 4080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4080 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 29830 "Photo.c"
		}
	}
#line 4088 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = has_editable;
#line 4088 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_) {
#line 29837 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 4089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 29841 "Photo.c"
		{
			{
				PhotoRow* _tmp9_;
#line 4091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = self->row;
#line 4091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 29849 "Photo.c"
				{
					PhotoRow* _tmp10_;
					BackingPhotoID _tmp11_;
					PhotoRow* _tmp15_;
					BackingPhotoRow* _tmp16_;
					BackingPhotoRow* _tmp17_;
#line 4092 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = self->row;
#line 4092 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_ = _tmp10_->editable_id;
#line 4092 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					editable_id = _tmp11_;
#line 4093 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (backing_photo_id_is_valid (&editable_id)) {
#line 29864 "Photo.c"
						PhotoTable* _tmp12_;
						PhotoTable* _tmp13_;
						PhotoRow* _tmp14_;
#line 4094 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp12_ = photo_table_get_instance ();
#line 4094 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp13_ = _tmp12_;
#line 4094 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp14_ = self->row;
#line 4094 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						photo_table_detach_editable (_tmp13_, _tmp14_, &_inner_error0_);
#line 4094 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_database_table_unref0 (_tmp13_);
#line 4094 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29880 "Photo.c"
							goto __finally425;
						}
					}
#line 4095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp15_ = self->row;
#line 4095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp16_ = _tmp15_->master;
#line 4095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp17_ = _backing_photo_row_ref0 (_tmp16_);
#line 4095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					self->backing_photo_row = _tmp17_;
#line 29894 "Photo.c"
				}
				__finally425:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp18_;
#line 4091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp18_ = self->row;
#line 4091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 29904 "Photo.c"
				}
#line 4091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 29910 "Photo.c"
						goto __catch424_database_error;
					}
#line 4091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 4091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 29921 "Photo.c"
				}
			}
		}
		goto __finally424;
		__catch424_database_error:
		{
			GError* err = NULL;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 4090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			err = _inner_error0_;
#line 4090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_inner_error0_ = NULL;
#line 4098 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp19_ = err;
#line 4098 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp20_ = _tmp19_->message;
#line 4098 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_warning ("Photo.vala:4098: Unable to remove editable from PhotoTable: %s", _tmp20_);
#line 4090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_error_free0 (err);
#line 29943 "Photo.c"
		}
		__finally424:
#line 4090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4090 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 29956 "Photo.c"
		}
		{
#line 4102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (backing_photo_id_is_valid (&editable_id)) {
#line 29961 "Photo.c"
				BackingPhotoTable* _tmp21_;
				BackingPhotoTable* _tmp22_;
				BackingPhotoID _tmp23_;
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = backing_photo_table_get_instance ();
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = _tmp21_;
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = editable_id;
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				backing_photo_table_remove (_tmp22_, &_tmp23_, &_inner_error0_);
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_database_table_unref0 (_tmp22_);
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 29979 "Photo.c"
						goto __catch426_database_error;
					}
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4103 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 29990 "Photo.c"
				}
			}
		}
		goto __finally426;
		__catch426_database_error:
		{
			GError* err = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 4101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			err = _inner_error0_;
#line 4101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_inner_error0_ = NULL;
#line 4105 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp24_ = err;
#line 4105 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp25_ = _tmp24_->message;
#line 4105 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_warning ("Photo.vala:4105: Unable to remove editable from BackingPhotoTable: %s", _tmp25_);
#line 4101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_error_free0 (err);
#line 30012 "Photo.c"
		}
		__finally426:
#line 4101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 30025 "Photo.c"
		}
	}
#line 4109 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (remove_transformations) {
#line 4110 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_remove_all_transformations (self, FALSE);
#line 30032 "Photo.c"
	}
#line 4112 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = has_editable;
#line 4112 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp26_) {
#line 30038 "Photo.c"
		GFile* _tmp27_;
#line 4113 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4114 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp27_ = editable_file;
#line 4114 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp27_, NULL);
#line 30046 "Photo.c"
	}
#line 4117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (delete_editable) {
#line 30050 "Photo.c"
		GFile* _tmp29_;
#line 4117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp29_ = editable_file;
#line 4117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp28_ = _tmp29_ != NULL;
#line 30056 "Photo.c"
	} else {
#line 4117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp28_ = FALSE;
#line 30060 "Photo.c"
	}
#line 4117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp28_) {
#line 30064 "Photo.c"
		{
			GFile* _tmp30_;
#line 4119 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp30_ = editable_file;
#line 4119 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_file_trash (_tmp30_, NULL, &_inner_error0_);
#line 4119 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 30073 "Photo.c"
				goto __catch427_g_error;
			}
		}
		goto __finally427;
		__catch427_g_error:
		{
			GError* err = NULL;
			GFile* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 4118 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			err = _inner_error0_;
#line 4118 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_inner_error0_ = NULL;
#line 4121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp31_ = editable_file;
#line 4121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp32_ = g_file_get_path (_tmp31_);
#line 4121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp33_ = _tmp32_;
#line 4121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp34_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 4121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36_ = err;
#line 4121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp37_ = _tmp36_->message;
#line 4121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_warning ("Photo.vala:4121: Unable to trash editable %s for %s: %s", _tmp33_, _tmp35_, _tmp37_);
#line 4121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_tmp35_);
#line 4121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (_tmp33_);
#line 4118 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_error_free0 (err);
#line 30114 "Photo.c"
		}
		__finally427:
#line 4118 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4118 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4118 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4118 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4118 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 30127 "Photo.c"
		}
	}
#line 4126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp40_ = has_editable;
#line 4126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp40_) {
#line 4126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp39_ = TRUE;
#line 30136 "Photo.c"
	} else {
#line 4126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp39_ = remove_transformations;
#line 30140 "Photo.c"
	}
#line 4126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp39_) {
#line 4126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp38_ = notify;
#line 30146 "Photo.c"
	} else {
#line 4126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp38_ = FALSE;
#line 30150 "Photo.c"
	}
#line 4126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp38_) {
#line 30154 "Photo.c"
		Alteration* _tmp41_;
		Alteration* _tmp42_;
#line 4127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp41_ = alteration_new ("image", "revert");
#line 4127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 4127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp42_);
#line 4127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_alteration_unref0 (_tmp42_);
#line 30165 "Photo.c"
	}
#line 4075 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 30169 "Photo.c"
}


static void
_photo_on_reimport_editable_one_shot_callback (gpointer self)
{
#line 4149 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_on_reimport_editable ((Photo*) self);
#line 30178 "Photo.c"
}


static void
_photo_on_update_editable_attributes_one_shot_callback (gpointer self)
{
#line 4158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_on_update_editable_attributes ((Photo*) self);
#line 30187 "Photo.c"
}


static void
_photo_on_remove_editable_one_shot_callback (gpointer self)
{
#line 4167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_on_remove_editable ((Photo*) self);
#line 30196 "Photo.c"
}


static void
photo_on_editable_file_changed (Photo* self,
                                GFile* file,
                                GFile* other_file,
                                GFileMonitorEvent event)
{
	GEnumValue* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 4130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 4130 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((other_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (other_file, g_file_get_type ()));
#line 30216 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 30223 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp3_;
			PhotoFileReader* _tmp4_;
			GFile* _tmp5_;
			GFile* _tmp6_;
			gboolean _tmp7_;
#line 4133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 4133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 4133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_vala_assert (_tmp2_ != NULL, "readers.editable != null");
#line 4135 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = self->priv->readers;
#line 4135 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp3_->editable;
#line 4135 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4135 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 4135 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = !g_file_equal (file, _tmp6_);
#line 4135 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp6_);
#line 4135 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp7_) {
#line 30252 "Photo.c"
				{
					PhotoBackingReaders* _tmp8_;
#line 4132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp8_ = self->priv->readers;
#line 4132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 30259 "Photo.c"
				}
#line 4139 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 30263 "Photo.c"
			}
		}
		__finally428:
		{
			PhotoBackingReaders* _tmp9_;
#line 4132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = self->priv->readers;
#line 4132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 30273 "Photo.c"
		}
#line 4132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 30283 "Photo.c"
		}
	}
#line 4143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 4143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = g_file_get_path (file);
#line 4143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 4143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_debug ("Photo.vala:4143: EDITABLE %s: %s", (_tmp10_ != NULL) ? _tmp10_->value_name : NULL, _tmp12_);
#line 4143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp12_);
#line 4145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	switch (event) {
#line 4145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 4145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 30302 "Photo.c"
		{
			OneShotScheduler* _tmp13_;
			OneShotScheduler* _tmp15_;
#line 4148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = self->priv->reimport_editable_scheduler;
#line 4148 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp13_ == NULL) {
#line 30310 "Photo.c"
				OneShotScheduler* _tmp14_;
#line 4149 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 4149 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 4149 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp14_;
#line 30318 "Photo.c"
			}
#line 4153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = self->priv->reimport_editable_scheduler;
#line 4153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp15_, (guint) 1000, TRUE);
#line 4154 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 30326 "Photo.c"
		}
#line 4145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 30330 "Photo.c"
		{
			OneShotScheduler* _tmp16_;
			OneShotScheduler* _tmp18_;
#line 4157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp16_ = self->priv->update_editable_attributes_scheduler;
#line 4157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp16_ == NULL) {
#line 30338 "Photo.c"
				OneShotScheduler* _tmp17_;
#line 4158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 4158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 4158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp17_;
#line 30346 "Photo.c"
			}
#line 4162 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp18_ = self->priv->update_editable_attributes_scheduler;
#line 4162 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp18_, (guint) 1000, TRUE);
#line 4163 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 30354 "Photo.c"
		}
#line 4145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 30358 "Photo.c"
		{
			OneShotScheduler* _tmp19_;
			OneShotScheduler* _tmp21_;
#line 4166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp19_ = self->priv->remove_editable_scheduler;
#line 4166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp19_ == NULL) {
#line 30366 "Photo.c"
				OneShotScheduler* _tmp20_;
#line 4167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp20_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 4167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 4167 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp20_;
#line 30374 "Photo.c"
			}
#line 4171 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp21_ = self->priv->remove_editable_scheduler;
#line 4171 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp21_, (guint) 3000, TRUE);
#line 4172 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 30382 "Photo.c"
		}
		default:
#line 4145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 30387 "Photo.c"
		{
#line 4177 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			break;
#line 30391 "Photo.c"
		}
	}
#line 4182 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_discard_prefetched (self);
#line 30396 "Photo.c"
}


static void
photo_on_reimport_editable (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4185 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4187 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_discard_prefetched (self);
#line 4189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_debug ("Photo.vala:4189: Reimporting editable for %s", _tmp1_);
#line 4189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 30418 "Photo.c"
	{
#line 4191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_editable (self, &_inner_error0_);
#line 4191 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 30424 "Photo.c"
			goto __catch429_g_error;
		}
	}
	goto __finally429;
	__catch429_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 4190 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 4190 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 4193 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4193 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4193 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = err;
#line 4193 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4193 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:4193: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 4193 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4190 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 30454 "Photo.c"
	}
	__finally429:
#line 4190 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4190 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4190 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4190 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 30465 "Photo.c"
	}
}


static void
photo_on_update_editable_attributes (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4198 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_debug ("Photo.vala:4199: Updating editable attributes for %s", _tmp1_);
#line 4199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 30486 "Photo.c"
	{
#line 4201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error0_);
#line 4201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 30492 "Photo.c"
			goto __catch430_g_error;
		}
	}
	goto __finally430;
	__catch430_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 4200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 4203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = err;
#line 4203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4203 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:4203: Unable to update editable attributes: %s", _tmp3_);
#line 4200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 30514 "Photo.c"
	}
	__finally430:
#line 4200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 30525 "Photo.c"
	}
}


static void
photo_on_remove_editable (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* file = NULL;
	PhotoFileReader* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 4207 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 4208 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	reader = _tmp0_;
#line 4209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = reader;
#line 4209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4210 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 30556 "Photo.c"
	}
#line 4212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = reader;
#line 4212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 4212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = _tmp3_;
#line 4213 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = file;
#line 4213 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 30568 "Photo.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 4214 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4214 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4214 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_debug ("Photo.vala:4214: Not removing editable for %s: file exists", _tmp6_);
#line 4214 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 4216 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 4216 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4216 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 30585 "Photo.c"
	}
#line 4219 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 4219 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4219 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_debug ("Photo.vala:4219: Removing editable for %s: file no longer exists", _tmp8_);
#line 4219 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp8_);
#line 4220 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4207 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 4207 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 30601 "Photo.c"
}


void
photo_get_original_dimensions (Photo* self,
                               Dimensions* result)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
#line 4228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4229 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4229 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dim = _tmp0_;
#line 4230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4232 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = dim;
#line 4232 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp1_, &_tmp2_);
#line 4232 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	*result = _tmp2_;
#line 4232 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 30630 "Photo.c"
}


void
photo_get_master_dimensions (Photo* self,
                             Dimensions* result)
{
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 4236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	orientation_rotate_dimensions (photo_get_original_orientation (self), &_tmp0_, &_tmp1_);
#line 4237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	*result = _tmp1_;
#line 4237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 30650 "Photo.c"
}


gboolean
photo_get_crop (Photo* self,
                Box* crop,
                PhotoException exceptions)
{
	Box _vala_crop = {0};
	gboolean result = FALSE;
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_;
	Dimensions dim = {0};
	Dimensions _tmp2_ = {0};
	Orientation orientation = 0;
#line 4241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4243 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 4243 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	raw = _tmp0_;
#line 4243 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp1_) {
#line 4244 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 4246 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 4246 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (crop) {
#line 4246 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*crop = _vala_crop;
#line 30683 "Photo.c"
		}
#line 4246 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 30687 "Photo.c"
	}
#line 4249 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 4249 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dim = _tmp2_;
#line 4250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 30697 "Photo.c"
		Orientation _tmp3_;
		Dimensions _tmp4_;
		Box _tmp5_;
		Box _tmp6_ = {0};
#line 4253 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = orientation;
#line 4253 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = dim;
#line 4253 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = raw;
#line 4253 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		orientation_rotate_box (_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 4253 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_crop = _tmp6_;
#line 30712 "Photo.c"
	} else {
		Box _tmp7_;
#line 4255 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = raw;
#line 4255 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_crop = _tmp7_;
#line 30719 "Photo.c"
	}
#line 4257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 4257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (crop) {
#line 4257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*crop = _vala_crop;
#line 30727 "Photo.c"
	}
#line 4257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 30731 "Photo.c"
}


void
photo_set_crop (Photo* self,
                Box* crop)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Box derotated = {0};
	Dimensions _tmp1_;
	Box _tmp2_;
	Box _tmp3_ = {0};
	Box _tmp4_;
	gint _tmp5_;
	Dimensions _tmp6_;
	gint _tmp7_;
	Box _tmp8_;
	gint _tmp9_;
	Box _tmp10_;
	gint _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	Box _tmp14_;
	gint _tmp15_;
	Dimensions _tmp16_;
	gint _tmp17_;
	Box _tmp18_;
	gint _tmp19_;
	Box _tmp20_;
	gint _tmp21_;
	Dimensions _tmp22_;
	gint _tmp23_;
	Box _tmp24_;
#line 4261 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4261 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 4262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 4262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dim = _tmp0_;
#line 4263 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = dim;
#line 4265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = *crop;
#line 4265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp1_, &_tmp2_, &_tmp3_);
#line 4265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	derotated = _tmp3_;
#line 4267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = derotated;
#line 4267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = _tmp4_.left;
#line 4267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = dim;
#line 4267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = _tmp6_.width;
#line 4267 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	derotated.left = CLAMP (_tmp5_, 0, _tmp7_ - 2);
#line 4268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = derotated;
#line 4268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 4268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = derotated;
#line 4268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = _tmp10_.left;
#line 4268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = dim;
#line 4268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = _tmp12_.width;
#line 4268 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	derotated.right = CLAMP (_tmp9_, _tmp11_, _tmp13_ - 1);
#line 4270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = derotated;
#line 4270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = _tmp14_.top;
#line 4270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = dim;
#line 4270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = _tmp16_.height;
#line 4270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	derotated.top = CLAMP (_tmp15_, 0, _tmp17_ - 2);
#line 4271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = derotated;
#line 4271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = _tmp18_.bottom;
#line 4271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = derotated;
#line 4271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = _tmp20_.top;
#line 4271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp22_ = dim;
#line 4271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = _tmp22_.height;
#line 4271 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	derotated.bottom = CLAMP (_tmp19_, _tmp21_, _tmp23_ - 1);
#line 4273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_ = derotated;
#line 4273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_set_raw_crop (self, &_tmp24_);
#line 30837 "Photo.c"
}


gboolean
photo_get_straighten (Photo* self,
                      gdouble* theta)
{
	gdouble _vala_theta = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
#line 4276 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4277 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 4277 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_theta = _tmp0_;
#line 4277 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp1_) {
#line 4278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 4278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (theta) {
#line 4278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*theta = _vala_theta;
#line 30863 "Photo.c"
		}
#line 4278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 30867 "Photo.c"
	}
#line 4280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 4280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (theta) {
#line 4280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*theta = _vala_theta;
#line 30875 "Photo.c"
	}
#line 4280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 30879 "Photo.c"
}


void
photo_set_straighten (Photo* self,
                      gdouble theta)
{
#line 4283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4284 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_set_raw_straighten (self, theta);
#line 30891 "Photo.c"
}


static GdkPixbuf*
photo_do_redeye (Photo* self,
                 GdkPixbuf* pixbuf,
                 EditingToolsRedeyeInstance* inst)
{
	GdkPixbuf* result = NULL;
	gdouble r = 0.0;
	EditingToolsRedeyeInstance _tmp0_;
	gint _tmp1_;
	gint* x_insets_first_quadrant = NULL;
	EditingToolsRedeyeInstance _tmp2_;
	gint _tmp3_;
	gint* _tmp4_;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i = 0;
	gint x_bounds_min = 0;
	EditingToolsRedeyeInstance _tmp19_;
	GdkPoint _tmp20_;
	gint _tmp21_;
	EditingToolsRedeyeInstance _tmp22_;
	gint _tmp23_;
	gint x_bounds_max = 0;
	EditingToolsRedeyeInstance _tmp24_;
	GdkPoint _tmp25_;
	gint _tmp26_;
	EditingToolsRedeyeInstance _tmp27_;
	gint _tmp28_;
	gint ymin = 0;
	EditingToolsRedeyeInstance _tmp29_;
	GdkPoint _tmp30_;
	gint _tmp31_;
	EditingToolsRedeyeInstance _tmp32_;
	gint _tmp33_;
	gint _tmp34_ = 0;
	gint _tmp35_;
	gint ymax = 0;
	EditingToolsRedeyeInstance _tmp37_;
	GdkPoint _tmp38_;
	gint _tmp39_;
	gint _tmp40_ = 0;
	gint _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	gint inset_index = 0;
	EditingToolsRedeyeInstance _tmp80_;
	GdkPoint _tmp81_;
	gint _tmp82_;
	EditingToolsRedeyeInstance _tmp83_;
	GdkPoint _tmp84_;
	gint _tmp85_;
	EditingToolsRedeyeInstance _tmp86_;
	gint _tmp87_;
	gint* _tmp88_;
	gint _tmp88__length1;
	GdkPixbuf* _tmp122_;
#line 4287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 4287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 4297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = *inst;
#line 4297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_.radius;
#line 4297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	r = (gdouble) _tmp1_;
#line 4298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = *inst;
#line 4298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_.radius;
#line 4298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = g_new0 (gint, _tmp3_ + 1);
#line 4298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	x_insets_first_quadrant = _tmp4_;
#line 4298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp3_ + 1;
#line 4298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 4300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	i = 0;
#line 30977 "Photo.c"
	{
		gdouble y = 0.0;
		gdouble _tmp5_;
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = r;
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		y = _tmp5_;
#line 30985 "Photo.c"
		{
			gboolean _tmp6_ = FALSE;
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = TRUE;
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 30992 "Photo.c"
				gdouble _tmp8_;
				gdouble theta = 0.0;
				gdouble _tmp9_;
				gdouble _tmp10_;
				gint x = 0;
				gdouble _tmp11_;
				gdouble _tmp12_;
				gint* _tmp13_;
				gint _tmp13__length1;
				gint _tmp14_;
				EditingToolsRedeyeInstance _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!_tmp6_) {
#line 31009 "Photo.c"
					gdouble _tmp7_;
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp7_ = y;
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					y = _tmp7_ - 1.0;
#line 31015 "Photo.c"
				}
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = FALSE;
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = y;
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!(_tmp8_ >= 0.0)) {
#line 4301 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 31025 "Photo.c"
				}
#line 4302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = y;
#line 4302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = r;
#line 4302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				theta = asin (_tmp9_ / _tmp10_);
#line 4303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = r;
#line 4303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = theta;
#line 4303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				x = (gint) ((_tmp11_ * cos (_tmp12_)) + 0.5);
#line 4304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = x_insets_first_quadrant;
#line 4304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13__length1 = x_insets_first_quadrant_length1;
#line 4304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = i;
#line 4304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = *inst;
#line 4304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = _tmp15_.radius;
#line 4304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = x;
#line 4304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_[_tmp14_] = _tmp16_ - _tmp17_;
#line 4306 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = i;
#line 4306 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				i = _tmp18_ + 1;
#line 31057 "Photo.c"
			}
		}
	}
#line 4309 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = *inst;
#line 4309 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = _tmp19_.center;
#line 4309 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = _tmp20_.x;
#line 4309 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp22_ = *inst;
#line 4309 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = _tmp22_.radius;
#line 4309 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	x_bounds_min = _tmp21_ - _tmp23_;
#line 4310 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_ = *inst;
#line 4310 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp25_ = _tmp24_.center;
#line 4310 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = _tmp25_.x;
#line 4310 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27_ = *inst;
#line 4310 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp28_ = _tmp27_.radius;
#line 4310 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	x_bounds_max = _tmp26_ + _tmp28_;
#line 4311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = *inst;
#line 4311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_ = _tmp29_.center;
#line 4311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = _tmp30_.y;
#line 4311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp32_ = *inst;
#line 4311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = _tmp32_.radius;
#line 4311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ymin = _tmp31_ - _tmp33_;
#line 4312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp35_ = ymin;
#line 4312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp35_ < 0) {
#line 4312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34_ = 0;
#line 31103 "Photo.c"
	} else {
		gint _tmp36_;
#line 4312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp36_ = ymin;
#line 4312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34_ = _tmp36_;
#line 31110 "Photo.c"
	}
#line 4312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ymin = _tmp34_;
#line 4313 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp37_ = *inst;
#line 4313 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp38_ = _tmp37_.center;
#line 4313 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp39_ = _tmp38_.y;
#line 4313 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ymax = _tmp39_;
#line 4314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp41_ = ymax;
#line 4314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp42_ = gdk_pixbuf_get_height (pixbuf);
#line 4314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 4314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp41_ > (_tmp43_ - 1)) {
#line 31130 "Photo.c"
		gint _tmp44_;
		gint _tmp45_;
#line 4314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp44_ = gdk_pixbuf_get_height (pixbuf);
#line 4314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp45_ = _tmp44_;
#line 4314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp40_ = _tmp45_ - 1;
#line 31139 "Photo.c"
	} else {
		gint _tmp46_;
#line 4314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp46_ = ymax;
#line 4314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp40_ = _tmp46_;
#line 31146 "Photo.c"
	}
#line 4314 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ymax = _tmp40_;
#line 4318 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	inset_index = 0;
#line 31152 "Photo.c"
	{
		gint y_it = 0;
		gint _tmp47_;
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp47_ = ymin;
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		y_it = _tmp47_;
#line 31160 "Photo.c"
		{
			gboolean _tmp48_ = FALSE;
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp48_ = TRUE;
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 31167 "Photo.c"
				gint _tmp50_;
				gint _tmp51_;
				gint xmin = 0;
				gint _tmp52_;
				gint* _tmp53_;
				gint _tmp53__length1;
				gint _tmp54_;
				gint _tmp55_;
				gint _tmp56_ = 0;
				gint _tmp57_;
				gint xmax = 0;
				gint _tmp59_;
				gint* _tmp60_;
				gint _tmp60__length1;
				gint _tmp61_;
				gint _tmp62_;
				gint _tmp63_ = 0;
				gint _tmp64_;
				gint _tmp65_;
				gint _tmp66_;
				gint _tmp79_;
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!_tmp48_) {
#line 31191 "Photo.c"
					gint _tmp49_;
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp49_ = y_it;
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					y_it = _tmp49_ + 1;
#line 31197 "Photo.c"
				}
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp48_ = FALSE;
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp50_ = y_it;
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp51_ = ymax;
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!(_tmp50_ <= _tmp51_)) {
#line 4319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 31209 "Photo.c"
				}
#line 4320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp52_ = x_bounds_min;
#line 4320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp53_ = x_insets_first_quadrant;
#line 4320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp53__length1 = x_insets_first_quadrant_length1;
#line 4320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp54_ = inset_index;
#line 4320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp55_ = _tmp53_[_tmp54_];
#line 4320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				xmin = _tmp52_ + _tmp55_;
#line 4321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp57_ = xmin;
#line 4321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp57_ < 0) {
#line 4321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp56_ = 0;
#line 31229 "Photo.c"
				} else {
					gint _tmp58_;
#line 4321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp58_ = xmin;
#line 4321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp56_ = _tmp58_;
#line 31236 "Photo.c"
				}
#line 4321 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				xmin = _tmp56_;
#line 4322 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp59_ = x_bounds_max;
#line 4322 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp60_ = x_insets_first_quadrant;
#line 4322 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp60__length1 = x_insets_first_quadrant_length1;
#line 4322 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp61_ = inset_index;
#line 4322 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp62_ = _tmp60_[_tmp61_];
#line 4322 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				xmax = _tmp59_ - _tmp62_;
#line 4323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp64_ = xmax;
#line 4323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp65_ = gdk_pixbuf_get_width (pixbuf);
#line 4323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp66_ = _tmp65_;
#line 4323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp64_ > (_tmp66_ - 1)) {
#line 31260 "Photo.c"
					gint _tmp67_;
					gint _tmp68_;
#line 4323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp67_ = gdk_pixbuf_get_width (pixbuf);
#line 4323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp68_ = _tmp67_;
#line 4323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp63_ = _tmp68_ - 1;
#line 31269 "Photo.c"
				} else {
					gint _tmp69_;
#line 4323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp69_ = xmax;
#line 4323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp63_ = _tmp69_;
#line 31276 "Photo.c"
				}
#line 4323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				xmax = _tmp63_;
#line 31280 "Photo.c"
				{
					gint x_it = 0;
					gint _tmp70_;
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp70_ = xmin;
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					x_it = _tmp70_;
#line 31288 "Photo.c"
					{
						gboolean _tmp71_ = FALSE;
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp71_ = TRUE;
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						while (TRUE) {
#line 31295 "Photo.c"
							gint _tmp73_;
							gint _tmp74_;
							gint _tmp75_;
							gint _tmp76_;
							GdkPixbuf* _tmp77_;
							GdkPixbuf* _tmp78_;
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (!_tmp71_) {
#line 31304 "Photo.c"
								gint _tmp72_;
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp72_ = x_it;
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								x_it = _tmp72_ + 1;
#line 31310 "Photo.c"
							}
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp71_ = FALSE;
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp73_ = x_it;
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp74_ = xmax;
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (!(_tmp73_ <= _tmp74_)) {
#line 4325 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								break;
#line 31322 "Photo.c"
							}
#line 4326 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp75_ = x_it;
#line 4326 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp76_ = y_it;
#line 4326 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp77_ = photo_red_reduce_pixel (self, pixbuf, _tmp75_, _tmp76_);
#line 4326 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp78_ = _tmp77_;
#line 4326 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (_tmp78_);
#line 31334 "Photo.c"
						}
					}
				}
#line 4328 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp79_ = inset_index;
#line 4328 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				inset_index = _tmp79_ + 1;
#line 31342 "Photo.c"
			}
		}
	}
#line 4333 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp80_ = *inst;
#line 4333 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp81_ = _tmp80_.center;
#line 4333 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp82_ = _tmp81_.y;
#line 4333 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ymin = _tmp82_;
#line 4334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp83_ = *inst;
#line 4334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp84_ = _tmp83_.center;
#line 4334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp85_ = _tmp84_.y;
#line 4334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp86_ = *inst;
#line 4334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp87_ = _tmp86_.radius;
#line 4334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ymax = _tmp85_ + _tmp87_;
#line 4335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp88_ = x_insets_first_quadrant;
#line 4335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp88__length1 = x_insets_first_quadrant_length1;
#line 4335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	inset_index = _tmp88__length1 - 1;
#line 31372 "Photo.c"
	{
		gint y_it = 0;
		gint _tmp89_;
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp89_ = ymin;
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		y_it = _tmp89_;
#line 31380 "Photo.c"
		{
			gboolean _tmp90_ = FALSE;
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp90_ = TRUE;
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 31387 "Photo.c"
				gint _tmp92_;
				gint _tmp93_;
				gint xmin = 0;
				gint _tmp94_;
				gint* _tmp95_;
				gint _tmp95__length1;
				gint _tmp96_;
				gint _tmp97_;
				gint _tmp98_ = 0;
				gint _tmp99_;
				gint xmax = 0;
				gint _tmp101_;
				gint* _tmp102_;
				gint _tmp102__length1;
				gint _tmp103_;
				gint _tmp104_;
				gint _tmp105_ = 0;
				gint _tmp106_;
				gint _tmp107_;
				gint _tmp108_;
				gint _tmp121_;
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!_tmp90_) {
#line 31411 "Photo.c"
					gint _tmp91_;
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp91_ = y_it;
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					y_it = _tmp91_ + 1;
#line 31417 "Photo.c"
				}
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp90_ = FALSE;
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp92_ = y_it;
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp93_ = ymax;
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!(_tmp92_ <= _tmp93_)) {
#line 4336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 31429 "Photo.c"
				}
#line 4337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp94_ = x_bounds_min;
#line 4337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp95_ = x_insets_first_quadrant;
#line 4337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp95__length1 = x_insets_first_quadrant_length1;
#line 4337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp96_ = inset_index;
#line 4337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp97_ = _tmp95_[_tmp96_];
#line 4337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				xmin = _tmp94_ + _tmp97_;
#line 4338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp99_ = xmin;
#line 4338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp99_ < 0) {
#line 4338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp98_ = 0;
#line 31449 "Photo.c"
				} else {
					gint _tmp100_;
#line 4338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp100_ = xmin;
#line 4338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp98_ = _tmp100_;
#line 31456 "Photo.c"
				}
#line 4338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				xmin = _tmp98_;
#line 4339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp101_ = x_bounds_max;
#line 4339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp102_ = x_insets_first_quadrant;
#line 4339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp102__length1 = x_insets_first_quadrant_length1;
#line 4339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp103_ = inset_index;
#line 4339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp104_ = _tmp102_[_tmp103_];
#line 4339 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				xmax = _tmp101_ - _tmp104_;
#line 4340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp106_ = xmax;
#line 4340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp107_ = gdk_pixbuf_get_width (pixbuf);
#line 4340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp108_ = _tmp107_;
#line 4340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp106_ > (_tmp108_ - 1)) {
#line 31480 "Photo.c"
					gint _tmp109_;
					gint _tmp110_;
#line 4340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp109_ = gdk_pixbuf_get_width (pixbuf);
#line 4340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp110_ = _tmp109_;
#line 4340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp105_ = _tmp110_ - 1;
#line 31489 "Photo.c"
				} else {
					gint _tmp111_;
#line 4340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp111_ = xmax;
#line 4340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp105_ = _tmp111_;
#line 31496 "Photo.c"
				}
#line 4340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				xmax = _tmp105_;
#line 31500 "Photo.c"
				{
					gint x_it = 0;
					gint _tmp112_;
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp112_ = xmin;
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					x_it = _tmp112_;
#line 31508 "Photo.c"
					{
						gboolean _tmp113_ = FALSE;
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp113_ = TRUE;
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						while (TRUE) {
#line 31515 "Photo.c"
							gint _tmp115_;
							gint _tmp116_;
							gint _tmp117_;
							gint _tmp118_;
							GdkPixbuf* _tmp119_;
							GdkPixbuf* _tmp120_;
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (!_tmp113_) {
#line 31524 "Photo.c"
								gint _tmp114_;
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp114_ = x_it;
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								x_it = _tmp114_ + 1;
#line 31530 "Photo.c"
							}
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp113_ = FALSE;
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp115_ = x_it;
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp116_ = xmax;
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (!(_tmp115_ <= _tmp116_)) {
#line 4342 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								break;
#line 31542 "Photo.c"
							}
#line 4343 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp117_ = x_it;
#line 4343 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp118_ = y_it;
#line 4343 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp119_ = photo_red_reduce_pixel (self, pixbuf, _tmp117_, _tmp118_);
#line 4343 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp120_ = _tmp119_;
#line 4343 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (_tmp120_);
#line 31554 "Photo.c"
						}
					}
				}
#line 4345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp121_ = inset_index;
#line 4345 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				inset_index = _tmp121_ - 1;
#line 31562 "Photo.c"
			}
		}
	}
#line 4348 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp122_ = _g_object_ref0 (pixbuf);
#line 4348 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp122_;
#line 4348 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 4348 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 31574 "Photo.c"
}


static GdkPixbuf*
photo_red_reduce_pixel (Photo* self,
                        GdkPixbuf* pixbuf,
                        gint x,
                        gint y)
{
	GdkPixbuf* result = NULL;
	gint px_start_byte_offset = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp19_;
#line 4351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4351 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 4352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	px_start_byte_offset = (y * gdk_pixbuf_get_rowstride (pixbuf)) + (x * gdk_pixbuf_get_n_channels (pixbuf));
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (x >= 0) {
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = y >= 0;
#line 31600 "Photo.c"
	} else {
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = FALSE;
#line 31604 "Photo.c"
	}
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_) {
#line 31608 "Photo.c"
		gint _tmp3_;
		gint _tmp4_;
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = gdk_pixbuf_get_width (pixbuf);
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = x < _tmp4_;
#line 31617 "Photo.c"
	} else {
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 31621 "Photo.c"
	}
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_) {
#line 31625 "Photo.c"
		gint _tmp5_;
		gint _tmp6_;
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = gdk_pixbuf_get_height (pixbuf);
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = y < _tmp6_;
#line 31634 "Photo.c"
	} else {
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 31638 "Photo.c"
	}
#line 4359 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp0_) {
#line 31642 "Photo.c"
		guchar* pixel_data = NULL;
		guint8* _tmp7_;
		gint pixel_data_length1;
		gint _pixel_data_size_;
		guchar g = '\0';
		guchar* _tmp8_;
		gint _tmp8__length1;
		gint _tmp9_;
		guchar _tmp10_;
		guchar b = '\0';
		guchar* _tmp11_;
		gint _tmp11__length1;
		gint _tmp12_;
		guchar _tmp13_;
		guchar r = '\0';
		guchar _tmp14_;
		guchar _tmp15_;
		guchar* _tmp16_;
		gint _tmp16__length1;
		gint _tmp17_;
		guchar _tmp18_;
#line 4360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = gdk_pixbuf_get_pixels (pixbuf);
#line 4360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		pixel_data = _tmp7_;
#line 4360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		pixel_data_length1 = -1;
#line 4360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = pixel_data;
#line 4370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8__length1 = pixel_data_length1;
#line 4370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = px_start_byte_offset;
#line 4370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = _tmp8_[_tmp9_ + 1];
#line 4370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g = _tmp10_;
#line 4371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = pixel_data;
#line 4371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11__length1 = pixel_data_length1;
#line 4371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = px_start_byte_offset;
#line 4371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = _tmp11_[_tmp12_ + 2];
#line 4371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		b = _tmp13_;
#line 4373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp14_ = g;
#line 4373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = b;
#line 4373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		r = (guchar) ((_tmp14_ + _tmp15_) / 2);
#line 4375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = pixel_data;
#line 4375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16__length1 = pixel_data_length1;
#line 4375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp17_ = px_start_byte_offset;
#line 4375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = r;
#line 4375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_[_tmp17_] = _tmp18_;
#line 31708 "Photo.c"
	}
#line 4378 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = _g_object_ref0 (pixbuf);
#line 4378 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp19_;
#line 4378 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 31716 "Photo.c"
}


void
photo_unscaled_to_raw_point (Photo* self,
                             GdkPoint* unscaled_point,
                             GdkPoint* result)
{
	Orientation unscaled_orientation = 0;
	Dimensions unscaled_dims = {0};
	Orientation _tmp0_;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
	gint unscaled_x_offset_raw = 0;
	gint unscaled_y_offset_raw = 0;
	Box crop_box = {0};
	Box _tmp3_ = {0};
	gboolean _tmp4_;
	GdkPoint derotated_point = {0};
	Orientation _tmp9_;
	Dimensions _tmp10_;
	GdkPoint _tmp11_;
	GdkPoint _tmp12_ = {0};
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
#line 4381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	unscaled_orientation = photo_get_orientation (self);
#line 4384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = unscaled_orientation;
#line 4384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp1_);
#line 4384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	orientation_rotate_dimensions (_tmp0_, &_tmp1_, &_tmp2_);
#line 4384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	unscaled_dims = _tmp2_;
#line 4387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4388 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4391 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 4391 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	crop_box = _tmp3_;
#line 4391 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp4_) {
#line 31768 "Photo.c"
		Box _tmp5_;
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
#line 4392 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = crop_box;
#line 4392 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = _tmp5_.left;
#line 4392 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		unscaled_x_offset_raw = _tmp6_;
#line 4393 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = crop_box;
#line 4393 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = _tmp7_.top;
#line 4393 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		unscaled_y_offset_raw = _tmp8_;
#line 31785 "Photo.c"
	}
#line 4396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = unscaled_orientation;
#line 4396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = unscaled_dims;
#line 4396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = *unscaled_point;
#line 4396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	orientation_derotate_point (_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
#line 4396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	derotated_point = _tmp12_;
#line 4400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = derotated_point.x;
#line 4400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = unscaled_x_offset_raw;
#line 4400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	derotated_point.x = _tmp13_ + _tmp14_;
#line 4401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = derotated_point.y;
#line 4401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = unscaled_y_offset_raw;
#line 4401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	derotated_point.y = _tmp15_ + _tmp16_;
#line 4403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	*result = derotated_point;
#line 4403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 31813 "Photo.c"
}


void
photo_unscaled_to_raw_rect (Photo* self,
                            GdkRectangle* unscaled_rect,
                            GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_ = {0};
	GdkPoint _tmp16_;
	GdkPoint _tmp17_ = {0};
	GdkPoint _tmp18_;
	gint _tmp19_;
	GdkPoint _tmp20_;
	gint _tmp21_;
	GdkPoint _tmp27_;
	gint _tmp28_;
	GdkPoint _tmp29_;
	gint _tmp30_;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp36_;
	gint _tmp37_;
	GdkPoint _tmp38_;
	gint _tmp39_;
	GdkPoint _tmp40_;
	gint _tmp41_;
	GdkPoint _tmp42_;
	gint _tmp43_;
	GdkPoint _tmp44_;
	gint _tmp45_;
	GdkPoint _tmp46_;
	gint _tmp47_;
#line 4406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 4406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_.x = 0;
#line 4407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	upper_left = _tmp0_;
#line 4408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_.x = 0;
#line 4408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	lower_right = _tmp1_;
#line 4409 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4409 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_.x;
#line 4409 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	upper_left.x = _tmp3_;
#line 4410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = *unscaled_rect;
#line 4410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = _tmp4_.y;
#line 4410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	upper_left.y = _tmp5_;
#line 4411 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = upper_left;
#line 4411 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = _tmp6_.x;
#line 4411 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = *unscaled_rect;
#line 4411 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = _tmp8_.width;
#line 4411 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	lower_right.x = _tmp7_ + _tmp9_;
#line 4412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = upper_left;
#line 4412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = _tmp10_.y;
#line 4412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = *unscaled_rect;
#line 4412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = _tmp12_.height;
#line 4412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	lower_right.y = _tmp11_ + _tmp13_;
#line 4414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = upper_left;
#line 4414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp14_, &_tmp15_);
#line 4414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	upper_left = _tmp15_;
#line 4415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = lower_right;
#line 4415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp16_, &_tmp17_);
#line 4415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	lower_right = _tmp17_;
#line 4417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = upper_left;
#line 4417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = _tmp18_.x;
#line 4417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = lower_right;
#line 4417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = _tmp20_.x;
#line 4417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp19_ > _tmp21_) {
#line 31929 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp22_;
		gint _tmp23_;
		GdkPoint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 4418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = upper_left;
#line 4418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = _tmp22_.x;
#line 4418 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		temp = _tmp23_;
#line 4419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp24_ = lower_right;
#line 4419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp25_ = _tmp24_.x;
#line 4419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		upper_left.x = _tmp25_;
#line 4420 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp26_ = temp;
#line 4420 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		lower_right.x = _tmp26_;
#line 31952 "Photo.c"
	}
#line 4422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27_ = upper_left;
#line 4422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp28_ = _tmp27_.y;
#line 4422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = lower_right;
#line 4422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_ = _tmp29_.y;
#line 4422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp28_ > _tmp30_) {
#line 31964 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp31_;
		gint _tmp32_;
		GdkPoint _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
#line 4423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp31_ = upper_left;
#line 4423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = _tmp31_.y;
#line 4423 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		temp = _tmp32_;
#line 4424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp33_ = lower_right;
#line 4424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34_ = _tmp33_.y;
#line 4424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		upper_left.y = _tmp34_;
#line 4425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp35_ = temp;
#line 4425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		lower_right.y = _tmp35_;
#line 31987 "Photo.c"
	}
#line 4428 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4429 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp36_ = upper_left;
#line 4429 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp37_ = _tmp36_.x;
#line 4429 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	raw_rect.x = _tmp37_;
#line 4430 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp38_ = upper_left;
#line 4430 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp39_ = _tmp38_.y;
#line 4430 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	raw_rect.y = _tmp39_;
#line 4431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp40_ = lower_right;
#line 4431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp41_ = _tmp40_.x;
#line 4431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp42_ = upper_left;
#line 4431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp43_ = _tmp42_.x;
#line 4431 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	raw_rect.width = _tmp41_ - _tmp43_;
#line 4432 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp44_ = lower_right;
#line 4432 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp45_ = _tmp44_.y;
#line 4432 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp46_ = upper_left;
#line 4432 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp47_ = _tmp46_.y;
#line 4432 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	raw_rect.height = _tmp45_ - _tmp47_;
#line 4434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	*result = raw_rect;
#line 4434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 32027 "Photo.c"
}


PixelTransformationBundle*
photo_get_enhance_transformations (Photo* self)
{
	PixelTransformationBundle* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	PixelTransformationBundle* transformations = NULL;
	GdkPixbuf* _tmp4_;
	PixelTransformationBundle* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 4437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4438 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	pixbuf = NULL;
#line 32044 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		Scaling _tmp1_ = {0};
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 4445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp1_);
#line 4445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 4445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = _tmp2_;
#line 4445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 32058 "Photo.c"
			goto __catch431_g_error;
		}
#line 4445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp0_;
#line 4445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 4445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		pixbuf = _tmp3_;
#line 4444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 32071 "Photo.c"
	}
	goto __finally431;
	__catch431_g_error:
	{
		GError* e = NULL;
#line 4444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		e = _inner_error0_;
#line 4444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 4452 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:4452: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = NULL;
#line 4454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (e);
#line 4454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4454 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 32091 "Photo.c"
	}
	__finally431:
#line 4444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 32104 "Photo.c"
	}
#line 4461 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4461 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = auto_enhance_create_auto_enhance_adjustments (_tmp4_);
#line 4461 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	transformations = _tmp5_;
#line 4469 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = transformations;
#line 4469 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4469 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 32118 "Photo.c"
}


gboolean
photo_enhance (Photo* self)
{
	gboolean result = FALSE;
	PixelTransformationBundle* transformations = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4473 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4473 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	transformations = _tmp0_;
#line 4475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = transformations;
#line 4475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4476 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 4476 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4476 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 32146 "Photo.c"
	}
	{
		PhotoRow* _tmp2_;
#line 4481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = self->row;
#line 4481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 32154 "Photo.c"
		{
			PixelTransformationBundle* _tmp3_;
#line 4482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = transformations;
#line 4482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo_set_color_adjustments (self, _tmp3_);
#line 32161 "Photo.c"
		}
		__finally432:
		{
			PhotoRow* _tmp4_;
#line 4481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->row;
#line 4481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 32170 "Photo.c"
		}
#line 4481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 32174 "Photo.c"
			gboolean _tmp5_ = FALSE;
#line 4481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return _tmp5_;
#line 32184 "Photo.c"
		}
	}
#line 4489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = TRUE;
#line 4489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 32193 "Photo.c"
}


gboolean
photo_get_develop_raw_photos_to_files (void)
{
	gboolean result;
	gboolean _tmp0_;
#line 346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo__develop_raw_photos_to_files;
#line 346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 32208 "Photo.c"
}


void
photo_set_develop_raw_photos_to_files (gboolean value)
{
#line 346 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo__develop_raw_photos_to_files = value;
#line 32217 "Photo.c"
}


static void
photo_real_editable_replaced (Photo* self,
                              GFile* old_file,
                              GFile* new_file)
{
#line 355 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 355 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 32230 "Photo.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data1 = closure->data;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 32256 "Photo.c"
	} else {
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data2 = closure->data;
#line 32262 "Photo.c"
	}
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 32268 "Photo.c"
}


static void
photo_real_raw_development_modified (Photo* self)
{
}


static void
photo_real_baseline_replaced (Photo* self)
{
}


static void
photo_real_master_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
#line 373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 32290 "Photo.c"
}


static void
g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data1 = closure->data;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 32316 "Photo.c"
	} else {
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data2 = closure->data;
#line 32322 "Photo.c"
	}
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 32328 "Photo.c"
}


static void
photo_real_editable_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 377 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 32338 "Photo.c"
}


static void
photo_real_baseline_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 32348 "Photo.c"
}


static void
photo_real_source_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
#line 391 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 32358 "Photo.c"
}


static void
_photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                           gpointer self)
{
#line 254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced ((PhotoPhotoTransformationStateImpl*) self);
#line 32368 "Photo.c"
}


static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_construct (GType object_type,
                                                 Photo* photo,
                                                 Orientation orientation,
                                                 GeeHashMap* transformations,
                                                 PixelTransformer* transformer,
                                                 PixelTransformationBundle* adjustments)
{
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	GeeHashMap* _tmp1_;
	PixelTransformer* _tmp2_;
	PixelTransformationBundle* _tmp3_;
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((transformations == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformations, GEE_TYPE_HASH_MAP), NULL);
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((transformer == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformer, TYPE_PIXEL_TRANSFORMER), NULL);
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((adjustments == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (adjustments, TYPE_PIXEL_TRANSFORMATION_BUNDLE), NULL);
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 244 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 244 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 244 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->photo = _tmp0_;
#line 245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->orientation = orientation;
#line 246 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (transformations);
#line 246 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 246 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->transformations = _tmp1_;
#line 247 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _pixel_transformer_ref0 (transformer);
#line 247 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 247 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->transformer = _tmp2_;
#line 248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _pixel_transformation_bundle_ref0 (adjustments);
#line 248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->adjustments = _tmp3_;
#line 250 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_connect_object (photo, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 32425 "Photo.c"
}


static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_new (Photo* photo,
                                           Orientation orientation,
                                           GeeHashMap* transformations,
                                           PixelTransformer* transformer,
                                           PixelTransformationBundle* adjustments)
{
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments);
#line 32438 "Photo.c"
}


static Orientation
photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self)
{
	Orientation result = 0;
	Orientation _tmp0_;
#line 257 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), 0);
#line 258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->orientation;
#line 258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 258 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 32455 "Photo.c"
}


static GeeHashMap*
photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self)
{
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 261 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp1_;
#line 262 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 32475 "Photo.c"
}


static PixelTransformer*
photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformer* result = NULL;
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_;
#line 265 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 32491 "Photo.c"
		PixelTransformer* _tmp2_;
		PixelTransformer* _tmp3_;
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 32502 "Photo.c"
	} else {
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 32508 "Photo.c"
	}
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 32514 "Photo.c"
}


static PixelTransformationBundle*
photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
#line 269 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 32530 "Photo.c"
		PixelTransformationBundle* _tmp2_;
		PixelTransformationBundle* _tmp3_;
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 32541 "Photo.c"
	} else {
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 32547 "Photo.c"
	}
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 32553 "Photo.c"
}


static GeeHashMap*
photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original)
{
	GeeHashMap* result = NULL;
	GeeHashMap* clone = NULL;
	GeeHashMap* _tmp0_;
#line 273 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((original == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (original, GEE_TYPE_HASH_MAP), NULL);
#line 275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (original == NULL) {
#line 276 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = NULL;
#line 276 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 32571 "Photo.c"
	}
#line 278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	clone = _tmp0_;
#line 32577 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (original, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_object_it = _tmp5_;
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 32601 "Photo.c"
			GeeIterator* _tmp6_;
			gchar* object = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeHashMap* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gpointer _tmp12_;
			KeyValueMap* _tmp13_;
			KeyValueMap* _tmp14_;
			KeyValueMap* _tmp15_;
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _object_it;
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 32619 "Photo.c"
			}
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = _object_it;
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			object = (gchar*) _tmp8_;
#line 280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = clone;
#line 280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = object;
#line 280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = object;
#line 280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (original, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp11_);
#line 280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = (KeyValueMap*) _tmp12_;
#line 280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = key_value_map_copy (_tmp13_);
#line 280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp10_, _tmp15_);
#line 280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_key_value_map_unref0 (_tmp15_);
#line 280 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_key_value_map_unref0 (_tmp13_);
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_free0 (object);
#line 32649 "Photo.c"
		}
#line 279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 32653 "Photo.c"
	}
#line 282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = clone;
#line 282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 32659 "Photo.c"
}


static void
photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self)
{
#line 285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self));
#line 286 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!photo_transformation_state_is_broken (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))) {
#line 287 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_signal_emit (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState), photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL], 0);
#line 32672 "Photo.c"
	}
}


static void
photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass)
{
#line 234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPhotoTransformationStateImplPrivate));
#line 234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 32686 "Photo.c"
}


static void
photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self)
{
#line 234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE (self);
#line 32695 "Photo.c"
}


static void
photo_photo_transformation_state_impl_finalize (GObject * obj)
{
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_;
	guint _tmp1_;
#line 234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl);
#line 254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 235 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 237 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 238 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 32723 "Photo.c"
}


static GType
photo_photo_transformation_state_impl_get_type (void)
{
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}


static PhotoBackingReaders*
photo_backing_readers_construct (GType object_type)
{
	PhotoBackingReaders* self = NULL;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 32749 "Photo.c"
}


static PhotoBackingReaders*
photo_backing_readers_new (void)
{
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 32758 "Photo.c"
}


static void
photo_value_backing_readers_init (GValue* value)
{
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32767 "Photo.c"
}


static void
photo_value_backing_readers_free_value (GValue* value)
{
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 32778 "Photo.c"
	}
}


static void
photo_value_backing_readers_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 32791 "Photo.c"
	} else {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32795 "Photo.c"
	}
}


static gpointer
photo_value_backing_readers_peek_pointer (const GValue* value)
{
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32805 "Photo.c"
}


static gchar*
photo_value_backing_readers_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32817 "Photo.c"
		PhotoBackingReaders * object;
		object = collect_values[0].v_pointer;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32824 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32828 "Photo.c"
		}
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 32832 "Photo.c"
	} else {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32836 "Photo.c"
	}
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 32840 "Photo.c"
}


static gchar*
photo_value_backing_readers_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	PhotoBackingReaders ** object_p;
	object_p = collect_values[0].v_pointer;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!object_p) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32856 "Photo.c"
	}
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = NULL;
#line 32862 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32866 "Photo.c"
	} else {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 32870 "Photo.c"
	}
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 32874 "Photo.c"
}


static GParamSpec*
photo_param_spec_backing_readers (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	PhotoParamSpecBackingReaders* spec;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32894 "Photo.c"
}


static gpointer
photo_value_get_backing_readers (const GValue* value)
{
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32905 "Photo.c"
}


static void
photo_value_set_backing_readers (GValue* value,
                                 gpointer v_object)
{
	PhotoBackingReaders * old;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 32928 "Photo.c"
	} else {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32932 "Photo.c"
	}
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 32938 "Photo.c"
	}
}


static void
photo_value_take_backing_readers (GValue* value,
                                  gpointer v_object)
{
	PhotoBackingReaders * old;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32960 "Photo.c"
	} else {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32964 "Photo.c"
	}
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 32970 "Photo.c"
	}
}


static void
photo_backing_readers_class_init (PhotoBackingReadersClass * klass)
{
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoBackingReadersClass *) klass)->finalize = photo_backing_readers_finalize;
#line 32982 "Photo.c"
}


static void
photo_backing_readers_instance_init (PhotoBackingReaders * self)
{
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->ref_count = 1;
#line 32991 "Photo.c"
}


static void
photo_backing_readers_finalize (PhotoBackingReaders * obj)
{
	PhotoBackingReaders * self;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders);
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 292 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 293 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 294 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 33009 "Photo.c"
}


static GType
photo_backing_readers_get_type (void)
{
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}


static gpointer
photo_backing_readers_ref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return instance;
#line 33038 "Photo.c"
}


static void
photo_backing_readers_unref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 291 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33053 "Photo.c"
	}
}


static PhotoCachedPixbuf*
photo_cached_pixbuf_construct (GType object_type,
                               Photo* photo,
                               GdkPixbuf* pixbuf)
{
	PhotoCachedPixbuf* self = NULL;
	Photo* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoCachedPixbuf*) g_type_create_instance (object_type);
#line 303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->photo);
#line 303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->photo = _tmp0_;
#line 304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (pixbuf);
#line 304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->pixbuf);
#line 304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->pixbuf = _tmp1_;
#line 302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 33086 "Photo.c"
}


static PhotoCachedPixbuf*
photo_cached_pixbuf_new (Photo* photo,
                         GdkPixbuf* pixbuf)
{
#line 302 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return photo_cached_pixbuf_construct (PHOTO_TYPE_CACHED_PIXBUF, photo, pixbuf);
#line 33096 "Photo.c"
}


static void
photo_value_cached_pixbuf_init (GValue* value)
{
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33105 "Photo.c"
}


static void
photo_value_cached_pixbuf_free_value (GValue* value)
{
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_cached_pixbuf_unref (value->data[0].v_pointer);
#line 33116 "Photo.c"
	}
}


static void
photo_value_cached_pixbuf_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_cached_pixbuf_ref (src_value->data[0].v_pointer);
#line 33129 "Photo.c"
	} else {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33133 "Photo.c"
	}
}


static gpointer
photo_value_cached_pixbuf_peek_pointer (const GValue* value)
{
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33143 "Photo.c"
}


static gchar*
photo_value_cached_pixbuf_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33155 "Photo.c"
		PhotoCachedPixbuf * object;
		object = collect_values[0].v_pointer;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33162 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33166 "Photo.c"
		}
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = photo_cached_pixbuf_ref (object);
#line 33170 "Photo.c"
	} else {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33174 "Photo.c"
	}
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 33178 "Photo.c"
}


static gchar*
photo_value_cached_pixbuf_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoCachedPixbuf ** object_p;
	object_p = collect_values[0].v_pointer;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!object_p) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33194 "Photo.c"
	}
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = NULL;
#line 33200 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33204 "Photo.c"
	} else {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = photo_cached_pixbuf_ref (value->data[0].v_pointer);
#line 33208 "Photo.c"
	}
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 33212 "Photo.c"
}


static GParamSpec*
photo_param_spec_cached_pixbuf (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	PhotoParamSpecCachedPixbuf* spec;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_CACHED_PIXBUF), NULL);
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33232 "Photo.c"
}


static gpointer
photo_value_get_cached_pixbuf (const GValue* value)
{
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF), NULL);
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33243 "Photo.c"
}


static void
photo_value_set_cached_pixbuf (GValue* value,
                               gpointer v_object)
{
	PhotoCachedPixbuf * old;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_cached_pixbuf_ref (value->data[0].v_pointer);
#line 33266 "Photo.c"
	} else {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33270 "Photo.c"
	}
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_cached_pixbuf_unref (old);
#line 33276 "Photo.c"
	}
}


static void
photo_value_take_cached_pixbuf (GValue* value,
                                gpointer v_object)
{
	PhotoCachedPixbuf * old;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_CACHED_PIXBUF));
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33298 "Photo.c"
	} else {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33302 "Photo.c"
	}
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_cached_pixbuf_unref (old);
#line 33308 "Photo.c"
	}
}


static void
photo_cached_pixbuf_class_init (PhotoCachedPixbufClass * klass)
{
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_cached_pixbuf_parent_class = g_type_class_peek_parent (klass);
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoCachedPixbufClass *) klass)->finalize = photo_cached_pixbuf_finalize;
#line 33320 "Photo.c"
}


static void
photo_cached_pixbuf_instance_init (PhotoCachedPixbuf * self)
{
	GTimer* _tmp0_;
#line 300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = g_timer_new ();
#line 300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->last_touched = _tmp0_;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->ref_count = 1;
#line 33334 "Photo.c"
}


static void
photo_cached_pixbuf_finalize (PhotoCachedPixbuf * obj)
{
	PhotoCachedPixbuf * self;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_CACHED_PIXBUF, PhotoCachedPixbuf);
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 298 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->photo);
#line 299 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->pixbuf);
#line 300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_timer_destroy0 (self->last_touched);
#line 33352 "Photo.c"
}


static GType
photo_cached_pixbuf_get_type (void)
{
	static volatile gsize photo_cached_pixbuf_type_id__volatile = 0;
	if (g_once_init_enter (&photo_cached_pixbuf_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_cached_pixbuf_init, photo_value_cached_pixbuf_free_value, photo_value_cached_pixbuf_copy_value, photo_value_cached_pixbuf_peek_pointer, "p", photo_value_cached_pixbuf_collect_value, "p", photo_value_cached_pixbuf_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoCachedPixbufClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_cached_pixbuf_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoCachedPixbuf), 0, (GInstanceInitFunc) photo_cached_pixbuf_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_cached_pixbuf_type_id;
		photo_cached_pixbuf_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoCachedPixbuf", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_cached_pixbuf_type_id__volatile, photo_cached_pixbuf_type_id);
	}
	return photo_cached_pixbuf_type_id__volatile;
}


static gpointer
photo_cached_pixbuf_ref (gpointer instance)
{
	PhotoCachedPixbuf * self;
	self = instance;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return instance;
#line 33381 "Photo.c"
}


static void
photo_cached_pixbuf_unref (gpointer instance)
{
	PhotoCachedPixbuf * self;
	self = instance;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		PHOTO_CACHED_PIXBUF_GET_CLASS (self)->finalize (self);
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33396 "Photo.c"
	}
}


PhotoReimportMasterState*
photo_reimport_master_state_construct (GType object_type)
{
	PhotoReimportMasterState* self = NULL;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 33409 "Photo.c"
}


static void
photo_value_reimport_master_state_init (GValue* value)
{
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33418 "Photo.c"
}


static void
photo_value_reimport_master_state_free_value (GValue* value)
{
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 33429 "Photo.c"
	}
}


static void
photo_value_reimport_master_state_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 33442 "Photo.c"
	} else {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33446 "Photo.c"
	}
}


static gpointer
photo_value_reimport_master_state_peek_pointer (const GValue* value)
{
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33456 "Photo.c"
}


static gchar*
photo_value_reimport_master_state_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33468 "Photo.c"
		PhotoReimportMasterState * object;
		object = collect_values[0].v_pointer;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33475 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33479 "Photo.c"
		}
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 33483 "Photo.c"
	} else {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33487 "Photo.c"
	}
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 33491 "Photo.c"
}


static gchar*
photo_value_reimport_master_state_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	PhotoReimportMasterState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!object_p) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33507 "Photo.c"
	}
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = NULL;
#line 33513 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33517 "Photo.c"
	} else {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 33521 "Photo.c"
	}
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 33525 "Photo.c"
}


GParamSpec*
photo_param_spec_reimport_master_state (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	PhotoParamSpecReimportMasterState* spec;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33545 "Photo.c"
}


gpointer
photo_value_get_reimport_master_state (const GValue* value)
{
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33556 "Photo.c"
}


void
photo_value_set_reimport_master_state (GValue* value,
                                       gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 33579 "Photo.c"
	} else {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33583 "Photo.c"
	}
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 33589 "Photo.c"
	}
}


void
photo_value_take_reimport_master_state (GValue* value,
                                        gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33611 "Photo.c"
	} else {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33615 "Photo.c"
	}
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 33621 "Photo.c"
	}
}


static void
photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass)
{
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_finalize;
#line 33633 "Photo.c"
}


static void
photo_reimport_master_state_instance_init (PhotoReimportMasterState * self)
{
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->ref_count = 1;
#line 33642 "Photo.c"
}


static void
photo_reimport_master_state_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterState * self;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 33654 "Photo.c"
}


GType
photo_reimport_master_state_get_type (void)
{
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}


gpointer
photo_reimport_master_state_ref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return instance;
#line 33683 "Photo.c"
}


void
photo_reimport_master_state_unref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33698 "Photo.c"
	}
}


static gchar**
_vala_array_dup27 (gchar** self,
                   int length)
{
	gchar** result;
	int i;
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = g_new0 (gchar*, length + 1);
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	for (i = 0; i < length; i++) {
#line 33713 "Photo.c"
		gchar* _tmp0_;
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = g_strdup (self[i]);
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result[i] = _tmp0_;
#line 33719 "Photo.c"
	}
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 33723 "Photo.c"
}


static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_construct (GType object_type,
                                            PhotoRow* row,
                                            PhotoMetadata* metadata,
                                            gchar** alterations,
                                            int alterations_length1)
{
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 1379 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 1379 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1379 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 1380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->row = _tmp0_;
#line 1381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1381 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->metadata = _tmp1_;
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = (alterations != NULL) ? _vala_array_dup27 (alterations, alterations_length1) : ((gpointer) alterations);
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2__length1 = alterations_length1;
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->alterations = _tmp2_;
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->alterations_length1 = _tmp2__length1;
#line 1382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1379 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 33771 "Photo.c"
}


static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_new (PhotoRow* row,
                                      PhotoMetadata* metadata,
                                      gchar** alterations,
                                      int alterations_length1)
{
#line 1379 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 33783 "Photo.c"
}


static void
photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass)
{
#line 1373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 33794 "Photo.c"
}


static void
photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self)
{
	PhotoRow* _tmp0_;
#line 1374 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1374 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->row = _tmp0_;
#line 1377 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 33808 "Photo.c"
}


static void
photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterStateImpl * self;
#line 1373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl);
#line 1374 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1375 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1376 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 33826 "Photo.c"
}


static GType
photo_reimport_master_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}


PhotoReimportEditableState*
photo_reimport_editable_state_construct (GType object_type)
{
	PhotoReimportEditableState* self = NULL;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 33852 "Photo.c"
}


static void
photo_value_reimport_editable_state_init (GValue* value)
{
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33861 "Photo.c"
}


static void
photo_value_reimport_editable_state_free_value (GValue* value)
{
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 33872 "Photo.c"
	}
}


static void
photo_value_reimport_editable_state_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 33885 "Photo.c"
	} else {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33889 "Photo.c"
	}
}


static gpointer
photo_value_reimport_editable_state_peek_pointer (const GValue* value)
{
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33899 "Photo.c"
}


static gchar*
photo_value_reimport_editable_state_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33911 "Photo.c"
		PhotoReimportEditableState * object;
		object = collect_values[0].v_pointer;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33918 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33922 "Photo.c"
		}
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 33926 "Photo.c"
	} else {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33930 "Photo.c"
	}
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 33934 "Photo.c"
}


static gchar*
photo_value_reimport_editable_state_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	PhotoReimportEditableState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!object_p) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33950 "Photo.c"
	}
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = NULL;
#line 33956 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33960 "Photo.c"
	} else {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 33964 "Photo.c"
	}
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 33968 "Photo.c"
}


GParamSpec*
photo_param_spec_reimport_editable_state (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	PhotoParamSpecReimportEditableState* spec;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33988 "Photo.c"
}


gpointer
photo_value_get_reimport_editable_state (const GValue* value)
{
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33999 "Photo.c"
}


void
photo_value_set_reimport_editable_state (GValue* value,
                                         gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 34022 "Photo.c"
	} else {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34026 "Photo.c"
	}
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 34032 "Photo.c"
	}
}


void
photo_value_take_reimport_editable_state (GValue* value,
                                          gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 34054 "Photo.c"
	} else {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34058 "Photo.c"
	}
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 34064 "Photo.c"
	}
}


static void
photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass)
{
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_finalize;
#line 34076 "Photo.c"
}


static void
photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self)
{
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->ref_count = 1;
#line 34085 "Photo.c"
}


static void
photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableState * self;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 34097 "Photo.c"
}


GType
photo_reimport_editable_state_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}


gpointer
photo_reimport_editable_state_ref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return instance;
#line 34126 "Photo.c"
}


void
photo_reimport_editable_state_unref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 34141 "Photo.c"
	}
}


static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_construct (GType object_type,
                                              BackingPhotoRow* backing_state,
                                              PhotoMetadata* metadata)
{
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing_state), NULL);
#line 1394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing_state);
#line 1395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1396 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->metadata = _tmp1_;
#line 1394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 34174 "Photo.c"
}


static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                        PhotoMetadata* metadata)
{
#line 1394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 34184 "Photo.c"
}


static void
photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass)
{
#line 1389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 34195 "Photo.c"
}


static void
photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self)
{
	BackingPhotoRow* _tmp0_;
#line 1390 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1390 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1392 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 34209 "Photo.c"
}


static void
photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableStateImpl * self;
#line 1389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl);
#line 1390 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1391 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 34225 "Photo.c"
}


static GType
photo_reimport_editable_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}


PhotoReimportRawDevelopmentState*
photo_reimport_raw_development_state_construct (GType object_type)
{
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 34251 "Photo.c"
}


static void
photo_value_reimport_raw_development_state_init (GValue* value)
{
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 34260 "Photo.c"
}


static void
photo_value_reimport_raw_development_state_free_value (GValue* value)
{
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 34271 "Photo.c"
	}
}


static void
photo_value_reimport_raw_development_state_copy_value (const GValue* src_value,
                                                       GValue* dest_value)
{
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 34284 "Photo.c"
	} else {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 34288 "Photo.c"
	}
}


static gpointer
photo_value_reimport_raw_development_state_peek_pointer (const GValue* value)
{
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 34298 "Photo.c"
}


static gchar*
photo_value_reimport_raw_development_state_collect_value (GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 34310 "Photo.c"
		PhotoReimportRawDevelopmentState * object;
		object = collect_values[0].v_pointer;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 34317 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 34321 "Photo.c"
		}
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 34325 "Photo.c"
	} else {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34329 "Photo.c"
	}
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 34333 "Photo.c"
}


static gchar*
photo_value_reimport_raw_development_state_lcopy_value (const GValue* value,
                                                        guint n_collect_values,
                                                        GTypeCValue* collect_values,
                                                        guint collect_flags)
{
	PhotoReimportRawDevelopmentState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!object_p) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 34349 "Photo.c"
	}
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = NULL;
#line 34355 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 34359 "Photo.c"
	} else {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 34363 "Photo.c"
	}
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 34367 "Photo.c"
}


GParamSpec*
photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags)
{
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 34387 "Photo.c"
}


gpointer
photo_value_get_reimport_raw_development_state (const GValue* value)
{
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 34398 "Photo.c"
}


void
photo_value_set_reimport_raw_development_state (GValue* value,
                                                gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 34421 "Photo.c"
	} else {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34425 "Photo.c"
	}
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 34431 "Photo.c"
	}
}


void
photo_value_take_reimport_raw_development_state (GValue* value,
                                                 gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 34453 "Photo.c"
	} else {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34457 "Photo.c"
	}
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 34463 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass)
{
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 34475 "Photo.c"
}


static void
photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self)
{
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->ref_count = 1;
#line 34484 "Photo.c"
}


static void
photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentState * self;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState);
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 34496 "Photo.c"
}


GType
photo_reimport_raw_development_state_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__volatile, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__volatile;
}


gpointer
photo_reimport_raw_development_state_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return instance;
#line 34525 "Photo.c"
}


void
photo_reimport_raw_development_state_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 34540 "Photo.c"
	}
}


static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_construct (GType object_type)
{
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 34553 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_new (void)
{
#line 1417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 34562 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                               BackingPhotoRow* backing,
                                               PhotoMetadata* metadata)
{
	GeeCollection* _tmp0_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp1_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp2_;
#line 1420 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self));
#line 1420 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (backing));
#line 1420 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 1421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->list;
#line 1421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (backing, metadata);
#line 1421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp2_);
#line 1421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp2_);
#line 34590 "Photo.c"
}


static gint
photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self)
{
	gint result = 0;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1424 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (self), 0);
#line 1425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->list;
#line 1425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp2_;
#line 1425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 34613 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                     BackingPhotoRow* backing,
                                                                     PhotoMetadata* metadata)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (backing), NULL);
#line 1408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 1408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1409 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing);
#line 1409 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1409 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->backing = _tmp0_;
#line 1410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->metadata = _tmp1_;
#line 1408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 34645 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                               PhotoMetadata* metadata)
{
#line 1408 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 34655 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value)
{
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 34664 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value)
{
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 34675 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value,
                                                                            GValue* dest_value)
{
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 34688 "Photo.c"
	} else {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 34692 "Photo.c"
	}
}


static gpointer
photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value)
{
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 34702 "Photo.c"
}


static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value,
                                                                               guint n_collect_values,
                                                                               GTypeCValue* collect_values,
                                                                               guint collect_flags)
{
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 34714 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport * object;
		object = collect_values[0].v_pointer;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 34721 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 34725 "Photo.c"
		}
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 34729 "Photo.c"
	} else {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34733 "Photo.c"
	}
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 34737 "Photo.c"
}


static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value,
                                                                             guint n_collect_values,
                                                                             GTypeCValue* collect_values,
                                                                             guint collect_flags)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!object_p) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 34753 "Photo.c"
	}
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = NULL;
#line 34759 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 34763 "Photo.c"
	} else {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 34767 "Photo.c"
	}
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return NULL;
#line 34771 "Photo.c"
}


static GParamSpec*
photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                      const gchar* nick,
                                                                      const gchar* blurb,
                                                                      GType object_type,
                                                                      GParamFlags flags)
{
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 34791 "Photo.c"
}


static gpointer
photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value)
{
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 34802 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                     gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 34825 "Photo.c"
	} else {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34829 "Photo.c"
	}
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 34835 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                      gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (v_object) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 34857 "Photo.c"
	} else {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 34861 "Photo.c"
	}
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 34867 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass)
{
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateImplDevToReimportClass *) klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 34879 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self)
{
	BackingPhotoRow* _tmp0_;
#line 1405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->backing = _tmp0_;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->ref_count = 1;
#line 34893 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport);
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 1405 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1406 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 34909 "Photo.c"
}


GType
photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile;
}


static gpointer
photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return instance;
#line 34938 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1404 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 34953 "Photo.c"
	}
}


static void
photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass)
{
#line 1403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 34965 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self)
{
	GeeArrayList* _tmp0_;
#line 1414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, (GDestroyNotify) photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL, NULL, NULL);
#line 1414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->list = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 34979 "Photo.c"
}


static void
photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl);
#line 1414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 34993 "Photo.c"
}


static GType
photo_reimport_raw_development_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__volatile, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__volatile;
}


static void
photo_class_init (PhotoClass * klass)
{
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPrivate));
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_replaced = (void (*) (Photo*, GFile*, GFile*)) photo_real_notify_editable_replaced;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_raw_development_modified = (void (*) (Photo*)) photo_real_notify_raw_development_modified;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_replaced = (void (*) (Photo*)) photo_real_notify_baseline_replaced;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_master_reimported;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_editable_reimported;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_source_reimported;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_baseline_reimported;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) photo_real_internal_delete_backing;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*) (MediaSource*, int*)) photo_real_get_backing_files_state;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) photo_real_apply_user_metadata_for_reimport;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) photo_real_get_typename;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) photo_real_get_instance_id;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataSourceClass *) klass)->get_source_id = (gchar* (*) (DataSource*)) photo_real_get_source_id;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) photo_real_get_preferred_thumbnail_format;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) photo_real_create_thumbnail;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_file = (GFile* (*) (MediaSource*)) photo_real_get_file;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*) (MediaSource*)) photo_real_get_master_file;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_timestamp = (time_t (*) (MediaSource*)) photo_real_get_timestamp;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_event_id = (void (*) (MediaSource*, EventID*)) photo_real_get_event_id;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_import_id = (void (*) (MediaSource*, ImportID*)) photo_real_get_import_id;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*) (MediaSource*)) photo_real_get_master_md5;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_rating = (Rating (*) (MediaSource*)) photo_real_get_rating;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->set_rating = (void (*) (MediaSource*, Rating)) photo_real_set_rating;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->increase_rating = (void (*) (MediaSource*)) photo_real_increase_rating;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->decrease_rating = (void (*) (MediaSource*)) photo_real_decrease_rating;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource*, SourceCollection*, const gchar*)) photo_real_commit_backlinks;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*) (MediaSource*, EventID*)) photo_real_set_event_id;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject*)) photo_real_to_string;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataSourceClass *) klass)->equals = (gboolean (*) (DataSource*, DataSource*)) photo_real_equals;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*) (MediaSource*)) photo_real_get_filesize;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*) (MediaSource*)) photo_real_get_master_filesize;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_exposure_time = (time_t (*) (MediaSource*)) photo_real_get_exposure_time;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_basename = (gchar* (*) (MediaSource*)) photo_real_get_basename;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_title = (gchar* (*) (MediaSource*)) photo_real_get_title;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_comment = (gchar* (*) (MediaSource*)) photo_real_get_comment;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->set_title = (void (*) (MediaSource*, const gchar*)) photo_real_set_title;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->set_comment = (gboolean (*) (MediaSource*, const gchar*)) photo_real_set_comment;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_dimensions = (void (*) (MediaSource*, PhotoException, Dimensions*)) photo_real_get_dimensions;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoSourceClass *) klass)->get_metadata = (PhotoMetadata* (*) (PhotoSource*)) photo_real_get_metadata;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) photo_real_rotate;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoSourceClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoSource*, Scaling*, GError**)) photo_real_get_pixbuf;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) photo_real_has_user_generated_metadata;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) photo_real_set_user_metadata_for_export;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->editable_replaced = photo_real_editable_replaced;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->raw_development_modified = photo_real_raw_development_modified;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->baseline_replaced = photo_real_baseline_replaced;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->master_reimported = photo_real_master_reimported;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->editable_reimported = photo_real_editable_reimported;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->baseline_reimported = photo_real_baseline_reimported;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->source_reimported = photo_real_source_reimported;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL] = g_signal_new ("editable-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_get_type ());
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL] = g_signal_new ("raw-development-modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL] = g_signal_new ("baseline-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_rec_mutex_init (&__lock_photo_photo_source_pixbuf_cache);
#line 35140 "Photo.c"
}


static void
photo_dateable_interface_init (DateableIface * iface)
{
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->get_exposure_time = (time_t (*) (Dateable*)) photo_real_get_exposure_time;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->set_exposure_time = (void (*) (Dateable*, time_t)) photo_real_set_exposure_time;
#line 35153 "Photo.c"
}


static void
photo_positionable_interface_init (PositionableIface * iface)
{
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_positionable_parent_iface = g_type_interface_peek_parent (iface);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->get_gps_coords = (void (*) (Positionable*, GpsCoords*)) photo_real_get_gps_coords;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->set_gps_coords = (void (*) (Positionable*, GpsCoords*)) photo_real_set_gps_coords;
#line 35166 "Photo.c"
}


static void
photo_instance_init (Photo * self)
{
	BackingPhotoRow* _tmp0_;
	PhotoBackingReaders* _tmp1_;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv = PHOTO_GET_PRIVATE (self);
#line 328 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_row);
#line 329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 330 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_readers);
#line 330 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 330 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 331 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->transformer = NULL;
#line 332 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->adjustments = NULL;
#line 334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->file_title = NULL;
#line 335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 343 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_developments);
#line 343 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->developments = NULL;
#line 350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->backing_photo_row = NULL;
#line 35211 "Photo.c"
}


static void
photo_finalize (GObject * obj)
{
	Photo * self;
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO, Photo);
#line 328 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_row);
#line 328 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 329 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 330 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_readers);
#line 330 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 331 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 332 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 336 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 338 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 343 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_developments);
#line 343 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 35253 "Photo.c"
}


GType
photo_get_type (void)
{
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo positionable_info = { (GInterfaceInitFunc) photo_positionable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType photo_type_id;
		photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
		g_type_add_interface_static (photo_type_id, TYPE_POSITIONABLE, &positionable_info);
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}


static void
_vala_photo_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	switch (property_id) {
#line 35285 "Photo.c"
		default:
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		break;
#line 35291 "Photo.c"
	}
}


static void
_vala_photo_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	switch (property_id) {
#line 35306 "Photo.c"
		default:
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 158 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		break;
#line 35312 "Photo.c"
	}
}


GType
library_photo_source_collection_state_get_type (void)
{
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}


static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 4513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35339 "Photo.c"
}


static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 4513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35352 "Photo.c"
}


static gint
_int64_compare_gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = int64_compare ((gint64*) a, (gint64*) b);
#line 4517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35365 "Photo.c"
}


static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 4517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return dup;
#line 35379 "Photo.c"
}


static gboolean
_int64_equal_gee_equal_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gboolean result;
	result = int64_equal ((gint64*) a, (gint64*) b);
#line 4519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35392 "Photo.c"
}


static gint64
_photo_get_photo_key_get_source_database_key (DataSource* source,
                                              gpointer self)
{
	gint64 result;
	result = photo_get_photo_key (source);
#line 4539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35404 "Photo.c"
}


static void
_library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                    GeeCollection* added,
                                                                                                    GeeCollection* removed,
                                                                                                    gpointer self)
{
#line 4541 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 35416 "Photo.c"
}


static void
_library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                   GeeCollection* added,
                                                                                                   GeeCollection* removed,
                                                                                                   gpointer self)
{
#line 4542 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 35428 "Photo.c"
}


LibraryPhotoSourceCollection*
library_photo_source_collection_construct (GType object_type)
{
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4541 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4541 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4541 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4541 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4542 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4542 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4542 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4542 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 35460 "Photo.c"
}


LibraryPhotoSourceCollection*
library_photo_source_collection_new (void)
{
#line 4538 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 35469 "Photo.c"
}


static gboolean
_library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35482 "Photo.c"
}


static MediaSourceHoldingTank*
library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4545 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 4546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35500 "Photo.c"
}


static gboolean
_library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35513 "Photo.c"
}


static MediaSourceHoldingTank*
library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank);
#line 4550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35531 "Photo.c"
}


static MediaMonitor*
library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                           Workers* workers,
                                                           GCancellable* cancellable)
{
	LibraryPhotoSourceCollection * self;
	MediaMonitor* result = NULL;
	PhotoMonitor* _tmp0_;
#line 4553 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4553 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_WORKERS (workers), NULL);
#line 4553 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 4554 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_monitor_new (workers, cancellable);
#line 4554 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_MONITOR, MediaMonitor);
#line 4554 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35555 "Photo.c"
}


static gboolean
library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                           DataSource* source)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
#line 4557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = IS_LIBRARY_PHOTO (source);
#line 4558 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35573 "Photo.c"
}


static gchar*
library_photo_source_collection_real_get_typename (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 4561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4562 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4562 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp0_;
#line 4562 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35591 "Photo.c"
}


static gboolean
library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                         GFile* file)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
#line 4565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 4566 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_file_format_is_file_supported (file);
#line 4566 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 35609 "Photo.c"
}


static void
_library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                               GFile* old_file,
                                                                               GFile* new_file,
                                                                               gpointer self)
{
#line 4578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_on_editable_replaced ((LibraryPhotoSourceCollection*) self, _sender, old_file, new_file);
#line 35621 "Photo.c"
}


static void
_library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                             gpointer self)
{
#line 4584 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified ((LibraryPhotoSourceCollection*) self, _sender);
#line 35631 "Photo.c"
}


static void
library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                              GeeIterable* added,
                                                              GeeIterable* removed)
{
	LibraryPhotoSourceCollection * self;
#line 4569 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4569 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_ITERABLE));
#line 4569 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_ITERABLE));
#line 4571 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (added != NULL) {
#line 35649 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (added);
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_object_it = _tmp0_;
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 35659 "Photo.c"
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp4_;
				LibraryPhoto* _tmp5_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				LibraryPhoto* _tmp12_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				LibraryPhoto* _tmp24_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoRow* _tmp27_;
				gint64 _tmp28_;
				gint64 _tmp29_;
				gint64 _tmp30_ = 0LL;
				LibraryPhoto* _tmp31_;
				BackingPhotoRow* _tmp32_;
				BackingPhotoRow* _tmp33_;
				gboolean _tmp34_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp39_;
				gint64 _tmp40_;
				LibraryPhoto* _tmp41_;
				GeeHashMap* _tmp42_;
				LibraryPhoto* _tmp43_;
				gint64 _tmp44_;
				gint64 _tmp45_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp52_;
				GeeCollection* _tmp53_;
				GeeCollection* _tmp54_;
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = _object_it;
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 35706 "Photo.c"
				}
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = _object_it;
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				object = (DataObject*) _tmp3_;
#line 4573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = object;
#line 4573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4573 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo = _tmp5_;
#line 4575 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = photo;
#line 4575 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PHOTO, Photo));
#line 4575 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				editable = _tmp7_;
#line 4576 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = editable;
#line 4576 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp8_ != NULL) {
#line 35730 "Photo.c"
					GeeHashMap* _tmp9_;
					GFile* _tmp10_;
					LibraryPhoto* _tmp11_;
#line 4577 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp9_ = self->priv->by_editable_file;
#line 4577 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = editable;
#line 4577 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_ = photo;
#line 4577 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp10_, _tmp11_);
#line 35742 "Photo.c"
				}
#line 4578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = photo;
#line 4578 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PHOTO, Photo), "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4580 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = photo;
#line 4580 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO, Photo));
#line 4580 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				raw_list = _tmp14_;
#line 4581 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = raw_list;
#line 4581 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 35758 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp16_;
						GeeIterator* _tmp17_;
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp16_ = raw_list;
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp17_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_f_it = _tmp17_;
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						while (TRUE) {
#line 35771 "Photo.c"
							GeeIterator* _tmp18_;
							GFile* f = NULL;
							GeeIterator* _tmp19_;
							gpointer _tmp20_;
							GeeHashMap* _tmp21_;
							GFile* _tmp22_;
							LibraryPhoto* _tmp23_;
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp18_ = _f_it;
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (!gee_iterator_next (_tmp18_)) {
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								break;
#line 35785 "Photo.c"
							}
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp19_ = _f_it;
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							f = (GFile*) _tmp20_;
#line 4583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp21_ = self->priv->by_raw_development_file;
#line 4583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp22_ = f;
#line 4583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp23_ = photo;
#line 4583 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp22_, _tmp23_);
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (f);
#line 35803 "Photo.c"
						}
#line 4582 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 35807 "Photo.c"
					}
				}
#line 4584 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = photo;
#line 4584 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_PHOTO, Photo), "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = photo;
#line 4586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp26_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_PHOTO, Photo));
#line 4586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp27_ = _tmp26_;
#line 4586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = _tmp27_->filesize;
#line 4586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = _tmp28_;
#line 4586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp27_);
#line 4586 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				master_filesize = _tmp29_;
#line 4587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp31_ = photo;
#line 4587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp32_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_PHOTO, Photo));
#line 4587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp34_ = _tmp33_ != NULL;
#line 4587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp33_);
#line 4587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp34_) {
#line 35840 "Photo.c"
					LibraryPhoto* _tmp35_;
					BackingPhotoRow* _tmp36_;
					BackingPhotoRow* _tmp37_;
					gint64 _tmp38_;
#line 4588 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp35_ = photo;
#line 4588 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp36_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_PHOTO, Photo));
#line 4588 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp37_ = _tmp36_;
#line 4588 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp38_ = _tmp37_->filesize;
#line 4588 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp30_ = _tmp38_;
#line 4588 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp37_);
#line 35857 "Photo.c"
				} else {
#line 4589 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp30_ = (gint64) -1;
#line 35861 "Photo.c"
				}
#line 4587 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				editable_filesize = _tmp30_;
#line 4590 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp39_ = self->priv->filesize_to_photo;
#line 4590 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp40_ = master_filesize;
#line 4590 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp41_ = photo;
#line 4590 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_multi_map_set (_tmp39_, &_tmp40_, _tmp41_);
#line 4591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp42_ = self->priv->photo_to_master_filesize;
#line 4591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp43_ = photo;
#line 4591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp44_ = master_filesize;
#line 4591 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp43_, &_tmp44_);
#line 4592 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp45_ = editable_filesize;
#line 4592 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp45_ >= ((gint64) 0)) {
#line 35885 "Photo.c"
					GeeMultiMap* _tmp46_;
					gint64 _tmp47_;
					LibraryPhoto* _tmp48_;
					GeeHashMap* _tmp49_;
					LibraryPhoto* _tmp50_;
					gint64 _tmp51_;
#line 4593 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp46_ = self->priv->filesize_to_photo;
#line 4593 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp47_ = editable_filesize;
#line 4593 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp48_ = photo;
#line 4593 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_multi_map_set (_tmp46_, &_tmp47_, _tmp48_);
#line 4594 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp49_ = self->priv->photo_to_editable_filesize;
#line 4594 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp50_ = photo;
#line 4594 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp51_ = editable_filesize;
#line 4594 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp50_, &_tmp51_);
#line 35908 "Photo.c"
				}
#line 4597 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp52_ = photo;
#line 4597 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp53_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, TYPE_PHOTO, Photo));
#line 4597 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				raw_rows = _tmp53_;
#line 4598 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp54_ = raw_rows;
#line 4598 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp54_ != NULL) {
#line 35920 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp55_;
						GeeIterator* _tmp56_;
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp55_ = raw_rows;
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp56_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_row_it = _tmp56_;
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						while (TRUE) {
#line 35933 "Photo.c"
							GeeIterator* _tmp57_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp58_;
							gpointer _tmp59_;
							BackingPhotoRow* _tmp60_;
							gint64 _tmp61_;
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp57_ = _row_it;
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (!gee_iterator_next (_tmp57_)) {
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								break;
#line 35946 "Photo.c"
							}
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp58_ = _row_it;
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp59_ = gee_iterator_get (_tmp58_);
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp59_;
#line 4600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp60_ = row;
#line 4600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp61_ = _tmp60_->filesize;
#line 4600 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (_tmp61_ >= ((gint64) 0)) {
#line 35960 "Photo.c"
								GeeMultiMap* _tmp62_;
								BackingPhotoRow* _tmp63_;
								gint64 _tmp64_;
								LibraryPhoto* _tmp65_;
								GeeMultiMap* _tmp66_;
								LibraryPhoto* _tmp67_;
								BackingPhotoRow* _tmp68_;
								gint64 _tmp69_;
#line 4601 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp62_ = self->priv->filesize_to_photo;
#line 4601 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp63_ = row;
#line 4601 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp64_ = _tmp63_->filesize;
#line 4601 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp65_ = photo;
#line 4601 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								gee_multi_map_set (_tmp62_, &_tmp64_, _tmp65_);
#line 4602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp66_ = self->priv->photo_to_raw_development_filesize;
#line 4602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp67_ = photo;
#line 4602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp68_ = row;
#line 4602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp69_ = _tmp68_->filesize;
#line 4602 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								gee_multi_map_set (_tmp66_, _tmp67_, &_tmp69_);
#line 35989 "Photo.c"
							}
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 35993 "Photo.c"
						}
#line 4599 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 35997 "Photo.c"
					}
				}
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (object);
#line 36010 "Photo.c"
			}
#line 4572 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 36014 "Photo.c"
		}
	}
#line 4609 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (removed != NULL) {
#line 36019 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp70_;
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp70_ = gee_iterable_iterator (removed);
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_object_it = _tmp70_;
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 36029 "Photo.c"
				GeeIterator* _tmp71_;
				DataObject* object = NULL;
				GeeIterator* _tmp72_;
				gpointer _tmp73_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp74_;
				LibraryPhoto* _tmp75_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp76_;
				GFile* _tmp77_;
				GFile* _tmp78_;
				LibraryPhoto* _tmp85_;
				guint _tmp86_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp87_;
				GeeCollection* _tmp88_;
				GeeCollection* _tmp89_;
				LibraryPhoto* _tmp97_;
				guint _tmp98_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp99_;
				BackingPhotoRow* _tmp100_;
				BackingPhotoRow* _tmp101_;
				gint64 _tmp102_;
				gint64 _tmp103_;
				gint64 _tmp104_ = 0LL;
				LibraryPhoto* _tmp105_;
				BackingPhotoRow* _tmp106_;
				BackingPhotoRow* _tmp107_;
				gboolean _tmp108_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp113_;
				gint64 _tmp114_;
				LibraryPhoto* _tmp115_;
				GeeHashMap* _tmp116_;
				LibraryPhoto* _tmp117_;
				gint64 _tmp118_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp124_;
				GeeCollection* _tmp125_;
				GeeCollection* _tmp126_;
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp71_ = _object_it;
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp71_)) {
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 36077 "Photo.c"
				}
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp72_ = _object_it;
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp73_ = gee_iterator_get (_tmp72_);
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				object = (DataObject*) _tmp73_;
#line 4611 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp74_ = object;
#line 4611 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp75_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4611 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo = _tmp75_;
#line 4613 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp76_ = photo;
#line 4613 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp77_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, TYPE_PHOTO, Photo));
#line 4613 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				editable = _tmp77_;
#line 4614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp78_ = editable;
#line 4614 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp78_ != NULL) {
#line 36101 "Photo.c"
					gboolean is_removed = FALSE;
					GeeHashMap* _tmp79_;
					LibraryPhoto* _tmp80_;
					GFile* _tmp81_;
					GFile* _tmp82_;
					gboolean _tmp83_;
					gboolean _tmp84_;
#line 4615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp79_ = self->priv->by_editable_file;
#line 4615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp80_ = photo;
#line 4615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp81_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, TYPE_PHOTO, Photo));
#line 4615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp82_ = _tmp81_;
#line 4615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp83_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp82_, NULL);
#line 4615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp82_);
#line 4615 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					is_removed = _tmp83_;
#line 4616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp84_ = is_removed;
#line 4616 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_vala_assert (_tmp84_, "is_removed");
#line 36127 "Photo.c"
				}
#line 4618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp85_ = photo;
#line 4618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp86_, NULL, FALSE);
#line 4618 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp85_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp86_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp87_ = photo;
#line 4620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp88_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp87_, TYPE_PHOTO, Photo));
#line 4620 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				raw_list = _tmp88_;
#line 4621 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp89_ = raw_list;
#line 4621 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp89_ != NULL) {
#line 36145 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp90_;
						GeeIterator* _tmp91_;
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp90_ = raw_list;
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp91_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp90_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_f_it = _tmp91_;
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						while (TRUE) {
#line 36158 "Photo.c"
							GeeIterator* _tmp92_;
							GFile* f = NULL;
							GeeIterator* _tmp93_;
							gpointer _tmp94_;
							GeeHashMap* _tmp95_;
							GFile* _tmp96_;
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp92_ = _f_it;
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (!gee_iterator_next (_tmp92_)) {
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								break;
#line 36171 "Photo.c"
							}
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp93_ = _f_it;
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp94_ = gee_iterator_get (_tmp93_);
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							f = (GFile*) _tmp94_;
#line 4623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp95_ = self->priv->by_raw_development_file;
#line 4623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp96_ = f;
#line 4623 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp95_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp96_, NULL);
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (f);
#line 36187 "Photo.c"
						}
#line 4622 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 36191 "Photo.c"
					}
				}
#line 4624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp97_ = photo;
#line 4624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp98_, NULL, FALSE);
#line 4624 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp97_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp98_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp99_ = photo;
#line 4626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp100_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp99_, TYPE_PHOTO, Photo));
#line 4626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp101_ = _tmp100_;
#line 4626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp102_ = _tmp101_->filesize;
#line 4626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp103_ = _tmp102_;
#line 4626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp101_);
#line 4626 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				master_filesize = _tmp103_;
#line 4627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp105_ = photo;
#line 4627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp106_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, TYPE_PHOTO, Photo));
#line 4627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp107_ = _tmp106_;
#line 4627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp108_ = _tmp107_ != NULL;
#line 4627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp107_);
#line 4627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp108_) {
#line 36226 "Photo.c"
					LibraryPhoto* _tmp109_;
					BackingPhotoRow* _tmp110_;
					BackingPhotoRow* _tmp111_;
					gint64 _tmp112_;
#line 4628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp109_ = photo;
#line 4628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp110_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp109_, TYPE_PHOTO, Photo));
#line 4628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp111_ = _tmp110_;
#line 4628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp112_ = _tmp111_->filesize;
#line 4628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp104_ = _tmp112_;
#line 4628 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp111_);
#line 36243 "Photo.c"
				} else {
#line 4629 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp104_ = (gint64) -1;
#line 36247 "Photo.c"
				}
#line 4627 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				editable_filesize = _tmp104_;
#line 4630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp113_ = self->priv->filesize_to_photo;
#line 4630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp114_ = master_filesize;
#line 4630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp115_ = photo;
#line 4630 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_multi_map_remove (_tmp113_, &_tmp114_, _tmp115_);
#line 4631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp116_ = self->priv->photo_to_master_filesize;
#line 4631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp117_ = photo;
#line 4631 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp116_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp117_, NULL);
#line 4632 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp118_ = editable_filesize;
#line 4632 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp118_ >= ((gint64) 0)) {
#line 36269 "Photo.c"
					GeeMultiMap* _tmp119_;
					gint64 _tmp120_;
					LibraryPhoto* _tmp121_;
					GeeHashMap* _tmp122_;
					LibraryPhoto* _tmp123_;
#line 4633 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp119_ = self->priv->filesize_to_photo;
#line 4633 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp120_ = editable_filesize;
#line 4633 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp121_ = photo;
#line 4633 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_multi_map_remove (_tmp119_, &_tmp120_, _tmp121_);
#line 4634 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp122_ = self->priv->photo_to_editable_filesize;
#line 4634 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp123_ = photo;
#line 4634 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp122_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp123_, NULL);
#line 36289 "Photo.c"
				}
#line 4637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp124_ = photo;
#line 4637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp125_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp124_, TYPE_PHOTO, Photo));
#line 4637 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				raw_rows = _tmp125_;
#line 4638 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp126_ = raw_rows;
#line 4638 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp126_ != NULL) {
#line 36301 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp127_;
						GeeIterator* _tmp128_;
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp127_ = raw_rows;
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp128_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp127_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_row_it = _tmp128_;
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						while (TRUE) {
#line 36314 "Photo.c"
							GeeIterator* _tmp129_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp130_;
							gpointer _tmp131_;
							BackingPhotoRow* _tmp132_;
							gint64 _tmp133_;
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp129_ = _row_it;
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (!gee_iterator_next (_tmp129_)) {
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								break;
#line 36327 "Photo.c"
							}
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp130_ = _row_it;
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp131_ = gee_iterator_get (_tmp130_);
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp131_;
#line 4640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp132_ = row;
#line 4640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp133_ = _tmp132_->filesize;
#line 4640 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (_tmp133_ >= ((gint64) 0)) {
#line 36341 "Photo.c"
								GeeMultiMap* _tmp134_;
								BackingPhotoRow* _tmp135_;
								gint64 _tmp136_;
								LibraryPhoto* _tmp137_;
								GeeMultiMap* _tmp138_;
								LibraryPhoto* _tmp139_;
								BackingPhotoRow* _tmp140_;
								gint64 _tmp141_;
#line 4641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp134_ = self->priv->filesize_to_photo;
#line 4641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp135_ = row;
#line 4641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp136_ = _tmp135_->filesize;
#line 4641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp137_ = photo;
#line 4641 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								gee_multi_map_remove (_tmp134_, &_tmp136_, _tmp137_);
#line 4642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp138_ = self->priv->photo_to_raw_development_filesize;
#line 4642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp139_ = photo;
#line 4642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp140_ = row;
#line 4642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								_tmp141_ = _tmp140_->filesize;
#line 4642 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								gee_multi_map_remove (_tmp138_, _tmp139_, &_tmp141_);
#line 36370 "Photo.c"
							}
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 36374 "Photo.c"
						}
#line 4639 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 36378 "Photo.c"
					}
				}
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (object);
#line 36391 "Photo.c"
			}
#line 4610 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 36395 "Photo.c"
		}
	}
#line 4649 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), added, removed);
#line 36400 "Photo.c"
}


static void
library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                      Photo* photo,
                                                      GFile* old_file,
                                                      GFile* new_file)
{
#line 4652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 4652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 4652 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 4653 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old_file != NULL) {
#line 36420 "Photo.c"
		gboolean is_removed = FALSE;
		GeeHashMap* _tmp0_;
		gboolean _tmp1_;
#line 4654 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->by_editable_file;
#line 4654 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		is_removed = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), old_file, NULL);
#line 4655 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = is_removed;
#line 4655 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_assert (_tmp1_, "is_removed");
#line 36432 "Photo.c"
	}
#line 4658 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (new_file != NULL) {
#line 36436 "Photo.c"
		GeeHashMap* _tmp2_;
#line 4659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = self->priv->by_editable_file;
#line 4659 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), new_file, G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 36442 "Photo.c"
	}
}


static void
library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                             Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* _tmp22_;
	GeeCollection* raw_rows = NULL;
	LibraryPhoto* _tmp31_;
	GeeCollection* _tmp32_;
	GeeCollection* _tmp33_;
#line 4662 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4662 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 4663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 4663 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = _tmp0_;
#line 4664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo;
#line 4664 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4665 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4665 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 36480 "Photo.c"
	}
#line 4668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = self->priv->photo_to_raw_development_filesize;
#line 4668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo;
#line 4668 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 36488 "Photo.c"
		GeeMultiMap* _tmp18_;
		LibraryPhoto* _tmp19_;
		{
			GeeIterator* _s_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->priv->photo_to_raw_development_filesize;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = photo;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_s_it = _tmp9_;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 36517 "Photo.c"
				GeeIterator* _tmp10_;
				gint64 s = 0LL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				gint64* _tmp13_;
				gint64 _tmp14_;
				GeeMultiMap* _tmp15_;
				gint64 _tmp16_;
				LibraryPhoto* _tmp17_;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _s_it;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 36533 "Photo.c"
				}
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _s_it;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = (gint64*) _tmp12_;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = *_tmp13_;
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp13_);
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				s = _tmp14_;
#line 4670 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = self->priv->filesize_to_photo;
#line 4670 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = s;
#line 4670 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = photo;
#line 4670 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_multi_map_remove (_tmp15_, &_tmp16_, _tmp17_);
#line 36555 "Photo.c"
			}
#line 4669 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 36559 "Photo.c"
		}
#line 4671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp18_ = self->priv->photo_to_raw_development_filesize;
#line 4671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = photo;
#line 4671 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gee_multi_map_remove_all (_tmp18_, _tmp19_);
#line 36567 "Photo.c"
	}
#line 4675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = photo;
#line 4675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PHOTO, Photo));
#line 4675 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	raw_list = _tmp21_;
#line 4676 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp22_ = raw_list;
#line 4676 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 36579 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp23_;
			GeeIterator* _tmp24_;
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp23_ = raw_list;
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_f_it = _tmp24_;
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 36592 "Photo.c"
				GeeIterator* _tmp25_;
				GFile* f = NULL;
				GeeIterator* _tmp26_;
				gpointer _tmp27_;
				GeeHashMap* _tmp28_;
				GFile* _tmp29_;
				LibraryPhoto* _tmp30_;
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = _f_it;
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp25_)) {
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 36606 "Photo.c"
				}
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp26_ = _f_it;
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp27_ = gee_iterator_get (_tmp26_);
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				f = (GFile*) _tmp27_;
#line 4678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = self->priv->by_raw_development_file;
#line 4678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = f;
#line 4678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp30_ = photo;
#line 4678 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp29_, _tmp30_);
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 36624 "Photo.c"
			}
#line 4677 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 36628 "Photo.c"
		}
	}
#line 4680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = photo;
#line 4680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp32_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_PHOTO, Photo));
#line 4680 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	raw_rows = _tmp32_;
#line 4681 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = raw_rows;
#line 4681 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp33_ != NULL) {
#line 36641 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_;
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp34_ = raw_rows;
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp35_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_row_it = _tmp35_;
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 36654 "Photo.c"
				GeeIterator* _tmp36_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp37_;
				gpointer _tmp38_;
				BackingPhotoRow* _tmp39_;
				gint64 _tmp40_;
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp36_ = _row_it;
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp36_)) {
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 36667 "Photo.c"
				}
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp37_ = _row_it;
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp38_ = gee_iterator_get (_tmp37_);
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp38_;
#line 4683 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp39_ = row;
#line 4683 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp40_ = _tmp39_->filesize;
#line 4683 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp40_ > ((gint64) 0)) {
#line 36681 "Photo.c"
					GeeMultiMap* _tmp41_;
					BackingPhotoRow* _tmp42_;
					gint64 _tmp43_;
					LibraryPhoto* _tmp44_;
					GeeMultiMap* _tmp45_;
					LibraryPhoto* _tmp46_;
					BackingPhotoRow* _tmp47_;
					gint64 _tmp48_;
#line 4684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp41_ = self->priv->filesize_to_photo;
#line 4684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp42_ = row;
#line 4684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp43_ = _tmp42_->filesize;
#line 4684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp44_ = photo;
#line 4684 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_multi_map_set (_tmp41_, &_tmp43_, _tmp44_);
#line 4685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp45_ = self->priv->photo_to_raw_development_filesize;
#line 4685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp46_ = photo;
#line 4685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp47_ = row;
#line 4685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp48_ = _tmp47_->filesize;
#line 4685 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_multi_map_set (_tmp45_, _tmp46_, &_tmp48_);
#line 36710 "Photo.c"
				}
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 36714 "Photo.c"
			}
#line 4682 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 36718 "Photo.c"
		}
	}
#line 4662 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4662 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4662 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 36727 "Photo.c"
}


static gpointer
__int64_dup0 (gpointer self)
{
#line 4701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 36736 "Photo.c"
}


static void
library_photo_source_collection_real_items_altered (DataCollection* base,
                                                    GeeMap* items)
{
	LibraryPhotoSourceCollection * self;
#line 4691 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4691 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (items, GEE_TYPE_MAP));
#line 36749 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_object_it = _tmp4_;
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 36773 "Photo.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp10_;
			LibraryPhoto* _tmp11_;
			gboolean _tmp12_ = FALSE;
			Alteration* _tmp13_;
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = _object_it;
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 36792 "Photo.c"
			}
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _object_it;
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			object = (DataObject*) _tmp7_;
#line 4693 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = object;
#line 4693 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 4693 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			alteration = (Alteration*) _tmp9_;
#line 4695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = object;
#line 4695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4695 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo = _tmp11_;
#line 4697 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = alteration;
#line 4697 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (alteration_has_detail (_tmp13_, "image", "master")) {
#line 4697 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = TRUE;
#line 36818 "Photo.c"
			} else {
				Alteration* _tmp14_;
#line 4697 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = alteration;
#line 4697 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = alteration_has_detail (_tmp14_, "image", "editable");
#line 36825 "Photo.c"
			}
#line 4697 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp12_) {
#line 36829 "Photo.c"
				gint64 old_master_filesize = 0LL;
				GeeHashMap* _tmp15_;
				LibraryPhoto* _tmp16_;
				gpointer _tmp17_;
				gint64* _tmp18_;
				gint64 _tmp19_;
				gint64* _tmp20_ = NULL;
				GeeHashMap* _tmp21_;
				LibraryPhoto* _tmp22_;
				gint64 old_editable_filesize = 0LL;
				GeeHashMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GeeMultiMap* _tmp30_;
				gint64 _tmp31_;
				LibraryPhoto* _tmp32_;
				gint64 _tmp33_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp39_;
				BackingPhotoRow* _tmp40_;
				BackingPhotoRow* _tmp41_;
				gint64 _tmp42_;
				gint64 _tmp43_;
				gint64 _tmp44_ = 0LL;
				LibraryPhoto* _tmp45_;
				BackingPhotoRow* _tmp46_;
				BackingPhotoRow* _tmp47_;
				gboolean _tmp48_;
				gint64 editable_filesize = 0LL;
				GeeHashMap* _tmp53_;
				LibraryPhoto* _tmp54_;
				gint64 _tmp55_;
				GeeMultiMap* _tmp56_;
				gint64 _tmp57_;
				LibraryPhoto* _tmp58_;
				gint64 _tmp59_;
#line 4698 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = self->priv->photo_to_master_filesize;
#line 4698 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = photo;
#line 4698 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp16_);
#line 4698 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = (gint64*) _tmp17_;
#line 4698 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp19_ = *_tmp18_;
#line 4698 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp18_);
#line 4698 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				old_master_filesize = _tmp19_;
#line 4699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = self->priv->photo_to_editable_filesize;
#line 4699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = photo;
#line 4699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp22_)) {
#line 36885 "Photo.c"
					GeeHashMap* _tmp23_;
					LibraryPhoto* _tmp24_;
					gpointer _tmp25_;
#line 4700 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp23_ = self->priv->photo_to_editable_filesize;
#line 4700 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp24_ = photo;
#line 4700 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp25_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp24_);
#line 4700 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4700 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp20_ = (gint64*) _tmp25_;
#line 36899 "Photo.c"
				} else {
					gint64 _tmp26_;
					gint64* _tmp27_;
#line 4701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp26_ = (gint64) -1;
#line 4701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp27_ = __int64_dup0 (&_tmp26_);
#line 4701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4701 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp20_ = _tmp27_;
#line 36911 "Photo.c"
				}
#line 4699 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				old_editable_filesize = *_tmp20_;
#line 4703 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = self->priv->photo_to_master_filesize;
#line 4703 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = photo;
#line 4703 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp29_, NULL);
#line 4704 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp30_ = self->priv->filesize_to_photo;
#line 4704 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp31_ = old_master_filesize;
#line 4704 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp32_ = photo;
#line 4704 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_multi_map_remove (_tmp30_, &_tmp31_, _tmp32_);
#line 4705 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp33_ = old_editable_filesize;
#line 4705 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp33_ >= ((gint64) 0)) {
#line 36933 "Photo.c"
					GeeHashMap* _tmp34_;
					LibraryPhoto* _tmp35_;
					GeeMultiMap* _tmp36_;
					gint64 _tmp37_;
					LibraryPhoto* _tmp38_;
#line 4706 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp34_ = self->priv->photo_to_editable_filesize;
#line 4706 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp35_ = photo;
#line 4706 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp35_, NULL);
#line 4707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp36_ = self->priv->filesize_to_photo;
#line 4707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp37_ = old_editable_filesize;
#line 4707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp38_ = photo;
#line 4707 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_multi_map_remove (_tmp36_, &_tmp37_, _tmp38_);
#line 36953 "Photo.c"
				}
#line 4710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp39_ = photo;
#line 4710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp40_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_PHOTO, Photo));
#line 4710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp41_ = _tmp40_;
#line 4710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp42_ = _tmp41_->filesize;
#line 4710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp43_ = _tmp42_;
#line 4710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp41_);
#line 4710 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				master_filesize = _tmp43_;
#line 4711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp45_ = photo;
#line 4711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp46_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_PHOTO, Photo));
#line 4711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp47_ = _tmp46_;
#line 4711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp48_ = _tmp47_ != NULL;
#line 4711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp47_);
#line 4711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp48_) {
#line 36981 "Photo.c"
					LibraryPhoto* _tmp49_;
					BackingPhotoRow* _tmp50_;
					BackingPhotoRow* _tmp51_;
					gint64 _tmp52_;
#line 4712 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp49_ = photo;
#line 4712 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp50_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, TYPE_PHOTO, Photo));
#line 4712 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp51_ = _tmp50_;
#line 4712 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp52_ = _tmp51_->filesize;
#line 4712 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp44_ = _tmp52_;
#line 4712 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp51_);
#line 36998 "Photo.c"
				} else {
#line 4713 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp44_ = (gint64) -1;
#line 37002 "Photo.c"
				}
#line 4711 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				editable_filesize = _tmp44_;
#line 4714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp53_ = self->priv->photo_to_master_filesize;
#line 4714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp54_ = photo;
#line 4714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp55_ = master_filesize;
#line 4714 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp54_, &_tmp55_);
#line 4715 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp56_ = self->priv->filesize_to_photo;
#line 4715 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp57_ = master_filesize;
#line 4715 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp58_ = photo;
#line 4715 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_multi_map_set (_tmp56_, &_tmp57_, _tmp58_);
#line 4716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp59_ = editable_filesize;
#line 4716 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp59_ >= ((gint64) 0)) {
#line 37026 "Photo.c"
					GeeHashMap* _tmp60_;
					LibraryPhoto* _tmp61_;
					gint64 _tmp62_;
					GeeMultiMap* _tmp63_;
					gint64 _tmp64_;
					LibraryPhoto* _tmp65_;
#line 4717 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp60_ = self->priv->photo_to_editable_filesize;
#line 4717 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp61_ = photo;
#line 4717 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp62_ = editable_filesize;
#line 4717 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp61_, &_tmp62_);
#line 4718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp63_ = self->priv->filesize_to_photo;
#line 4718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp64_ = editable_filesize;
#line 4718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp65_ = photo;
#line 4718 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_multi_map_set (_tmp63_, &_tmp64_, _tmp65_);
#line 37049 "Photo.c"
				}
#line 4697 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp20_);
#line 37053 "Photo.c"
			}
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (object);
#line 37061 "Photo.c"
		}
#line 4692 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 37065 "Photo.c"
	}
#line 4723 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), items);
#line 37069 "Photo.c"
}


static void
library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                 GeeCollection* media_sources)
{
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_;
#line 4727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (media_sources, GEE_TYPE_COLLECTION));
#line 4728 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4728 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	map = _tmp0_;
#line 37088 "Photo.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_it = _tmp1_;
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 37098 "Photo.c"
			GeeIterator* _tmp2_;
			MediaSource* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp5_;
			LibraryPhoto* _tmp6_;
			PhotoMetadata* metadata = NULL;
			LibraryPhoto* _tmp7_;
			PhotoMetadata* _tmp8_;
			HierarchicalTagIndex* global_index = NULL;
			HierarchicalTagIndex* _tmp9_;
			HierarchicalTagIndex* htag_index = NULL;
			gboolean _tmp10_ = FALSE;
			PhotoMetadata* _tmp11_;
			LibraryPhoto* _tmp17_;
			GeeCollection* _tmp18_;
			GeeCollection* _tmp19_;
			gboolean _tmp20_;
			gboolean _tmp51_ = FALSE;
			PhotoMetadata* _tmp52_;
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp2_ = _media_it;
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 37126 "Photo.c"
			}
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp3_ = _media_it;
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			media = (MediaSource*) _tmp4_;
#line 4730 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = media;
#line 4730 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4730 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo = _tmp6_;
#line 4731 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = photo;
#line 4731 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO_SOURCE, PhotoSource));
#line 4731 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			metadata = _tmp8_;
#line 4734 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = hierarchical_tag_index_get_global_index ();
#line 4734 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			global_index = _tmp9_;
#line 4741 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			htag_index = NULL;
#line 4742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = metadata;
#line 4742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp11_ != NULL) {
#line 37156 "Photo.c"
				PhotoMetadata* _tmp12_;
#line 4742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = metadata;
#line 4742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = photo_metadata_has_hierarchical_keywords (_tmp12_);
#line 37162 "Photo.c"
			} else {
#line 4742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = FALSE;
#line 37166 "Photo.c"
			}
#line 4742 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp10_) {
#line 37170 "Photo.c"
				PhotoMetadata* _tmp13_;
				GeeSet* _tmp14_;
				GeeSet* _tmp15_;
				HierarchicalTagIndex* _tmp16_;
#line 4743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = metadata;
#line 4743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = photo_metadata_get_hierarchical_keywords (_tmp13_);
#line 4743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = _tmp14_;
#line 4743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 4743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				htag_index = _tmp16_;
#line 4743 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp15_);
#line 37189 "Photo.c"
			}
#line 4747 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp17_ = photo;
#line 4747 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp18_ = library_photo_get_import_keywords (_tmp17_);
#line 4747 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 4747 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp20_ = _tmp19_ != NULL;
#line 4747 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 4747 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp20_) {
#line 37203 "Photo.c"
				{
					GeeIterator* _keyword_it = NULL;
					LibraryPhoto* _tmp21_;
					GeeCollection* _tmp22_;
					GeeCollection* _tmp23_;
					GeeIterator* _tmp24_;
					GeeIterator* _tmp25_;
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp21_ = photo;
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp22_ = library_photo_get_import_keywords (_tmp21_);
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp23_ = _tmp22_;
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp25_ = _tmp24_;
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp23_);
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_keyword_it = _tmp25_;
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					while (TRUE) {
#line 37227 "Photo.c"
						GeeIterator* _tmp26_;
						gchar* keyword = NULL;
						GeeIterator* _tmp27_;
						gpointer _tmp28_;
						gboolean _tmp29_ = FALSE;
						HierarchicalTagIndex* _tmp30_;
						gchar* name = NULL;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						HierarchicalTagIndex* _tmp35_;
						const gchar* _tmp36_;
						const gchar* _tmp45_;
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp26_ = _keyword_it;
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (!gee_iterator_next (_tmp26_)) {
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							break;
#line 37246 "Photo.c"
						}
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp27_ = _keyword_it;
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp28_ = gee_iterator_get (_tmp27_);
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						keyword = (gchar*) _tmp28_;
#line 4749 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp30_ = htag_index;
#line 4749 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp30_ != NULL) {
#line 37258 "Photo.c"
							HierarchicalTagIndex* _tmp31_;
							const gchar* _tmp32_;
#line 4749 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp31_ = htag_index;
#line 4749 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp32_ = keyword;
#line 4749 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp29_ = hierarchical_tag_index_is_tag_in_index (_tmp31_, _tmp32_);
#line 37267 "Photo.c"
						} else {
#line 4749 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp29_ = FALSE;
#line 37271 "Photo.c"
						}
#line 4749 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp29_) {
#line 4750 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_free0 (keyword);
#line 4750 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							continue;
#line 37279 "Photo.c"
						}
#line 4752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp33_ = keyword;
#line 4752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp34_ = tag_prep_tag_name (_tmp33_);
#line 4752 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						name = _tmp34_;
#line 4754 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp35_ = global_index;
#line 4754 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp36_ = name;
#line 4754 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (hierarchical_tag_index_is_tag_in_index (_tmp35_, _tmp36_)) {
#line 37293 "Photo.c"
							gchar* most_derived_path = NULL;
							HierarchicalTagIndex* _tmp37_;
							const gchar* _tmp38_;
							gchar* _tmp39_;
							GeeHashMultiMap* _tmp40_;
							const gchar* _tmp41_;
							Tag* _tmp42_;
							Tag* _tmp43_;
							LibraryPhoto* _tmp44_;
#line 4755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp37_ = global_index;
#line 4755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp38_ = name;
#line 4755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp39_ = hierarchical_tag_index_get_path_for_name (_tmp37_, _tmp38_);
#line 4755 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							most_derived_path = _tmp39_;
#line 4756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp40_ = map;
#line 4756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp41_ = most_derived_path;
#line 4756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp42_ = tag_for_path (_tmp41_);
#line 4756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp43_ = _tmp42_;
#line 4756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp44_ = photo;
#line 4756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp43_, _tmp44_);
#line 4756 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (_tmp43_);
#line 4757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_free0 (name);
#line 4757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_free0 (keyword);
#line 4757 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							continue;
#line 37333 "Photo.c"
						}
#line 4760 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp45_ = name;
#line 4760 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp45_ != NULL) {
#line 37339 "Photo.c"
							GeeHashMultiMap* _tmp46_;
							const gchar* _tmp47_;
							Tag* _tmp48_;
							Tag* _tmp49_;
							LibraryPhoto* _tmp50_;
#line 4761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp46_ = map;
#line 4761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp47_ = name;
#line 4761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp48_ = tag_for_path (_tmp47_);
#line 4761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp49_ = _tmp48_;
#line 4761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp50_ = photo;
#line 4761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp49_, _tmp50_);
#line 4761 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (_tmp49_);
#line 37359 "Photo.c"
						}
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_free0 (name);
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_free0 (keyword);
#line 37365 "Photo.c"
					}
#line 4748 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 37369 "Photo.c"
				}
			}
#line 4765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp52_ = metadata;
#line 4765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp52_ != NULL) {
#line 37376 "Photo.c"
				PhotoMetadata* _tmp53_;
#line 4765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp53_ = metadata;
#line 4765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp51_ = photo_metadata_has_hierarchical_keywords (_tmp53_);
#line 37382 "Photo.c"
			} else {
#line 4765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp51_ = FALSE;
#line 37386 "Photo.c"
			}
#line 4765 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp51_) {
#line 37390 "Photo.c"
				{
					GeeIterator* _path_it = NULL;
					HierarchicalTagIndex* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp54_ = htag_index;
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp55_ = hierarchical_tag_index_get_all_paths (_tmp54_);
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp57_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_path_it = _tmp58_;
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					while (TRUE) {
#line 37414 "Photo.c"
						GeeIterator* _tmp59_;
						gchar* path = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						gchar* name = NULL;
						const gchar* _tmp62_;
						gchar* _tmp63_;
						const gchar* _tmp64_;
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp59_ = _path_it;
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							break;
#line 37429 "Photo.c"
						}
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp60_ = _path_it;
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						path = (gchar*) _tmp61_;
#line 4767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp62_ = path;
#line 4767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp63_ = tag_prep_tag_name (_tmp62_);
#line 4767 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						name = _tmp63_;
#line 4768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp64_ = name;
#line 4768 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (_tmp64_ != NULL) {
#line 37447 "Photo.c"
							GeeHashMultiMap* _tmp65_;
							const gchar* _tmp66_;
							Tag* _tmp67_;
							Tag* _tmp68_;
							LibraryPhoto* _tmp69_;
#line 4769 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp65_ = map;
#line 4769 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp66_ = name;
#line 4769 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp67_ = tag_for_path (_tmp66_);
#line 4769 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp68_ = _tmp67_;
#line 4769 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp69_ = photo;
#line 4769 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp68_, _tmp69_);
#line 4769 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (_tmp68_);
#line 37467 "Photo.c"
						}
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_free0 (name);
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_free0 (path);
#line 37473 "Photo.c"
					}
#line 4766 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 37477 "Photo.c"
				}
			}
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 37490 "Photo.c"
		}
#line 4729 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 37494 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp70_;
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp70_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_it = _tmp70_;
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 37505 "Photo.c"
			GeeIterator* _tmp71_;
			MediaSource* media = NULL;
			GeeIterator* _tmp72_;
			gpointer _tmp73_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp74_;
			LibraryPhoto* _tmp75_;
			LibraryPhoto* _tmp76_;
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp71_ = _media_it;
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp71_)) {
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 37520 "Photo.c"
			}
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp72_ = _media_it;
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp73_ = gee_iterator_get (_tmp72_);
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			media = (MediaSource*) _tmp73_;
#line 4775 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp74_ = media;
#line 4775 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp75_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4775 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo = _tmp75_;
#line 4776 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp76_ = photo;
#line 4776 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			library_photo_clear_import_keywords (_tmp76_);
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 37542 "Photo.c"
		}
#line 4774 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 37546 "Photo.c"
	}
	{
		GeeIterator* _tag_it = NULL;
		GeeHashMultiMap* _tmp77_;
		GeeSet* _tmp78_;
		GeeSet* _tmp79_;
		GeeIterator* _tmp80_;
		GeeIterator* _tmp81_;
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp77_ = map;
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp78_ = gee_multi_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp79_ = _tmp78_;
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp80_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp81_ = _tmp80_;
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp79_);
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tag_it = _tmp81_;
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 37571 "Photo.c"
			GeeIterator* _tmp82_;
			Tag* tag = NULL;
			GeeIterator* _tmp83_;
			gpointer _tmp84_;
			Tag* _tmp85_;
			GeeHashMultiMap* _tmp86_;
			Tag* _tmp87_;
			GeeCollection* _tmp88_;
			GeeCollection* _tmp89_;
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp82_ = _tag_it;
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp82_)) {
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 37587 "Photo.c"
			}
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp83_ = _tag_it;
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp84_ = gee_iterator_get (_tmp83_);
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			tag = (Tag*) _tmp84_;
#line 4780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp85_ = tag;
#line 4780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp86_ = map;
#line 4780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp87_ = tag;
#line 4780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp88_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp86_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp87_);
#line 4780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp89_ = _tmp88_;
#line 4780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			tag_attach_many (_tmp85_, _tmp89_);
#line 4780 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp89_);
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (tag);
#line 37611 "Photo.c"
		}
#line 4779 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 37615 "Photo.c"
	}
#line 4782 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), media_sources);
#line 4727 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (map);
#line 37621 "Photo.c"
}


static void
library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4787 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 37636 "Photo.c"
}


void
library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4786 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_master_reimported (self, photo, metadata);
#line 37649 "Photo.c"
}


static void
library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4791 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4791 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4792 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 37664 "Photo.c"
}


void
library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
#line 4791 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4791 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_editable_reimported (self, photo, metadata);
#line 37677 "Photo.c"
}


static void
library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4796 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4796 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4797 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 37692 "Photo.c"
}


void
library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4796 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4796 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_source_reimported (self, photo, metadata);
#line 37705 "Photo.c"
}


static void
library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 4802 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 37720 "Photo.c"
}


void
library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
#line 4801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4801 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_baseline_reimported (self, photo, metadata);
#line 37733 "Photo.c"
}


static MediaSource*
library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                          gint64 numeric_id)
{
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	PhotoID _tmp0_ = {0};
	LibraryPhoto* _tmp1_;
#line 4805 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4806 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_id_init (&_tmp0_, numeric_id);
#line 4806 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = library_photo_source_collection_fetch (self, &_tmp0_);
#line 4806 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_MEDIA_SOURCE, MediaSource);
#line 4806 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 37755 "Photo.c"
}


static void
library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                              GeeCollection* added,
                                                              GeeCollection* removed)
{
#line 4809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
#line 4809 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
#line 4811 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 37772 "Photo.c"
}


static gboolean
library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result = FALSE;
#line 4815 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4815 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4815 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4816 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 4816 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 37792 "Photo.c"
}


static void
library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                             GeeCollection* added,
                                                             GeeCollection* removed)
{
#line 4819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
#line 4819 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
#line 4821 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 37809 "Photo.c"
}


static gboolean
library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result = FALSE;
#line 4825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4825 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 4826 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = media_source_is_offline (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 4826 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 37829 "Photo.c"
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = maxlen;
#line 1394 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 37853 "Photo.c"
	} else {
		gchar* _tmp2_;
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 37862 "Photo.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1403 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 37883 "Photo.c"
	} else {
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 37887 "Photo.c"
	}
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 37893 "Photo.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 37903 "Photo.c"
	}
#line 1412 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 37907 "Photo.c"
		glong _tmp3_;
#line 1413 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1413 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1414 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 37915 "Photo.c"
	} else {
		glong _tmp4_;
#line 1416 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1416 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 37922 "Photo.c"
	}
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 37926 "Photo.c"
		glong _tmp5_;
#line 1419 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1419 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 37932 "Photo.c"
	}
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp7_;
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 37944 "Photo.c"
}


static MediaSource*
library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                         const gchar* source_id)
{
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	gchar* numeric_only = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	MediaSource* _tmp3_;
#line 4829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4829 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4830 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (g_str_has_prefix (source_id, PHOTO_TYPENAME), "source_id.has_prefix(Photo.TYPENAME)");
#line 4831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = strlen (PHOTO_TYPENAME);
#line 4831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = string_substring (source_id, (glong) _tmp1_, (glong) -1);
#line 4831 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	numeric_only = _tmp2_;
#line 4833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = media_source_collection_fetch_by_numeric_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), parse_int64 (numeric_only, 16));
#line 4833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 4833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (numeric_only);
#line 4833 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 37981 "Photo.c"
}


static GeeCollection*
library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                           EventID* event_id)
{
	LibraryPhotoSourceCollection * self;
	GeeCollection* result = NULL;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_;
	GeeCollection* _tmp4_;
#line 4836 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4836 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = *event_id;
#line 4837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 4837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp4_;
#line 4837 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38016 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                       PhotoID* photo_id)
{
	LibraryPhoto* result = NULL;
	PhotoID _tmp0_;
	gint64 _tmp1_;
	DataSource* _tmp2_;
#line 4840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4840 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 4841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = database_source_collection_fetch_by_key (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), _tmp1_);
#line 4841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4841 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38042 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                        GFile* file)
{
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 4844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4844 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4845 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4845 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 4845 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4845 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38065 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                               GFile* file)
{
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 4848 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4848 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4849 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4849 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 4849 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4849 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38088 "Photo.c"
}


static void
library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                 LibraryPhoto* photo,
                                                 GFileInfo* info,
                                                 GeeCollection* matches_master,
                                                 GeeCollection* matches_editable,
                                                 GeeCollection* matches_development)
{
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	gboolean _tmp2_;
	BackingPhotoRow* editable = NULL;
	BackingPhotoRow* _tmp3_;
	gboolean _tmp4_ = FALSE;
	BackingPhotoRow* _tmp5_;
	GeeCollection* development = NULL;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
#line 4852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 4852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_master, GEE_TYPE_COLLECTION));
#line 4852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_editable, GEE_TYPE_COLLECTION));
#line 4852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_development, GEE_TYPE_COLLECTION));
#line 4855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_get_master_photo_row (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = backing_photo_row_matches_file_info (_tmp1_, info);
#line 4855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp1_);
#line 4855 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_) {
#line 4856 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gee_collection_add (matches_master, photo);
#line 38134 "Photo.c"
	}
#line 4858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4858 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	editable = _tmp3_;
#line 4859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = editable;
#line 4859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 38144 "Photo.c"
		BackingPhotoRow* _tmp6_;
#line 4859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = editable;
#line 4859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = backing_photo_row_matches_file_info (_tmp6_, info);
#line 38150 "Photo.c"
	} else {
#line 4859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = FALSE;
#line 38154 "Photo.c"
	}
#line 4859 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp4_) {
#line 4860 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gee_collection_add (matches_editable, photo);
#line 38160 "Photo.c"
	}
#line 4862 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = photo_get_raw_development_photo_rows (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo));
#line 4862 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	development = _tmp7_;
#line 4863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = development;
#line 4863 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 38170 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_;
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = development;
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_row_it = _tmp10_;
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 38183 "Photo.c"
				GeeIterator* _tmp11_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				BackingPhotoRow* _tmp14_;
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _row_it;
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 38195 "Photo.c"
				}
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = _row_it;
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp13_;
#line 4865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = row;
#line 4865 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (backing_photo_row_matches_file_info (_tmp14_, info)) {
#line 4866 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_collection_add (matches_development, photo);
#line 4868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4868 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 38213 "Photo.c"
				}
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 38217 "Photo.c"
			}
#line 4864 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 38221 "Photo.c"
		}
	}
#line 4852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (development);
#line 4852 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 38228 "Photo.c"
}


void
library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                           GFileInfo* info,
                                                           GeeCollection* matches_master,
                                                           GeeCollection* matches_editable,
                                                           GeeCollection* matched_development)
{
#line 4876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 4876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_master, GEE_TYPE_COLLECTION));
#line 4876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matches_editable, GEE_TYPE_COLLECTION));
#line 4876 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matched_development, GEE_TYPE_COLLECTION));
#line 38249 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		gint64 _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = g_file_info_get_size (info);
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_it = _tmp5_;
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 38276 "Photo.c"
			GeeIterator* _tmp6_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			LibraryPhoto* _tmp9_;
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 38288 "Photo.c"
			}
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp8_;
#line 4879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = photo;
#line 4879 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp9_, info, matches_master, matches_editable, matched_development);
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 38302 "Photo.c"
		}
#line 4878 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 38306 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp10_;
		GeeCollection* _tmp11_;
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = media_source_collection_get_offline_bin_contents (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp11_);
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_it = _tmp13_;
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 38328 "Photo.c"
			GeeIterator* _tmp14_;
			MediaSource* media = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			MediaSource* _tmp17_;
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = _media_it;
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 38340 "Photo.c"
			}
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = _media_it;
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			media = (MediaSource*) _tmp16_;
#line 4882 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp17_ = media;
#line 4882 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_LIBRARY_PHOTO, LibraryPhoto), info, matches_master, matches_editable, matched_development);
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 38354 "Photo.c"
		}
#line 4881 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 38358 "Photo.c"
	}
}


void
library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize,
                                                                 PhotoID* result)
{
	PhotoID _tmp15_ = {0};
#line 4885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 4885 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (basename != NULL);
#line 38374 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = gee_multi_map_get (_tmp0_, &filesize);
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_photo_it = _tmp4_;
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		while (TRUE) {
#line 38398 "Photo.c"
			GeeIterator* _tmp5_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			LibraryPhoto* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_;
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = _photo_it;
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				break;
#line 38414 "Photo.c"
			}
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp7_;
#line 4887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = photo;
#line 4887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_MEDIA_SOURCE, MediaSource));
#line 4887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 4887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = g_file_get_basename (_tmp10_);
#line 4887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = utf8_ci_compare (_tmp11_, basename) == 0;
#line 4887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp10_);
#line 4887 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_tmp12_) {
#line 38436 "Photo.c"
				LibraryPhoto* _tmp13_;
				PhotoID _tmp14_ = {0};
#line 4888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = photo;
#line 4888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO, Photo), &_tmp14_);
#line 4888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				*result = _tmp14_;
#line 4888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4888 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 38451 "Photo.c"
			}
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 38455 "Photo.c"
		}
#line 4886 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 38459 "Photo.c"
	}
#line 4891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_id_init (&_tmp15_, PHOTO_ID_INVALID);
#line 4891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	*result = _tmp15_;
#line 4891 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 38467 "Photo.c"
}


gboolean
library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize)
{
	gboolean result = FALSE;
	PhotoID _tmp0_ = {0};
#line 4895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 4895 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 4896 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_get_basename_filesize_duplicate (self, basename, filesize, &_tmp0_);
#line 4896 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 4896 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38488 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
#line 4899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4899 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4900 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = _tmp3_;
#line 4901 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = photo;
#line 4901 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 38523 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4902 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 38539 "Photo.c"
	}
#line 4905 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo;
#line 4905 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38545 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
#line 4908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4908 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 4909 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38576 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
#line 4912 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4912 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4913 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = _tmp3_;
#line 4914 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = photo;
#line 4914 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 38611 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4915 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 38627 "Photo.c"
	}
#line 4918 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo;
#line 4918 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38633 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
#line 4921 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4921 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4922 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4922 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4922 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4922 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4922 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4922 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp3_;
#line 4922 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38664 "Photo.c"
}


gint
library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self)
{
	gint result = 0;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_;
#line 4925 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), 0);
#line 4926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank));
#line 4926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp2_;
#line 4926 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38689 "Photo.c"
}


LibraryPhoto*
library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                   GFile* file,
                                                   LibraryPhotoSourceCollectionState* state)
{
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSource* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* _tmp5_;
	LibraryPhoto* _tmp6_;
	LibraryPhoto* _tmp7_;
	LibraryPhoto* _tmp8_;
	LibraryPhoto* _tmp9_;
	LibraryPhoto* _tmp10_;
	LibraryPhoto* _tmp11_;
#line 4929 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 4929 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 4930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_collection_fetch_by_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), file);
#line 4930 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4931 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo;
#line 4931 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 4932 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4934 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = photo;
#line 4934 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 4934 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 38733 "Photo.c"
		}
#line 4934 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 38737 "Photo.c"
	}
#line 4937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch_by_editable_file (self, file);
#line 4937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4937 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = _tmp2_;
#line 4938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo;
#line 4938 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 4939 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = photo;
#line 4941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 4941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 38757 "Photo.c"
		}
#line 4941 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 38761 "Photo.c"
	}
#line 4944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_raw_development_file (self, file);
#line 4944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4944 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = _tmp4_;
#line 4945 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = photo;
#line 4945 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4946 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4948 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = photo;
#line 4948 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 4948 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 38781 "Photo.c"
		}
#line 4948 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 38785 "Photo.c"
	}
#line 4951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = library_photo_source_collection_get_trashed_by_file (self, file);
#line 4951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = IS_LIBRARY_PHOTO (_tmp6_) ? ((LibraryPhoto*) _tmp6_) : NULL;
#line 4951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 4951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 38795 "Photo.c"
	}
#line 4951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4951 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = _tmp7_;
#line 4952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = photo;
#line 4952 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 4953 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 4955 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = photo;
#line 4955 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 4955 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 38813 "Photo.c"
		}
#line 4955 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 38817 "Photo.c"
	}
#line 4958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = library_photo_source_collection_get_offline_by_file (self, file);
#line 4958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = IS_LIBRARY_PHOTO (_tmp9_) ? ((LibraryPhoto*) _tmp9_) : NULL;
#line 4958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 4958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 38827 "Photo.c"
	}
#line 4958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4958 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = _tmp10_;
#line 4959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = photo;
#line 4959 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 4960 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 4962 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = photo;
#line 4962 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (state) {
#line 4962 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*state = _vala_state;
#line 38845 "Photo.c"
		}
#line 4962 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 38849 "Photo.c"
	}
#line 4965 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 4967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = NULL;
#line 4967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (state) {
#line 4967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*state = _vala_state;
#line 38861 "Photo.c"
	}
#line 4967 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38865 "Photo.c"
}


static gboolean
library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                   SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gboolean _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
	MediaSourceHoldingTank* _tmp4_;
	gboolean _tmp5_;
#line 4970 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4970 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 4971 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), backlink)) {
#line 4972 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = TRUE;
#line 4972 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 38891 "Photo.c"
	}
#line 4974 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4974 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4974 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = source_holding_tank_has_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4974 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4974 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_) {
#line 4975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = TRUE;
#line 4975 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 38907 "Photo.c"
	}
#line 4977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 4977 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp5_) {
#line 4978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = TRUE;
#line 4978 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 38923 "Photo.c"
	}
#line 4980 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = FALSE;
#line 4980 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38929 "Photo.c"
}


static void
library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                      SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4983 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 4984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	source_holding_tank_remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4984 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	source_holding_tank_remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), backlink);
#line 4985 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4987 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_SOURCE_COLLECTION, SourceCollection), backlink);
#line 38964 "Photo.c"
}


static TransactionController*
library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base)
{
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 4504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 38981 "Photo.c"
		MediaSourceTransactionController* _tmp1_;
#line 4506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 4506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		self->priv->_transaction_controller = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_TRANSACTION_CONTROLLER, TransactionController);
#line 38989 "Photo.c"
	}
#line 4508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp2_;
#line 4508 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 38997 "Photo.c"
}


static void
library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4526 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4526 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 39010 "Photo.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data1 = closure->data;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 39036 "Photo.c"
	} else {
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data2 = closure->data;
#line 39042 "Photo.c"
	}
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 39048 "Photo.c"
}


static void
library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4529 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 39061 "Photo.c"
}


static void
library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4532 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4532 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 39074 "Photo.c"
}


static void
library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4535 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 4535 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 39087 "Photo.c"
}


static void
library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass)
{
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataCollectionClass *) klass)->finalize = library_photo_source_collection_finalize;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceCollectionPrivate));
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_trashcan;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_offline_bin;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*) (MediaSourceCollection*, Workers*, GCancellable*)) library_photo_source_collection_real_create_media_monitor;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*) (SourceCollection*, DataSource*)) library_photo_source_collection_real_holds_type_of_source;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*) (MediaSourceCollection*)) library_photo_source_collection_real_get_typename;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*) (MediaSourceCollection*, GFile*)) library_photo_source_collection_real_is_file_recognized;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*) (DataCollection*, GeeIterable*, GeeIterable*)) library_photo_source_collection_real_notify_contents_altered;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection*, GeeMap*)) library_photo_source_collection_real_items_altered;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->postprocess_imported_media = (void (*) (MediaSourceCollection*, GeeCollection*)) library_photo_source_collection_real_postprocess_imported_media;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_master_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_master_reimported;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_editable_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_editable_reimported;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_source_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_source_reimported;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_baseline_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_baseline_reimported;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*) (MediaSourceCollection*, gint64)) library_photo_source_collection_real_fetch_by_numeric_id;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_source_id = (MediaSource* (*) (MediaSourceCollection*, const gchar*)) library_photo_source_collection_real_fetch_by_source_id;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*) (MediaSourceCollection*, EventID*)) library_photo_source_collection_real_get_event_source_ids;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((SourceCollectionClass *) klass)->has_backlink = (gboolean (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_has_backlink;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((SourceCollectionClass *) klass)->remove_backlink = (void (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_remove_backlink;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 39154 "Photo.c"
}


static void
library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeTreeMultiMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeTreeMultiMap* _tmp5_;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE (self);
#line 4512 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _int64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->filesize_to_photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 4519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp3_;
#line 4521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp4_;
#line 4523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 39195 "Photo.c"
}


static void
library_photo_source_collection_finalize (DataCollection * obj)
{
	LibraryPhotoSourceCollection * self;
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4512 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4513 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4523 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 39221 "Photo.c"
}


GType
library_photo_source_collection_get_type (void)
{
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}


static void
_library_photo_generate_thumbnails_one_shot_callback (gpointer self)
{
#line 5015 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_generate_thumbnails ((LibraryPhoto*) self);
#line 39244 "Photo.c"
}


static void
_library_photo_import_gps_metadata_one_shot_callback (gpointer self)
{
#line 5018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_import_gps_metadata ((LibraryPhoto*) self);
#line 39253 "Photo.c"
}


static LibraryPhoto*
library_photo_construct (GType object_type,
                         PhotoRow* row)
{
	LibraryPhoto * self = NULL;
	OneShotScheduler* _tmp0_;
	GpsCoords _tmp1_;
	gint _tmp2_;
	guint64 _tmp5_;
	guint64 _tmp8_;
#line 5010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), NULL);
#line 5011 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, row);
#line 5013 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5013 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 5015 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 5015 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5015 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp0_;
#line 5017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = row->gps_coords;
#line 5017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp1_.has_gps;
#line 5017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_ == -1) {
#line 39287 "Photo.c"
		OneShotScheduler* gps_import_scheduler = NULL;
		OneShotScheduler* _tmp3_;
		OneShotScheduler* _tmp4_;
#line 5018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_import_gps_metadata_one_shot_callback, self);
#line 5018 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gps_import_scheduler = _tmp3_;
#line 5019 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = gps_import_scheduler;
#line 5019 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp4_, G_PRIORITY_LOW);
#line 5017 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_one_shot_scheduler_unref0 (gps_import_scheduler);
#line 39301 "Photo.c"
	}
#line 5023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = row->flags;
#line 5023 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((_tmp5_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 39307 "Photo.c"
		LibraryPhotoSourceCollection* _tmp6_;
		const gchar* _tmp7_;
#line 5024 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = library_photo_global;
#line 5024 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = row->backlinks;
#line 5024 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp7_);
#line 39316 "Photo.c"
	}
#line 5026 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = row->flags;
#line 5026 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((_tmp8_ & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 39322 "Photo.c"
		guint64 _tmp9_;
#line 5027 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = row->flags;
#line 5027 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp9_);
#line 39328 "Photo.c"
	}
#line 5010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 39332 "Photo.c"
}


static LibraryPhoto*
library_photo_new (PhotoRow* row)
{
#line 5010 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 39341 "Photo.c"
}


static LibraryPhoto*
library_photo_construct_from_import_params (GType object_type,
                                            PhotoImportParams* import_params)
{
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	OneShotScheduler* _tmp3_;
	PhotoRow* _tmp4_;
	guint64 _tmp5_;
	PhotoRow* _tmp9_;
	guint64 _tmp10_;
#line 5030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (import_params), NULL);
#line 5031 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = import_params->row;
#line 5031 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 5033 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = import_params->keywords;
#line 5033 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 5033 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5033 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->import_keywords = _tmp2_;
#line 5034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 5034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5034 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp3_;
#line 5037 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = import_params->row;
#line 5037 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = _tmp4_->flags;
#line 5037 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((_tmp5_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 39384 "Photo.c"
		LibraryPhotoSourceCollection* _tmp6_;
		PhotoRow* _tmp7_;
		const gchar* _tmp8_;
#line 5038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = library_photo_global;
#line 5038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = import_params->row;
#line 5038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp8_ = _tmp7_->backlinks;
#line 5038 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp8_);
#line 39396 "Photo.c"
	}
#line 5040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = import_params->row;
#line 5040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = _tmp9_->flags;
#line 5040 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((_tmp10_ & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 39404 "Photo.c"
		PhotoRow* _tmp11_;
		guint64 _tmp12_;
#line 5041 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp11_ = import_params->row;
#line 5041 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp12_ = _tmp11_->flags;
#line 5041 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp12_);
#line 39413 "Photo.c"
	}
#line 5030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 39417 "Photo.c"
}


static LibraryPhoto*
library_photo_new_from_import_params (PhotoImportParams* import_params)
{
#line 5030 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 39426 "Photo.c"
}


void
library_photo_init (ProgressMonitor monitor,
                    gpointer monitor_target)
{
	LibraryPhotoSourceCollection* _tmp0_;
	GeeArrayList* all = NULL;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* all_photos = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* trashed_photos = NULL;
	GeeArrayList* _tmp6_;
	GeeArrayList* offline_photos = NULL;
	GeeArrayList* _tmp7_;
	gint count = 0;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	LibraryPhotoSourceCollection* _tmp32_;
	GeeArrayList* _tmp33_;
	GeeCollection* _tmp34_;
	GeeCollection* _tmp35_;
	LibraryPhotoSourceCollection* _tmp36_;
	GeeArrayList* _tmp37_;
	LibraryPhotoSourceCollection* _tmp38_;
	GeeArrayList* _tmp39_;
#line 5045 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_init_photo ();
#line 5047 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 5047 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 5047 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_global = _tmp0_;
#line 5051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 5051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 5051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 5051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 5051 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	all = _tmp4_;
#line 5052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5052 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	all_photos = _tmp5_;
#line 5053 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5053 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	trashed_photos = _tmp6_;
#line 5054 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5054 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	offline_photos = _tmp7_;
#line 5055 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = all;
#line 5055 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 5055 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 5055 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	count = _tmp10_;
#line 39498 "Photo.c"
	{
		gint ctr = 0;
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		ctr = 0;
#line 39503 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = TRUE;
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 39510 "Photo.c"
				gint _tmp13_;
				gint _tmp14_;
				PhotoRow* row = NULL;
				GeeArrayList* _tmp15_;
				gint _tmp16_;
				gpointer _tmp17_;
				LibraryPhoto* photo = NULL;
				PhotoRow* _tmp18_;
				LibraryPhoto* _tmp19_;
				guint64 flags = 0ULL;
				PhotoRow* _tmp20_;
				guint64 _tmp21_;
				guint64 _tmp22_;
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!_tmp11_) {
#line 39526 "Photo.c"
					gint _tmp12_;
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = ctr;
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					ctr = _tmp12_ + 1;
#line 39532 "Photo.c"
				}
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = FALSE;
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = ctr;
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = count;
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 39544 "Photo.c"
				}
#line 5057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = all;
#line 5057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = ctr;
#line 5057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp16_);
#line 5057 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				row = (PhotoRow*) _tmp17_;
#line 5058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = row;
#line 5058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp19_ = library_photo_new (_tmp18_);
#line 5058 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo = _tmp19_;
#line 5059 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp20_ = row;
#line 5059 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = _tmp20_->flags;
#line 5059 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				flags = _tmp21_;
#line 5061 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = flags;
#line 5061 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if ((_tmp22_ & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 39570 "Photo.c"
					GeeArrayList* _tmp23_;
					LibraryPhoto* _tmp24_;
#line 5062 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp23_ = trashed_photos;
#line 5062 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp24_ = photo;
#line 5062 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp24_);
#line 39579 "Photo.c"
				} else {
					guint64 _tmp25_;
#line 5063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp25_ = flags;
#line 5063 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					if ((_tmp25_ & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 39586 "Photo.c"
						GeeArrayList* _tmp26_;
						LibraryPhoto* _tmp27_;
#line 5064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp26_ = offline_photos;
#line 5064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp27_ = photo;
#line 5064 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp27_);
#line 39595 "Photo.c"
					} else {
						GeeArrayList* _tmp28_;
						LibraryPhoto* _tmp29_;
#line 5066 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp28_ = all_photos;
#line 5066 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp29_ = photo;
#line 5066 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp29_);
#line 39605 "Photo.c"
					}
				}
#line 5068 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (monitor != NULL) {
#line 39610 "Photo.c"
					gint _tmp30_;
					gint _tmp31_;
#line 5069 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp30_ = ctr;
#line 5069 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp31_ = count;
#line 5069 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					monitor ((guint64) _tmp30_, (guint64) _tmp31_, TRUE, monitor_target);
#line 39619 "Photo.c"
				}
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5056 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_photo_row_unref0 (row);
#line 39625 "Photo.c"
			}
		}
	}
#line 5072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp32_ = library_photo_global;
#line 5072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = all_photos;
#line 5072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp34_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 5072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp35_ = _tmp34_;
#line 5072 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp35_);
#line 5073 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp36_ = library_photo_global;
#line 5073 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp37_ = trashed_photos;
#line 5073 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	media_source_collection_add_many_to_trash (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp38_ = library_photo_global;
#line 5074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp39_ = offline_photos;
#line 5074 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	media_source_collection_add_many_to_offline (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 5044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 5044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 5044 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (all);
#line 39659 "Photo.c"
}


void
library_photo_terminate (void)
{
#line 5078 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_terminate_photo ();
#line 39668 "Photo.c"
}


ImportResult
library_photo_import_create (PhotoImportParams* params,
                             LibraryPhoto* * photo)
{
	LibraryPhoto* _vala_photo = NULL;
	ImportResult result = 0;
	PhotoID photo_id = {0};
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoID _tmp3_ = {0};
	PhotoID _tmp4_;
	LibraryPhoto* _tmp5_;
#line 5085 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 5087 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 5087 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5087 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = params->row;
#line 5087 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_table_add (_tmp1_, _tmp2_, &_tmp3_);
#line 5087 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5087 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 5087 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_id = _tmp4_;
#line 5088 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_id_is_invalid (&photo_id)) {
#line 5089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 5089 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_vala_photo = NULL;
#line 5091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 5091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (photo) {
#line 5091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			*photo = _vala_photo;
#line 39713 "Photo.c"
		} else {
#line 5091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 39717 "Photo.c"
		}
#line 5091 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 39721 "Photo.c"
	}
#line 5095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = library_photo_new_from_import_params (params);
#line 5095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 5095 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_photo = _tmp5_;
#line 5097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 5097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo) {
#line 5097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*photo = _vala_photo;
#line 39735 "Photo.c"
	} else {
#line 5097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 39739 "Photo.c"
	}
#line 5097 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 39743 "Photo.c"
}


void
library_photo_import_failed (LibraryPhoto* photo)
{
	GError* _inner_error0_ = NULL;
#line 5100 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 39753 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 5102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 5102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_PHOTO, Photo), &_tmp2_);
#line 5102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp2_, &_inner_error0_);
#line 5102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 5102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 39772 "Photo.c"
				goto __catch433_database_error;
			}
#line 5102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5102 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 39781 "Photo.c"
		}
	}
	goto __finally433;
	__catch433_database_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
#line 5101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 5101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 5104 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = err;
#line 5104 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		app_window_database_error (_tmp3_);
#line 5101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 39799 "Photo.c"
	}
	__finally433:
#line 5101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5101 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 39810 "Photo.c"
	}
}


static void
library_photo_real_notify_master_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5108 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5108 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5109 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5111 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp0_, self, metadata);
#line 39831 "Photo.c"
}


static void
library_photo_real_notify_editable_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5114 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5114 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5115 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5117 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp0_, self, metadata);
#line 39851 "Photo.c"
}


static void
library_photo_real_notify_source_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5120 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5120 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5121 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5123 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5123 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp0_, self, metadata);
#line 39871 "Photo.c"
}


static void
library_photo_real_notify_baseline_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5126 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 5127 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5129 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5129 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp0_, self, metadata);
#line 39891 "Photo.c"
}


static void
library_photo_generate_thumbnails (LibraryPhoto* self)
{
	GError* _inner_error0_ = NULL;
#line 5132 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 39901 "Photo.c"
	{
#line 5134 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		thumbnail_cache_import_from_source (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), TRUE, &_inner_error0_);
#line 5134 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39907 "Photo.c"
			goto __catch434_g_error;
		}
	}
	goto __finally434;
	__catch434_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 5133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 5136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 5136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = err;
#line 5136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:5136: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5136 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 39937 "Photo.c"
	}
	__finally434:
#line 5133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5133 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 39948 "Photo.c"
	}
#line 5140 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 39952 "Photo.c"
}


static void
library_photo_import_gps_metadata (LibraryPhoto* self)
{
	GpsCoords gps_coords = {0};
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	GpsCoords _tmp2_ = {0};
	GpsCoords _tmp3_;
	GpsCoords _tmp4_;
#line 5143 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5144 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 5144 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5144 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_metadata_get_gps_coords (_tmp1_, &_tmp2_);
#line 5144 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5144 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (_tmp1_);
#line 5144 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	gps_coords = _tmp3_;
#line 5145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = gps_coords;
#line 5145 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	positionable_set_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp4_);
#line 39983 "Photo.c"
}


GeeCollection*
library_photo_get_import_keywords (LibraryPhoto* self)
{
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 5149 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 5150 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 5150 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 5150 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp1_;
#line 5150 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 40003 "Photo.c"
}


void
library_photo_clear_import_keywords (LibraryPhoto* self)
{
#line 5153 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5154 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5154 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 40016 "Photo.c"
}


static void
library_photo_real_notify_altered (DataObject* base,
                                   Alteration* alteration)
{
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 5157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5157 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 5159 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = self->priv->block_thumbnail_generation;
#line 5159 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp1_) {
#line 5159 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = alteration_has_subject (alteration, "image");
#line 40037 "Photo.c"
	} else {
#line 5159 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 40041 "Photo.c"
	}
#line 5159 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp0_) {
#line 40045 "Photo.c"
		OneShotScheduler* _tmp2_;
#line 5160 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = self->priv->thumbnail_scheduler;
#line 5160 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp2_, G_PRIORITY_LOW);
#line 40051 "Photo.c"
	}
#line 5162 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_OBJECT, DataObject), alteration);
#line 40055 "Photo.c"
}


static GdkPixbuf*
library_photo_real_get_preview_pixbuf (MediaSource* base,
                                       Scaling* scaling,
                                       GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 5165 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5165 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 5166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error0_);
#line 5166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	pixbuf = _tmp0_;
#line 5166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5166 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 40084 "Photo.c"
	}
#line 5168 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 5168 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp1_;
#line 5168 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 5168 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 40094 "Photo.c"
}


static void
library_photo_real_rotate (Photo* base,
                           Rotation rotation)
{
	LibraryPhoto * self;
	GError* _inner_error0_ = NULL;
#line 5171 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5173 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 5174 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), rotation);
#line 5175 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 40112 "Photo.c"
	{
#line 5183 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		thumbnail_cache_rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), rotation, &_inner_error0_);
#line 5183 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40118 "Photo.c"
			goto __catch435_g_error;
		}
	}
	goto __finally435;
	__catch435_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5182 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 5182 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 5186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
#line 5186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = err;
#line 5186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_warning ("Photo.vala:5186: Unable to update thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5186 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5182 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 40148 "Photo.c"
	}
	__finally435:
#line 5182 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5182 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5182 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5182 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 40159 "Photo.c"
	}
#line 5189 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 40163 "Photo.c"
}


static GdkPixbuf*
library_photo_real_get_thumbnail (ThumbnailSource* base,
                                  gint scale,
                                  GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 5193 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5194 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = thumbnail_cache_fetch (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), scale, &_inner_error0_);
#line 5194 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 5194 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5194 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5194 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 40190 "Photo.c"
	}
#line 5194 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 5194 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = NULL;
#line 5194 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = _tmp2_;
#line 5194 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 5194 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 40202 "Photo.c"
}


static void
_library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                              gint64 total_num_bytes,
                                                              gpointer self)
{
#line 5206 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_on_duplicate_progress ((LibraryPhoto*) self, current_num_bytes, total_num_bytes);
#line 40213 "Photo.c"
}


static void
library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                       BackingPhotoRow* backing,
                                       BackingPhotoID* result,
                                       GError** error)
{
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	GFile* file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 5199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5199 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((backing == NULL) || IS_BACKING_PHOTO_ROW (backing));
#line 5200 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 5201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (backing == NULL) {
#line 5201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 40240 "Photo.c"
	} else {
		const gchar* _tmp1_;
#line 5201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = backing->filepath;
#line 5201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 40247 "Photo.c"
	}
#line 5201 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp0_) {
#line 5202 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*result = backing_id;
#line 5202 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 40255 "Photo.c"
	}
#line 5204 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = backing->filepath;
#line 5204 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 5204 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	file = _tmp3_;
#line 5205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = file;
#line 5205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 40267 "Photo.c"
		GFile* dupe_file = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoRow* state = NULL;
		GFile* _tmp7_;
		DetectedPhotoInformation* _tmp8_ = NULL;
		BackingPhotoRow* _tmp9_;
		BackingPhotoRow* _tmp10_;
#line 5206 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = file;
#line 5206 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = library_files_duplicate (_tmp5_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5206 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		dupe_file = _tmp6_;
#line 5206 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5206 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5206 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 5206 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 40291 "Photo.c"
		}
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = dupe_file;
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp9_ = photo_query_backing_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp8_, &_inner_error0_);
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		detected = _tmp8_;
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		state = _tmp9_;
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 5209 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 40315 "Photo.c"
		}
#line 5211 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp10_ = state;
#line 5211 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp10_ != NULL) {
#line 40321 "Photo.c"
			BackingPhotoTable* _tmp11_;
			BackingPhotoTable* _tmp12_;
			BackingPhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			BackingPhotoID _tmp15_;
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp11_ = backing_photo_table_get_instance ();
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp13_ = state;
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			backing_photo_table_add (_tmp12_, _tmp13_, &_inner_error0_);
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 5212 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				return;
#line 40351 "Photo.c"
			}
#line 5213 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp14_ = state;
#line 5213 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp15_ = _tmp14_->id;
#line 5213 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			backing_id = _tmp15_;
#line 40359 "Photo.c"
		}
#line 5205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 5205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5205 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 40367 "Photo.c"
	}
#line 5217 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	*result = backing_id;
#line 5217 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 5217 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 40375 "Photo.c"
}


LibraryPhoto*
library_photo_duplicate (LibraryPhoto* self,
                         GError** error)
{
	LibraryPhoto* result = NULL;
	GFile* dupe_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	BackingPhotoID dupe_editable_id = {0};
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_;
	BackingPhotoID dupe_raw_shotwell_id = {0};
	BackingPhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_;
	BackingPhotoID dupe_raw_camera_id = {0};
	BackingPhotoRow* _tmp12_;
	BackingPhotoRow* _tmp13_;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_;
	BackingPhotoID dupe_raw_embedded_id = {0};
	BackingPhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_;
	PhotoID dupe_id = {0};
	PhotoTable* _tmp20_;
	PhotoTable* _tmp21_;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	BackingPhotoID _tmp26_;
	BackingPhotoID _tmp27_;
	BackingPhotoID _tmp28_;
	BackingPhotoID _tmp29_;
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_;
	PhotoRow* dupe_row = NULL;
	PhotoTable* _tmp32_;
	PhotoTable* _tmp33_;
	PhotoID _tmp34_;
	PhotoRow* _tmp35_;
	PhotoRow* _tmp36_;
	LibraryPhoto* dupe = NULL;
	PhotoRow* _tmp37_;
	LibraryPhoto* _tmp38_;
	LibraryPhoto* _tmp39_;
	LibraryPhotoSourceCollection* _tmp40_;
	LibraryPhoto* _tmp41_;
	LibraryPhoto* _tmp42_;
	Event* _tmp43_;
	Event* _tmp44_;
	gboolean _tmp45_;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp50_;
	GeeList* _tmp51_;
	GeeCollection* _tmp52_;
	GError* _inner_error0_ = NULL;
#line 5220 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 5222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 5222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dupe_file = _tmp3_;
#line 5222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5222 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 40463 "Photo.c"
	}
#line 5225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo));
#line 5225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 5225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error0_);
#line 5225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 5225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 5225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 5225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5225 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 40485 "Photo.c"
	}
#line 5226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_SHOTWELL);
#line 5226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 5226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error0_);
#line 5226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 5226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 5226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 5226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5226 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 40507 "Photo.c"
	}
#line 5228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_CAMERA);
#line 5228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 5228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error0_);
#line 5228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 5228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 5228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 5228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5228 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 40529 "Photo.c"
	}
#line 5230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), RAW_DEVELOPER_EMBEDDED);
#line 5230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 5230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error0_);
#line 5230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 5230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 5230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 5230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5230 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return NULL;
#line 40551 "Photo.c"
	}
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp22_);
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp23_ = dupe_file;
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_free0 (_tmp25_);
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 5234 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dupe_id = _tmp31_;
#line 5236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 5236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 5236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp34_ = dupe_id;
#line 5236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 5236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 5236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 5236 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dupe_row = _tmp36_;
#line 5239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp37_ = dupe_row;
#line 5239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 5239 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	dupe = _tmp38_;
#line 5242 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp39_ = dupe;
#line 5242 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	thumbnail_cache_duplicate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 5245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 5245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp41_ = dupe;
#line 5245 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_DATA_OBJECT, DataObject));
#line 5248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp42_ = dupe;
#line 5248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp43_ = media_source_get_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 5248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp45_ = _tmp44_ != NULL;
#line 5248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 5248 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp45_) {
#line 40625 "Photo.c"
		LibraryPhoto* _tmp46_;
		Event* _tmp47_;
		Event* _tmp48_;
		LibraryPhoto* _tmp49_;
#line 5249 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp46_ = dupe;
#line 5249 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp47_ = media_source_get_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5249 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 5249 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp49_ = dupe;
#line 5249 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		event_attach (_tmp48_, G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5249 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp48_);
#line 40642 "Photo.c"
	}
#line 5252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp50_ = tag_global;
#line 5252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp51_ = tag_source_collection_fetch_for_source (_tmp50_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5252 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5253 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp52_ = tags;
#line 5253 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 40654 "Photo.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp53_;
			GeeIterator* _tmp54_;
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp53_ = tags;
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp54_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tag_it = _tmp54_;
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 40667 "Photo.c"
				GeeIterator* _tmp55_;
				Tag* tag = NULL;
				GeeIterator* _tmp56_;
				gpointer _tmp57_;
				Tag* _tmp58_;
				LibraryPhoto* _tmp59_;
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp55_ = _tag_it;
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp55_)) {
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 40680 "Photo.c"
				}
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp56_ = _tag_it;
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp57_ = gee_iterator_get (_tmp56_);
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				tag = (Tag*) _tmp57_;
#line 5255 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp58_ = tag;
#line 5255 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp59_ = dupe;
#line 5255 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				tag_attach (_tmp58_, G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, TYPE_MEDIA_SOURCE, MediaSource));
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 40696 "Photo.c"
			}
#line 5254 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 40700 "Photo.c"
		}
	}
#line 5275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = dupe;
#line 5275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 5275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 5275 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 40713 "Photo.c"
}


static void
library_photo_on_duplicate_progress (LibraryPhoto* self,
                                     gint64 current,
                                     gint64 total)
{
#line 5278 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5279 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	spin_event_loop ();
#line 40726 "Photo.c"
}


static void
library_photo_upgrade_rating_flags (LibraryPhoto* self,
                                    guint64 flags)
{
#line 5282 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 5283 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((flags & LIBRARY_PHOTO_FLAG_HIDDEN) != ((guint64) 0)) {
#line 5284 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), RATING_REJECTED);
#line 5285 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_HIDDEN, NULL);
#line 40742 "Photo.c"
	}
#line 5288 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if ((flags & LIBRARY_PHOTO_FLAG_FAVORITE) != ((guint64) 0)) {
#line 5289 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), RATING_FIVE);
#line 5290 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FAVORITE, NULL);
#line 40750 "Photo.c"
	}
}


static gboolean
library_photo_real_is_trashed (MediaSource* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5295 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5296 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH);
#line 5296 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 40766 "Photo.c"
}


static void
library_photo_real_trash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5299 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5300 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 40778 "Photo.c"
}


static void
library_photo_real_untrash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5303 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5304 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 40790 "Photo.c"
}


static gboolean
library_photo_real_is_offline (Monitorable* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5307 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5308 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE);
#line 5308 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 40805 "Photo.c"
}


static void
library_photo_real_mark_offline (Monitorable* base)
{
	LibraryPhoto * self;
#line 5311 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5312 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 40817 "Photo.c"
}


static void
library_photo_real_mark_online (Monitorable* base)
{
	LibraryPhoto * self;
#line 5315 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5316 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 40829 "Photo.c"
}


static gboolean
library_photo_real_is_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5319 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_is_flag_set (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED);
#line 5320 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 40844 "Photo.c"
}


static void
library_photo_real_mark_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5323 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_add_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5324 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 40864 "Photo.c"
}


static void
library_photo_real_mark_unflagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5327 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5328 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5328 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5328 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_remove_flags (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5328 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 40884 "Photo.c"
}


static gboolean
library_photo_real_internal_delete_backing (DataSource* base,
                                            GError** error)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 5331 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_SOURCE, DataSource), &_inner_error0_);
#line 5334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40902 "Photo.c"
		gboolean _tmp1_ = FALSE;
#line 5334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return _tmp1_;
#line 40908 "Photo.c"
	}
#line 5334 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp0_) {
#line 5335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = FALSE;
#line 5335 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 40916 "Photo.c"
	}
#line 5337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = media_source_delete_original_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5337 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 40922 "Photo.c"
}


static void
library_photo_real_destroy (DataSource* base)
{
	LibraryPhoto * self;
	PhotoID photo_id = {0};
	PhotoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 5340 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5341 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_tmp0_);
#line 5341 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_id = _tmp0_;
#line 5344 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	thumbnail_cache_remove (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 40941 "Photo.c"
	{
		PhotoTable* _tmp1_;
		PhotoTable* _tmp2_;
		PhotoID _tmp3_;
#line 5350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 5350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 5350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = photo_id;
#line 5350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error0_);
#line 5350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 5350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 40960 "Photo.c"
				goto __catch436_database_error;
			}
#line 5350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5350 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			return;
#line 40969 "Photo.c"
		}
	}
	goto __finally436;
	__catch436_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 5349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		err = _inner_error0_;
#line 5349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_inner_error0_ = NULL;
#line 5352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = err;
#line 5352 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 5349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_error_free0 (err);
#line 40987 "Photo.c"
	}
	__finally436:
#line 5349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5349 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 40998 "Photo.c"
	}
#line 5355 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), TYPE_DATA_SOURCE, DataSource));
#line 41002 "Photo.c"
}


gboolean
library_photo_has_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format)
{
	gboolean result = FALSE;
	PhotoID _tmp0_ = {0};
#line 5358 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 5360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_get_nontrash_duplicate (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 5360 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 41022 "Photo.c"
}


void
library_photo_get_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format,
                                      PhotoID* result)
{
	PhotoID* ids = NULL;
	gint _tmp0_ = 0;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp2_ = FALSE;
	PhotoID* _tmp3_;
	gint _tmp3__length1;
	PhotoID* _tmp6_;
	gint _tmp6__length1;
	PhotoID _tmp13_ = {0};
#line 5363 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 5365 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo_get_duplicate_ids (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5365 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ids = _tmp1_;
#line 5365 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ids_length1 = _tmp0_;
#line 5365 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_ids_size_ = ids_length1;
#line 5367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = ids;
#line 5367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3__length1 = ids_length1;
#line 5367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 5367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = TRUE;
#line 41062 "Photo.c"
	} else {
		PhotoID* _tmp4_;
		gint _tmp4__length1;
#line 5367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = ids;
#line 5367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4__length1 = ids_length1;
#line 5367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = _tmp4__length1 == 0;
#line 41072 "Photo.c"
	}
#line 5367 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_) {
#line 41076 "Photo.c"
		PhotoID _tmp5_ = {0};
#line 5368 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_id_init (&_tmp5_, PHOTO_ID_INVALID);
#line 5368 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		*result = _tmp5_;
#line 5368 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 5368 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return;
#line 41086 "Photo.c"
	}
#line 5370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6_ = ids;
#line 5370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp6__length1 = ids_length1;
#line 41092 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 5370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		id_collection = _tmp6_;
#line 5370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		id_collection_length1 = _tmp6__length1;
#line 5370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
#line 41104 "Photo.c"
			PhotoID id = {0};
#line 5370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			id = id_collection[id_it];
#line 41108 "Photo.c"
			{
				LibraryPhoto* photo = NULL;
				LibraryPhotoSourceCollection* _tmp7_;
				PhotoID _tmp8_;
				LibraryPhoto* _tmp9_;
				gboolean _tmp10_ = FALSE;
				LibraryPhoto* _tmp11_;
#line 5371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = library_photo_global;
#line 5371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = id;
#line 5371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = library_photo_source_collection_fetch (_tmp7_, &_tmp8_);
#line 5371 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo = _tmp9_;
#line 5372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = photo;
#line 5372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 41128 "Photo.c"
					LibraryPhoto* _tmp12_;
#line 5372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = photo;
#line 5372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = !media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_MEDIA_SOURCE, MediaSource));
#line 41134 "Photo.c"
				} else {
#line 5372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = FALSE;
#line 41138 "Photo.c"
				}
#line 5372 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp10_) {
#line 5373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					*result = id;
#line 5373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 5373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 5373 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return;
#line 41150 "Photo.c"
				}
#line 5370 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 41154 "Photo.c"
			}
		}
	}
#line 5376 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_id_init (&_tmp13_, PHOTO_ID_INVALID);
#line 5376 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	*result = _tmp13_;
#line 5376 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 5376 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return;
#line 41166 "Photo.c"
}


static gboolean
library_photo_real_has_user_generated_metadata (Photo* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
	GeeList* tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp13_;
	GpsCoords old_coords = {0};
	PhotoMetadata* _tmp14_;
	GpsCoords _tmp15_ = {0};
	GpsCoords _tmp16_ = {0};
	gboolean _tmp17_;
	GeeSet* keywords = NULL;
	PhotoMetadata* _tmp18_;
	GeeSet* _tmp19_;
	gint _tmp20_ = 0;
	GeeList* _tmp21_;
	gint tags_count = 0;
	gint _tmp25_ = 0;
	GeeSet* _tmp26_;
	gint keywords_count = 0;
	gint _tmp30_;
	gint _tmp31_;
	gboolean _tmp32_ = FALSE;
	GeeList* _tmp33_;
#line 5379 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5380 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	tags = _tmp1_;
#line 5382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_source_get_metadata (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource));
#line 5382 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	metadata = _tmp2_;
#line 5383 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = metadata;
#line 5383 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 41216 "Photo.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		GeeList* _tmp7_;
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp7_ = tags;
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp7_ != NULL) {
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = TRUE;
#line 41227 "Photo.c"
		} else {
			GeeList* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = tags;
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _tmp10_ > 0;
#line 41240 "Photo.c"
		}
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp6_) {
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = TRUE;
#line 41246 "Photo.c"
		} else {
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != RATING_UNRATED;
#line 41250 "Photo.c"
		}
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		if (_tmp5_) {
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = TRUE;
#line 41256 "Photo.c"
		} else {
			GpsCoords _tmp11_ = {0};
			gint _tmp12_;
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			positionable_get_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp11_);
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp12_ = _tmp11_.has_gps;
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = _tmp12_ != 0;
#line 41266 "Photo.c"
		}
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = _tmp4_;
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5384 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 41276 "Photo.c"
	}
#line 5386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp13_ = metadata;
#line 5386 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)) != photo_metadata_get_rating (_tmp13_)) {
#line 5387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = TRUE;
#line 5387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5387 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 41290 "Photo.c"
	}
#line 5389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp14_ = metadata;
#line 5389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_metadata_get_gps_coords (_tmp14_, &_tmp15_);
#line 5389 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	old_coords = _tmp15_;
#line 5390 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	positionable_get_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp16_);
#line 5390 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = gps_coords_equals (&_tmp16_, &old_coords);
#line 5390 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (!_tmp17_) {
#line 5391 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = TRUE;
#line 5391 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5391 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5391 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 41312 "Photo.c"
	}
#line 5393 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = metadata;
#line 5393 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = photo_metadata_get_keywords (_tmp18_, NULL, NULL, NULL);
#line 5393 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	keywords = _tmp19_;
#line 5394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp21_ = tags;
#line 5394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp21_ != NULL) {
#line 41324 "Photo.c"
		GeeList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
#line 5394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp22_ = tags;
#line 5394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp23_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp24_ = _tmp23_;
#line 5394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = _tmp24_;
#line 41336 "Photo.c"
	} else {
#line 5394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp20_ = 0;
#line 41340 "Photo.c"
	}
#line 5394 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	tags_count = _tmp20_;
#line 5395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp26_ = keywords;
#line 5395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp26_ != NULL) {
#line 41348 "Photo.c"
		GeeSet* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
#line 5395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp27_ = keywords;
#line 5395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp28_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 5395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp25_ = _tmp29_;
#line 41360 "Photo.c"
	} else {
#line 5395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp25_ = 0;
#line 41364 "Photo.c"
	}
#line 5395 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	keywords_count = _tmp25_;
#line 5397 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp30_ = tags_count;
#line 5397 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = keywords_count;
#line 5397 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp30_ != _tmp31_) {
#line 5398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = TRUE;
#line 5398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5398 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 41384 "Photo.c"
	}
#line 5400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp33_ = tags;
#line 5400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp33_ != NULL) {
#line 41390 "Photo.c"
		GeeSet* _tmp34_;
#line 5400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp34_ = keywords;
#line 5400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = _tmp34_ != NULL;
#line 41396 "Photo.c"
	} else {
#line 5400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp32_ = FALSE;
#line 41400 "Photo.c"
	}
#line 5400 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp32_) {
#line 41404 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp35_;
			GeeList* _tmp36_;
			gint _tag_size = 0;
			GeeList* _tmp37_;
			gint _tmp38_;
			gint _tmp39_;
			gint _tag_index = 0;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp35_ = tags;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36_ = _g_object_ref0 (_tmp35_);
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tag_list = _tmp36_;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp37_ = _tag_list;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp38_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp39_ = _tmp38_;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tag_size = _tmp39_;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tag_index = -1;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 41432 "Photo.c"
				gint _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				Tag* tag = NULL;
				GeeList* _tmp43_;
				gint _tmp44_;
				gpointer _tmp45_;
				GeeSet* _tmp46_;
				Tag* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gboolean _tmp52_;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp40_ = _tag_index;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tag_index = _tmp40_ + 1;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp41_ = _tag_index;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp42_ = _tag_size;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!(_tmp41_ < _tmp42_)) {
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 41459 "Photo.c"
				}
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp43_ = _tag_list;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp44_ = _tag_index;
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp45_ = gee_list_get (_tmp43_, _tmp44_);
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				tag = (Tag*) _tmp45_;
#line 5402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp46_ = keywords;
#line 5402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp47_ = tag;
#line 5402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp48_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, TYPE_DATA_OBJECT, DataObject));
#line 5402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp49_ = _tmp48_;
#line 5402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp50_ = g_utf8_normalize (_tmp49_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 5402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp51_ = _tmp50_;
#line 5402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp52_ = !gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_COLLECTION, GeeCollection), _tmp51_);
#line 5402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp51_);
#line 5402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp49_);
#line 5402 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp52_) {
#line 5403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					result = TRUE;
#line 5403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (tag);
#line 5403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tag_list);
#line 5403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (tags);
#line 5403 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					return result;
#line 41503 "Photo.c"
				}
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 41507 "Photo.c"
			}
#line 5401 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 41511 "Photo.c"
		}
	}
#line 5407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = FALSE;
#line 5407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5407 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 41524 "Photo.c"
}


static void
library_photo_real_set_user_metadata_for_export (Photo* base,
                                                 PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	GeeList* photo_tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	GpsCoords _tmp20_ = {0};
#line 5410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5411 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5411 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5411 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_tags = _tmp1_;
#line 5412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 41552 "Photo.c"
		GeeCollection* string_tags = NULL;
		GeeArrayList* _tmp3_;
		GeeCollection* _tmp19_;
#line 5413 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 5413 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		string_tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 41560 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp4_;
			GeeList* _tmp5_;
			gint _tag_size = 0;
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tag_index = 0;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tag_list = _tmp5_;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = _tag_list;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tag_size = _tmp8_;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tag_index = -1;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 41588 "Photo.c"
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				Tag* tag = NULL;
				GeeList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_;
				GeeCollection* _tmp15_;
				Tag* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = _tag_index;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tag_index = _tmp9_ + 1;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _tag_index;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _tag_size;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 41612 "Photo.c"
				}
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = _tag_list;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = _tag_index;
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = gee_list_get (_tmp12_, _tmp13_);
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				tag = (Tag*) _tmp14_;
#line 5415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = string_tags;
#line 5415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = tag;
#line 5415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_DATA_OBJECT, DataObject));
#line 5415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = _tmp17_;
#line 5415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_collection_add (_tmp15_, _tmp18_);
#line 5415 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (_tmp18_);
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 41636 "Photo.c"
			}
#line 5414 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 41640 "Photo.c"
		}
#line 5417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp19_ = string_tags;
#line 5417 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_keywords (metadata, _tmp19_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5412 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 41648 "Photo.c"
	} else {
#line 5419 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		photo_metadata_set_keywords (metadata, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 41652 "Photo.c"
	}
#line 5421 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_metadata_set_rating (metadata, media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource)));
#line 5422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	positionable_get_gps_coords (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_POSITIONABLE, Positionable), &_tmp20_);
#line 5422 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo_metadata_set_gps_coords (metadata, &_tmp20_);
#line 5410 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 41662 "Photo.c"
}


static void
library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                     PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index = NULL;
	GeeCollection* keywords = NULL;
	GeeSet* _tmp3_;
	GeeCollection* _tmp4_;
	HierarchicalTagIndex* _tmp31_;
#line 5425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 5426 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	new_htag_index = NULL;
#line 5428 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (photo_metadata_has_hierarchical_keywords (metadata)) {
#line 41684 "Photo.c"
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		HierarchicalTagIndex* _tmp2_;
#line 5429 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp0_ = photo_metadata_get_hierarchical_keywords (metadata);
#line 5429 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5429 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = hierarchical_tag_utilities_process_hierarchical_import_keywords (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5429 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5429 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		new_htag_index = _tmp2_;
#line 5429 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 41700 "Photo.c"
	}
#line 5433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo_metadata_get_keywords (metadata, NULL, NULL, NULL);
#line 5433 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 5434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = keywords;
#line 5434 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp4_ != NULL) {
#line 41710 "Photo.c"
		{
			GeeIterator* _keyword_it = NULL;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = keywords;
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_keyword_it = _tmp6_;
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 41723 "Photo.c"
				GeeIterator* _tmp7_;
				gchar* keyword = NULL;
				GeeIterator* _tmp8_;
				gpointer _tmp9_;
				gboolean _tmp10_ = FALSE;
				HierarchicalTagIndex* _tmp11_;
				gchar* safe_keyword = NULL;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* promoted_keyword = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				TagSourceCollection* _tmp18_;
				const gchar* _tmp19_;
				TagSourceCollection* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp28_;
				Tag* _tmp29_;
				Tag* _tmp30_;
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = _keyword_it;
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp7_)) {
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 41749 "Photo.c"
				}
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = _keyword_it;
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = gee_iterator_get (_tmp8_);
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				keyword = (gchar*) _tmp9_;
#line 5436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = new_htag_index;
#line 5436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 41761 "Photo.c"
					HierarchicalTagIndex* _tmp12_;
					const gchar* _tmp13_;
#line 5436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = new_htag_index;
#line 5436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp13_ = keyword;
#line 5436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = hierarchical_tag_index_is_tag_in_index (_tmp12_, _tmp13_);
#line 41770 "Photo.c"
				} else {
#line 5436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = FALSE;
#line 41774 "Photo.c"
				}
#line 5436 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp10_) {
#line 5437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (keyword);
#line 5437 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					continue;
#line 41782 "Photo.c"
				}
#line 5439 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = keyword;
#line 5439 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp15_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp14_);
#line 5439 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				safe_keyword = _tmp15_;
#line 5440 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp16_ = safe_keyword;
#line 5440 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp16_);
#line 5440 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				promoted_keyword = _tmp17_;
#line 5443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp18_ = tag_global;
#line 5443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp19_ = safe_keyword;
#line 5443 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (tag_source_collection_exists (_tmp18_, _tmp19_, FALSE)) {
#line 41802 "Photo.c"
					const gchar* _tmp20_;
					Tag* _tmp21_;
					Tag* _tmp22_;
#line 5444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp20_ = safe_keyword;
#line 5444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp21_ = tag_for_path (_tmp20_);
#line 5444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					tag_attach (_tmp22_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5444 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 5445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (keyword);
#line 5445 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					continue;
#line 41824 "Photo.c"
				}
#line 5448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = tag_global;
#line 5448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = promoted_keyword;
#line 5448 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (tag_source_collection_exists (_tmp23_, _tmp24_, FALSE)) {
#line 41832 "Photo.c"
					const gchar* _tmp25_;
					Tag* _tmp26_;
					Tag* _tmp27_;
#line 5449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp25_ = promoted_keyword;
#line 5449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp26_ = tag_for_path (_tmp25_);
#line 5449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp27_ = _tmp26_;
#line 5449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					tag_attach (_tmp27_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5449 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp27_);
#line 5450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_free0 (keyword);
#line 5450 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					continue;
#line 41854 "Photo.c"
				}
#line 5453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = keyword;
#line 5453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = tag_for_path (_tmp28_);
#line 5453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp30_ = _tmp29_;
#line 5453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				tag_attach (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5453 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp30_);
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (keyword);
#line 41872 "Photo.c"
			}
#line 5435 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 41876 "Photo.c"
		}
	}
#line 5457 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp31_ = new_htag_index;
#line 5457 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp31_ != NULL) {
#line 41883 "Photo.c"
		{
			GeeIterator* _path_it = NULL;
			HierarchicalTagIndex* _tmp32_;
			GeeCollection* _tmp33_;
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_;
			GeeIterator* _tmp36_;
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp32_ = new_htag_index;
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp33_ = hierarchical_tag_index_get_all_paths (_tmp32_);
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp35_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp34_);
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_path_it = _tmp36_;
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 41907 "Photo.c"
				GeeIterator* _tmp37_;
				gchar* path = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				const gchar* _tmp40_;
				Tag* _tmp41_;
				Tag* _tmp42_;
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp37_ = _path_it;
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 41921 "Photo.c"
				}
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp38_ = _path_it;
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				path = (gchar*) _tmp39_;
#line 5459 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp40_ = path;
#line 5459 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp41_ = tag_for_path (_tmp40_);
#line 5459 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5459 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				tag_attach (_tmp42_, G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
#line 5459 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp42_);
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_free0 (path);
#line 41941 "Photo.c"
			}
#line 5458 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 41945 "Photo.c"
		}
	}
#line 5425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5425 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 41952 "Photo.c"
}


static void
library_photo_class_init (LibraryPhotoClass * klass)
{
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoPrivate));
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_master_reimported;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_editable_reimported;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_source_reimported;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_baseline_reimported;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject*, Alteration*)) library_photo_real_notify_altered;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*) (MediaSource*, Scaling*, GError**)) library_photo_real_get_preview_pixbuf;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) library_photo_real_rotate;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) library_photo_real_get_thumbnail;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*) (MediaSource*)) library_photo_real_is_trashed;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->trash = (void (*) (MediaSource*)) library_photo_real_trash;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->untrash = (void (*) (MediaSource*)) library_photo_real_untrash;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->is_offline = (gboolean (*) (MediaSource*)) library_photo_real_is_offline;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->mark_offline = (void (*) (MediaSource*)) library_photo_real_mark_offline;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((MediaSourceClass *) klass)->mark_online = (void (*) (MediaSource*)) library_photo_real_mark_online;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) library_photo_real_internal_delete_backing;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource*)) library_photo_real_destroy;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) library_photo_real_has_user_generated_metadata;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_set_user_metadata_for_export;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_apply_user_metadata_for_reimport;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 42003 "Photo.c"
}


static void
library_photo_flaggable_interface_init (FlaggableIface * iface)
{
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->is_flagged = (gboolean (*) (Flaggable*)) library_photo_real_is_flagged;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->mark_flagged = (void (*) (Flaggable*)) library_photo_real_mark_flagged;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->mark_unflagged = (void (*) (Flaggable*)) library_photo_real_mark_unflagged;
#line 42018 "Photo.c"
}


static void
library_photo_monitorable_interface_init (MonitorableIface * iface)
{
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->is_offline = (gboolean (*) (Monitorable*)) library_photo_real_is_offline;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->mark_offline = (void (*) (Monitorable*)) library_photo_real_mark_offline;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->mark_online = (void (*) (Monitorable*)) library_photo_real_mark_online;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->set_master_file = (void (*) (Photo*, GFile*)) photo_set_master_file;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	iface->set_master_timestamp = (void (*) (Photo*, GFileInfo*)) photo_set_master_timestamp;
#line 42037 "Photo.c"
}


static void
library_photo_instance_init (LibraryPhoto * self)
{
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_GET_PRIVATE (self);
#line 5006 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 5007 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 42050 "Photo.c"
}


static void
library_photo_finalize (GObject * obj)
{
	LibraryPhoto * self;
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5007 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5008 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4995 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 42066 "Photo.c"
}


GType
library_photo_get_type (void)
{
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType library_photo_type_id;
		library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
		g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}


LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_construct (GType object_type,
                                             LibraryPhotoSourceCollection* sources,
                                             SourceHoldingTankCheckToKeep check_to_keep,
                                             gpointer check_to_keep_target,
                                             GetSourceDatabaseKey get_key,
                                             gpointer get_key_target)
{
	LibraryPhotoSourceHoldingTank* self = NULL;
#line 5475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (sources), NULL);
#line 5477 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 5475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return self;
#line 42103 "Photo.c"
}


LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                       SourceHoldingTankCheckToKeep check_to_keep,
                                       gpointer check_to_keep_target,
                                       GetSourceDatabaseKey get_key,
                                       gpointer get_key_target)
{
#line 5475 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 42116 "Photo.c"
}


LibraryPhoto*
library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                         GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* ret = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
#line 5480 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self), NULL);
#line 5480 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 5481 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ret = NULL;
#line 5482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 5482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5482 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	ret = (LibraryPhoto*) _tmp1_;
#line 5483 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = ret;
#line 5483 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 5484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		result = ret;
#line 5484 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		return result;
#line 42153 "Photo.c"
	}
#line 5486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = self->priv->development_file_map;
#line 5486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp4_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 5486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	result = (LibraryPhoto*) _tmp4_;
#line 5486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5486 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	return result;
#line 42165 "Photo.c"
}


static void
_library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                 GFile* old_file,
                                                                                 GFile* new_file,
                                                                                 gpointer self)
{
#line 5510 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced ((LibraryPhotoSourceHoldingTank*) self, _sender, old_file, new_file);
#line 42177 "Photo.c"
}


static void
_library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                               gpointer self)
{
#line 5511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified ((LibraryPhotoSourceHoldingTank*) self, _sender);
#line 42187 "Photo.c"
}


static void
library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                GeeCollection* added,
                                                                GeeCollection* removed)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
#line 5489 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
#line 5491 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (added != NULL) {
#line 42205 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp0_;
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_ITERABLE, GeeIterable));
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_source_it = _tmp0_;
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 42215 "Photo.c"
				GeeIterator* _tmp1_;
				DataSource* source = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp4_;
				LibraryPhoto* _tmp5_;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				gboolean _tmp9_;
				GeeCollection* raw_files = NULL;
				LibraryPhoto* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				LibraryPhoto* _tmp34_;
				LibraryPhoto* _tmp35_;
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp1_ = _source_it;
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 42239 "Photo.c"
				}
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp2_ = _source_it;
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				source = (DataSource*) _tmp3_;
#line 5493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp4_ = source;
#line 5493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5493 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo = _tmp5_;
#line 5496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp6_ = photo;
#line 5496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp7_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PHOTO, Photo));
#line 5496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 5496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp9_ = _tmp8_ != NULL;
#line 5496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 5496 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp9_) {
#line 42265 "Photo.c"
					GeeHashMap* _tmp10_;
					LibraryPhoto* _tmp11_;
					GFile* _tmp12_;
					GFile* _tmp13_;
					LibraryPhoto* _tmp14_;
					GeeMultiMap* _tmp15_;
					LibraryPhoto* _tmp16_;
					LibraryPhoto* _tmp17_;
					GFile* _tmp18_;
					GFile* _tmp19_;
#line 5497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp10_ = self->priv->editable_file_map;
#line 5497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp11_ = photo;
#line 5497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp12_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_PHOTO, Photo));
#line 5497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp13_ = _tmp12_;
#line 5497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp14_ = photo;
#line 5497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp13_, _tmp14_);
#line 5497 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp13_);
#line 5498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp15_ = self->priv->reverse_editable_file_map;
#line 5498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp16_ = photo;
#line 5498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp17_ = photo;
#line 5498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp18_ = photo_get_editable_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO, Photo));
#line 5498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 5498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					gee_multi_map_set (_tmp15_, _tmp16_, _tmp19_);
#line 5498 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp19_);
#line 42304 "Photo.c"
				}
#line 5502 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp20_ = photo;
#line 5502 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp21_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PHOTO, Photo));
#line 5502 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				raw_files = _tmp21_;
#line 5503 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = raw_files;
#line 5503 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (_tmp22_ != NULL) {
#line 42316 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp23_;
						GeeIterator* _tmp24_;
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp23_ = raw_files;
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_f_it = _tmp24_;
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						while (TRUE) {
#line 42329 "Photo.c"
							GeeIterator* _tmp25_;
							GFile* f = NULL;
							GeeIterator* _tmp26_;
							gpointer _tmp27_;
							GeeHashMap* _tmp28_;
							GFile* _tmp29_;
							LibraryPhoto* _tmp30_;
							GeeMultiMap* _tmp31_;
							LibraryPhoto* _tmp32_;
							GFile* _tmp33_;
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp25_ = _f_it;
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							if (!gee_iterator_next (_tmp25_)) {
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
								break;
#line 42346 "Photo.c"
							}
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp26_ = _f_it;
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp27_ = gee_iterator_get (_tmp26_);
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							f = (GFile*) _tmp27_;
#line 5505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp28_ = self->priv->development_file_map;
#line 5505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp29_ = f;
#line 5505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp30_ = photo;
#line 5505 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp29_, _tmp30_);
#line 5506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp31_ = self->priv->reverse_development_file_map;
#line 5506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp32_ = photo;
#line 5506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_tmp33_ = f;
#line 5506 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							gee_multi_map_set (_tmp31_, _tmp32_, _tmp33_);
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							_g_object_unref0 (f);
#line 42372 "Photo.c"
						}
#line 5504 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 42376 "Photo.c"
					}
				}
#line 5510 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp34_ = photo;
#line 5510 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_PHOTO, Photo), "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp35_ = photo;
#line 5511 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_PHOTO, Photo), "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (source);
#line 42393 "Photo.c"
			}
#line 5492 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 42397 "Photo.c"
		}
	}
#line 5515 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (removed != NULL) {
#line 42402 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp36_;
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp36_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_ITERABLE, GeeIterable));
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_source_it = _tmp36_;
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 42412 "Photo.c"
				GeeIterator* _tmp37_;
				DataSource* source = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp40_;
				LibraryPhoto* _tmp41_;
				GeeMultiMap* _tmp64_;
				LibraryPhoto* _tmp65_;
				GeeMultiMap* _tmp66_;
				LibraryPhoto* _tmp67_;
				LibraryPhoto* _tmp68_;
				guint _tmp69_;
				LibraryPhoto* _tmp70_;
				guint _tmp71_;
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp37_ = _source_it;
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 42434 "Photo.c"
				}
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp38_ = _source_it;
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				source = (DataSource*) _tmp39_;
#line 5517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp40_ = source;
#line 5517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp41_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5517 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				photo = _tmp41_;
#line 42448 "Photo.c"
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					GeeCollection* _tmp44_;
					GeeCollection* _tmp45_;
					GeeIterator* _tmp46_;
					GeeIterator* _tmp47_;
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp42_ = self->priv->reverse_editable_file_map;
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp43_ = photo;
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp44_ = gee_multi_map_get (_tmp42_, _tmp43_);
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp45_ = _tmp44_;
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp46_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp45_);
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_f_it = _tmp47_;
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					while (TRUE) {
#line 42475 "Photo.c"
						GeeIterator* _tmp48_;
						GFile* f = NULL;
						GeeIterator* _tmp49_;
						gpointer _tmp50_;
						GeeHashMap* _tmp51_;
						GFile* _tmp52_;
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp48_ = _f_it;
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (!gee_iterator_next (_tmp48_)) {
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							break;
#line 42488 "Photo.c"
						}
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp49_ = _f_it;
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp50_ = gee_iterator_get (_tmp49_);
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						f = (GFile*) _tmp50_;
#line 5519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp51_ = self->priv->editable_file_map;
#line 5519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp52_ = f;
#line 5519 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp52_, NULL);
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (f);
#line 42504 "Photo.c"
					}
#line 5518 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 42508 "Photo.c"
				}
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp53_;
					LibraryPhoto* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp53_ = self->priv->reverse_development_file_map;
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp54_ = photo;
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp55_ = gee_multi_map_get (_tmp53_, _tmp54_);
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp57_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_f_it = _tmp58_;
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					while (TRUE) {
#line 42536 "Photo.c"
						GeeIterator* _tmp59_;
						GFile* f = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						GeeHashMap* _tmp62_;
						GFile* _tmp63_;
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp59_ = _f_it;
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
							break;
#line 42549 "Photo.c"
						}
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp60_ = _f_it;
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						f = (GFile*) _tmp61_;
#line 5522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp62_ = self->priv->development_file_map;
#line 5522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_tmp63_ = f;
#line 5522 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp63_, NULL);
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
						_g_object_unref0 (f);
#line 42565 "Photo.c"
					}
#line 5521 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 42569 "Photo.c"
				}
#line 5524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp64_ = self->priv->reverse_editable_file_map;
#line 5524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp65_ = photo;
#line 5524 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_multi_map_remove_all (_tmp64_, _tmp65_);
#line 5525 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp66_ = self->priv->reverse_development_file_map;
#line 5525 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp67_ = photo;
#line 5525 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_multi_map_remove_all (_tmp66_, _tmp67_);
#line 5527 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp68_ = photo;
#line 5527 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp69_, NULL, FALSE);
#line 5527 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp69_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp70_ = photo;
#line 5528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp71_, NULL, FALSE);
#line 5528 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, TYPE_PHOTO, Photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp71_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (source);
#line 42599 "Photo.c"
			}
#line 5516 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 42603 "Photo.c"
		}
	}
#line 5532 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), added, removed);
#line 42608 "Photo.c"
}


static void
library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                        Photo* _photo,
                                                        GFile* old_file,
                                                        GFile* new_file)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp7_;
	LibraryPhoto* _tmp8_;
#line 5535 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5535 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5535 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 5535 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 5536 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 5536 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = _tmp0_;
#line 5537 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo;
#line 5537 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5539 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (old_file != NULL) {
#line 42641 "Photo.c"
		GeeHashMap* _tmp2_;
		GeeMultiMap* _tmp3_;
		LibraryPhoto* _tmp4_;
#line 5540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp2_ = self->priv->editable_file_map;
#line 5540 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), old_file, NULL);
#line 5541 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp3_ = self->priv->reverse_editable_file_map;
#line 5541 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp4_ = photo;
#line 5541 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gee_multi_map_remove (_tmp3_, _tmp4_, old_file);
#line 42655 "Photo.c"
	}
#line 5544 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (new_file != NULL) {
#line 42659 "Photo.c"
		GeeHashMap* _tmp5_;
		LibraryPhoto* _tmp6_;
#line 5545 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp5_ = self->priv->editable_file_map;
#line 5545 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp6_ = photo;
#line 5545 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), new_file, _tmp6_);
#line 42668 "Photo.c"
	}
#line 5546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp7_ = self->priv->reverse_editable_file_map;
#line 5546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp8_ = photo;
#line 5546 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	gee_multi_map_set (_tmp7_, _tmp8_, new_file);
#line 5535 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 42678 "Photo.c"
}


static void
library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                               Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp17_;
	GeeCollection* _tmp18_;
	GeeCollection* _tmp19_;
#line 5549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (self));
#line 5549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (_photo));
#line 5550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_photo) ? ((LibraryPhoto*) _photo) : NULL);
#line 5550 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	photo = _tmp0_;
#line 5551 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = photo;
#line 5551 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5554 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = self->priv->reverse_development_file_map;
#line 5554 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = photo;
#line 5554 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 42713 "Photo.c"
		GeeMultiMap* _tmp15_;
		LibraryPhoto* _tmp16_;
		{
			GeeIterator* _f_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp4_ = self->priv->reverse_development_file_map;
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp5_ = photo;
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_f_it = _tmp9_;
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 42742 "Photo.c"
				GeeIterator* _tmp10_;
				GFile* f = NULL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				GeeHashMap* _tmp13_;
				GFile* _tmp14_;
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp10_ = _f_it;
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 42755 "Photo.c"
				}
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp11_ = _f_it;
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				f = (GFile*) _tmp12_;
#line 5556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp13_ = self->priv->development_file_map;
#line 5556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp14_ = f;
#line 5556 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp14_, NULL);
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 42771 "Photo.c"
			}
#line 5555 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 42775 "Photo.c"
		}
#line 5557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp15_ = self->priv->reverse_development_file_map;
#line 5557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		_tmp16_ = photo;
#line 5557 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
		gee_multi_map_remove_all (_tmp15_, _tmp16_);
#line 42783 "Photo.c"
	}
#line 5561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp17_ = photo;
#line 5561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp18_ = photo_get_raw_developer_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PHOTO, Photo));
#line 5561 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	raw_list = _tmp18_;
#line 5562 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp19_ = raw_list;
#line 5562 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 42795 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp20_;
			GeeIterator* _tmp21_;
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp20_ = raw_list;
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_tmp21_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ITERABLE, GeeIterable));
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_f_it = _tmp21_;
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			while (TRUE) {
#line 42808 "Photo.c"
				GeeIterator* _tmp22_;
				GFile* f = NULL;
				GeeIterator* _tmp23_;
				gpointer _tmp24_;
				GeeHashMap* _tmp25_;
				GFile* _tmp26_;
				LibraryPhoto* _tmp27_;
				GeeMultiMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GFile* _tmp30_;
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp22_ = _f_it;
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				if (!gee_iterator_next (_tmp22_)) {
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
					break;
#line 42825 "Photo.c"
				}
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp23_ = _f_it;
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp24_ = gee_iterator_get (_tmp23_);
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				f = (GFile*) _tmp24_;
#line 5564 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp25_ = self->priv->development_file_map;
#line 5564 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp26_ = f;
#line 5564 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp27_ = photo;
#line 5564 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp26_, _tmp27_);
#line 5565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp28_ = self->priv->reverse_development_file_map;
#line 5565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp29_ = photo;
#line 5565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_tmp30_ = f;
#line 5565 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				gee_multi_map_set (_tmp28_, _tmp29_, _tmp30_);
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
				_g_object_unref0 (f);
#line 42851 "Photo.c"
			}
#line 5563 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 42855 "Photo.c"
		}
	}
#line 5549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5549 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 42862 "Photo.c"
}


static void
library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass)
{
#line 5465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((SourceHoldingTankClass *) klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceHoldingTankPrivate));
#line 5465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = (void (*) (SourceHoldingTank*, GeeCollection*, GeeCollection*)) library_photo_source_holding_tank_real_notify_contents_altered;
#line 42877 "Photo.c"
}


static void
library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMultiMap* _tmp2_;
	GeeHashMultiMap* _tmp3_;
#line 5465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE (self);
#line 5466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5468 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5468 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5470 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp2_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5470 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->reverse_editable_file_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 5472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_tmp3_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self->priv->reverse_development_file_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
#line 42906 "Photo.c"
}


static void
library_photo_source_holding_tank_finalize (SourceHoldingTank * obj)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5466 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5468 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5470 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5472 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5465 "/builddir/build/BUILD/shotwell-0.31.1/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 42926 "Photo.c"
}


GType
library_photo_source_holding_tank_get_type (void)
{
	static volatile gsize library_photo_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_holding_tank_type_id__volatile, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



