/* PhotoTable.c generated by valac 0.40.19, the Vala compiler
 * generated from PhotoTable.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <gee.h>
#include "shotwell-graphics-processor.h"
#include <float.h>
#include <math.h>
#include <sqlite3.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;


#define TYPE_ORIENTATION (orientation_get_type ())
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;


#define TYPE_RATING (rating_get_type ())

#define TYPE_GPS_COORDS (gps_coords_get_type ())
typedef struct _GpsCoords GpsCoords;

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;


#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecPhotoRow ParamSpecPhotoRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
typedef struct _PhotoTablePrivate PhotoTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;


#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecBackingPhotoRow ParamSpecBackingPhotoRow;

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;
typedef struct _BackingPhotoTablePrivate BackingPhotoTablePrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PhotoID {
	gint64 id;
};

struct _ImportID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _GpsCoords {
	gint has_gps;
	gdouble latitude;
	gdouble longitude;
};

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	GpsCoords gps_coords;
	gchar* comment;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _ParamSpecPhotoRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _PhotoTable {
	DatabaseTable parent_instance;
	PhotoTablePrivate * priv;
};

struct _PhotoTableClass {
	DatabaseTableClass parent_class;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _ParamSpecBackingPhotoRow {
	GParamSpec parent_instance;
};

struct _BackingPhotoTable {
	DatabaseTable parent_instance;
	BackingPhotoTablePrivate * priv;
};

struct _BackingPhotoTableClass {
	DatabaseTableClass parent_class;
};


static gpointer photo_row_parent_class = NULL;
static gpointer photo_table_parent_class = NULL;
static PhotoTable* photo_table_instance;
static PhotoTable* photo_table_instance = NULL;
extern sqlite3* database_table_db;
static gpointer backing_photo_row_parent_class = NULL;
static gpointer backing_photo_table_parent_class = NULL;
static BackingPhotoTable* backing_photo_table_instance;
static BackingPhotoTable* backing_photo_table_instance = NULL;

GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
#define PHOTO_ID_INVALID ((gint64) -1)
void photo_id_init (PhotoID *self,
                    gint64 id);
gboolean photo_id_is_invalid (PhotoID *self);
gboolean photo_id_is_valid (PhotoID *self);
guint photo_id_hash (PhotoID *self);
guint int64_hash (gint64* n);
gboolean photo_id_equal (void* a,
                         void* b);
gchar* photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id);
#define PHOTO_TYPENAME "thumb"
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
#define IMPORT_ID_INVALID ((gint64) 0)
void import_id_init (ImportID *self,
                     gint64 id);
void import_id_generate (ImportID* result);
#define UTIL_USEC_PER_SEC ((gint64) 1000000)
gboolean import_id_is_invalid (ImportID *self);
gboolean import_id_is_valid (ImportID *self);
gint import_id_compare_func (ImportID* a,
                             ImportID* b);
gint64 import_id_comparator (void* a,
                             void* b);
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_photo_row (GValue* value,
                          gpointer v_object);
void value_take_photo_row (GValue* value,
                           gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST;
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_backing_photo_row (GValue* value,
                                  gpointer v_object);
void value_take_backing_photo_row (GValue* value,
                                   gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST;
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
GType orientation_get_type (void) G_GNUC_CONST;
GType rating_get_type (void) G_GNUC_CONST;
GType gps_coords_get_type (void) G_GNUC_CONST;
GpsCoords* gps_coords_dup (const GpsCoords* self);
void gps_coords_free (GpsCoords* self);
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
GType raw_developer_get_type (void) G_GNUC_CONST;
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
void backing_photo_id_init (BackingPhotoID *self,
                            gint64 id);
RawDeveloper* raw_developer_as_array (int* result_length1);
static void photo_row_finalize (PhotoRow * obj);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType photo_table_get_type (void) G_GNUC_CONST;
static PhotoTable* photo_table_new (void);
static PhotoTable* photo_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_fatal (const gchar* op,
                           gint res);
void database_table_warning (const gchar* op,
                             gint res);
void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
PhotoTable* photo_table_get_instance (void);
void photo_table_add (PhotoTable* self,
                      PhotoRow* photo_row,
                      PhotoID* result);
gulong now_sec (void);
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
#define EVENT_ID_INVALID ((gint64) -1)
gint photo_file_format_serialize (PhotoFileFormat self);
gint rating_serialize (Rating self);
gchar* raw_developer_to_string (RawDeveloper self);
void event_id_init (EventID *self,
                    gint64 id);
GQuark database_error_quark (void);
void photo_table_reimport (PhotoTable* self,
                           PhotoRow* row,
                           GError** error);
void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
gboolean photo_table_master_exif_updated (PhotoTable* self,
                                          PhotoID* photoID,
                                          gint64 filesize,
                                          glong timestamp,
                                          const gchar* md5,
                                          const gchar* exif_md5,
                                          const gchar* thumbnail_md5,
                                          PhotoRow* row);
static void photo_table_validate_orientation (PhotoTable* self,
                                       PhotoRow* row);
gboolean photo_table_set_orientation (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation);
PhotoRow* photo_table_get_row (PhotoTable* self,
                               PhotoID* photo_id);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
GeeHashMap* photo_table_marshall_all_transformations (const gchar* trans);
Rating rating_unserialize (gint value);
PhotoFileFormat photo_file_format_unserialize (gint value);
RawDeveloper raw_developer_from_string (const gchar* value);
GeeArrayList* photo_table_get_all (PhotoTable* self);
void photo_table_duplicate (PhotoTable* self,
                            PhotoID* photo_id,
                            const gchar* new_filename,
                            BackingPhotoID* editable_id,
                            BackingPhotoID* develop_shotwell,
                            BackingPhotoID* develop_camera_id,
                            BackingPhotoID* develop_embedded_id,
                            PhotoID* result);
gchar* photo_table_unmarshall_all_transformations (GeeHashMap* transformations);
gboolean photo_table_set_title (PhotoTable* self,
                                PhotoID* photo_id,
                                const gchar* new_title);
gboolean database_table_update_text_by_id (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           const gchar* text);
void photo_table_set_gps_coords (PhotoTable* self,
                                 PhotoID* photo_id,
                                 GpsCoords* new_gps_coords,
                                 GError** error);
void database_table_update_int_by_id_2 (DatabaseTable* self,
                                        gint64 id,
                                        const gchar* column,
                                        gint value,
                                        GError** error);
void database_table_update_double_by_id_2 (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           gdouble value,
                                           GError** error);
gboolean photo_table_set_comment (PhotoTable* self,
                                  PhotoID* photo_id,
                                  const gchar* new_comment);
void photo_table_set_filepath (PhotoTable* self,
                               PhotoID* photo_id,
                               const gchar* filepath,
                               GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
void photo_table_update_timestamp (PhotoTable* self,
                                   PhotoID* photo_id,
                                   time_t timestamp,
                                   GError** error);
void database_table_update_int64_by_id_2 (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint64 value,
                                          GError** error);
gboolean photo_table_set_exposure_time (PhotoTable* self,
                                        PhotoID* photo_id,
                                        time_t time);
gboolean database_table_update_int64_by_id (DatabaseTable* self,
                                            gint64 id,
                                            const gchar* column,
                                            gint64 value);
void photo_table_set_import_id (PhotoTable* self,
                                PhotoID* photo_id,
                                ImportID* import_id,
                                GError** error);
gboolean photo_table_remove_by_file (PhotoTable* self,
                                     GFile* file);
void photo_table_remove (PhotoTable* self,
                         PhotoID* photo_id,
                         GError** error);
void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
GeeArrayList* photo_table_get_photos (PhotoTable* self);
gboolean database_table_update_int_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint value);
gboolean photo_table_replace_flags (PhotoTable* self,
                                    PhotoID* photo_id,
                                    guint64 flags);
gboolean photo_table_set_rating (PhotoTable* self,
                                 PhotoID* photo_id,
                                 Rating rating);
gint photo_table_get_event_photo_count (PhotoTable* self,
                                        EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self,
                                                EventID* event_id);
gboolean photo_table_event_has_photos (PhotoTable* self,
                                       EventID* event_id);
gboolean photo_table_drop_event (PhotoTable* self,
                                 EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self,
                                PhotoID* photo_id,
                                EventID* event_id);
static gchar* photo_table_get_raw_transformations (PhotoTable* self,
                                            PhotoID* photo_id);
gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt* * stmt);
static gboolean photo_table_set_raw_transformations (PhotoTable* self,
                                              PhotoID* photo_id,
                                              const gchar* trans);
gboolean photo_table_set_transformation_state (PhotoTable* self,
                                               PhotoID* photo_id,
                                               Orientation orientation,
                                               GeeHashMap* transformations);
gboolean photo_table_set_transformation (PhotoTable* self,
                                         PhotoID* photo_id,
                                         KeyValueMap* map);
gboolean photo_table_remove_transformation (PhotoTable* self,
                                            PhotoID* photo_id,
                                            const gchar* object);
gboolean photo_table_remove_all_transformations (PhotoTable* self,
                                                 PhotoID* photo_id);
static sqlite3_stmt* photo_table_get_duplicate_stmt (PhotoTable* self,
                                              GFile* file,
                                              const gchar* thumbnail_md5,
                                              const gchar* md5,
                                              PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self,
                                    GFile* file,
                                    const gchar* thumbnail_md5,
                                    const gchar* md5,
                                    PhotoFileFormat file_format);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self,
                                        GFile* file,
                                        const gchar* thumbnail_md5,
                                        const gchar* md5,
                                        PhotoFileFormat file_format,
                                        int* result_length1);
static void _vala_array_add2 (PhotoID* * array,
                       int* length,
                       int* size,
                       const PhotoID* value);
void photo_table_update_backlinks (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* backlinks,
                                   GError** error);
void photo_table_attach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  BackingPhotoID* editable_id,
                                  GError** error);
void photo_table_detach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self,
                                     PhotoID* photo_id,
                                     gboolean dirty,
                                     GError** error);
void photo_table_update_raw_development (PhotoTable* self,
                                         PhotoRow* row,
                                         RawDeveloper rd,
                                         BackingPhotoID* backing_photo_id,
                                         GError** error);
void photo_table_remove_development (PhotoTable* self,
                                     PhotoRow* row,
                                     RawDeveloper rd,
                                     GError** error);
static void photo_table_finalize (DatabaseTable * obj);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                              GFileInfo* info);
gboolean backing_photo_row_is_touched (BackingPhotoRow* self,
                                       GFileInfo* info);
void backing_photo_row_copy_from (BackingPhotoRow* self,
                                  BackingPhotoRow* from);
static void backing_photo_row_finalize (BackingPhotoRow * obj);
GType backing_photo_table_get_type (void) G_GNUC_CONST;
static BackingPhotoTable* backing_photo_table_new (void);
static BackingPhotoTable* backing_photo_table_construct (GType object_type);
BackingPhotoTable* backing_photo_table_get_instance (void);
void backing_photo_table_add (BackingPhotoTable* self,
                              BackingPhotoRow* state,
                              GError** error);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GError** error);
void backing_photo_table_update (BackingPhotoTable* self,
                                 BackingPhotoRow* row,
                                 GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            time_t timestamp,
                                            gint64 filesize,
                                            GError** error);
void backing_photo_table_remove (BackingPhotoTable* self,
                                 BackingPhotoID* backing_id,
                                 GError** error);
void backing_photo_table_set_filepath (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       const gchar* filepath,
                                       GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                           BackingPhotoID* id,
                                           time_t timestamp,
                                           GError** error);
static void backing_photo_table_finalize (DatabaseTable * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


void
photo_id_init (PhotoID *self,
               gint64 id)
{
#line 12 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	memset (self, 0, sizeof (PhotoID));
#line 13 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	(*self).id = id;
#line 656 "PhotoTable.c"
}


gboolean
photo_id_is_invalid (PhotoID *self)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = (*self).id;
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp0_ == PHOTO_ID_INVALID;
#line 17 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 671 "PhotoTable.c"
}


gboolean
photo_id_is_valid (PhotoID *self)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = (*self).id;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp0_ != PHOTO_ID_INVALID;
#line 21 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 686 "PhotoTable.c"
}


guint
photo_id_hash (PhotoID *self)
{
	guint result = 0U;
	gint64 _tmp0_;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = (*self).id;
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = int64_hash (&_tmp0_);
#line 25 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 701 "PhotoTable.c"
}


gboolean
photo_id_equal (void* a,
                void* b)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
	gint64 _tmp1_;
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = (*((PhotoID*) a)).id;
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = (*((PhotoID*) b)).id;
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp0_ == _tmp1_;
#line 29 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 720 "PhotoTable.c"
}


gchar*
photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id)
{
	gchar* result = NULL;
	PhotoID _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_;
#line 32 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", PHOTO_TYPENAME, _tmp1_);
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp2_;
#line 33 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 743 "PhotoTable.c"
}


PhotoID*
photo_id_dup (const PhotoID* self)
{
	PhotoID* dup;
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	dup = g_new0 (PhotoID, 1);
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (PhotoID));
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return dup;
#line 757 "PhotoTable.c"
}


void
photo_id_free (PhotoID* self)
{
#line 7 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_free (self);
#line 766 "PhotoTable.c"
}


GType
photo_id_get_type (void)
{
	static volatile gsize photo_id_type_id__volatile = 0;
	if (g_once_init_enter (&photo_id_type_id__volatile)) {
		GType photo_id_type_id;
		photo_id_type_id = g_boxed_type_register_static ("PhotoID", (GBoxedCopyFunc) photo_id_dup, (GBoxedFreeFunc) photo_id_free);
		g_once_init_leave (&photo_id_type_id__volatile, photo_id_type_id);
	}
	return photo_id_type_id__volatile;
}


void
import_id_init (ImportID *self,
                gint64 id)
{
#line 42 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	memset (self, 0, sizeof (ImportID));
#line 43 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	(*self).id = id;
#line 791 "PhotoTable.c"
}


void
import_id_generate (ImportID* result)
{
	gint64 id = 0LL;
	ImportID _tmp0_ = {0};
#line 47 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	id = g_get_real_time () / UTIL_USEC_PER_SEC;
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	import_id_init (&_tmp0_, id);
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	*result = _tmp0_;
#line 49 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return;
#line 808 "PhotoTable.c"
}


gboolean
import_id_is_invalid (ImportID *self)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 53 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = (*self).id;
#line 53 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp0_ == IMPORT_ID_INVALID;
#line 53 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 823 "PhotoTable.c"
}


gboolean
import_id_is_valid (ImportID *self)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = (*self).id;
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp0_ != IMPORT_ID_INVALID;
#line 57 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 838 "PhotoTable.c"
}


gint
import_id_compare_func (ImportID* a,
                        ImportID* b)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	gint64 _tmp1_;
	gint64 _tmp2_;
#line 61 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (a != NULL) {
#line 61 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = b != NULL;
#line 854 "PhotoTable.c"
	} else {
#line 61 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = FALSE;
#line 858 "PhotoTable.c"
	}
#line 61 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp0_, "a != null && b != null");
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = (*a).id;
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = (*b).id;
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = (gint) (_tmp1_ - _tmp2_);
#line 62 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 870 "PhotoTable.c"
}


gint64
import_id_comparator (void* a,
                      void* b)
{
	gint64 result = 0LL;
	gint64 _tmp0_;
	gint64 _tmp1_;
#line 66 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = (*((ImportID*) a)).id;
#line 66 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = (*((ImportID*) b)).id;
#line 66 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp0_ - _tmp1_;
#line 66 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 889 "PhotoTable.c"
}


ImportID*
import_id_dup (const ImportID* self)
{
	ImportID* dup;
#line 37 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	dup = g_new0 (ImportID, 1);
#line 37 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (ImportID));
#line 37 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return dup;
#line 903 "PhotoTable.c"
}


void
import_id_free (ImportID* self)
{
#line 37 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_free (self);
#line 912 "PhotoTable.c"
}


GType
import_id_get_type (void)
{
	static volatile gsize import_id_type_id__volatile = 0;
	if (g_once_init_enter (&import_id_type_id__volatile)) {
		GType import_id_type_id;
		import_id_type_id = g_boxed_type_register_static ("ImportID", (GBoxedCopyFunc) import_id_dup, (GBoxedFreeFunc) import_id_free);
		g_once_init_leave (&import_id_type_id__volatile, import_id_type_id);
	}
	return import_id_type_id__volatile;
}


PhotoRow*
photo_row_construct (GType object_type)
{
	PhotoRow* self = NULL;
	BackingPhotoRow* _tmp0_;
	gint _tmp1_ = 0;
	RawDeveloper* _tmp2_;
	RawDeveloper* _tmp3_;
	gint _tmp3__length1;
	BackingPhotoID* _tmp4_;
	gint _tmp5_ = 0;
	RawDeveloper* _tmp6_;
	gint _tmp10_ = 0;
	RawDeveloper* _tmp11_;
	RawDeveloper* _tmp12_;
	gint _tmp12__length1;
	BackingPhotoID* _tmp13_;
	gint _tmp14_ = 0;
	RawDeveloper* _tmp15_;
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self = (PhotoRow*) g_type_create_instance (object_type);
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = backing_photo_row_new ();
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_backing_photo_row_unref0 (self->master);
#line 100 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->master = _tmp0_;
#line 101 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	backing_photo_id_init (&self->editable_id, BACKING_PHOTO_ID_INVALID);
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = raw_developer_as_array (&_tmp1_);
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_;
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3__length1 = _tmp1_;
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = g_new0 (BackingPhotoID, _tmp1_);
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->development_ids = _tmp4_;
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->development_ids_length1 = _tmp1_;
#line 102 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = raw_developer_as_array (&_tmp5_);
#line 976 "PhotoTable.c"
	{
		RawDeveloper* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		d_collection = _tmp6_;
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		d_collection_length1 = _tmp5_;
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 988 "PhotoTable.c"
			RawDeveloper d = 0;
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			d = d_collection[d_it];
#line 992 "PhotoTable.c"
			{
				BackingPhotoID* _tmp7_;
				gint _tmp7__length1;
				RawDeveloper _tmp8_;
				BackingPhotoID _tmp9_ = {0};
#line 104 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp7_ = self->development_ids;
#line 104 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp7__length1 = self->development_ids_length1;
#line 104 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp8_ = d;
#line 104 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				backing_photo_id_init (&_tmp9_, BACKING_PHOTO_ID_INVALID);
#line 104 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp7_[_tmp8_] = _tmp9_;
#line 1008 "PhotoTable.c"
			}
		}
#line 103 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		d_collection = (g_free (d_collection), NULL);
#line 1013 "PhotoTable.c"
	}
#line 105 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	memset (&self->gps_coords, 0, sizeof (GpsCoords));
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = raw_developer_as_array (&_tmp10_);
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = _tmp11_;
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12__length1 = _tmp10_;
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = g_new0 (BackingPhotoID, _tmp10_);
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->development_ids = _tmp13_;
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->development_ids_length1 = _tmp10_;
#line 106 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = (g_free (_tmp12_), NULL);
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_ = raw_developer_as_array (&_tmp14_);
#line 1035 "PhotoTable.c"
	{
		RawDeveloper* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		d_collection = _tmp15_;
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		d_collection_length1 = _tmp14_;
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 1047 "PhotoTable.c"
			RawDeveloper d = 0;
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			d = d_collection[d_it];
#line 1051 "PhotoTable.c"
			{
				BackingPhotoID* _tmp16_;
				gint _tmp16__length1;
				RawDeveloper _tmp17_;
				BackingPhotoID _tmp18_ = {0};
#line 108 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp16_ = self->development_ids;
#line 108 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp16__length1 = self->development_ids_length1;
#line 108 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp17_ = d;
#line 108 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				backing_photo_id_init (&_tmp18_, BACKING_PHOTO_ID_INVALID);
#line 108 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp16_[_tmp17_] = _tmp18_;
#line 1067 "PhotoTable.c"
			}
		}
#line 107 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		d_collection = (g_free (d_collection), NULL);
#line 1072 "PhotoTable.c"
	}
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return self;
#line 1076 "PhotoTable.c"
}


PhotoRow*
photo_row_new (void)
{
#line 99 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return photo_row_construct (TYPE_PHOTO_ROW);
#line 1085 "PhotoTable.c"
}


static void
value_photo_row_init (GValue* value)
{
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	value->data[0].v_pointer = NULL;
#line 1094 "PhotoTable.c"
}


static void
value_photo_row_free_value (GValue* value)
{
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (value->data[0].v_pointer) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		photo_row_unref (value->data[0].v_pointer);
#line 1105 "PhotoTable.c"
	}
}


static void
value_photo_row_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = photo_row_ref (src_value->data[0].v_pointer);
#line 1118 "PhotoTable.c"
	} else {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1122 "PhotoTable.c"
	}
}


static gpointer
value_photo_row_peek_pointer (const GValue* value)
{
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 1132 "PhotoTable.c"
}


static gchar*
value_photo_row_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (collect_values[0].v_pointer) {
#line 1144 "PhotoTable.c"
		PhotoRow * object;
		object = collect_values[0].v_pointer;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1151 "PhotoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1155 "PhotoTable.c"
		}
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = photo_row_ref (object);
#line 1159 "PhotoTable.c"
	} else {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 1163 "PhotoTable.c"
	}
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return NULL;
#line 1167 "PhotoTable.c"
}


static gchar*
value_photo_row_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	PhotoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (!object_p) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1183 "PhotoTable.c"
	}
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (!value->data[0].v_pointer) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*object_p = NULL;
#line 1189 "PhotoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 1193 "PhotoTable.c"
	} else {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*object_p = photo_row_ref (value->data[0].v_pointer);
#line 1197 "PhotoTable.c"
	}
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return NULL;
#line 1201 "PhotoTable.c"
}


GParamSpec*
param_spec_photo_row (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecPhotoRow* spec;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_ROW), NULL);
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return G_PARAM_SPEC (spec);
#line 1221 "PhotoTable.c"
}


gpointer
value_get_photo_row (const GValue* value)
{
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW), NULL);
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 1232 "PhotoTable.c"
}


void
value_set_photo_row (GValue* value,
                     gpointer v_object)
{
	PhotoRow * old;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW));
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (v_object) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_ROW));
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		photo_row_ref (value->data[0].v_pointer);
#line 1255 "PhotoTable.c"
	} else {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 1259 "PhotoTable.c"
	}
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (old) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		photo_row_unref (old);
#line 1265 "PhotoTable.c"
	}
}


void
value_take_photo_row (GValue* value,
                      gpointer v_object)
{
	PhotoRow * old;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW));
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (v_object) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_ROW));
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 1287 "PhotoTable.c"
	} else {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 1291 "PhotoTable.c"
	}
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (old) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		photo_row_unref (old);
#line 1297 "PhotoTable.c"
	}
}


static void
photo_row_class_init (PhotoRowClass * klass)
{
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	photo_row_parent_class = g_type_class_peek_parent (klass);
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	((PhotoRowClass *) klass)->finalize = photo_row_finalize;
#line 1309 "PhotoTable.c"
}


static void
photo_row_instance_init (PhotoRow * self)
{
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->ref_count = 1;
#line 1318 "PhotoTable.c"
}


static void
photo_row_finalize (PhotoRow * obj)
{
	PhotoRow * self;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_ROW, PhotoRow);
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_signal_handlers_destroy (self);
#line 72 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_backing_photo_row_unref0 (self->master);
#line 77 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_object_unref0 (self->transformations);
#line 78 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (self->md5);
#line 79 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (self->thumbnail_md5);
#line 80 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (self->exif_md5);
#line 84 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (self->title);
#line 86 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (self->comment);
#line 87 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (self->backlinks);
#line 96 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 1348 "PhotoTable.c"
}


GType
photo_row_get_type (void)
{
	static volatile gsize photo_row_type_id__volatile = 0;
	if (g_once_init_enter (&photo_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_row_init, value_photo_row_free_value, value_photo_row_copy_value, value_photo_row_peek_pointer, "p", value_photo_row_collect_value, "p", value_photo_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoRow), 0, (GInstanceInitFunc) photo_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_row_type_id;
		photo_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_row_type_id__volatile, photo_row_type_id);
	}
	return photo_row_type_id__volatile;
}


gpointer
photo_row_ref (gpointer instance)
{
	PhotoRow * self;
	self = instance;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return instance;
#line 1377 "PhotoTable.c"
}


void
photo_row_unref (gpointer instance)
{
	PhotoRow * self;
	self = instance;
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		PHOTO_ROW_GET_CLASS (self)->finalize (self);
#line 70 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1392 "PhotoTable.c"
	}
}


static PhotoTable*
photo_table_construct (GType object_type)
{
	PhotoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* stmt2 = NULL;
	gint res2 = 0;
	sqlite3* _tmp7_;
	sqlite3_stmt* _tmp8_ = NULL;
	gint _tmp9_;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_;
	gint _tmp12_;
	sqlite3* _tmp14_;
	sqlite3_stmt* _tmp15_ = NULL;
	gint _tmp16_;
	gint _tmp17_;
	sqlite3_stmt* _tmp18_;
	gint _tmp19_;
	sqlite3* _tmp21_;
	sqlite3_stmt* _tmp22_ = NULL;
	gint _tmp23_;
	gint _tmp24_;
	sqlite3_stmt* _tmp25_;
	gint _tmp26_;
	sqlite3* _tmp28_;
	sqlite3_stmt* _tmp29_ = NULL;
	gint _tmp30_;
	gint _tmp31_;
	sqlite3_stmt* _tmp32_;
	gint _tmp33_;
	sqlite3* _tmp35_;
	sqlite3_stmt* _tmp36_ = NULL;
	gint _tmp37_;
	gint _tmp38_;
	sqlite3_stmt* _tmp39_;
	gint _tmp40_;
#line 115 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self = (PhotoTable*) database_table_construct (object_type);
#line 117 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 117 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS PhotoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "orientation INTEGER, " "original_orientation INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "transformations TEXT, " "md5 TEXT, " "thumbnail_md5 TEXT, " "exif_md5 TEXT, " "time_created INTEGER, " "flags INTEGER DEFAULT 0, " "rating INTEGER DEFAULT 0, " "file_format INTEGER DEFAULT 0, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "editable_id INTEGER DEFAULT -1, " "metadata_dirty INTEGER DEFAULT 0, " "developer TEXT, " "develop_shotwell_id INTEGER DEFAULT -1, " "develop_camera_id INTEGER DEFAULT -1, " "develop_embedded_id INTEGER DEFAULT -1, " "has_gps INTEGER DEFAULT -1, " "gps_lat REAL, " "gps_lon REAL, " "comment TEXT" ")", -1, &_tmp1_, NULL);
#line 117 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 117 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 117 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 151 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 151 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp4_);
#line 154 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = res;
#line 154 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp5_ != SQLITE_DONE) {
#line 1465 "PhotoTable.c"
		gint _tmp6_;
#line 155 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp6_ = res;
#line 155 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_fatal ("create photo table", _tmp6_);
#line 1471 "PhotoTable.c"
	}
#line 159 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = database_table_db;
#line 159 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = sqlite3_prepare_v2 (_tmp7_, "CREATE INDEX IF NOT EXISTS PhotoEventIDIndex ON PhotoTable (event_id)", -1, &_tmp8_, NULL);
#line 159 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 159 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt2 = _tmp8_;
#line 159 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res2 = _tmp9_;
#line 161 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = res2;
#line 161 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp10_ == SQLITE_OK, "res2 == Sqlite.OK");
#line 163 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = stmt2;
#line 163 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res2 = sqlite3_step (_tmp11_);
#line 164 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = res2;
#line 164 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp12_ != SQLITE_DONE) {
#line 1495 "PhotoTable.c"
		gint _tmp13_;
#line 165 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp13_ = res2;
#line 165 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_fatal ("create photo table", _tmp13_);
#line 1501 "PhotoTable.c"
	}
#line 171 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp14_ = database_table_db;
#line 171 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp16_ = sqlite3_prepare_v2 (_tmp14_, "DROP INDEX IF EXISTS PhotoTableMD5Format", -1, &_tmp15_, NULL);
#line 171 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 171 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp15_;
#line 171 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp16_;
#line 172 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp17_ = res;
#line 172 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp17_ == SQLITE_OK, "res == Sqlite.OK");
#line 173 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp18_ = stmt;
#line 173 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp18_);
#line 174 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_ = res;
#line 174 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp19_ != SQLITE_DONE) {
#line 1525 "PhotoTable.c"
		gint _tmp20_;
#line 175 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp20_ = res;
#line 175 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_warning ("Failed to drop old PhotoTable index", _tmp20_);
#line 1531 "PhotoTable.c"
	}
#line 178 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp21_ = database_table_db;
#line 178 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp23_ = sqlite3_prepare_v2 (_tmp21_, "CREATE INDEX IF NOT EXISTS PhotoTableMD5FormatV2 on PhotoTable(md5, fi" \
"le_format)", -1, &_tmp22_, NULL);
#line 178 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 178 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp22_;
#line 178 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp23_;
#line 179 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp24_ = res;
#line 179 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp24_ == SQLITE_OK, "res == Sqlite.OK");
#line 180 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp25_ = stmt;
#line 180 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp25_);
#line 181 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp26_ = res;
#line 181 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp26_ != SQLITE_DONE) {
#line 1555 "PhotoTable.c"
		gint _tmp27_;
#line 182 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp27_ = res;
#line 182 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_warning ("Failed to create index on md5 and file_format", _tmp27_);
#line 1561 "PhotoTable.c"
	}
#line 186 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_ = database_table_db;
#line 186 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp30_ = sqlite3_prepare_v2 (_tmp28_, "CREATE INDEX IF NOT EXISTS PhotoTableThumbnailMD5Format on PhotoTable(" \
"thumbnail_md5, file_format)", -1, &_tmp29_, NULL);
#line 186 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 186 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp29_;
#line 186 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp30_;
#line 187 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp31_ = res;
#line 187 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp31_ == SQLITE_OK, "res == Sqlite.OK");
#line 188 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp32_ = stmt;
#line 188 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp32_);
#line 189 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp33_ = res;
#line 189 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp33_ != SQLITE_DONE) {
#line 1585 "PhotoTable.c"
		gint _tmp34_;
#line 190 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp34_ = res;
#line 190 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_warning ("Failed to create index on md5 and file_format", _tmp34_);
#line 1591 "PhotoTable.c"
	}
#line 194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp35_ = database_table_db;
#line 194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp37_ = sqlite3_prepare_v2 (_tmp35_, "CREATE INDEX IF NOT EXISTS PhotoTableThumbnailMD5MD5 on PhotoTable(thu" \
"mbnail_md5, md5)", -1, &_tmp36_, NULL);
#line 194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp36_;
#line 194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp37_;
#line 195 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp38_ = res;
#line 195 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp38_ == SQLITE_OK, "res == Sqlite.OK");
#line 196 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp39_ = stmt;
#line 196 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp39_);
#line 197 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp40_ = res;
#line 197 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp40_ != SQLITE_DONE) {
#line 1615 "PhotoTable.c"
		gint _tmp41_;
#line 198 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp41_ = res;
#line 198 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_warning ("Failed to create index on thumbnail_md5 and md5", _tmp41_);
#line 1621 "PhotoTable.c"
	}
#line 201 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "PhotoTable");
#line 115 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 115 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 115 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return self;
#line 1631 "PhotoTable.c"
}


static PhotoTable*
photo_table_new (void)
{
#line 115 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return photo_table_construct (TYPE_PHOTO_TABLE);
#line 1640 "PhotoTable.c"
}


static gpointer
_database_table_ref0 (gpointer self)
{
#line 208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 1649 "PhotoTable.c"
}


PhotoTable*
photo_table_get_instance (void)
{
	PhotoTable* result = NULL;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp2_;
	PhotoTable* _tmp3_;
#line 205 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = photo_table_instance;
#line 205 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp0_ == NULL) {
#line 1664 "PhotoTable.c"
		PhotoTable* _tmp1_;
#line 206 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp1_ = photo_table_new ();
#line 206 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_database_table_unref0 (photo_table_instance);
#line 206 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		photo_table_instance = _tmp1_;
#line 1672 "PhotoTable.c"
	}
#line 208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = photo_table_instance;
#line 208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp3_;
#line 208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 1682 "PhotoTable.c"
}


void
photo_table_add (PhotoTable* self,
                 PhotoRow* photo_row,
                 PhotoID* result)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	gulong time_created = 0UL;
	sqlite3_stmt* _tmp4_;
	BackingPhotoRow* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GDestroyNotify _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_;
	BackingPhotoRow* _tmp11_;
	Dimensions _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	sqlite3_stmt* _tmp15_;
	BackingPhotoRow* _tmp16_;
	Dimensions _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	sqlite3_stmt* _tmp20_;
	BackingPhotoRow* _tmp21_;
	gint64 _tmp22_;
	gint _tmp23_;
	sqlite3_stmt* _tmp24_;
	BackingPhotoRow* _tmp25_;
	time_t _tmp26_;
	gint _tmp27_;
	sqlite3_stmt* _tmp28_;
	time_t _tmp29_;
	gint _tmp30_;
	sqlite3_stmt* _tmp31_;
	BackingPhotoRow* _tmp32_;
	Orientation _tmp33_;
	gint _tmp34_;
	sqlite3_stmt* _tmp35_;
	BackingPhotoRow* _tmp36_;
	Orientation _tmp37_;
	gint _tmp38_;
	sqlite3_stmt* _tmp39_;
	ImportID _tmp40_;
	gint64 _tmp41_;
	gint _tmp42_;
	sqlite3_stmt* _tmp43_;
	gint _tmp44_;
	sqlite3_stmt* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	GDestroyNotify _tmp48_;
	gint _tmp49_;
	sqlite3_stmt* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_;
	GDestroyNotify _tmp53_;
	gint _tmp54_;
	sqlite3_stmt* _tmp55_;
	const gchar* _tmp56_;
	gchar* _tmp57_;
	GDestroyNotify _tmp58_;
	gint _tmp59_;
	sqlite3_stmt* _tmp60_;
	gulong _tmp61_;
	gint _tmp62_;
	sqlite3_stmt* _tmp63_;
	BackingPhotoRow* _tmp64_;
	PhotoFileFormat _tmp65_;
	gint _tmp66_;
	sqlite3_stmt* _tmp67_;
	const gchar* _tmp68_;
	gchar* _tmp69_;
	GDestroyNotify _tmp70_;
	gint _tmp71_;
	sqlite3_stmt* _tmp72_;
	Rating _tmp73_;
	gint _tmp74_;
	sqlite3_stmt* _tmp75_;
	gint _tmp76_;
	sqlite3_stmt* _tmp77_;
	RawDeveloper _tmp78_;
	gchar* _tmp79_;
	GDestroyNotify _tmp80_;
	gint _tmp81_;
	sqlite3_stmt* _tmp82_;
	GpsCoords _tmp83_;
	gint _tmp84_;
	gint _tmp85_;
	sqlite3_stmt* _tmp86_;
	GpsCoords _tmp87_;
	gdouble _tmp88_;
	gint _tmp89_;
	sqlite3_stmt* _tmp90_;
	GpsCoords _tmp91_;
	gdouble _tmp92_;
	gint _tmp93_;
	sqlite3_stmt* _tmp94_;
	const gchar* _tmp95_;
	gchar* _tmp96_;
	GDestroyNotify _tmp97_;
	gint _tmp98_;
	sqlite3_stmt* _tmp99_;
	gint _tmp100_;
	sqlite3* _tmp104_;
	BackingPhotoRow* _tmp105_;
	Orientation _tmp106_;
	gulong _tmp107_;
	PhotoID _tmp108_;
#line 213 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 213 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (photo_row));
#line 215 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 215 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO PhotoTable (filename, width, height, filesize, timestamp, " \
"exposure_time, " "orientation, original_orientation, import_id, event_id, md5, thumbnail" \
"_md5, " "exif_md5, time_created, file_format, title, rating, editable_id, devel" \
"oper, has_gps, gps_lat, gps_lon, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?," \
" ?, ?)", -1, &_tmp1_, NULL);
#line 215 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 215 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 215 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 221 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 221 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 223 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	time_created = now_sec ();
#line 225 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 225 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = photo_row->master;
#line 225 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_->filepath;
#line 225 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 225 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = g_free;
#line 225 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp4_, 1, _tmp7_, -1, _tmp8_);
#line 226 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = res;
#line 226 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp9_ == SQLITE_OK, "res == Sqlite.OK");
#line 227 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 227 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = photo_row->master;
#line 227 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = _tmp11_->dim;
#line 227 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = _tmp12_.width;
#line 227 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp10_, 2, _tmp13_);
#line 228 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp14_ = res;
#line 228 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp14_ == SQLITE_OK, "res == Sqlite.OK");
#line 229 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_ = stmt;
#line 229 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp16_ = photo_row->master;
#line 229 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp17_ = _tmp16_->dim;
#line 229 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp18_ = _tmp17_.height;
#line 229 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp15_, 3, _tmp18_);
#line 230 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_ = res;
#line 230 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp19_ == SQLITE_OK, "res == Sqlite.OK");
#line 231 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp20_ = stmt;
#line 231 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp21_ = photo_row->master;
#line 231 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp22_ = _tmp21_->filesize;
#line 231 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp20_, 4, _tmp22_);
#line 232 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp23_ = res;
#line 232 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp23_ == SQLITE_OK, "res == Sqlite.OK");
#line 233 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp24_ = stmt;
#line 233 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp25_ = photo_row->master;
#line 233 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp26_ = _tmp25_->timestamp;
#line 233 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp24_, 5, (gint64) _tmp26_);
#line 234 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp27_ = res;
#line 234 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp27_ == SQLITE_OK, "res == Sqlite.OK");
#line 235 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_ = stmt;
#line 235 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp29_ = photo_row->exposure_time;
#line 235 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp28_, 6, (gint64) _tmp29_);
#line 236 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp30_ = res;
#line 236 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp30_ == SQLITE_OK, "res == Sqlite.OK");
#line 237 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp31_ = stmt;
#line 237 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp32_ = photo_row->master;
#line 237 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp33_ = _tmp32_->original_orientation;
#line 237 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp31_, 7, (gint) _tmp33_);
#line 238 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp34_ = res;
#line 238 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp34_ == SQLITE_OK, "res == Sqlite.OK");
#line 239 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp35_ = stmt;
#line 239 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp36_ = photo_row->master;
#line 239 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp37_ = _tmp36_->original_orientation;
#line 239 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp35_, 8, (gint) _tmp37_);
#line 240 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp38_ = res;
#line 240 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp38_ == SQLITE_OK, "res == Sqlite.OK");
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp39_ = stmt;
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp40_ = photo_row->import_id;
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp41_ = _tmp40_.id;
#line 241 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp39_, 9, _tmp41_);
#line 242 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp42_ = res;
#line 242 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp42_ == SQLITE_OK, "res == Sqlite.OK");
#line 243 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp43_ = stmt;
#line 243 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp43_, 10, EVENT_ID_INVALID);
#line 244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp44_ = res;
#line 244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp44_ == SQLITE_OK, "res == Sqlite.OK");
#line 245 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp45_ = stmt;
#line 245 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp46_ = photo_row->md5;
#line 245 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp47_ = g_strdup (_tmp46_);
#line 245 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp48_ = g_free;
#line 245 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp45_, 11, _tmp47_, -1, _tmp48_);
#line 246 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp49_ = res;
#line 246 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp49_ == SQLITE_OK, "res == Sqlite.OK");
#line 247 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp50_ = stmt;
#line 247 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp51_ = photo_row->thumbnail_md5;
#line 247 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp52_ = g_strdup (_tmp51_);
#line 247 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp53_ = g_free;
#line 247 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp50_, 12, _tmp52_, -1, _tmp53_);
#line 248 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp54_ = res;
#line 248 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp54_ == SQLITE_OK, "res == Sqlite.OK");
#line 249 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp55_ = stmt;
#line 249 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp56_ = photo_row->exif_md5;
#line 249 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp57_ = g_strdup (_tmp56_);
#line 249 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp58_ = g_free;
#line 249 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp55_, 13, _tmp57_, -1, _tmp58_);
#line 250 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp59_ = res;
#line 250 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp59_ == SQLITE_OK, "res == Sqlite.OK");
#line 251 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp60_ = stmt;
#line 251 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp61_ = time_created;
#line 251 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp60_, 14, (gint64) _tmp61_);
#line 252 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp62_ = res;
#line 252 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp62_ == SQLITE_OK, "res == Sqlite.OK");
#line 253 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp63_ = stmt;
#line 253 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp64_ = photo_row->master;
#line 253 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp65_ = _tmp64_->file_format;
#line 253 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp63_, 15, photo_file_format_serialize (_tmp65_));
#line 254 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp66_ = res;
#line 254 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp66_ == SQLITE_OK, "res == Sqlite.OK");
#line 255 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp67_ = stmt;
#line 255 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp68_ = photo_row->title;
#line 255 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp69_ = g_strdup (_tmp68_);
#line 255 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp70_ = g_free;
#line 255 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp67_, 16, _tmp69_, -1, _tmp70_);
#line 256 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp71_ = res;
#line 256 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp71_ == SQLITE_OK, "res == Sqlite.OK");
#line 257 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp72_ = stmt;
#line 257 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp73_ = photo_row->rating;
#line 257 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp72_, 17, (gint64) rating_serialize (_tmp73_));
#line 258 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp74_ = res;
#line 258 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp74_ == SQLITE_OK, "res == Sqlite.OK");
#line 259 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp75_ = stmt;
#line 259 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp75_, 18, BACKING_PHOTO_ID_INVALID);
#line 260 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp76_ = res;
#line 260 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp76_ == SQLITE_OK, "res == Sqlite.OK");
#line 261 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp77_ = stmt;
#line 261 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp78_ = photo_row->developer;
#line 261 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp79_ = raw_developer_to_string (_tmp78_);
#line 261 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp80_ = g_free;
#line 261 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp77_, 19, _tmp79_, -1, _tmp80_);
#line 262 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp81_ = res;
#line 262 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp81_ == SQLITE_OK, "res == Sqlite.OK");
#line 263 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp82_ = stmt;
#line 263 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp83_ = photo_row->gps_coords;
#line 263 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp84_ = _tmp83_.has_gps;
#line 263 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp82_, 20, _tmp84_);
#line 264 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp85_ = res;
#line 264 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp85_ == SQLITE_OK, "res == Sqlite.OK");
#line 265 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp86_ = stmt;
#line 265 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp87_ = photo_row->gps_coords;
#line 265 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp88_ = _tmp87_.latitude;
#line 265 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp86_, 21, _tmp88_);
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp89_ = res;
#line 266 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp89_ == SQLITE_OK, "res == Sqlite.OK");
#line 267 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp90_ = stmt;
#line 267 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp91_ = photo_row->gps_coords;
#line 267 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp92_ = _tmp91_.longitude;
#line 267 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp90_, 22, _tmp92_);
#line 268 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp93_ = res;
#line 268 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp93_ == SQLITE_OK, "res == Sqlite.OK");
#line 269 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp94_ = stmt;
#line 269 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp95_ = photo_row->comment;
#line 269 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp96_ = g_strdup (_tmp95_);
#line 269 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp97_ = g_free;
#line 269 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp94_, 23, _tmp96_, -1, _tmp97_);
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp98_ = res;
#line 270 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp98_ == SQLITE_OK, "res == Sqlite.OK");
#line 272 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp99_ = stmt;
#line 272 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp99_);
#line 273 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp100_ = res;
#line 273 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp100_ != SQLITE_DONE) {
#line 2110 "PhotoTable.c"
		gint _tmp101_;
		PhotoID _tmp103_ = {0};
#line 274 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp101_ = res;
#line 274 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_tmp101_ != SQLITE_CONSTRAINT) {
#line 2117 "PhotoTable.c"
			gint _tmp102_;
#line 275 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp102_ = res;
#line 275 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			database_table_fatal ("add_photo", _tmp102_);
#line 2123 "PhotoTable.c"
		}
#line 277 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		photo_id_init (&_tmp103_, PHOTO_ID_INVALID);
#line 277 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*result = _tmp103_;
#line 277 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 277 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return;
#line 2133 "PhotoTable.c"
	}
#line 281 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp104_ = database_table_db;
#line 281 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	photo_id_init (&photo_row->photo_id, sqlite3_last_insert_rowid (_tmp104_));
#line 282 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp105_ = photo_row->master;
#line 282 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp106_ = _tmp105_->original_orientation;
#line 282 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	photo_row->orientation = _tmp106_;
#line 283 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	event_id_init (&photo_row->event_id, EVENT_ID_INVALID);
#line 284 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp107_ = time_created;
#line 284 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	photo_row->time_created = (time_t) _tmp107_;
#line 285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	photo_row->flags = (guint64) 0;
#line 287 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp108_ = photo_row->photo_id;
#line 287 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	*result = _tmp108_;
#line 287 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 287 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return;
#line 2161 "PhotoTable.c"
}


void
photo_table_reimport (PhotoTable* self,
                      PhotoRow* row,
                      GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	time_t time_reimported = 0;
	sqlite3_stmt* _tmp4_;
	BackingPhotoRow* _tmp5_;
	Dimensions _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	sqlite3_stmt* _tmp9_;
	BackingPhotoRow* _tmp10_;
	Dimensions _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	sqlite3_stmt* _tmp14_;
	BackingPhotoRow* _tmp15_;
	gint64 _tmp16_;
	gint _tmp17_;
	sqlite3_stmt* _tmp18_;
	BackingPhotoRow* _tmp19_;
	time_t _tmp20_;
	gint _tmp21_;
	sqlite3_stmt* _tmp22_;
	time_t _tmp23_;
	gint _tmp24_;
	sqlite3_stmt* _tmp25_;
	BackingPhotoRow* _tmp26_;
	Orientation _tmp27_;
	gint _tmp28_;
	sqlite3_stmt* _tmp29_;
	BackingPhotoRow* _tmp30_;
	Orientation _tmp31_;
	gint _tmp32_;
	sqlite3_stmt* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	GDestroyNotify _tmp36_;
	gint _tmp37_;
	sqlite3_stmt* _tmp38_;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	GDestroyNotify _tmp41_;
	gint _tmp42_;
	sqlite3_stmt* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	GDestroyNotify _tmp46_;
	gint _tmp47_;
	sqlite3_stmt* _tmp48_;
	BackingPhotoRow* _tmp49_;
	PhotoFileFormat _tmp50_;
	gint _tmp51_;
	sqlite3_stmt* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	GDestroyNotify _tmp55_;
	gint _tmp56_;
	sqlite3_stmt* _tmp57_;
	GpsCoords _tmp58_;
	gint _tmp59_;
	gint _tmp60_;
	sqlite3_stmt* _tmp61_;
	GpsCoords _tmp62_;
	gdouble _tmp63_;
	gint _tmp64_;
	sqlite3_stmt* _tmp65_;
	GpsCoords _tmp66_;
	gdouble _tmp67_;
	gint _tmp68_;
	sqlite3_stmt* _tmp69_;
	time_t _tmp70_;
	gint _tmp71_;
	sqlite3_stmt* _tmp72_;
	PhotoID _tmp73_;
	gint64 _tmp74_;
	gint _tmp75_;
	sqlite3_stmt* _tmp76_;
	gint _tmp77_;
	time_t _tmp79_;
	BackingPhotoRow* _tmp80_;
	Orientation _tmp81_;
	GError* _inner_error0_ = NULL;
#line 295 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 295 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET width = ?, height = ?, filesize = ?, timestamp =" \
" ?, " "exposure_time = ?, orientation = ?, original_orientation = ?, md5 = ?," \
" " "exif_md5 = ?, thumbnail_md5 = ?, file_format = ?, title = ?, " "has_gps = ?, gps_lat = ?, gps_lon = ?, time_reimported = ? " "WHERE id = ?", -1, &_tmp1_, NULL);
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 297 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 305 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	time_reimported = (time_t) now_sec ();
#line 307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = row->master;
#line 307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_->dim;
#line 307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = _tmp6_.width;
#line 307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp4_, 1, _tmp7_);
#line 308 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = res;
#line 308 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp8_ == SQLITE_OK, "res == Sqlite.OK");
#line 309 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 309 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = row->master;
#line 309 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = _tmp10_->dim;
#line 309 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = _tmp11_.height;
#line 309 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp9_, 2, _tmp12_);
#line 310 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = res;
#line 310 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp13_ == SQLITE_OK, "res == Sqlite.OK");
#line 311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_ = row->master;
#line 311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp16_ = _tmp15_->filesize;
#line 311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp14_, 3, _tmp16_);
#line 312 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp17_ = res;
#line 312 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp17_ == SQLITE_OK, "res == Sqlite.OK");
#line 313 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp18_ = stmt;
#line 313 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_ = row->master;
#line 313 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp20_ = _tmp19_->timestamp;
#line 313 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp18_, 4, (gint64) _tmp20_);
#line 314 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp21_ = res;
#line 314 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp21_ == SQLITE_OK, "res == Sqlite.OK");
#line 315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp22_ = stmt;
#line 315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp23_ = row->exposure_time;
#line 315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp22_, 5, (gint64) _tmp23_);
#line 316 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp24_ = res;
#line 316 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp24_ == SQLITE_OK, "res == Sqlite.OK");
#line 317 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp25_ = stmt;
#line 317 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp26_ = row->master;
#line 317 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp27_ = _tmp26_->original_orientation;
#line 317 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp25_, 6, (gint) _tmp27_);
#line 318 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_ = res;
#line 318 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp28_ == SQLITE_OK, "res == Sqlite.OK");
#line 319 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp29_ = stmt;
#line 319 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp30_ = row->master;
#line 319 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp31_ = _tmp30_->original_orientation;
#line 319 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp29_, 7, (gint) _tmp31_);
#line 320 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp32_ = res;
#line 320 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp32_ == SQLITE_OK, "res == Sqlite.OK");
#line 321 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp33_ = stmt;
#line 321 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp34_ = row->md5;
#line 321 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp35_ = g_strdup (_tmp34_);
#line 321 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp36_ = g_free;
#line 321 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp33_, 8, _tmp35_, -1, _tmp36_);
#line 322 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp37_ = res;
#line 322 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp37_ == SQLITE_OK, "res == Sqlite.OK");
#line 323 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp38_ = stmt;
#line 323 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp39_ = row->exif_md5;
#line 323 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp40_ = g_strdup (_tmp39_);
#line 323 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp41_ = g_free;
#line 323 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp38_, 9, _tmp40_, -1, _tmp41_);
#line 324 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp42_ = res;
#line 324 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp42_ == SQLITE_OK, "res == Sqlite.OK");
#line 325 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp43_ = stmt;
#line 325 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp44_ = row->thumbnail_md5;
#line 325 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp45_ = g_strdup (_tmp44_);
#line 325 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp46_ = g_free;
#line 325 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp43_, 10, _tmp45_, -1, _tmp46_);
#line 326 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp47_ = res;
#line 326 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp47_ == SQLITE_OK, "res == Sqlite.OK");
#line 327 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp48_ = stmt;
#line 327 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp49_ = row->master;
#line 327 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp50_ = _tmp49_->file_format;
#line 327 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp48_, 11, photo_file_format_serialize (_tmp50_));
#line 328 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp51_ = res;
#line 328 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp51_ == SQLITE_OK, "res == Sqlite.OK");
#line 329 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp52_ = stmt;
#line 329 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp53_ = row->title;
#line 329 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp54_ = g_strdup (_tmp53_);
#line 329 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp55_ = g_free;
#line 329 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp52_, 12, _tmp54_, -1, _tmp55_);
#line 330 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp56_ = res;
#line 330 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp56_ == SQLITE_OK, "res == Sqlite.OK");
#line 331 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp57_ = stmt;
#line 331 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp58_ = row->gps_coords;
#line 331 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp59_ = _tmp58_.has_gps;
#line 331 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp57_, 13, _tmp59_);
#line 332 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp60_ = res;
#line 332 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp60_ == SQLITE_OK, "res == Sqlite.OK");
#line 333 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp61_ = stmt;
#line 333 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp62_ = row->gps_coords;
#line 333 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp63_ = _tmp62_.latitude;
#line 333 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp61_, 14, _tmp63_);
#line 334 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp64_ = res;
#line 334 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp64_ == SQLITE_OK, "res == Sqlite.OK");
#line 335 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp65_ = stmt;
#line 335 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp66_ = row->gps_coords;
#line 335 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp67_ = _tmp66_.longitude;
#line 335 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp65_, 15, _tmp67_);
#line 336 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp68_ = res;
#line 336 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp68_ == SQLITE_OK, "res == Sqlite.OK");
#line 337 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp69_ = stmt;
#line 337 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp70_ = time_reimported;
#line 337 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp69_, 16, (gint64) _tmp70_);
#line 338 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp71_ = res;
#line 338 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp71_ == SQLITE_OK, "res == Sqlite.OK");
#line 339 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp72_ = stmt;
#line 339 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp73_ = row->photo_id;
#line 339 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp74_ = _tmp73_.id;
#line 339 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp72_, 17, _tmp74_);
#line 340 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp75_ = res;
#line 340 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp75_ == SQLITE_OK, "res == Sqlite.OK");
#line 342 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp76_ = stmt;
#line 342 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp76_);
#line 343 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp77_ = res;
#line 343 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp77_ != SQLITE_DONE) {
#line 2495 "PhotoTable.c"
		gint _tmp78_;
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp78_ = res;
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_throw_error ("PhotoTable.reimport_master", _tmp78_, &_inner_error0_);
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 2511 "PhotoTable.c"
			} else {
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 344 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 2521 "PhotoTable.c"
			}
		}
	}
#line 346 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp79_ = time_reimported;
#line 346 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	row->time_reimported = _tmp79_;
#line 347 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp80_ = row->master;
#line 347 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp81_ = _tmp80_->original_orientation;
#line 347 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	row->orientation = _tmp81_;
#line 295 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2537 "PhotoTable.c"
}


gboolean
photo_table_master_exif_updated (PhotoTable* self,
                                 PhotoID* photoID,
                                 gint64 filesize,
                                 glong timestamp,
                                 const gchar* md5,
                                 const gchar* exif_md5,
                                 const gchar* thumbnail_md5,
                                 PhotoRow* row)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	gchar* _tmp9_;
	GDestroyNotify _tmp10_;
	gint _tmp11_;
	sqlite3_stmt* _tmp12_;
	gchar* _tmp13_;
	GDestroyNotify _tmp14_;
	gint _tmp15_;
	sqlite3_stmt* _tmp16_;
	gchar* _tmp17_;
	GDestroyNotify _tmp18_;
	gint _tmp19_;
	sqlite3_stmt* _tmp20_;
	PhotoID _tmp21_;
	gint64 _tmp22_;
	gint _tmp23_;
	sqlite3_stmt* _tmp24_;
	gint _tmp25_;
	BackingPhotoRow* _tmp28_;
	BackingPhotoRow* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
#line 350 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 350 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photoID != NULL, FALSE);
#line 350 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (md5 != NULL, FALSE);
#line 350 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), FALSE);
#line 353 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 353 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET filesize = ?, timestamp = ?, md5 = ?, exif_md5 =" \
" ?," "thumbnail_md5 =? WHERE id = ?", -1, &_tmp1_, NULL);
#line 353 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 353 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 353 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 356 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 356 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 358 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 358 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, filesize);
#line 359 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = res;
#line 359 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp5_ == SQLITE_OK, "res == Sqlite.OK");
#line 360 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 360 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 2, (gint64) timestamp);
#line 361 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = res;
#line 361 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 362 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 362 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = g_strdup (md5);
#line 362 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = g_free;
#line 362 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp8_, 3, _tmp9_, -1, _tmp10_);
#line 363 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = res;
#line 363 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp11_ == SQLITE_OK, "res == Sqlite.OK");
#line 364 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 364 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = g_strdup (exif_md5);
#line 364 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp14_ = g_free;
#line 364 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp12_, 4, _tmp13_, -1, _tmp14_);
#line 365 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_ = res;
#line 365 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp15_ == SQLITE_OK, "res == Sqlite.OK");
#line 366 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 366 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp17_ = g_strdup (thumbnail_md5);
#line 366 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp18_ = g_free;
#line 366 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp16_, 5, _tmp17_, -1, _tmp18_);
#line 367 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_ = res;
#line 367 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp19_ == SQLITE_OK, "res == Sqlite.OK");
#line 368 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp20_ = stmt;
#line 368 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp21_ = *photoID;
#line 368 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp22_ = _tmp21_.id;
#line 368 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp20_, 6, _tmp22_);
#line 369 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp23_ = res;
#line 369 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp23_ == SQLITE_OK, "res == Sqlite.OK");
#line 371 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp24_ = stmt;
#line 371 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp24_);
#line 372 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp25_ = res;
#line 372 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp25_ != SQLITE_DONE) {
#line 2679 "PhotoTable.c"
		gint _tmp26_;
#line 373 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp26_ = res;
#line 373 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_tmp26_ != SQLITE_CONSTRAINT) {
#line 2685 "PhotoTable.c"
			gint _tmp27_;
#line 374 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp27_ = res;
#line 374 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			database_table_fatal ("write_update_photo", _tmp27_);
#line 2691 "PhotoTable.c"
		}
#line 376 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = FALSE;
#line 376 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 376 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 2699 "PhotoTable.c"
	}
#line 379 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_ = row->master;
#line 379 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_->filesize = filesize;
#line 380 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp29_ = row->master;
#line 380 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp29_->timestamp = (time_t) timestamp;
#line 381 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp30_ = g_strdup (md5);
#line 381 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (row->md5);
#line 381 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	row->md5 = _tmp30_;
#line 382 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp31_ = g_strdup (exif_md5);
#line 382 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (row->exif_md5);
#line 382 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	row->exif_md5 = _tmp31_;
#line 383 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp32_ = g_strdup (thumbnail_md5);
#line 383 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (row->thumbnail_md5);
#line 383 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	row->thumbnail_md5 = _tmp32_;
#line 385 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = TRUE;
#line 385 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 385 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 2733 "PhotoTable.c"
}


static void
photo_table_validate_orientation (PhotoTable* self,
                                  PhotoRow* row)
{
	gboolean _tmp0_ = FALSE;
	Orientation _tmp1_;
#line 396 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 396 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 397 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = row->orientation;
#line 397 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp1_ < ORIENTATION_MIN) {
#line 397 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 2753 "PhotoTable.c"
	} else {
		Orientation _tmp2_;
#line 398 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp2_ = row->orientation;
#line 398 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = _tmp2_ > ORIENTATION_MAX;
#line 2760 "PhotoTable.c"
	}
#line 397 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 2764 "PhotoTable.c"
		PhotoID _tmp3_;
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp3_ = row->photo_id;
#line 400 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		photo_table_set_orientation (self, &_tmp3_, ORIENTATION_MIN);
#line 401 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		row->orientation = ORIENTATION_MIN;
#line 2772 "PhotoTable.c"
	}
}


PhotoRow*
photo_table_get_row (PhotoTable* self,
                     PhotoID* photo_id)
{
	PhotoRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	PhotoID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	PhotoRow* row = NULL;
	PhotoRow* _tmp9_;
	PhotoRow* _tmp10_;
	PhotoID _tmp11_;
	PhotoRow* _tmp12_;
	BackingPhotoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	PhotoRow* _tmp17_;
	BackingPhotoRow* _tmp18_;
	sqlite3_stmt* _tmp19_;
	sqlite3_stmt* _tmp20_;
	PhotoRow* _tmp21_;
	BackingPhotoRow* _tmp22_;
	sqlite3_stmt* _tmp23_;
	PhotoRow* _tmp24_;
	BackingPhotoRow* _tmp25_;
	sqlite3_stmt* _tmp26_;
	PhotoRow* _tmp27_;
	sqlite3_stmt* _tmp28_;
	PhotoRow* _tmp29_;
	sqlite3_stmt* _tmp30_;
	PhotoRow* _tmp31_;
	BackingPhotoRow* _tmp32_;
	sqlite3_stmt* _tmp33_;
	PhotoRow* _tmp34_;
	sqlite3_stmt* _tmp35_;
	PhotoRow* _tmp36_;
	sqlite3_stmt* _tmp37_;
	PhotoRow* _tmp38_;
	sqlite3_stmt* _tmp39_;
	const gchar* _tmp40_;
	GeeHashMap* _tmp41_;
	PhotoRow* _tmp42_;
	sqlite3_stmt* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	PhotoRow* _tmp46_;
	sqlite3_stmt* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	PhotoRow* _tmp50_;
	sqlite3_stmt* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	PhotoRow* _tmp54_;
	sqlite3_stmt* _tmp55_;
	PhotoRow* _tmp56_;
	sqlite3_stmt* _tmp57_;
	PhotoRow* _tmp58_;
	sqlite3_stmt* _tmp59_;
	PhotoRow* _tmp60_;
	BackingPhotoRow* _tmp61_;
	sqlite3_stmt* _tmp62_;
	PhotoRow* _tmp63_;
	sqlite3_stmt* _tmp64_;
	const gchar* _tmp65_;
	gchar* _tmp66_;
	PhotoRow* _tmp67_;
	sqlite3_stmt* _tmp68_;
	const gchar* _tmp69_;
	gchar* _tmp70_;
	PhotoRow* _tmp71_;
	sqlite3_stmt* _tmp72_;
	PhotoRow* _tmp73_;
	sqlite3_stmt* _tmp74_;
	PhotoRow* _tmp75_;
	sqlite3_stmt* _tmp76_;
	RawDeveloper _tmp77_ = 0;
	sqlite3_stmt* _tmp78_;
	const gchar* _tmp79_;
	PhotoRow* _tmp82_;
	PhotoRow* _tmp83_;
	BackingPhotoID* _tmp84_;
	gint _tmp84__length1;
	sqlite3_stmt* _tmp85_;
	BackingPhotoID _tmp86_ = {0};
	PhotoRow* _tmp87_;
	BackingPhotoID* _tmp88_;
	gint _tmp88__length1;
	sqlite3_stmt* _tmp89_;
	BackingPhotoID _tmp90_ = {0};
	PhotoRow* _tmp91_;
	BackingPhotoID* _tmp92_;
	gint _tmp92__length1;
	sqlite3_stmt* _tmp93_;
	BackingPhotoID _tmp94_ = {0};
	PhotoRow* _tmp95_;
	sqlite3_stmt* _tmp96_;
	PhotoRow* _tmp97_;
	sqlite3_stmt* _tmp98_;
	PhotoRow* _tmp99_;
	sqlite3_stmt* _tmp100_;
	PhotoRow* _tmp101_;
	sqlite3_stmt* _tmp102_;
	const gchar* _tmp103_;
	gchar* _tmp104_;
#line 405 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 405 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 407 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 407 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT filename, width, height, filesize, timestamp, exposure_time, or" \
"ientation, " "original_orientation, import_id, event_id, transformations, md5, thumb" \
"nail_md5, " "exif_md5, time_created, flags, rating, file_format, title, backlinks, " "time_reimported, editable_id, metadata_dirty, developer, develop_shotw" \
"ell_id, " "develop_camera_id, develop_embedded_id, has_gps, gps_lat, gps_lon, com" \
"ment " "FROM PhotoTable WHERE id=?", -1, &_tmp1_, NULL);
#line 407 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 407 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 407 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 415 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 415 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 417 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 417 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = *photo_id;
#line 417 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_.id;
#line 417 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 418 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = res;
#line 418 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 420 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 420 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (sqlite3_step (_tmp8_) != SQLITE_ROW) {
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = NULL;
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 421 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 2931 "PhotoTable.c"
	}
#line 423 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = photo_row_new ();
#line 423 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	row = _tmp9_;
#line 424 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = row;
#line 424 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = *photo_id;
#line 424 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_->photo_id = _tmp11_;
#line 425 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = row;
#line 425 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = _tmp12_->master;
#line 425 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 425 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_ = (const gchar*) sqlite3_column_text (_tmp14_, 0);
#line 425 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 425 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (_tmp13_->filepath);
#line 425 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_->filepath = _tmp16_;
#line 426 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp17_ = row;
#line 426 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp18_ = _tmp17_->master;
#line 426 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 426 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp20_ = stmt;
#line 426 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	dimensions_init (&_tmp18_->dim, sqlite3_column_int (_tmp19_, 1), sqlite3_column_int (_tmp20_, 2));
#line 427 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp21_ = row;
#line 427 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp22_ = _tmp21_->master;
#line 427 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 427 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp22_->filesize = sqlite3_column_int64 (_tmp23_, 3);
#line 428 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp24_ = row;
#line 428 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp25_ = _tmp24_->master;
#line 428 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp26_ = stmt;
#line 428 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp25_->timestamp = (time_t) sqlite3_column_int64 (_tmp26_, 4);
#line 429 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp27_ = row;
#line 429 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_ = stmt;
#line 429 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp27_->exposure_time = (time_t) sqlite3_column_int64 (_tmp28_, 5);
#line 430 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp29_ = row;
#line 430 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp30_ = stmt;
#line 430 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp29_->orientation = (Orientation) sqlite3_column_int (_tmp30_, 6);
#line 431 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp31_ = row;
#line 431 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp32_ = _tmp31_->master;
#line 431 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp33_ = stmt;
#line 431 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp32_->original_orientation = (Orientation) sqlite3_column_int (_tmp33_, 7);
#line 432 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp34_ = row;
#line 432 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp35_ = stmt;
#line 432 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp34_->import_id.id = sqlite3_column_int64 (_tmp35_, 8);
#line 433 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp36_ = row;
#line 433 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp37_ = stmt;
#line 433 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp36_->event_id.id = sqlite3_column_int64 (_tmp37_, 9);
#line 434 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp38_ = row;
#line 434 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp39_ = stmt;
#line 434 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp40_ = (const gchar*) sqlite3_column_text (_tmp39_, 10);
#line 434 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp41_ = photo_table_marshall_all_transformations (_tmp40_);
#line 434 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_object_unref0 (_tmp38_->transformations);
#line 434 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp38_->transformations = _tmp41_;
#line 435 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp42_ = row;
#line 435 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp43_ = stmt;
#line 435 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp44_ = (const gchar*) sqlite3_column_text (_tmp43_, 11);
#line 435 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp45_ = g_strdup (_tmp44_);
#line 435 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (_tmp42_->md5);
#line 435 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp42_->md5 = _tmp45_;
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp46_ = row;
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp47_ = stmt;
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp48_ = (const gchar*) sqlite3_column_text (_tmp47_, 12);
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp49_ = g_strdup (_tmp48_);
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (_tmp46_->thumbnail_md5);
#line 436 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp46_->thumbnail_md5 = _tmp49_;
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp50_ = row;
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp51_ = stmt;
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp52_ = (const gchar*) sqlite3_column_text (_tmp51_, 13);
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp53_ = g_strdup (_tmp52_);
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (_tmp50_->exif_md5);
#line 437 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp50_->exif_md5 = _tmp53_;
#line 438 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp54_ = row;
#line 438 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp55_ = stmt;
#line 438 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp54_->time_created = (time_t) sqlite3_column_int64 (_tmp55_, 14);
#line 439 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp56_ = row;
#line 439 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp57_ = stmt;
#line 439 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp56_->flags = (guint64) sqlite3_column_int64 (_tmp57_, 15);
#line 440 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp58_ = row;
#line 440 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp59_ = stmt;
#line 440 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp58_->rating = rating_unserialize (sqlite3_column_int (_tmp59_, 16));
#line 441 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp60_ = row;
#line 441 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp61_ = _tmp60_->master;
#line 441 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp62_ = stmt;
#line 441 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp61_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp62_, 17));
#line 442 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp63_ = row;
#line 442 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp64_ = stmt;
#line 442 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp65_ = (const gchar*) sqlite3_column_text (_tmp64_, 18);
#line 442 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp66_ = g_strdup (_tmp65_);
#line 442 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (_tmp63_->title);
#line 442 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp63_->title = _tmp66_;
#line 443 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp67_ = row;
#line 443 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp68_ = stmt;
#line 443 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp69_ = (const gchar*) sqlite3_column_text (_tmp68_, 19);
#line 443 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp70_ = g_strdup (_tmp69_);
#line 443 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (_tmp67_->backlinks);
#line 443 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp67_->backlinks = _tmp70_;
#line 444 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp71_ = row;
#line 444 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp72_ = stmt;
#line 444 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp71_->time_reimported = (time_t) sqlite3_column_int64 (_tmp72_, 20);
#line 445 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp73_ = row;
#line 445 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp74_ = stmt;
#line 445 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp73_->editable_id, sqlite3_column_int64 (_tmp74_, 21));
#line 446 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp75_ = row;
#line 446 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp76_ = stmt;
#line 446 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp75_->metadata_dirty = sqlite3_column_int (_tmp76_, 22) != 0;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp78_ = stmt;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp79_ = (const gchar*) sqlite3_column_text (_tmp78_, 23);
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp79_ != NULL) {
#line 3137 "PhotoTable.c"
		sqlite3_stmt* _tmp80_;
		const gchar* _tmp81_;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp80_ = stmt;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp81_ = (const gchar*) sqlite3_column_text (_tmp80_, 23);
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp77_ = raw_developer_from_string (_tmp81_);
#line 3146 "PhotoTable.c"
	} else {
#line 448 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp77_ = RAW_DEVELOPER_CAMERA;
#line 3150 "PhotoTable.c"
	}
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp82_ = row;
#line 447 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp82_->developer = _tmp77_;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp83_ = row;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp84_ = _tmp83_->development_ids;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp84__length1 = _tmp83_->development_ids_length1;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp85_ = stmt;
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp86_, sqlite3_column_int64 (_tmp85_, 24));
#line 449 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp84_[RAW_DEVELOPER_SHOTWELL] = _tmp86_;
#line 450 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp87_ = row;
#line 450 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp88_ = _tmp87_->development_ids;
#line 450 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp88__length1 = _tmp87_->development_ids_length1;
#line 450 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp89_ = stmt;
#line 450 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp90_, sqlite3_column_int64 (_tmp89_, 25));
#line 450 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp88_[RAW_DEVELOPER_CAMERA] = _tmp90_;
#line 451 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp91_ = row;
#line 451 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp92_ = _tmp91_->development_ids;
#line 451 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp92__length1 = _tmp91_->development_ids_length1;
#line 451 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp93_ = stmt;
#line 451 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp94_, sqlite3_column_int64 (_tmp93_, 26));
#line 451 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp92_[RAW_DEVELOPER_EMBEDDED] = _tmp94_;
#line 452 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp95_ = row;
#line 452 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp96_ = stmt;
#line 452 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp95_->gps_coords.has_gps = sqlite3_column_int (_tmp96_, 27);
#line 453 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp97_ = row;
#line 453 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp98_ = stmt;
#line 453 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp97_->gps_coords.latitude = sqlite3_column_double (_tmp98_, 28);
#line 454 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp99_ = row;
#line 454 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp100_ = stmt;
#line 454 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp99_->gps_coords.longitude = sqlite3_column_double (_tmp100_, 29);
#line 455 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp101_ = row;
#line 455 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp102_ = stmt;
#line 455 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp103_ = (const gchar*) sqlite3_column_text (_tmp102_, 30);
#line 455 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp104_ = g_strdup (_tmp103_);
#line 455 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (_tmp101_->comment);
#line 455 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp101_->comment = _tmp104_;
#line 457 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = row;
#line 457 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 457 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 3228 "PhotoTable.c"
}


GeeArrayList*
photo_table_get_all (PhotoTable* self)
{
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	GeeArrayList* all = NULL;
	GeeArrayList* _tmp4_;
#line 460 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 462 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 462 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, filename, width, height, filesize, timestamp, exposure_time" \
", orientation, " "original_orientation, import_id, event_id, transformations, md5, thumb" \
"nail_md5, " "exif_md5, time_created, flags, rating, file_format, title, backlinks, " \
"time_reimported, " "editable_id, metadata_dirty, developer, develop_shotwell_id, develop_c" \
"amera_id, " "develop_embedded_id, has_gps, gps_lat, gps_lon, comment FROM PhotoTabl" \
"e", -1, &_tmp1_, NULL);
#line 462 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 462 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 462 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 469 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 469 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 471 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = gee_array_list_new (TYPE_PHOTO_ROW, (GBoxedCopyFunc) photo_row_ref, (GDestroyNotify) photo_row_unref, NULL, NULL, NULL);
#line 471 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	all = _tmp4_;
#line 473 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	while (TRUE) {
#line 3266 "PhotoTable.c"
		sqlite3_stmt* _tmp5_;
		gint _tmp6_;
		PhotoRow* row = NULL;
		PhotoRow* _tmp7_;
		PhotoRow* _tmp8_;
		sqlite3_stmt* _tmp9_;
		PhotoRow* _tmp10_;
		BackingPhotoRow* _tmp11_;
		sqlite3_stmt* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		PhotoRow* _tmp15_;
		BackingPhotoRow* _tmp16_;
		sqlite3_stmt* _tmp17_;
		sqlite3_stmt* _tmp18_;
		PhotoRow* _tmp19_;
		BackingPhotoRow* _tmp20_;
		sqlite3_stmt* _tmp21_;
		PhotoRow* _tmp22_;
		BackingPhotoRow* _tmp23_;
		sqlite3_stmt* _tmp24_;
		PhotoRow* _tmp25_;
		sqlite3_stmt* _tmp26_;
		PhotoRow* _tmp27_;
		sqlite3_stmt* _tmp28_;
		PhotoRow* _tmp29_;
		BackingPhotoRow* _tmp30_;
		sqlite3_stmt* _tmp31_;
		PhotoRow* _tmp32_;
		sqlite3_stmt* _tmp33_;
		PhotoRow* _tmp34_;
		sqlite3_stmt* _tmp35_;
		PhotoRow* _tmp36_;
		sqlite3_stmt* _tmp37_;
		const gchar* _tmp38_;
		GeeHashMap* _tmp39_;
		PhotoRow* _tmp40_;
		sqlite3_stmt* _tmp41_;
		const gchar* _tmp42_;
		gchar* _tmp43_;
		PhotoRow* _tmp44_;
		sqlite3_stmt* _tmp45_;
		const gchar* _tmp46_;
		gchar* _tmp47_;
		PhotoRow* _tmp48_;
		sqlite3_stmt* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		PhotoRow* _tmp52_;
		sqlite3_stmt* _tmp53_;
		PhotoRow* _tmp54_;
		sqlite3_stmt* _tmp55_;
		PhotoRow* _tmp56_;
		sqlite3_stmt* _tmp57_;
		PhotoRow* _tmp58_;
		BackingPhotoRow* _tmp59_;
		sqlite3_stmt* _tmp60_;
		PhotoRow* _tmp61_;
		sqlite3_stmt* _tmp62_;
		const gchar* _tmp63_;
		gchar* _tmp64_;
		PhotoRow* _tmp65_;
		sqlite3_stmt* _tmp66_;
		const gchar* _tmp67_;
		gchar* _tmp68_;
		PhotoRow* _tmp69_;
		sqlite3_stmt* _tmp70_;
		PhotoRow* _tmp71_;
		sqlite3_stmt* _tmp72_;
		PhotoRow* _tmp73_;
		sqlite3_stmt* _tmp74_;
		RawDeveloper _tmp75_ = 0;
		sqlite3_stmt* _tmp76_;
		const gchar* _tmp77_;
		PhotoRow* _tmp80_;
		PhotoRow* _tmp81_;
		BackingPhotoID* _tmp82_;
		gint _tmp82__length1;
		sqlite3_stmt* _tmp83_;
		BackingPhotoID _tmp84_ = {0};
		PhotoRow* _tmp85_;
		BackingPhotoID* _tmp86_;
		gint _tmp86__length1;
		sqlite3_stmt* _tmp87_;
		BackingPhotoID _tmp88_ = {0};
		PhotoRow* _tmp89_;
		BackingPhotoID* _tmp90_;
		gint _tmp90__length1;
		sqlite3_stmt* _tmp91_;
		BackingPhotoID _tmp92_ = {0};
		PhotoRow* _tmp93_;
		sqlite3_stmt* _tmp94_;
		PhotoRow* _tmp95_;
		sqlite3_stmt* _tmp96_;
		PhotoRow* _tmp97_;
		sqlite3_stmt* _tmp98_;
		PhotoRow* _tmp99_;
		sqlite3_stmt* _tmp100_;
		const gchar* _tmp101_;
		gchar* _tmp102_;
		PhotoRow* _tmp103_;
		GeeArrayList* _tmp104_;
		PhotoRow* _tmp105_;
#line 473 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp5_ = stmt;
#line 473 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		res = sqlite3_step (_tmp5_);
#line 473 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp6_ = res;
#line 473 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (!(_tmp6_ == SQLITE_ROW)) {
#line 473 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			break;
#line 3380 "PhotoTable.c"
		}
#line 474 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp7_ = photo_row_new ();
#line 474 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		row = _tmp7_;
#line 475 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp8_ = row;
#line 475 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp9_ = stmt;
#line 475 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp8_->photo_id.id = sqlite3_column_int64 (_tmp9_, 0);
#line 476 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp10_ = row;
#line 476 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp11_ = _tmp10_->master;
#line 476 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp12_ = stmt;
#line 476 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp13_ = (const gchar*) sqlite3_column_text (_tmp12_, 1);
#line 476 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 476 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (_tmp11_->filepath);
#line 476 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp11_->filepath = _tmp14_;
#line 477 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp15_ = row;
#line 477 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp16_ = _tmp15_->master;
#line 477 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp17_ = stmt;
#line 477 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp18_ = stmt;
#line 477 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		dimensions_init (&_tmp16_->dim, sqlite3_column_int (_tmp17_, 2), sqlite3_column_int (_tmp18_, 3));
#line 478 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp19_ = row;
#line 478 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp20_ = _tmp19_->master;
#line 478 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp21_ = stmt;
#line 478 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp20_->filesize = sqlite3_column_int64 (_tmp21_, 4);
#line 479 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp22_ = row;
#line 479 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp23_ = _tmp22_->master;
#line 479 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp24_ = stmt;
#line 479 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp23_->timestamp = (time_t) sqlite3_column_int64 (_tmp24_, 5);
#line 480 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp25_ = row;
#line 480 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp26_ = stmt;
#line 480 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp25_->exposure_time = (time_t) sqlite3_column_int64 (_tmp26_, 6);
#line 481 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp27_ = row;
#line 481 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp28_ = stmt;
#line 481 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp27_->orientation = (Orientation) sqlite3_column_int (_tmp28_, 7);
#line 482 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp29_ = row;
#line 482 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp30_ = _tmp29_->master;
#line 482 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp31_ = stmt;
#line 482 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp30_->original_orientation = (Orientation) sqlite3_column_int (_tmp31_, 8);
#line 483 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp32_ = row;
#line 483 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp33_ = stmt;
#line 483 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp32_->import_id.id = sqlite3_column_int64 (_tmp33_, 9);
#line 484 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp34_ = row;
#line 484 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp35_ = stmt;
#line 484 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp34_->event_id.id = sqlite3_column_int64 (_tmp35_, 10);
#line 485 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp36_ = row;
#line 485 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp37_ = stmt;
#line 485 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp38_ = (const gchar*) sqlite3_column_text (_tmp37_, 11);
#line 485 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp39_ = photo_table_marshall_all_transformations (_tmp38_);
#line 485 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp36_->transformations);
#line 485 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp36_->transformations = _tmp39_;
#line 486 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp40_ = row;
#line 486 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp41_ = stmt;
#line 486 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp42_ = (const gchar*) sqlite3_column_text (_tmp41_, 12);
#line 486 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp43_ = g_strdup (_tmp42_);
#line 486 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (_tmp40_->md5);
#line 486 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp40_->md5 = _tmp43_;
#line 487 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp44_ = row;
#line 487 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp45_ = stmt;
#line 487 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp46_ = (const gchar*) sqlite3_column_text (_tmp45_, 13);
#line 487 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp47_ = g_strdup (_tmp46_);
#line 487 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (_tmp44_->thumbnail_md5);
#line 487 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp44_->thumbnail_md5 = _tmp47_;
#line 488 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp48_ = row;
#line 488 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp49_ = stmt;
#line 488 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp50_ = (const gchar*) sqlite3_column_text (_tmp49_, 14);
#line 488 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp51_ = g_strdup (_tmp50_);
#line 488 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (_tmp48_->exif_md5);
#line 488 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp48_->exif_md5 = _tmp51_;
#line 489 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp52_ = row;
#line 489 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp53_ = stmt;
#line 489 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp52_->time_created = (time_t) sqlite3_column_int64 (_tmp53_, 15);
#line 490 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp54_ = row;
#line 490 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp55_ = stmt;
#line 490 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp54_->flags = (guint64) sqlite3_column_int64 (_tmp55_, 16);
#line 491 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp56_ = row;
#line 491 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp57_ = stmt;
#line 491 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp56_->rating = rating_unserialize (sqlite3_column_int (_tmp57_, 17));
#line 492 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp58_ = row;
#line 492 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp59_ = _tmp58_->master;
#line 492 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp60_ = stmt;
#line 492 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp59_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp60_, 18));
#line 493 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp61_ = row;
#line 493 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp62_ = stmt;
#line 493 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp63_ = (const gchar*) sqlite3_column_text (_tmp62_, 19);
#line 493 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp64_ = g_strdup (_tmp63_);
#line 493 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (_tmp61_->title);
#line 493 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp61_->title = _tmp64_;
#line 494 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp65_ = row;
#line 494 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp66_ = stmt;
#line 494 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp67_ = (const gchar*) sqlite3_column_text (_tmp66_, 20);
#line 494 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp68_ = g_strdup (_tmp67_);
#line 494 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (_tmp65_->backlinks);
#line 494 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp65_->backlinks = _tmp68_;
#line 495 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp69_ = row;
#line 495 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp70_ = stmt;
#line 495 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp69_->time_reimported = (time_t) sqlite3_column_int64 (_tmp70_, 21);
#line 496 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp71_ = row;
#line 496 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp72_ = stmt;
#line 496 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp71_->editable_id, sqlite3_column_int64 (_tmp72_, 22));
#line 497 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp73_ = row;
#line 497 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp74_ = stmt;
#line 497 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp73_->metadata_dirty = sqlite3_column_int (_tmp74_, 23) != 0;
#line 498 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp76_ = stmt;
#line 498 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp77_ = (const gchar*) sqlite3_column_text (_tmp76_, 24);
#line 498 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_tmp77_ != NULL) {
#line 3586 "PhotoTable.c"
			sqlite3_stmt* _tmp78_;
			const gchar* _tmp79_;
#line 498 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp78_ = stmt;
#line 498 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp79_ = (const gchar*) sqlite3_column_text (_tmp78_, 24);
#line 498 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp75_ = raw_developer_from_string (_tmp79_);
#line 3595 "PhotoTable.c"
		} else {
#line 499 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp75_ = RAW_DEVELOPER_CAMERA;
#line 3599 "PhotoTable.c"
		}
#line 498 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp80_ = row;
#line 498 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp80_->developer = _tmp75_;
#line 500 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp81_ = row;
#line 500 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp82_ = _tmp81_->development_ids;
#line 500 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp82__length1 = _tmp81_->development_ids_length1;
#line 500 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp83_ = stmt;
#line 500 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp84_, sqlite3_column_int64 (_tmp83_, 25));
#line 500 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp82_[RAW_DEVELOPER_SHOTWELL] = _tmp84_;
#line 501 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp85_ = row;
#line 501 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp86_ = _tmp85_->development_ids;
#line 501 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp86__length1 = _tmp85_->development_ids_length1;
#line 501 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp87_ = stmt;
#line 501 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp88_, sqlite3_column_int64 (_tmp87_, 26));
#line 501 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp86_[RAW_DEVELOPER_CAMERA] = _tmp88_;
#line 502 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp89_ = row;
#line 502 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp90_ = _tmp89_->development_ids;
#line 502 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp90__length1 = _tmp89_->development_ids_length1;
#line 502 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp91_ = stmt;
#line 502 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp92_, sqlite3_column_int64 (_tmp91_, 27));
#line 502 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp90_[RAW_DEVELOPER_EMBEDDED] = _tmp92_;
#line 503 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp93_ = row;
#line 503 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp94_ = stmt;
#line 503 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp93_->gps_coords.has_gps = sqlite3_column_int (_tmp94_, 28);
#line 504 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp95_ = row;
#line 504 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp96_ = stmt;
#line 504 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp95_->gps_coords.latitude = sqlite3_column_double (_tmp96_, 29);
#line 505 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp97_ = row;
#line 505 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp98_ = stmt;
#line 505 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp97_->gps_coords.longitude = sqlite3_column_double (_tmp98_, 30);
#line 506 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp99_ = row;
#line 506 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp100_ = stmt;
#line 506 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp101_ = (const gchar*) sqlite3_column_text (_tmp100_, 31);
#line 506 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp102_ = g_strdup (_tmp101_);
#line 506 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (_tmp99_->comment);
#line 506 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp99_->comment = _tmp102_;
#line 508 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp103_ = row;
#line 508 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		photo_table_validate_orientation (self, _tmp103_);
#line 510 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp104_ = all;
#line 510 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp105_ = row;
#line 510 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp104_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp105_);
#line 473 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_photo_row_unref0 (row);
#line 3683 "PhotoTable.c"
	}
#line 513 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = all;
#line 513 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 513 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 3691 "PhotoTable.c"
}


void
photo_table_duplicate (PhotoTable* self,
                       PhotoID* photo_id,
                       const gchar* new_filename,
                       BackingPhotoID* editable_id,
                       BackingPhotoID* develop_shotwell,
                       BackingPhotoID* develop_camera_id,
                       BackingPhotoID* develop_embedded_id,
                       PhotoID* result)
{
	PhotoRow* original = NULL;
	PhotoID _tmp0_;
	PhotoRow* _tmp1_;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	gchar* _tmp7_;
	GDestroyNotify _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_;
	PhotoRow* _tmp11_;
	BackingPhotoRow* _tmp12_;
	Dimensions _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	sqlite3_stmt* _tmp16_;
	PhotoRow* _tmp17_;
	BackingPhotoRow* _tmp18_;
	Dimensions _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	sqlite3_stmt* _tmp22_;
	PhotoRow* _tmp23_;
	BackingPhotoRow* _tmp24_;
	gint64 _tmp25_;
	gint _tmp26_;
	sqlite3_stmt* _tmp27_;
	PhotoRow* _tmp28_;
	BackingPhotoRow* _tmp29_;
	time_t _tmp30_;
	gint _tmp31_;
	sqlite3_stmt* _tmp32_;
	PhotoRow* _tmp33_;
	time_t _tmp34_;
	gint _tmp35_;
	sqlite3_stmt* _tmp36_;
	PhotoRow* _tmp37_;
	Orientation _tmp38_;
	gint _tmp39_;
	sqlite3_stmt* _tmp40_;
	PhotoRow* _tmp41_;
	BackingPhotoRow* _tmp42_;
	Orientation _tmp43_;
	gint _tmp44_;
	sqlite3_stmt* _tmp45_;
	PhotoRow* _tmp46_;
	ImportID _tmp47_;
	gint64 _tmp48_;
	gint _tmp49_;
	sqlite3_stmt* _tmp50_;
	PhotoRow* _tmp51_;
	EventID _tmp52_;
	gint64 _tmp53_;
	gint _tmp54_;
	sqlite3_stmt* _tmp55_;
	PhotoRow* _tmp56_;
	GeeHashMap* _tmp57_;
	gchar* _tmp58_;
	GDestroyNotify _tmp59_;
	gint _tmp60_;
	sqlite3_stmt* _tmp61_;
	PhotoRow* _tmp62_;
	const gchar* _tmp63_;
	gchar* _tmp64_;
	GDestroyNotify _tmp65_;
	gint _tmp66_;
	sqlite3_stmt* _tmp67_;
	PhotoRow* _tmp68_;
	const gchar* _tmp69_;
	gchar* _tmp70_;
	GDestroyNotify _tmp71_;
	gint _tmp72_;
	sqlite3_stmt* _tmp73_;
	PhotoRow* _tmp74_;
	const gchar* _tmp75_;
	gchar* _tmp76_;
	GDestroyNotify _tmp77_;
	gint _tmp78_;
	sqlite3_stmt* _tmp79_;
	gint _tmp80_;
	sqlite3_stmt* _tmp81_;
	PhotoRow* _tmp82_;
	guint64 _tmp83_;
	gint _tmp84_;
	sqlite3_stmt* _tmp85_;
	PhotoRow* _tmp86_;
	Rating _tmp87_;
	gint _tmp88_;
	sqlite3_stmt* _tmp89_;
	PhotoRow* _tmp90_;
	BackingPhotoRow* _tmp91_;
	PhotoFileFormat _tmp92_;
	gint _tmp93_;
	sqlite3_stmt* _tmp94_;
	PhotoRow* _tmp95_;
	const gchar* _tmp96_;
	gchar* _tmp97_;
	GDestroyNotify _tmp98_;
	gint _tmp99_;
	sqlite3_stmt* _tmp100_;
	PhotoRow* _tmp101_;
	GpsCoords _tmp102_;
	gint _tmp103_;
	gint _tmp104_;
	sqlite3_stmt* _tmp105_;
	PhotoRow* _tmp106_;
	GpsCoords _tmp107_;
	gdouble _tmp108_;
	gint _tmp109_;
	sqlite3_stmt* _tmp110_;
	PhotoRow* _tmp111_;
	GpsCoords _tmp112_;
	gdouble _tmp113_;
	gint _tmp114_;
	sqlite3_stmt* _tmp115_;
	BackingPhotoID _tmp116_;
	gint64 _tmp117_;
	gint _tmp118_;
	sqlite3_stmt* _tmp119_;
	PhotoRow* _tmp120_;
	RawDeveloper _tmp121_;
	gchar* _tmp122_;
	GDestroyNotify _tmp123_;
	gint _tmp124_;
	sqlite3_stmt* _tmp125_;
	BackingPhotoID _tmp126_;
	gint64 _tmp127_;
	gint _tmp128_;
	sqlite3_stmt* _tmp129_;
	BackingPhotoID _tmp130_;
	gint64 _tmp131_;
	gint _tmp132_;
	sqlite3_stmt* _tmp133_;
	BackingPhotoID _tmp134_;
	gint64 _tmp135_;
	gint _tmp136_;
	sqlite3_stmt* _tmp137_;
	PhotoRow* _tmp138_;
	const gchar* _tmp139_;
	gchar* _tmp140_;
	GDestroyNotify _tmp141_;
	gint _tmp142_;
	sqlite3_stmt* _tmp143_;
	gint _tmp144_;
	sqlite3* _tmp148_;
	PhotoID _tmp149_ = {0};
#line 518 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 518 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 518 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (new_filename != NULL);
#line 518 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (editable_id != NULL);
#line 518 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (develop_shotwell != NULL);
#line 518 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (develop_camera_id != NULL);
#line 518 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (develop_embedded_id != NULL);
#line 522 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 522 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_row (self, &_tmp0_);
#line 522 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	original = _tmp1_;
#line 525 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = database_table_db;
#line 525 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp2_, "INSERT INTO PhotoTable (filename, width, height, filesize, " "timestamp, exposure_time, orientation, original_orientation, import_id" \
", event_id, " "transformations, md5, thumbnail_md5, exif_md5, time_created, flags, ra" \
"ting, " "file_format, title, has_gps, gps_lat, gps_lon, editable_id, developer," \
" " "develop_shotwell_id, develop_camera_id, develop_embedded_id, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?," \
" ?, ?, ?, ?, ?, ?, ?)", -1, &_tmp3_, NULL);
#line 525 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 525 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp3_;
#line 525 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp4_;
#line 532 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = res;
#line 532 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp5_ == SQLITE_OK, "res == Sqlite.OK");
#line 534 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 534 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = g_strdup (new_filename);
#line 534 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = g_free;
#line 534 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp6_, 1, _tmp7_, -1, _tmp8_);
#line 535 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = res;
#line 535 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp9_ == SQLITE_OK, "res == Sqlite.OK");
#line 536 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 536 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = original;
#line 536 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = _tmp11_->master;
#line 536 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = _tmp12_->dim;
#line 536 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp14_ = _tmp13_.width;
#line 536 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp10_, 2, _tmp14_);
#line 537 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_ = res;
#line 537 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp15_ == SQLITE_OK, "res == Sqlite.OK");
#line 538 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 538 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp17_ = original;
#line 538 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp18_ = _tmp17_->master;
#line 538 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_ = _tmp18_->dim;
#line 538 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp20_ = _tmp19_.height;
#line 538 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp16_, 3, _tmp20_);
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp21_ = res;
#line 539 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp21_ == SQLITE_OK, "res == Sqlite.OK");
#line 540 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp22_ = stmt;
#line 540 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp23_ = original;
#line 540 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp24_ = _tmp23_->master;
#line 540 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp25_ = _tmp24_->filesize;
#line 540 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp22_, 4, _tmp25_);
#line 541 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp26_ = res;
#line 541 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp26_ == SQLITE_OK, "res == Sqlite.OK");
#line 542 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp27_ = stmt;
#line 542 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_ = original;
#line 542 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp29_ = _tmp28_->master;
#line 542 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp30_ = _tmp29_->timestamp;
#line 542 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp27_, 5, (gint64) _tmp30_);
#line 543 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp31_ = res;
#line 543 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp31_ == SQLITE_OK, "res == Sqlite.OK");
#line 544 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp32_ = stmt;
#line 544 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp33_ = original;
#line 544 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp34_ = _tmp33_->exposure_time;
#line 544 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp32_, 6, (gint64) _tmp34_);
#line 545 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp35_ = res;
#line 545 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp35_ == SQLITE_OK, "res == Sqlite.OK");
#line 546 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp36_ = stmt;
#line 546 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp37_ = original;
#line 546 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp38_ = _tmp37_->orientation;
#line 546 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp36_, 7, (gint) _tmp38_);
#line 547 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp39_ = res;
#line 547 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp39_ == SQLITE_OK, "res == Sqlite.OK");
#line 548 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp40_ = stmt;
#line 548 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp41_ = original;
#line 548 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp42_ = _tmp41_->master;
#line 548 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp43_ = _tmp42_->original_orientation;
#line 548 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp40_, 8, (gint) _tmp43_);
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp44_ = res;
#line 549 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp44_ == SQLITE_OK, "res == Sqlite.OK");
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp45_ = stmt;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp46_ = original;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp47_ = _tmp46_->import_id;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp48_ = _tmp47_.id;
#line 550 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp45_, 9, _tmp48_);
#line 551 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp49_ = res;
#line 551 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp49_ == SQLITE_OK, "res == Sqlite.OK");
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp50_ = stmt;
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp51_ = original;
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp52_ = _tmp51_->event_id;
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp53_ = _tmp52_.id;
#line 552 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp50_, 10, _tmp53_);
#line 553 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp54_ = res;
#line 553 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp54_ == SQLITE_OK, "res == Sqlite.OK");
#line 554 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp55_ = stmt;
#line 554 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp56_ = original;
#line 554 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp57_ = _tmp56_->transformations;
#line 554 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp58_ = photo_table_unmarshall_all_transformations (_tmp57_);
#line 554 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp59_ = g_free;
#line 554 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp55_, 11, _tmp58_, -1, _tmp59_);
#line 555 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp60_ = res;
#line 555 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp60_ == SQLITE_OK, "res == Sqlite.OK");
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp61_ = stmt;
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp62_ = original;
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp63_ = _tmp62_->md5;
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp64_ = g_strdup (_tmp63_);
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp65_ = g_free;
#line 556 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp61_, 12, _tmp64_, -1, _tmp65_);
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp66_ = res;
#line 557 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp66_ == SQLITE_OK, "res == Sqlite.OK");
#line 558 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp67_ = stmt;
#line 558 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp68_ = original;
#line 558 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp69_ = _tmp68_->thumbnail_md5;
#line 558 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp70_ = g_strdup (_tmp69_);
#line 558 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp71_ = g_free;
#line 558 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp67_, 13, _tmp70_, -1, _tmp71_);
#line 559 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp72_ = res;
#line 559 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp72_ == SQLITE_OK, "res == Sqlite.OK");
#line 560 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp73_ = stmt;
#line 560 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp74_ = original;
#line 560 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp75_ = _tmp74_->exif_md5;
#line 560 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp76_ = g_strdup (_tmp75_);
#line 560 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp77_ = g_free;
#line 560 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp73_, 14, _tmp76_, -1, _tmp77_);
#line 561 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp78_ = res;
#line 561 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp78_ == SQLITE_OK, "res == Sqlite.OK");
#line 562 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp79_ = stmt;
#line 562 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp79_, 15, (gint64) now_sec ());
#line 563 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp80_ = res;
#line 563 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp80_ == SQLITE_OK, "res == Sqlite.OK");
#line 564 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp81_ = stmt;
#line 564 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp82_ = original;
#line 564 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp83_ = _tmp82_->flags;
#line 564 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp81_, 16, (gint64) _tmp83_);
#line 565 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp84_ = res;
#line 565 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp84_ == SQLITE_OK, "res == Sqlite.OK");
#line 566 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp85_ = stmt;
#line 566 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp86_ = original;
#line 566 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp87_ = _tmp86_->rating;
#line 566 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp85_, 17, (gint64) rating_serialize (_tmp87_));
#line 567 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp88_ = res;
#line 567 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp88_ == SQLITE_OK, "res == Sqlite.OK");
#line 568 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp89_ = stmt;
#line 568 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp90_ = original;
#line 568 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp91_ = _tmp90_->master;
#line 568 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp92_ = _tmp91_->file_format;
#line 568 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp89_, 18, photo_file_format_serialize (_tmp92_));
#line 569 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp93_ = res;
#line 569 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp93_ == SQLITE_OK, "res == Sqlite.OK");
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp94_ = stmt;
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp95_ = original;
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp96_ = _tmp95_->title;
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp97_ = g_strdup (_tmp96_);
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp98_ = g_free;
#line 570 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp94_, 19, _tmp97_, -1, _tmp98_);
#line 571 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp99_ = res;
#line 571 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp99_ == SQLITE_OK, "res == Sqlite.OK");
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp100_ = stmt;
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp101_ = original;
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp102_ = _tmp101_->gps_coords;
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp103_ = _tmp102_.has_gps;
#line 572 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp100_, 20, _tmp103_);
#line 573 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp104_ = res;
#line 573 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp104_ == SQLITE_OK, "res == Sqlite.OK");
#line 574 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp105_ = stmt;
#line 574 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp106_ = original;
#line 574 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp107_ = _tmp106_->gps_coords;
#line 574 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp108_ = _tmp107_.latitude;
#line 574 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp105_, 21, _tmp108_);
#line 575 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp109_ = res;
#line 575 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp109_ == SQLITE_OK, "res == Sqlite.OK");
#line 576 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp110_ = stmt;
#line 576 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp111_ = original;
#line 576 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp112_ = _tmp111_->gps_coords;
#line 576 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp113_ = _tmp112_.longitude;
#line 576 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp110_, 22, _tmp113_);
#line 577 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp114_ = res;
#line 577 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp114_ == SQLITE_OK, "res == Sqlite.OK");
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp115_ = stmt;
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp116_ = *editable_id;
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp117_ = _tmp116_.id;
#line 578 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp115_, 23, _tmp117_);
#line 579 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp118_ = res;
#line 579 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp118_ == SQLITE_OK, "res == Sqlite.OK");
#line 580 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp119_ = stmt;
#line 580 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp120_ = original;
#line 580 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp121_ = _tmp120_->developer;
#line 580 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp122_ = raw_developer_to_string (_tmp121_);
#line 580 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp123_ = g_free;
#line 580 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp119_, 24, _tmp122_, -1, _tmp123_);
#line 581 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp124_ = res;
#line 581 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp124_ == SQLITE_OK, "res == Sqlite.OK");
#line 582 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp125_ = stmt;
#line 582 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp126_ = *develop_shotwell;
#line 582 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp127_ = _tmp126_.id;
#line 582 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp125_, 25, _tmp127_);
#line 583 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp128_ = res;
#line 583 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp128_ == SQLITE_OK, "res == Sqlite.OK");
#line 584 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp129_ = stmt;
#line 584 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp130_ = *develop_camera_id;
#line 584 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp131_ = _tmp130_.id;
#line 584 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp129_, 26, _tmp131_);
#line 585 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp132_ = res;
#line 585 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp132_ == SQLITE_OK, "res == Sqlite.OK");
#line 586 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp133_ = stmt;
#line 586 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp134_ = *develop_embedded_id;
#line 586 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp135_ = _tmp134_.id;
#line 586 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp133_, 27, _tmp135_);
#line 587 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp136_ = res;
#line 587 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp136_ == SQLITE_OK, "res == Sqlite.OK");
#line 588 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp137_ = stmt;
#line 588 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp138_ = original;
#line 588 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp139_ = _tmp138_->comment;
#line 588 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp140_ = g_strdup (_tmp139_);
#line 588 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp141_ = g_free;
#line 588 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp137_, 28, _tmp140_, -1, _tmp141_);
#line 589 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp142_ = res;
#line 589 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp142_ == SQLITE_OK, "res == Sqlite.OK");
#line 591 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp143_ = stmt;
#line 591 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp143_);
#line 592 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp144_ = res;
#line 592 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp144_ != SQLITE_DONE) {
#line 4283 "PhotoTable.c"
		gint _tmp145_;
		PhotoID _tmp147_ = {0};
#line 593 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp145_ = res;
#line 593 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_tmp145_ != SQLITE_CONSTRAINT) {
#line 4290 "PhotoTable.c"
			gint _tmp146_;
#line 594 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp146_ = res;
#line 594 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			database_table_fatal ("duplicate", _tmp146_);
#line 4296 "PhotoTable.c"
		}
#line 596 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		photo_id_init (&_tmp147_, PHOTO_ID_INVALID);
#line 596 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*result = _tmp147_;
#line 596 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 596 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_photo_row_unref0 (original);
#line 596 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return;
#line 4308 "PhotoTable.c"
	}
#line 599 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp148_ = database_table_db;
#line 599 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	photo_id_init (&_tmp149_, sqlite3_last_insert_rowid (_tmp148_));
#line 599 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	*result = _tmp149_;
#line 599 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 599 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_photo_row_unref0 (original);
#line 599 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return;
#line 4322 "PhotoTable.c"
}


gboolean
photo_table_set_title (PhotoTable* self,
                       PhotoID* photo_id,
                       const gchar* new_title)
{
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	gint64 _tmp2_;
#line 602 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 602 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 603 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (new_title != NULL) {
#line 603 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = new_title;
#line 4343 "PhotoTable.c"
	} else {
#line 603 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 4347 "PhotoTable.c"
	}
#line 603 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 603 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = _tmp1_.id;
#line 603 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp2_, "title", _tmp0_);
#line 603 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 4357 "PhotoTable.c"
}


void
photo_table_set_gps_coords (PhotoTable* self,
                            PhotoID* photo_id,
                            GpsCoords* new_gps_coords,
                            GError** error)
{
	PhotoID _tmp0_;
	gint64 _tmp1_;
	GpsCoords _tmp2_;
	gint _tmp3_;
	GpsCoords _tmp4_;
	gint _tmp5_;
	GError* _inner_error0_ = NULL;
#line 606 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 606 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 606 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (new_gps_coords != NULL);
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = *new_gps_coords;
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_.has_gps;
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_int_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "has_gps", _tmp3_, &_inner_error0_);
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 4398 "PhotoTable.c"
		} else {
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 607 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 4406 "PhotoTable.c"
		}
	}
#line 608 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = *new_gps_coords;
#line 608 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = _tmp4_.has_gps;
#line 608 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp5_ > 0) {
#line 4415 "PhotoTable.c"
		PhotoID _tmp6_;
		gint64 _tmp7_;
		GpsCoords _tmp8_;
		gdouble _tmp9_;
		PhotoID _tmp10_;
		gint64 _tmp11_;
		GpsCoords _tmp12_;
		gdouble _tmp13_;
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp6_ = *photo_id;
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp7_ = _tmp6_.id;
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp8_ = *new_gps_coords;
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_.latitude;
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_update_double_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp7_, "gps_lat", _tmp9_, &_inner_error0_);
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 4442 "PhotoTable.c"
			} else {
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 609 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 4450 "PhotoTable.c"
			}
		}
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp10_ = *photo_id;
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp11_ = _tmp10_.id;
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp12_ = *new_gps_coords;
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp13_ = _tmp12_.longitude;
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_update_double_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp11_, "gps_lon", _tmp13_, &_inner_error0_);
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 4471 "PhotoTable.c"
			} else {
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 610 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 4479 "PhotoTable.c"
			}
		}
	}
}


gboolean
photo_table_set_comment (PhotoTable* self,
                         PhotoID* photo_id,
                         const gchar* new_comment)
{
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	gint64 _tmp2_;
#line 614 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 614 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 615 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (new_comment != NULL) {
#line 615 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = new_comment;
#line 4503 "PhotoTable.c"
	} else {
#line 615 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 4507 "PhotoTable.c"
	}
#line 615 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 615 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = _tmp1_.id;
#line 615 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp2_, "comment", _tmp0_);
#line 615 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 4517 "PhotoTable.c"
}


void
photo_table_set_filepath (PhotoTable* self,
                          PhotoID* photo_id,
                          const gchar* filepath,
                          GError** error)
{
	PhotoID _tmp0_;
	gint64 _tmp1_;
	GError* _inner_error0_ = NULL;
#line 618 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 618 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 618 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 619 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 619 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 619 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "filename", filepath, &_inner_error0_);
#line 619 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 619 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 619 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 619 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 4550 "PhotoTable.c"
		} else {
#line 619 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 619 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 619 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 4558 "PhotoTable.c"
		}
	}
}


void
photo_table_update_timestamp (PhotoTable* self,
                              PhotoID* photo_id,
                              time_t timestamp,
                              GError** error)
{
	PhotoID _tmp0_;
	gint64 _tmp1_;
	GError* _inner_error0_ = NULL;
#line 622 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 622 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 623 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 623 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 623 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "timestamp", (gint64) timestamp, &_inner_error0_);
#line 623 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 623 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 623 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 623 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 4591 "PhotoTable.c"
		} else {
#line 623 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 623 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 623 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 4599 "PhotoTable.c"
		}
	}
}


gboolean
photo_table_set_exposure_time (PhotoTable* self,
                               PhotoID* photo_id,
                               time_t time)
{
	gboolean result = FALSE;
	PhotoID _tmp0_;
	gint64 _tmp1_;
#line 626 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 626 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 627 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 627 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 627 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "exposure_time", (gint64) time);
#line 627 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 4625 "PhotoTable.c"
}


void
photo_table_set_import_id (PhotoTable* self,
                           PhotoID* photo_id,
                           ImportID* import_id,
                           GError** error)
{
	PhotoID _tmp0_;
	gint64 _tmp1_;
	ImportID _tmp2_;
	gint64 _tmp3_;
	GError* _inner_error0_ = NULL;
#line 630 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 630 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 630 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (import_id != NULL);
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = *import_id;
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "import_id", _tmp3_, &_inner_error0_);
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 4664 "PhotoTable.c"
		} else {
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 631 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 4672 "PhotoTable.c"
		}
	}
}


gboolean
photo_table_remove_by_file (PhotoTable* self,
                            GFile* file)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	gint _tmp9_;
#line 634 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 634 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 636 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 636 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "DELETE FROM PhotoTable WHERE filename=?", -1, &_tmp1_, NULL);
#line 636 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 636 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 636 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 637 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 637 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 639 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 639 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = g_file_get_path (file);
#line 639 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = g_free;
#line 639 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp4_, 1, _tmp5_, -1, _tmp6_);
#line 640 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = res;
#line 640 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 642 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 642 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp8_);
#line 643 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = res;
#line 643 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp9_ != SQLITE_DONE) {
#line 4733 "PhotoTable.c"
		gint _tmp10_;
#line 644 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp10_ = res;
#line 644 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_warning ("remove", _tmp10_);
#line 646 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = FALSE;
#line 646 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 646 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 4745 "PhotoTable.c"
	}
#line 649 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = TRUE;
#line 649 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 649 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 4753 "PhotoTable.c"
}


void
photo_table_remove (PhotoTable* self,
                    PhotoID* photo_id,
                    GError** error)
{
	PhotoID _tmp0_;
	gint64 _tmp1_;
	GError* _inner_error0_ = NULL;
#line 652 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 652 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, &_inner_error0_);
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 4783 "PhotoTable.c"
		} else {
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 653 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 4791 "PhotoTable.c"
		}
	}
}


GeeArrayList*
photo_table_get_photos (PhotoTable* self)
{
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	GeeArrayList* photo_ids = NULL;
	GeeArrayList* _tmp4_;
#line 656 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 658 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 658 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable", -1, &_tmp1_, NULL);
#line 658 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 658 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 658 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 659 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 659 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 661 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = gee_array_list_new (TYPE_PHOTO_ID, (GBoxedCopyFunc) photo_id_dup, (GDestroyNotify) photo_id_free, NULL, NULL, NULL);
#line 661 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	photo_ids = _tmp4_;
#line 4829 "PhotoTable.c"
	{
		gboolean _tmp5_ = FALSE;
#line 662 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp5_ = TRUE;
#line 662 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		while (TRUE) {
#line 4836 "PhotoTable.c"
			sqlite3_stmt* _tmp6_;
			gint _tmp7_;
			GeeArrayList* _tmp10_;
			sqlite3_stmt* _tmp11_;
			PhotoID _tmp12_ = {0};
#line 662 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (!_tmp5_) {
#line 4844 "PhotoTable.c"
			}
#line 662 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp5_ = FALSE;
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp6_ = stmt;
#line 663 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp6_);
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp7_ = res;
#line 664 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (_tmp7_ == SQLITE_DONE) {
#line 665 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				break;
#line 4858 "PhotoTable.c"
			} else {
				gint _tmp8_;
#line 666 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp8_ = res;
#line 666 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				if (_tmp8_ != SQLITE_ROW) {
#line 4865 "PhotoTable.c"
					gint _tmp9_;
#line 667 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp9_ = res;
#line 667 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					database_table_fatal ("get_photos", _tmp9_);
#line 669 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					break;
#line 4873 "PhotoTable.c"
				}
			}
#line 672 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp10_ = photo_ids;
#line 672 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp11_ = stmt;
#line 672 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			photo_id_init (&_tmp12_, sqlite3_column_int64 (_tmp11_, 0));
#line 672 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp12_);
#line 4884 "PhotoTable.c"
		}
	}
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = photo_ids;
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 675 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 4893 "PhotoTable.c"
}


gboolean
photo_table_set_orientation (PhotoTable* self,
                             PhotoID* photo_id,
                             Orientation orientation)
{
	gboolean result = FALSE;
	PhotoID _tmp0_;
	gint64 _tmp1_;
#line 678 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 678 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = database_table_update_int_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "orientation", (gint) orientation);
#line 679 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 4917 "PhotoTable.c"
}


gboolean
photo_table_replace_flags (PhotoTable* self,
                           PhotoID* photo_id,
                           guint64 flags)
{
	gboolean result = FALSE;
	PhotoID _tmp0_;
	gint64 _tmp1_;
#line 682 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 682 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 683 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 683 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 683 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "flags", (gint64) flags);
#line 683 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 4941 "PhotoTable.c"
}


gboolean
photo_table_set_rating (PhotoTable* self,
                        PhotoID* photo_id,
                        Rating rating)
{
	gboolean result = FALSE;
	PhotoID _tmp0_;
	gint64 _tmp1_;
#line 686 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 686 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 687 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 687 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 687 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = database_table_update_int_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "rating", rating_serialize (rating));
#line 687 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 4965 "PhotoTable.c"
}


gint
photo_table_get_event_photo_count (PhotoTable* self,
                                   EventID* event_id)
{
	gint result = 0;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	EventID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_;
	gint count = 0;
#line 690 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), 0);
#line 690 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, 0);
#line 692 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 692 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 692 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 692 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 692 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 693 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 693 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 695 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 695 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = *event_id;
#line 695 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_.id;
#line 695 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 696 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = res;
#line 696 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 698 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	count = 0;
#line 5017 "PhotoTable.c"
	{
		gboolean _tmp8_ = FALSE;
#line 699 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp8_ = TRUE;
#line 699 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		while (TRUE) {
#line 5024 "PhotoTable.c"
			sqlite3_stmt* _tmp9_;
			gint _tmp10_;
			gint _tmp13_;
#line 699 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (!_tmp8_) {
#line 5030 "PhotoTable.c"
			}
#line 699 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp8_ = FALSE;
#line 700 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp9_ = stmt;
#line 700 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp9_);
#line 701 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp10_ = res;
#line 701 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (_tmp10_ == SQLITE_DONE) {
#line 702 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				break;
#line 5044 "PhotoTable.c"
			} else {
				gint _tmp11_;
#line 703 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp11_ = res;
#line 703 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				if (_tmp11_ != SQLITE_ROW) {
#line 5051 "PhotoTable.c"
					gint _tmp12_;
#line 704 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp12_ = res;
#line 704 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					database_table_fatal ("get_event_photo_count", _tmp12_);
#line 706 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					break;
#line 5059 "PhotoTable.c"
				}
			}
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp13_ = count;
#line 709 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			count = _tmp13_ + 1;
#line 5066 "PhotoTable.c"
		}
	}
#line 712 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = count;
#line 712 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 712 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 5075 "PhotoTable.c"
}


GeeArrayList*
photo_table_get_event_source_ids (PhotoTable* self,
                                  EventID* event_id)
{
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	EventID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp8_;
#line 715 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 715 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 717 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 717 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 717 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 717 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 717 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 718 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 718 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 720 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 720 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = *event_id;
#line 720 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_.id;
#line 720 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 721 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = res;
#line 721 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 723 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 723 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_result_ = _tmp8_;
#line 5130 "PhotoTable.c"
	{
		gboolean _tmp9_ = FALSE;
#line 724 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp9_ = TRUE;
#line 724 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		while (TRUE) {
#line 5137 "PhotoTable.c"
			sqlite3_stmt* _tmp10_;
			gint _tmp11_;
			GeeArrayList* _tmp14_;
			sqlite3_stmt* _tmp15_;
			PhotoID _tmp16_ = {0};
			gchar* _tmp17_;
			gchar* _tmp18_;
#line 724 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (!_tmp9_) {
#line 5147 "PhotoTable.c"
			}
#line 724 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp9_ = FALSE;
#line 725 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp10_ = stmt;
#line 725 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp10_);
#line 726 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp11_ = res;
#line 726 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (_tmp11_ == SQLITE_DONE) {
#line 727 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				break;
#line 5161 "PhotoTable.c"
			} else {
				gint _tmp12_;
#line 728 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp12_ = res;
#line 728 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				if (_tmp12_ != SQLITE_ROW) {
#line 5168 "PhotoTable.c"
					gint _tmp13_;
#line 729 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp13_ = res;
#line 729 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					database_table_fatal ("get_event_source_ids", _tmp13_);
#line 731 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					break;
#line 5176 "PhotoTable.c"
				}
			}
#line 734 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp14_ = _result_;
#line 734 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp15_ = stmt;
#line 734 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			photo_id_init (&_tmp16_, sqlite3_column_int64 (_tmp15_, 0));
#line 734 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp17_ = photo_id_upgrade_photo_id_to_source_id (&_tmp16_);
#line 734 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp18_ = _tmp17_;
#line 734 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp18_);
#line 734 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (_tmp18_);
#line 5193 "PhotoTable.c"
		}
	}
#line 737 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _result_;
#line 737 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 737 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 5202 "PhotoTable.c"
}


gboolean
photo_table_event_has_photos (PhotoTable* self,
                              EventID* event_id)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	EventID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	gint _tmp9_;
#line 740 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 740 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 742 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 742 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable WHERE event_id = ? LIMIT 1", -1, &_tmp1_, NULL);
#line 742 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 742 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 742 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 743 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 743 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 745 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 745 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = *event_id;
#line 745 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_.id;
#line 745 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 746 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = res;
#line 746 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 748 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 748 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp8_);
#line 749 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = res;
#line 749 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp9_ == SQLITE_DONE) {
#line 750 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = FALSE;
#line 750 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 750 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 5267 "PhotoTable.c"
	} else {
		gint _tmp10_;
#line 751 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp10_ = res;
#line 751 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_tmp10_ != SQLITE_ROW) {
#line 5274 "PhotoTable.c"
			gint _tmp11_;
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp11_ = res;
#line 752 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			database_table_fatal ("event_has_photos", _tmp11_);
#line 754 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			result = FALSE;
#line 754 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 754 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return result;
#line 5286 "PhotoTable.c"
		}
	}
#line 757 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = TRUE;
#line 757 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 757 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 5295 "PhotoTable.c"
}


gboolean
photo_table_drop_event (PhotoTable* self,
                        EventID* event_id)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	EventID _tmp7_;
	gint64 _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_;
	gint _tmp11_;
#line 760 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 760 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 762 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 762 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET event_id = ? WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 762 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 762 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 762 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 763 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 763 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 765 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 765 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, EVENT_ID_INVALID);
#line 766 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = res;
#line 766 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp5_ == SQLITE_OK, "res == Sqlite.OK");
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = *event_id;
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = _tmp7_.id;
#line 767 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 2, _tmp8_);
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = res;
#line 768 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp9_ == SQLITE_OK, "res == Sqlite.OK");
#line 770 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 770 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp10_);
#line 771 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = res;
#line 771 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp11_ != SQLITE_DONE) {
#line 5364 "PhotoTable.c"
		gint _tmp12_;
#line 772 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp12_ = res;
#line 772 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_fatal ("drop_event", _tmp12_);
#line 774 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = FALSE;
#line 774 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 774 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 5376 "PhotoTable.c"
	}
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = TRUE;
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 777 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 5384 "PhotoTable.c"
}


gboolean
photo_table_set_event (PhotoTable* self,
                       PhotoID* photo_id,
                       EventID* event_id)
{
	gboolean result = FALSE;
	PhotoID _tmp0_;
	gint64 _tmp1_;
	EventID _tmp2_;
	gint64 _tmp3_;
#line 780 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 780 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 780 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 781 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 781 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 781 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = *event_id;
#line 781 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 781 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "event_id", _tmp3_);
#line 781 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 5416 "PhotoTable.c"
}


static gchar*
photo_table_get_raw_transformations (PhotoTable* self,
                                     PhotoID* photo_id)
{
	gchar* result = NULL;
	sqlite3_stmt* stmt = NULL;
	PhotoID _tmp0_;
	gint64 _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gboolean _tmp3_;
	gchar* trans = NULL;
	sqlite3_stmt* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 784 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = database_table_select_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "transformations", &_tmp2_);
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp2_;
#line 786 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (!_tmp3_) {
#line 787 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = NULL;
#line 787 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 787 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 5458 "PhotoTable.c"
	}
#line 789 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 789 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = (const gchar*) sqlite3_column_text (_tmp4_, 0);
#line 789 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 789 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	trans = _tmp6_;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = trans;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp8_ == NULL) {
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp7_ = TRUE;
#line 5474 "PhotoTable.c"
	} else {
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp9_ = trans;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp10_ = strlen (_tmp9_);
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp11_ = _tmp10_;
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp7_ = _tmp11_ == 0;
#line 5487 "PhotoTable.c"
	}
#line 790 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp7_) {
#line 791 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = NULL;
#line 791 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 791 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 791 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 5499 "PhotoTable.c"
	}
#line 793 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = trans;
#line 793 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 793 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 5507 "PhotoTable.c"
}


static gboolean
photo_table_set_raw_transformations (PhotoTable* self,
                                     PhotoID* photo_id,
                                     const gchar* trans)
{
	gboolean result = FALSE;
	PhotoID _tmp0_;
	gint64 _tmp1_;
#line 796 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 796 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 796 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 797 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 797 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 797 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "transformations", trans);
#line 797 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 5533 "PhotoTable.c"
}


gboolean
photo_table_set_transformation_state (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation,
                                      GeeHashMap* transformations)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	gchar* _tmp7_;
	GDestroyNotify _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_;
	PhotoID _tmp11_;
	gint64 _tmp12_;
	gint _tmp13_;
	sqlite3_stmt* _tmp14_;
	gint _tmp15_;
#line 800 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 800 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 800 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail ((transformations == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformations, GEE_TYPE_HASH_MAP), FALSE);
#line 803 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 803 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET orientation = ?, transformations = ? WHERE id = " \
"?", -1, &_tmp1_, NULL);
#line 803 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 803 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 803 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 805 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 805 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 807 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 807 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp4_, 1, (gint) orientation);
#line 808 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = res;
#line 808 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp5_ == SQLITE_OK, "res == Sqlite.OK");
#line 809 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 809 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = photo_table_unmarshall_all_transformations (transformations);
#line 809 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = g_free;
#line 809 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp6_, 2, _tmp7_, -1, _tmp8_);
#line 810 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = res;
#line 810 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp9_ == SQLITE_OK, "res == Sqlite.OK");
#line 811 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 811 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = *photo_id;
#line 811 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = _tmp11_.id;
#line 811 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp10_, 3, _tmp12_);
#line 812 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = res;
#line 812 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp13_ == SQLITE_OK, "res == Sqlite.OK");
#line 814 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 814 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp14_);
#line 815 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_ = res;
#line 815 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp15_ != SQLITE_DONE) {
#line 5622 "PhotoTable.c"
		gint _tmp16_;
#line 816 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp16_ = res;
#line 816 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_fatal ("set_transformation_state", _tmp16_);
#line 818 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = FALSE;
#line 818 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 818 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 5634 "PhotoTable.c"
	}
#line 821 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = TRUE;
#line 821 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 821 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 5642 "PhotoTable.c"
}


GeeHashMap*
photo_table_marshall_all_transformations (const gchar* trans)
{
	GeeHashMap* result = NULL;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (trans == NULL) {
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 5656 "PhotoTable.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp1_ = strlen (trans);
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp2_ = _tmp1_;
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = _tmp2_ == 0;
#line 5666 "PhotoTable.c"
	}
#line 825 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 826 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = NULL;
#line 826 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 5674 "PhotoTable.c"
	}
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GKeyFile* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		GeeHashMap* map = NULL;
		GeeHashMap* _tmp8_;
		gchar** objects = NULL;
		GKeyFile* _tmp9_;
		gsize _tmp10_ = 0;
		gchar** _tmp11_;
		gint objects_length1;
		gint _objects_size_;
		gchar** _tmp12_;
		gint _tmp12__length1;
#line 829 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp3_ = g_key_file_new ();
#line 829 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		keyfile = _tmp3_;
#line 830 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp5_ = keyfile;
#line 830 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp6_ = strlen (trans);
#line 830 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp7_ = _tmp6_;
#line 830 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp4_ = g_key_file_load_from_data (_tmp5_, trans, (gsize) _tmp7_, G_KEY_FILE_NONE, &_inner_error0_);
#line 830 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 830 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 5709 "PhotoTable.c"
			goto __catch19_g_error;
		}
#line 830 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (!_tmp4_) {
#line 831 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			result = NULL;
#line 831 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 831 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return result;
#line 5720 "PhotoTable.c"
		}
#line 833 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 833 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		map = _tmp8_;
#line 835 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp9_ = keyfile;
#line 835 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp11_ = g_key_file_get_groups (_tmp9_, &_tmp10_);
#line 835 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		objects = _tmp11_;
#line 835 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		objects_length1 = _tmp10_;
#line 835 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_objects_size_ = objects_length1;
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp12_ = objects;
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp12__length1 = objects_length1;
#line 5740 "PhotoTable.c"
		{
			gchar** object_collection = NULL;
			gint object_collection_length1 = 0;
			gint _object_collection_size_ = 0;
			gint object_it = 0;
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			object_collection = _tmp12_;
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			object_collection_length1 = _tmp12__length1;
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			for (object_it = 0; object_it < object_collection_length1; object_it = object_it + 1) {
#line 5752 "PhotoTable.c"
				gchar* _tmp13_;
				gchar* object = NULL;
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp13_ = g_strdup (object_collection[object_it]);
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				object = _tmp13_;
#line 5759 "PhotoTable.c"
				{
					gchar** keys = NULL;
					GKeyFile* _tmp14_;
					const gchar* _tmp15_;
					gsize _tmp16_ = 0;
					gchar** _tmp17_;
					gint keys_length1;
					gint _keys_size_;
					gboolean _tmp18_ = FALSE;
					gchar** _tmp19_;
					gint _tmp19__length1;
					KeyValueMap* key_map = NULL;
					const gchar* _tmp21_;
					KeyValueMap* _tmp22_;
					GeeHashMap* _tmp38_;
					const gchar* _tmp39_;
					KeyValueMap* _tmp40_;
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp14_ = keyfile;
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp15_ = object;
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp17_ = g_key_file_get_keys (_tmp14_, _tmp15_, &_tmp16_, &_inner_error0_);
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					keys = _tmp17_;
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					keys_length1 = _tmp16_;
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_keys_size_ = keys_length1;
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						_g_free0 (object);
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						_g_object_unref0 (map);
#line 837 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						_g_key_file_unref0 (keyfile);
#line 5799 "PhotoTable.c"
						goto __catch19_g_error;
					}
#line 838 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp19_ = keys;
#line 838 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp19__length1 = keys_length1;
#line 838 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					if (_tmp19_ == NULL) {
#line 838 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						_tmp18_ = TRUE;
#line 5810 "PhotoTable.c"
					} else {
						gchar** _tmp20_;
						gint _tmp20__length1;
#line 838 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						_tmp20_ = keys;
#line 838 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						_tmp20__length1 = keys_length1;
#line 838 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						_tmp18_ = _tmp20__length1 == 0;
#line 5820 "PhotoTable.c"
					}
#line 838 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					if (_tmp18_) {
#line 839 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 839 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						_g_free0 (object);
#line 839 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						continue;
#line 5830 "PhotoTable.c"
					}
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp21_ = object;
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp22_ = key_value_map_new (_tmp21_);
#line 841 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					key_map = _tmp22_;
#line 5838 "PhotoTable.c"
					{
						gint ctr = 0;
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						ctr = 0;
#line 5843 "PhotoTable.c"
						{
							gboolean _tmp23_ = FALSE;
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
							_tmp23_ = TRUE;
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
							while (TRUE) {
#line 5850 "PhotoTable.c"
								gint _tmp25_;
								gchar** _tmp26_;
								gint _tmp26__length1;
								gchar* _tmp27_ = NULL;
								GKeyFile* _tmp28_;
								const gchar* _tmp29_;
								gchar** _tmp30_;
								gint _tmp30__length1;
								gint _tmp31_;
								const gchar* _tmp32_;
								gchar* _tmp33_;
								KeyValueMap* _tmp34_;
								gchar** _tmp35_;
								gint _tmp35__length1;
								gint _tmp36_;
								const gchar* _tmp37_;
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								if (!_tmp23_) {
#line 5869 "PhotoTable.c"
									gint _tmp24_;
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
									_tmp24_ = ctr;
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
									ctr = _tmp24_ + 1;
#line 5875 "PhotoTable.c"
								}
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp23_ = FALSE;
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp25_ = ctr;
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp26_ = keys;
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp26__length1 = keys_length1;
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								if (!(_tmp25_ < _tmp26__length1)) {
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
									break;
#line 5889 "PhotoTable.c"
								}
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp28_ = keyfile;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp29_ = object;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp30_ = keys;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp30__length1 = keys_length1;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp31_ = ctr;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp32_ = _tmp30_[_tmp31_];
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp33_ = g_key_file_get_string (_tmp28_, _tmp29_, _tmp32_, &_inner_error0_);
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp27_ = _tmp33_;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
									_key_value_map_unref0 (key_map);
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
									keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
									_g_free0 (object);
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
									objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
									_g_object_unref0 (map);
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
									_g_key_file_unref0 (keyfile);
#line 5921 "PhotoTable.c"
									goto __catch19_g_error;
								}
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp34_ = key_map;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp35_ = keys;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp35__length1 = keys_length1;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp36_ = ctr;
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_tmp37_ = _tmp35_[_tmp36_];
#line 843 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								key_value_map_set_string (_tmp34_, _tmp37_, _tmp27_);
#line 842 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
								_g_free0 (_tmp27_);
#line 5938 "PhotoTable.c"
							}
						}
					}
#line 845 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp38_ = map;
#line 845 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp39_ = object;
#line 845 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp40_ = key_map;
#line 845 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp39_, _tmp40_);
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_key_value_map_unref0 (key_map);
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 836 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_g_free0 (object);
#line 5956 "PhotoTable.c"
				}
			}
		}
#line 848 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = map;
#line 848 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 848 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 848 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 5968 "PhotoTable.c"
	}
	goto __finally19;
	__catch19_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp41_;
#line 828 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 828 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 850 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp41_ = err->message;
#line 850 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:850: %s", _tmp41_);
#line 828 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 5985 "PhotoTable.c"
	}
	__finally19:
#line 828 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 828 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_clear_error (&_inner_error0_);
#line 828 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return NULL;
#line 5994 "PhotoTable.c"
}


gchar*
photo_table_unmarshall_all_transformations (GeeHashMap* transformations)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp6_;
	gsize length = 0UL;
	gchar* unmarshalled = NULL;
	GKeyFile* _tmp33_;
	gsize _tmp34_ = 0UL;
	gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
#line 854 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail ((transformations == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformations, GEE_TYPE_HASH_MAP), NULL);
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (transformations == NULL) {
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 6020 "PhotoTable.c"
	} else {
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (transformations, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp2_ = _tmp1_;
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp3_ = _tmp2_;
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp5_ = _tmp4_;
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = _tmp5_ == 0;
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp3_);
#line 6041 "PhotoTable.c"
	}
#line 855 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 856 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = NULL;
#line 856 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 6049 "PhotoTable.c"
	}
#line 858 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = g_key_file_new ();
#line 858 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	keyfile = _tmp6_;
#line 6055 "PhotoTable.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp7_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (transformations, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp8_ = _tmp7_;
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_;
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp11_ = _tmp10_;
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp9_);
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_object_it = _tmp11_;
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		while (TRUE) {
#line 6079 "PhotoTable.c"
			GeeIterator* _tmp12_;
			gchar* object = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			KeyValueMap* map = NULL;
			const gchar* _tmp15_;
			gpointer _tmp16_;
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp12_ = _object_it;
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				break;
#line 6093 "PhotoTable.c"
			}
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp13_ = _object_it;
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			object = (gchar*) _tmp14_;
#line 861 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp15_ = object;
#line 861 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp16_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (transformations, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp15_);
#line 861 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			map = (KeyValueMap*) _tmp16_;
#line 6107 "PhotoTable.c"
			{
				GeeIterator* _key_it = NULL;
				KeyValueMap* _tmp17_;
				GeeSet* _tmp18_;
				GeeSet* _tmp19_;
				GeeIterator* _tmp20_;
				GeeIterator* _tmp21_;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp17_ = map;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp18_ = key_value_map_get_keys (_tmp17_);
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp19_ = _tmp18_;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp20_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ITERABLE, GeeIterable));
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp21_ = _tmp20_;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_object_unref0 (_tmp19_);
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_key_it = _tmp21_;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				while (TRUE) {
#line 6131 "PhotoTable.c"
					GeeIterator* _tmp22_;
					gchar* key = NULL;
					GeeIterator* _tmp23_;
					gpointer _tmp24_;
					gchar* value = NULL;
					KeyValueMap* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					const gchar* _tmp28_;
					GKeyFile* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp22_ = _key_it;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					if (!gee_iterator_next (_tmp22_)) {
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
						break;
#line 6151 "PhotoTable.c"
					}
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp23_ = _key_it;
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp24_ = gee_iterator_get (_tmp23_);
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					key = (gchar*) _tmp24_;
#line 864 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp25_ = map;
#line 864 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp26_ = key;
#line 864 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp27_ = key_value_map_get_string (_tmp25_, _tmp26_, NULL);
#line 864 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					value = _tmp27_;
#line 865 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp28_ = value;
#line 865 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_vala_assert (_tmp28_ != NULL, "value != null");
#line 867 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp29_ = keyfile;
#line 867 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp30_ = object;
#line 867 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp31_ = key;
#line 867 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_tmp32_ = value;
#line 867 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					g_key_file_set_string (_tmp29_, _tmp30_, _tmp31_, _tmp32_);
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_g_free0 (value);
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_g_free0 (key);
#line 6185 "PhotoTable.c"
				}
#line 863 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_object_unref0 (_key_it);
#line 6189 "PhotoTable.c"
			}
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_key_value_map_unref0 (map);
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (object);
#line 6195 "PhotoTable.c"
		}
#line 860 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_object_unref0 (_object_it);
#line 6199 "PhotoTable.c"
	}
#line 872 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp33_ = keyfile;
#line 872 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp35_ = g_key_file_to_data (_tmp33_, &_tmp34_, NULL);
#line 872 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	length = _tmp34_;
#line 872 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	unmarshalled = _tmp35_;
#line 873 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp36_ = unmarshalled;
#line 873 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp36_ != NULL, "unmarshalled != null");
#line 874 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp37_ = unmarshalled;
#line 874 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp38_ = strlen (_tmp37_);
#line 874 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp39_ = _tmp38_;
#line 874 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp39_ > 0, "unmarshalled.length > 0");
#line 876 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = unmarshalled;
#line 876 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_key_file_unref0 (keyfile);
#line 876 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 6227 "PhotoTable.c"
}


gboolean
photo_table_set_transformation (PhotoTable* self,
                                PhotoID* photo_id,
                                KeyValueMap* map)
{
	gboolean result = FALSE;
	gchar* trans = NULL;
	PhotoID _tmp0_;
	gchar* _tmp1_;
	PhotoID _tmp33_;
	const gchar* _tmp34_;
	GError* _inner_error0_ = NULL;
#line 879 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 879 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 879 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, TYPE_KEY_VALUE_MAP), FALSE);
#line 880 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 880 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 880 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	trans = _tmp1_;
#line 6255 "PhotoTable.c"
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp2_;
		const gchar* _tmp3_;
		GeeSet* keys = NULL;
		GeeSet* _tmp10_;
		gsize length = 0UL;
		GKeyFile* _tmp24_;
		gsize _tmp25_ = 0UL;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
#line 883 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp2_ = g_key_file_new ();
#line 883 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		keyfile = _tmp2_;
#line 884 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp3_ = trans;
#line 884 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_tmp3_ != NULL) {
#line 6278 "PhotoTable.c"
			gboolean _tmp4_ = FALSE;
			GKeyFile* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 885 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp5_ = keyfile;
#line 885 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp6_ = trans;
#line 885 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp7_ = trans;
#line 885 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp8_ = strlen (_tmp7_);
#line 885 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp9_ = _tmp8_;
#line 885 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp4_ = g_key_file_load_from_data (_tmp5_, _tmp6_, (gsize) _tmp9_, G_KEY_FILE_NONE, &_inner_error0_);
#line 885 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 885 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_key_file_unref0 (keyfile);
#line 6301 "PhotoTable.c"
				goto __catch20_g_error;
			}
#line 885 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (!_tmp4_) {
#line 886 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				result = FALSE;
#line 886 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_key_file_unref0 (keyfile);
#line 886 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_free0 (trans);
#line 886 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return result;
#line 6314 "PhotoTable.c"
			}
		}
#line 889 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp10_ = key_value_map_get_keys (map);
#line 889 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		keys = _tmp10_;
#line 6321 "PhotoTable.c"
		{
			GeeIterator* _key_it = NULL;
			GeeSet* _tmp11_;
			GeeIterator* _tmp12_;
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp11_ = keys;
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_key_it = _tmp12_;
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			while (TRUE) {
#line 6334 "PhotoTable.c"
				GeeIterator* _tmp13_;
				gchar* key = NULL;
				GeeIterator* _tmp14_;
				gpointer _tmp15_;
				gchar* value = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				const gchar* _tmp18_;
				GKeyFile* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp13_ = _key_it;
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				if (!gee_iterator_next (_tmp13_)) {
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					break;
#line 6354 "PhotoTable.c"
				}
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp14_ = _key_it;
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				key = (gchar*) _tmp15_;
#line 891 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp16_ = key;
#line 891 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp17_ = key_value_map_get_string (map, _tmp16_, NULL);
#line 891 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				value = _tmp17_;
#line 892 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp18_ = value;
#line 892 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_vala_assert (_tmp18_ != NULL, "value != null");
#line 894 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp19_ = keyfile;
#line 894 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp20_ = key_value_map_get_group (map);
#line 894 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp21_ = _tmp20_;
#line 894 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp22_ = key;
#line 894 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp23_ = value;
#line 894 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_key_file_set_string (_tmp19_, _tmp21_, _tmp22_, _tmp23_);
#line 894 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_free0 (_tmp21_);
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_free0 (value);
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_free0 (key);
#line 6390 "PhotoTable.c"
			}
#line 890 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_object_unref0 (_key_it);
#line 6394 "PhotoTable.c"
		}
#line 898 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp24_ = keyfile;
#line 898 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp26_ = g_key_file_to_data (_tmp24_, &_tmp25_, NULL);
#line 898 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		length = _tmp25_;
#line 898 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 898 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		trans = _tmp26_;
#line 899 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp27_ = trans;
#line 899 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_vala_assert (_tmp27_ != NULL, "trans != null");
#line 900 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp28_ = trans;
#line 900 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp29_ = strlen (_tmp28_);
#line 900 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp30_ = _tmp29_;
#line 900 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_vala_assert (_tmp30_ > 0, "trans.length > 0");
#line 882 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_object_unref0 (keys);
#line 882 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 6422 "PhotoTable.c"
	}
	goto __finally20;
	__catch20_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp31_;
#line 882 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 882 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 902 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp31_ = err->message;
#line 902 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:902: %s", _tmp31_);
#line 882 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 6439 "PhotoTable.c"
	}
	__finally20:
#line 882 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6444 "PhotoTable.c"
		gboolean _tmp32_ = FALSE;
#line 882 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 882 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 882 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_clear_error (&_inner_error0_);
#line 882 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return _tmp32_;
#line 6454 "PhotoTable.c"
	}
#line 905 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp33_ = *photo_id;
#line 905 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp34_ = trans;
#line 905 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = photo_table_set_raw_transformations (self, &_tmp33_, _tmp34_);
#line 905 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (trans);
#line 905 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 6466 "PhotoTable.c"
}


gboolean
photo_table_remove_transformation (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* object)
{
	gboolean result = FALSE;
	gchar* trans = NULL;
	PhotoID _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoID _tmp18_;
	const gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 908 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 909 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 909 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 909 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	trans = _tmp1_;
#line 910 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = trans;
#line 910 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp2_ == NULL) {
#line 911 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = TRUE;
#line 911 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 911 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 6505 "PhotoTable.c"
	}
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GKeyFile* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		GKeyFile* _tmp10_;
		GKeyFile* _tmp11_;
		gsize length = 0UL;
		GKeyFile* _tmp12_;
		gsize _tmp13_ = 0UL;
		gchar* _tmp14_;
		const gchar* _tmp15_;
#line 914 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp3_ = g_key_file_new ();
#line 914 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		keyfile = _tmp3_;
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp5_ = keyfile;
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp6_ = trans;
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp7_ = trans;
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp8_ = strlen (_tmp7_);
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_;
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp4_ = g_key_file_load_from_data (_tmp5_, _tmp6_, (gsize) _tmp9_, G_KEY_FILE_NONE, &_inner_error0_);
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 6543 "PhotoTable.c"
			goto __catch21_g_error;
		}
#line 915 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (!_tmp4_) {
#line 916 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			result = FALSE;
#line 916 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 916 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (trans);
#line 916 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return result;
#line 6556 "PhotoTable.c"
		}
#line 918 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp10_ = keyfile;
#line 918 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (!g_key_file_has_group (_tmp10_, object)) {
#line 919 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			result = TRUE;
#line 919 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 919 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (trans);
#line 919 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return result;
#line 6570 "PhotoTable.c"
		}
#line 921 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp11_ = keyfile;
#line 921 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_key_file_remove_group (_tmp11_, object, &_inner_error0_);
#line 921 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 921 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 6580 "PhotoTable.c"
			goto __catch21_g_error;
		}
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp12_ = keyfile;
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp14_ = g_key_file_to_data (_tmp12_, &_tmp13_, NULL);
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		length = _tmp13_;
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 924 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		trans = _tmp14_;
#line 925 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp15_ = trans;
#line 925 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_vala_assert (_tmp15_ != NULL, "trans != null");
#line 913 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 6599 "PhotoTable.c"
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp16_;
#line 913 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 913 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 927 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp16_ = err->message;
#line 927 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:927: %s", _tmp16_);
#line 913 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 6616 "PhotoTable.c"
	}
	__finally21:
#line 913 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6621 "PhotoTable.c"
		gboolean _tmp17_ = FALSE;
#line 913 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 913 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 913 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_clear_error (&_inner_error0_);
#line 913 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return _tmp17_;
#line 6631 "PhotoTable.c"
	}
#line 930 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp18_ = *photo_id;
#line 930 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_ = trans;
#line 930 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = photo_table_set_raw_transformations (self, &_tmp18_, _tmp19_);
#line 930 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (trans);
#line 930 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 6643 "PhotoTable.c"
}


gboolean
photo_table_remove_all_transformations (PhotoTable* self,
                                        PhotoID* photo_id)
{
	gboolean result = FALSE;
	PhotoID _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	PhotoID _tmp4_;
	gint64 _tmp5_;
#line 933 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 933 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 934 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 934 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 934 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = _tmp1_;
#line 934 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 934 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (_tmp2_);
#line 934 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp3_) {
#line 935 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = FALSE;
#line 935 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 6678 "PhotoTable.c"
	}
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = *photo_id;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = _tmp4_.id;
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp5_, "transformations", "");
#line 937 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 6688 "PhotoTable.c"
}


static sqlite3_stmt*
photo_table_get_duplicate_stmt (PhotoTable* self,
                                GFile* file,
                                const gchar* thumbnail_md5,
                                const gchar* md5,
                                PhotoFileFormat file_format)
{
	sqlite3_stmt* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* sql = NULL;
	gchar* _tmp2_;
	gboolean first = FALSE;
	gboolean _tmp5_ = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp23_;
	const gchar* _tmp24_;
	sqlite3_stmt* _tmp25_ = NULL;
	gint _tmp26_;
	gint _tmp27_;
	gint col = 0;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp44_ = FALSE;
#line 942 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 942 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (file != NULL) {
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp1_ = TRUE;
#line 6724 "PhotoTable.c"
	} else {
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp1_ = thumbnail_md5 != NULL;
#line 6728 "PhotoTable.c"
	}
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp1_) {
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 6734 "PhotoTable.c"
	} else {
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = md5 != NULL;
#line 6738 "PhotoTable.c"
	}
#line 944 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp0_, "file != null || thumbnail_md5 != null || md5 != null");
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = g_strdup ("SELECT id FROM PhotoTable WHERE");
#line 946 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	sql = _tmp2_;
#line 947 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	first = TRUE;
#line 949 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (file != NULL) {
#line 6750 "PhotoTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 950 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp3_ = sql;
#line 950 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp4_ = g_strconcat (_tmp3_, " filename=?", NULL);
#line 950 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 950 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		sql = _tmp4_;
#line 951 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		first = FALSE;
#line 6763 "PhotoTable.c"
	}
#line 954 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 954 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp5_ = TRUE;
#line 6769 "PhotoTable.c"
	} else {
#line 954 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp5_ = md5 != NULL;
#line 6773 "PhotoTable.c"
	}
#line 954 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp5_) {
#line 6777 "PhotoTable.c"
		gboolean _tmp6_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
#line 955 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp6_ = first;
#line 955 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_tmp6_) {
#line 6787 "PhotoTable.c"
			const gchar* _tmp7_;
			gchar* _tmp8_;
#line 956 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp7_ = sql;
#line 956 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp8_ = g_strconcat (_tmp7_, " ((", NULL);
#line 956 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 956 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			sql = _tmp8_;
#line 6798 "PhotoTable.c"
		} else {
			const gchar* _tmp9_;
			gchar* _tmp10_;
#line 958 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp9_ = sql;
#line 958 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp10_ = g_strconcat (_tmp9_, " OR ((", NULL);
#line 958 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 958 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			sql = _tmp10_;
#line 6810 "PhotoTable.c"
		}
#line 959 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		first = FALSE;
#line 961 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (md5 != NULL) {
#line 6816 "PhotoTable.c"
			const gchar* _tmp11_;
			gchar* _tmp12_;
#line 962 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp11_ = sql;
#line 962 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp12_ = g_strconcat (_tmp11_, " md5=?", NULL);
#line 962 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 962 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			sql = _tmp12_;
#line 6827 "PhotoTable.c"
		}
#line 965 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (thumbnail_md5 != NULL) {
#line 966 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (md5 == NULL) {
#line 6833 "PhotoTable.c"
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 967 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp13_ = sql;
#line 967 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp14_ = g_strconcat (_tmp13_, " thumbnail_md5=?", NULL);
#line 967 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_free0 (sql);
#line 967 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				sql = _tmp14_;
#line 6844 "PhotoTable.c"
			} else {
				const gchar* _tmp15_;
				gchar* _tmp16_;
#line 969 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp15_ = sql;
#line 969 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_tmp16_ = g_strconcat (_tmp15_, " OR (md5 IS NULL AND thumbnail_md5=?)", NULL);
#line 969 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_free0 (sql);
#line 969 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				sql = _tmp16_;
#line 6856 "PhotoTable.c"
			}
		}
#line 972 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp17_ = sql;
#line 972 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp18_ = g_strconcat (_tmp17_, ")", NULL);
#line 972 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 972 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		sql = _tmp18_;
#line 974 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (file_format != PHOTO_FILE_FORMAT_UNKNOWN) {
#line 6869 "PhotoTable.c"
			const gchar* _tmp19_;
			gchar* _tmp20_;
#line 975 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp19_ = sql;
#line 975 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp20_ = g_strconcat (_tmp19_, " AND file_format=?", NULL);
#line 975 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 975 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			sql = _tmp20_;
#line 6880 "PhotoTable.c"
		}
#line 977 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp21_ = sql;
#line 977 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp22_ = g_strconcat (_tmp21_, ")", NULL);
#line 977 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 977 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		sql = _tmp22_;
#line 6890 "PhotoTable.c"
	}
#line 981 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp23_ = database_table_db;
#line 981 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp24_ = sql;
#line 981 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp26_ = sqlite3_prepare_v2 (_tmp23_, _tmp24_, -1, &_tmp25_, NULL);
#line 981 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 981 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp25_;
#line 981 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp26_;
#line 982 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp27_ = res;
#line 982 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp27_ == SQLITE_OK, "res == Sqlite.OK");
#line 984 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	col = 1;
#line 986 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (file != NULL) {
#line 6912 "PhotoTable.c"
		sqlite3_stmt* _tmp28_;
		gint _tmp29_;
		gchar* _tmp30_;
		GDestroyNotify _tmp31_;
		gint _tmp32_;
#line 987 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp28_ = stmt;
#line 987 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp29_ = col;
#line 987 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		col = _tmp29_ + 1;
#line 987 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp30_ = g_file_get_path (file);
#line 987 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp31_ = g_free;
#line 987 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		res = sqlite3_bind_text (_tmp28_, _tmp29_, _tmp30_, -1, _tmp31_);
#line 988 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp32_ = res;
#line 988 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_vala_assert (_tmp32_ == SQLITE_OK, "res == Sqlite.OK");
#line 6934 "PhotoTable.c"
	}
#line 991 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 6938 "PhotoTable.c"
		sqlite3_stmt* _tmp33_;
		gint _tmp34_;
		gchar* _tmp35_;
		GDestroyNotify _tmp36_;
		gint _tmp37_;
#line 992 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp33_ = stmt;
#line 992 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp34_ = col;
#line 992 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		col = _tmp34_ + 1;
#line 992 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp35_ = g_strdup (thumbnail_md5);
#line 992 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp36_ = g_free;
#line 992 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		res = sqlite3_bind_text (_tmp33_, _tmp34_, _tmp35_, -1, _tmp36_);
#line 993 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp37_ = res;
#line 993 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_vala_assert (_tmp37_ == SQLITE_OK, "res == Sqlite.OK");
#line 6960 "PhotoTable.c"
	}
#line 996 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (md5 != NULL) {
#line 6964 "PhotoTable.c"
		sqlite3_stmt* _tmp38_;
		gint _tmp39_;
		gchar* _tmp40_;
		GDestroyNotify _tmp41_;
		gint _tmp42_;
#line 997 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp38_ = stmt;
#line 997 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp39_ = col;
#line 997 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		col = _tmp39_ + 1;
#line 997 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp40_ = g_strdup (md5);
#line 997 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp41_ = g_free;
#line 997 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		res = sqlite3_bind_text (_tmp38_, _tmp39_, _tmp40_, -1, _tmp41_);
#line 998 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp42_ = res;
#line 998 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_vala_assert (_tmp42_ == SQLITE_OK, "res == Sqlite.OK");
#line 6986 "PhotoTable.c"
	}
#line 1001 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 1001 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp44_ = TRUE;
#line 6992 "PhotoTable.c"
	} else {
#line 1001 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp44_ = md5 != NULL;
#line 6996 "PhotoTable.c"
	}
#line 1001 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp44_) {
#line 1001 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp43_ = file_format != PHOTO_FILE_FORMAT_UNKNOWN;
#line 7002 "PhotoTable.c"
	} else {
#line 1001 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp43_ = FALSE;
#line 7006 "PhotoTable.c"
	}
#line 1001 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp43_) {
#line 7010 "PhotoTable.c"
		sqlite3_stmt* _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
#line 1002 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp45_ = stmt;
#line 1002 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp46_ = col;
#line 1002 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		col = _tmp46_ + 1;
#line 1002 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		res = sqlite3_bind_int (_tmp45_, _tmp46_, photo_file_format_serialize (file_format));
#line 1003 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp47_ = res;
#line 1003 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_vala_assert (_tmp47_ == SQLITE_OK, "res == Sqlite.OK");
#line 7026 "PhotoTable.c"
	}
#line 1006 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = stmt;
#line 1006 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (sql);
#line 1006 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 7034 "PhotoTable.c"
}


gboolean
photo_table_has_duplicate (PhotoTable* self,
                           GFile* file,
                           const gchar* thumbnail_md5,
                           const gchar* md5,
                           PhotoFileFormat file_format)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
#line 1009 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 1009 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1010 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = photo_table_get_duplicate_stmt (self, file, thumbnail_md5, md5, file_format);
#line 1010 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1011 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 1011 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 1013 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = res;
#line 1013 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp2_ == SQLITE_DONE) {
#line 1015 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = FALSE;
#line 1015 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 1015 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 7073 "PhotoTable.c"
	} else {
		gint _tmp3_;
#line 1016 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp3_ = res;
#line 1016 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_tmp3_ == SQLITE_ROW) {
#line 1018 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			result = TRUE;
#line 1018 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 1018 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return result;
#line 7086 "PhotoTable.c"
		} else {
			gint _tmp4_;
#line 1020 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp4_ = res;
#line 1020 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			database_table_fatal ("has_duplicate", _tmp4_);
#line 1022 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			result = FALSE;
#line 1022 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 1022 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return result;
#line 7099 "PhotoTable.c"
		}
	}
#line 1009 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 7104 "PhotoTable.c"
}


static void
_vala_array_add2 (PhotoID* * array,
                  int* length,
                  int* size,
                  const PhotoID* value)
{
#line 1034 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if ((*length) == (*size)) {
#line 1034 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1034 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*array = g_renew (PhotoID, *array, *size);
#line 7120 "PhotoTable.c"
	}
#line 1034 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	(*array)[(*length)++] = *value;
#line 7124 "PhotoTable.c"
}


PhotoID*
photo_table_get_duplicate_ids (PhotoTable* self,
                               GFile* file,
                               const gchar* thumbnail_md5,
                               const gchar* md5,
                               PhotoFileFormat file_format,
                               int* result_length1)
{
	PhotoID* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	PhotoID* ids = NULL;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gint res = 0;
	sqlite3_stmt* _tmp2_;
	PhotoID* _tmp8_;
	gint _tmp8__length1;
#line 1026 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 1026 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1028 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = photo_table_get_duplicate_stmt (self, file, thumbnail_md5, md5, file_format);
#line 1028 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1030 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = g_new0 (PhotoID, 0);
#line 1030 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	ids = _tmp1_;
#line 1030 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	ids_length1 = 0;
#line 1030 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_ids_size_ = ids_length1;
#line 1032 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = stmt;
#line 1032 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp2_);
#line 1033 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	while (TRUE) {
#line 7169 "PhotoTable.c"
		gint _tmp3_;
		PhotoID* _tmp4_;
		gint _tmp4__length1;
		sqlite3_stmt* _tmp5_;
		PhotoID _tmp6_ = {0};
		sqlite3_stmt* _tmp7_;
#line 1033 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp3_ = res;
#line 1033 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (!(_tmp3_ == SQLITE_ROW)) {
#line 1033 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			break;
#line 7182 "PhotoTable.c"
		}
#line 1034 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp4_ = ids;
#line 1034 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp4__length1 = ids_length1;
#line 1034 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp5_ = stmt;
#line 1034 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		photo_id_init (&_tmp6_, sqlite3_column_int64 (_tmp5_, 0));
#line 1034 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_vala_array_add2 (&ids, &ids_length1, &_ids_size_, &_tmp6_);
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp7_ = stmt;
#line 1035 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		res = sqlite3_step (_tmp7_);
#line 7198 "PhotoTable.c"
	}
#line 1038 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = ids;
#line 1038 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8__length1 = ids_length1;
#line 1038 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (result_length1) {
#line 1038 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*result_length1 = _tmp8__length1;
#line 7208 "PhotoTable.c"
	}
#line 1038 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp8_;
#line 1038 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1038 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 7216 "PhotoTable.c"
}


void
photo_table_update_backlinks (PhotoTable* self,
                              PhotoID* photo_id,
                              const gchar* backlinks,
                              GError** error)
{
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	gint64 _tmp2_;
	GError* _inner_error0_ = NULL;
#line 1041 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1041 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (backlinks != NULL) {
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = backlinks;
#line 7238 "PhotoTable.c"
	} else {
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 7242 "PhotoTable.c"
	}
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = _tmp1_.id;
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp2_, "backlinks", _tmp0_, &_inner_error0_);
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7258 "PhotoTable.c"
		} else {
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1042 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7266 "PhotoTable.c"
		}
	}
}


void
photo_table_attach_editable (PhotoTable* self,
                             PhotoRow* row,
                             BackingPhotoID* editable_id,
                             GError** error)
{
	PhotoID _tmp0_;
	gint64 _tmp1_;
	BackingPhotoID _tmp2_;
	gint64 _tmp3_;
	BackingPhotoID _tmp4_;
	GError* _inner_error0_ = NULL;
#line 1045 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1045 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1045 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (editable_id != NULL);
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = row->photo_id;
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = *editable_id;
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "editable_id", _tmp3_, &_inner_error0_);
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7308 "PhotoTable.c"
		} else {
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1046 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7316 "PhotoTable.c"
		}
	}
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = *editable_id;
#line 1048 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	row->editable_id = _tmp4_;
#line 7323 "PhotoTable.c"
}


void
photo_table_detach_editable (PhotoTable* self,
                             PhotoRow* row,
                             GError** error)
{
	PhotoID _tmp0_;
	gint64 _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1051 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1051 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1052 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = row->photo_id;
#line 1052 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 1052 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "editable_id", BACKING_PHOTO_ID_INVALID, &_inner_error0_);
#line 1052 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1052 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1052 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1052 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7353 "PhotoTable.c"
		} else {
#line 1052 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1052 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1052 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7361 "PhotoTable.c"
		}
	}
#line 1054 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	backing_photo_id_init (&row->editable_id, BACKING_PHOTO_ID_INVALID);
#line 7366 "PhotoTable.c"
}


void
photo_table_set_metadata_dirty (PhotoTable* self,
                                PhotoID* photo_id,
                                gboolean dirty,
                                GError** error)
{
	gint _tmp0_ = 0;
	PhotoID _tmp1_;
	gint64 _tmp2_;
	GError* _inner_error0_ = NULL;
#line 1057 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1057 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (dirty) {
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = 1;
#line 7388 "PhotoTable.c"
	} else {
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp0_ = 0;
#line 7392 "PhotoTable.c"
	}
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = _tmp1_.id;
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_int_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp2_, "metadata_dirty", _tmp0_, &_inner_error0_);
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7408 "PhotoTable.c"
		} else {
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1058 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7416 "PhotoTable.c"
		}
	}
}


void
photo_table_update_raw_development (PhotoTable* self,
                                    PhotoRow* row,
                                    RawDeveloper rd,
                                    BackingPhotoID* backing_photo_id,
                                    GError** error)
{
	gchar* col = NULL;
	BackingPhotoID* _tmp3_;
	gint _tmp3__length1;
	BackingPhotoID _tmp4_;
	PhotoID _tmp5_;
	gint64 _tmp6_;
	const gchar* _tmp7_;
	BackingPhotoID _tmp8_;
	gint64 _tmp9_;
	BackingPhotoID _tmp10_;
	gint64 _tmp11_;
	GError* _inner_error0_ = NULL;
#line 1061 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1061 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1061 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (backing_photo_id != NULL);
#line 1065 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	switch (rd) {
#line 1065 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 7451 "PhotoTable.c"
		{
			gchar* _tmp0_;
#line 1067 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp0_ = g_strdup ("develop_shotwell_id");
#line 1067 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1067 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			col = _tmp0_;
#line 1068 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			break;
#line 7462 "PhotoTable.c"
		}
#line 1065 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		case RAW_DEVELOPER_CAMERA:
#line 7466 "PhotoTable.c"
		{
			gchar* _tmp1_;
#line 1071 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp1_ = g_strdup ("develop_camera_id");
#line 1071 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1071 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			col = _tmp1_;
#line 1072 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			break;
#line 7477 "PhotoTable.c"
		}
#line 1065 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 7481 "PhotoTable.c"
		{
			gchar* _tmp2_;
#line 1075 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp2_ = g_strdup ("develop_embedded_id");
#line 1075 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1075 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			col = _tmp2_;
#line 1076 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			break;
#line 7492 "PhotoTable.c"
		}
		default:
		{
#line 1079 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_assert_not_reached ();
#line 7498 "PhotoTable.c"
		}
	}
#line 1082 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = row->development_ids;
#line 1082 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3__length1 = row->development_ids_length1;
#line 1082 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = *backing_photo_id;
#line 1082 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_[rd] = _tmp4_;
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = row->photo_id;
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_.id;
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = col;
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = *backing_photo_id;
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = _tmp8_.id;
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp6_, _tmp7_, _tmp9_, &_inner_error0_);
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7531 "PhotoTable.c"
		} else {
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1083 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7541 "PhotoTable.c"
		}
	}
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = *backing_photo_id;
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = _tmp10_.id;
#line 1085 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp11_ != BACKING_PHOTO_ID_INVALID) {
#line 7550 "PhotoTable.c"
		PhotoID _tmp12_;
		gint64 _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp12_ = row->photo_id;
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp13_ = _tmp12_.id;
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp14_ = raw_developer_to_string (rd);
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp15_ = _tmp14_;
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp13_, "developer", _tmp15_, &_inner_error0_);
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_g_free0 (_tmp15_);
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_free0 (col);
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 7577 "PhotoTable.c"
			} else {
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_g_free0 (col);
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1086 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 7587 "PhotoTable.c"
			}
		}
	}
#line 1061 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (col);
#line 7593 "PhotoTable.c"
}


void
photo_table_remove_development (PhotoTable* self,
                                PhotoRow* row,
                                RawDeveloper rd,
                                GError** error)
{
	BackingPhotoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 1089 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1089 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp0_, BACKING_PHOTO_ID_INVALID);
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	photo_table_update_raw_development (self, row, rd, &_tmp0_, &_inner_error0_);
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7621 "PhotoTable.c"
		} else {
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1090 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 7629 "PhotoTable.c"
		}
	}
}


static void
photo_table_class_init (PhotoTableClass * klass)
{
#line 112 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	photo_table_parent_class = g_type_class_peek_parent (klass);
#line 112 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	((DatabaseTableClass *) klass)->finalize = photo_table_finalize;
#line 7642 "PhotoTable.c"
}


static void
photo_table_instance_init (PhotoTable * self)
{
}


static void
photo_table_finalize (DatabaseTable * obj)
{
	PhotoTable * self;
#line 112 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TABLE, PhotoTable);
#line 112 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	DATABASE_TABLE_CLASS (photo_table_parent_class)->finalize (obj);
#line 7660 "PhotoTable.c"
}


GType
photo_table_get_type (void)
{
	static volatile gsize photo_table_type_id__volatile = 0;
	if (g_once_init_enter (&photo_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTable), 0, (GInstanceInitFunc) photo_table_instance_init, NULL };
		GType photo_table_type_id;
		photo_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "PhotoTable", &g_define_type_info, 0);
		g_once_init_leave (&photo_table_type_id__volatile, photo_table_type_id);
	}
	return photo_table_type_id__volatile;
}


void
backing_photo_id_init (BackingPhotoID *self,
                       gint64 id)
{
#line 1110 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	memset (self, 0, sizeof (BackingPhotoID));
#line 1111 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	(*self).id = id;
#line 7686 "PhotoTable.c"
}


gboolean
backing_photo_id_is_invalid (BackingPhotoID *self)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 1115 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = (*self).id;
#line 1115 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp0_ == BACKING_PHOTO_ID_INVALID;
#line 1115 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 7701 "PhotoTable.c"
}


gboolean
backing_photo_id_is_valid (BackingPhotoID *self)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 1119 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = (*self).id;
#line 1119 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp0_ != BACKING_PHOTO_ID_INVALID;
#line 1119 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 7716 "PhotoTable.c"
}


BackingPhotoID*
backing_photo_id_dup (const BackingPhotoID* self)
{
	BackingPhotoID* dup;
#line 1105 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	dup = g_new0 (BackingPhotoID, 1);
#line 1105 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (BackingPhotoID));
#line 1105 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return dup;
#line 7730 "PhotoTable.c"
}


void
backing_photo_id_free (BackingPhotoID* self)
{
#line 1105 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_free (self);
#line 7739 "PhotoTable.c"
}


GType
backing_photo_id_get_type (void)
{
	static volatile gsize backing_photo_id_type_id__volatile = 0;
	if (g_once_init_enter (&backing_photo_id_type_id__volatile)) {
		GType backing_photo_id_type_id;
		backing_photo_id_type_id = g_boxed_type_register_static ("BackingPhotoID", (GBoxedCopyFunc) backing_photo_id_dup, (GBoxedFreeFunc) backing_photo_id_free);
		g_once_init_leave (&backing_photo_id_type_id__volatile, backing_photo_id_type_id);
	}
	return backing_photo_id_type_id__volatile;
}


gboolean
backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                     GFileInfo* info)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
	time_t _tmp1_;
	GTimeVal _tmp2_ = {0};
	glong _tmp3_;
#line 1133 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (self), FALSE);
#line 1133 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 1134 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = self->filesize;
#line 1134 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp0_ != g_file_info_get_size (info)) {
#line 1135 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = FALSE;
#line 1135 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 7777 "PhotoTable.c"
	}
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = self->timestamp;
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_file_info_get_modification_time (info, &_tmp2_);
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_.tv_sec;
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp1_ == ((time_t) _tmp3_);
#line 1137 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 7789 "PhotoTable.c"
}


gboolean
backing_photo_row_is_touched (BackingPhotoRow* self,
                              GFileInfo* info)
{
	gboolean result = FALSE;
	gint64 _tmp0_;
	time_t _tmp1_;
	GTimeVal _tmp2_ = {0};
	glong _tmp3_;
#line 1140 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (self), FALSE);
#line 1140 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 1141 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = self->filesize;
#line 1141 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp0_ != g_file_info_get_size (info)) {
#line 1142 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = FALSE;
#line 1142 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 7814 "PhotoTable.c"
	}
#line 1144 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = self->timestamp;
#line 1144 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_file_info_get_modification_time (info, &_tmp2_);
#line 1144 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_.tv_sec;
#line 1144 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp1_ != ((time_t) _tmp3_);
#line 1144 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 7826 "PhotoTable.c"
}


void
backing_photo_row_copy_from (BackingPhotoRow* self,
                             BackingPhotoRow* from)
{
	BackingPhotoID _tmp0_;
	time_t _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gint64 _tmp4_;
	time_t _tmp5_;
	PhotoFileFormat _tmp6_;
	Dimensions _tmp7_;
	Orientation _tmp8_;
#line 1148 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (self));
#line 1148 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (from));
#line 1149 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = from->id;
#line 1149 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->id = _tmp0_;
#line 1150 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = from->time_created;
#line 1150 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->time_created = _tmp1_;
#line 1151 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = from->filepath;
#line 1151 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 1151 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (self->filepath);
#line 1151 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->filepath = _tmp3_;
#line 1152 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = from->filesize;
#line 1152 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->filesize = _tmp4_;
#line 1153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = from->timestamp;
#line 1153 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->timestamp = _tmp5_;
#line 1154 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = from->file_format;
#line 1154 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->file_format = _tmp6_;
#line 1155 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = from->dim;
#line 1155 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->dim = _tmp7_;
#line 1156 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = from->original_orientation;
#line 1156 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->original_orientation = _tmp8_;
#line 7883 "PhotoTable.c"
}


BackingPhotoRow*
backing_photo_row_construct (GType object_type)
{
	BackingPhotoRow* self = NULL;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self = (BackingPhotoRow*) g_type_create_instance (object_type);
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return self;
#line 7895 "PhotoTable.c"
}


BackingPhotoRow*
backing_photo_row_new (void)
{
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return backing_photo_row_construct (TYPE_BACKING_PHOTO_ROW);
#line 7904 "PhotoTable.c"
}


static void
value_backing_photo_row_init (GValue* value)
{
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	value->data[0].v_pointer = NULL;
#line 7913 "PhotoTable.c"
}


static void
value_backing_photo_row_free_value (GValue* value)
{
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (value->data[0].v_pointer) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		backing_photo_row_unref (value->data[0].v_pointer);
#line 7924 "PhotoTable.c"
	}
}


static void
value_backing_photo_row_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = backing_photo_row_ref (src_value->data[0].v_pointer);
#line 7937 "PhotoTable.c"
	} else {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7941 "PhotoTable.c"
	}
}


static gpointer
value_backing_photo_row_peek_pointer (const GValue* value)
{
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 7951 "PhotoTable.c"
}


static gchar*
value_backing_photo_row_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (collect_values[0].v_pointer) {
#line 7963 "PhotoTable.c"
		BackingPhotoRow * object;
		object = collect_values[0].v_pointer;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7970 "PhotoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7974 "PhotoTable.c"
		}
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = backing_photo_row_ref (object);
#line 7978 "PhotoTable.c"
	} else {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 7982 "PhotoTable.c"
	}
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return NULL;
#line 7986 "PhotoTable.c"
}


static gchar*
value_backing_photo_row_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	BackingPhotoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (!object_p) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8002 "PhotoTable.c"
	}
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (!value->data[0].v_pointer) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*object_p = NULL;
#line 8008 "PhotoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 8012 "PhotoTable.c"
	} else {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		*object_p = backing_photo_row_ref (value->data[0].v_pointer);
#line 8016 "PhotoTable.c"
	}
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return NULL;
#line 8020 "PhotoTable.c"
}


GParamSpec*
param_spec_backing_photo_row (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	ParamSpecBackingPhotoRow* spec;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BACKING_PHOTO_ROW), NULL);
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return G_PARAM_SPEC (spec);
#line 8040 "PhotoTable.c"
}


gpointer
value_get_backing_photo_row (const GValue* value)
{
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW), NULL);
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 8051 "PhotoTable.c"
}


void
value_set_backing_photo_row (GValue* value,
                             gpointer v_object)
{
	BackingPhotoRow * old;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW));
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (v_object) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKING_PHOTO_ROW));
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		backing_photo_row_ref (value->data[0].v_pointer);
#line 8074 "PhotoTable.c"
	} else {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 8078 "PhotoTable.c"
	}
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (old) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		backing_photo_row_unref (old);
#line 8084 "PhotoTable.c"
	}
}


void
value_take_backing_photo_row (GValue* value,
                              gpointer v_object)
{
	BackingPhotoRow * old;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW));
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (v_object) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKING_PHOTO_ROW));
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 8106 "PhotoTable.c"
	} else {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 8110 "PhotoTable.c"
	}
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (old) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		backing_photo_row_unref (old);
#line 8116 "PhotoTable.c"
	}
}


static void
backing_photo_row_class_init (BackingPhotoRowClass * klass)
{
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	backing_photo_row_parent_class = g_type_class_peek_parent (klass);
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	((BackingPhotoRowClass *) klass)->finalize = backing_photo_row_finalize;
#line 8128 "PhotoTable.c"
}


static void
backing_photo_row_instance_init (BackingPhotoRow * self)
{
#line 1126 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->filepath = NULL;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self->ref_count = 1;
#line 8139 "PhotoTable.c"
}


static void
backing_photo_row_finalize (BackingPhotoRow * obj)
{
	BackingPhotoRow * self;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKING_PHOTO_ROW, BackingPhotoRow);
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_signal_handlers_destroy (self);
#line 1126 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (self->filepath);
#line 8153 "PhotoTable.c"
}


GType
backing_photo_row_get_type (void)
{
	static volatile gsize backing_photo_row_type_id__volatile = 0;
	if (g_once_init_enter (&backing_photo_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_backing_photo_row_init, value_backing_photo_row_free_value, value_backing_photo_row_copy_value, value_backing_photo_row_peek_pointer, "p", value_backing_photo_row_collect_value, "p", value_backing_photo_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BackingPhotoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) backing_photo_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackingPhotoRow), 0, (GInstanceInitFunc) backing_photo_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType backing_photo_row_type_id;
		backing_photo_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackingPhotoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&backing_photo_row_type_id__volatile, backing_photo_row_type_id);
	}
	return backing_photo_row_type_id__volatile;
}


gpointer
backing_photo_row_ref (gpointer instance)
{
	BackingPhotoRow * self;
	self = instance;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return instance;
#line 8182 "PhotoTable.c"
}


void
backing_photo_row_unref (gpointer instance)
{
	BackingPhotoRow * self;
	self = instance;
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		BACKING_PHOTO_ROW_GET_CLASS (self)->finalize (self);
#line 1123 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8197 "PhotoTable.c"
	}
}


static BackingPhotoTable*
backing_photo_table_construct (GType object_type)
{
	BackingPhotoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
#line 1163 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self = (BackingPhotoTable*) database_table_construct (object_type);
#line 1164 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "BackingPhotoTable");
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "BackingPhotoTable " "(" "id INTEGER PRIMARY KEY, " "filepath TEXT UNIQUE NOT NULL, " "timestamp INTEGER, " "filesize INTEGER, " "width INTEGER, " "height INTEGER, " "original_orientation INTEGER, " "file_format INTEGER, " "time_created INTEGER " ")", -1, &_tmp1_, NULL);
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1167 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1180 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 1180 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 1182 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 1182 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp4_);
#line 1183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = res;
#line 1183 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp5_ != SQLITE_DONE) {
#line 8240 "PhotoTable.c"
		gint _tmp6_;
#line 1184 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp6_ = res;
#line 1184 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_fatal ("create PhotoBackingTable", _tmp6_);
#line 8246 "PhotoTable.c"
	}
#line 1163 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1163 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return self;
#line 8252 "PhotoTable.c"
}


static BackingPhotoTable*
backing_photo_table_new (void)
{
#line 1163 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return backing_photo_table_construct (TYPE_BACKING_PHOTO_TABLE);
#line 8261 "PhotoTable.c"
}


BackingPhotoTable*
backing_photo_table_get_instance (void)
{
	BackingPhotoTable* result = NULL;
	BackingPhotoTable* _tmp0_;
	BackingPhotoTable* _tmp2_;
	BackingPhotoTable* _tmp3_;
#line 1188 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = backing_photo_table_instance;
#line 1188 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp0_ == NULL) {
#line 8276 "PhotoTable.c"
		BackingPhotoTable* _tmp1_;
#line 1189 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp1_ = backing_photo_table_new ();
#line 1189 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_database_table_unref0 (backing_photo_table_instance);
#line 1189 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		backing_photo_table_instance = _tmp1_;
#line 8284 "PhotoTable.c"
	}
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = backing_photo_table_instance;
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = _tmp3_;
#line 1191 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 8294 "PhotoTable.c"
}


void
backing_photo_table_add (BackingPhotoTable* self,
                         BackingPhotoRow* state,
                         GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	time_t time_created = 0;
	sqlite3_stmt* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GDestroyNotify _tmp7_;
	gint _tmp8_;
	sqlite3_stmt* _tmp9_;
	time_t _tmp10_;
	gint _tmp11_;
	sqlite3_stmt* _tmp12_;
	gint64 _tmp13_;
	gint _tmp14_;
	sqlite3_stmt* _tmp15_;
	Dimensions _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	sqlite3_stmt* _tmp19_;
	Dimensions _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	sqlite3_stmt* _tmp23_;
	Orientation _tmp24_;
	gint _tmp25_;
	sqlite3_stmt* _tmp26_;
	PhotoFileFormat _tmp27_;
	gint _tmp28_;
	sqlite3_stmt* _tmp29_;
	time_t _tmp30_;
	gint _tmp31_;
	sqlite3_stmt* _tmp32_;
	gint _tmp33_;
	sqlite3* _tmp35_;
	time_t _tmp36_;
	GError* _inner_error0_ = NULL;
#line 1194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (state));
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO BackingPhotoTable " "(filepath, timestamp, filesize, width, height, original_orientation, " "file_format, time_created) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?)", -1, &_tmp1_, NULL);
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1196 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1201 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 1201 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 1203 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	time_created = (time_t) now_sec ();
#line 1205 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 1205 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = state->filepath;
#line 1205 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 1205 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = g_free;
#line 1205 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp4_, 1, _tmp6_, -1, _tmp7_);
#line 1206 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = res;
#line 1206 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp8_ == SQLITE_OK, "res == Sqlite.OK");
#line 1207 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 1207 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = state->timestamp;
#line 1207 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp9_, 2, (gint64) _tmp10_);
#line 1208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = res;
#line 1208 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp11_ == SQLITE_OK, "res == Sqlite.OK");
#line 1209 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 1209 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = state->filesize;
#line 1209 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp12_, 3, _tmp13_);
#line 1210 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp14_ = res;
#line 1210 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp14_ == SQLITE_OK, "res == Sqlite.OK");
#line 1211 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_ = stmt;
#line 1211 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp16_ = state->dim;
#line 1211 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp17_ = _tmp16_.width;
#line 1211 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp15_, 4, _tmp17_);
#line 1212 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp18_ = res;
#line 1212 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp18_ == SQLITE_OK, "res == Sqlite.OK");
#line 1213 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 1213 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp20_ = state->dim;
#line 1213 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp21_ = _tmp20_.height;
#line 1213 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp19_, 5, _tmp21_);
#line 1214 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp22_ = res;
#line 1214 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp22_ == SQLITE_OK, "res == Sqlite.OK");
#line 1215 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 1215 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp24_ = state->original_orientation;
#line 1215 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp23_, 6, (gint) _tmp24_);
#line 1216 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp25_ = res;
#line 1216 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp25_ == SQLITE_OK, "res == Sqlite.OK");
#line 1217 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp26_ = stmt;
#line 1217 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp27_ = state->file_format;
#line 1217 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp26_, 7, photo_file_format_serialize (_tmp27_));
#line 1218 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_ = res;
#line 1218 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp28_ == SQLITE_OK, "res == Sqlite.OK");
#line 1219 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp29_ = stmt;
#line 1219 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp30_ = time_created;
#line 1219 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp29_, 8, (gint64) _tmp30_);
#line 1220 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp31_ = res;
#line 1220 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp31_ == SQLITE_OK, "res == Sqlite.OK");
#line 1222 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp32_ = stmt;
#line 1222 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp32_);
#line 1223 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp33_ = res;
#line 1223 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp33_ != SQLITE_DONE) {
#line 8459 "PhotoTable.c"
		gint _tmp34_;
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp34_ = res;
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_throw_error ("PhotoBackingTable.add", _tmp34_, &_inner_error0_);
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 8475 "PhotoTable.c"
			} else {
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1224 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 8485 "PhotoTable.c"
			}
		}
	}
#line 1226 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp35_ = database_table_db;
#line 1226 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	backing_photo_id_init (&state->id, sqlite3_last_insert_rowid (_tmp35_));
#line 1227 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp36_ = time_created;
#line 1227 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	state->time_created = _tmp36_;
#line 1194 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 8499 "PhotoTable.c"
}


BackingPhotoRow*
backing_photo_table_fetch (BackingPhotoTable* self,
                           BackingPhotoID* id,
                           GError** error)
{
	BackingPhotoRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	BackingPhotoID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	gint _tmp9_;
	BackingPhotoRow* row = NULL;
	BackingPhotoRow* _tmp12_;
	BackingPhotoRow* _tmp13_;
	BackingPhotoID _tmp14_;
	BackingPhotoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	BackingPhotoRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	BackingPhotoRow* _tmp21_;
	sqlite3_stmt* _tmp22_;
	BackingPhotoRow* _tmp23_;
	sqlite3_stmt* _tmp24_;
	sqlite3_stmt* _tmp25_;
	BackingPhotoRow* _tmp26_;
	sqlite3_stmt* _tmp27_;
	BackingPhotoRow* _tmp28_;
	sqlite3_stmt* _tmp29_;
	BackingPhotoRow* _tmp30_;
	sqlite3_stmt* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 1230 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_TABLE (self), NULL);
#line 1230 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1232 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1232 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT filepath, timestamp, filesize, width, height, " "original_orientation, file_format, time_created FROM BackingPhotoTable" \
" WHERE id=?", -1, &_tmp1_, NULL);
#line 1232 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1232 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1232 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1235 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 1235 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 1237 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 1237 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = *id;
#line 1237 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = _tmp5_.id;
#line 1237 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 1238 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = res;
#line 1238 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 1240 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 1240 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp8_);
#line 1241 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = res;
#line 1241 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp9_ == SQLITE_DONE) {
#line 1242 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		result = NULL;
#line 1242 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 1242 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		return result;
#line 8587 "PhotoTable.c"
	} else {
		gint _tmp10_;
#line 1243 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp10_ = res;
#line 1243 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_tmp10_ != SQLITE_ROW) {
#line 8594 "PhotoTable.c"
			gint _tmp11_;
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			_tmp11_ = res;
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			database_table_throw_error ("BackingPhotoTable.fetch_for_photo", _tmp11_, &_inner_error0_);
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					return NULL;
#line 8610 "PhotoTable.c"
				} else {
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					g_clear_error (&_inner_error0_);
#line 1244 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
					return NULL;
#line 8620 "PhotoTable.c"
				}
			}
		}
	}
#line 1246 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = backing_photo_row_new ();
#line 1246 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	row = _tmp12_;
#line 1247 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = row;
#line 1247 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp14_ = *id;
#line 1247 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_->id = _tmp14_;
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_ = row;
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp17_ = (const gchar*) sqlite3_column_text (_tmp16_, 0);
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_g_free0 (_tmp15_->filepath);
#line 1248 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_->filepath = _tmp18_;
#line 1249 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_ = row;
#line 1249 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp20_ = stmt;
#line 1249 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_->timestamp = (time_t) sqlite3_column_int64 (_tmp20_, 1);
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp21_ = row;
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp22_ = stmt;
#line 1250 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp21_->filesize = sqlite3_column_int64 (_tmp22_, 2);
#line 1251 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp23_ = row;
#line 1251 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp24_ = stmt;
#line 1251 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp25_ = stmt;
#line 1251 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	dimensions_init (&_tmp23_->dim, sqlite3_column_int (_tmp24_, 3), sqlite3_column_int (_tmp25_, 4));
#line 1252 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp26_ = row;
#line 1252 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp27_ = stmt;
#line 1252 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp26_->original_orientation = (Orientation) sqlite3_column_int (_tmp27_, 5);
#line 1253 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_ = row;
#line 1253 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp29_ = stmt;
#line 1253 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp29_, 6));
#line 1254 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp30_ = row;
#line 1254 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp31_ = stmt;
#line 1254 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp30_->time_created = (time_t) sqlite3_column_int64 (_tmp31_, 7);
#line 1256 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	result = row;
#line 1256 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1256 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	return result;
#line 8691 "PhotoTable.c"
}


void
backing_photo_table_update (BackingPhotoTable* self,
                            BackingPhotoRow* row,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	time_t _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	gint64 _tmp8_;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_;
	Dimensions _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	sqlite3_stmt* _tmp14_;
	Dimensions _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	sqlite3_stmt* _tmp18_;
	Orientation _tmp19_;
	gint _tmp20_;
	sqlite3_stmt* _tmp21_;
	PhotoFileFormat _tmp22_;
	gint _tmp23_;
	sqlite3_stmt* _tmp24_;
	BackingPhotoID _tmp25_;
	gint64 _tmp26_;
	gint _tmp27_;
	sqlite3_stmt* _tmp28_;
	gint _tmp29_;
	GError* _inner_error0_ = NULL;
#line 1260 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1260 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (row));
#line 1262 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1262 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE BackingPhotoTable SET timestamp=?, filesize=?, " "width=?, height=?, original_orientation=?, file_format=? " "WHERE id=?", -1, &_tmp1_, NULL);
#line 1262 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1262 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1262 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1266 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 1266 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 1268 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 1268 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = row->timestamp;
#line 1268 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, (gint64) _tmp5_);
#line 1269 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = res;
#line 1269 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp6_ == SQLITE_OK, "res == Sqlite.OK");
#line 1270 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 1270 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = row->filesize;
#line 1270 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 2, _tmp8_);
#line 1271 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = res;
#line 1271 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp9_ == SQLITE_OK, "res == Sqlite.OK");
#line 1272 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 1272 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = row->dim;
#line 1272 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = _tmp11_.width;
#line 1272 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp10_, 3, _tmp12_);
#line 1273 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = res;
#line 1273 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp13_ == SQLITE_OK, "res == Sqlite.OK");
#line 1274 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 1274 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp15_ = row->dim;
#line 1274 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp16_ = _tmp15_.height;
#line 1274 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp14_, 4, _tmp16_);
#line 1275 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp17_ = res;
#line 1275 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp17_ == SQLITE_OK, "res == Sqlite.OK");
#line 1276 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp18_ = stmt;
#line 1276 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp19_ = row->original_orientation;
#line 1276 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp18_, 5, (gint) _tmp19_);
#line 1277 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp20_ = res;
#line 1277 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp20_ == SQLITE_OK, "res == Sqlite.OK");
#line 1278 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp21_ = stmt;
#line 1278 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp22_ = row->file_format;
#line 1278 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp21_, 6, photo_file_format_serialize (_tmp22_));
#line 1279 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp23_ = res;
#line 1279 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp23_ == SQLITE_OK, "res == Sqlite.OK");
#line 1280 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp24_ = stmt;
#line 1280 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp25_ = row->id;
#line 1280 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp26_ = _tmp25_.id;
#line 1280 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp24_, 7, _tmp26_);
#line 1281 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp27_ = res;
#line 1281 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp27_ == SQLITE_OK, "res == Sqlite.OK");
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp28_ = stmt;
#line 1283 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp28_);
#line 1284 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp29_ = res;
#line 1284 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp29_ != SQLITE_DONE) {
#line 8835 "PhotoTable.c"
		gint _tmp30_;
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp30_ = res;
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_throw_error ("BackingPhotoTable.update", _tmp30_, &_inner_error0_);
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 8851 "PhotoTable.c"
			} else {
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1285 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 8861 "PhotoTable.c"
			}
		}
	}
#line 1260 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 8867 "PhotoTable.c"
}


void
backing_photo_table_update_attributes (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       time_t timestamp,
                                       gint64 filesize,
                                       GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	BackingPhotoID _tmp9_;
	gint64 _tmp10_;
	gint _tmp11_;
	sqlite3_stmt* _tmp12_;
	gint _tmp13_;
	GError* _inner_error0_ = NULL;
#line 1288 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1288 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1290 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1290 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE BackingPhotoTable SET timestamp=?, filesize=? WHERE id=?", -1, &_tmp1_, NULL);
#line 1290 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1290 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1290 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1292 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp3_ = res;
#line 1292 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp3_ == SQLITE_OK, "res == Sqlite.OK");
#line 1294 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 1294 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 1, (gint64) timestamp);
#line 1295 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp5_ = res;
#line 1295 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp5_ == SQLITE_OK, "res == Sqlite.OK");
#line 1296 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 1296 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 2, filesize);
#line 1297 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp7_ = res;
#line 1297 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp7_ == SQLITE_OK, "res == Sqlite.OK");
#line 1298 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 1298 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp9_ = *id;
#line 1298 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp10_ = _tmp9_.id;
#line 1298 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp8_, 3, _tmp10_);
#line 1299 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp11_ = res;
#line 1299 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_vala_assert (_tmp11_ == SQLITE_OK, "res == Sqlite.OK");
#line 1301 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 1301 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp12_);
#line 1302 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp13_ = res;
#line 1302 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (_tmp13_ != SQLITE_DONE) {
#line 8949 "PhotoTable.c"
		gint _tmp14_;
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		_tmp14_ = res;
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		database_table_throw_error ("BackingPhotoTable.update_attributes", _tmp14_, &_inner_error0_);
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 8965 "PhotoTable.c"
			} else {
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1303 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
				return;
#line 8975 "PhotoTable.c"
			}
		}
	}
#line 1288 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 8981 "PhotoTable.c"
}


void
backing_photo_table_remove (BackingPhotoTable* self,
                            BackingPhotoID* backing_id,
                            GError** error)
{
	BackingPhotoID _tmp0_;
	gint64 _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1306 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1306 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (backing_id != NULL);
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *backing_id;
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, &_inner_error0_);
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 9011 "PhotoTable.c"
		} else {
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1307 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 9019 "PhotoTable.c"
		}
	}
}


void
backing_photo_table_set_filepath (BackingPhotoTable* self,
                                  BackingPhotoID* id,
                                  const gchar* filepath,
                                  GError** error)
{
	BackingPhotoID _tmp0_;
	gint64 _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1310 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1310 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1310 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *id;
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "filepath", filepath, &_inner_error0_);
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 9054 "PhotoTable.c"
		} else {
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1311 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 9062 "PhotoTable.c"
		}
	}
}


void
backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                      BackingPhotoID* id,
                                      time_t timestamp,
                                      GError** error)
{
	BackingPhotoID _tmp0_;
	gint64 _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1314 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1314 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp0_ = *id;
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_, "timestamp", (gint64) timestamp, &_inner_error0_);
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 9095 "PhotoTable.c"
		} else {
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1315 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
			return;
#line 9103 "PhotoTable.c"
		}
	}
}


static void
backing_photo_table_class_init (BackingPhotoTableClass * klass)
{
#line 1160 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	backing_photo_table_parent_class = g_type_class_peek_parent (klass);
#line 1160 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	((DatabaseTableClass *) klass)->finalize = backing_photo_table_finalize;
#line 9116 "PhotoTable.c"
}


static void
backing_photo_table_instance_init (BackingPhotoTable * self)
{
}


static void
backing_photo_table_finalize (DatabaseTable * obj)
{
	BackingPhotoTable * self;
#line 1160 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable);
#line 1160 "/builddir/build/BUILD/shotwell-0.31.1/src/db/PhotoTable.vala"
	DATABASE_TABLE_CLASS (backing_photo_table_parent_class)->finalize (obj);
#line 9134 "PhotoTable.c"
}


GType
backing_photo_table_get_type (void)
{
	static volatile gsize backing_photo_table_type_id__volatile = 0;
	if (g_once_init_enter (&backing_photo_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BackingPhotoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) backing_photo_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackingPhotoTable), 0, (GInstanceInitFunc) backing_photo_table_instance_init, NULL };
		GType backing_photo_table_type_id;
		backing_photo_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "BackingPhotoTable", &g_define_type_info, 0);
		g_once_init_leave (&backing_photo_table_type_id__volatile, backing_photo_table_type_id);
	}
	return backing_photo_table_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



